INCDIR=include
CODEDIR=code
OBJDIR=code

SOURCES_BASE=\
  code/sbaes.c \
  code/sbalgorithmidentifier.c \
  code/sbapplecertstorage.c \
  code/sbapplecommon.c \
  code/sbbzip2.c \
  code/sbbzip2basetypes.c \
  code/sbbzip2common.c \
  code/sbbzip2types.c \
  code/sbbzip2utils.c \
  code/sbbzlib.c \
  code/sbchacha20.c \
  code/sbconstants.c \
  code/sbcustomcrypto.c \
  code/sbdes.c \
  code/sbdsa.c \
  code/sbasn1.c \
  code/sbasn1tree.c \
  code/sbhashfunction.c \
  code/sbhmac.c \
  code/sbmath.c \
  code/sbmskeyblob.c \
  code/sbmd.c \
  code/sbpem.c \
  code/sbpoly1305.c \
  code/sbrandom.c \
  code/sbrc2.c \
  code/sbrc4.c \
  code/sbripemd.c \
  code/sbrsa.c \
  code/sbsha.c \
  code/sbsha2.c \
  code/sbtypes.c \
  code/sbutils.c \
  code/sbstrutils.c \
  code/sbstreams.c \
  code/sbencoding.c \
  code/sbblowfish.c \
  code/sbelgamal.c \
  code/sbcamellia.c \
  code/sbcast128.c \
  code/sbcrc.c \
  code/sblicensemanager.c \
  code/sbseed.c \
  code/sbrabbit.c \
  code/sbserpent.c \
  code/sbsharedresource.c \
  code/sbsocket.c \
  code/sbportknock.c \
  code/sbstringlist.c \
  code/sbtimer.c \
  code/sbtwofish.c \
  code/sbzuncompressunit.c \
  code/sbzlib.c \
  code/sbzcommonunit.c \
  code/sbzcompressunit.c \
  code/sbcmsutils.c \
  code/sbcryptoprov.c \
  code/sbcryptoprovrs.c \
  code/sbcryptoprovutils.c \
  code/sbcryptoprovdefault.c \
  code/sbcryptoprovbuiltin.c \
  code/sbcryptoprovbuiltinhash.c \
  code/sbcryptoprovbuiltinpki.c \
  code/sbcryptoprovbuiltinsym.c \
  code/sbcryptoprovwin32.c \
  code/sbcryptoprovmanager.c \
  code/sbx509.c \
  code/sbx509ext.c \
  code/sbcrl.c \
  code/sbcrlstorage.c \
  code/sbcertretriever.c \
  code/sbcertvalidator.c \
  code/sbrdn.c \
  code/sbcustomcertstorage.c \
  code/sbmessages.c \
  code/sbpkcs5.c \
  code/sbpkcs7.c \
  code/sbpkcs7utils.c \
  code/sbpkcs8.c \
  code/sbpkcs12.c \
  code/sbjks.c \
  code/sbwincertstorage.c \
  code/sbwincrypt.c \
  code/sbsmimesignatures.c \
  code/sbocspcommon.c \
  code/sbocspclient.c \
  code/sbocspstorage.c \
  code/sbpublickeycrypto.c \
  code/sbsrp.c \
  code/sbsymmetriccrypto.c \
  code/sbpkiasync.c \
  code/sbpkicommon.c \
  code/sbtspcommon.c \
  code/sbtspclient.c \
  code/sbsockettspclient.c \
  code/sbtar.c \
  code/sbumac.c \
  code/sbeccommon.c \
  code/sbecmath.c \
  code/sbecdsa.c \
  code/sbgostcommon.c \
  code/sbgost341194.c \
  code/sbgost341094.c \
  code/sbgost341001.c \
  code/sbgost2814789.c \
  code/sbgssapi.c \
  code/sbgssapibase.c \
  code/sbgsswinauth.c \
  code/sbsspi.c \
  code/sbdnssec.c \
  code/sbdnssectypes.c \
  code/sbdnssecconsts.c \
  code/sbdnssecutils.c \
  code/sbcustomfsadapter.c \
  code/sbdiskfsadapter.c \
  code/sbpunycode.c \
  code/sbhttpauth.c \
  code/sbhttpsconstants.c \
  code/sbsasl.c \
  code/sbcomprstream.c \
  code/sbdc.c \
  code/sbdcdef.c \
  code/sbdcenc.c \
  code/sbdcpkiconstants.c \
  code/csarmscii_8.c \
  code/csatarist.c \
  code/csbigfive.c \
  code/cscns_11643_1.c \
  code/cscns_11643_2.c \
  code/cscns_11643_3.c \
  code/cscns_11643_4.c \
  code/cscns_11643_5.c \
  code/cscns_11643_6.c \
  code/cscns_11643_7.c \
  code/cscns_11643_f.c \
  code/cscp1006.c \
  code/cscp1131.c \
  code/cscp1133.c \
  code/cscp1250.c \
  code/cscp1251.c \
  code/cscp1252.c \
  code/cscp1253.c \
  code/cscp1254.c \
  code/cscp1255.c \
  code/cscp1256.c \
  code/cscp1257.c \
  code/cscp1258.c \
  code/cscp037.c \
  code/cscp424.c \
  code/cscp437.c \
  code/cscp500.c \
  code/cscp737.c \
  code/cscp775.c \
  code/cscp850.c \
  code/cscp852.c \
  code/cscp853.c \
  code/cscp855.c \
  code/cscp856.c \
  code/cscp857.c \
  code/cscp860.c \
  code/cscp861.c \
  code/cscp862.c \
  code/cscp863.c \
  code/cscp864.c \
  code/cscp865.c \
  code/cscp866.c \
  code/cscp869.c \
  code/cscp874.c \
  code/cscp875.c \
  code/cscp950data.c \
  code/csgb_18030.c \
  code/csgb_2312.c \
  code/csgbk.c \
  code/csgeorgianacademy.c \
  code/csgeorgianps.c \
  code/csgeostd8.c \
  code/cshkscs.c \
  code/cshproman8.c \
  code/csiso_8859_10.c \
  code/csiso_8859_11.c \
  code/csiso_8859_13.c \
  code/csiso_8859_14.c \
  code/csiso_8859_15.c \
  code/csiso_8859_16.c \
  code/csiso_8859_2.c \
  code/csiso_8859_3.c \
  code/csiso_8859_4.c \
  code/csiso_8859_5.c \
  code/csiso_8859_6.c \
  code/csiso_8859_7.c \
  code/csiso_8859_8.c \
  code/csiso_8859_8i.c \
  code/csiso_8859_9.c \
  code/csiso_ir_165.c \
  code/csjis_0201.c \
  code/csjis_0208.c \
  code/csjis_0212.c \
  code/cskoi8r.c \
  code/cskoi8ru.c \
  code/cskoi8t.c \
  code/cskoi8u.c \
  code/csks_x_1001.c \
  code/csmacceltic.c \
  code/csmaccentraleuropean.c \
  code/csmaccroatian.c \
  code/csmaccyrillic.c \
  code/csmacgaelic.c \
  code/csmacgreek.c \
  code/csmachebrew.c \
  code/csmacicelandic.c \
  code/csmacroman.c \
  code/csmacromanian.c \
  code/csmacthai.c \
  code/csmacturkish.c \
  code/csnextstep.c \
  code/csshiftjis.c \
  code/csuhc.c \
  code/csviscii.c \
  code/sbchscjk.c \
  code/sbchsconv.c \
  code/sbchsconvbase.c \
  code/sbchsconvconsts.c \
  code/sbchsunicode.c \
  code/sbunicode.c \
  code/sbidea.c \
  code/sbcryptoprovbuiltinex.c \
  code/sbjson.c \
  code/sbbcrypt.c \
  code/sbwhirlpool.c \
  code/sbdictionary.c \
  code/sbusers.c 

SOURCES_CLOUD=\
  code/sbdatastorage.c \
  code/sbawsdatastorage.c \
  code/sbfiledatastorage.c \
  code/sbencstream.c \
  code/sbauthdatastream.c \
  code/sbwinazuredatastorage.c \
  code/sbgoogledatastorage.c \
  code/sbgoogledrivedatastorage.c \
  code/sbonedrivedatastorage.c \
  code/sbdropboxdatastorage.c \
  code/sbdatastorageencodings.c \
  code/sbdatastorageutils.c \
  code/sbboxdatastorage.c 

SOURCES_DAVCLI=\
  code/sbhttpswebdavclient.c \
  code/sbwebdavclient.c \
  code/sbwebdavcommon.c \
  code/sbvcard.c 

SOURCES_DAVSRV=\
  code/sbwebdavserver.c 

SOURCES_DC=\
  code/sbdcxmlenc.c \
  code/sbdcpki.c \
  code/sbdcserver.c 

SOURCES_EDI=\
  code/sbas2.c \
  code/sbas3.c \
  code/sbascommon.c \
  code/sbasconstants.c \
  code/sbasresources.c \
  code/sbasutils.c 

SOURCES_FTPSCLI=\
  code/sbsimpleftps.c 

SOURCES_FTPSSRV=\
  code/sbftpscommon.c \
  code/sbftpsserver.c \
  code/sbsimpleftpsserver.c 

SOURCES_HTTPCLI=\
  code/sbhttpscommon.c \
  code/sbhttpsclient.c \
  code/sbhttptspclient.c \
  code/sbhttpocspclient.c \
  code/sbhttpcertretriever.c \
  code/sbhttpcrl.c \
  code/sboauth2.c \
  code/sbcookiemgr.c \
  code/sbwebsocketcommon.c \
  code/sbwebsocketclient.c \
  code/sbrestclient.c 

SOURCES_HTTPSRV=\
  code/sbhttpsserver.c \
  code/sbwebsocketserver.c 

SOURCES_LDAP=\
  code/sbldapcertstorage.c \
  code/sbldapcertretriever.c \
  code/sbldapcrl.c \
  code/sbldapsclient.c \
  code/sbldapscore.c 

SOURCES_MAIL=\
  code/sbsmtpclient.c \
  code/sbpop3client.c \
  code/sbimapclient.c \
  code/sbimaputils.c 

SOURCES_MIME=\
  code/sbdomainkeys.c \
  code/sbmime.c \
  code/sbmimeenc.c \
  code/sbmimestream.c \
  code/sbsimplemime.c 

SOURCES_OFFICE=\
  code/sbcompoundfile.c \
  code/sbcompoundfilebase.c \
  code/sbcompoundfileresources.c \
  code/sboffice.c \
  code/sbofficebinarycore.c \
  code/sbofficecommon.c \
  code/sbofficeconstants.c \
  code/sbofficepackage.c \
  code/sbofficeresources.c \
  code/sbofficesecurity.c \
  code/sbofficexmlcore.c 

SOURCES_PDF=\
  code/sbpdf.c \
  code/sbpdfcore.c \
  code/sbpdfsecurity.c \
  code/sbpdfutils.c \
  code/sbpades.c 

SOURCES_PGP=\
  code/sbpgp.c \
  code/sbpgpconstants.c \
  code/sbpgpentities.c \
  code/sbpgpexceptions.c \
  code/sbpgpkeys.c \
  code/sbpgpmd.c \
  code/sbpgpresourcestrings.c \
  code/sbpgpstreams.c \
  code/sbpgputils.c \
  code/sbpgpsfx.c 

SOURCES_PGPLDAP=\
  code/sbldapskeyserverclient.c 

SOURCES_PGPMIME=\
  code/sbpgpmime.c 

SOURCES_PGPSSH=\
  code/sbpgpssh.c 

SOURCES_PGPTLS=\
  code/sbpgptls.c 

SOURCES_PKI=\
  code/sbcms.c \
  code/sbcryptoprovpkcs11.c \
  code/sbpkcs11common.c \
  code/sbpkcs11base.c \
  code/sbpkcs11manager.c \
  code/sbpkcs11certstorage.c \
  code/sbpkcs10.c \
  code/sbocspserver.c \
  code/sbtspserver.c \
  code/sbauthenticode.c \
  code/sbcrlex.c \
  code/sbx509ex.c \
  code/sbsshpkcs11keystorage.c \
  code/sbcades.c \
  code/sbcmc.c \
  code/sbotpcommon.c \
  code/sbotpclient.c \
  code/sbotpserver.c \
  code/sbeciescrypto.c 

SOURCES_SFTPCLI=\
  code/sbsftp.c \
  code/sbsftpcommon.c \
  code/sbsimplesftp.c 

SOURCES_SFTPSRV=\
  code/sbsftphandler.c \
  code/sbsftpserver.c \
  code/sbsimplesftpserver.c 

SOURCES_SMIME=\
  code/sbsmimecore.c \
  code/sbsmimecades.c 

SOURCES_SSHCLI=\
  code/sbsshconstants.c \
  code/sbsshkeystorage.c \
  code/sbsshterm.c \
  code/sbsshutils.c \
  code/sbsshclient.c \
  code/sbsshcommon.c \
  code/sbsimplessh.c \
  code/sbsshforwarding.c \
  code/sbsshpubkeycommon.c \
  code/sbsshpubkeyclient.c \
  code/sbsshauthagent.c 

SOURCES_SSHSRV=\
  code/sbsshserver.c \
  code/sbsshhandlers.c \
  code/sbsshconnectionhandler.c \
  code/sbsshpubkeyserver.c \
  code/sbsshpubkeyhandler.c \
  code/sbsimplesshserver.c \
  code/sbsshforwardinghandlers.c 

SOURCES_SSLCLI=\
  code/sbsslclient.c \
  code/sbsimplessl.c \
  code/sbsslcommon.c \
  code/sbsslconstants.c \
  code/sbcmdsslclient.c \
  code/sbdtlsclient.c 

SOURCES_SSLSRV=\
  code/sbsslserver.c \
  code/sbsessionpool.c \
  code/sbdtlsserver.c 

SOURCES_XML=\
  code/sbxmlcharsets.c \
  code/sbxmlcore.c \
  code/sbxmldefs.c \
  code/sbxmlpath.c \
  code/sbxmlutils.c 

SOURCES_XMLSEC=\
  code/sbxmlades.c \
  code/sbxmladesintf.c \
  code/sbxmlenc.c \
  code/sbxmlsec.c \
  code/sbxmlsig.c \
  code/sbxmltransform.c \
  code/sbxmlsoapcore.c \
  code/sbxmlwsscore.c \
  code/sbxmlsoap.c \
  code/sbxmlsoapsecurity.c 

SOURCES_SOAPCLI=\
  code/sbxmlsoapclient.c 

SOURCES_ZIP=\
  code/sbarcbase.c \
  code/sbarczip.c \
  code/sbzipentities.c \
  code/sbziputils.c \
  code/sbarctar.c \
  code/sbtarentities.c \
  code/sbtarutils.c \
  code/sbarcgzip.c \
  code/sbarcbzip2.c \
  code/sbzipsfx.c \
  code/sbzipsfxmaker.c 

SOURCES_SAML=\
  code/sbxmlsamlbind.c \
  code/sbxmlsamlcommon.c \
  code/sbxmlsamlcore.c \
  code/sbxmlsamlmetadata.c \
  code/sbxmlsamlprotocol.c \
  code/sbsamlidentityprovider.c \
  code/sbsamlserviceprovider.c 

SOURCES_DCPKI=\
  code/sbdccms.c 

SOURCES_CORE=\
  code/sbphpcore.c \
  code/sbsystem.c

SOURCES=$(SOURCES_BASE) $(SOURCES_CLOUD) $(SOURCES_DAVCLI) $(SOURCES_DAVSRV) $(SOURCES_DC) $(SOURCES_EDI) $(SOURCES_FTPSCLI) $(SOURCES_FTPSSRV) $(SOURCES_HTTPCLI) $(SOURCES_HTTPSRV) $(SOURCES_LDAP) $(SOURCES_MAIL) $(SOURCES_MIME) $(SOURCES_OFFICE) $(SOURCES_PDF) $(SOURCES_PGP) $(SOURCES_PGPLDAP) $(SOURCES_PGPMIME) $(SOURCES_PGPSSH) $(SOURCES_PGPTLS) $(SOURCES_PKI) $(SOURCES_SFTPCLI) $(SOURCES_SFTPSRV) $(SOURCES_SMIME) $(SOURCES_SSHCLI) $(SOURCES_SSHSRV) $(SOURCES_SSLCLI) $(SOURCES_SSLSRV) $(SOURCES_XML) $(SOURCES_XMLSEC) $(SOURCES_SOAPCLI) $(SOURCES_ZIP) $(SOURCES_SAML) $(SOURCES_DCPKI) $(SOURCES_CORE)
