#include "sbdefs.h"

#ifdef MACOS
#include "sbapplecertstorage.h"

void SB_CALLBACK TElEvaluationResultEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcres, int32_t szres, const SB_SecTrustResultTypeRaw resType)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zres;
	zval * zresType;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zres);
	ZVAL_STRINGL(zres, pcres, szres, 1);
	MAKE_STD_ZVAL(zresType);
	ZVAL_LONG(zresType, (long)resType);

	params[0] = &zSender;
	params[1] = &zres;
	params[2] = &zresType;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zres);
	zval_ptr_dtor(&zresType);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElAppleCertStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElAppleCertStorage, GetOpenedKeychains_Inst)
{
	zval *oKeychains;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeychains, TStrings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_GetOpenedKeychains_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeychains TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, GetOpenedKeychains)
{
	zval *oKeychains;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeychains, TStrings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_GetOpenedKeychains(SBGetObjectHandle(oKeychains TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, AddToSearchList_Inst)
{
	char *sKeychainPath;
	int sKeychainPath_len;
	zval *oKeychainsPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKeychainPath, &sKeychainPath_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_AddToSearchList_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKeychainPath, (int32_t)sKeychainPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeychainsPath, TStringList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_AddToSearchList_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeychainsPath TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStringList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, AddToSearchList)
{
	char *sKeychainPath;
	int sKeychainPath_len;
	zval *oKeychainsPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKeychainPath, &sKeychainPath_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_AddToSearchList(sKeychainPath, (int32_t)sKeychainPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeychainsPath, TStringList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_AddToSearchList_2(SBGetObjectHandle(oKeychainsPath TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStringList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, RemoveFromSearchList_Inst)
{
	char *sKeychainPath;
	int sKeychainPath_len;
	zval *oKeychainsPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKeychainPath, &sKeychainPath_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_RemoveFromSearchList_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKeychainPath, (int32_t)sKeychainPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeychainsPath, TStringList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_RemoveFromSearchList_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeychainsPath TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStringList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, RemoveFromSearchList)
{
	char *sKeychainPath;
	int sKeychainPath_len;
	zval *oKeychainsPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKeychainPath, &sKeychainPath_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_RemoveFromSearchList(sKeychainPath, (int32_t)sKeychainPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeychainsPath, TStringList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_RemoveFromSearchList_2(SBGetObjectHandle(oKeychainsPath TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStringList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, CreateKeychain_Inst)
{
	char *skeychainPath;
	char *spassword;
	int skeychainPath_len;
	int spassword_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &skeychainPath, &skeychainPath_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_CreateKeychain_1(SBGetObjectHandle(getThis() TSRMLS_CC), skeychainPath, (int32_t)skeychainPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &skeychainPath, &skeychainPath_len, &spassword, &spassword_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_CreateKeychain_3(SBGetObjectHandle(getThis() TSRMLS_CC), skeychainPath, (int32_t)skeychainPath_len, spassword, (int32_t)spassword_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, CreateKeychain)
{
	char *skeychainPath;
	char *spassword;
	int skeychainPath_len;
	int spassword_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &skeychainPath, &skeychainPath_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_CreateKeychain(skeychainPath, (int32_t)skeychainPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &skeychainPath, &skeychainPath_len, &spassword, &spassword_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_CreateKeychain_2(skeychainPath, (int32_t)skeychainPath_len, spassword, (int32_t)spassword_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, DeleteKeychain_Inst)
{
	char *skeychainPath;
	char *spassword;
	int skeychainPath_len;
	int spassword_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &skeychainPath, &skeychainPath_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_DeleteKeychain_1(SBGetObjectHandle(getThis() TSRMLS_CC), skeychainPath, (int32_t)skeychainPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &skeychainPath, &skeychainPath_len, &spassword, &spassword_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_DeleteKeychain_3(SBGetObjectHandle(getThis() TSRMLS_CC), skeychainPath, (int32_t)skeychainPath_len, spassword, (int32_t)spassword_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, DeleteKeychain)
{
	char *skeychainPath;
	char *spassword;
	int skeychainPath_len;
	int spassword_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &skeychainPath, &skeychainPath_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_DeleteKeychain(skeychainPath, (int32_t)skeychainPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &skeychainPath, &skeychainPath_len, &spassword, &spassword_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_DeleteKeychain_2(skeychainPath, (int32_t)skeychainPath_len, spassword, (int32_t)spassword_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, Add)
{
	char *skeychainPath;
	int skeychainPath_len;
	zend_bool bBindToExistingPrivateKey;
	zend_bool bCopyPrivateKey;
	zend_bool bsetTrusted;
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oCertificate, TElX509Certificate_ce_ptr, &bCopyPrivateKey) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bCopyPrivateKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sbb", &oCertificate, TElX509Certificate_ce_ptr, &skeychainPath, &skeychainPath_len, &bCopyPrivateKey, &bsetTrusted) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), skeychainPath, (int32_t)skeychainPath_len, (int8_t)bCopyPrivateKey, (int8_t)bsetTrusted) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bsb", &oCertificate, TElX509Certificate_ce_ptr, &bBindToExistingPrivateKey, &skeychainPath, &skeychainPath_len, &bsetTrusted) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_Add_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bBindToExistingPrivateKey, skeychainPath, (int32_t)skeychainPath_len, (int8_t)bsetTrusted) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, bool) or (TElX509Certificate, string, bool, bool) or (TElX509Certificate, bool, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, ClearAll)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_ClearAll(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, PreloadCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_PreloadCertificates(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, EvaluateTrust)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_EvaluateTrust(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, ExportWithPrivateKey)
{
	char *spassword;
	int spassword_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &spassword, &spassword_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAppleCertStorage_ExportWithPrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, spassword, (int32_t)spassword_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAppleCertStorage_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, get_Certificates)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAppleCertStorage_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, get_Keychains)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAppleCertStorage_get_Keychains(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, set_Keychains)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStringList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_set_Keychains(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStringList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, get_ReadOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAppleCertStorage_get_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, set_ReadOnly)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_set_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAppleCertStorage_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, set_CryptoProvider)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_set_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, get_LastPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAppleCertStorage_get_LastPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(279149066, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, set_LastPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAppleCertStorage_set_LastPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, get_OnEvaluationResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElEvaluationResultEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElAppleCertStorage_get_OnEvaluationResult(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, set_OnEvaluationResult)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElAppleCertStorage_set_OnEvaluationResult(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElEvaluationResultEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElEvaluationResultEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAppleCertStorage, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAppleCertStorage_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_GetOpenedKeychains_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Keychains, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_GetOpenedKeychains, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Keychains, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_AddToSearchList_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeychainPath_or_KeychainsPath, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_AddToSearchList, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeychainPath_or_KeychainsPath, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_RemoveFromSearchList_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeychainPath_or_KeychainsPath, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_RemoveFromSearchList, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeychainPath_or_KeychainsPath, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_CreateKeychain_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, keychainPath)
	ZEND_ARG_INFO(0, password)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_CreateKeychain, 0, 0, 1)
	ZEND_ARG_INFO(0, keychainPath)
	ZEND_ARG_INFO(0, password)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_DeleteKeychain_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, keychainPath)
	ZEND_ARG_INFO(0, password)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_DeleteKeychain, 0, 0, 1)
	ZEND_ARG_INFO(0, keychainPath)
	ZEND_ARG_INFO(0, password)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_Add, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Certificate, 0, 1)
	ZEND_ARG_INFO(0, CopyPrivateKey_or_keychainPath_or_BindToExistingPrivateKey)
	ZEND_ARG_INFO(0, CopyPrivateKey_or_keychainPath)
	ZEND_ARG_INFO(0, setTrusted)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_ClearAll, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_PreloadCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_EvaluateTrust, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_ExportWithPrivateKey, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, password)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_get_Certificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_get_Keychains, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_set_Keychains, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStringList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_get_ReadOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_set_ReadOnly, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_set_CryptoProvider, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_get_LastPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_set_LastPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_get_OnEvaluationResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage_set_OnEvaluationResult, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAppleCertStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAppleCertStorage_methods[] = {
	PHP_ME(TElAppleCertStorage, GetOpenedKeychains_Inst, arginfo_TElAppleCertStorage_GetOpenedKeychains_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, GetOpenedKeychains, arginfo_TElAppleCertStorage_GetOpenedKeychains, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAppleCertStorage, AddToSearchList_Inst, arginfo_TElAppleCertStorage_AddToSearchList_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, AddToSearchList, arginfo_TElAppleCertStorage_AddToSearchList, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAppleCertStorage, RemoveFromSearchList_Inst, arginfo_TElAppleCertStorage_RemoveFromSearchList_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, RemoveFromSearchList, arginfo_TElAppleCertStorage_RemoveFromSearchList, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAppleCertStorage, CreateKeychain_Inst, arginfo_TElAppleCertStorage_CreateKeychain_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, CreateKeychain, arginfo_TElAppleCertStorage_CreateKeychain, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAppleCertStorage, DeleteKeychain_Inst, arginfo_TElAppleCertStorage_DeleteKeychain_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, DeleteKeychain, arginfo_TElAppleCertStorage_DeleteKeychain, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAppleCertStorage, Add, arginfo_TElAppleCertStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, ClearAll, arginfo_TElAppleCertStorage_ClearAll, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, Remove, arginfo_TElAppleCertStorage_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, Refresh, arginfo_TElAppleCertStorage_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, PreloadCertificates, arginfo_TElAppleCertStorage_PreloadCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, EvaluateTrust, arginfo_TElAppleCertStorage_EvaluateTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, ExportWithPrivateKey, arginfo_TElAppleCertStorage_ExportWithPrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, get_Count, arginfo_TElAppleCertStorage_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, get_Certificates, arginfo_TElAppleCertStorage_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, get_Keychains, arginfo_TElAppleCertStorage_get_Keychains, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, set_Keychains, arginfo_TElAppleCertStorage_set_Keychains, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, get_ReadOnly, arginfo_TElAppleCertStorage_get_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, set_ReadOnly, arginfo_TElAppleCertStorage_set_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, get_CryptoProvider, arginfo_TElAppleCertStorage_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, set_CryptoProvider, arginfo_TElAppleCertStorage_set_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, get_LastPassword, arginfo_TElAppleCertStorage_get_LastPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, set_LastPassword, arginfo_TElAppleCertStorage_set_LastPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, get_OnEvaluationResult, arginfo_TElAppleCertStorage_get_OnEvaluationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, set_OnEvaluationResult, arginfo_TElAppleCertStorage_set_OnEvaluationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElAppleCertStorage, __construct, arginfo_TElAppleCertStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAppleCertStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAppleCertStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAppleCertStorage", TElAppleCertStorage_methods);
	if (NULL == TElCustomCertStorage_ce_ptr)
		Register_TElCustomCertStorage(TSRMLS_C);
	TElAppleCertStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCertStorage_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBAppleCertStorage_Aliases(TSRMLS_D)
{
	if (NULL == TElAppleCertStorage_ce_ptr)
		Register_TElAppleCertStorage(TSRMLS_C);
	zend_register_class_alias("ElAppleCertStorage", TElAppleCertStorage_ce_ptr);
}
#endif
