#include "sbarcgzip.h"

void SB_CALLBACK TSBGZipProgressEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Processed, int64_t Total, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zProcessed;
	zval * zTotal;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zProcessed);
	ZVAL_LONG(zProcessed, (long)Processed);
	MAKE_STD_ZVAL(zTotal);
	ZVAL_LONG(zTotal, (long)Total);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zProcessed;
	params[2] = &zTotal;
	params[3] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zProcessed);
	zval_ptr_dtor(&zTotal);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBGZipUserActionNeededEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ForEvent, const char * pcDescription, int32_t szDescription, int32_t * UserAction)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zForEvent;
	zval * zDescription;
	zval * zUserAction;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zForEvent);
	ZVAL_LONG(zForEvent, (long)ForEvent);
	MAKE_STD_ZVAL(zDescription);
	ZVAL_STRINGL(zDescription, pcDescription, szDescription, 1);
	MAKE_STD_ZVAL(zUserAction);
	ZVAL_LONG(zUserAction, (long)*UserAction);

	params[0] = &zSender;
	params[1] = &zForEvent;
	params[2] = &zDescription;
	params[3] = &zUserAction;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zForEvent);
	zval_ptr_dtor(&zDescription);
	*UserAction = (int32_t)Z_LVAL_P(zUserAction);
	zval_ptr_dtor(&zUserAction);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBGZipExtractionStreamNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBGZipCompressionStreamNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBGZipArchiveErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ErrorCode, const char * pcErrorMessage, int32_t szErrorMessage, int8_t * TryContinue)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zErrorCode;
	zval * zErrorMessage;
	zval * zTryContinue;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)ErrorCode);
	MAKE_STD_ZVAL(zErrorMessage);
	ZVAL_STRINGL(zErrorMessage, pcErrorMessage, szErrorMessage, 1);
	MAKE_STD_ZVAL(zTryContinue);
	ZVAL_BOOL(zTryContinue, (zend_bool)*TryContinue);

	params[0] = &zSender;
	params[1] = &zErrorCode;
	params[2] = &zErrorMessage;
	params[3] = &zTryContinue;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zErrorCode);
	zval_ptr_dtor(&zErrorMessage);
	*TryContinue = (int8_t)Z_BVAL_P(zTryContinue);
	zval_ptr_dtor(&zTryContinue);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBGZipFileSystem_ce_ptr = NULL;

zend_class_entry *TElGZipDecompressingUnit_ce_ptr = NULL;

SB_PHP_METHOD(TElGZipDecompressingUnit, InitializeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGZipDecompressingUnit_InitializeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipDecompressingUnit, ProcessBlock)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGZipDecompressingUnit_ProcessBlock(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipDecompressingUnit, FinalizeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGZipDecompressingUnit_FinalizeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipDecompressingUnit, get_CRC32)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGZipDecompressingUnit_get_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipDecompressingUnit, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGZipDecompressingUnit_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipDecompressingUnit_InitializeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipDecompressingUnit_ProcessBlock, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipDecompressingUnit_FinalizeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipDecompressingUnit_get_CRC32, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipDecompressingUnit___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGZipDecompressingUnit_methods[] = {
	PHP_ME(TElGZipDecompressingUnit, InitializeProcessing, arginfo_TElGZipDecompressingUnit_InitializeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipDecompressingUnit, ProcessBlock, arginfo_TElGZipDecompressingUnit_ProcessBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipDecompressingUnit, FinalizeProcessing, arginfo_TElGZipDecompressingUnit_FinalizeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipDecompressingUnit, get_CRC32, arginfo_TElGZipDecompressingUnit_get_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipDecompressingUnit, __construct, arginfo_TElGZipDecompressingUnit___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGZipDecompressingUnit(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGZipDecompressingUnit_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGZipDecompressingUnit", TElGZipDecompressingUnit_methods);
	if (NULL == TElArcProcessingUnit_ce_ptr)
		Register_TElArcProcessingUnit(TSRMLS_C);
	TElGZipDecompressingUnit_ce_ptr = zend_register_internal_class_ex(&ce, TElArcProcessingUnit_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGZipCompressingUnit_ce_ptr = NULL;

SB_PHP_METHOD(TElGZipCompressingUnit, InitializeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGZipCompressingUnit_InitializeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipCompressingUnit, ProcessBlock)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGZipCompressingUnit_ProcessBlock(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipCompressingUnit, FinalizeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGZipCompressingUnit_FinalizeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipCompressingUnit, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGZipCompressingUnit_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipCompressingUnit, set_CompressionLevel)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElGZipCompressingUnit_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipCompressingUnit, get_CRC32)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGZipCompressingUnit_get_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipCompressingUnit, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGZipCompressingUnit_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipCompressingUnit_InitializeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipCompressingUnit_ProcessBlock, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipCompressingUnit_FinalizeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipCompressingUnit_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipCompressingUnit_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipCompressingUnit_get_CRC32, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipCompressingUnit___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGZipCompressingUnit_methods[] = {
	PHP_ME(TElGZipCompressingUnit, InitializeProcessing, arginfo_TElGZipCompressingUnit_InitializeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipCompressingUnit, ProcessBlock, arginfo_TElGZipCompressingUnit_ProcessBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipCompressingUnit, FinalizeProcessing, arginfo_TElGZipCompressingUnit_FinalizeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipCompressingUnit, get_CompressionLevel, arginfo_TElGZipCompressingUnit_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipCompressingUnit, set_CompressionLevel, arginfo_TElGZipCompressingUnit_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipCompressingUnit, get_CRC32, arginfo_TElGZipCompressingUnit_get_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipCompressingUnit, __construct, arginfo_TElGZipCompressingUnit___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGZipCompressingUnit(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGZipCompressingUnit_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGZipCompressingUnit", TElGZipCompressingUnit_methods);
	if (NULL == TElArcProcessingUnit_ce_ptr)
		Register_TElArcProcessingUnit(TSRMLS_C);
	TElGZipCompressingUnit_ce_ptr = zend_register_internal_class_ex(&ce, TElArcProcessingUnit_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGZipFileAttributes_ce_ptr = NULL;

SB_PHP_METHOD(TElGZipFileAttributes, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElGZipFileAttributes_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGZipFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElGZipFileAttributes_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGZipFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_FileName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGZipFileAttributes_get_FileName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(442654734, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_FileName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_FileName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_ModifyTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_ModifyTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_ModifyTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_ModifyTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_FileSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_FileSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_FileSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_FileSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_Flag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_Flag(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_Flag)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_Flag(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_ExtraFlag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_ExtraFlag(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_ExtraFlag)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_ExtraFlag(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_CRC16)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_CRC16(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_CRC16)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_CRC16(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_CRC32)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_CRC32)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_ExtraField)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGZipFileAttributes_get_ExtraField(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(125067537, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_ExtraField)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGZipFileAttributes_set_ExtraField(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_Comment)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGZipFileAttributes_get_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(334144410, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_Comment)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_FileSystem)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGZipFileSystemRaw fOutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_FileSystem(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_FileSystem)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_FileSystem(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGZipFileSystemRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_FileSystemCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_FileSystemCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_FileSystemCode)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_FileSystemCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_HasText)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_HasText(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_HasText)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_HasText(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_HasCRC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_HasCRC(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_HasCRC)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_HasCRC(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_HasExtra)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_HasExtra(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_HasExtra)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_HasExtra(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_HasName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_HasName(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_HasName)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_HasName(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, get_HasComment)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipFileAttributes_get_HasComment(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, set_HasComment)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGZipFileAttributes_set_HasComment(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipFileAttributes, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGZipFileAttributes_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElGZipFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElGZipFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_FileName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_FileName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_ModifyTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_ModifyTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_FileSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_FileSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_Flag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_Flag, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_ExtraFlag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_ExtraFlag, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_CRC16, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_CRC16, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_CRC32, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_CRC32, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_ExtraField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_ExtraField, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_Comment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_Comment, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_FileSystem, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_FileSystem, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_FileSystemCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_FileSystemCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_HasText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_HasText, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_HasCRC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_HasCRC, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_HasExtra, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_HasExtra, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_HasName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_HasName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_get_HasComment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes_set_HasComment, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipFileAttributes___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGZipFileAttributes_methods[] = {
	PHP_ME(TElGZipFileAttributes, Assign, arginfo_TElGZipFileAttributes_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, AssignTo, arginfo_TElGZipFileAttributes_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_FileName, arginfo_TElGZipFileAttributes_get_FileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_FileName, arginfo_TElGZipFileAttributes_set_FileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_ModifyTime, arginfo_TElGZipFileAttributes_get_ModifyTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_ModifyTime, arginfo_TElGZipFileAttributes_set_ModifyTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_FileSize, arginfo_TElGZipFileAttributes_get_FileSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_FileSize, arginfo_TElGZipFileAttributes_set_FileSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_Flag, arginfo_TElGZipFileAttributes_get_Flag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_Flag, arginfo_TElGZipFileAttributes_set_Flag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_ExtraFlag, arginfo_TElGZipFileAttributes_get_ExtraFlag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_ExtraFlag, arginfo_TElGZipFileAttributes_set_ExtraFlag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_CRC16, arginfo_TElGZipFileAttributes_get_CRC16, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_CRC16, arginfo_TElGZipFileAttributes_set_CRC16, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_CRC32, arginfo_TElGZipFileAttributes_get_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_CRC32, arginfo_TElGZipFileAttributes_set_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_ExtraField, arginfo_TElGZipFileAttributes_get_ExtraField, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_ExtraField, arginfo_TElGZipFileAttributes_set_ExtraField, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_Comment, arginfo_TElGZipFileAttributes_get_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_Comment, arginfo_TElGZipFileAttributes_set_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_FileSystem, arginfo_TElGZipFileAttributes_get_FileSystem, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_FileSystem, arginfo_TElGZipFileAttributes_set_FileSystem, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_FileSystemCode, arginfo_TElGZipFileAttributes_get_FileSystemCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_FileSystemCode, arginfo_TElGZipFileAttributes_set_FileSystemCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_HasText, arginfo_TElGZipFileAttributes_get_HasText, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_HasText, arginfo_TElGZipFileAttributes_set_HasText, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_HasCRC, arginfo_TElGZipFileAttributes_get_HasCRC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_HasCRC, arginfo_TElGZipFileAttributes_set_HasCRC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_HasExtra, arginfo_TElGZipFileAttributes_get_HasExtra, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_HasExtra, arginfo_TElGZipFileAttributes_set_HasExtra, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_HasName, arginfo_TElGZipFileAttributes_get_HasName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_HasName, arginfo_TElGZipFileAttributes_set_HasName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, get_HasComment, arginfo_TElGZipFileAttributes_get_HasComment, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, set_HasComment, arginfo_TElGZipFileAttributes_set_HasComment, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipFileAttributes, __construct, arginfo_TElGZipFileAttributes___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGZipFileAttributes(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGZipFileAttributes_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGZipFileAttributes", TElGZipFileAttributes_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGZipFileAttributes_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGZipReader_ce_ptr = NULL;

SB_PHP_METHOD(TElGZipReader, Open)
{
	char *sFileName;
	int sFileName_len;
	zend_bool bReadOnly;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sFileName, &sFileName_len, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElGZipReader_Open(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGZipReader_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGZipReader_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, Extract)
{
	char *sOutputFile;
	char *sOutputPath;
	int sOutputFile_len;
	int sOutputPath_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sOutputPath, &sOutputPath_len, &sOutputFile, &sOutputFile_len) == SUCCESS)
	{
		SBCheckError(TElGZipReader_Extract(SBGetObjectHandle(getThis() TSRMLS_CC), sOutputPath, (int32_t)sOutputPath_len, sOutputFile, (int32_t)sOutputFile_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGZipReader_Extract_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, CheckArchive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipReader_CheckArchive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, get_CompressedSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGZipReader_get_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, get_Attributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGZipReader_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGZipFileAttributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, get_IgnoreArchiveErrors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipReader_get_IgnoreArchiveErrors(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, set_IgnoreArchiveErrors)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGZipReader_set_IgnoreArchiveErrors(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, get_FilenamesCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGZipReader_get_FilenamesCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1801482892, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, set_FilenamesCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGZipReader_set_FilenamesCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGZipReader_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGZipReader_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, get_OnExtractionStreamNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGZipExtractionStreamNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElGZipReader_get_OnExtractionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, set_OnExtractionStreamNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElGZipReader_set_OnExtractionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBGZipExtractionStreamNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBGZipExtractionStreamNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGZipProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElGZipReader_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElGZipReader_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBGZipProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBGZipProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, get_OnUserActionNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGZipUserActionNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElGZipReader_get_OnUserActionNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, set_OnUserActionNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElGZipReader_set_OnUserActionNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBGZipUserActionNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBGZipUserActionNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, get_OnArchiveError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGZipArchiveErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElGZipReader_get_OnArchiveError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, set_OnArchiveError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElGZipReader_set_OnArchiveError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBGZipArchiveErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBGZipArchiveErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipReader, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGZipReader_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_Open, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_Extract, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutputPath_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, OutputFile)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_CheckArchive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_get_CompressedSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_get_IgnoreArchiveErrors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_set_IgnoreArchiveErrors, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_get_FilenamesCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_set_FilenamesCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_get_OnExtractionStreamNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_set_OnExtractionStreamNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_get_OnUserActionNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_set_OnUserActionNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_get_OnArchiveError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader_set_OnArchiveError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipReader___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGZipReader_methods[] = {
	PHP_ME(TElGZipReader, Open, arginfo_TElGZipReader_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, Close, arginfo_TElGZipReader_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, Extract, arginfo_TElGZipReader_Extract, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, CheckArchive, arginfo_TElGZipReader_CheckArchive, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, get_CompressedSize, arginfo_TElGZipReader_get_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, get_Attributes, arginfo_TElGZipReader_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, get_IgnoreArchiveErrors, arginfo_TElGZipReader_get_IgnoreArchiveErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, set_IgnoreArchiveErrors, arginfo_TElGZipReader_set_IgnoreArchiveErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, get_FilenamesCharset, arginfo_TElGZipReader_get_FilenamesCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, set_FilenamesCharset, arginfo_TElGZipReader_set_FilenamesCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, get_FileSystemAdapter, arginfo_TElGZipReader_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, set_FileSystemAdapter, arginfo_TElGZipReader_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, get_OnExtractionStreamNeeded, arginfo_TElGZipReader_get_OnExtractionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, set_OnExtractionStreamNeeded, arginfo_TElGZipReader_set_OnExtractionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, get_OnProgress, arginfo_TElGZipReader_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, set_OnProgress, arginfo_TElGZipReader_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, get_OnUserActionNeeded, arginfo_TElGZipReader_get_OnUserActionNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, set_OnUserActionNeeded, arginfo_TElGZipReader_set_OnUserActionNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, get_OnArchiveError, arginfo_TElGZipReader_get_OnArchiveError, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, set_OnArchiveError, arginfo_TElGZipReader_set_OnArchiveError, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipReader, __construct, arginfo_TElGZipReader___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGZipReader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGZipReader_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGZipReader", TElGZipReader_methods);
	if (NULL == TElBaseArchive_ce_ptr)
		Register_TElBaseArchive(TSRMLS_C);
	TElGZipReader_ce_ptr = zend_register_internal_class_ex(&ce, TElBaseArchive_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGZipWriter_ce_ptr = NULL;

SB_PHP_METHOD(TElGZipWriter, CreateArchive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGZipWriter_CreateArchive(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, Open)
{
	char *sFileName;
	int sFileName_len;
	zend_bool bReadOnly;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sFileName, &sFileName_len, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElGZipWriter_Open(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGZipWriter_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, Add)
{
	char *sFileName;
	int sFileName_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipWriter_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStream, TStream_ce_ptr, &sFileName, &sFileName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipWriter_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sFileName, (int32_t)sFileName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, Compress)
{
	char *sDestination;
	int sDestination_len;
	zval *oDestination;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGZipWriter_Compress(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDestination, &sDestination_len) == SUCCESS)
	{
		SBCheckError(TElGZipWriter_Compress_1(SBGetObjectHandle(getThis() TSRMLS_CC), sDestination, (int32_t)sDestination_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGZipWriter_Compress_2(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGZipWriter_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, get_NewArchive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGZipWriter_get_NewArchive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, get_FileSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGZipWriter_get_FileSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGZipWriter_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, set_CompressionLevel)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElGZipWriter_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, get_WorkFactor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGZipWriter_get_WorkFactor(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, set_WorkFactor)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElGZipWriter_set_WorkFactor(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, get_OnCompressionStreamNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGZipCompressionStreamNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElGZipWriter_get_OnCompressionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, set_OnCompressionStreamNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElGZipWriter_set_OnCompressionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBGZipCompressionStreamNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBGZipCompressionStreamNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGZipWriter, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGZipWriter_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_CreateArchive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_Open, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_Compress, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Destination, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_get_NewArchive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_get_FileSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_get_WorkFactor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_set_WorkFactor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_get_OnCompressionStreamNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter_set_OnCompressionStreamNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGZipWriter___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGZipWriter_methods[] = {
	PHP_ME(TElGZipWriter, CreateArchive, arginfo_TElGZipWriter_CreateArchive, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, Open, arginfo_TElGZipWriter_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, Add, arginfo_TElGZipWriter_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, Compress, arginfo_TElGZipWriter_Compress, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, Close, arginfo_TElGZipWriter_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, get_NewArchive, arginfo_TElGZipWriter_get_NewArchive, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, get_FileSize, arginfo_TElGZipWriter_get_FileSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, get_CompressionLevel, arginfo_TElGZipWriter_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, set_CompressionLevel, arginfo_TElGZipWriter_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, get_WorkFactor, arginfo_TElGZipWriter_get_WorkFactor, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, set_WorkFactor, arginfo_TElGZipWriter_set_WorkFactor, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, get_OnCompressionStreamNeeded, arginfo_TElGZipWriter_get_OnCompressionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, set_OnCompressionStreamNeeded, arginfo_TElGZipWriter_set_OnCompressionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElGZipWriter, __construct, arginfo_TElGZipWriter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGZipWriter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGZipWriter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGZipWriter", TElGZipWriter_methods);
	if (NULL == TElGZipReader_ce_ptr)
		Register_TElGZipReader(TSRMLS_C);
	TElGZipWriter_ce_ptr = zend_register_internal_class_ex(&ce, TElGZipReader_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBArcGZip_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_BUFFER_SIZE, SB_GZIP_BUFFER_SIZE, SB_GZIP_BUFFER_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_EVENT_EXTRACTION_FAILED, SB_GZIP_EVENT_EXTRACTION_FAILED, SB_GZIP_EVENT_EXTRACTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_EVENT_FILE_ALREADY_EXISTS, SB_GZIP_EVENT_FILE_ALREADY_EXISTS, SB_GZIP_EVENT_FILE_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_EVENT_CANNOT_CREATE_FILE, SB_GZIP_EVENT_CANNOT_CREATE_FILE, SB_GZIP_EVENT_CANNOT_CREATE_FILE);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_EVENT_DIR_ALREADY_EXISTS, SB_GZIP_EVENT_DIR_ALREADY_EXISTS, SB_GZIP_EVENT_DIR_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_EVENT_FILE_ALREADY_ADDED, SB_GZIP_EVENT_FILE_ALREADY_ADDED, SB_GZIP_EVENT_FILE_ALREADY_ADDED);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_EVENT_CRC_MISMATCH, SB_GZIP_EVENT_CRC_MISMATCH, SB_GZIP_EVENT_CRC_MISMATCH);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_ACTION_IGNORE, SB_GZIP_ACTION_IGNORE, SB_GZIP_ACTION_IGNORE);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_ACTION_ABORT, SB_GZIP_ACTION_ABORT, SB_GZIP_ACTION_ABORT);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_ACTION_RETRY, SB_GZIP_ACTION_RETRY, SB_GZIP_ACTION_RETRY);
	SB_REGISTER_LONG_CONSTANT(SBArcGZip, GZIP_ACTION_SKIP, SB_GZIP_ACTION_SKIP, SB_GZIP_ACTION_SKIP);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SErrorCorrupted, SB_SErrorCorrupted, SB_SErrorCorrupted);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SInvalidPath, SB_SInvalidPath, SB_SInvalidPath);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SInvalidTypeCast, SB_SInvalidTypeCast, SB_SInvalidTypeCast);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SFileAlreadyExists, SB_SFileAlreadyExists, SB_SFileAlreadyExists);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SCannotCreateFile, SB_SCannotCreateFile, SB_SCannotCreateFile);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SCRCMismatch, SB_SCRCMismatch, SB_SCRCMismatch);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SNotExtractNewArchive, SB_SNotExtractNewArchive, SB_SNotExtractNewArchive);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SInvalidActionRequested, SB_SInvalidActionRequested, SB_SInvalidActionRequested);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SInvalidOutputFile, SB_SInvalidOutputFile, SB_SInvalidOutputFile);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SNoOutputStream, SB_SNoOutputStream, SB_SNoOutputStream);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SInvalidCompressionLevel, SB_SInvalidCompressionLevel, SB_SInvalidCompressionLevel);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SInvalidWorkFactor, SB_SInvalidWorkFactor, SB_SInvalidWorkFactor);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SArchiveAlreadyHaveFile, SB_SArchiveAlreadyHaveFile, SB_SArchiveAlreadyHaveFile);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SNoInputForCompression, SB_SNoInputForCompression, SB_SNoInputForCompression);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SArchiveNotOpened, SB_SArchiveNotOpened, SB_SArchiveNotOpened);
	SB_REGISTER_STRING_CONSTANT(SBArcGZip, SArchiveNotAssign, SB_SArchiveNotAssign, SB_SArchiveNotAssign);
}

void Register_SBArcGZip_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBGZipFileSystem", NULL);
	TSBGZipFileSystem_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGZipFileSystem_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsFAT", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsAmiga", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsVMS", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsUnix", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fmVMCMS", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsAtariTOS", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsHPFS", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsMacintosh", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fdZSystem", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsCPM", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsTOPS20", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsNTFS", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsQDOS", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsAcornRISCOS", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSBGZipFileSystem_ce_ptr, "fsUnknown", 14)
}

void Register_SBArcGZip_Aliases(TSRMLS_D)
{
	if (NULL == TElGZipDecompressingUnit_ce_ptr)
		Register_TElGZipDecompressingUnit(TSRMLS_C);
	zend_register_class_alias("ElGZipDecompressingUnit", TElGZipDecompressingUnit_ce_ptr);
	if (NULL == TElGZipCompressingUnit_ce_ptr)
		Register_TElGZipCompressingUnit(TSRMLS_C);
	zend_register_class_alias("ElGZipCompressingUnit", TElGZipCompressingUnit_ce_ptr);
	if (NULL == TElGZipReader_ce_ptr)
		Register_TElGZipReader(TSRMLS_C);
	zend_register_class_alias("ElGZipReader", TElGZipReader_ce_ptr);
	if (NULL == TElGZipWriter_ce_ptr)
		Register_TElGZipWriter(TSRMLS_C);
	zend_register_class_alias("ElGZipWriter", TElGZipWriter_ce_ptr);
}

