#include "sbcamellia.h"

SB_PHP_METHOD(TCmInt64, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TCmInt64));
		intern->len = sizeof(TCmInt64);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TCmInt64, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TCmInt64));
}

zend_class_entry *TCmInt64_ce_ptr = NULL;

static zend_function_entry TCmInt64_methods[] = {
	PHP_ME(TCmInt64, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TCmInt64, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TCmInt64(TSRMLS_D)
{
	zend_class_entry ce;
	if (TCmInt64_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TCmInt64", TCmInt64_methods);
	TCmInt64_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TCmInt128, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TCmInt128));
		intern->len = sizeof(TCmInt128);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TCmInt128, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TCmInt128));
}

zend_class_entry *TCmInt128_ce_ptr = NULL;

static zend_function_entry TCmInt128_methods[] = {
	PHP_ME(TCmInt128, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TCmInt128, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TCmInt128(TSRMLS_D)
{
	zend_class_entry ce;
	if (TCmInt128_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TCmInt128", TCmInt128_methods);
	TCmInt128_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBCamelliaBuffer, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBCamelliaBuffer));
		intern->len = sizeof(TSBCamelliaBuffer);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBCamelliaBuffer, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBCamelliaBuffer));
}

zend_class_entry *TSBCamelliaBuffer_ce_ptr = NULL;

static zend_function_entry TSBCamelliaBuffer_methods[] = {
	PHP_ME(TSBCamelliaBuffer, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCamelliaBuffer, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSBCamelliaBuffer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBCamelliaBuffer_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBCamelliaBuffer", TSBCamelliaBuffer_methods);
	TSBCamelliaBuffer_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBCamelliaExpandedKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBCamelliaExpandedKey));
		intern->len = sizeof(TSBCamelliaExpandedKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBCamelliaExpandedKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBCamelliaExpandedKey));
}

zend_class_entry *TSBCamelliaExpandedKey_ce_ptr = NULL;

static zend_function_entry TSBCamelliaExpandedKey_methods[] = {
	PHP_ME(TSBCamelliaExpandedKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBCamelliaExpandedKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSBCamelliaExpandedKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBCamelliaExpandedKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBCamelliaExpandedKey", TSBCamelliaExpandedKey_methods);
	TSBCamelliaExpandedKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCamellia, EncryptBlock)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zend_bool bLongKey;
	zval *oKey;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzOb", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oKey, TSBCamelliaExpandedKey_ce_ptr, &bLongKey) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBCamellia_EncryptBlock(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TSBCamelliaExpandedKey *)SBGetStructPointer(oKey TSRMLS_CC), (int8_t)bLongKey) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer, &integer, &integer, TSBCamelliaExpandedKey, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCamellia, ExpandKeyForEncryption)
{
	SBArrayZValInfo aiKey;
	zval *oEKey;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaKey, &oEKey, TSBCamelliaExpandedKey_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && PZVAL_IS_REF(oEKey))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBCamellia_ExpandKeyForEncryption(aiKey.data, aiKey.len, (TSBCamelliaExpandedKey *)SBGetStructPointer(oEKey TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TSBCamelliaExpandedKey)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCamellia, ExpandKeyForDecryption)
{
	SBArrayZValInfo aiKey;
	zval *oEKey;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaKey, &oEKey, TSBCamelliaExpandedKey_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && PZVAL_IS_REF(oEKey))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBCamellia_ExpandKeyForDecryption(aiKey.data, aiKey.len, (TSBCamelliaExpandedKey *)SBGetStructPointer(oEKey TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TSBCamelliaExpandedKey)" TSRMLS_CC);
	}
}

