#include "sbcast128.h"

SB_PHP_METHOD(TCAST128Key, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TCAST128Key));
		intern->len = sizeof(TCAST128Key);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TCAST128Key, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TCAST128Key));
}

zend_class_entry *TCAST128Key_ce_ptr = NULL;

static zend_function_entry TCAST128Key_methods[] = {
	PHP_ME(TCAST128Key, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TCAST128Key, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TCAST128Key(TSRMLS_D)
{
	zend_class_entry ce;
	if (TCAST128Key_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TCAST128Key", TCAST128Key_methods);
	TCAST128Key_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TCAST128ExpandedKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TCAST128ExpandedKey));
		intern->len = sizeof(TCAST128ExpandedKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TCAST128ExpandedKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TCAST128ExpandedKey));
}

zend_class_entry *TCAST128ExpandedKey_ce_ptr = NULL;

static zend_function_entry TCAST128ExpandedKey_methods[] = {
	PHP_ME(TCAST128ExpandedKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TCAST128ExpandedKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TCAST128ExpandedKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TCAST128ExpandedKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TCAST128ExpandedKey", TCAST128ExpandedKey_methods);
	TCAST128ExpandedKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TCAST128Buffer, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TCAST128Buffer));
		intern->len = sizeof(TCAST128Buffer);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TCAST128Buffer, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TCAST128Buffer));
}

zend_class_entry *TCAST128Buffer_ce_ptr = NULL;

static zend_function_entry TCAST128Buffer_methods[] = {
	PHP_ME(TCAST128Buffer, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TCAST128Buffer, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TCAST128Buffer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TCAST128Buffer_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TCAST128Buffer", TCAST128Buffer_methods);
	TCAST128Buffer_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCAST128, ExpandKey)
{
	zval *oExpandedKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oKey, TCAST128Key_ce_ptr, &oExpandedKey, TCAST128ExpandedKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oExpandedKey))
	{
		SBCheckError(SBCAST128_ExpandKey((TCAST128Key *)SBGetStructPointer(oKey TSRMLS_CC), (TCAST128ExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TCAST128Key, &TCAST128ExpandedKey)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCAST128, Encrypt16)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	zval *oExpandedKey;
	zval *zu4B0;
	zval *zu4B1;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO", &zu4B0, &zu4B1, &oExpandedKey, TCAST128ExpandedKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(oExpandedKey))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		SBCheckError(SBCAST128_Encrypt16(&u4B0Raw, &u4B1Raw, (TCAST128ExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer, &TCAST128ExpandedKey)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCAST128, Decrypt16)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	zval *oExpandedKey;
	zval *zu4B0;
	zval *zu4B1;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO", &zu4B0, &zu4B1, &oExpandedKey, TCAST128ExpandedKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(oExpandedKey))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		SBCheckError(SBCAST128_Decrypt16(&u4B0Raw, &u4B1Raw, (TCAST128ExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer, &TCAST128ExpandedKey)" TSRMLS_CC);
	}
}

