#include "sbchsconv.h"

zend_class_entry *TPlConvertOption_ce_ptr = NULL;

zend_class_entry *TPlConvertOptions_ce_ptr = NULL;

zend_class_entry *TPlConverterLineState_ce_ptr = NULL;

zend_class_entry *TPlConverterLineStates_ce_ptr = NULL;

zend_class_entry *TPlUTF7State_ce_ptr = NULL;

zend_class_entry *TPlConverter_ce_ptr = NULL;

SB_PHP_METHOD(TPlConverter, Convert)
{
	char *sDest = NULL;
	char *sSource;
	int sSource_len;
	int32_t sDest_len = 0;
	long fOptions;
	long l4MaxChars;
	uint32_t _err;
	zval *oDest;
	zval *oSource;
	zval *zsDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sSource, &sSource_len, &zsDest, &fOptions) == SUCCESS) && PZVAL_IS_REF(zsDest) && (IS_STRING == Z_TYPE_P(zsDest)))
	{
		_err = TPlConverter_Convert(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, sDest, &sDest_len, (TPlConvertOptionsRaw)fOptions);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sDest = emalloc(sDest_len + 1);
			SBCheckError(SBGetLastReturnStringA(1001996868, 2, sDest, &sDest_len) TSRMLS_CC);
			zval_dtor(zsDest);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sDest[sDest_len] = 0;
		ZVAL_STRINGL(zsDest, sDest, sDest_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ll", &oSource, TStream_ce_ptr, &oDest, TStream_ce_ptr, &fOptions, &l4MaxChars) == SUCCESS)
	{
		SBCheckError(TPlConverter_Convert_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC), (TPlConvertOptionsRaw)fOptions, (int32_t)l4MaxChars) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string, integer) or (TStream, TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, IsConvert)
{
	char *sDest = NULL;
	char *sSource;
	int sSource_len;
	int32_t sDest_len = 0;
	long fOptions;
	long l4MaxChars;
	uint32_t _err;
	zval *oDest;
	zval *oSource;
	zval *zsDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sSource, &sSource_len, &zsDest, &fOptions) == SUCCESS) && PZVAL_IS_REF(zsDest) && (IS_STRING == Z_TYPE_P(zsDest)))
	{
		int8_t bOutResultRaw = 0;
		_err = TPlConverter_IsConvert(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, sDest, &sDest_len, (TPlConvertOptionsRaw)fOptions, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sDest = emalloc(sDest_len + 1);
			SBCheckError(SBGetLastReturnStringA(2055207206, 2, sDest, &sDest_len) TSRMLS_CC);
			zval_dtor(zsDest);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sDest[sDest_len] = 0;
		ZVAL_STRINGL(zsDest, sDest, sDest_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ll", &oSource, TStream_ce_ptr, &oDest, TStream_ce_ptr, &fOptions, &l4MaxChars) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TPlConverter_IsConvert_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC), (TPlConvertOptionsRaw)fOptions, (int32_t)l4MaxChars, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string, integer) or (TStream, TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, ConvertFromUnicode)
{
	char *sDest = NULL;
	char *sSource;
	int sSource_len;
	int32_t sDest_len = 0;
	long fOptions;
	uint32_t _err;
	zval *zsDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sSource, &sSource_len, &zsDest, &fOptions) == SUCCESS) && PZVAL_IS_REF(zsDest) && (IS_STRING == Z_TYPE_P(zsDest)))
	{
		_err = TPlConverter_ConvertFromUnicode(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, sDest, &sDest_len, (TPlConvertOptionsRaw)fOptions);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sDest = emalloc(sDest_len + 1);
			SBCheckError(SBGetLastReturnStringA(-546920311, 2, sDest, &sDest_len) TSRMLS_CC);
			zval_dtor(zsDest);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sDest[sDest_len] = 0;
		ZVAL_STRINGL(zsDest, sDest, sDest_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, ConvertToUnicode)
{
	char *sDest = NULL;
	char *sSource;
	int sSource_len;
	int32_t sDest_len = 0;
	long fOptions;
	uint32_t _err;
	zval *zsDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sSource, &sSource_len, &zsDest, &fOptions) == SUCCESS) && PZVAL_IS_REF(zsDest) && (IS_STRING == Z_TYPE_P(zsDest)))
	{
		_err = TPlConverter_ConvertToUnicode(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, sDest, &sDest_len, (TPlConvertOptionsRaw)fOptions);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sDest = emalloc(sDest_len + 1);
			SBCheckError(SBGetLastReturnStringA(1817422112, 2, sDest, &sDest_len) TSRMLS_CC);
			zval_dtor(zsDest);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sDest[sDest_len] = 0;
		ZVAL_STRINGL(zsDest, sDest, sDest_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, IsConvertFromUnicode)
{
	char *sDest = NULL;
	char *sSource;
	int sSource_len;
	int32_t sDest_len = 0;
	long fOptions;
	uint32_t _err;
	zval *zsDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sSource, &sSource_len, &zsDest, &fOptions) == SUCCESS) && PZVAL_IS_REF(zsDest) && (IS_STRING == Z_TYPE_P(zsDest)))
	{
		int8_t bOutResultRaw = 0;
		_err = TPlConverter_IsConvertFromUnicode(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, sDest, &sDest_len, (TPlConvertOptionsRaw)fOptions, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sDest = emalloc(sDest_len + 1);
			SBCheckError(SBGetLastReturnStringA(880438118, 2, sDest, &sDest_len) TSRMLS_CC);
			zval_dtor(zsDest);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sDest[sDest_len] = 0;
		ZVAL_STRINGL(zsDest, sDest, sDest_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, IsConvertToUnicode)
{
	char *sDest = NULL;
	char *sSource;
	int sSource_len;
	int32_t sDest_len = 0;
	long fOptions;
	uint32_t _err;
	zval *zsDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sSource, &sSource_len, &zsDest, &fOptions) == SUCCESS) && PZVAL_IS_REF(zsDest) && (IS_STRING == Z_TYPE_P(zsDest)))
	{
		int8_t bOutResultRaw = 0;
		_err = TPlConverter_IsConvertToUnicode(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, sDest, &sDest_len, (TPlConvertOptionsRaw)fOptions, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sDest = emalloc(sDest_len + 1);
			SBCheckError(SBGetLastReturnStringA(101573092, 2, sDest, &sDest_len) TSRMLS_CC);
			zval_dtor(zsDest);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sDest[sDest_len] = 0;
		ZVAL_STRINGL(zsDest, sDest, sDest_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, get_DstCharset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlConverter_get_DstCharset(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, IPlCharset_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, get_DstCharsetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlConverter_get_DstCharsetName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1992048386, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, set_DstCharsetName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TPlConverter_set_DstCharsetName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, get_SrcCharset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlConverter_get_SrcCharset(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, IPlCharset_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, get_SrcCharsetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlConverter_get_SrcCharsetName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(791317412, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, set_SrcCharsetName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TPlConverter_set_SrcCharsetName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConverter, __construct)
{
	char *sDstCharset;
	char *sSrcCharset;
	int sDstCharset_len;
	int sSrcCharset_len;
	zval *oDstCharset;
	zval *oSrcCharset;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlConverter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sSrcCharset, &sSrcCharset_len, &sDstCharset, &sDstCharset_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlConverter_Create_1(sSrcCharset, (int32_t)sSrcCharset_len, sDstCharset, (int32_t)sDstCharset_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSrcCharset, IPlCharset_ce_ptr, &oDstCharset, IPlCharset_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlConverter_Create_2(SBGetObjectHandle(oSrcCharset TSRMLS_CC), SBGetObjectHandle(oDstCharset TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string, string) or (IPlCharset, IPlCharset)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_Convert, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Dest, 0, 1)
	ZEND_ARG_INFO(0, Options)
	ZEND_ARG_INFO(0, MaxChars)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_IsConvert, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Dest, 0, 1)
	ZEND_ARG_INFO(0, Options)
	ZEND_ARG_INFO(0, MaxChars)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_ConvertFromUnicode, 0, 0, 3)
	ZEND_ARG_INFO(0, Source)
	ZEND_ARG_INFO(1, Dest)
	ZEND_ARG_INFO(0, Options)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_ConvertToUnicode, 0, 0, 3)
	ZEND_ARG_INFO(0, Source)
	ZEND_ARG_INFO(1, Dest)
	ZEND_ARG_INFO(0, Options)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_IsConvertFromUnicode, 0, 0, 3)
	ZEND_ARG_INFO(0, Source)
	ZEND_ARG_INFO(1, Dest)
	ZEND_ARG_INFO(0, Options)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_IsConvertToUnicode, 0, 0, 3)
	ZEND_ARG_INFO(0, Source)
	ZEND_ARG_INFO(1, Dest)
	ZEND_ARG_INFO(0, Options)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_get_DstCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_get_DstCharsetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_set_DstCharsetName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_get_SrcCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_get_SrcCharsetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter_set_SrcCharsetName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConverter___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, SrcCharset, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DstCharset, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TPlConverter_methods[] = {
	PHP_ME(TPlConverter, Convert, arginfo_TPlConverter_Convert, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, IsConvert, arginfo_TPlConverter_IsConvert, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, ConvertFromUnicode, arginfo_TPlConverter_ConvertFromUnicode, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, ConvertToUnicode, arginfo_TPlConverter_ConvertToUnicode, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, IsConvertFromUnicode, arginfo_TPlConverter_IsConvertFromUnicode, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, IsConvertToUnicode, arginfo_TPlConverter_IsConvertToUnicode, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, get_DstCharset, arginfo_TPlConverter_get_DstCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, get_DstCharsetName, arginfo_TPlConverter_get_DstCharsetName, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, set_DstCharsetName, arginfo_TPlConverter_set_DstCharsetName, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, get_SrcCharset, arginfo_TPlConverter_get_SrcCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, get_SrcCharsetName, arginfo_TPlConverter_get_SrcCharsetName, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, set_SrcCharsetName, arginfo_TPlConverter_set_SrcCharsetName, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConverter, __construct, arginfo_TPlConverter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlConverter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlConverter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlConverter", TPlConverter_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TPlConverter_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlCustomUTF_ce_ptr = NULL;

SB_PHP_METHOD(TPlCustomUTF, GetCategory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlCustomUTF_GetCategory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1631645591, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomUTF, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCustomUTF_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomUTF, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCustomUTF_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomUTF, CreateShift)
{
	long l4Shift;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Shift) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCustomUTF_CreateShift((int32_t)l4Shift, &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomUTF, CreateNoInit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCustomUTF_CreateNoInit(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomUTF, CreateForFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCustomUTF_CreateForFinalize(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF_GetCategory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF_CreateShift, 0, 0, 1)
	ZEND_ARG_INFO(0, Shift)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF_CreateNoInit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF_CreateForFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlCustomUTF_methods[] = {
	PHP_ME(TPlCustomUTF, GetCategory, arginfo_TPlCustomUTF_GetCategory, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCustomUTF, ClassType, arginfo_TPlCustomUTF_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlCustomUTF, __construct, arginfo_TPlCustomUTF___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TPlCustomUTF, CreateShift, arginfo_TPlCustomUTF_CreateShift, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlCustomUTF, CreateNoInit, arginfo_TPlCustomUTF_CreateNoInit, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlCustomUTF, CreateForFinalize, arginfo_TPlCustomUTF_CreateForFinalize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlCustomUTF(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlCustomUTF_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlCustomUTF", TPlCustomUTF_methods);
	if (NULL == TPlCharset_ce_ptr)
		Register_TPlCharset(TSRMLS_C);
	TPlCustomUTF_ce_ptr = zend_register_internal_class_ex(&ce, TPlCharset_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlUTF32_ce_ptr = NULL;

SB_PHP_METHOD(TPlUTF32, ConvertFromUCS)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlUTF32_ConvertFromUCS(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32, ConvertToUCS)
{
	uint32_t u4CharRaw = 0;
	zval *oStream;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zu4Char) == SUCCESS) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlUTF32_ConvertToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32, ConvertBufferToUCS)
{
	long l4Count;
	SBPointerZValInfo piBuf;
	uint32_t u4CharRaw = 0;
	zend_bool bIsLastChunk;
	zval *zpBuf;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbz", &zpBuf, &l4Count, &bIsLastChunk, &zu4Char) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlUTF32_ConvertBufferToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), piBuf.data, (int32_t)l4Count, (int8_t)bIsLastChunk, &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF32_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(449190065, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF32_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF32_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32, CreateShift)
{
	long l4Shift;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Shift) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF32_CreateShift((int32_t)l4Shift, &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32, CreateNoInit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF32_CreateNoInit(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32, CreateForFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF32_CreateForFinalize(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32_ConvertFromUCS, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32_ConvertToUCS, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32_ConvertBufferToUCS, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, IsLastChunk)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32_CreateShift, 0, 0, 1)
	ZEND_ARG_INFO(0, Shift)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32_CreateNoInit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32_CreateForFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlUTF32_methods[] = {
	PHP_ME(TPlUTF32, ConvertFromUCS, arginfo_TPlUTF32_ConvertFromUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF32, ConvertToUCS, arginfo_TPlUTF32_ConvertToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF32, ConvertBufferToUCS, arginfo_TPlUTF32_ConvertBufferToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF32, GetDescription, arginfo_TPlUTF32_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF32, ClassType, arginfo_TPlUTF32_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF32, __construct, arginfo_TPlUTF32___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF32, CreateShift, arginfo_TPlUTF32_CreateShift, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF32, CreateNoInit, arginfo_TPlUTF32_CreateNoInit, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF32, CreateForFinalize, arginfo_TPlUTF32_CreateForFinalize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlUTF32(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlUTF32_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlUTF32", TPlUTF32_methods);
	if (NULL == TPlCustomUTF_ce_ptr)
		Register_TPlCustomUTF(TSRMLS_C);
	TPlUTF32_ce_ptr = zend_register_internal_class_ex(&ce, TPlCustomUTF_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlUTF32BE_ce_ptr = NULL;

SB_PHP_METHOD(TPlUTF32BE, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF32BE_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1158159909, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32BE, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF32BE_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF32BE, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF32BE_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32BE_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32BE_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF32BE___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlUTF32BE_methods[] = {
	PHP_ME(TPlUTF32BE, GetDescription, arginfo_TPlUTF32BE_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF32BE, ClassType, arginfo_TPlUTF32BE_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF32BE, __construct, arginfo_TPlUTF32BE___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlUTF32BE(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlUTF32BE_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlUTF32BE", TPlUTF32BE_methods);
	if (NULL == TPlUTF32_ce_ptr)
		Register_TPlUTF32(TSRMLS_C);
	TPlUTF32BE_ce_ptr = zend_register_internal_class_ex(&ce, TPlUTF32_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlUTF16_ce_ptr = NULL;

SB_PHP_METHOD(TPlUTF16, ConvertFromUCS)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlUTF16_ConvertFromUCS(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16, ConvertToUCS)
{
	uint32_t u4CharRaw = 0;
	zval *oStream;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zu4Char) == SUCCESS) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlUTF16_ConvertToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16, ConvertBufferToUCS)
{
	long l4Count;
	SBPointerZValInfo piBuf;
	uint32_t u4CharRaw = 0;
	zend_bool bIsLastChunk;
	zval *zpBuf;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbz", &zpBuf, &l4Count, &bIsLastChunk, &zu4Char) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlUTF16_ConvertBufferToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), piBuf.data, (int32_t)l4Count, (int8_t)bIsLastChunk, &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF16_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1688344979, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF16_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF16_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16, CreateShift)
{
	long l4Shift;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Shift) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF16_CreateShift((int32_t)l4Shift, &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16, CreateNoInit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF16_CreateNoInit(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16, CreateForFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF16_CreateForFinalize(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16_ConvertFromUCS, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16_ConvertToUCS, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16_ConvertBufferToUCS, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, IsLastChunk)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16_CreateShift, 0, 0, 1)
	ZEND_ARG_INFO(0, Shift)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16_CreateNoInit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16_CreateForFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlUTF16_methods[] = {
	PHP_ME(TPlUTF16, ConvertFromUCS, arginfo_TPlUTF16_ConvertFromUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF16, ConvertToUCS, arginfo_TPlUTF16_ConvertToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF16, ConvertBufferToUCS, arginfo_TPlUTF16_ConvertBufferToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF16, GetDescription, arginfo_TPlUTF16_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF16, ClassType, arginfo_TPlUTF16_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF16, __construct, arginfo_TPlUTF16___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF16, CreateShift, arginfo_TPlUTF16_CreateShift, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF16, CreateNoInit, arginfo_TPlUTF16_CreateNoInit, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF16, CreateForFinalize, arginfo_TPlUTF16_CreateForFinalize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlUTF16(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlUTF16_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlUTF16", TPlUTF16_methods);
	if (NULL == TPlCustomUTF_ce_ptr)
		Register_TPlCustomUTF(TSRMLS_C);
	TPlUTF16_ce_ptr = zend_register_internal_class_ex(&ce, TPlCustomUTF_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlUTF16BE_ce_ptr = NULL;

SB_PHP_METHOD(TPlUTF16BE, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF16BE_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-805127283, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16BE, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF16BE_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF16BE, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF16BE_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16BE_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16BE_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF16BE___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlUTF16BE_methods[] = {
	PHP_ME(TPlUTF16BE, GetDescription, arginfo_TPlUTF16BE_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF16BE, ClassType, arginfo_TPlUTF16BE_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF16BE, __construct, arginfo_TPlUTF16BE___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlUTF16BE(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlUTF16BE_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlUTF16BE", TPlUTF16BE_methods);
	if (NULL == TPlUTF16_ce_ptr)
		Register_TPlUTF16(TSRMLS_C);
	TPlUTF16BE_ce_ptr = zend_register_internal_class_ex(&ce, TPlUTF16_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlUTF8_ce_ptr = NULL;

SB_PHP_METHOD(TPlUTF8, ConvertFromUCS)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlUTF8_ConvertFromUCS(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF8, ConvertToUCS)
{
	uint32_t u4CharRaw = 0;
	zval *oStream;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zu4Char) == SUCCESS) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlUTF8_ConvertToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF8, ConvertBufferToUCS)
{
	long l4Count;
	SBPointerZValInfo piBuf;
	uint32_t u4CharRaw = 0;
	zend_bool bIsLastChunk;
	zval *zpBuf;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbz", &zpBuf, &l4Count, &bIsLastChunk, &zu4Char) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlUTF8_ConvertBufferToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), piBuf.data, (int32_t)l4Count, (int8_t)bIsLastChunk, &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF8, GetCategory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF8_GetCategory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1603300002, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF8, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF8_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1481134695, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF8, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF8_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF8, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF8_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF8, CreateShift)
{
	long l4Shift;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Shift) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF8_CreateShift((int32_t)l4Shift, &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF8, CreateNoInit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF8_CreateNoInit(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF8, CreateForFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF8_CreateForFinalize(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8_ConvertFromUCS, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8_ConvertToUCS, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8_ConvertBufferToUCS, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, IsLastChunk)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8_GetCategory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8_CreateShift, 0, 0, 1)
	ZEND_ARG_INFO(0, Shift)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8_CreateNoInit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF8_CreateForFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlUTF8_methods[] = {
	PHP_ME(TPlUTF8, ConvertFromUCS, arginfo_TPlUTF8_ConvertFromUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF8, ConvertToUCS, arginfo_TPlUTF8_ConvertToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF8, ConvertBufferToUCS, arginfo_TPlUTF8_ConvertBufferToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF8, GetCategory, arginfo_TPlUTF8_GetCategory, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF8, GetDescription, arginfo_TPlUTF8_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF8, ClassType, arginfo_TPlUTF8_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF8, __construct, arginfo_TPlUTF8___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF8, CreateShift, arginfo_TPlUTF8_CreateShift, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF8, CreateNoInit, arginfo_TPlUTF8_CreateNoInit, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF8, CreateForFinalize, arginfo_TPlUTF8_CreateForFinalize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlUTF8(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlUTF8_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlUTF8", TPlUTF8_methods);
	if (NULL == TPlCharset_ce_ptr)
		Register_TPlCharset(TSRMLS_C);
	TPlUTF8_ce_ptr = zend_register_internal_class_ex(&ce, TPlCharset_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlCustomUTF7_ce_ptr = NULL;

SB_PHP_METHOD(TPlCustomUTF7, ConvertFromUCS)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlCustomUTF7_ConvertFromUCS(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomUTF7, ConvertToUCS)
{
	uint32_t u4CharRaw = 0;
	zval *oStream;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zu4Char) == SUCCESS) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlCustomUTF7_ConvertToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomUTF7, ConvertBufferToUCS)
{
	long l4Count;
	SBPointerZValInfo piBuf;
	uint32_t u4CharRaw = 0;
	zend_bool bIsLastChunk;
	zval *zpBuf;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbz", &zpBuf, &l4Count, &bIsLastChunk, &zu4Char) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlCustomUTF7_ConvertBufferToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), piBuf.data, (int32_t)l4Count, (int8_t)bIsLastChunk, &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomUTF7, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCustomUTF7_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomUTF7, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCustomUTF7_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF7_ConvertFromUCS, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF7_ConvertToUCS, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF7_ConvertBufferToUCS, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, IsLastChunk)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF7_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomUTF7___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlCustomUTF7_methods[] = {
	PHP_ME(TPlCustomUTF7, ConvertFromUCS, arginfo_TPlCustomUTF7_ConvertFromUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCustomUTF7, ConvertToUCS, arginfo_TPlCustomUTF7_ConvertToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCustomUTF7, ConvertBufferToUCS, arginfo_TPlCustomUTF7_ConvertBufferToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCustomUTF7, ClassType, arginfo_TPlCustomUTF7_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlCustomUTF7, __construct, arginfo_TPlCustomUTF7___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlCustomUTF7(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlCustomUTF7_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlCustomUTF7", TPlCustomUTF7_methods);
	if (NULL == TPlCharset_ce_ptr)
		Register_TPlCharset(TSRMLS_C);
	TPlCustomUTF7_ce_ptr = zend_register_internal_class_ex(&ce, TPlCharset_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlUTF7_ce_ptr = NULL;

SB_PHP_METHOD(TPlUTF7, GetCategory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF7_GetCategory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1988481810, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF7, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF7_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-472907352, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF7, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF7_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF7, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF7_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF7_GetCategory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF7_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF7_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF7___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlUTF7_methods[] = {
	PHP_ME(TPlUTF7, GetCategory, arginfo_TPlUTF7_GetCategory, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF7, GetDescription, arginfo_TPlUTF7_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF7, ClassType, arginfo_TPlUTF7_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF7, __construct, arginfo_TPlUTF7___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlUTF7(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlUTF7_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlUTF7", TPlUTF7_methods);
	if (NULL == TPlCustomUTF7_ce_ptr)
		Register_TPlCustomUTF7(TSRMLS_C);
	TPlUTF7_ce_ptr = zend_register_internal_class_ex(&ce, TPlCustomUTF7_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlUTF7_IMAP_ce_ptr = NULL;

SB_PHP_METHOD(TPlUTF7_IMAP, GetCategory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF7_IMAP_GetCategory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(339467666, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF7_IMAP, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlUTF7_IMAP_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(131520256, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF7_IMAP, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF7_IMAP_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlUTF7_IMAP, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlUTF7_IMAP_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF7_IMAP_GetCategory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF7_IMAP_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF7_IMAP_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlUTF7_IMAP___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlUTF7_IMAP_methods[] = {
	PHP_ME(TPlUTF7_IMAP, GetCategory, arginfo_TPlUTF7_IMAP_GetCategory, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF7_IMAP, GetDescription, arginfo_TPlUTF7_IMAP_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUTF7_IMAP, ClassType, arginfo_TPlUTF7_IMAP_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUTF7_IMAP, __construct, arginfo_TPlUTF7_IMAP___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlUTF7_IMAP(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlUTF7_IMAP_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlUTF7_IMAP", TPlUTF7_IMAP_methods);
	if (NULL == TPlCustomUTF7_ce_ptr)
		Register_TPlCustomUTF7(TSRMLS_C);
	TPlUTF7_IMAP_ce_ptr = zend_register_internal_class_ex(&ce, TPlCustomUTF7_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlConvBuffer_ce_ptr = NULL;

SB_PHP_METHOD(TPlConvBuffer, CheckString)
{
	char *sStr;
	int sStr_len;
	long l4Shift;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oStream, TStream_ce_ptr, &sStr, &sStr_len, &l4Shift) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TPlConvBuffer_CheckString(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sStr, (int32_t)sStr_len, (int32_t)l4Shift, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, GetByte)
{
	int8_t bExistsRaw;
	zval *oStream;
	zval *zbExists;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zbExists) == SUCCESS) && PZVAL_IS_REF(zbExists) && (IS_BOOL == Z_TYPE_P(zbExists)))
	{
		uint8_t u1OutResultRaw = 0;
		bExistsRaw = (int8_t)Z_BVAL_P(zbExists);
		SBCheckError(TPlConvBuffer_GetByte(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &bExistsRaw, &u1OutResultRaw) TSRMLS_CC);
		ZVAL_BOOL(zbExists, (zend_bool)bExistsRaw);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, GetWide)
{
	int8_t bExistsRaw;
	zval *oStream;
	zval *zbExists;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zbExists) == SUCCESS) && PZVAL_IS_REF(zbExists) && (IS_BOOL == Z_TYPE_P(zbExists)))
	{
		uint16_t u2OutResultRaw = 0;
		bExistsRaw = (int8_t)Z_BVAL_P(zbExists);
		SBCheckError(TPlConvBuffer_GetWide(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &bExistsRaw, &u2OutResultRaw) TSRMLS_CC);
		ZVAL_BOOL(zbExists, (zend_bool)bExistsRaw);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, GetLong)
{
	int8_t bExistsRaw;
	zval *oStream;
	zval *zbExists;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zbExists) == SUCCESS) && PZVAL_IS_REF(zbExists) && (IS_BOOL == Z_TYPE_P(zbExists)))
	{
		uint32_t u4OutResultRaw = 0;
		bExistsRaw = (int8_t)Z_BVAL_P(zbExists);
		SBCheckError(TPlConvBuffer_GetLong(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &bExistsRaw, &u4OutResultRaw) TSRMLS_CC);
		ZVAL_BOOL(zbExists, (zend_bool)bExistsRaw);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, ReturnByte)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TPlConvBuffer_ReturnByte(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TPlConvBuffer_ReturnByte_1(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, ReturnBytes)
{
	long l4Count;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Count) == SUCCESS)
	{
		SBCheckError(TPlConvBuffer_ReturnBytes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, Flush)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TPlConvBuffer_Flush(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, Put)
{
	long l4Count;
	SBPointerZValInfo piData;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpData, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlConvBuffer_Put(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4Count) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, PutByte)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TPlConvBuffer_PutByte(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, PutWordLE)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TPlConvBuffer_PutWordLE(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, RevokeByte)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TPlConvBuffer_RevokeByte(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvBuffer, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlConvBuffer_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_CheckString, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Str)
	ZEND_ARG_INFO(0, Shift)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_GetByte, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Exists)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_GetWide, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Exists)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_GetLong, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Exists)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_ReturnByte, 0, 0, 0)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_ReturnBytes, 0, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_Flush, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_Put, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_PutByte, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_PutWordLE, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer_RevokeByte, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvBuffer___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlConvBuffer_methods[] = {
	PHP_ME(TPlConvBuffer, CheckString, arginfo_TPlConvBuffer_CheckString, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, GetByte, arginfo_TPlConvBuffer_GetByte, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, GetWide, arginfo_TPlConvBuffer_GetWide, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, GetLong, arginfo_TPlConvBuffer_GetLong, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, ReturnByte, arginfo_TPlConvBuffer_ReturnByte, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, ReturnBytes, arginfo_TPlConvBuffer_ReturnBytes, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, Flush, arginfo_TPlConvBuffer_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, Put, arginfo_TPlConvBuffer_Put, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, PutByte, arginfo_TPlConvBuffer_PutByte, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, PutWordLE, arginfo_TPlConvBuffer_PutWordLE, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, RevokeByte, arginfo_TPlConvBuffer_RevokeByte, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvBuffer, __construct, arginfo_TPlConvBuffer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlConvBuffer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlConvBuffer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlConvBuffer", TPlConvBuffer_methods);
	if (NULL == TInterfacedObject_ce_ptr)
		Register_TInterfacedObject(TSRMLS_C);
	TPlConvBuffer_ce_ptr = zend_register_internal_class_ex(&ce, TInterfacedObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlCustomStringStream_ce_ptr = NULL;

SB_PHP_METHOD(TPlCustomStringStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlCustomStringStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomStringStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlCustomStringStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomStringStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlCustomStringStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TPlCustomStringStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomStringStream, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TPlCustomStringStream_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCustomStringStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCustomStringStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomStringStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomStringStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomStringStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomStringStream_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomStringStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlCustomStringStream_methods[] = {
	PHP_ME(TPlCustomStringStream, Read, arginfo_TPlCustomStringStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCustomStringStream, Write, arginfo_TPlCustomStringStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCustomStringStream, Seek, arginfo_TPlCustomStringStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCustomStringStream, Clear, arginfo_TPlCustomStringStream_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCustomStringStream, __construct, arginfo_TPlCustomStringStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlCustomStringStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlCustomStringStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlCustomStringStream", TPlCustomStringStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TPlCustomStringStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlAnsiStringStream_ce_ptr = NULL;

SB_PHP_METHOD(TPlAnsiStringStream, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlAnsiStringStream_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(6513069, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlAnsiStringStream, set_Data)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TPlAnsiStringStream_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlAnsiStringStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlAnsiStringStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlAnsiStringStream_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlAnsiStringStream_set_Data, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlAnsiStringStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlAnsiStringStream_methods[] = {
	PHP_ME(TPlAnsiStringStream, get_Data, arginfo_TPlAnsiStringStream_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TPlAnsiStringStream, set_Data, arginfo_TPlAnsiStringStream_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TPlAnsiStringStream, __construct, arginfo_TPlAnsiStringStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlAnsiStringStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlAnsiStringStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlAnsiStringStream", TPlAnsiStringStream_methods);
	if (NULL == TPlCustomStringStream_ce_ptr)
		Register_TPlCustomStringStream(TSRMLS_C);
	TPlAnsiStringStream_ce_ptr = zend_register_internal_class_ex(&ce, TPlCustomStringStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlWideStringStream_ce_ptr = NULL;

SB_PHP_METHOD(TPlWideStringStream, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlWideStringStream_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1868646672, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlWideStringStream, set_Data)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TPlWideStringStream_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlWideStringStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlWideStringStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlWideStringStream_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlWideStringStream_set_Data, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlWideStringStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlWideStringStream_methods[] = {
	PHP_ME(TPlWideStringStream, get_Data, arginfo_TPlWideStringStream_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TPlWideStringStream, set_Data, arginfo_TPlWideStringStream_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TPlWideStringStream, __construct, arginfo_TPlWideStringStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlWideStringStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlWideStringStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlWideStringStream", TPlWideStringStream_methods);
	if (NULL == TPlCustomStringStream_ce_ptr)
		Register_TPlCustomStringStream(TSRMLS_C);
	TPlWideStringStream_ce_ptr = zend_register_internal_class_ex(&ce, TPlCustomStringStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlByteArrayStream_ce_ptr = NULL;

SB_PHP_METHOD(TPlByteArrayStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlByteArrayStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlByteArrayStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlByteArrayStream_methods[] = {
	PHP_ME(TPlByteArrayStream, __construct, arginfo_TPlByteArrayStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlByteArrayStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlByteArrayStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlByteArrayStream", TPlByteArrayStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TPlByteArrayStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlCustomStringStreamPool_ce_ptr = NULL;

SB_PHP_METHOD(TPlCustomStringStreamPool, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCustomStringStreamPool_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCustomStringStreamPool___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlCustomStringStreamPool_methods[] = {
	PHP_ME(TPlCustomStringStreamPool, __construct, arginfo_TPlCustomStringStreamPool___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlCustomStringStreamPool(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlCustomStringStreamPool_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlCustomStringStreamPool", TPlCustomStringStreamPool_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TPlCustomStringStreamPool_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlAnsiStringStreamPool_ce_ptr = NULL;

SB_PHP_METHOD(TPlAnsiStringStreamPool, AcquireStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlAnsiStringStreamPool_AcquireStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TPlAnsiStringStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlAnsiStringStreamPool, ReleaseStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TPlAnsiStringStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TPlAnsiStringStreamPool_ReleaseStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPlAnsiStringStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlAnsiStringStreamPool, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlAnsiStringStreamPool_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlAnsiStringStreamPool_AcquireStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlAnsiStringStreamPool_ReleaseStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TPlAnsiStringStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlAnsiStringStreamPool___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlAnsiStringStreamPool_methods[] = {
	PHP_ME(TPlAnsiStringStreamPool, AcquireStream, arginfo_TPlAnsiStringStreamPool_AcquireStream, ZEND_ACC_PUBLIC)
	PHP_ME(TPlAnsiStringStreamPool, ReleaseStream, arginfo_TPlAnsiStringStreamPool_ReleaseStream, ZEND_ACC_PUBLIC)
	PHP_ME(TPlAnsiStringStreamPool, __construct, arginfo_TPlAnsiStringStreamPool___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlAnsiStringStreamPool(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlAnsiStringStreamPool_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlAnsiStringStreamPool", TPlAnsiStringStreamPool_methods);
	if (NULL == TPlCustomStringStreamPool_ce_ptr)
		Register_TPlCustomStringStreamPool(TSRMLS_C);
	TPlAnsiStringStreamPool_ce_ptr = zend_register_internal_class_ex(&ce, TPlCustomStringStreamPool_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlWideStringStreamPool_ce_ptr = NULL;

SB_PHP_METHOD(TPlWideStringStreamPool, AcquireStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlWideStringStreamPool_AcquireStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TPlWideStringStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlWideStringStreamPool, ReleaseStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TPlWideStringStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TPlWideStringStreamPool_ReleaseStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPlWideStringStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlWideStringStreamPool, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlWideStringStreamPool_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlWideStringStreamPool_AcquireStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlWideStringStreamPool_ReleaseStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TPlWideStringStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlWideStringStreamPool___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlWideStringStreamPool_methods[] = {
	PHP_ME(TPlWideStringStreamPool, AcquireStream, arginfo_TPlWideStringStreamPool_AcquireStream, ZEND_ACC_PUBLIC)
	PHP_ME(TPlWideStringStreamPool, ReleaseStream, arginfo_TPlWideStringStreamPool_ReleaseStream, ZEND_ACC_PUBLIC)
	PHP_ME(TPlWideStringStreamPool, __construct, arginfo_TPlWideStringStreamPool___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlWideStringStreamPool(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlWideStringStreamPool_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlWideStringStreamPool", TPlWideStringStreamPool_methods);
	if (NULL == TPlCustomStringStreamPool_ce_ptr)
		Register_TPlCustomStringStreamPool(TSRMLS_C);
	TPlWideStringStreamPool_ce_ptr = zend_register_internal_class_ex(&ce, TPlCustomStringStreamPool_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBChSConv, EnumCharsets)
{
	SBArrayZValInfo piUserData;
	zval *zEnumProc;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zEnumProc, &zpUserData) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zEnumProc))) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBChSConv_EnumCharsets(NULL, piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConv, CreateCharset)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBChSConv_CreateCharset(sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, IPlCharset_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConv, CreateCharsetByDescription)
{
	char *sADescription;
	int sADescription_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sADescription, &sADescription_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBChSConv_CreateCharsetByDescription(sADescription, (int32_t)sADescription_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, IPlCharset_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConv, CreateSystemDefaultCharset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBChSConv_CreateSystemDefaultCharset(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, IPlCharset_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConv, GetSystemDefaultCharsetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSConv_GetSystemDefaultCharsetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1743342996, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConv, GetCharsetNameByAlias)
{
	char *sAlias;
	int sAlias_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAlias, &sAlias_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSConv_GetCharsetNameByAlias(sAlias, (int32_t)sAlias_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1138165464, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConv, InitializeCharsetObjects)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBChSConv_InitializeCharsetObjects() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBChSConv_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TPlConvertOption", NULL);
	TPlConvertOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TPlConvertOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOption_ce_ptr, "coContinuePrevious", 0)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOption_ce_ptr, "coNoDefaultChar", 1)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOption_ce_ptr, "coInvalidCharException", 2)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOption_ce_ptr, "coWriteFileHeader", 3)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOption_ce_ptr, "coWriteLineBegin", 4)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOption_ce_ptr, "coWriteLineEnd", 5)
	
	INIT_CLASS_ENTRY(ce, "TPlConvertOptions", NULL);
	TPlConvertOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TPlConvertOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOptions_ce_ptr, "coContinuePrevious", 1)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOptions_ce_ptr, "coNoDefaultChar", 2)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOptions_ce_ptr, "coInvalidCharException", 4)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOptions_ce_ptr, "coWriteFileHeader", 8)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOptions_ce_ptr, "coWriteLineBegin", 16)
	SB_DECLARE_CLASS_LONG_CONST(TPlConvertOptions_ce_ptr, "coWriteLineEnd", 32)
	
	INIT_CLASS_ENTRY(ce, "TPlConverterLineState", NULL);
	TPlConverterLineState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TPlConverterLineState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TPlConverterLineState_ce_ptr, "lsStarted", 0)
	SB_DECLARE_CLASS_LONG_CONST(TPlConverterLineState_ce_ptr, "lsFinished", 1)
	
	INIT_CLASS_ENTRY(ce, "TPlConverterLineStates", NULL);
	TPlConverterLineStates_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TPlConverterLineStates_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TPlConverterLineStates_ce_ptr, "lsStarted", 1)
	SB_DECLARE_CLASS_LONG_CONST(TPlConverterLineStates_ce_ptr, "lsFinished", 2)
	
	INIT_CLASS_ENTRY(ce, "TPlUTF7State", NULL);
	TPlUTF7State_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TPlUTF7State_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TPlUTF7State_ce_ptr, "usDirect", 0)
	SB_DECLARE_CLASS_LONG_CONST(TPlUTF7State_ce_ptr, "usBase64", 1)
	SB_DECLARE_CLASS_LONG_CONST(TPlUTF7State_ce_ptr, "usShift", 2)
}

