#include "sbcmdsslclient.h"

zend_class_entry *TElCommandSSLClient_ce_ptr = NULL;

SB_PHP_METHOD(TElCommandSSLClient, SendCmd)
{
	char *sCommand;
	int sCommand_len;
	SBArrayZValInfo aiAcceptCodes;
	zval *zaAcceptCodes;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sCommand, &sCommand_len, &zaAcceptCodes) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaAcceptCodes)) || (IS_NULL == Z_TYPE_P(zaAcceptCodes))))
	{
		int16_t l2OutResultRaw = 0;
		if (!SBGetInt16ArrayFromZVal(zaAcceptCodes, &aiAcceptCodes TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCommandSSLClient_SendCmd(SBGetObjectHandle(getThis() TSRMLS_CC), sCommand, (int32_t)sCommand_len, aiAcceptCodes.data, aiAcceptCodes.len, &l2OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAcceptCodes);
		RETURN_LONG((long)l2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of int16|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCommandSSLClient, get_LastReply)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCommandSSLClient_get_LastReply(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-62805901, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCommandSSLClient, get_OnSent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTextDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCommandSSLClient_get_OnSent(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCommandSSLClient, set_OnSent)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCommandSSLClient_set_OnSent(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTextDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTextDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCommandSSLClient, get_OnReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTextDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCommandSSLClient_get_OnReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCommandSSLClient, set_OnReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCommandSSLClient_set_OnReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTextDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTextDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCommandSSLClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCommandSSLClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCommandSSLClient_SendCmd, 0, 0, 2)
	ZEND_ARG_INFO(0, Command)
	ZEND_ARG_ARRAY_INFO(0, AcceptCodes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCommandSSLClient_get_LastReply, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCommandSSLClient_get_OnSent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCommandSSLClient_set_OnSent, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCommandSSLClient_get_OnReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCommandSSLClient_set_OnReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCommandSSLClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCommandSSLClient_methods[] = {
	PHP_ME(TElCommandSSLClient, SendCmd, arginfo_TElCommandSSLClient_SendCmd, ZEND_ACC_PUBLIC)
	PHP_ME(TElCommandSSLClient, get_LastReply, arginfo_TElCommandSSLClient_get_LastReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElCommandSSLClient, get_OnSent, arginfo_TElCommandSSLClient_get_OnSent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCommandSSLClient, set_OnSent, arginfo_TElCommandSSLClient_set_OnSent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCommandSSLClient, get_OnReceived, arginfo_TElCommandSSLClient_get_OnReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElCommandSSLClient, set_OnReceived, arginfo_TElCommandSSLClient_set_OnReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElCommandSSLClient, __construct, arginfo_TElCommandSSLClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCommandSSLClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCommandSSLClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCommandSSLClient", TElCommandSSLClient_methods);
	if (NULL == TElSimpleSSLClient_ce_ptr)
		Register_TElSimpleSSLClient(TSRMLS_C);
	TElCommandSSLClient_ce_ptr = zend_register_internal_class_ex(&ce, TElSimpleSSLClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBCmdSSLClient_Aliases(TSRMLS_D)
{
	if (NULL == TElCommandSSLClient_ce_ptr)
		Register_TElCommandSSLClient(TSRMLS_C);
	zend_register_class_alias("ElCommandSSLClient", TElCommandSSLClient_ce_ptr);
}

