#include "sbcryptoprovbuiltin.h"

zend_class_entry *TElBuiltInCryptoProviderOptions_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, Assign)
{
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProviderOptions_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOptions TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderOptions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, get_UsePlatformKeyGeneration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProviderOptions_get_UsePlatformKeyGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, set_UsePlatformKeyGeneration)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProviderOptions_set_UsePlatformKeyGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, get_RollbackToBuiltInKeyGeneration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProviderOptions_get_RollbackToBuiltInKeyGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, set_RollbackToBuiltInKeyGeneration)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProviderOptions_set_RollbackToBuiltInKeyGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, get_UseTimingAttackProtection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProviderOptions_get_UseTimingAttackProtection(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, set_UseTimingAttackProtection)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProviderOptions_set_UseTimingAttackProtection(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, get_AutoVerifyCreatedSignatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProviderOptions_get_AutoVerifyCreatedSignatures(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, set_AutoVerifyCreatedSignatures)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProviderOptions_set_AutoVerifyCreatedSignatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, get_AlignEncryptedDataToKeyLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProviderOptions_get_AlignEncryptedDataToKeyLength(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, set_AlignEncryptedDataToKeyLength)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProviderOptions_set_AlignEncryptedDataToKeyLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderOptions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProviderOptions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Options, TElCustomCryptoProviderOptions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_get_UsePlatformKeyGeneration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_set_UsePlatformKeyGeneration, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_get_RollbackToBuiltInKeyGeneration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_set_RollbackToBuiltInKeyGeneration, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_get_UseTimingAttackProtection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_set_UseTimingAttackProtection, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_get_AutoVerifyCreatedSignatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_set_AutoVerifyCreatedSignatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_get_AlignEncryptedDataToKeyLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions_set_AlignEncryptedDataToKeyLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderOptions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInCryptoProviderOptions_methods[] = {
	PHP_ME(TElBuiltInCryptoProviderOptions, Assign, arginfo_TElBuiltInCryptoProviderOptions_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, get_UsePlatformKeyGeneration, arginfo_TElBuiltInCryptoProviderOptions_get_UsePlatformKeyGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, set_UsePlatformKeyGeneration, arginfo_TElBuiltInCryptoProviderOptions_set_UsePlatformKeyGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, get_RollbackToBuiltInKeyGeneration, arginfo_TElBuiltInCryptoProviderOptions_get_RollbackToBuiltInKeyGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, set_RollbackToBuiltInKeyGeneration, arginfo_TElBuiltInCryptoProviderOptions_set_RollbackToBuiltInKeyGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, get_UseTimingAttackProtection, arginfo_TElBuiltInCryptoProviderOptions_get_UseTimingAttackProtection, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, set_UseTimingAttackProtection, arginfo_TElBuiltInCryptoProviderOptions_set_UseTimingAttackProtection, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, get_AutoVerifyCreatedSignatures, arginfo_TElBuiltInCryptoProviderOptions_get_AutoVerifyCreatedSignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, set_AutoVerifyCreatedSignatures, arginfo_TElBuiltInCryptoProviderOptions_set_AutoVerifyCreatedSignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, get_AlignEncryptedDataToKeyLength, arginfo_TElBuiltInCryptoProviderOptions_get_AlignEncryptedDataToKeyLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, set_AlignEncryptedDataToKeyLength, arginfo_TElBuiltInCryptoProviderOptions_set_AlignEncryptedDataToKeyLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderOptions, __construct, arginfo_TElBuiltInCryptoProviderOptions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInCryptoProviderOptions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInCryptoProviderOptions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInCryptoProviderOptions", TElBuiltInCryptoProviderOptions_methods);
	if (NULL == TElCustomCryptoProviderOptions_ce_ptr)
		Register_TElCustomCryptoProviderOptions(TSRMLS_C);
	TElBuiltInCryptoProviderOptions_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCryptoProviderOptions_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInCryptoKey_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInCryptoKey, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoKey_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoKey, ChangeAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoKey_ChangeAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoKey, PrepareForEncryption)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoKey_PrepareForEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoKey, PrepareForSigning)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoKey_PrepareForSigning(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoKey, CancelPreparation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoKey_CancelPreparation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoKey, AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoKey_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoKey, Equals)
{
	zend_bool bPublicOnly;
	zval *oParams;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bO!", &oSource, TElCustomCryptoKey_ce_ptr, &bPublicOnly, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoKey_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey, bool, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoKey, Persistentiate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoKey_Persistentiate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoKey, __construct)
{
	zval *oCryptoProvider;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoKey_Create(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoKey_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoKey_ChangeAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoKey_PrepareForEncryption, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoKey_PrepareForSigning, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoKey_CancelPreparation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoKey_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoKey_Equals, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomCryptoKey, 1)
	ZEND_ARG_INFO(0, PublicOnly)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoKey_Persistentiate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoKey___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInCryptoKey_methods[] = {
	PHP_ME(TElBuiltInCryptoKey, Reset, arginfo_TElBuiltInCryptoKey_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoKey, ChangeAlgorithm, arginfo_TElBuiltInCryptoKey_ChangeAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoKey, PrepareForEncryption, arginfo_TElBuiltInCryptoKey_PrepareForEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoKey, PrepareForSigning, arginfo_TElBuiltInCryptoKey_PrepareForSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoKey, CancelPreparation, arginfo_TElBuiltInCryptoKey_CancelPreparation, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoKey, AsyncOperationFinished, arginfo_TElBuiltInCryptoKey_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoKey, Equals, arginfo_TElBuiltInCryptoKey_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoKey, Persistentiate, arginfo_TElBuiltInCryptoKey_Persistentiate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoKey, __construct, arginfo_TElBuiltInCryptoKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInCryptoKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInCryptoKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInCryptoKey", TElBuiltInCryptoKey_methods);
	if (NULL == TElCustomCryptoKey_ce_ptr)
		Register_TElCustomCryptoKey(TSRMLS_C);
	TElBuiltInCryptoKey_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCryptoKey_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInCryptoProvider_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInCryptoProvider, Init)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProvider_Init(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, Deinit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProvider_Deinit(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, SetAsDefault_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProvider_SetAsDefault_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, SetAsDefault)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProvider_SetAsDefault() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, IsAlgorithmSupported)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4Mode) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProvider_IsAlgorithmSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaAlgOID, &zaAlgParams, &l4Mode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_IsAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, IsOperationSupported)
{
	long l4Algorithm;
	long l4Mode;
	long l4Operation;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllO!O!", &l4Operation, &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProvider_IsOperationSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlO!O!", &l4Operation, &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_IsOperationSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName) or (integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, GetAlgorithmProperty)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llz", &l4Algorithm, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElBuiltInCryptoProvider_GetAlgorithmProperty(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1528028610, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlz", &zaAlgOID, &zaAlgParams, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElBuiltInCryptoProvider_GetAlgorithmProperty_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(836240899, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, GetAlgorithmClass)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProvider_GetAlgorithmClass(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaAlgOID, &zaAlgParams) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_GetAlgorithmClass_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, GetDefaultInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProvider_GetDefaultInstance(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, CreateKey)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4Algorithm, &l4Mode, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProvider_CreateKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zaAlgOID, &zaAlgParams, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_CreateKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElRelativeDistinguishedName) or (array of byte|string|NULL, array of byte|string|NULL, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, CloneKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProvider_CloneKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, ReleaseKey)
{
	TElClassHandle hoKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKey) && (IS_OBJECT == Z_TYPE_P(oKey)))
	{
		hoKey = SBGetObjectHandle(oKey TSRMLS_CC);
		SBCheckError(TElBuiltInCryptoProvider_ReleaseKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKey) TSRMLS_CC);
		SBUpdateObjectHandle(oKey, hoKey TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, DeleteKey)
{
	TElClassHandle hoKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKey) && (IS_OBJECT == Z_TYPE_P(oKey)))
	{
		hoKey = SBGetObjectHandle(oKey TSRMLS_CC);
		SBCheckError(TElBuiltInCryptoProvider_DeleteKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKey) TSRMLS_CC);
		SBUpdateObjectHandle(oKey, hoKey TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, DecryptKey)
{
	long l4EncKeySize;
	SBArrayZValInfo aiEncKeyAlgOID;
	SBArrayZValInfo aiEncKeyAlgParams;
	SBArrayZValInfo aiKeyAlgOID;
	SBArrayZValInfo aiKeyAlgParams;
	SBArrayZValInfo piEncKey;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaEncKeyAlgOID;
	zval *zaEncKeyAlgParams;
	zval *zaKeyAlgOID;
	zval *zaKeyAlgParams;
	zval *zpEncKey;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzO!zzO!zz", &zpEncKey, &l4EncKeySize, &zaEncKeyAlgOID, &zaEncKeyAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zaKeyAlgOID, &zaKeyAlgParams, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpEncKey) == IS_STRING) || (Z_TYPE_P(zpEncKey) == IS_ARRAY) || (Z_TYPE_P(zpEncKey) == IS_NULL) || ((Z_TYPE_P(zpEncKey) == IS_OBJECT) && (Z_OBJCE_P(zpEncKey) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgParams))) && ((IS_STRING == Z_TYPE_P(zaKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaKeyAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpEncKey, &piEncKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgOID, &aiEncKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgParams, &aiEncKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyAlgOID, &aiKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyAlgParams, &aiKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_DecryptKey(SBGetObjectHandle(getThis() TSRMLS_CC), piEncKey.data, (int32_t)l4EncKeySize, aiEncKeyAlgOID.data, aiEncKeyAlgOID.len, aiEncKeyAlgParams.data, aiEncKeyAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), aiKeyAlgOID.data, aiKeyAlgOID.len, aiKeyAlgParams.data, aiKeyAlgParams.len, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piEncKey);
		SBFreeArrayZValInfo(&aiEncKeyAlgOID);
		SBFreeArrayZValInfo(&aiEncKeyAlgParams);
		SBFreeArrayZValInfo(&aiKeyAlgOID);
		SBFreeArrayZValInfo(&aiKeyAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, array of byte|string|NULL, array of byte|string|NULL, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, EncryptInit)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_EncryptInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!O!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_EncryptInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, DecryptInit)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_DecryptInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!O!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_DecryptInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, SignInit)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zend_bool bDetached;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_SignInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!bO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_SignInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, bool, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, bool, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, VerifyInit)
{
	long l4Algorithm;
	long l4SigSize;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	SBArrayZValInfo piSigBuffer;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	zval *zpSigBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zlO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_VerifyInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!zlO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_VerifyInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, EncryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_EncryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, DecryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_DecryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, SignUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_SignUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, VerifyUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_VerifyUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, EncryptFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_EncryptFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, DecryptFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_DecryptFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, SignFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_SignFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, VerifyFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_VerifyFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, HashInit)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_HashInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!O!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_HashInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, HashUpdate)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_HashUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, HashFinal)
{
	SBArrayZValInfo piProgressData;
	uint32_t _err;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zz", &oContext, TElCustomCryptoContext_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		_err = TElBuiltInCryptoProvider_HashFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1385673189, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piProgressData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, ReleaseCryptoContext)
{
	TElClassHandle hoContext;
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TElCustomCryptoContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext) && (IS_OBJECT == Z_TYPE_P(oContext)))
	{
		hoContext = SBGetObjectHandle(oContext TSRMLS_CC);
		SBCheckError(TElBuiltInCryptoProvider_ReleaseCryptoContext(SBGetObjectHandle(getThis() TSRMLS_CC), &hoContext) TSRMLS_CC);
		SBUpdateObjectHandle(oContext, hoContext TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, CreateKeyStorage)
{
	zend_bool bPersistent;
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bPersistent, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProvider_CreateKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bPersistent, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, ReleaseKeyStorage)
{
	TElClassHandle hoKeyStorage;
	zval *oKeyStorage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKeyStorage, TElCustomCryptoKeyStorage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKeyStorage) && (IS_OBJECT == Z_TYPE_P(oKeyStorage)))
	{
		hoKeyStorage = SBGetObjectHandle(oKeyStorage TSRMLS_CC);
		SBCheckError(TElBuiltInCryptoProvider_ReleaseKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyStorage) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyStorage, hoKeyStorage TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, DeleteKeyStorage)
{
	TElClassHandle hoKeyStorage;
	zval *oKeyStorage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKeyStorage, TElCustomCryptoKeyStorage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKeyStorage) && (IS_OBJECT == Z_TYPE_P(oKeyStorage)))
	{
		hoKeyStorage = SBGetObjectHandle(oKeyStorage TSRMLS_CC);
		SBCheckError(TElBuiltInCryptoProvider_DeleteKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyStorage) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyStorage, hoKeyStorage TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, RandomInit)
{
	long l4BaseDataSize;
	SBArrayZValInfo piBaseData;
	zval *oParams;
	zval *zpBaseData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBaseData, &l4BaseDataSize, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBaseData) == IS_STRING) || (Z_TYPE_P(zpBaseData) == IS_ARRAY) || (Z_TYPE_P(zpBaseData) == IS_NULL) || ((Z_TYPE_P(zpBaseData) == IS_OBJECT) && (Z_OBJCE_P(zpBaseData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBaseData, &piBaseData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_RandomInit(SBGetObjectHandle(getThis() TSRMLS_CC), piBaseData.data, (int32_t)l4BaseDataSize, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBaseData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, RandomSeed)
{
	long l4DataSize;
	SBArrayZValInfo piData;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpData, &l4DataSize) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_RandomSeed(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4DataSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, RandomGenerate)
{
	long l4MaxValue;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInCryptoProvider_RandomGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4MaxValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProvider_RandomGenerate_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4MaxValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProvider_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProvider, __construct)
{
	zval *oAOwner;
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProvider_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr, &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProvider_Create_1(SBGetObjectHandle(oOptions TSRMLS_CC), SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent) or (TElCustomCryptoProviderOptions, TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_Init, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_Deinit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_SetAsDefault_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_SetAsDefault, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_IsAlgorithmSupported, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_IsOperationSupported, 0, 0, 5)
	ZEND_ARG_INFO(0, Operation)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_GetAlgorithmProperty, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_GetAlgorithmClass, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgParams, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_GetDefaultInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_CreateKey, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_CloneKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_ReleaseKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Key, TElCustomCryptoKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_DeleteKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Key, TElCustomCryptoKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_DecryptKey, 0, 0, 10)
	ZEND_ARG_TYPE_INFO(0, EncKey, 0, 1)
	ZEND_ARG_INFO(0, EncKeySize)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
	ZEND_ARG_TYPE_INFO(0, KeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeyAlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_EncryptInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_DecryptInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_SignInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Detached_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Detached, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_VerifyInit, 0, 0, 7)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigBuffer_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigSize_or_SigBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_SigSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_EncryptUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_DecryptUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_SignUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_VerifyUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_EncryptFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_DecryptFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_SignFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_VerifyFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_HashInit, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_HashUpdate, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_HashFinal, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_ReleaseCryptoContext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Context, TElCustomCryptoContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_CreateKeyStorage, 0, 0, 2)
	ZEND_ARG_INFO(0, Persistent)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_ReleaseKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, KeyStorage, TElCustomCryptoKeyStorage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_DeleteKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, KeyStorage, TElCustomCryptoKeyStorage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_RandomInit, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, BaseData, 0, 1)
	ZEND_ARG_INFO(0, BaseDataSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_RandomSeed, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, DataSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_RandomGenerate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_MaxValue, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProvider___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AOwner_or_Options, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInCryptoProvider_methods[] = {
	PHP_ME(TElBuiltInCryptoProvider, Init, arginfo_TElBuiltInCryptoProvider_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, Deinit, arginfo_TElBuiltInCryptoProvider_Deinit, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, SetAsDefault_Inst, arginfo_TElBuiltInCryptoProvider_SetAsDefault_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, SetAsDefault, arginfo_TElBuiltInCryptoProvider_SetAsDefault, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInCryptoProvider, IsAlgorithmSupported, arginfo_TElBuiltInCryptoProvider_IsAlgorithmSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, IsOperationSupported, arginfo_TElBuiltInCryptoProvider_IsOperationSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, GetAlgorithmProperty, arginfo_TElBuiltInCryptoProvider_GetAlgorithmProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, GetAlgorithmClass, arginfo_TElBuiltInCryptoProvider_GetAlgorithmClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, GetDefaultInstance, arginfo_TElBuiltInCryptoProvider_GetDefaultInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, CreateKey, arginfo_TElBuiltInCryptoProvider_CreateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, CloneKey, arginfo_TElBuiltInCryptoProvider_CloneKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, ReleaseKey, arginfo_TElBuiltInCryptoProvider_ReleaseKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, DeleteKey, arginfo_TElBuiltInCryptoProvider_DeleteKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, DecryptKey, arginfo_TElBuiltInCryptoProvider_DecryptKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, EncryptInit, arginfo_TElBuiltInCryptoProvider_EncryptInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, DecryptInit, arginfo_TElBuiltInCryptoProvider_DecryptInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, SignInit, arginfo_TElBuiltInCryptoProvider_SignInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, VerifyInit, arginfo_TElBuiltInCryptoProvider_VerifyInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, EncryptUpdate, arginfo_TElBuiltInCryptoProvider_EncryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, DecryptUpdate, arginfo_TElBuiltInCryptoProvider_DecryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, SignUpdate, arginfo_TElBuiltInCryptoProvider_SignUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, VerifyUpdate, arginfo_TElBuiltInCryptoProvider_VerifyUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, EncryptFinal, arginfo_TElBuiltInCryptoProvider_EncryptFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, DecryptFinal, arginfo_TElBuiltInCryptoProvider_DecryptFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, SignFinal, arginfo_TElBuiltInCryptoProvider_SignFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, VerifyFinal, arginfo_TElBuiltInCryptoProvider_VerifyFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, HashInit, arginfo_TElBuiltInCryptoProvider_HashInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, HashUpdate, arginfo_TElBuiltInCryptoProvider_HashUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, HashFinal, arginfo_TElBuiltInCryptoProvider_HashFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, ReleaseCryptoContext, arginfo_TElBuiltInCryptoProvider_ReleaseCryptoContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, CreateKeyStorage, arginfo_TElBuiltInCryptoProvider_CreateKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, ReleaseKeyStorage, arginfo_TElBuiltInCryptoProvider_ReleaseKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, DeleteKeyStorage, arginfo_TElBuiltInCryptoProvider_DeleteKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, RandomInit, arginfo_TElBuiltInCryptoProvider_RandomInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, RandomSeed, arginfo_TElBuiltInCryptoProvider_RandomSeed, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, RandomGenerate, arginfo_TElBuiltInCryptoProvider_RandomGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProvider, ClassType, arginfo_TElBuiltInCryptoProvider_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInCryptoProvider, __construct, arginfo_TElBuiltInCryptoProvider___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInCryptoProvider(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInCryptoProvider_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInCryptoProvider", TElBuiltInCryptoProvider_methods);
	if (NULL == TElBlackboxCryptoProvider_ce_ptr)
		Register_TElBlackboxCryptoProvider(TSRMLS_C);
	TElBuiltInCryptoProvider_ce_ptr = zend_register_internal_class_ex(&ce, TElBlackboxCryptoProvider_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCryptoProvBuiltIn, BuiltInCryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBCryptoProvBuiltIn_BuiltInCryptoProvider(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

