#include "sbdictionary.h"

void SB_CALLBACK TSBDictionaryDeleteValueEventRaw(void * _ObjectData, TObjectHandle Sender, TObjectHandle Value)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zValue;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zValue);
	SBInitObject(zValue, TObject_ce_ptr, Value TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zValue;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zValue);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElDictionaryEntry_ce_ptr = NULL;

SB_PHP_METHOD(TElDictionaryEntry, get_HashCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElDictionaryEntry_get_HashCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, set_HashCode)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElDictionaryEntry_set_HashCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, get_Next)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDictionaryEntry_get_Next(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, set_Next)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElDictionaryEntry_set_Next(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDictionaryEntry_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, set_Value)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDictionaryEntry_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, get_StrKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDictionaryEntry_get_StrKey(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1821037055, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, set_StrKey)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDictionaryEntry_set_StrKey(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, get_ByteKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDictionaryEntry_get_ByteKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(947065758, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, set_ByteKey)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDictionaryEntry_set_ByteKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionaryEntry, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDictionaryEntry_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_get_HashCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_set_HashCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_get_Next, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_set_Next, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_set_Value, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_get_StrKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_set_StrKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_get_ByteKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry_set_ByteKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionaryEntry___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDictionaryEntry_methods[] = {
	PHP_ME(TElDictionaryEntry, get_HashCode, arginfo_TElDictionaryEntry_get_HashCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, set_HashCode, arginfo_TElDictionaryEntry_set_HashCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, get_Next, arginfo_TElDictionaryEntry_get_Next, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, set_Next, arginfo_TElDictionaryEntry_set_Next, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, get_Value, arginfo_TElDictionaryEntry_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, set_Value, arginfo_TElDictionaryEntry_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, get_StrKey, arginfo_TElDictionaryEntry_get_StrKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, set_StrKey, arginfo_TElDictionaryEntry_set_StrKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, get_ByteKey, arginfo_TElDictionaryEntry_get_ByteKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, set_ByteKey, arginfo_TElDictionaryEntry_set_ByteKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionaryEntry, __construct, arginfo_TElDictionaryEntry___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDictionaryEntry(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDictionaryEntry_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDictionaryEntry", TElDictionaryEntry_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDictionaryEntry_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDictionary_ce_ptr = NULL;

SB_PHP_METHOD(TElDictionary, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDictionary_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, Add)
{
	char *sKey;
	int sKey_len;
	SBArrayZValInfo aiKey;
	zval *oValue;
	zval *zaKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sKey, &sKey_len, &oValue, TObject_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDictionary_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oValue TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaKey, &oValue, TObject_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDictionary_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiKey.data, aiKey.len, SBGetObjectHandle(oValue TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TObject) or (array of byte|string|NULL, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, ContainsKey)
{
	char *sKey;
	int sKey_len;
	SBArrayZValInfo aiKey;
	zval *zaKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDictionary_ContainsKey(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDictionary_ContainsKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiKey.data, aiKey.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, ContainsValue)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TObject_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDictionary_ContainsValue(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, Remove)
{
	char *sKey;
	int sKey_len;
	SBArrayZValInfo aiKey;
	zval *oValue;
	zval *zaKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDictionary_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDictionary_Remove_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiKey.data, aiKey.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TObject_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDictionary_Remove_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (array of byte|string|NULL) or (TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, TryGetValue)
{
	char *sKey;
	int sKey_len;
	SBArrayZValInfo aiKey;
	TElClassHandle hoValue;
	zval *oValue;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO", &sKey, &sKey_len, &oValue, TObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oValue) && (IS_OBJECT == Z_TYPE_P(oValue)))
	{
		int8_t bOutResultRaw = 0;
		hoValue = SBGetObjectHandle(oValue TSRMLS_CC);
		SBCheckError(TElDictionary_TryGetValue(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, &hoValue, &bOutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oValue, hoValue TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaKey, &oValue, TObject_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && PZVAL_IS_REF(oValue) && (IS_OBJECT == Z_TYPE_P(oValue)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		hoValue = SBGetObjectHandle(oValue TSRMLS_CC);
		SBCheckError(TElDictionary_TryGetValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiKey.data, aiKey.len, &hoValue, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBUpdateObjectHandle(oValue, hoValue TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &TObject) or (array of byte|string|NULL, &TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, GetItem)
{
	char *sKey;
	int sKey_len;
	SBArrayZValInfo aiKey;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDictionary_GetItem(SBGetObjectHandle(getThis() TSRMLS_CC), aiKey.data, aiKey.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDictionary_GetItem_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, SetItem)
{
	char *sKey;
	int sKey_len;
	SBArrayZValInfo aiKey;
	zval *oValue;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaKey, &oValue, TObject_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDictionary_SetItem(SBGetObjectHandle(getThis() TSRMLS_CC), aiKey.data, aiKey.len, SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sKey, &sKey_len, &oValue, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDictionary_SetItem_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TObject) or (string, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDictionary_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, get_FreeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDictionary_get_FreeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, get_Values)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDictionary_get_Values(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, get_StringKeys)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDictionary_get_StringKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-186017449, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, get_ByteKeys)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDictionary_get_ByteKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-395937803, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, get_OnDeleteValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDictionaryDeleteValueEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDictionary_get_OnDeleteValue(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, set_OnDeleteValue)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDictionary_set_OnDeleteValue(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDictionaryDeleteValueEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDictionaryDeleteValueEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDictionary, __construct)
{
	long l4Capacity;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDictionary_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Capacity) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDictionary_Create_1((int32_t)l4Capacity, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_Add, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_ContainsKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_ContainsValue, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_Remove, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_TryGetValue, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Value, TObject, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_GetItem, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_SetItem, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_get_FreeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_get_Values, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_get_StringKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_get_ByteKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_get_OnDeleteValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary_set_OnDeleteValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDictionary___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, Capacity)
ZEND_END_ARG_INFO()

static zend_function_entry TElDictionary_methods[] = {
	PHP_ME(TElDictionary, Clear, arginfo_TElDictionary_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, Add, arginfo_TElDictionary_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, ContainsKey, arginfo_TElDictionary_ContainsKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, ContainsValue, arginfo_TElDictionary_ContainsValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, Remove, arginfo_TElDictionary_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, TryGetValue, arginfo_TElDictionary_TryGetValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, GetItem, arginfo_TElDictionary_GetItem, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, SetItem, arginfo_TElDictionary_SetItem, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, get_Count, arginfo_TElDictionary_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, get_FreeCount, arginfo_TElDictionary_get_FreeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, get_Values, arginfo_TElDictionary_get_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, get_StringKeys, arginfo_TElDictionary_get_StringKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, get_ByteKeys, arginfo_TElDictionary_get_ByteKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, get_OnDeleteValue, arginfo_TElDictionary_get_OnDeleteValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, set_OnDeleteValue, arginfo_TElDictionary_set_OnDeleteValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElDictionary, __construct, arginfo_TElDictionary___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDictionary(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDictionary_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDictionary", TElDictionary_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDictionary_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

