#include "sbdnssec.h"

void SB_CALLBACK TSBDNSClientSendingEventRaw(void * _ObjectData, TObjectHandle Sender, TElDNSMessageHandle Request)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zRequest;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRequest);
	SBInitObject(zRequest, TElDNSMessage_ce_ptr, Request TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zRequest;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRequest);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBDNSClientTimeoutEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t * Wait)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zWait;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zWait);
	ZVAL_BOOL(zWait, (zend_bool)*Wait);

	params[0] = &zSender;
	params[1] = &zWait;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Wait = (int8_t)Z_BVAL_P(zWait);
	zval_ptr_dtor(&zWait);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBDNSResolverPrepareEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcServerName, int32_t szServerName, const char * pcServerAddress, int32_t szServerAddress, uint16_t ServerPort, const char * pcCriteria, int32_t szCriteria, TSBDNSResourceTypeRaw InfoType)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zServerName;
	zval * zServerAddress;
	zval * zServerPort;
	zval * zCriteria;
	zval * zInfoType;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zServerName);
	ZVAL_STRINGL(zServerName, pcServerName, szServerName, 1);
	MAKE_STD_ZVAL(zServerAddress);
	ZVAL_STRINGL(zServerAddress, pcServerAddress, szServerAddress, 1);
	MAKE_STD_ZVAL(zServerPort);
	ZVAL_LONG(zServerPort, (long)ServerPort);
	MAKE_STD_ZVAL(zCriteria);
	ZVAL_STRINGL(zCriteria, pcCriteria, szCriteria, 1);
	MAKE_STD_ZVAL(zInfoType);
	ZVAL_LONG(zInfoType, (long)InfoType);

	params[0] = &zSender;
	params[1] = &zServerName;
	params[2] = &zServerAddress;
	params[3] = &zServerPort;
	params[4] = &zCriteria;
	params[5] = &zInfoType;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zServerName);
	zval_ptr_dtor(&zServerAddress);
	zval_ptr_dtor(&zServerPort);
	zval_ptr_dtor(&zCriteria);
	zval_ptr_dtor(&zInfoType);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBDNSResolverRequestEventRaw(void * _ObjectData, TObjectHandle Sender, TElDNSMessageHandle Request)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zRequest;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRequest);
	SBInitObject(zRequest, TElDNSMessage_ce_ptr, Request TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zRequest;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRequest);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBDNSResolverResponseEventRaw(void * _ObjectData, TObjectHandle Sender, TElDNSMessageHandle Response)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zResponse;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zResponse);
	SBInitObject(zResponse, TElDNSMessage_ce_ptr, Response TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zResponse;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zResponse);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBDNSResolverErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ErrorCode, const char * pcErrorMessage, int32_t szErrorMessage)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zErrorCode;
	zval * zErrorMessage;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)ErrorCode);
	MAKE_STD_ZVAL(zErrorMessage);
	ZVAL_STRINGL(zErrorMessage, pcErrorMessage, szErrorMessage, 1);

	params[0] = &zSender;
	params[1] = &zErrorCode;
	params[2] = &zErrorMessage;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zErrorCode);
	zval_ptr_dtor(&zErrorMessage);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElDNSQuestion_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSQuestion, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSQuestion_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestion, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSQuestion_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestion, Write)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSQuestion_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestion, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSQuestion_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-838839251, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestion, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSQuestion_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestion, get_ResourceCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSQuestion_get_ResourceCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestion, set_ResourceCode)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSQuestion_set_ResourceCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestion, get_ResourceType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResourceTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDNSQuestion_get_ResourceType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestion, set_ResourceType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDNSQuestion_set_ResourceType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestion, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSQuestion_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion_Write, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion_get_ResourceCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion_set_ResourceCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion_get_ResourceType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion_set_ResourceType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestion___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSQuestion_methods[] = {
	PHP_ME(TElDNSQuestion, Assign, arginfo_TElDNSQuestion_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestion, Read, arginfo_TElDNSQuestion_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestion, Write, arginfo_TElDNSQuestion_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestion, get_Name, arginfo_TElDNSQuestion_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestion, set_Name, arginfo_TElDNSQuestion_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestion, get_ResourceCode, arginfo_TElDNSQuestion_get_ResourceCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestion, set_ResourceCode, arginfo_TElDNSQuestion_set_ResourceCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestion, get_ResourceType, arginfo_TElDNSQuestion_get_ResourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestion, set_ResourceType, arginfo_TElDNSQuestion_set_ResourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestion, __construct, arginfo_TElDNSQuestion___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSQuestion(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSQuestion_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSQuestion", TElDNSQuestion_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElDNSQuestion_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSQuestionList_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSQuestionList, Add)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSQuestionList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSQuestion_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestionList, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSQuestionList_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestionList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDNSQuestionList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestionList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDNSQuestionList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestionList, IndexOf)
{
	zval *oQuestion;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oQuestion, TElDNSQuestion_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSQuestionList_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oQuestion TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSQuestion)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestionList, Insert)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSQuestionList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSQuestion_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestionList, Remove)
{
	zval *oQuestion;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oQuestion, TElDNSQuestion_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSQuestionList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oQuestion TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSQuestion)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestionList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSQuestionList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestionList, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSQuestionList_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSQuestion_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSQuestionList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSQuestionList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList_Add, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList_IndexOf, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Question, TElDNSQuestion, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList_Insert, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList_Remove, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Question, TElDNSQuestion, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSQuestionList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSQuestionList_methods[] = {
	PHP_ME(TElDNSQuestionList, Add, arginfo_TElDNSQuestionList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestionList, Assign, arginfo_TElDNSQuestionList_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestionList, Clear, arginfo_TElDNSQuestionList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestionList, Delete, arginfo_TElDNSQuestionList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestionList, IndexOf, arginfo_TElDNSQuestionList_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestionList, Insert, arginfo_TElDNSQuestionList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestionList, Remove, arginfo_TElDNSQuestionList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestionList, get_Count, arginfo_TElDNSQuestionList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestionList, get_Items, arginfo_TElDNSQuestionList_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSQuestionList, __construct, arginfo_TElDNSQuestionList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSQuestionList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSQuestionList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSQuestionList", TElDNSQuestionList_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElDNSQuestionList_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSCache_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSCache, Add)
{
	long fResourceType;
	zval *oRecords;
	zval *oResourceRecord;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRecords, TElDNSResourceRecordSet_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSCache_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRecords TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fResourceType) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSCache_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fResourceType, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSResourceRecord_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResourceRecord, TElDNSResourceRecord_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSCache_Add_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResourceRecord TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSResourceRecordSet) or (integer) or (TElDNSResourceRecord)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSCache, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSCache_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSCache_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Records_or_ResourceType_or_ResourceRecord, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSCache___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSCache_methods[] = {
	PHP_ME(TElDNSCache, Add, arginfo_TElDNSCache_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSCache, __construct, arginfo_TElDNSCache___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSCache(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSCache_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSCache", TElDNSCache_methods);
	if (NULL == TElDNSResourceRecordSet_ce_ptr)
		Register_TElDNSResourceRecordSet(TSRMLS_C);
	TElDNSCache_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecordSet_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSMessageExtensions_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSMessageExtensions, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMessageExtensions_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDNSMessageExtensions_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSMessageExtensions_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessageExtensions_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, get_DNSSECOK)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSMessageExtensions_get_DNSSECOK(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, set_DNSSECOK)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessageExtensions_set_DNSSECOK(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSMessageExtensions_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, set_Flags)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSMessageExtensions_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, get_PayloadSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSMessageExtensions_get_PayloadSize(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, set_PayloadSize)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSMessageExtensions_set_PayloadSize(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, get_ResponseCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSMessageExtensions_get_ResponseCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, set_ResponseCode)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSMessageExtensions_set_ResponseCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSMessageExtensions_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, set_Version)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSMessageExtensions_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessageExtensions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSMessageExtensions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_get_DNSSECOK, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_set_DNSSECOK, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_get_PayloadSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_set_PayloadSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_get_ResponseCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_set_ResponseCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessageExtensions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSMessageExtensions_methods[] = {
	PHP_ME(TElDNSMessageExtensions, Assign, arginfo_TElDNSMessageExtensions_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, Clear, arginfo_TElDNSMessageExtensions_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, get_Enabled, arginfo_TElDNSMessageExtensions_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, set_Enabled, arginfo_TElDNSMessageExtensions_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, get_DNSSECOK, arginfo_TElDNSMessageExtensions_get_DNSSECOK, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, set_DNSSECOK, arginfo_TElDNSMessageExtensions_set_DNSSECOK, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, get_Flags, arginfo_TElDNSMessageExtensions_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, set_Flags, arginfo_TElDNSMessageExtensions_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, get_PayloadSize, arginfo_TElDNSMessageExtensions_get_PayloadSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, set_PayloadSize, arginfo_TElDNSMessageExtensions_set_PayloadSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, get_ResponseCode, arginfo_TElDNSMessageExtensions_get_ResponseCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, set_ResponseCode, arginfo_TElDNSMessageExtensions_set_ResponseCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, get_Version, arginfo_TElDNSMessageExtensions_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, set_Version, arginfo_TElDNSMessageExtensions_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessageExtensions, __construct, arginfo_TElDNSMessageExtensions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSMessageExtensions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSMessageExtensions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSMessageExtensions", TElDNSMessageExtensions_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElDNSMessageExtensions_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSMessage, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDNSMessage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, Read)
{
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDNSMessage_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, Write)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Authenticated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_Authenticated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Authenticated)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Authenticated(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Authoritative)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_Authoritative(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Authoritative)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Authoritative(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_CheckingDisabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_CheckingDisabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_CheckingDisabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_CheckingDisabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSMessage_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSMessageExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Extensions)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDNSMessageExtensions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSMessageExtensions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_ID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_ID)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_MessageType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSMessageTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_MessageType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_MessageType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_MessageType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSMessageTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_OpCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_OpCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_OpCode)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_OpCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Operation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSOperationCodeRaw fOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_Operation(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Operation)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Operation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSOperationCodeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_RCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_RCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_RCode)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_RCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_RecursionAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_RecursionAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_RecursionAvailable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_RecursionAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_RecursionDesired)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_RecursionDesired(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_RecursionDesired)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_RecursionDesired(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_ResponseCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResponseCodeRaw fOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_ResponseCode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_ResponseCode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_ResponseCode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResponseCodeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Truncated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_Truncated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Truncated)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Truncated(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Z)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSMessage_get_Z(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Z)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Z(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Questions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSMessage_get_Questions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSQuestionList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Questions)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDNSQuestionList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Questions(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSQuestionList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Answers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSMessage_get_Answers(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSResourceRecordSet_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Answers)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDNSResourceRecordSet_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Answers(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSResourceRecordSet)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Authorities)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSMessage_get_Authorities(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSResourceRecordSet_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Authorities)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDNSResourceRecordSet_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Authorities(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSResourceRecordSet)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, get_Additionals)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSMessage_get_Additionals(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSResourceRecordSet_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, set_Additionals)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDNSResourceRecordSet_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMessage_set_Additionals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSResourceRecordSet)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMessage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSMessage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_Read, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_Write, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Authenticated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Authenticated, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Authoritative, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Authoritative, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_CheckingDisabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_CheckingDisabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Extensions, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDNSMessageExtensions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_MessageType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_MessageType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_OpCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_OpCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Operation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Operation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_RCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_RCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_RecursionAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_RecursionAvailable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_RecursionDesired, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_RecursionDesired, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_ResponseCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_ResponseCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Truncated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Truncated, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Z, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Z, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Questions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Questions, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDNSQuestionList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Answers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Answers, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDNSResourceRecordSet, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Authorities, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Authorities, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDNSResourceRecordSet, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_get_Additionals, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage_set_Additionals, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDNSResourceRecordSet, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMessage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSMessage_methods[] = {
	PHP_ME(TElDNSMessage, Assign, arginfo_TElDNSMessage_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, Clear, arginfo_TElDNSMessage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, Read, arginfo_TElDNSMessage_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, Write, arginfo_TElDNSMessage_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Authenticated, arginfo_TElDNSMessage_get_Authenticated, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Authenticated, arginfo_TElDNSMessage_set_Authenticated, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Authoritative, arginfo_TElDNSMessage_get_Authoritative, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Authoritative, arginfo_TElDNSMessage_set_Authoritative, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_CheckingDisabled, arginfo_TElDNSMessage_get_CheckingDisabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_CheckingDisabled, arginfo_TElDNSMessage_set_CheckingDisabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Extensions, arginfo_TElDNSMessage_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Extensions, arginfo_TElDNSMessage_set_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_ID, arginfo_TElDNSMessage_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_ID, arginfo_TElDNSMessage_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_MessageType, arginfo_TElDNSMessage_get_MessageType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_MessageType, arginfo_TElDNSMessage_set_MessageType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_OpCode, arginfo_TElDNSMessage_get_OpCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_OpCode, arginfo_TElDNSMessage_set_OpCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Operation, arginfo_TElDNSMessage_get_Operation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Operation, arginfo_TElDNSMessage_set_Operation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_RCode, arginfo_TElDNSMessage_get_RCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_RCode, arginfo_TElDNSMessage_set_RCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_RecursionAvailable, arginfo_TElDNSMessage_get_RecursionAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_RecursionAvailable, arginfo_TElDNSMessage_set_RecursionAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_RecursionDesired, arginfo_TElDNSMessage_get_RecursionDesired, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_RecursionDesired, arginfo_TElDNSMessage_set_RecursionDesired, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_ResponseCode, arginfo_TElDNSMessage_get_ResponseCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_ResponseCode, arginfo_TElDNSMessage_set_ResponseCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Truncated, arginfo_TElDNSMessage_get_Truncated, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Truncated, arginfo_TElDNSMessage_set_Truncated, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Z, arginfo_TElDNSMessage_get_Z, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Z, arginfo_TElDNSMessage_set_Z, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Questions, arginfo_TElDNSMessage_get_Questions, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Questions, arginfo_TElDNSMessage_set_Questions, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Answers, arginfo_TElDNSMessage_get_Answers, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Answers, arginfo_TElDNSMessage_set_Answers, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Authorities, arginfo_TElDNSMessage_get_Authorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Authorities, arginfo_TElDNSMessage_set_Authorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, get_Additionals, arginfo_TElDNSMessage_get_Additionals, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, set_Additionals, arginfo_TElDNSMessage_set_Additionals, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMessage, __construct, arginfo_TElDNSMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSMessage", TElDNSMessage_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElDNSMessage_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSClient_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSClient, Activate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDNSClient_Activate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, Deactivate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDNSClient_Deactivate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, Lookup)
{
	char *sName;
	int sName_len;
	long fResourceType;
	long u1ResourceCode;
	TElClassHandle hoResponse;
	zval *oResponse;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO", &sName, &sName_len, &fResourceType, &oResponse, TElDNSMessage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oResponse) && (IS_OBJECT == Z_TYPE_P(oResponse)))
	{
		hoResponse = SBGetObjectHandle(oResponse TSRMLS_CC);
		SBCheckError(TElDNSClient_Lookup(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (TSBDNSResourceTypeRaw)fResourceType, &hoResponse) TSRMLS_CC);
		SBUpdateObjectHandle(oResponse, hoResponse TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO", &sName, &sName_len, &u1ResourceCode, &oResponse, TElDNSMessage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oResponse) && (IS_OBJECT == Z_TYPE_P(oResponse)))
	{
		hoResponse = SBGetObjectHandle(oResponse TSRMLS_CC);
		SBCheckError(TElDNSClient_Lookup_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (uint8_t)u1ResourceCode, &hoResponse) TSRMLS_CC);
		SBUpdateObjectHandle(oResponse, hoResponse TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, &TElDNSMessage) or (string, integer, &TElDNSMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSClient_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, get_BoundAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSClient_get_BoundAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-676175483, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, get_BoundPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSClient_get_BoundPort(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElDNSClient, get_UsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSClient_get_UsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElDNSClient, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSClient_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(800633046, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSClient_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, get_Binding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSClient_get_Binding(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSocketBinding_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, set_Binding)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElClientSocketBinding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSClient_set_Binding(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientSocketBinding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSClient_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, set_Port)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSClient_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, get_Timeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSClient_get_Timeout(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, set_Timeout)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSClient_set_Timeout(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElDNSClient, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSClient_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSClient_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElDNSClient, get_UseRecursion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSClient_get_UseRecursion(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, set_UseRecursion)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSClient_set_UseRecursion(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, get_UseSecurity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSClient_get_UseSecurity(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, set_UseSecurity)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSClient_set_UseSecurity(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, get_OnSending)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSClientSendingEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDNSClient_get_OnSending(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, set_OnSending)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDNSClient_set_OnSending(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSClientSendingEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSClientSendingEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, get_OnTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSClientTimeoutEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDNSClient_get_OnTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, set_OnTimeout)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDNSClient_set_OnTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSClientTimeoutEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSClientTimeoutEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_Activate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_Deactivate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_Lookup, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, ResourceType_or_ResourceCode)
	ZEND_ARG_OBJ_INFO(1, Response, TElDNSMessage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_BoundAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_BoundPort, 0, 0, 0)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_UsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_Binding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_set_Binding, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElClientSocketBinding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_Timeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_set_Timeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_UseRecursion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_set_UseRecursion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_UseSecurity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_set_UseSecurity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_OnSending, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_set_OnSending, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_get_OnTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient_set_OnTimeout, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSClient_methods[] = {
	PHP_ME(TElDNSClient, Activate, arginfo_TElDNSClient_Activate, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, Deactivate, arginfo_TElDNSClient_Deactivate, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, Lookup, arginfo_TElDNSClient_Lookup, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, get_Active, arginfo_TElDNSClient_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, get_BoundAddress, arginfo_TElDNSClient_get_BoundAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, get_BoundPort, arginfo_TElDNSClient_get_BoundPort, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElDNSClient, get_UsingIPv6, arginfo_TElDNSClient_get_UsingIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElDNSClient, get_Address, arginfo_TElDNSClient_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, set_Address, arginfo_TElDNSClient_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, get_Binding, arginfo_TElDNSClient_get_Binding, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, set_Binding, arginfo_TElDNSClient_set_Binding, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, get_Port, arginfo_TElDNSClient_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, set_Port, arginfo_TElDNSClient_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, get_Timeout, arginfo_TElDNSClient_get_Timeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, set_Timeout, arginfo_TElDNSClient_set_Timeout, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElDNSClient, get_UseIPv6, arginfo_TElDNSClient_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, set_UseIPv6, arginfo_TElDNSClient_set_UseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElDNSClient, get_UseRecursion, arginfo_TElDNSClient_get_UseRecursion, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, set_UseRecursion, arginfo_TElDNSClient_set_UseRecursion, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, get_UseSecurity, arginfo_TElDNSClient_get_UseSecurity, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, set_UseSecurity, arginfo_TElDNSClient_set_UseSecurity, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, get_OnSending, arginfo_TElDNSClient_get_OnSending, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, set_OnSending, arginfo_TElDNSClient_set_OnSending, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, get_OnTimeout, arginfo_TElDNSClient_get_OnTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, set_OnTimeout, arginfo_TElDNSClient_set_OnTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSClient, __construct, arginfo_TElDNSClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSClient", TElDNSClient_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElDNSClient_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSResolver_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSResolver, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSResolver_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, Lookup)
{
	char *sCriteria;
	int sCriteria_len;
	long fInfoType;
	TSBDNSSecurityStatusRaw fSecurityStatusRaw = 0;
	zval *oFoundInfo;
	zval *zfSecurityStatus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!z", &sCriteria, &sCriteria_len, &fInfoType, &oFoundInfo, TElDNSResourceRecordSet_ce_ptr, &zfSecurityStatus) == SUCCESS) && PZVAL_IS_REF(zfSecurityStatus) && (IS_LONG == Z_TYPE_P(zfSecurityStatus)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResolver_Lookup(SBGetObjectHandle(getThis() TSRMLS_CC), sCriteria, (int32_t)sCriteria_len, (TSBDNSResourceTypeRaw)fInfoType, SBGetObjectHandle(oFoundInfo TSRMLS_CC), &fSecurityStatusRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zfSecurityStatus, (long)fSecurityStatusRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, TElDNSResourceRecordSet, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSResolver_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_Port)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSResolver_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, get_Servers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSResolver_get_Servers(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_Servers)
{
	zval *oValue;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElDNSResolver_set_Servers(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElDNSResolver, get_QueryTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSResolver_get_QueryTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_QueryTimeout)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSResolver_set_QueryTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, get_TotalTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSResolver_get_TotalTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_TotalTimeout)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSResolver_set_TotalTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElDNSResolver, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSResolver_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSResolver_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElDNSResolver, get_UseSecurity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSResolver_get_UseSecurity(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_UseSecurity)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSResolver_set_UseSecurity(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolverErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDNSResolver_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDNSResolver_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolverErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolverErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, get_OnKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDNSResolver_get_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_OnKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDNSResolver_set_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, get_OnKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDNSResolver_get_OnKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_OnKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDNSResolver_set_OnKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, get_OnPrepare)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolverPrepareEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDNSResolver_get_OnPrepare(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_OnPrepare)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDNSResolver_set_OnPrepare(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolverPrepareEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolverPrepareEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, get_OnRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolverRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDNSResolver_get_OnRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_OnRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDNSResolver_set_OnRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolverRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolverRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, get_OnResponse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolverResponseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDNSResolver_get_OnResponse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, set_OnResponse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDNSResolver_set_OnResponse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolverResponseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolverResponseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResolver, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSResolver_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_Lookup, 0, 0, 4)
	ZEND_ARG_INFO(0, Criteria)
	ZEND_ARG_INFO(0, InfoType)
	ZEND_ARG_OBJ_INFO(0, FoundInfo, TElDNSResourceRecordSet, 1)
	ZEND_ARG_INFO(1, SecurityStatus)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_Servers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_Servers, 0, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Value, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Value, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_QueryTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_QueryTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_TotalTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_TotalTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_UseSecurity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_UseSecurity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_OnKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_OnKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_OnKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_OnKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_OnPrepare, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_OnPrepare, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_OnRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_OnRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_get_OnResponse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver_set_OnResponse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResolver___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSResolver_methods[] = {
	PHP_ME(TElDNSResolver, Assign, arginfo_TElDNSResolver_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, Lookup, arginfo_TElDNSResolver_Lookup, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_Port, arginfo_TElDNSResolver_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_Port, arginfo_TElDNSResolver_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_Servers, arginfo_TElDNSResolver_get_Servers, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_Servers, arginfo_TElDNSResolver_set_Servers, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_QueryTimeout, arginfo_TElDNSResolver_get_QueryTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_QueryTimeout, arginfo_TElDNSResolver_set_QueryTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_TotalTimeout, arginfo_TElDNSResolver_get_TotalTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_TotalTimeout, arginfo_TElDNSResolver_set_TotalTimeout, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElDNSResolver, get_UseIPv6, arginfo_TElDNSResolver_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_UseIPv6, arginfo_TElDNSResolver_set_UseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElDNSResolver, get_UseSecurity, arginfo_TElDNSResolver_get_UseSecurity, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_UseSecurity, arginfo_TElDNSResolver_set_UseSecurity, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_OnError, arginfo_TElDNSResolver_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_OnError, arginfo_TElDNSResolver_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_OnKeyNeeded, arginfo_TElDNSResolver_get_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_OnKeyNeeded, arginfo_TElDNSResolver_set_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_OnKeyValidate, arginfo_TElDNSResolver_get_OnKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_OnKeyValidate, arginfo_TElDNSResolver_set_OnKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_OnPrepare, arginfo_TElDNSResolver_get_OnPrepare, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_OnPrepare, arginfo_TElDNSResolver_set_OnPrepare, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_OnRequest, arginfo_TElDNSResolver_get_OnRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_OnRequest, arginfo_TElDNSResolver_set_OnRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, get_OnResponse, arginfo_TElDNSResolver_get_OnResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, set_OnResponse, arginfo_TElDNSResolver_set_OnResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResolver, __construct, arginfo_TElDNSResolver___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSResolver(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSResolver_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSResolver", TElDNSResolver_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElDNSResolver_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}
