#include "sbdsa.h"

SB_PHP_FUNCTION(SBDSA, ValidateSignature)
{
	long l4GSize;
	long l4HashSize;
	long l4PSize;
	long l4QSize;
	long l4RSize;
	long l4SSize;
	long l4YSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piHash;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piY;
	zval *zpG;
	zval *zpHash;
	zval *zpP;
	zval *zpQ;
	zval *zpR;
	zval *zpS;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzlzl", &zpHash, &l4HashSize, &zpP, &l4PSize, &zpQ, &l4QSize, &zpG, &l4GSize, &zpY, &l4YSize, &zpR, &l4RSize, &zpS, &l4SSize) == SUCCESS) && ((Z_TYPE_P(zpHash) == IS_STRING) || (Z_TYPE_P(zpHash) == IS_ARRAY) || (Z_TYPE_P(zpHash) == IS_NULL) || ((Z_TYPE_P(zpHash) == IS_OBJECT) && (Z_OBJCE_P(zpHash) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHash, &piHash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBDSA_ValidateSignature(piHash.data, (int32_t)l4HashSize, piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize, piR.data, (int32_t)l4RSize, piS.data, (int32_t)l4SSize, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHash);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piR);
		SBFreePointerZValInfo(&piS);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, Generate)
{
	int32_t l4GSizeRaw;
	int32_t l4PrivateKeyBlobSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4QSizeRaw;
	int32_t l4XSizeRaw;
	int32_t l4YSizeRaw;
	long l4Bits;
	SBArrayZValInfo piData;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piPrivateKeyBlob;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	void *pzProgressFunc;
	zval *zl4GSize;
	zval *zl4PrivateKeyBlobSize;
	zval *zl4PSize;
	zval *zl4QSize;
	zval *zl4XSize;
	zval *zl4YSize;
	zval *zpData;
	zval *zpG;
	zval *zpP;
	zval *zpPrivateKeyBlob;
	zval *zpQ;
	zval *zProgressFunc;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzzzzzzzz", &l4Bits, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize, &zpX, &zl4XSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4XSize) && (IS_LONG == Z_TYPE_P(zl4XSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		l4XSizeRaw = (int32_t)Z_LVAL_P(zl4XSize);
		SBCheckError(SBDSA_Generate((int32_t)l4Bits, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw, piX.data, &l4XSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
		SBFreePointerZValInfo(&piX);
		ZVAL_LONG(zl4XSize, (long)l4XSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzzzzzzzzzzzz", &l4Bits, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize, &zpX, &zl4XSize, &zpPrivateKeyBlob, &zl4PrivateKeyBlobSize, &zProgressFunc, &zpData) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4XSize) && (IS_LONG == Z_TYPE_P(zl4XSize)) && ((Z_TYPE_P(zpPrivateKeyBlob) == IS_STRING) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_ARRAY) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_NULL) || ((Z_TYPE_P(zpPrivateKeyBlob) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateKeyBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateKeyBlobSize) && (IS_LONG == Z_TYPE_P(zl4PrivateKeyBlobSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		l4XSizeRaw = (int32_t)Z_LVAL_P(zl4XSize);
		if (!SBGetPointerFromZVal(zpPrivateKeyBlob, &piPrivateKeyBlob TSRMLS_CC)) RETURN_FALSE;
		l4PrivateKeyBlobSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateKeyBlobSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBDSA_Generate_1((int32_t)l4Bits, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw, piX.data, &l4XSizeRaw, piPrivateKeyBlob.data, &l4PrivateKeyBlobSizeRaw, pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
		SBFreePointerZValInfo(&piX);
		ZVAL_LONG(zl4XSize, (long)l4XSizeRaw);
		SBFreePointerZValInfo(&piPrivateKeyBlob);
		ZVAL_LONG(zl4PrivateKeyBlobSize, (long)l4PrivateKeyBlobSizeRaw);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer) or (integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, ExternalGenerate)
{
	int32_t l4GSizeRaw;
	int32_t l4PrivateKeyBlobSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4QSizeRaw;
	int32_t l4XSizeRaw;
	int32_t l4YSizeRaw;
	long l4Bits;
	SBArrayZValInfo piData;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piPrivateKeyBlob;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	void *pzProgressFunc;
	zval *zl4GSize;
	zval *zl4PrivateKeyBlobSize;
	zval *zl4PSize;
	zval *zl4QSize;
	zval *zl4XSize;
	zval *zl4YSize;
	zval *zpData;
	zval *zpG;
	zval *zpP;
	zval *zpPrivateKeyBlob;
	zval *zpQ;
	zval *zProgressFunc;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzzzzzzzz", &l4Bits, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize, &zpX, &zl4XSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4XSize) && (IS_LONG == Z_TYPE_P(zl4XSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		l4XSizeRaw = (int32_t)Z_LVAL_P(zl4XSize);
		SBCheckError(SBDSA_ExternalGenerate((int32_t)l4Bits, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw, piX.data, &l4XSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
		SBFreePointerZValInfo(&piX);
		ZVAL_LONG(zl4XSize, (long)l4XSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzzzzzzzzzzzz", &l4Bits, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize, &zpX, &zl4XSize, &zpPrivateKeyBlob, &zl4PrivateKeyBlobSize, &zProgressFunc, &zpData) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4XSize) && (IS_LONG == Z_TYPE_P(zl4XSize)) && ((Z_TYPE_P(zpPrivateKeyBlob) == IS_STRING) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_ARRAY) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_NULL) || ((Z_TYPE_P(zpPrivateKeyBlob) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateKeyBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateKeyBlobSize) && (IS_LONG == Z_TYPE_P(zl4PrivateKeyBlobSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		l4XSizeRaw = (int32_t)Z_LVAL_P(zl4XSize);
		if (!SBGetPointerFromZVal(zpPrivateKeyBlob, &piPrivateKeyBlob TSRMLS_CC)) RETURN_FALSE;
		l4PrivateKeyBlobSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateKeyBlobSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBDSA_ExternalGenerate_1((int32_t)l4Bits, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw, piX.data, &l4XSizeRaw, piPrivateKeyBlob.data, &l4PrivateKeyBlobSizeRaw, pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
		SBFreePointerZValInfo(&piX);
		ZVAL_LONG(zl4XSize, (long)l4XSizeRaw);
		SBFreePointerZValInfo(&piPrivateKeyBlob);
		ZVAL_LONG(zl4PrivateKeyBlobSize, (long)l4PrivateKeyBlobSizeRaw);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer) or (integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, GenerateEx)
{
	int32_t l4GSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4QSizeRaw;
	int32_t l4XSizeRaw;
	int32_t l4YSizeRaw;
	long l4PBits;
	long l4QBits;
	SBArrayZValInfo piData;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	void *pzProgressFunc;
	zval *zl4GSize;
	zval *zl4PSize;
	zval *zl4QSize;
	zval *zl4XSize;
	zval *zl4YSize;
	zval *zpData;
	zval *zpG;
	zval *zpP;
	zval *zpQ;
	zval *zProgressFunc;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llzzzzzzzzzzzz", &l4PBits, &l4QBits, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize, &zpX, &zl4XSize, &zProgressFunc, &zpData) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4XSize) && (IS_LONG == Z_TYPE_P(zl4XSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		l4XSizeRaw = (int32_t)Z_LVAL_P(zl4XSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBDSA_GenerateEx((int32_t)l4PBits, (int32_t)l4QBits, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw, piX.data, &l4XSizeRaw, pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
		SBFreePointerZValInfo(&piX);
		ZVAL_LONG(zl4XSize, (long)l4XSizeRaw);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, ExternalGenerateEx)
{
	int32_t l4GSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4QSizeRaw;
	int32_t l4XSizeRaw;
	int32_t l4YSizeRaw;
	long l4PBits;
	long l4QBits;
	SBArrayZValInfo piData;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	void *pzProgressFunc;
	zval *zl4GSize;
	zval *zl4PSize;
	zval *zl4QSize;
	zval *zl4XSize;
	zval *zl4YSize;
	zval *zpData;
	zval *zpG;
	zval *zpP;
	zval *zpQ;
	zval *zProgressFunc;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llzzzzzzzzzzzz", &l4PBits, &l4QBits, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize, &zpX, &zl4XSize, &zProgressFunc, &zpData) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4XSize) && (IS_LONG == Z_TYPE_P(zl4XSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		l4XSizeRaw = (int32_t)Z_LVAL_P(zl4XSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBDSA_ExternalGenerateEx((int32_t)l4PBits, (int32_t)l4QBits, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw, piX.data, &l4XSizeRaw, pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
		SBFreePointerZValInfo(&piX);
		ZVAL_LONG(zl4XSize, (long)l4XSizeRaw);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, Sign)
{
	int32_t l4RSizeRaw;
	int32_t l4SSizeRaw;
	long l4GSize;
	long l4HashSize;
	long l4PSize;
	long l4QSize;
	long l4XSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piHash;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piX;
	zval *zl4RSize;
	zval *zl4SSize;
	zval *zpG;
	zval *zpHash;
	zval *zpP;
	zval *zpQ;
	zval *zpR;
	zval *zpS;
	zval *zpX;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzzzz", &zpHash, &l4HashSize, &zpP, &l4PSize, &zpQ, &l4QSize, &zpG, &l4GSize, &zpX, &l4XSize, &zpR, &zl4RSize, &zpS, &zl4SSize) == SUCCESS) && ((Z_TYPE_P(zpHash) == IS_STRING) || (Z_TYPE_P(zpHash) == IS_ARRAY) || (Z_TYPE_P(zpHash) == IS_NULL) || ((Z_TYPE_P(zpHash) == IS_OBJECT) && (Z_OBJCE_P(zpHash) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4RSize) && (IS_LONG == Z_TYPE_P(zl4RSize)) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SSize) && (IS_LONG == Z_TYPE_P(zl4SSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHash, &piHash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		l4RSizeRaw = (int32_t)Z_LVAL_P(zl4RSize);
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		l4SSizeRaw = (int32_t)Z_LVAL_P(zl4SSize);
		SBCheckError(SBDSA_Sign(piHash.data, (int32_t)l4HashSize, piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piG.data, (int32_t)l4GSize, piX.data, (int32_t)l4XSize, piR.data, &l4RSizeRaw, piS.data, &l4SSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHash);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piX);
		SBFreePointerZValInfo(&piR);
		ZVAL_LONG(zl4RSize, (long)l4RSizeRaw);
		SBFreePointerZValInfo(&piS);
		ZVAL_LONG(zl4SSize, (long)l4SSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, SignEx)
{
	int32_t l4RSizeRaw;
	int32_t l4SSizeRaw;
	long l4GSize;
	long l4HashSize;
	long l4PSize;
	long l4QSize;
	long l4XSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piHash;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piX;
	zval *zl4RSize;
	zval *zl4SSize;
	zval *zpG;
	zval *zpHash;
	zval *zpP;
	zval *zpQ;
	zval *zpR;
	zval *zpS;
	zval *zpX;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzzzz", &zpHash, &l4HashSize, &zpP, &l4PSize, &zpQ, &l4QSize, &zpG, &l4GSize, &zpX, &l4XSize, &zpR, &zl4RSize, &zpS, &zl4SSize) == SUCCESS) && ((Z_TYPE_P(zpHash) == IS_STRING) || (Z_TYPE_P(zpHash) == IS_ARRAY) || (Z_TYPE_P(zpHash) == IS_NULL) || ((Z_TYPE_P(zpHash) == IS_OBJECT) && (Z_OBJCE_P(zpHash) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4RSize) && (IS_LONG == Z_TYPE_P(zl4RSize)) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SSize) && (IS_LONG == Z_TYPE_P(zl4SSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHash, &piHash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		l4RSizeRaw = (int32_t)Z_LVAL_P(zl4RSize);
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		l4SSizeRaw = (int32_t)Z_LVAL_P(zl4SSize);
		SBCheckError(SBDSA_SignEx(piHash.data, (int32_t)l4HashSize, piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piG.data, (int32_t)l4GSize, piX.data, (int32_t)l4XSize, piR.data, &l4RSizeRaw, piS.data, &l4SSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHash);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piX);
		SBFreePointerZValInfo(&piR);
		ZVAL_LONG(zl4RSize, (long)l4RSizeRaw);
		SBFreePointerZValInfo(&piS);
		ZVAL_LONG(zl4SSize, (long)l4SSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, DecodePrivateKey)
{
	int32_t l4GSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4QSizeRaw;
	int32_t l4XSizeRaw;
	int32_t l4YSizeRaw;
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *zl4GSize;
	zval *zl4PSize;
	zval *zl4QSize;
	zval *zl4XSize;
	zval *zl4YSize;
	zval *zpBuffer;
	zval *zpG;
	zval *zpP;
	zval *zpQ;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzzzzzzz", &zpBuffer, &l4Size, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize, &zpX, &zl4XSize) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4XSize) && (IS_LONG == Z_TYPE_P(zl4XSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		l4XSizeRaw = (int32_t)Z_LVAL_P(zl4XSize);
		SBCheckError(SBDSA_DecodePrivateKey(piBuffer.data, (int32_t)l4Size, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw, piX.data, &l4XSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
		SBFreePointerZValInfo(&piX);
		ZVAL_LONG(zl4XSize, (long)l4XSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, EncodePrivateKey)
{
	int32_t l4OutSizeRaw;
	long l4GSize;
	long l4PSize;
	long l4QSize;
	long l4XSize;
	long l4YSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *zl4OutSize;
	zval *zpG;
	zval *zpOutBuffer;
	zval *zpP;
	zval *zpQ;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzz", &zpP, &l4PSize, &zpQ, &l4QSize, &zpG, &l4GSize, &zpY, &l4YSize, &zpX, &l4XSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBDSA_EncodePrivateKey(piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize, piX.data, (int32_t)l4XSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piX);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, EncodeSignature)
{
	int32_t l4BlobSizeRaw;
	long l4RSize;
	long l4SSize;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	zval *zl4BlobSize;
	zval *zpBlob;
	zval *zpR;
	zval *zpS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzz", &zpR, &l4RSize, &zpS, &l4SSize, &zpBlob, &zl4BlobSize) == SUCCESS) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4BlobSize) && (IS_LONG == Z_TYPE_P(zl4BlobSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		l4BlobSizeRaw = (int32_t)Z_LVAL_P(zl4BlobSize);
		SBCheckError(SBDSA_EncodeSignature(piR.data, (int32_t)l4RSize, piS.data, (int32_t)l4SSize, piBlob.data, &l4BlobSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piR);
		SBFreePointerZValInfo(&piS);
		SBFreePointerZValInfo(&piBlob);
		ZVAL_LONG(zl4BlobSize, (long)l4BlobSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, DecodeSignature)
{
	int32_t l4RSizeRaw;
	int32_t l4SSizeRaw;
	long l4Size;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	zval *zl4RSize;
	zval *zl4SSize;
	zval *zpBlob;
	zval *zpR;
	zval *zpS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzz", &zpBlob, &l4Size, &zpR, &zl4RSize, &zpS, &zl4SSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4RSize) && (IS_LONG == Z_TYPE_P(zl4RSize)) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SSize) && (IS_LONG == Z_TYPE_P(zl4SSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		l4RSizeRaw = (int32_t)Z_LVAL_P(zl4RSize);
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		l4SSizeRaw = (int32_t)Z_LVAL_P(zl4SSize);
		SBCheckError(SBDSA_DecodeSignature(piBlob.data, (int32_t)l4Size, piR.data, &l4RSizeRaw, piS.data, &l4SSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piR);
		ZVAL_LONG(zl4RSize, (long)l4RSizeRaw);
		SBFreePointerZValInfo(&piS);
		ZVAL_LONG(zl4SSize, (long)l4SSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, IsValidKey)
{
	long l4GSize;
	long l4PSize;
	long l4QSize;
	long l4XSize;
	long l4YSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zend_bool bSecret;
	zend_bool bStrictMode;
	zval *zpG;
	zval *zpP;
	zval *zpQ;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlbb", &zpP, &l4PSize, &zpQ, &l4QSize, &zpG, &l4GSize, &zpY, &l4YSize, &zpX, &l4XSize, &bSecret, &bStrictMode) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBDSA_IsValidKey(piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize, piX.data, (int32_t)l4XSize, (int8_t)bSecret, (int8_t)bStrictMode, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piX);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDSA, ExternalGenerationSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBDSA_ExternalGenerationSupported(&bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

