#include "sbgost341094.h"

zend_class_entry *TElGOSTSignerBase_ce_ptr = NULL;

SB_PHP_METHOD(TElGOSTSignerBase, AssignSecretKey)
{
	char *sHexStr;
	int sHexStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sHexStr, &sHexStr_len) == SUCCESS)
	{
		SBCheckError(TElGOSTSignerBase_AssignSecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), sHexStr, (int32_t)sHexStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSignerBase, AssignPublicKey)
{
	char *sHexStr;
	int sHexStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sHexStr, &sHexStr_len) == SUCCESS)
	{
		SBCheckError(TElGOSTSignerBase_AssignPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), sHexStr, (int32_t)sHexStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSignerBase, get_SecretKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TLInt * proOutResult;
		SBCheckError(TElGOSTSignerBase_get_SecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), &proOutResult) TSRMLS_CC);
		object_init_ex(return_value, TLInt_ce_ptr);
		SBSetStructPointer(return_value, proOutResult, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSignerBase, set_SecretKey)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOSTSignerBase_set_SecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSignerBase, get_PublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TLInt * proOutResult;
		SBCheckError(TElGOSTSignerBase_get_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &proOutResult) TSRMLS_CC);
		object_init_ex(return_value, TLInt_ce_ptr);
		SBSetStructPointer(return_value, proOutResult, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSignerBase, set_PublicKey)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOSTSignerBase_set_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSignerBase, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOSTSignerBase_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSignerBase_AssignSecretKey, 0, 0, 1)
	ZEND_ARG_INFO(0, HexStr)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSignerBase_AssignPublicKey, 0, 0, 1)
	ZEND_ARG_INFO(0, HexStr)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSignerBase_get_SecretKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSignerBase_set_SecretKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSignerBase_get_PublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSignerBase_set_PublicKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSignerBase___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOSTSignerBase_methods[] = {
	PHP_ME(TElGOSTSignerBase, AssignSecretKey, arginfo_TElGOSTSignerBase_AssignSecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSignerBase, AssignPublicKey, arginfo_TElGOSTSignerBase_AssignPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSignerBase, get_SecretKey, arginfo_TElGOSTSignerBase_get_SecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSignerBase, set_SecretKey, arginfo_TElGOSTSignerBase_set_SecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSignerBase, get_PublicKey, arginfo_TElGOSTSignerBase_get_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSignerBase, set_PublicKey, arginfo_TElGOSTSignerBase_set_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSignerBase, __construct, arginfo_TElGOSTSignerBase___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOSTSignerBase(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOSTSignerBase_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOSTSignerBase", TElGOSTSignerBase_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGOSTSignerBase_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGOSTSigner_ce_ptr = NULL;

SB_PHP_METHOD(TElGOSTSigner, AssignP)
{
	char *sHexStr;
	int sHexStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sHexStr, &sHexStr_len) == SUCCESS)
	{
		SBCheckError(TElGOSTSigner_AssignP(SBGetObjectHandle(getThis() TSRMLS_CC), sHexStr, (int32_t)sHexStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, AssignQ)
{
	char *sHexStr;
	int sHexStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sHexStr, &sHexStr_len) == SUCCESS)
	{
		SBCheckError(TElGOSTSigner_AssignQ(SBGetObjectHandle(getThis() TSRMLS_CC), sHexStr, (int32_t)sHexStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, AssignA)
{
	char *sHexStr;
	int sHexStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sHexStr, &sHexStr_len) == SUCCESS)
	{
		SBCheckError(TElGOSTSigner_AssignA(SBGetObjectHandle(getThis() TSRMLS_CC), sHexStr, (int32_t)sHexStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Check_Params_Inst)
{
	long l4Bits;
	long l8c;
	long l8x0;
	zval *oA;
	zval *oP;
	zval *oQ;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!O!ll", &l4Bits, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &l8x0, &l8c) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGOSTSigner_Check_Params_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (int64_t)l8x0, (int64_t)l8c, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TLInt, TLInt, TLInt, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Check_Params)
{
	long l4Bits;
	long l8c;
	long l8x0;
	zval *oA;
	zval *oP;
	zval *oQ;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!O!ll", &l4Bits, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &l8x0, &l8c) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGOSTSigner_Check_Params((int32_t)l4Bits, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (int64_t)l8x0, (int64_t)l8c, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TLInt, TLInt, TLInt, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Generate_PQA_Inst)
{
	int64_t l8cRaw;
	int64_t l8x0Raw;
	long l4Bits;
	long l4TypeProc;
	TLInt * proA;
	TLInt * proP;
	TLInt * proQ;
	zval *oA;
	zval *oP;
	zval *oQ;
	zval *zl8c;
	zval *zl8x0;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llzz", &l4Bits, &l4TypeProc, &zl8x0, &zl8c) == SUCCESS) && PZVAL_IS_REF(zl8x0) && (IS_LONG == Z_TYPE_P(zl8x0)) && PZVAL_IS_REF(zl8c) && (IS_LONG == Z_TYPE_P(zl8c)))
	{
		int8_t bOutResultRaw = 0;
		l8x0Raw = (int64_t)Z_LVAL_P(zl8x0);
		l8cRaw = (int64_t)Z_LVAL_P(zl8c);
		SBCheckError(TElGOSTSigner_Generate_PQA(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, (int32_t)l4TypeProc, &l8x0Raw, &l8cRaw, &bOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zl8x0, (long)l8x0Raw);
		ZVAL_LONG(zl8c, (long)l8cRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llzzOOO", &l4Bits, &l4TypeProc, &zl8x0, &zl8c, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zl8x0) && (IS_LONG == Z_TYPE_P(zl8x0)) && PZVAL_IS_REF(zl8c) && (IS_LONG == Z_TYPE_P(zl8c)) && PZVAL_IS_REF(oP) && PZVAL_IS_REF(oQ) && PZVAL_IS_REF(oA))
	{
		int8_t bOutResultRaw = 0;
		l8x0Raw = (int64_t)Z_LVAL_P(zl8x0);
		l8cRaw = (int64_t)Z_LVAL_P(zl8c);
		proP = (TLInt *)SBGetStructPointer(oP TSRMLS_CC);
		proQ = (TLInt *)SBGetStructPointer(oQ TSRMLS_CC);
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(TElGOSTSigner_Generate_PQA_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, (int32_t)l4TypeProc, &l8x0Raw, &l8cRaw, &proP, &proQ, &proA, &bOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zl8x0, (long)l8x0Raw);
		ZVAL_LONG(zl8c, (long)l8cRaw);
		SBSetStructPointer(oP, proP, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oQ, proQ, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, &integer, &integer) or (integer, integer, &integer, &integer, &TLInt, &TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Generate_PQA)
{
	int64_t l8cRaw;
	int64_t l8x0Raw;
	long l4Bits;
	long l4TypeProc;
	TLInt * proA;
	TLInt * proP;
	TLInt * proQ;
	zval *oA;
	zval *oP;
	zval *oQ;
	zval *zl8c;
	zval *zl8x0;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llzzOOO", &l4Bits, &l4TypeProc, &zl8x0, &zl8c, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zl8x0) && (IS_LONG == Z_TYPE_P(zl8x0)) && PZVAL_IS_REF(zl8c) && (IS_LONG == Z_TYPE_P(zl8c)) && PZVAL_IS_REF(oP) && PZVAL_IS_REF(oQ) && PZVAL_IS_REF(oA))
	{
		int8_t bOutResultRaw = 0;
		l8x0Raw = (int64_t)Z_LVAL_P(zl8x0);
		l8cRaw = (int64_t)Z_LVAL_P(zl8c);
		proP = (TLInt *)SBGetStructPointer(oP TSRMLS_CC);
		proQ = (TLInt *)SBGetStructPointer(oQ TSRMLS_CC);
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(TElGOSTSigner_Generate_PQA_1((int32_t)l4Bits, (int32_t)l4TypeProc, &l8x0Raw, &l8cRaw, &proP, &proQ, &proA, &bOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zl8x0, (long)l8x0Raw);
		ZVAL_LONG(zl8c, (long)l8cRaw);
		SBSetStructPointer(oP, proP, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oQ, proQ, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, &integer, &integer, &TLInt, &TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Generate_All)
{
	int64_t l8cRaw;
	int64_t l8x0Raw;
	long l4Bits;
	long l4TypeProc;
	zval *zl8c;
	zval *zl8x0;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llzz", &l4Bits, &l4TypeProc, &zl8x0, &zl8c) == SUCCESS) && PZVAL_IS_REF(zl8x0) && (IS_LONG == Z_TYPE_P(zl8x0)) && PZVAL_IS_REF(zl8c) && (IS_LONG == Z_TYPE_P(zl8c)))
	{
		int8_t bOutResultRaw = 0;
		l8x0Raw = (int64_t)Z_LVAL_P(zl8x0);
		l8cRaw = (int64_t)Z_LVAL_P(zl8c);
		SBCheckError(TElGOSTSigner_Generate_All(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, (int32_t)l4TypeProc, &l8x0Raw, &l8cRaw, &bOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zl8x0, (long)l8x0Raw);
		ZVAL_LONG(zl8c, (long)l8cRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Generate_Keys_Inst)
{
	TLInt * proPublicKey;
	TLInt * proSecretKey;
	zval *oA;
	zval *oP;
	zval *oPublicKey;
	zval *oQ;
	zval *oSecretKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOSTSigner_Generate_Keys(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!OO", &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oSecretKey, TLInt_ce_ptr, &oPublicKey, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oSecretKey) && PZVAL_IS_REF(oPublicKey))
	{
		proSecretKey = (TLInt *)SBGetStructPointer(oSecretKey TSRMLS_CC);
		proPublicKey = (TLInt *)SBGetStructPointer(oPublicKey TSRMLS_CC);
		SBCheckError(TElGOSTSigner_Generate_Keys_2(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), &proSecretKey, &proPublicKey) TSRMLS_CC);
		SBSetStructPointer(oSecretKey, proSecretKey, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oPublicKey, proPublicKey, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TLInt, TLInt, TLInt, &TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Generate_Keys)
{
	TLInt * proPublicKey;
	TLInt * proSecretKey;
	zval *oA;
	zval *oP;
	zval *oPublicKey;
	zval *oQ;
	zval *oSecretKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!OO", &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oSecretKey, TLInt_ce_ptr, &oPublicKey, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oSecretKey) && PZVAL_IS_REF(oPublicKey))
	{
		proSecretKey = (TLInt *)SBGetStructPointer(oSecretKey TSRMLS_CC);
		proPublicKey = (TLInt *)SBGetStructPointer(oPublicKey TSRMLS_CC);
		SBCheckError(TElGOSTSigner_Generate_Keys_1((TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), &proSecretKey, &proPublicKey) TSRMLS_CC);
		SBSetStructPointer(oSecretKey, proSecretKey, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oPublicKey, proPublicKey, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Sign_Inst)
{
	char *sA;
	char *sKey;
	char *sP;
	char *sQ;
	int sA_len;
	int sKey_len;
	int sP_len;
	int sQ_len;
	SBArrayZValInfo aiDigest;
	uint32_t _err;
	zval *oA;
	zval *oKey;
	zval *oP;
	zval *oQ;
	zval *zaDigest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaDigest) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest)) || (IS_NULL == Z_TYPE_P(zaDigest))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaDigest, &aiDigest TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOSTSigner_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), aiDigest.data, aiDigest.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1791132830, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiDigest);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zssss", &zaDigest, &sP, &sP_len, &sQ, &sQ_len, &sA, &sA_len, &sKey, &sKey_len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest)) || (IS_NULL == Z_TYPE_P(zaDigest))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaDigest, &aiDigest TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOSTSigner_Sign_2(SBGetObjectHandle(getThis() TSRMLS_CC), aiDigest.data, aiDigest.len, sP, (int32_t)sP_len, sQ, (int32_t)sQ_len, sA, (int32_t)sA_len, sKey, (int32_t)sKey_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-874401495, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiDigest);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!O!O!", &zaDigest, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oKey, TLInt_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest)) || (IS_NULL == Z_TYPE_P(zaDigest))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaDigest, &aiDigest TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOSTSigner_Sign_4(SBGetObjectHandle(getThis() TSRMLS_CC), aiDigest.data, aiDigest.len, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oKey TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1620962134, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiDigest);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (array of byte|string|NULL, string, string, string, string) or (array of byte|string|NULL, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Sign)
{
	char *sA;
	char *sKey;
	char *sP;
	char *sQ;
	int sA_len;
	int sKey_len;
	int sP_len;
	int sQ_len;
	SBArrayZValInfo aiDigest;
	uint32_t _err;
	zval *oA;
	zval *oKey;
	zval *oP;
	zval *oQ;
	zval *zaDigest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zssss", &zaDigest, &sP, &sP_len, &sQ, &sQ_len, &sA, &sA_len, &sKey, &sKey_len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest)) || (IS_NULL == Z_TYPE_P(zaDigest))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaDigest, &aiDigest TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOSTSigner_Sign_1(aiDigest.data, aiDigest.len, sP, (int32_t)sP_len, sQ, (int32_t)sQ_len, sA, (int32_t)sA_len, sKey, (int32_t)sKey_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-874401495, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiDigest);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!O!O!", &zaDigest, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oKey, TLInt_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest)) || (IS_NULL == Z_TYPE_P(zaDigest))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaDigest, &aiDigest TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOSTSigner_Sign_3(aiDigest.data, aiDigest.len, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oKey TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1620962134, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiDigest);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, string, string, string, string) or (array of byte|string|NULL, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Verify_Inst)
{
	SBArrayZValInfo aiDigest;
	SBArrayZValInfo aiSign;
	zval *oA;
	zval *oKey;
	zval *oP;
	zval *oQ;
	zval *zaDigest;
	zval *zaSign;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaDigest, &zaSign) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest)) || (IS_NULL == Z_TYPE_P(zaDigest))) && ((IS_STRING == Z_TYPE_P(zaSign)) || (IS_ARRAY == Z_TYPE_P(zaSign)) || (IS_NULL == Z_TYPE_P(zaSign))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaDigest, &aiDigest TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaSign, &aiSign TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOSTSigner_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), aiDigest.data, aiDigest.len, aiSign.data, aiSign.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDigest);
		SBFreeArrayZValInfo(&aiSign);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!O!O!O!", &zaDigest, &zaSign, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oKey, TLInt_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest)) || (IS_NULL == Z_TYPE_P(zaDigest))) && ((IS_STRING == Z_TYPE_P(zaSign)) || (IS_ARRAY == Z_TYPE_P(zaSign)) || (IS_NULL == Z_TYPE_P(zaSign))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaDigest, &aiDigest TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaSign, &aiSign TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOSTSigner_Verify_2(SBGetObjectHandle(getThis() TSRMLS_CC), aiDigest.data, aiDigest.len, aiSign.data, aiSign.len, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oKey TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDigest);
		SBFreeArrayZValInfo(&aiSign);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, Verify)
{
	SBArrayZValInfo aiDigest;
	SBArrayZValInfo aiSign;
	zval *oA;
	zval *oKey;
	zval *oP;
	zval *oQ;
	zval *zaDigest;
	zval *zaSign;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!O!O!O!", &zaDigest, &zaSign, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oKey, TLInt_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDigest)) || (IS_ARRAY == Z_TYPE_P(zaDigest)) || (IS_NULL == Z_TYPE_P(zaDigest))) && ((IS_STRING == Z_TYPE_P(zaSign)) || (IS_ARRAY == Z_TYPE_P(zaSign)) || (IS_NULL == Z_TYPE_P(zaSign))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaDigest, &aiDigest TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaSign, &aiSign TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOSTSigner_Verify_1(aiDigest.data, aiDigest.len, aiSign.data, aiSign.len, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oKey TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDigest);
		SBFreeArrayZValInfo(&aiSign);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, get_P)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TLInt * proOutResult;
		SBCheckError(TElGOSTSigner_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), &proOutResult) TSRMLS_CC);
		object_init_ex(return_value, TLInt_ce_ptr);
		SBSetStructPointer(return_value, proOutResult, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, set_P)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOSTSigner_set_P(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, get_Q)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TLInt * proOutResult;
		SBCheckError(TElGOSTSigner_get_Q(SBGetObjectHandle(getThis() TSRMLS_CC), &proOutResult) TSRMLS_CC);
		object_init_ex(return_value, TLInt_ce_ptr);
		SBSetStructPointer(return_value, proOutResult, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, set_Q)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOSTSigner_set_Q(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, get_A)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TLInt * proOutResult;
		SBCheckError(TElGOSTSigner_get_A(SBGetObjectHandle(getThis() TSRMLS_CC), &proOutResult) TSRMLS_CC);
		object_init_ex(return_value, TLInt_ce_ptr);
		SBSetStructPointer(return_value, proOutResult, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, set_A)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOSTSigner_set_A(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTSigner, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOSTSigner_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_AssignP, 0, 0, 1)
	ZEND_ARG_INFO(0, HexStr)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_AssignQ, 0, 0, 1)
	ZEND_ARG_INFO(0, HexStr)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_AssignA, 0, 0, 1)
	ZEND_ARG_INFO(0, HexStr)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Check_Params_Inst, 0, 0, 6)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Q, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, A, TLInt, 1)
	ZEND_ARG_INFO(0, x0)
	ZEND_ARG_INFO(0, c)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Check_Params, 0, 0, 6)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Q, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, A, TLInt, 1)
	ZEND_ARG_INFO(0, x0)
	ZEND_ARG_INFO(0, c)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Generate_PQA_Inst, 0, 0, 4)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_INFO(0, TypeProc)
	ZEND_ARG_INFO(1, x0)
	ZEND_ARG_INFO(1, c)
	ZEND_ARG_OBJ_INFO(1, P, TLInt, 0)
	ZEND_ARG_OBJ_INFO(1, Q, TLInt, 0)
	ZEND_ARG_OBJ_INFO(1, A, TLInt, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Generate_PQA, 0, 0, 7)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_INFO(0, TypeProc)
	ZEND_ARG_INFO(1, x0)
	ZEND_ARG_INFO(1, c)
	ZEND_ARG_OBJ_INFO(1, P, TLInt, 0)
	ZEND_ARG_OBJ_INFO(1, Q, TLInt, 0)
	ZEND_ARG_OBJ_INFO(1, A, TLInt, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Generate_All, 0, 0, 4)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_INFO(0, TypeProc)
	ZEND_ARG_INFO(1, x0)
	ZEND_ARG_INFO(1, c)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Generate_Keys_Inst, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Q, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, A, TLInt, 1)
	ZEND_ARG_OBJ_INFO(1, SecretKey, TLInt, 0)
	ZEND_ARG_OBJ_INFO(1, PublicKey, TLInt, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Generate_Keys, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Q, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, A, TLInt, 1)
	ZEND_ARG_OBJ_INFO(1, SecretKey, TLInt, 0)
	ZEND_ARG_OBJ_INFO(1, PublicKey, TLInt, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Sign_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Digest, 0, 1)
	ZEND_ARG_TYPE_INFO(0, P, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Q, 0, 1)
	ZEND_ARG_TYPE_INFO(0, A, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Sign, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Digest, 0, 1)
	ZEND_ARG_TYPE_INFO(0, P, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Q, 0, 1)
	ZEND_ARG_TYPE_INFO(0, A, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Verify_Inst, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Digest, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Sign, 0, 1)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Q, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, A, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_Verify, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Digest, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Sign, 0, 1)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Q, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, A, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_set_P, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_get_Q, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_set_Q, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_get_A, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner_set_A, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTSigner___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOSTSigner_methods[] = {
	PHP_ME(TElGOSTSigner, AssignP, arginfo_TElGOSTSigner_AssignP, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, AssignQ, arginfo_TElGOSTSigner_AssignQ, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, AssignA, arginfo_TElGOSTSigner_AssignA, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, Check_Params_Inst, arginfo_TElGOSTSigner_Check_Params_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, Check_Params, arginfo_TElGOSTSigner_Check_Params, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOSTSigner, Generate_PQA_Inst, arginfo_TElGOSTSigner_Generate_PQA_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, Generate_PQA, arginfo_TElGOSTSigner_Generate_PQA, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOSTSigner, Generate_All, arginfo_TElGOSTSigner_Generate_All, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, Generate_Keys_Inst, arginfo_TElGOSTSigner_Generate_Keys_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, Generate_Keys, arginfo_TElGOSTSigner_Generate_Keys, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOSTSigner, Sign_Inst, arginfo_TElGOSTSigner_Sign_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, Sign, arginfo_TElGOSTSigner_Sign, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOSTSigner, Verify_Inst, arginfo_TElGOSTSigner_Verify_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, Verify, arginfo_TElGOSTSigner_Verify, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOSTSigner, get_P, arginfo_TElGOSTSigner_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, set_P, arginfo_TElGOSTSigner_set_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, get_Q, arginfo_TElGOSTSigner_get_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, set_Q, arginfo_TElGOSTSigner_set_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, get_A, arginfo_TElGOSTSigner_get_A, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, set_A, arginfo_TElGOSTSigner_set_A, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTSigner, __construct, arginfo_TElGOSTSigner___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOSTSigner(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOSTSigner_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOSTSigner", TElGOSTSigner_methods);
	if (NULL == TElGOSTSignerBase_ce_ptr)
		Register_TElGOSTSignerBase(TSRMLS_C);
	TElGOSTSigner_ce_ptr = zend_register_internal_class_ex(&ce, TElGOSTSignerBase_ce_ptr, NULL TSRMLS_CC);
}

