#include "sbdefs.h"
#ifdef SB_WINDOWS
#include "sbgsswinauth.h"

zend_class_entry *TElGSSWinAuthProtocols_ce_ptr = NULL;

zend_class_entry *TElGSSWinContext_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSWinContext, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSWinContext_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinContext___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSWinContext_methods[] = {
	PHP_ME(TElGSSWinContext, __construct, arginfo_TElGSSWinContext___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSWinContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSWinContext_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSWinContext", TElGSSWinContext_methods);
	if (NULL == TElGSSCustomContext_ce_ptr)
		Register_TElGSSCustomContext(TSRMLS_C);
	TElGSSWinContext_ce_ptr = zend_register_internal_class_ex(&ce, TElGSSCustomContext_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGSSWinName_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSWinName, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSWinName_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinName___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSWinName_methods[] = {
	PHP_ME(TElGSSWinName, __construct, arginfo_TElGSSWinName___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSWinName(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSWinName_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSWinName", TElGSSWinName_methods);
	if (NULL == TElGSSCustomName_ce_ptr)
		Register_TElGSSCustomName(TSRMLS_C);
	TElGSSWinName_ce_ptr = zend_register_internal_class_ex(&ce, TElGSSCustomName_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGSSWinAuthMechanism_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSWinAuthMechanism, Initialize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGSSWinAuthMechanism_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, AcquireCred)
{
	SBArrayZValInfo aiMechOID;
	TElClassHandle hoCtx;
	zval *oCtx;
	zval *zaMechOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaMechOID, &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMechOID)) || (IS_ARRAY == Z_TYPE_P(zaMechOID)) || (IS_NULL == Z_TYPE_P(zaMechOID))) && PZVAL_IS_REF(oCtx) && (IS_OBJECT == Z_TYPE_P(oCtx)))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMechOID, &aiMechOID TSRMLS_CC)) RETURN_FALSE;
		hoCtx = SBGetObjectHandle(oCtx TSRMLS_CC);
		SBCheckError(TElGSSWinAuthMechanism_AcquireCred(SBGetObjectHandle(getThis() TSRMLS_CC), aiMechOID.data, aiMechOID.len, &hoCtx, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMechOID);
		SBUpdateObjectHandle(oCtx, hoCtx TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, AcceptSecContext)
{
	SBArrayZValInfo aiInputToken;
	SBArrayZValInfo aiOutputToken;
	uint32_t _err;
	zval *oCtx;
	zval *oSourceName;
	zval *zaInputToken;
	zval *zaOutputToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &oSourceName, TElGSSCustomName_ce_ptr, &zaInputToken, &zaOutputToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInputToken)) || (IS_ARRAY == Z_TYPE_P(zaInputToken)) || (IS_NULL == Z_TYPE_P(zaInputToken))) && PZVAL_IS_REF(zaOutputToken) && ((IS_STRING == Z_TYPE_P(zaOutputToken)) || (IS_ARRAY == Z_TYPE_P(zaOutputToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInputToken, &aiInputToken TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutputToken, &aiOutputToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSWinAuthMechanism_AcceptSecContext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), SBGetObjectHandle(oSourceName TSRMLS_CC), aiInputToken.data, aiInputToken.len, aiOutputToken.data, &aiOutputToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutputToken, &aiOutputToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1048824200, 4, aiOutputToken.data, &aiOutputToken.len) TSRMLS_CC);
			((char *)aiOutputToken.data)[aiOutputToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutputToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInputToken);
		SBSetByteArrayToZVal(&aiOutputToken, zaOutputToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, TElGSSCustomName, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, InitSecContext)
{
	SBArrayZValInfo aiInputToken;
	SBArrayZValInfo aiOutputToken;
	uint32_t _err;
	zend_bool bDelegateCred;
	zval *oCtx;
	zval *oTargetName;
	zval *zaInputToken;
	zval *zaOutputToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bzz", &oCtx, TElGSSCustomContext_ce_ptr, &oTargetName, TElGSSCustomName_ce_ptr, &bDelegateCred, &zaInputToken, &zaOutputToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInputToken)) || (IS_ARRAY == Z_TYPE_P(zaInputToken)) || (IS_NULL == Z_TYPE_P(zaInputToken))) && PZVAL_IS_REF(zaOutputToken) && ((IS_STRING == Z_TYPE_P(zaOutputToken)) || (IS_ARRAY == Z_TYPE_P(zaOutputToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInputToken, &aiInputToken TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutputToken, &aiOutputToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSWinAuthMechanism_InitSecContext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), SBGetObjectHandle(oTargetName TSRMLS_CC), (int8_t)bDelegateCred, aiInputToken.data, aiInputToken.len, aiOutputToken.data, &aiOutputToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutputToken, &aiOutputToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-384277698, 5, aiOutputToken.data, &aiOutputToken.len) TSRMLS_CC);
			((char *)aiOutputToken.data)[aiOutputToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutputToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInputToken);
		SBSetByteArrayToZVal(&aiOutputToken, zaOutputToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, TElGSSCustomName, bool, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, ReleaseContext)
{
	TElClassHandle hoCtx;
	zval *oCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCtx) && (IS_OBJECT == Z_TYPE_P(oCtx)))
	{
		uint32_t u4OutResultRaw = 0;
		hoCtx = SBGetObjectHandle(oCtx TSRMLS_CC);
		SBCheckError(TElGSSWinAuthMechanism_ReleaseContext(SBGetObjectHandle(getThis() TSRMLS_CC), &hoCtx, &u4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oCtx, hoCtx TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, ImportName)
{
	char *sInputName;
	int sInputName_len;
	SBArrayZValInfo aiMechOID;
	TElClassHandle hoOutputName;
	zval *oOutputName;
	zval *zaMechOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO", &zaMechOID, &sInputName, &sInputName_len, &oOutputName, TElGSSCustomName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMechOID)) || (IS_ARRAY == Z_TYPE_P(zaMechOID)) || (IS_NULL == Z_TYPE_P(zaMechOID))) && PZVAL_IS_REF(oOutputName) && (IS_OBJECT == Z_TYPE_P(oOutputName)))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMechOID, &aiMechOID TSRMLS_CC)) RETURN_FALSE;
		hoOutputName = SBGetObjectHandle(oOutputName TSRMLS_CC);
		SBCheckError(TElGSSWinAuthMechanism_ImportName(SBGetObjectHandle(getThis() TSRMLS_CC), aiMechOID.data, aiMechOID.len, sInputName, (int32_t)sInputName_len, &hoOutputName, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMechOID);
		SBUpdateObjectHandle(oOutputName, hoOutputName TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, string, &TElGSSCustomName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, ReleaseName)
{
	TElClassHandle hoName;
	zval *oName;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oName, TElGSSCustomName_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oName) && (IS_OBJECT == Z_TYPE_P(oName)))
	{
		uint32_t u4OutResultRaw = 0;
		hoName = SBGetObjectHandle(oName TSRMLS_CC);
		SBCheckError(TElGSSWinAuthMechanism_ReleaseName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoName, &u4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oName, hoName TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TElGSSCustomName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, GetMIC)
{
	SBArrayZValInfo aiMessageBuffer;
	SBArrayZValInfo aiMessageToken;
	uint32_t _err;
	zval *oCtx;
	zval *zaMessageBuffer;
	zval *zaMessageToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &zaMessageBuffer, &zaMessageToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMessageBuffer)) || (IS_ARRAY == Z_TYPE_P(zaMessageBuffer)) || (IS_NULL == Z_TYPE_P(zaMessageBuffer))) && PZVAL_IS_REF(zaMessageToken) && ((IS_STRING == Z_TYPE_P(zaMessageToken)) || (IS_ARRAY == Z_TYPE_P(zaMessageToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMessageBuffer, &aiMessageBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMessageToken, &aiMessageToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSWinAuthMechanism_GetMIC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), aiMessageBuffer.data, aiMessageBuffer.len, aiMessageToken.data, &aiMessageToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaMessageToken, &aiMessageToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-601380314, 3, aiMessageToken.data, &aiMessageToken.len) TSRMLS_CC);
			((char *)aiMessageToken.data)[aiMessageToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiMessageToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiMessageBuffer);
		SBSetByteArrayToZVal(&aiMessageToken, zaMessageToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, VerifyMIC)
{
	SBArrayZValInfo aiMessageBuffer;
	SBArrayZValInfo aiMessageToken;
	zval *oCtx;
	zval *zaMessageBuffer;
	zval *zaMessageToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &zaMessageBuffer, &zaMessageToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMessageBuffer)) || (IS_ARRAY == Z_TYPE_P(zaMessageBuffer)) || (IS_NULL == Z_TYPE_P(zaMessageBuffer))) && ((IS_STRING == Z_TYPE_P(zaMessageToken)) || (IS_ARRAY == Z_TYPE_P(zaMessageToken)) || (IS_NULL == Z_TYPE_P(zaMessageToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMessageBuffer, &aiMessageBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMessageToken, &aiMessageToken TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGSSWinAuthMechanism_VerifyMIC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), aiMessageBuffer.data, aiMessageBuffer.len, aiMessageToken.data, aiMessageToken.len, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMessageBuffer);
		SBFreeArrayZValInfo(&aiMessageToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, get_AuthProtocols)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElGSSWinAuthProtocolsRaw fOutResultRaw = 0;
		SBCheckError(TElGSSWinAuthMechanism_get_AuthProtocols(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, set_AuthProtocols)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElGSSWinAuthMechanism_set_AuthProtocols(SBGetObjectHandle(getThis() TSRMLS_CC), (TElGSSWinAuthProtocolsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSWinAuthMechanism, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSWinAuthMechanism_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_Initialize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_AcquireCred, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, MechOID, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Ctx, TElGSSCustomContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_AcceptSecContext, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_OBJ_INFO(0, SourceName, TElGSSCustomName, 1)
	ZEND_ARG_TYPE_INFO(0, InputToken, 0, 1)
	ZEND_ARG_INFO(1, OutputToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_InitSecContext, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_OBJ_INFO(0, TargetName, TElGSSCustomName, 1)
	ZEND_ARG_INFO(0, DelegateCred)
	ZEND_ARG_TYPE_INFO(0, InputToken, 0, 1)
	ZEND_ARG_INFO(1, OutputToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_ReleaseContext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Ctx, TElGSSCustomContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_ImportName, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, MechOID, 0, 1)
	ZEND_ARG_INFO(0, InputName)
	ZEND_ARG_OBJ_INFO(1, OutputName, TElGSSCustomName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_ReleaseName, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Name, TElGSSCustomName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_GetMIC, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_TYPE_INFO(0, MessageBuffer, 0, 1)
	ZEND_ARG_INFO(1, MessageToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_VerifyMIC, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_TYPE_INFO(0, MessageBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, MessageToken, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_get_AuthProtocols, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism_set_AuthProtocols, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSWinAuthMechanism___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSWinAuthMechanism_methods[] = {
	PHP_ME(TElGSSWinAuthMechanism, Initialize, arginfo_TElGSSWinAuthMechanism_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, AcquireCred, arginfo_TElGSSWinAuthMechanism_AcquireCred, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, AcceptSecContext, arginfo_TElGSSWinAuthMechanism_AcceptSecContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, InitSecContext, arginfo_TElGSSWinAuthMechanism_InitSecContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, ReleaseContext, arginfo_TElGSSWinAuthMechanism_ReleaseContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, ImportName, arginfo_TElGSSWinAuthMechanism_ImportName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, ReleaseName, arginfo_TElGSSWinAuthMechanism_ReleaseName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, GetMIC, arginfo_TElGSSWinAuthMechanism_GetMIC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, VerifyMIC, arginfo_TElGSSWinAuthMechanism_VerifyMIC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, get_AuthProtocols, arginfo_TElGSSWinAuthMechanism_get_AuthProtocols, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, set_AuthProtocols, arginfo_TElGSSWinAuthMechanism_set_AuthProtocols, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSWinAuthMechanism, __construct, arginfo_TElGSSWinAuthMechanism___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSWinAuthMechanism(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSWinAuthMechanism_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSWinAuthMechanism", TElGSSWinAuthMechanism_methods);
	if (NULL == TElGSSBaseMechanism_ce_ptr)
		Register_TElGSSBaseMechanism(TSRMLS_C);
	TElGSSWinAuthMechanism_ce_ptr = zend_register_internal_class_ex(&ce, TElGSSBaseMechanism_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBGSSWinAuth_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBGSSWinAuth, GSS_MECH_NTLM, SB_GSS_MECH_NTLM, SB_GSS_MECH_NTLM);
	SB_REGISTER_STRING_CONSTANT(SBGSSWinAuth, GSS_MECH_KRB5, SB_GSS_MECH_KRB5, SB_GSS_MECH_KRB5);
}

void Register_SBGSSWinAuth_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElGSSWinAuthProtocols", NULL);
	TElGSSWinAuthProtocols_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TElGSSWinAuthProtocols_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElGSSWinAuthProtocols_ce_ptr, "apKerberos", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElGSSWinAuthProtocols_ce_ptr, "apNTLM", 2)
}
#endif
