#include "sbhttpcertretriever.h"

zend_class_entry *TElHTTPCertificateRetriever_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPCertificateRetriever, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPCertificateRetriever_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCertificateRetriever, RetrieveCertificate)
{
	char *sURL;
	int sURL_len;
	long fNameType;
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oCertificate, TElX509Certificate_ce_ptr, &fNameType, &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCertificateRetriever_RetrieveCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCertificateRetriever, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCertificateRetriever_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCertificateRetriever, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPCertificateRetriever_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCertificateRetriever, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCertificateRetriever_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCertificateRetriever_SupportsLocation, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCertificateRetriever_RetrieveCertificate, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCertificateRetriever_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCertificateRetriever_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCertificateRetriever___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPCertificateRetriever_methods[] = {
	PHP_ME(TElHTTPCertificateRetriever, SupportsLocation, arginfo_TElHTTPCertificateRetriever_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCertificateRetriever, RetrieveCertificate, arginfo_TElHTTPCertificateRetriever_RetrieveCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCertificateRetriever, get_HTTPClient, arginfo_TElHTTPCertificateRetriever_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCertificateRetriever, set_HTTPClient, arginfo_TElHTTPCertificateRetriever_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCertificateRetriever, __construct, arginfo_TElHTTPCertificateRetriever___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPCertificateRetriever(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPCertificateRetriever_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPCertificateRetriever", TElHTTPCertificateRetriever_methods);
	if (NULL == TElCustomCertificateRetriever_ce_ptr)
		Register_TElCustomCertificateRetriever(TSRMLS_C);
	TElHTTPCertificateRetriever_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCertificateRetriever_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPCertificateRetrieverFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPCertificateRetrieverFactory, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPCertificateRetrieverFactory_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCertificateRetrieverFactory, GetClientInstance)
{
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCertificateRetrieverFactory_GetClientInstance(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertificateRetriever_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCertificateRetrieverFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCertificateRetrieverFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCertificateRetrieverFactory_SupportsLocation, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCertificateRetrieverFactory_GetClientInstance, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCertificateRetrieverFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPCertificateRetrieverFactory_methods[] = {
	PHP_ME(TElHTTPCertificateRetrieverFactory, SupportsLocation, arginfo_TElHTTPCertificateRetrieverFactory_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCertificateRetrieverFactory, GetClientInstance, arginfo_TElHTTPCertificateRetrieverFactory_GetClientInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCertificateRetrieverFactory, __construct, arginfo_TElHTTPCertificateRetrieverFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPCertificateRetrieverFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPCertificateRetrieverFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPCertificateRetrieverFactory", TElHTTPCertificateRetrieverFactory_methods);
	if (NULL == TElCustomCertificateRetrieverFactory_ce_ptr)
		Register_TElCustomCertificateRetrieverFactory(TSRMLS_C);
	TElHTTPCertificateRetrieverFactory_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCertificateRetrieverFactory_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBHTTPCertRetriever, RegisterHTTPCertificateRetrieverFactory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBHTTPCertRetriever_RegisterHTTPCertificateRetrieverFactory() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBHTTPCertRetriever_Aliases(TSRMLS_D)
{
	if (NULL == TElHTTPCertificateRetriever_ce_ptr)
		Register_TElHTTPCertificateRetriever(TSRMLS_C);
	zend_register_class_alias("ElHTTPCertificateRetriever", TElHTTPCertificateRetriever_ce_ptr);
}

