#include "sbhttpocspclient.h"

zend_class_entry *TElHTTPOCSPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPOCSPClient, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPOCSPClient_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPOCSPClient, PerformRequest)
{
	SBArrayZValInfo aiReply;
	TElOCSPServerErrorRaw fServerResultRaw;
	uint32_t _err;
	zval *zaReply;
	zval *zfServerResult;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zfServerResult, &zaReply) == SUCCESS) && PZVAL_IS_REF(zfServerResult) && (IS_LONG == Z_TYPE_P(zfServerResult)) && PZVAL_IS_REF(zaReply) && ((IS_STRING == Z_TYPE_P(zaReply)) || (IS_ARRAY == Z_TYPE_P(zaReply))))
	{
		int32_t l4OutResultRaw = 0;
		fServerResultRaw = (TElOCSPServerErrorRaw)Z_LVAL_P(zfServerResult);
		if (!SBGetByteArrayFromZVal(zaReply, &aiReply TSRMLS_CC)) RETURN_FALSE;
		_err = TElHTTPOCSPClient_PerformRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &fServerResultRaw, aiReply.data, &aiReply.len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaReply, &aiReply TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(227724039, 2, aiReply.data, &aiReply.len) TSRMLS_CC);
			((char *)aiReply.data)[aiReply.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiReply);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zfServerResult, (long)fServerResultRaw);
		SBSetByteArrayToZVal(&aiReply, zaReply);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPOCSPClient, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPOCSPClient_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPOCSPClient, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPOCSPClient_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPOCSPClient, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPOCSPClient_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPOCSPClient_SupportsLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPOCSPClient_PerformRequest, 0, 0, 2)
	ZEND_ARG_INFO(1, ServerResult)
	ZEND_ARG_INFO(1, Reply)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPOCSPClient_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPOCSPClient_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPOCSPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPOCSPClient_methods[] = {
	PHP_ME(TElHTTPOCSPClient, SupportsLocation, arginfo_TElHTTPOCSPClient_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPOCSPClient, PerformRequest, arginfo_TElHTTPOCSPClient_PerformRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPOCSPClient, get_HTTPClient, arginfo_TElHTTPOCSPClient_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPOCSPClient, set_HTTPClient, arginfo_TElHTTPOCSPClient_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPOCSPClient, __construct, arginfo_TElHTTPOCSPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPOCSPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPOCSPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPOCSPClient", TElHTTPOCSPClient_methods);
	if (NULL == TElOCSPClient_ce_ptr)
		Register_TElOCSPClient(TSRMLS_C);
	TElHTTPOCSPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElOCSPClient_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPOCSPClientFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPOCSPClientFactory, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPOCSPClientFactory_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPOCSPClientFactory, GetClientInstance)
{
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPOCSPClientFactory_GetClientInstance(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPOCSPClientFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPOCSPClientFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPOCSPClientFactory_SupportsLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPOCSPClientFactory_GetClientInstance, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPOCSPClientFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPOCSPClientFactory_methods[] = {
	PHP_ME(TElHTTPOCSPClientFactory, SupportsLocation, arginfo_TElHTTPOCSPClientFactory_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPOCSPClientFactory, GetClientInstance, arginfo_TElHTTPOCSPClientFactory_GetClientInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPOCSPClientFactory, __construct, arginfo_TElHTTPOCSPClientFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPOCSPClientFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPOCSPClientFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPOCSPClientFactory", TElHTTPOCSPClientFactory_methods);
	if (NULL == TElCustomOCSPClientFactory_ce_ptr)
		Register_TElCustomOCSPClientFactory(TSRMLS_C);
	TElHTTPOCSPClientFactory_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomOCSPClientFactory_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBHTTPOCSPClient, RegisterHTTPOCSPClientFactory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBHTTPOCSPClient_RegisterHTTPOCSPClientFactory() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBHTTPOCSPClient_Aliases(TSRMLS_D)
{
	if (NULL == TElHTTPOCSPClient_ce_ptr)
		Register_TElHTTPOCSPClient(TSRMLS_C);
	zend_register_class_alias("ElHTTPOCSPClient", TElHTTPOCSPClient_ce_ptr);
}

