#include "sbjks.h"

SB_PHP_METHOD(TJKSEntry, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TJKSEntry));
		intern->len = sizeof(TJKSEntry);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TJKSEntry, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TJKSEntry));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TJKSEntry, get_Alias)
{
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TJKSEntry, set_Alias)
{
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *TJKSEntry_ce_ptr = NULL;

static zend_function_entry TJKSEntry_methods[] = {
	PHP_ME(TJKSEntry, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TJKSEntry, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TJKSEntry, get_Alias, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TJKSEntry, set_Alias, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TJKSEntry(TSRMLS_D)
{
	zend_class_entry ce;
	if (TJKSEntry_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TJKSEntry", TJKSEntry_methods);
	TJKSEntry_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void SB_CALLBACK TElJKSPasswordEventRaw(void * _ObjectData, const char * pcAlias, int32_t szAlias, char * pcPassword, int32_t * szPassword, int8_t * OutResult)
{
	zval **params[2];
	zval * zAlias;
	zval * zPassword;
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zAlias);
	ZVAL_STRINGL(zAlias, pcAlias, szAlias, 1);
	MAKE_STD_ZVAL(zPassword);
	ZVAL_STRINGL(zPassword, pcPassword, *szPassword, 1);

	params[0] = &zAlias;
	params[1] = &zPassword;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zAlias);
	SBCheckError(SBSetEventReturnStringA(2, Z_STRVAL_P(zPassword), (int32_t)Z_STRLEN_P(zPassword)) TSRMLS_CC);
	zval_ptr_dtor(&zPassword);
	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

void SB_CALLBACK TElJKSAliasNeededEventRaw(void * _ObjectData, TElX509CertificateHandle Cert, char * pcAlias, int32_t * szAlias, int8_t * OutResult)
{
	zval **params[2];
	zval * zCert;
	zval * zAlias;
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);
	MAKE_STD_ZVAL(zAlias);
	ZVAL_STRINGL(zAlias, pcAlias, *szAlias, 1);

	params[0] = &zCert;
	params[1] = &zAlias;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zCert);
	SBCheckError(SBSetEventReturnStringA(2, Z_STRVAL_P(zAlias), (int32_t)Z_STRLEN_P(zAlias)) TSRMLS_CC);
	zval_ptr_dtor(&zAlias);
	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

zend_class_entry *TElJKS_ce_ptr = NULL;

SB_PHP_METHOD(TElJKS, LoadFromStream)
{
	char *sJKS_Pass;
	int sJKS_Pass_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStream, TStream_ce_ptr, &sJKS_Pass, &sJKS_Pass_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJKS_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sJKS_Pass, (int32_t)sJKS_Pass_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, LoadFromBuffer)
{
	char *sJKS_Pass;
	int sJKS_Pass_len;
	int32_t l4BufferPosRaw;
	long l4BufferSize;
	SBArrayZValInfo piSrc_Ptr;
	zval *zl4BufferPos;
	zval *zpSrc_Ptr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzs", &zpSrc_Ptr, &l4BufferSize, &zl4BufferPos, &sJKS_Pass, &sJKS_Pass_len) == SUCCESS) && ((Z_TYPE_P(zpSrc_Ptr) == IS_STRING) || (Z_TYPE_P(zpSrc_Ptr) == IS_ARRAY) || (Z_TYPE_P(zpSrc_Ptr) == IS_NULL) || ((Z_TYPE_P(zpSrc_Ptr) == IS_OBJECT) && (Z_OBJCE_P(zpSrc_Ptr) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4BufferPos) && (IS_LONG == Z_TYPE_P(zl4BufferPos)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpSrc_Ptr, &piSrc_Ptr TSRMLS_CC)) RETURN_FALSE;
		l4BufferPosRaw = (int32_t)Z_LVAL_P(zl4BufferPos);
		SBCheckError(TElJKS_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piSrc_Ptr.data, (int32_t)l4BufferSize, &l4BufferPosRaw, sJKS_Pass, (int32_t)sJKS_Pass_len, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piSrc_Ptr);
		ZVAL_LONG(zl4BufferPos, (long)l4BufferPosRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, &integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, GetSaveBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJKS_GetSaveBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, SaveToStream)
{
	char *sJKS_Pass;
	int sJKS_Pass_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStream, TStream_ce_ptr, &sJKS_Pass, &sJKS_Pass_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJKS_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sJKS_Pass, (int32_t)sJKS_Pass_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, SaveToBuffer)
{
	char *sJKS_Pass;
	int sJKS_Pass_len;
	int32_t l4BufferPosRaw;
	long l4BufferSize;
	SBArrayZValInfo aiDstBuffer;
	uint32_t _err;
	zval *zaDstBuffer;
	zval *zl4BufferPos;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzs", &zaDstBuffer, &l4BufferSize, &zl4BufferPos, &sJKS_Pass, &sJKS_Pass_len) == SUCCESS) && PZVAL_IS_REF(zaDstBuffer) && ((IS_STRING == Z_TYPE_P(zaDstBuffer)) || (IS_ARRAY == Z_TYPE_P(zaDstBuffer))) && PZVAL_IS_REF(zl4BufferPos) && (IS_LONG == Z_TYPE_P(zl4BufferPos)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaDstBuffer, &aiDstBuffer TSRMLS_CC)) RETURN_FALSE;
		l4BufferPosRaw = (int32_t)Z_LVAL_P(zl4BufferPos);
		_err = TElJKS_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiDstBuffer.data, &aiDstBuffer.len, (int32_t)l4BufferSize, &l4BufferPosRaw, sJKS_Pass, (int32_t)sJKS_Pass_len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaDstBuffer, &aiDstBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1956113573, 1, aiDstBuffer.data, &aiDstBuffer.len) TSRMLS_CC);
			((char *)aiDstBuffer.data)[aiDstBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiDstBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiDstBuffer, zaDstBuffer);
		ZVAL_LONG(zl4BufferPos, (long)l4BufferPosRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, GetPrivateKey)
{
	char *sPass;
	int sPass_len;
	long l4Index;
	SBArrayZValInfo aiKey;
	uint32_t _err;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsz", &l4Index, &sPass, &sPass_len, &zaKey) == SUCCESS) && PZVAL_IS_REF(zaKey) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		_err = TElJKS_GetPrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sPass, (int32_t)sPass_len, aiKey.data, &aiKey.len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaKey, &aiKey TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1872655427, 3, aiKey.data, &aiKey.len) TSRMLS_CC);
			((char *)aiKey.data)[aiKey.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiKey);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiKey, zaKey);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, SetPrivateKey)
{
	char *sPass;
	int sPass_len;
	long l4Index;
	SBArrayZValInfo aiKey;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsz", &l4Index, &sPass, &sPass_len, &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElJKS_SetPrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sPass, (int32_t)sPass_len, aiKey.data, aiKey.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, AddPrivateKey)
{
	char *sPass;
	int sPass_len;
	SBArrayZValInfo aiKey;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sPass, &sPass_len, &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElJKS_AddPrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), sPass, (int32_t)sPass_len, aiKey.data, aiKey.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, GetKeyCertificate)
{
	long l4Cert_Index;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l4Cert_Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJKS_GetKeyCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4Cert_Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, AddKeyCertificate)
{
	long l4Index;
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJKS_AddKeyCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oCert TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, DelKeyCertificate)
{
	long l4Cert_Index;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l4Cert_Index) == SUCCESS)
	{
		SBCheckError(TElJKS_DelKeyCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4Cert_Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, GetTrustedCertificate)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJKS_GetTrustedCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, AddTrustedCertificate)
{
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJKS_AddTrustedCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, DelTrustedCertificate)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElJKS_DelTrustedCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, GetAlias)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElJKS_GetAlias(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1384838685, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, SetAlias)
{
	char *sAlias;
	int sAlias_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sAlias, &sAlias_len) == SUCCESS)
	{
		SBCheckError(TElJKS_SetAlias(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sAlias, (int32_t)sAlias_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, get_Entries_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJKS_get_Entries_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, get_PrivateKeyCert_Count)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJKS_get_PrivateKeyCert_Count(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, get_IsPrivateKey)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJKS_get_IsPrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, get_IgnoreBadStorageSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJKS_get_IgnoreBadStorageSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, set_IgnoreBadStorageSignature)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElJKS_set_IgnoreBadStorageSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJKS, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJKS_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, JKS_Pass)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_LoadFromBuffer, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Src_Ptr, 0, 1)
	ZEND_ARG_INFO(0, BufferSize)
	ZEND_ARG_INFO(1, BufferPos)
	ZEND_ARG_INFO(0, JKS_Pass)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_GetSaveBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_SaveToStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, JKS_Pass)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_SaveToBuffer, 0, 0, 4)
	ZEND_ARG_INFO(1, DstBuffer)
	ZEND_ARG_INFO(0, BufferSize)
	ZEND_ARG_INFO(1, BufferPos)
	ZEND_ARG_INFO(0, JKS_Pass)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_GetPrivateKey, 0, 0, 3)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Pass)
	ZEND_ARG_INFO(1, Key)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_SetPrivateKey, 0, 0, 3)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Pass)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_AddPrivateKey, 0, 0, 2)
	ZEND_ARG_INFO(0, Pass)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_GetKeyCertificate, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Cert_Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_AddKeyCertificate, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_DelKeyCertificate, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Cert_Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_GetTrustedCertificate, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_AddTrustedCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_DelTrustedCertificate, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_GetAlias, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_SetAlias, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Alias)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_get_Entries_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_get_PrivateKeyCert_Count, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_get_IsPrivateKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_get_IgnoreBadStorageSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS_set_IgnoreBadStorageSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJKS___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElJKS_methods[] = {
	PHP_ME(TElJKS, LoadFromStream, arginfo_TElJKS_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, LoadFromBuffer, arginfo_TElJKS_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, GetSaveBufferSize, arginfo_TElJKS_GetSaveBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, SaveToStream, arginfo_TElJKS_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, SaveToBuffer, arginfo_TElJKS_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, GetPrivateKey, arginfo_TElJKS_GetPrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, SetPrivateKey, arginfo_TElJKS_SetPrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, AddPrivateKey, arginfo_TElJKS_AddPrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, GetKeyCertificate, arginfo_TElJKS_GetKeyCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, AddKeyCertificate, arginfo_TElJKS_AddKeyCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, DelKeyCertificate, arginfo_TElJKS_DelKeyCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, GetTrustedCertificate, arginfo_TElJKS_GetTrustedCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, AddTrustedCertificate, arginfo_TElJKS_AddTrustedCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, DelTrustedCertificate, arginfo_TElJKS_DelTrustedCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, GetAlias, arginfo_TElJKS_GetAlias, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, SetAlias, arginfo_TElJKS_SetAlias, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, get_Entries_Count, arginfo_TElJKS_get_Entries_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, get_PrivateKeyCert_Count, arginfo_TElJKS_get_PrivateKeyCert_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, get_IsPrivateKey, arginfo_TElJKS_get_IsPrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, get_IgnoreBadStorageSignature, arginfo_TElJKS_get_IgnoreBadStorageSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, set_IgnoreBadStorageSignature, arginfo_TElJKS_set_IgnoreBadStorageSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElJKS, __construct, arginfo_TElJKS___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElJKS(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElJKS_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElJKS", TElJKS_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElJKS_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBJKS_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBJKS, E_JKS_FORMAT_ERROR, SB_E_JKS_FORMAT_ERROR, SB_E_JKS_FORMAT_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBJKS, E_JKS_READ_ERROR, SB_E_JKS_READ_ERROR, SB_E_JKS_READ_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBJKS, E_JKS_WRITE_ERROR, SB_E_JKS_WRITE_ERROR, SB_E_JKS_WRITE_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBJKS, E_JKS_VERSION_ERROR, SB_E_JKS_VERSION_ERROR, SB_E_JKS_VERSION_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBJKS, E_JKS_KEY_FORMAT_ERROR, SB_E_JKS_KEY_FORMAT_ERROR, SB_E_JKS_KEY_FORMAT_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBJKS, E_JKS_UNKNOWN_CERT, SB_E_JKS_UNKNOWN_CERT, SB_E_JKS_UNKNOWN_CERT);
	SB_REGISTER_LONG_CONSTANT(SBJKS, E_JKS_CHECKSUM, SB_E_JKS_CHECKSUM, SB_E_JKS_CHECKSUM);
	SB_REGISTER_LONG_CONSTANT(SBJKS, E_JKS_SIGNATURE, SB_E_JKS_SIGNATURE, SB_E_JKS_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBJKS, E_JKS_NO_SPACE, SB_E_JKS_NO_SPACE, SB_E_JKS_NO_SPACE);
}

void Register_SBJKS_Aliases(TSRMLS_D)
{
	if (NULL == TElJKS_ce_ptr)
		Register_TElJKS(TSRMLS_C);
	zend_register_class_alias("ElJKS", TElJKS_ce_ptr);
}

