#include "sbjson.h"

zend_class_entry *TSBJsonType_ce_ptr = NULL;

zend_class_entry *TElJsonEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElJsonEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElJsonEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonEntity, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonEntity_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonEntity_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElJsonEntity_methods[] = {
	PHP_ME(TElJsonEntity, Assign, arginfo_TElJsonEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonEntity, Clone, arginfo_TElJsonEntity_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonEntity, __construct, arginfo_TElJsonEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElJsonEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElJsonEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElJsonEntity", TElJsonEntity_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElJsonEntity_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElJsonArray_ce_ptr = NULL;

SB_PHP_METHOD(TElJsonArray, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElJsonArray_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonArray_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, Append)
{
	char *sValue;
	double dValue;
	int sValue_len;
	long l4Value;
	zend_bool bValue;
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElJsonEntity_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonArray_Append(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonArray_Append_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonArray_Append_2(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonArray_Append_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonArray_Append_4(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonArray_Append_5(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElJsonEntity) or (integer) or (double) or (bool) or (string) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElJsonArray_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElJsonArray_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, GetArray)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonArray_GetArray(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonArray_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, GetArrayIfExists)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonArray_GetArrayIfExists(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonArray_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, GetBooleanValue)
{
	long l4Index;
	zend_bool bDefault;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonArray_GetBooleanValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Index, &bDefault) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonArray_GetBooleanValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bDefault, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, GetDoubleValue)
{
	double dDefault;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElJsonArray_GetDoubleValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ld", &l4Index, &dDefault) == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElJsonArray_GetDoubleValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (double)dDefault, &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, GetIntegerValue)
{
	long l4Index;
	long l8Default;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElJsonArray_GetIntegerValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l8Default) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElJsonArray_GetIntegerValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int64_t)l8Default, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, GetObject)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonArray_GetObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, GetObjectIfExists)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonArray_GetObjectIfExists(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, GetStringValue)
{
	char *sDefault;
	int sDefault_len;
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElJsonArray_GetStringValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1166726195, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sDefault, &sDefault_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElJsonArray_GetStringValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sDefault, (int32_t)sDefault_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1190904774, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, Insert)
{
	char *sValue;
	double dValue;
	int sValue_len;
	long l4Index;
	long l4Value;
	zend_bool bValue;
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oValue, TElJsonEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElJsonArray_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElJsonArray_Insert_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ld", &l4Index, &dValue) == SUCCESS)
	{
		SBCheckError(TElJsonArray_Insert_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (double)dValue) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElJsonArray_Insert_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bValue) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElJsonArray_Insert_4(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElJsonArray_Insert_5(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElJsonEntity) or (integer, integer) or (integer, double) or (integer, bool) or (integer, string) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, IsNullValue)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonArray_IsNullValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, SetBooleanValue)
{
	long l4Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElJsonArray_SetBooleanValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, SetDoubleValue)
{
	double dValue;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ld", &l4Index, &dValue) == SUCCESS)
	{
		SBCheckError(TElJsonArray_SetDoubleValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, SetIntegerValue)
{
	long l4Index;
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l8Value) == SUCCESS)
	{
		SBCheckError(TElJsonArray_SetIntegerValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, SetNullValue)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElJsonArray_SetNullValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, SetStringValue)
{
	char *sValue;
	int sValue_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElJsonArray_SetStringValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, get_Item)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonArray_get_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, set_Item)
{
	long l4Index;
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oValue, TElJsonEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElJsonArray_set_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElJsonEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, get_Length)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonArray_get_Length(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, set_Length)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElJsonArray_set_Length(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, get_OwnsItems)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonArray_get_OwnsItems(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonArray, __construct)
{
	zend_bool bOwnsItems;
	zval *oOriginal;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnsItems) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonArray_Create((int8_t)bOwnsItems, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOriginal, TElJsonArray_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonArray_Create_1(SBGetObjectHandle(oOriginal TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (TElJsonArray)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_Append, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_GetArray, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_GetArrayIfExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_GetBooleanValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Default)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_GetDoubleValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Default)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_GetIntegerValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Default)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_GetObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_GetObjectIfExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_GetStringValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Default)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_Insert, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_IsNullValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_SetBooleanValue, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_SetDoubleValue, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_SetIntegerValue, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_SetNullValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_SetStringValue, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_get_Item, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_set_Item, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, Value, TElJsonEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_get_Length, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_set_Length, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray_get_OwnsItems, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonArray___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OwnsItems_or_Original, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElJsonArray_methods[] = {
	PHP_ME(TElJsonArray, Assign, arginfo_TElJsonArray_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, Clone, arginfo_TElJsonArray_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, Append, arginfo_TElJsonArray_Append, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, Clear, arginfo_TElJsonArray_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, Delete, arginfo_TElJsonArray_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, GetArray, arginfo_TElJsonArray_GetArray, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, GetArrayIfExists, arginfo_TElJsonArray_GetArrayIfExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, GetBooleanValue, arginfo_TElJsonArray_GetBooleanValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, GetDoubleValue, arginfo_TElJsonArray_GetDoubleValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, GetIntegerValue, arginfo_TElJsonArray_GetIntegerValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, GetObject, arginfo_TElJsonArray_GetObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, GetObjectIfExists, arginfo_TElJsonArray_GetObjectIfExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, GetStringValue, arginfo_TElJsonArray_GetStringValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, Insert, arginfo_TElJsonArray_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, IsNullValue, arginfo_TElJsonArray_IsNullValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, SetBooleanValue, arginfo_TElJsonArray_SetBooleanValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, SetDoubleValue, arginfo_TElJsonArray_SetDoubleValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, SetIntegerValue, arginfo_TElJsonArray_SetIntegerValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, SetNullValue, arginfo_TElJsonArray_SetNullValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, SetStringValue, arginfo_TElJsonArray_SetStringValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, get_Item, arginfo_TElJsonArray_get_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, set_Item, arginfo_TElJsonArray_set_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, get_Length, arginfo_TElJsonArray_get_Length, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, set_Length, arginfo_TElJsonArray_set_Length, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, get_OwnsItems, arginfo_TElJsonArray_get_OwnsItems, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonArray, __construct, arginfo_TElJsonArray___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElJsonArray(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElJsonArray_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElJsonArray", TElJsonArray_methods);
	if (NULL == TElJsonEntity_ce_ptr)
		Register_TElJsonEntity(TSRMLS_C);
	TElJsonArray_ce_ptr = zend_register_internal_class_ex(&ce, TElJsonEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElJsonObject_ce_ptr = NULL;

SB_PHP_METHOD(TElJsonObject, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElJsonObject_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElJsonObject_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElJsonObject_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, GetArray)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_GetArray(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonArray_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, GetArrayIfExists)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_GetArrayIfExists(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonArray_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, GetBooleanValue)
{
	char *sName;
	int sName_len;
	zend_bool bDefault;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonObject_GetBooleanValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sName, &sName_len, &bDefault) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonObject_GetBooleanValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bDefault, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, GetDoubleValue)
{
	char *sName;
	double dDefault;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElJsonObject_GetDoubleValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sd", &sName, &sName_len, &dDefault) == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElJsonObject_GetDoubleValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (double)dDefault, &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, GetIntegerValue)
{
	char *sName;
	int sName_len;
	long l8Default;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElJsonObject_GetIntegerValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sName, &sName_len, &l8Default) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElJsonObject_GetIntegerValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int64_t)l8Default, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, GetObject)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_GetObject(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, GetObjectIfExists)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_GetObjectIfExists(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, GetStringValue)
{
	char *sDefault;
	char *sName;
	int sDefault_len;
	int sName_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElJsonObject_GetStringValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1670015003, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sDefault, &sDefault_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElJsonObject_GetStringValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sDefault, (int32_t)sDefault_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-780686030, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, GetValueIfExists)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_GetValueIfExists(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, IndexOf)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonObject_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, IsNullValue)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonObject_IsNullValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, Remove)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonObject_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, NameAtIndex)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElJsonObject_NameAtIndex(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-929865159, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, ValueAtIndex)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_ValueAtIndex(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, ValueExists)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonObject_ValueExists(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, SetBooleanValue)
{
	char *sName;
	int sName_len;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sName, &sName_len, &bValue) == SUCCESS)
	{
		SBCheckError(TElJsonObject_SetBooleanValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, SetDoubleValue)
{
	char *sName;
	double dValue;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sd", &sName, &sName_len, &dValue) == SUCCESS)
	{
		SBCheckError(TElJsonObject_SetDoubleValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, SetNullValue)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		SBCheckError(TElJsonObject_SetNullValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, SetIntegerValue)
{
	char *sName;
	int sName_len;
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sName, &sName_len, &l8Value) == SUCCESS)
	{
		SBCheckError(TElJsonObject_SetIntegerValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, SetStringValue)
{
	char *sName;
	char *sValue;
	int sName_len;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElJsonObject_SetStringValue(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElJsonObject_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, get_OwnsValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonObject_get_OwnsValues(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, get_Value)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, set_Value)
{
	char *sName;
	int sName_len;
	zval *oAValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sName, &sName_len, &oAValue, TElJsonEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElJsonObject_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oAValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElJsonEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonObject, __construct)
{
	zend_bool bOwnsValues;
	zval *oOriginal;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnsValues) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_Create((int8_t)bOwnsValues, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOriginal, TElJsonObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonObject_Create_1(SBGetObjectHandle(oOriginal TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (TElJsonObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_GetArray, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_GetArrayIfExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_GetBooleanValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Default)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_GetDoubleValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Default)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_GetIntegerValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Default)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_GetObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_GetObjectIfExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_GetStringValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Default)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_GetValueIfExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_IndexOf, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_IsNullValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_NameAtIndex, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_ValueAtIndex, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_ValueExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_SetBooleanValue, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_SetDoubleValue, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_SetNullValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_SetIntegerValue, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_SetStringValue, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_get_OwnsValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_get_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject_set_Value, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_OBJ_INFO(0, AValue, TElJsonEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonObject___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OwnsValues_or_Original, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElJsonObject_methods[] = {
	PHP_ME(TElJsonObject, Assign, arginfo_TElJsonObject_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, Clone, arginfo_TElJsonObject_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, Clear, arginfo_TElJsonObject_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, Delete, arginfo_TElJsonObject_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, GetArray, arginfo_TElJsonObject_GetArray, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, GetArrayIfExists, arginfo_TElJsonObject_GetArrayIfExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, GetBooleanValue, arginfo_TElJsonObject_GetBooleanValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, GetDoubleValue, arginfo_TElJsonObject_GetDoubleValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, GetIntegerValue, arginfo_TElJsonObject_GetIntegerValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, GetObject, arginfo_TElJsonObject_GetObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, GetObjectIfExists, arginfo_TElJsonObject_GetObjectIfExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, GetStringValue, arginfo_TElJsonObject_GetStringValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, GetValueIfExists, arginfo_TElJsonObject_GetValueIfExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, IndexOf, arginfo_TElJsonObject_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, IsNullValue, arginfo_TElJsonObject_IsNullValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, Remove, arginfo_TElJsonObject_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, NameAtIndex, arginfo_TElJsonObject_NameAtIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, ValueAtIndex, arginfo_TElJsonObject_ValueAtIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, ValueExists, arginfo_TElJsonObject_ValueExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, SetBooleanValue, arginfo_TElJsonObject_SetBooleanValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, SetDoubleValue, arginfo_TElJsonObject_SetDoubleValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, SetNullValue, arginfo_TElJsonObject_SetNullValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, SetIntegerValue, arginfo_TElJsonObject_SetIntegerValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, SetStringValue, arginfo_TElJsonObject_SetStringValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, get_Count, arginfo_TElJsonObject_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, get_OwnsValues, arginfo_TElJsonObject_get_OwnsValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, get_Value, arginfo_TElJsonObject_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, set_Value, arginfo_TElJsonObject_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonObject, __construct, arginfo_TElJsonObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElJsonObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElJsonObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElJsonObject", TElJsonObject_methods);
	if (NULL == TElJsonEntity_ce_ptr)
		Register_TElJsonEntity(TSRMLS_C);
	TElJsonObject_ce_ptr = zend_register_internal_class_ex(&ce, TElJsonEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElJsonValue_ce_ptr = NULL;

SB_PHP_METHOD(TElJsonValue, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElJsonValue_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonValue_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_AsBoolean)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonValue_get_AsBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, set_AsBoolean)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElJsonValue_set_AsBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_AsInteger)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElJsonValue_get_AsInteger(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, set_AsInteger)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElJsonValue_set_AsInteger(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_AsNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElJsonValue_get_AsNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, set_AsNumber)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElJsonValue_set_AsNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_AsString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElJsonValue_get_AsString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(722361528, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, set_AsString)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElJsonValue_set_AsString(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_IsBoolean)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonValue_get_IsBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_IsNull)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonValue_get_IsNull(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, set_IsNull)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElJsonValue_set_IsNull(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_IsNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonValue_get_IsNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_IsString)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElJsonValue_get_IsString(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElJsonValue_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1465167972, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, get_ValueType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBJsonTypeRaw fOutResultRaw = 0;
		SBCheckError(TElJsonValue_get_ValueType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElJsonValue, __construct)
{
	char *sValue;
	double dValue;
	int sValue_len;
	long l8Value;
	zend_bool bValue;
	zval *oOriginal;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonValue_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOriginal, TElJsonValue_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonValue_Create_1(SBGetObjectHandle(oOriginal TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonValue_Create_2((int8_t)bValue, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonValue_Create_3((double)dValue, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonValue_Create_4((int64_t)l8Value, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElJsonValue_Create_5(sValue, (int32_t)sValue_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElJsonValue) or (bool) or (double) or (integer) or (string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_AsBoolean, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_set_AsBoolean, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_AsInteger, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_set_AsInteger, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_AsNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_set_AsNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_AsString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_set_AsString, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_IsBoolean, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_IsNull, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_set_IsNull, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_IsNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_IsString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue_get_ValueType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElJsonValue___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Original_or_Value, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElJsonValue_methods[] = {
	PHP_ME(TElJsonValue, Assign, arginfo_TElJsonValue_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, Clone, arginfo_TElJsonValue_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_AsBoolean, arginfo_TElJsonValue_get_AsBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, set_AsBoolean, arginfo_TElJsonValue_set_AsBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_AsInteger, arginfo_TElJsonValue_get_AsInteger, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, set_AsInteger, arginfo_TElJsonValue_set_AsInteger, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_AsNumber, arginfo_TElJsonValue_get_AsNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, set_AsNumber, arginfo_TElJsonValue_set_AsNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_AsString, arginfo_TElJsonValue_get_AsString, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, set_AsString, arginfo_TElJsonValue_set_AsString, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_IsBoolean, arginfo_TElJsonValue_get_IsBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_IsNull, arginfo_TElJsonValue_get_IsNull, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, set_IsNull, arginfo_TElJsonValue_set_IsNull, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_IsNumber, arginfo_TElJsonValue_get_IsNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_IsString, arginfo_TElJsonValue_get_IsString, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_Value, arginfo_TElJsonValue_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, get_ValueType, arginfo_TElJsonValue_get_ValueType, ZEND_ACC_PUBLIC)
	PHP_ME(TElJsonValue, __construct, arginfo_TElJsonValue___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElJsonValue(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElJsonValue_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElJsonValue", TElJsonValue_methods);
	if (NULL == TElJsonEntity_ce_ptr)
		Register_TElJsonEntity(TSRMLS_C);
	TElJsonValue_ce_ptr = zend_register_internal_class_ex(&ce, TElJsonEntity_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBJSON, NewArray)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBJSON_NewArray(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonArray_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBJSON, NewNull)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBJSON_NewNull(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBJSON, NewObject)
{
	zend_bool bOwnsValues;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnsValues) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBJSON_NewObject((int8_t)bOwnsValues, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBJSON, NewValue)
{
	char *sS;
	double dE;
	int sS_len;
	long l8I;
	zend_bool bB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bB) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBJSON_NewValue((int8_t)bB, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dE) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBJSON_NewValue_1((double)dE, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8I) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBJSON_NewValue_2((int64_t)l8I, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBJSON_NewValue_3(sS, (int32_t)sS_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (double) or (integer) or (string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBJSON, Read)
{
	char *sText;
	int sText_len;
	long l4Length;
	long l4StartIndex;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sText, &sText_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBJSON_Read(sText, (int32_t)sText_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBJSON_Read_1(aiBuffer.data, aiBuffer.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4StartIndex, &l4Length) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBJSON_Read_2(aiBuffer.data, aiBuffer.len, (int32_t)l4StartIndex, (int32_t)l4Length, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (array of byte|string|NULL) or (array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBJSON, Write)
{
	char *cIndentChar;
	int cIndentChar_len;
	long l4CharsPerIndentLevel;
	long l4StartIndex;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *oEntity;
	zval *oStream;
	zval *zaBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oEntity, TElJsonEntity_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBJSON_Write(SBGetObjectHandle(oEntity TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1306413420, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oEntity, TElJsonEntity_ce_ptr, &cIndentChar, &cIndentChar_len, &l4CharsPerIndentLevel) == SUCCESS) && (1 == cIndentChar_len))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBJSON_Write_1(SBGetObjectHandle(oEntity TSRMLS_CC), cIndentChar[0], (int32_t)l4CharsPerIndentLevel, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(951428880, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zl", &oEntity, TElJsonEntity_ce_ptr, &zaBuffer, &l4StartIndex) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBJSON_Write_2(SBGetObjectHandle(oEntity TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4StartIndex, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1088547202, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slzl", &oEntity, TElJsonEntity_ce_ptr, &cIndentChar, &cIndentChar_len, &l4CharsPerIndentLevel, &zaBuffer, &l4StartIndex) == SUCCESS) && (1 == cIndentChar_len) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBJSON_Write_3(SBGetObjectHandle(oEntity TSRMLS_CC), cIndentChar[0], (int32_t)l4CharsPerIndentLevel, aiBuffer.data, &aiBuffer.len, (int32_t)l4StartIndex, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-562286490, 3, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oEntity, TElJsonEntity_ce_ptr, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBJSON_Write_4(SBGetObjectHandle(oEntity TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slO!", &oEntity, TElJsonEntity_ce_ptr, &cIndentChar, &cIndentChar_len, &l4CharsPerIndentLevel, &oStream, TStream_ce_ptr) == SUCCESS) && (1 == cIndentChar_len))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBJSON_Write_5(SBGetObjectHandle(oEntity TSRMLS_CC), cIndentChar[0], (int32_t)l4CharsPerIndentLevel, SBGetObjectHandle(oStream TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElJsonEntity) or (TElJsonEntity, char, integer) or (TElJsonEntity, &array of byte|string, integer) or (TElJsonEntity, char, integer, &array of byte|string, integer) or (TElJsonEntity, TStream) or (TElJsonEntity, char, integer, TStream)" TSRMLS_CC);
	}
}

void Register_SBJSON_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBJsonType", NULL);
	TSBJsonType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBJsonType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBJsonType_ce_ptr, "jsonNull", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBJsonType_ce_ptr, "jsonBoolean", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBJsonType_ce_ptr, "jsonString", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBJsonType_ce_ptr, "jsonNumber", 3)
}

