#include "sbldapcertretriever.h"

zend_class_entry *TElLDAPCertificateRetriever_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPCertificateRetriever, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPCertificateRetriever_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertificateRetriever, RetrieveCertificate)
{
	char *sURL;
	int sURL_len;
	long fNameType;
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oCertificate, TElX509Certificate_ce_ptr, &fNameType, &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCertificateRetriever_RetrieveCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertificateRetriever, get_LDAPSClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCertificateRetriever_get_LDAPSClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertificateRetriever, get_ServerList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCertificateRetriever_get_ServerList(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertificateRetriever, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCertificateRetriever_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertificateRetriever_SupportsLocation, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertificateRetriever_RetrieveCertificate, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertificateRetriever_get_LDAPSClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertificateRetriever_get_ServerList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertificateRetriever___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPCertificateRetriever_methods[] = {
	PHP_ME(TElLDAPCertificateRetriever, SupportsLocation, arginfo_TElLDAPCertificateRetriever_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertificateRetriever, RetrieveCertificate, arginfo_TElLDAPCertificateRetriever_RetrieveCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertificateRetriever, get_LDAPSClient, arginfo_TElLDAPCertificateRetriever_get_LDAPSClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertificateRetriever, get_ServerList, arginfo_TElLDAPCertificateRetriever_get_ServerList, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertificateRetriever, __construct, arginfo_TElLDAPCertificateRetriever___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPCertificateRetriever(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPCertificateRetriever_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPCertificateRetriever", TElLDAPCertificateRetriever_methods);
	if (NULL == TElCustomCertificateRetriever_ce_ptr)
		Register_TElCustomCertificateRetriever(TSRMLS_C);
	TElLDAPCertificateRetriever_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCertificateRetriever_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPCertificateRetrieverFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPCertificateRetrieverFactory, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPCertificateRetrieverFactory_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertificateRetrieverFactory, GetClientInstance)
{
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCertificateRetrieverFactory_GetClientInstance(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertificateRetriever_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCertificateRetrieverFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCertificateRetrieverFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertificateRetrieverFactory_SupportsLocation, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertificateRetrieverFactory_GetClientInstance, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCertificateRetrieverFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPCertificateRetrieverFactory_methods[] = {
	PHP_ME(TElLDAPCertificateRetrieverFactory, SupportsLocation, arginfo_TElLDAPCertificateRetrieverFactory_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertificateRetrieverFactory, GetClientInstance, arginfo_TElLDAPCertificateRetrieverFactory_GetClientInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCertificateRetrieverFactory, __construct, arginfo_TElLDAPCertificateRetrieverFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPCertificateRetrieverFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPCertificateRetrieverFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPCertificateRetrieverFactory", TElLDAPCertificateRetrieverFactory_methods);
	if (NULL == TElCustomCertificateRetrieverFactory_ce_ptr)
		Register_TElCustomCertificateRetrieverFactory(TSRMLS_C);
	TElLDAPCertificateRetrieverFactory_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCertificateRetrieverFactory_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBLDAPCertRetriever, RegisterLDAPCertificateRetrieverFactory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBLDAPCertRetriever_RegisterLDAPCertificateRetrieverFactory() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBLDAPCertRetriever_Aliases(TSRMLS_D)
{
	if (NULL == TElLDAPCertificateRetriever_ce_ptr)
		Register_TElLDAPCertificateRetriever(TSRMLS_C);
	zend_register_class_alias("ElLDAPCertificateRetriever", TElLDAPCertificateRetriever_ce_ptr);
}
