#include "sbldapcrl.h"

zend_class_entry *TElLDAPCRLRetriever_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPCRLRetriever, Supports)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sLocation, &sLocation_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPCRLRetriever_Supports(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCRLRetriever, GetCRL)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	zval *oCACertificate;
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ls", &oCertificate, TElX509Certificate_ce_ptr, &oCACertificate, TElX509Certificate_ce_ptr, &fNameType, &sLocation, &sLocation_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCRLRetriever_GetCRL(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), SBGetObjectHandle(oCACertificate TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateRevocationList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElX509Certificate, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCRLRetriever, get_LDAPSClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCRLRetriever_get_LDAPSClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCRLRetriever, get_ServerList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCRLRetriever_get_ServerList(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCRLRetriever, set_ServerList)
{
	zval *oValue;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElLDAPCRLRetriever_set_ServerList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElLDAPCRLRetriever, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCRLRetriever_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCRLRetriever_Supports, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCRLRetriever_GetCRL, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_OBJ_INFO(0, CACertificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCRLRetriever_get_LDAPSClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCRLRetriever_get_ServerList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCRLRetriever_set_ServerList, 0, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Value, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Value, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCRLRetriever___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPCRLRetriever_methods[] = {
	PHP_ME(TElLDAPCRLRetriever, Supports, arginfo_TElLDAPCRLRetriever_Supports, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCRLRetriever, GetCRL, arginfo_TElLDAPCRLRetriever_GetCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCRLRetriever, get_LDAPSClient, arginfo_TElLDAPCRLRetriever_get_LDAPSClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCRLRetriever, get_ServerList, arginfo_TElLDAPCRLRetriever_get_ServerList, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCRLRetriever, set_ServerList, arginfo_TElLDAPCRLRetriever_set_ServerList, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCRLRetriever, __construct, arginfo_TElLDAPCRLRetriever___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPCRLRetriever(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPCRLRetriever_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPCRLRetriever", TElLDAPCRLRetriever_methods);
	if (NULL == TElCustomCRLRetriever_ce_ptr)
		Register_TElCustomCRLRetriever(TSRMLS_C);
	TElLDAPCRLRetriever_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCRLRetriever_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPCRLRetrieverFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPCRLRetrieverFactory, Supports)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sLocation, &sLocation_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPCRLRetrieverFactory_Supports(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCRLRetrieverFactory, GetRetrieverInstance)
{
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCRLRetrieverFactory_GetRetrieverInstance(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCRLRetriever_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPCRLRetrieverFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPCRLRetrieverFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCRLRetrieverFactory_Supports, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCRLRetrieverFactory_GetRetrieverInstance, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPCRLRetrieverFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPCRLRetrieverFactory_methods[] = {
	PHP_ME(TElLDAPCRLRetrieverFactory, Supports, arginfo_TElLDAPCRLRetrieverFactory_Supports, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCRLRetrieverFactory, GetRetrieverInstance, arginfo_TElLDAPCRLRetrieverFactory_GetRetrieverInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPCRLRetrieverFactory, __construct, arginfo_TElLDAPCRLRetrieverFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPCRLRetrieverFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPCRLRetrieverFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPCRLRetrieverFactory", TElLDAPCRLRetrieverFactory_methods);
	if (NULL == TElCustomCRLRetrieverFactory_ce_ptr)
		Register_TElCustomCRLRetrieverFactory(TSRMLS_C);
	TElLDAPCRLRetrieverFactory_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCRLRetrieverFactory_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBLDAPCRL, RegisterLDAPCRLRetrieverFactory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBLDAPCRL_RegisterLDAPCRLRetrieverFactory() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
