#include "sbldapskeyserverclient.h"

zend_class_entry *TSBLDAPSKeyserverAttribute_ce_ptr = NULL;

zend_class_entry *TSBSearchRequestType_ce_ptr = NULL;

zend_class_entry *TElLDAPSKeyserverSearchFilter_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPSKeyserverSearchFilter, AddCondition)
{
	char *sAttribute;
	char *sValue;
	int sAttribute_len;
	int sValue_len;
	long fAttribute;
	long fEquality;
	long fLogicalOperator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llls", &fLogicalOperator, &fAttribute, &fEquality, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSKeyserverSearchFilter_AddCondition(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBLDAPSLogicalOperatorRaw)fLogicalOperator, (TSBLDAPSKeyserverAttributeRaw)fAttribute, (TSBLDAPSEqualityRaw)fEquality, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsls", &fLogicalOperator, &sAttribute, &sAttribute_len, &fEquality, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSKeyserverSearchFilter_AddCondition_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBLDAPSLogicalOperatorRaw)fLogicalOperator, sAttribute, (int32_t)sAttribute_len, (TSBLDAPSEqualityRaw)fEquality, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, string) or (integer, string, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverSearchFilter, __construct)
{
	char *sValue;
	int sValue_len;
	long fAttribute;
	long fEquality;
	long fLogicalOperator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSKeyserverSearchFilter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llls", &fLogicalOperator, &fAttribute, &fEquality, &sValue, &sValue_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSKeyserverSearchFilter_Create_1((TSBLDAPSLogicalOperatorRaw)fLogicalOperator, (TSBLDAPSKeyserverAttributeRaw)fAttribute, (TSBLDAPSEqualityRaw)fEquality, sValue, (int32_t)sValue_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer, integer, integer, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverSearchFilter_AddCondition, 0, 0, 4)
	ZEND_ARG_INFO(0, LogicalOperator)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Equality)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverSearchFilter___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, LogicalOperator)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Equality)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPSKeyserverSearchFilter_methods[] = {
	PHP_ME(TElLDAPSKeyserverSearchFilter, AddCondition, arginfo_TElLDAPSKeyserverSearchFilter_AddCondition, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverSearchFilter, __construct, arginfo_TElLDAPSKeyserverSearchFilter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPSKeyserverSearchFilter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPSKeyserverSearchFilter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPSKeyserverSearchFilter", TElLDAPSKeyserverSearchFilter_methods);
	if (NULL == TElLDAPSSearchFilter_ce_ptr)
		Register_TElLDAPSSearchFilter(TSRMLS_C);
	TElLDAPSKeyserverSearchFilter_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPSSearchFilter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPSKeyserverClient_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPSKeyserverClient, Search)
{
	char *sBaseDN;
	char *sFilter;
	char *sID;
	int sBaseDN_len;
	int sFilter_len;
	int sID_len;
	long fScope;
	TElClassHandle hoKeyRing;
	zend_bool bAttrsOnly;
	zval *oAttrs;
	zval *oFilter;
	zval *oKeyRing;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sID, &sID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSKeyserverClient_Search(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPKeyring_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oKeyRing, TElPGPKeyring_ce_ptr, &sID, &sID_len) == SUCCESS) && PZVAL_IS_REF(oKeyRing) && (IS_OBJECT == Z_TYPE_P(oKeyRing)))
	{
		hoKeyRing = SBGetObjectHandle(oKeyRing TSRMLS_CC);
		SBCheckError(TElLDAPSKeyserverClient_Search_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyRing, sID, (int32_t)sID_len) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyRing, hoKeyRing TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFilter, TElLDAPSKeyserverSearchFilter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSKeyserverClient_Search_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFilter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPKeyring_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!", &oKeyRing, TElPGPKeyring_ce_ptr, &oFilter, TElLDAPSKeyserverSearchFilter_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKeyRing) && (IS_OBJECT == Z_TYPE_P(oKeyRing)))
	{
		hoKeyRing = SBGetObjectHandle(oKeyRing TSRMLS_CC);
		SBCheckError(TElLDAPSKeyserverClient_Search_3(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyRing, SBGetObjectHandle(oFilter TSRMLS_CC)) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyRing, hoKeyRing TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slsO!b", &sBaseDN, &sBaseDN_len, &fScope, &sFilter, &sFilter_len, &oAttrs, TStringList_ce_ptr, &bAttrsOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSKeyserverClient_Search_4(SBGetObjectHandle(getThis() TSRMLS_CC), sBaseDN, (int32_t)sBaseDN_len, (TSBLDAPScopeRaw)fScope, sFilter, (int32_t)sFilter_len, SBGetObjectHandle(oAttrs TSRMLS_CC), (int8_t)bAttrsOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!O!b", &sBaseDN, &sBaseDN_len, &fScope, &oFilter, TElLDAPSSearchFilter_ce_ptr, &oAttrs, TStringList_ce_ptr, &bAttrsOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSKeyserverClient_Search_5(SBGetObjectHandle(getThis() TSRMLS_CC), sBaseDN, (int32_t)sBaseDN_len, (TSBLDAPScopeRaw)fScope, SBGetObjectHandle(oFilter TSRMLS_CC), SBGetObjectHandle(oAttrs TSRMLS_CC), (int8_t)bAttrsOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSKeyserverClient_Search_6(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (&TElPGPKeyring, string) or (TElLDAPSKeyserverSearchFilter) or (&TElPGPKeyring, TElLDAPSKeyserverSearchFilter) or (string, integer, string, TStringList, bool) or (string, integer, TElLDAPSSearchFilter, TStringList, bool) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, Remove)
{
	char *sKeyID;
	int sKeyID_len;
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElPGPPublicKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElLDAPSKeyserverClient_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKeyID, &sKeyID_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSKeyserverClient_Remove_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKeyID, (int32_t)sKeyID_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPPublicKey) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, Add)
{
	char *sDN;
	int sDN_len;
	SBArrayZValInfo aiAttrs;
	zval *oKey;
	zval *zaAttrs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElPGPPublicKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElLDAPSKeyserverClient_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sDN, &sDN_len, &zaAttrs, TElLDAPPartialAttribute_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaAttrs)) || (IS_NULL == Z_TYPE_P(zaAttrs))))
	{
		if (!SBGetObjectArrayFromZVal(zaAttrs, TElLDAPPartialAttribute_ce_ptr, &aiAttrs TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPSKeyserverClient_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), sDN, (int32_t)sDN_len, aiAttrs.data, aiAttrs.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAttrs);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPPublicKey) or (string, &array of TElLDAPPartialAttribute|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, get_ServerSoftwareName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSKeyserverClient_get_ServerSoftwareName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1281649303, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, get_ServerSoftwareVersion)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSKeyserverClient_get_ServerSoftwareVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2056969058, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, get_KeySearchRetryCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPSKeyserverClient_get_KeySearchRetryCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, set_KeySearchRetryCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElLDAPSKeyserverClient_set_KeySearchRetryCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, get_IncludeSubkeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPSKeyserverClient_get_IncludeSubkeys(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, set_IncludeSubkeys)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElLDAPSKeyserverClient_set_IncludeSubkeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, get_IncludeDisabledKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPSKeyserverClient_get_IncludeDisabledKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, set_IncludeDisabledKeys)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElLDAPSKeyserverClient_set_IncludeDisabledKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, get_IncludeRevokedKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPSKeyserverClient_get_IncludeRevokedKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, set_IncludeRevokedKeys)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElLDAPSKeyserverClient_set_IncludeRevokedKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSKeyserverClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSKeyserverClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_Search, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(1, ID_or_KeyRing_or_Filter_or_BaseDN, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ID_or_Filter_or_Scope, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Filter, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attrs, TStringList, 1)
	ZEND_ARG_INFO(0, AttrsOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_Remove, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_KeyID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_DN, 0, 1)
	ZEND_ARG_ARRAY_INFO(0, Attrs, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_get_ServerSoftwareName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_get_ServerSoftwareVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_get_KeySearchRetryCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_set_KeySearchRetryCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_get_IncludeSubkeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_set_IncludeSubkeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_get_IncludeDisabledKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_set_IncludeDisabledKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_get_IncludeRevokedKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient_set_IncludeRevokedKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSKeyserverClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPSKeyserverClient_methods[] = {
	PHP_ME(TElLDAPSKeyserverClient, Search, arginfo_TElLDAPSKeyserverClient_Search, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, Remove, arginfo_TElLDAPSKeyserverClient_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, Add, arginfo_TElLDAPSKeyserverClient_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, get_ServerSoftwareName, arginfo_TElLDAPSKeyserverClient_get_ServerSoftwareName, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, get_ServerSoftwareVersion, arginfo_TElLDAPSKeyserverClient_get_ServerSoftwareVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, get_KeySearchRetryCount, arginfo_TElLDAPSKeyserverClient_get_KeySearchRetryCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, set_KeySearchRetryCount, arginfo_TElLDAPSKeyserverClient_set_KeySearchRetryCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, get_IncludeSubkeys, arginfo_TElLDAPSKeyserverClient_get_IncludeSubkeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, set_IncludeSubkeys, arginfo_TElLDAPSKeyserverClient_set_IncludeSubkeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, get_IncludeDisabledKeys, arginfo_TElLDAPSKeyserverClient_get_IncludeDisabledKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, set_IncludeDisabledKeys, arginfo_TElLDAPSKeyserverClient_set_IncludeDisabledKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, get_IncludeRevokedKeys, arginfo_TElLDAPSKeyserverClient_get_IncludeRevokedKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, set_IncludeRevokedKeys, arginfo_TElLDAPSKeyserverClient_set_IncludeRevokedKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSKeyserverClient, __construct, arginfo_TElLDAPSKeyserverClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPSKeyserverClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPSKeyserverClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPSKeyserverClient", TElLDAPSKeyserverClient_methods);
	if (NULL == TElLDAPSClient_ce_ptr)
		Register_TElLDAPSClient(TSRMLS_C);
	TElLDAPSKeyserverClient_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPSClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBLDAPSKeyserverClient_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBLDAPSKeyserverClient, SUnknownBaseKeyspaceDN, SB_SUnknownBaseKeyspaceDN, SB_SUnknownBaseKeyspaceDN);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSKeyserverClient, SWrongSearchParam, SB_SWrongSearchParam, SB_SWrongSearchParam);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSKeyserverClient, SNoSearchConditions, SB_SNoSearchConditions, SB_SNoSearchConditions);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSKeyserverClient, SB_LDAP_KEYSERVER_CLIENT_ERROR_BASE, SB_LDAP_KEYSERVER_CLIENT_ERROR_BASE, SB_LDAP_KEYSERVER_CLIENT_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSKeyserverClient, SB_LDAP_KEYSERVER_CLIENT_NO_BASE_DN, SB_LDAP_KEYSERVER_CLIENT_NO_BASE_DN, SB_LDAP_KEYSERVER_CLIENT_NO_BASE_DN);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSKeyserverClient, SB_LDAP_KEYSERVER_WRONG_SEARCH_PARAM, SB_LDAP_KEYSERVER_WRONG_SEARCH_PARAM, SB_LDAP_KEYSERVER_WRONG_SEARCH_PARAM);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSKeyserverClient, SB_LDAP_KEYSERVER_NO_SEARCH_CONDITIONS, SB_LDAP_KEYSERVER_NO_SEARCH_CONDITIONS, SB_LDAP_KEYSERVER_NO_SEARCH_CONDITIONS);
}

void Register_SBLDAPSKeyserverClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBLDAPSKeyserverAttribute", NULL);
	TSBLDAPSKeyserverAttribute_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBLDAPSKeyserverAttribute_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaCertID", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaDisabled", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaKeyID", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaKeyType", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaUserID", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaKeyCreateTime", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaSignerID", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaRevoked", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaSubKeyID", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaSubKeyID32", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaKeySize", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSKeyserverAttribute_ce_ptr, "lkaKeyExpireTime", 11)
	
	INIT_CLASS_ENTRY(ce, "TSBSearchRequestType", NULL);
	TSBSearchRequestType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSearchRequestType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSearchRequestType_ce_ptr, "srtEmail", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSearchRequestType_ce_ptr, "srtShortID", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSearchRequestType_ce_ptr, "srtLongID", 2)
}

void Register_SBLDAPSKeyserverClient_Aliases(TSRMLS_D)
{
	if (NULL == TElLDAPSKeyserverSearchFilter_ce_ptr)
		Register_TElLDAPSKeyserverSearchFilter(TSRMLS_C);
	zend_register_class_alias("ElLDAPSKeyserverSearchFilter", TElLDAPSKeyserverSearchFilter_ce_ptr);
	if (NULL == TElLDAPSKeyserverClient_ce_ptr)
		Register_TElLDAPSKeyserverClient(TSRMLS_C);
	zend_register_class_alias("ElLDAPSKeyserverClient", TElLDAPSKeyserverClient_ce_ptr);
}

