#include "sbmimeenc.h"

zend_class_entry *TElMimeEncodingStreamClass_ce_ptr = NULL;

zend_class_entry *TElEncodingType_ce_ptr = NULL;

zend_class_entry *TElMimeEncodingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElMimeEncodingStream, ReInit)
{
	long l4SplitOnLen;
	long l4StreamLen;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l4StreamLen, &l4SplitOnLen) == SUCCESS)
	{
		SBCheckError(TElMimeEncodingStream_ReInit(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4StreamLen, (int32_t)l4SplitOnLen) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, _CopyTo)
{
	long l8Count;
	zval *oDestStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oDestStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElMimeEncodingStream__CopyTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestStream TSRMLS_CC), (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMimeEncodingStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElMimeEncodingStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, GetEncodingName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElMimeEncodingStream_GetEncodingName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(158317961, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, GetEncodingName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElMimeEncodingStream_GetEncodingName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(158317961, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, GetEncodedSize)
{
	long l4SourceSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SourceSize) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMimeEncodingStream_GetEncodedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SourceSize, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, GetDecodedSize)
{
	long l4SourceSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SourceSize) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMimeEncodingStream_GetDecodedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SourceSize, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMimeEncodingStream_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, get_IsErrorOccured)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMimeEncodingStream_get_IsErrorOccured(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, get_Stream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMimeEncodingStream_get_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, set_Stream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElMimeEncodingStream_set_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, get_SplitOnLen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMimeEncodingStream_get_SplitOnLen(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, set_SplitOnLen)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElMimeEncodingStream_set_SplitOnLen(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMimeEncodingStream, __construct)
{
	long l4SplitOnLen;
	long l4StreamLen;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMimeEncodingStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l4StreamLen, &l4SplitOnLen) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMimeEncodingStream_Create_1(SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4StreamLen, (int32_t)l4SplitOnLen, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream, integer, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_ReInit, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, StreamLen)
	ZEND_ARG_INFO(0, SplitOnLen)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream__CopyTo, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_GetEncodingName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_GetEncodingName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_GetEncodedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, SourceSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_GetDecodedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, SourceSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_get_IsErrorOccured, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_get_Stream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_set_Stream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_get_SplitOnLen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream_set_SplitOnLen, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMimeEncodingStream___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, StreamLen)
	ZEND_ARG_INFO(0, SplitOnLen)
ZEND_END_ARG_INFO()

static zend_function_entry TElMimeEncodingStream_methods[] = {
	PHP_ME(TElMimeEncodingStream, ReInit, arginfo_TElMimeEncodingStream_ReInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, _CopyTo, arginfo_TElMimeEncodingStream__CopyTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, Seek, arginfo_TElMimeEncodingStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, GetEncodingName_Inst, arginfo_TElMimeEncodingStream_GetEncodingName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, GetEncodingName, arginfo_TElMimeEncodingStream_GetEncodingName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElMimeEncodingStream, GetEncodedSize, arginfo_TElMimeEncodingStream_GetEncodedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, GetDecodedSize, arginfo_TElMimeEncodingStream_GetDecodedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, ClassType, arginfo_TElMimeEncodingStream_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElMimeEncodingStream, get_IsErrorOccured, arginfo_TElMimeEncodingStream_get_IsErrorOccured, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, get_Stream, arginfo_TElMimeEncodingStream_get_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, set_Stream, arginfo_TElMimeEncodingStream_set_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, get_SplitOnLen, arginfo_TElMimeEncodingStream_get_SplitOnLen, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, set_SplitOnLen, arginfo_TElMimeEncodingStream_set_SplitOnLen, ZEND_ACC_PUBLIC)
	PHP_ME(TElMimeEncodingStream, __construct, arginfo_TElMimeEncodingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElMimeEncodingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElMimeEncodingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElMimeEncodingStream", TElMimeEncodingStream_methods);
	if (NULL == TElCustomMIMEStream_ce_ptr)
		Register_TElCustomMIMEStream(TSRMLS_C);
	TElMimeEncodingStream_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomMIMEStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBase64Stream_ce_ptr = NULL;

SB_PHP_METHOD(TElBase64Stream, ReInit)
{
	long l4SplitOnLen;
	long l4StreamLen;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l4StreamLen, &l4SplitOnLen) == SUCCESS)
	{
		SBCheckError(TElBase64Stream_ReInit(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4StreamLen, (int32_t)l4SplitOnLen) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBase64Stream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBase64Stream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBase64Stream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBase64Stream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBase64Stream, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBase64Stream_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBase64Stream, GetEncodedSize)
{
	long l4SourceSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SourceSize) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBase64Stream_GetEncodedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SourceSize, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBase64Stream, GetDecodedSize)
{
	long l4SourceSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SourceSize) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBase64Stream_GetDecodedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SourceSize, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBase64Stream, GetEncodingName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBase64Stream_GetEncodingName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2089751914, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBase64Stream, GetEncodingName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBase64Stream_GetEncodingName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2089751914, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBase64Stream, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBase64Stream_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBase64Stream, __construct)
{
	long l4SplitOnLen;
	long l4StreamLen;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBase64Stream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l4StreamLen, &l4SplitOnLen) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBase64Stream_Create_1(SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4StreamLen, (int32_t)l4SplitOnLen, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream, integer, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream_ReInit, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, StreamLen)
	ZEND_ARG_INFO(0, SplitOnLen)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream_GetEncodedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, SourceSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream_GetDecodedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, SourceSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream_GetEncodingName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream_GetEncodingName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBase64Stream___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, StreamLen)
	ZEND_ARG_INFO(0, SplitOnLen)
ZEND_END_ARG_INFO()

static zend_function_entry TElBase64Stream_methods[] = {
	PHP_ME(TElBase64Stream, ReInit, arginfo_TElBase64Stream_ReInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElBase64Stream, Read, arginfo_TElBase64Stream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElBase64Stream, Write, arginfo_TElBase64Stream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElBase64Stream, Flush, arginfo_TElBase64Stream_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElBase64Stream, GetEncodedSize, arginfo_TElBase64Stream_GetEncodedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBase64Stream, GetDecodedSize, arginfo_TElBase64Stream_GetDecodedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBase64Stream, GetEncodingName_Inst, arginfo_TElBase64Stream_GetEncodingName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElBase64Stream, GetEncodingName, arginfo_TElBase64Stream_GetEncodingName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBase64Stream, ClassType, arginfo_TElBase64Stream_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBase64Stream, __construct, arginfo_TElBase64Stream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBase64Stream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBase64Stream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBase64Stream", TElBase64Stream_methods);
	if (NULL == TElMimeEncodingStream_ce_ptr)
		Register_TElMimeEncodingStream(TSRMLS_C);
	TElBase64Stream_ce_ptr = zend_register_internal_class_ex(&ce, TElMimeEncodingStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElQuotedPrintableStream_ce_ptr = NULL;

SB_PHP_METHOD(TElQuotedPrintableStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElQuotedPrintableStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElQuotedPrintableStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElQuotedPrintableStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElQuotedPrintableStream, GetEncodedSize)
{
	long l4SourceSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SourceSize) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElQuotedPrintableStream_GetEncodedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SourceSize, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElQuotedPrintableStream, GetDecodedSize)
{
	long l4SourceSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SourceSize) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElQuotedPrintableStream_GetDecodedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SourceSize, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElQuotedPrintableStream, GetEncodingName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElQuotedPrintableStream_GetEncodingName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-76276848, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElQuotedPrintableStream, GetEncodingName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElQuotedPrintableStream_GetEncodingName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-76276848, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElQuotedPrintableStream, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElQuotedPrintableStream_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElQuotedPrintableStream, __construct)
{
	long l4SplitOnLen;
	long l4StreamLen;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElQuotedPrintableStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l4StreamLen, &l4SplitOnLen) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElQuotedPrintableStream_Create_1(SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4StreamLen, (int32_t)l4SplitOnLen, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream, integer, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElQuotedPrintableStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElQuotedPrintableStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElQuotedPrintableStream_GetEncodedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, SourceSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElQuotedPrintableStream_GetDecodedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, SourceSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElQuotedPrintableStream_GetEncodingName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElQuotedPrintableStream_GetEncodingName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElQuotedPrintableStream_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElQuotedPrintableStream___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, StreamLen)
	ZEND_ARG_INFO(0, SplitOnLen)
ZEND_END_ARG_INFO()

static zend_function_entry TElQuotedPrintableStream_methods[] = {
	PHP_ME(TElQuotedPrintableStream, Read, arginfo_TElQuotedPrintableStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElQuotedPrintableStream, Write, arginfo_TElQuotedPrintableStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElQuotedPrintableStream, GetEncodedSize, arginfo_TElQuotedPrintableStream_GetEncodedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElQuotedPrintableStream, GetDecodedSize, arginfo_TElQuotedPrintableStream_GetDecodedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElQuotedPrintableStream, GetEncodingName_Inst, arginfo_TElQuotedPrintableStream_GetEncodingName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElQuotedPrintableStream, GetEncodingName, arginfo_TElQuotedPrintableStream_GetEncodingName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElQuotedPrintableStream, ClassType, arginfo_TElQuotedPrintableStream_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElQuotedPrintableStream, __construct, arginfo_TElQuotedPrintableStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElQuotedPrintableStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElQuotedPrintableStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElQuotedPrintableStream", TElQuotedPrintableStream_methods);
	if (NULL == TElMimeEncodingStream_ce_ptr)
		Register_TElMimeEncodingStream(TSRMLS_C);
	TElQuotedPrintableStream_ce_ptr = zend_register_internal_class_ex(&ce, TElMimeEncodingStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TEl7BitStream_ce_ptr = NULL;

SB_PHP_METHOD(TEl7BitStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TEl7BitStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl7BitStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TEl7BitStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl7BitStream, GetEncodingName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TEl7BitStream_GetEncodingName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1723789240, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl7BitStream, GetEncodingName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TEl7BitStream_GetEncodingName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1723789240, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl7BitStream, ReInit)
{
	long l4SplitOnLen;
	long l4StreamLen;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l4StreamLen, &l4SplitOnLen) == SUCCESS)
	{
		SBCheckError(TEl7BitStream_ReInit(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4StreamLen, (int32_t)l4SplitOnLen) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl7BitStream, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl7BitStream_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl7BitStream, get_Passthrough)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TEl7BitStream_get_Passthrough(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl7BitStream, set_Passthrough)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TEl7BitStream_set_Passthrough(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl7BitStream, __construct)
{
	long l4SplitOnLen;
	long l4StreamLen;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl7BitStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l4StreamLen, &l4SplitOnLen) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl7BitStream_Create_1(SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4StreamLen, (int32_t)l4SplitOnLen, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream, integer, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl7BitStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl7BitStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl7BitStream_GetEncodingName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl7BitStream_GetEncodingName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl7BitStream_ReInit, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, StreamLen)
	ZEND_ARG_INFO(0, SplitOnLen)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl7BitStream_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl7BitStream_get_Passthrough, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl7BitStream_set_Passthrough, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl7BitStream___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, StreamLen)
	ZEND_ARG_INFO(0, SplitOnLen)
ZEND_END_ARG_INFO()

static zend_function_entry TEl7BitStream_methods[] = {
	PHP_ME(TEl7BitStream, Read, arginfo_TEl7BitStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TEl7BitStream, Write, arginfo_TEl7BitStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TEl7BitStream, GetEncodingName_Inst, arginfo_TEl7BitStream_GetEncodingName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TEl7BitStream, GetEncodingName, arginfo_TEl7BitStream_GetEncodingName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TEl7BitStream, ReInit, arginfo_TEl7BitStream_ReInit, ZEND_ACC_PUBLIC)
	PHP_ME(TEl7BitStream, ClassType, arginfo_TEl7BitStream_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TEl7BitStream, get_Passthrough, arginfo_TEl7BitStream_get_Passthrough, ZEND_ACC_PUBLIC)
	PHP_ME(TEl7BitStream, set_Passthrough, arginfo_TEl7BitStream_set_Passthrough, ZEND_ACC_PUBLIC)
	PHP_ME(TEl7BitStream, __construct, arginfo_TEl7BitStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TEl7BitStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TEl7BitStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TEl7BitStream", TEl7BitStream_methods);
	if (NULL == TElMimeEncodingStream_ce_ptr)
		Register_TElMimeEncodingStream(TSRMLS_C);
	TEl7BitStream_ce_ptr = zend_register_internal_class_ex(&ce, TElMimeEncodingStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TEl8BitStream_ce_ptr = NULL;

SB_PHP_METHOD(TEl8BitStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TEl8BitStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl8BitStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TEl8BitStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl8BitStream, GetEncodingName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TEl8BitStream_GetEncodingName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-947394558, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl8BitStream, GetEncodingName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TEl8BitStream_GetEncodingName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-947394558, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl8BitStream, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl8BitStream_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl8BitStream, __construct)
{
	long l4SplitOnLen;
	long l4StreamLen;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl8BitStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l4StreamLen, &l4SplitOnLen) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl8BitStream_Create_1(SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4StreamLen, (int32_t)l4SplitOnLen, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream, integer, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl8BitStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl8BitStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl8BitStream_GetEncodingName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl8BitStream_GetEncodingName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl8BitStream_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl8BitStream___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, StreamLen)
	ZEND_ARG_INFO(0, SplitOnLen)
ZEND_END_ARG_INFO()

static zend_function_entry TEl8BitStream_methods[] = {
	PHP_ME(TEl8BitStream, Read, arginfo_TEl8BitStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TEl8BitStream, Write, arginfo_TEl8BitStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TEl8BitStream, GetEncodingName_Inst, arginfo_TEl8BitStream_GetEncodingName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TEl8BitStream, GetEncodingName, arginfo_TEl8BitStream_GetEncodingName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TEl8BitStream, ClassType, arginfo_TEl8BitStream_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TEl8BitStream, __construct, arginfo_TEl8BitStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TEl8BitStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TEl8BitStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TEl8BitStream", TEl8BitStream_methods);
	if (NULL == TElMimeEncodingStream_ce_ptr)
		Register_TElMimeEncodingStream(TSRMLS_C);
	TEl8BitStream_ce_ptr = zend_register_internal_class_ex(&ce, TElMimeEncodingStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBinaryStream_ce_ptr = NULL;

SB_PHP_METHOD(TElBinaryStream, GetEncodingName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBinaryStream_GetEncodingName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1115540887, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBinaryStream, GetEncodingName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBinaryStream_GetEncodingName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1115540887, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBinaryStream, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBinaryStream_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBinaryStream, __construct)
{
	long l4SplitOnLen;
	long l4StreamLen;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBinaryStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l4StreamLen, &l4SplitOnLen) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBinaryStream_Create_1(SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4StreamLen, (int32_t)l4SplitOnLen, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream, integer, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBinaryStream_GetEncodingName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBinaryStream_GetEncodingName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBinaryStream_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBinaryStream___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, StreamLen)
	ZEND_ARG_INFO(0, SplitOnLen)
ZEND_END_ARG_INFO()

static zend_function_entry TElBinaryStream_methods[] = {
	PHP_ME(TElBinaryStream, GetEncodingName_Inst, arginfo_TElBinaryStream_GetEncodingName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElBinaryStream, GetEncodingName, arginfo_TElBinaryStream_GetEncodingName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBinaryStream, ClassType, arginfo_TElBinaryStream_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBinaryStream, __construct, arginfo_TElBinaryStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBinaryStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBinaryStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBinaryStream", TElBinaryStream_methods);
	if (NULL == TEl8BitStream_ce_ptr)
		Register_TEl8BitStream(TSRMLS_C);
	TElBinaryStream_ce_ptr = zend_register_internal_class_ex(&ce, TEl8BitStream_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBMIMEEnc, DecodeHeader)
{
	char *sDecodedStr;
	char *sEncodedStr;
	char *sOutCodePage;
	int sEncodedStr_len;
	int32_t sDecodedStr_len;
	int32_t sOutCodePage_len;
	long fEncoding;
	uint32_t _err;
	zval *zsDecodedStr;
	zval *zsOutCodePage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slzz", &sEncodedStr, &sEncodedStr_len, &fEncoding, &zsOutCodePage, &zsDecodedStr) == SUCCESS) && PZVAL_IS_REF(zsOutCodePage) && (IS_STRING == Z_TYPE_P(zsOutCodePage)) && PZVAL_IS_REF(zsDecodedStr) && (IS_STRING == Z_TYPE_P(zsDecodedStr)))
	{
		sOutCodePage = Z_STRVAL_P(zsOutCodePage);
		sOutCodePage_len = (int32_t)Z_STRLEN_P(zsOutCodePage);
		sDecodedStr = Z_STRVAL_P(zsDecodedStr);
		sDecodedStr_len = (int32_t)Z_STRLEN_P(zsDecodedStr);
		_err = SBMIMEEnc_DecodeHeader(sEncodedStr, (int32_t)sEncodedStr_len, (TElEncodingTypeRaw)fEncoding, sOutCodePage, &sOutCodePage_len, sDecodedStr, &sDecodedStr_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutCodePage = emalloc(sOutCodePage_len + 1);
			SBCheckError(SBGetLastReturnStringA(-598642571, 2, sOutCodePage, &sOutCodePage_len) TSRMLS_CC);
			zval_dtor(zsOutCodePage);
			sDecodedStr = emalloc(sDecodedStr_len + 1);
			SBCheckError(SBGetLastReturnStringA(-598642571, 3, sDecodedStr, &sDecodedStr_len) TSRMLS_CC);
			zval_dtor(zsDecodedStr);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sOutCodePage[sOutCodePage_len] = 0;
		ZVAL_STRINGL(zsOutCodePage, sOutCodePage, sOutCodePage_len, 0);
		sDecodedStr[sDecodedStr_len] = 0;
		ZVAL_STRINGL(zsDecodedStr, sDecodedStr, sDecodedStr_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, &string, &string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMIMEEnc, EncodeQuotedPrintableBodyForHeader)
{
	char *sDest;
	char *sSource;
	int sSource_len;
	int32_t l4OffsetRaw;
	int32_t sDest_len;
	long l4Max;
	uint32_t _err;
	zval *zl4Offset;
	zval *zsDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szlz", &sSource, &sSource_len, &zl4Offset, &l4Max, &zsDest) == SUCCESS) && PZVAL_IS_REF(zl4Offset) && (IS_LONG == Z_TYPE_P(zl4Offset)) && PZVAL_IS_REF(zsDest) && (IS_STRING == Z_TYPE_P(zsDest)))
	{
		l4OffsetRaw = (int32_t)Z_LVAL_P(zl4Offset);
		sDest = Z_STRVAL_P(zsDest);
		sDest_len = (int32_t)Z_STRLEN_P(zsDest);
		_err = SBMIMEEnc_EncodeQuotedPrintableBodyForHeader(sSource, (int32_t)sSource_len, &l4OffsetRaw, (int32_t)l4Max, sDest, &sDest_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sDest = emalloc(sDest_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1510317348, 3, sDest, &sDest_len) TSRMLS_CC);
			zval_dtor(zsDest);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl4Offset, (long)l4OffsetRaw);
		sDest[sDest_len] = 0;
		ZVAL_STRINGL(zsDest, sDest, sDest_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, &integer, integer, &string)" TSRMLS_CC);
	}
}

void Register_SBMIMEEnc_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBMIMEEnc, cSplitOutLenDef, SB_cSplitOutLenDef, SB_cSplitOutLenDef);
	SB_REGISTER_LONG_CONSTANT(SBMIMEEnc, cMinusOne, SB_cMinusOne, SB_cMinusOne);
}

void Register_SBMIMEEnc_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElEncodingType", NULL);
	TElEncodingType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElEncodingType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElEncodingType_ce_ptr, "etNotEncoded", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElEncodingType_ce_ptr, "etQuotedPrintable", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElEncodingType_ce_ptr, "etBase64", 2)
}

void Register_SBMIMEEnc_Aliases(TSRMLS_D)
{
	if (NULL == TElMimeEncodingStream_ce_ptr)
		Register_TElMimeEncodingStream(TSRMLS_C);
	zend_register_class_alias("ElMimeEncodingStream", TElMimeEncodingStream_ce_ptr);
	if (NULL == TElBase64Stream_ce_ptr)
		Register_TElBase64Stream(TSRMLS_C);
	zend_register_class_alias("ElBase64Stream", TElBase64Stream_ce_ptr);
	if (NULL == TElQuotedPrintableStream_ce_ptr)
		Register_TElQuotedPrintableStream(TSRMLS_C);
	zend_register_class_alias("ElQuotedPrintableStream", TElQuotedPrintableStream_ce_ptr);
	if (NULL == TEl7BitStream_ce_ptr)
		Register_TEl7BitStream(TSRMLS_C);
	zend_register_class_alias("El7BitStream", TEl7BitStream_ce_ptr);
	if (NULL == TEl8BitStream_ce_ptr)
		Register_TEl8BitStream(TSRMLS_C);
	zend_register_class_alias("El8BitStream", TEl8BitStream_ce_ptr);
	if (NULL == TElBinaryStream_ce_ptr)
		Register_TElBinaryStream(TSRMLS_C);
	zend_register_class_alias("ElBinaryStream", TElBinaryStream_ce_ptr);
	TElMimeEncodingStreamClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElMimeEncodingStreamClass", TElMimeEncodingStreamClass_ce_ptr);
	zend_register_class_alias("ElMimeEncodingStreamClass", TObject_ce_ptr);
	if (NULL == TElEncodingType_ce_ptr)
		Register_SBMIMEEnc_Enum_Flags(TSRMLS_C);
	zend_register_class_alias("ElEncodingType", TElEncodingType_ce_ptr);
}

