#include "sbocspclient.h"

zend_class_entry *TSBOCSPClientOption_ce_ptr = NULL;

zend_class_entry *TSBOCSPClientOptions_ce_ptr = NULL;

void SB_CALLBACK TSBOCSPValidationNeededEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, TStreamHandle RequestStream, TStreamHandle ReplyStream, int8_t * Succeeded)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zURL;
	zval * zRequestStream;
	zval * zReplyStream;
	zval * zSucceeded;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zRequestStream);
	SBInitObject(zRequestStream, TStream_ce_ptr, RequestStream TSRMLS_CC);
	MAKE_STD_ZVAL(zReplyStream);
	SBInitObject(zReplyStream, TStream_ce_ptr, ReplyStream TSRMLS_CC);
	MAKE_STD_ZVAL(zSucceeded);
	ZVAL_BOOL(zSucceeded, (zend_bool)*Succeeded);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zRequestStream;
	params[3] = &zReplyStream;
	params[4] = &zSucceeded;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zRequestStream);
	zval_ptr_dtor(&zReplyStream);
	*Succeeded = (int8_t)Z_BVAL_P(zSucceeded);
	zval_ptr_dtor(&zSucceeded);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElOCSPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElOCSPClient, CreateRequest)
{
	SBArrayZValInfo aiRequest;
	uint32_t _err;
	zval *zaRequest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaRequest) == SUCCESS) && PZVAL_IS_REF(zaRequest) && ((IS_STRING == Z_TYPE_P(zaRequest)) || (IS_ARRAY == Z_TYPE_P(zaRequest))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaRequest, &aiRequest TSRMLS_CC)) RETURN_FALSE;
		_err = TElOCSPClient_CreateRequest(SBGetObjectHandle(getThis() TSRMLS_CC), aiRequest.data, &aiRequest.len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaRequest, &aiRequest TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(571009497, 1, aiRequest.data, &aiRequest.len) TSRMLS_CC);
			((char *)aiRequest.data)[aiRequest.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiRequest);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiRequest, zaRequest);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, ProcessReply)
{
	SBArrayZValInfo aiReply;
	TElOCSPServerErrorRaw fServerResultRaw;
	zval *zaReply;
	zval *zfServerResult;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaReply, &zfServerResult) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaReply)) || (IS_ARRAY == Z_TYPE_P(zaReply)) || (IS_NULL == Z_TYPE_P(zaReply))) && PZVAL_IS_REF(zfServerResult) && (IS_LONG == Z_TYPE_P(zfServerResult)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaReply, &aiReply TSRMLS_CC)) RETURN_FALSE;
		fServerResultRaw = (TElOCSPServerErrorRaw)Z_LVAL_P(zfServerResult);
		SBCheckError(TElOCSPClient_ProcessReply(SBGetObjectHandle(getThis() TSRMLS_CC), aiReply.data, aiReply.len, &fServerResultRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiReply);
		ZVAL_LONG(zfServerResult, (long)fServerResultRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, PerformRequest)
{
	SBArrayZValInfo aiReply;
	TElOCSPServerErrorRaw fServerResultRaw;
	uint32_t _err;
	zval *zaReply;
	zval *zfServerResult;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zfServerResult, &zaReply) == SUCCESS) && PZVAL_IS_REF(zfServerResult) && (IS_LONG == Z_TYPE_P(zfServerResult)) && PZVAL_IS_REF(zaReply) && ((IS_STRING == Z_TYPE_P(zaReply)) || (IS_ARRAY == Z_TYPE_P(zaReply))))
	{
		int32_t l4OutResultRaw = 0;
		fServerResultRaw = (TElOCSPServerErrorRaw)Z_LVAL_P(zfServerResult);
		if (!SBGetByteArrayFromZVal(zaReply, &aiReply TSRMLS_CC)) RETURN_FALSE;
		_err = TElOCSPClient_PerformRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &fServerResultRaw, aiReply.data, &aiReply.len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaReply, &aiReply TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1674482338, 2, aiReply.data, &aiReply.len) TSRMLS_CC);
			((char *)aiReply.data)[aiReply.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiReply);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zfServerResult, (long)fServerResultRaw);
		SBSetByteArrayToZVal(&aiReply, zaReply);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOCSPClient_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_ReplyProducedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOCSPClient_get_ReplyProducedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_ReplyNonce)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOCSPClient_get_ReplyNonce(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-630927206, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_ReplyCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClient_get_ReplyCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_ServerName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClient_get_ServerName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_ServerCertKeyHash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOCSPClient_get_ServerCertKeyHash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(487844738, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, set_ServerCertKeyHash)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOCSPClient_set_ServerCertKeyHash(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_CertStatus)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElOCSPCertificateStatusRaw fOutResultRaw = 0;
		SBCheckError(TElOCSPClient_get_CertStatus(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_RevocationTime)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOCSPClient_get_RevocationTime(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_RevocationReason)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TSBCRLReasonFlagRaw fOutResultRaw = 0;
		SBCheckError(TElOCSPClient_get_RevocationReason(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_ThisUpdate)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOCSPClient_get_ThisUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_NextUpdate)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOCSPClient_get_NextUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_Response)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClient_get_Response(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_Nonce)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOCSPClient_get_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1103259277, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, set_Nonce)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOCSPClient_set_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClient_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOCSPClient_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_IssuerCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClient_get_IssuerCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, set_IssuerCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOCSPClient_set_IssuerCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_IncludeSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOCSPClient_get_IncludeSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, set_IncludeSignature)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOCSPClient_set_IncludeSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_SignatureAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOCSPClient_get_SignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, set_SignatureAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOCSPClient_set_SignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_Options)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOCSPClientOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElOCSPClient_get_Options(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, set_Options)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElOCSPClient_set_Options(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBOCSPClientOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOCSPClient_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1076938350, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOCSPClient_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClient, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClient_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_CreateRequest, 0, 0, 1)
	ZEND_ARG_INFO(1, Request)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_ProcessReply, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Reply, 0, 1)
	ZEND_ARG_INFO(1, ServerResult)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_PerformRequest, 0, 0, 2)
	ZEND_ARG_INFO(1, ServerResult)
	ZEND_ARG_INFO(1, Reply)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_SupportsLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_ReplyProducedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_ReplyNonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_ReplyCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_ServerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_ServerCertKeyHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_set_ServerCertKeyHash, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_CertStatus, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_RevocationTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_RevocationReason, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_ThisUpdate, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_NextUpdate, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_Response, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_Nonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_set_Nonce, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_IssuerCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_set_IssuerCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_IncludeSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_set_IncludeSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_SignatureAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_set_SignatureAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_Options, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_set_Options, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOCSPClient_methods[] = {
	PHP_ME(TElOCSPClient, CreateRequest, arginfo_TElOCSPClient_CreateRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, ProcessReply, arginfo_TElOCSPClient_ProcessReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, PerformRequest, arginfo_TElOCSPClient_PerformRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, SupportsLocation, arginfo_TElOCSPClient_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_ReplyProducedAt, arginfo_TElOCSPClient_get_ReplyProducedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_ReplyNonce, arginfo_TElOCSPClient_get_ReplyNonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_ReplyCertificates, arginfo_TElOCSPClient_get_ReplyCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_ServerName, arginfo_TElOCSPClient_get_ServerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_ServerCertKeyHash, arginfo_TElOCSPClient_get_ServerCertKeyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, set_ServerCertKeyHash, arginfo_TElOCSPClient_set_ServerCertKeyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_CertStatus, arginfo_TElOCSPClient_get_CertStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_RevocationTime, arginfo_TElOCSPClient_get_RevocationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_RevocationReason, arginfo_TElOCSPClient_get_RevocationReason, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_ThisUpdate, arginfo_TElOCSPClient_get_ThisUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_NextUpdate, arginfo_TElOCSPClient_get_NextUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_Response, arginfo_TElOCSPClient_get_Response, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_Nonce, arginfo_TElOCSPClient_get_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, set_Nonce, arginfo_TElOCSPClient_set_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_CertStorage, arginfo_TElOCSPClient_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, set_CertStorage, arginfo_TElOCSPClient_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_IssuerCertStorage, arginfo_TElOCSPClient_get_IssuerCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, set_IssuerCertStorage, arginfo_TElOCSPClient_set_IssuerCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_IncludeSignature, arginfo_TElOCSPClient_get_IncludeSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, set_IncludeSignature, arginfo_TElOCSPClient_set_IncludeSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_SignatureAlgorithm, arginfo_TElOCSPClient_get_SignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, set_SignatureAlgorithm, arginfo_TElOCSPClient_set_SignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_Options, arginfo_TElOCSPClient_get_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, set_Options, arginfo_TElOCSPClient_set_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, get_URL, arginfo_TElOCSPClient_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, set_URL, arginfo_TElOCSPClient_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClient, __construct, arginfo_TElOCSPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOCSPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOCSPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOCSPClient", TElOCSPClient_methods);
	if (NULL == TElOCSPClass_ce_ptr)
		Register_TElOCSPClass(TSRMLS_C);
	TElOCSPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElOCSPClass_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOCSPResponderID_ce_ptr = NULL;

SB_PHP_METHOD(TElOCSPResponderID, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOCSPResponderID_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponderID, get_Name)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPResponderID_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponderID, get_SHA1KeyHash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOCSPResponderID_get_SHA1KeyHash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(453980664, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponderID, set_SHA1KeyHash)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOCSPResponderID_set_SHA1KeyHash(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponderID, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPResponderID_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponderID_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponderID_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponderID_get_SHA1KeyHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponderID_set_SHA1KeyHash, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponderID___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOCSPResponderID_methods[] = {
	PHP_ME(TElOCSPResponderID, Clear, arginfo_TElOCSPResponderID_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponderID, get_Name, arginfo_TElOCSPResponderID_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponderID, get_SHA1KeyHash, arginfo_TElOCSPResponderID_get_SHA1KeyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponderID, set_SHA1KeyHash, arginfo_TElOCSPResponderID_set_SHA1KeyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponderID, __construct, arginfo_TElOCSPResponderID___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOCSPResponderID(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOCSPResponderID_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOCSPResponderID", TElOCSPResponderID_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOCSPResponderID_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOCSPSingleResponse_ce_ptr = NULL;

SB_PHP_METHOD(TElOCSPSingleResponse, LoadFromTag)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOCSPSingleResponse_LoadFromTag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTag TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, CertMatches)
{
	zval *oCert;
	zval *oIssuer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCert, TElX509Certificate_ce_ptr, &oIssuer, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOCSPSingleResponse_CertMatches(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), SBGetObjectHandle(oIssuer TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, SignerMatches)
{
	zval *oIssuer;
	zval *oSigner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSigner, TElPKCS7Issuer_ce_ptr, &oIssuer, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOCSPSingleResponse_SignerMatches(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigner TSRMLS_CC), SBGetObjectHandle(oIssuer TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS7Issuer, TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOCSPSingleResponse_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, get_IssuerNameHash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOCSPSingleResponse_get_IssuerNameHash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-553708567, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, get_IssuerKeyHash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOCSPSingleResponse_get_IssuerKeyHash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1894661179, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOCSPSingleResponse_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(189526734, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, get_CertStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElOCSPCertificateStatusRaw fOutResultRaw = 0;
		SBCheckError(TElOCSPSingleResponse_get_CertStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, get_ThisUpdate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOCSPSingleResponse_get_ThisUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, get_NextUpdate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOCSPSingleResponse_get_NextUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, get_RevocationTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOCSPSingleResponse_get_RevocationTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, get_RevocationReasons)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLReasonFlagsRaw fOutResultRaw = 0;
		SBCheckError(TElOCSPSingleResponse_get_RevocationReasons(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPSingleResponse, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPSingleResponse_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_LoadFromTag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tag, TElASN1ConstrainedTag, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_CertMatches, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
	ZEND_ARG_OBJ_INFO(0, Issuer, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_SignerMatches, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Signer, TElPKCS7Issuer, 1)
	ZEND_ARG_OBJ_INFO(0, Issuer, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_get_IssuerNameHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_get_IssuerKeyHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_get_CertStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_get_ThisUpdate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_get_NextUpdate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_get_RevocationTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse_get_RevocationReasons, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPSingleResponse___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOCSPSingleResponse_methods[] = {
	PHP_ME(TElOCSPSingleResponse, LoadFromTag, arginfo_TElOCSPSingleResponse_LoadFromTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, CertMatches, arginfo_TElOCSPSingleResponse_CertMatches, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, SignerMatches, arginfo_TElOCSPSingleResponse_SignerMatches, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, get_HashAlgorithm, arginfo_TElOCSPSingleResponse_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, get_IssuerNameHash, arginfo_TElOCSPSingleResponse_get_IssuerNameHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, get_IssuerKeyHash, arginfo_TElOCSPSingleResponse_get_IssuerKeyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, get_SerialNumber, arginfo_TElOCSPSingleResponse_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, get_CertStatus, arginfo_TElOCSPSingleResponse_get_CertStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, get_ThisUpdate, arginfo_TElOCSPSingleResponse_get_ThisUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, get_NextUpdate, arginfo_TElOCSPSingleResponse_get_NextUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, get_RevocationTime, arginfo_TElOCSPSingleResponse_get_RevocationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, get_RevocationReasons, arginfo_TElOCSPSingleResponse_get_RevocationReasons, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPSingleResponse, __construct, arginfo_TElOCSPSingleResponse___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOCSPSingleResponse(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOCSPSingleResponse_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOCSPSingleResponse", TElOCSPSingleResponse_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOCSPSingleResponse_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOCSPResponse_ce_ptr = NULL;

SB_PHP_METHOD(TElOCSPResponse, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOCSPResponse_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOCSPResponse_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, Load)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOCSPResponse_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, Save)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElOCSPResponse_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, SaveBasic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElOCSPResponse_SaveBasic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, SaveFull)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElOCSPResponse_SaveFull(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, EqualsTo)
{
	zval *oOtherResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOtherResponse, TElOCSPResponse_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOCSPResponse_EqualsTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOtherResponse TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOCSPResponse)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, FindResponse)
{
	zval *oCert;
	zval *oIssuer;
	zval *oSigner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCert, TElX509Certificate_ce_ptr, &oIssuer, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOCSPResponse_FindResponse(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), SBGetObjectHandle(oIssuer TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSigner, TElPKCS7Issuer_ce_ptr, &oIssuer, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOCSPResponse_FindResponse_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigner TSRMLS_CC), SBGetObjectHandle(oIssuer TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElX509Certificate) or (TElPKCS7Issuer, TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, GetSignerCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPResponse_GetSignerCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, IsSignerCertificate)
{
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOCSPResponse_IsSignerCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, Validate)
{
	zval *oCACertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSSignatureValidityRaw fOutResultRaw = 0;
		SBCheckError(TElOCSPResponse_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCACertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		TSBCMSSignatureValidityRaw fOutResultRaw = 0;
		SBCheckError(TElOCSPResponse_Validate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCACertificate TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, GetOCSPResponseHash)
{
	long l4Alg;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOCSPResponse_GetOCSPResponseHash(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1286318205, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, get_SignatureAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOCSPResponse_get_SignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPResponse_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMemoryCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, get_ResponderID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPResponse_get_ResponderID(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPResponderID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, get_ProducedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOCSPResponse_get_ProducedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, get_Responses)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPResponse_get_Responses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPSingleResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, get_ResponseCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOCSPResponse_get_ResponseCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, get_OnCertificateNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSCertificateNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOCSPResponse_get_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, set_OnCertificateNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOCSPResponse_set_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCMSCertificateNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCMSCertificateNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPResponse, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPResponse_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_Load, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_Save, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_SaveBasic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_SaveFull, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_EqualsTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, OtherResponse, TElOCSPResponse, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_FindResponse, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Cert_or_Signer, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Issuer, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_GetSignerCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_IsSignerCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_Validate, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, CACertificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_GetOCSPResponseHash, 0, 0, 1)
	ZEND_ARG_INFO(0, Alg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_get_SignatureAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_get_ResponderID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_get_ProducedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_get_Responses, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_get_ResponseCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_get_OnCertificateNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse_set_OnCertificateNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPResponse___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOCSPResponse_methods[] = {
	PHP_ME(TElOCSPResponse, Clear, arginfo_TElOCSPResponse_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, Assign, arginfo_TElOCSPResponse_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, Load, arginfo_TElOCSPResponse_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, Save, arginfo_TElOCSPResponse_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, SaveBasic, arginfo_TElOCSPResponse_SaveBasic, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, SaveFull, arginfo_TElOCSPResponse_SaveFull, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, EqualsTo, arginfo_TElOCSPResponse_EqualsTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, FindResponse, arginfo_TElOCSPResponse_FindResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, GetSignerCertificate, arginfo_TElOCSPResponse_GetSignerCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, IsSignerCertificate, arginfo_TElOCSPResponse_IsSignerCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, Validate, arginfo_TElOCSPResponse_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, GetOCSPResponseHash, arginfo_TElOCSPResponse_GetOCSPResponseHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, get_SignatureAlgorithm, arginfo_TElOCSPResponse_get_SignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, get_Certificates, arginfo_TElOCSPResponse_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, get_ResponderID, arginfo_TElOCSPResponse_get_ResponderID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, get_ProducedAt, arginfo_TElOCSPResponse_get_ProducedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, get_Responses, arginfo_TElOCSPResponse_get_Responses, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, get_ResponseCount, arginfo_TElOCSPResponse_get_ResponseCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, get_OnCertificateNeeded, arginfo_TElOCSPResponse_get_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, set_OnCertificateNeeded, arginfo_TElOCSPResponse_set_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPResponse, __construct, arginfo_TElOCSPResponse___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOCSPResponse(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOCSPResponse_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOCSPResponse", TElOCSPResponse_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElOCSPResponse_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFileOCSPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElFileOCSPClient, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFileOCSPClient_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileOCSPClient, PerformRequest)
{
	SBArrayZValInfo aiReply;
	TElOCSPServerErrorRaw fServerResultRaw;
	uint32_t _err;
	zval *zaReply;
	zval *zfServerResult;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zfServerResult, &zaReply) == SUCCESS) && PZVAL_IS_REF(zfServerResult) && (IS_LONG == Z_TYPE_P(zfServerResult)) && PZVAL_IS_REF(zaReply) && ((IS_STRING == Z_TYPE_P(zaReply)) || (IS_ARRAY == Z_TYPE_P(zaReply))))
	{
		int32_t l4OutResultRaw = 0;
		fServerResultRaw = (TElOCSPServerErrorRaw)Z_LVAL_P(zfServerResult);
		if (!SBGetByteArrayFromZVal(zaReply, &aiReply TSRMLS_CC)) RETURN_FALSE;
		_err = TElFileOCSPClient_PerformRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &fServerResultRaw, aiReply.data, &aiReply.len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaReply, &aiReply TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1284353318, 2, aiReply.data, &aiReply.len) TSRMLS_CC);
			((char *)aiReply.data)[aiReply.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiReply);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zfServerResult, (long)fServerResultRaw);
		SBSetByteArrayToZVal(&aiReply, zaReply);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileOCSPClient, get_OnOCSPValidationNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOCSPValidationNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFileOCSPClient_get_OnOCSPValidationNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileOCSPClient, set_OnOCSPValidationNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFileOCSPClient_set_OnOCSPValidationNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOCSPValidationNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOCSPValidationNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileOCSPClient, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFileOCSPClient_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileOCSPClient_SupportsLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileOCSPClient_PerformRequest, 0, 0, 2)
	ZEND_ARG_INFO(1, ServerResult)
	ZEND_ARG_INFO(1, Reply)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileOCSPClient_get_OnOCSPValidationNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileOCSPClient_set_OnOCSPValidationNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileOCSPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElFileOCSPClient_methods[] = {
	PHP_ME(TElFileOCSPClient, SupportsLocation, arginfo_TElFileOCSPClient_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileOCSPClient, PerformRequest, arginfo_TElFileOCSPClient_PerformRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileOCSPClient, get_OnOCSPValidationNeeded, arginfo_TElFileOCSPClient_get_OnOCSPValidationNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileOCSPClient, set_OnOCSPValidationNeeded, arginfo_TElFileOCSPClient_set_OnOCSPValidationNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileOCSPClient, __construct, arginfo_TElFileOCSPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFileOCSPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFileOCSPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFileOCSPClient", TElFileOCSPClient_methods);
	if (NULL == TElOCSPClient_ce_ptr)
		Register_TElOCSPClient(TSRMLS_C);
	TElFileOCSPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElOCSPClient_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomOCSPClientFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomOCSPClientFactory, SupportsLocation)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomOCSPClientFactory_SupportsLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomOCSPClientFactory, GetClientInstance)
{
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomOCSPClientFactory_GetClientInstance(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomOCSPClientFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomOCSPClientFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomOCSPClientFactory_SupportsLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomOCSPClientFactory_GetClientInstance, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomOCSPClientFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomOCSPClientFactory_methods[] = {
	PHP_ME(TElCustomOCSPClientFactory, SupportsLocation, arginfo_TElCustomOCSPClientFactory_SupportsLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomOCSPClientFactory, GetClientInstance, arginfo_TElCustomOCSPClientFactory_GetClientInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomOCSPClientFactory, __construct, arginfo_TElCustomOCSPClientFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomOCSPClientFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomOCSPClientFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomOCSPClientFactory", TElCustomOCSPClientFactory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomOCSPClientFactory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOCSPClientManager_ce_ptr = NULL;

SB_PHP_METHOD(TElOCSPClientManager, FindOCSPClientByLocation)
{
	char *sLocation;
	int sLocation_len;
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sLocation, &sLocation_len, &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClientManager_FindOCSPClientByLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sLocation, (int32_t)sLocation_len, SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClientManager, RegisterOCSPClientFactory)
{
	zval *oFactory;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFactory, TElCustomOCSPClientFactory_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOCSPClientManager_RegisterOCSPClientFactory(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFactory TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomOCSPClientFactory)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClientManager, UnregisterOCSPClientFactory)
{
	zval *oFactory;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFactory, TElCustomOCSPClientFactory_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOCSPClientManager_UnregisterOCSPClientFactory(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFactory TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomOCSPClientFactory)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClientManager, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClientManager_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClientManager_FindOCSPClientByLocation, 0, 0, 2)
	ZEND_ARG_INFO(0, Location)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClientManager_RegisterOCSPClientFactory, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Factory, TElCustomOCSPClientFactory, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClientManager_UnregisterOCSPClientFactory, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Factory, TElCustomOCSPClientFactory, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClientManager___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOCSPClientManager_methods[] = {
	PHP_ME(TElOCSPClientManager, FindOCSPClientByLocation, arginfo_TElOCSPClientManager_FindOCSPClientByLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClientManager, RegisterOCSPClientFactory, arginfo_TElOCSPClientManager_RegisterOCSPClientFactory, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClientManager, UnregisterOCSPClientFactory, arginfo_TElOCSPClientManager_UnregisterOCSPClientFactory, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClientManager, __construct, arginfo_TElOCSPClientManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOCSPClientManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOCSPClientManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOCSPClientManager", TElOCSPClientManager_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOCSPClientManager_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBOCSPClient, OCSPClientManagerAddRef)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBOCSPClient_OCSPClientManagerAddRef(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPClientManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOCSPClient, OCSPClientManagerRelease)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBOCSPClient_OCSPClientManagerRelease() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOCSPClient, GetOCSPCertID)
{
	long l4DigestAlg;
	SBArrayZValInfo aiaIssuerNameHash;
	SBArrayZValInfo aiIssuerKeyHash;
	uint32_t _err;
	zval *oCert;
	zval *oIssuer;
	zval *oSigner;
	zval *zaaIssuerNameHash;
	zval *zaIssuerKeyHash;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lzz", &oCert, TElX509Certificate_ce_ptr, &oIssuer, TElX509Certificate_ce_ptr, &l4DigestAlg, &zaaIssuerNameHash, &zaIssuerKeyHash) == SUCCESS) && PZVAL_IS_REF(zaaIssuerNameHash) && ((IS_STRING == Z_TYPE_P(zaaIssuerNameHash)) || (IS_ARRAY == Z_TYPE_P(zaaIssuerNameHash))) && PZVAL_IS_REF(zaIssuerKeyHash) && ((IS_STRING == Z_TYPE_P(zaIssuerKeyHash)) || (IS_ARRAY == Z_TYPE_P(zaIssuerKeyHash))))
	{
		if (!SBGetByteArrayFromZVal(zaaIssuerNameHash, &aiaIssuerNameHash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIssuerKeyHash, &aiIssuerKeyHash TSRMLS_CC)) RETURN_FALSE;
		_err = SBOCSPClient_GetOCSPCertID(SBGetObjectHandle(oCert TSRMLS_CC), SBGetObjectHandle(oIssuer TSRMLS_CC), (int32_t)l4DigestAlg, aiaIssuerNameHash.data, &aiaIssuerNameHash.len, aiIssuerKeyHash.data, &aiIssuerKeyHash.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaaIssuerNameHash, &aiaIssuerNameHash TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-691874869, 3, aiaIssuerNameHash.data, &aiaIssuerNameHash.len) TSRMLS_CC);
			((char *)aiaIssuerNameHash.data)[aiaIssuerNameHash.len] = 0;
			SBDetachDataFromZValAndResize(zaIssuerKeyHash, &aiIssuerKeyHash TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-691874869, 4, aiIssuerKeyHash.data, &aiIssuerKeyHash.len) TSRMLS_CC);
			((char *)aiIssuerKeyHash.data)[aiIssuerKeyHash.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiaIssuerNameHash);
			SBFreeArrayZValInfo(&aiIssuerKeyHash);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiaIssuerNameHash, zaaIssuerNameHash);
		SBSetByteArrayToZVal(&aiIssuerKeyHash, zaIssuerKeyHash);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lzz", &oSigner, TElPKCS7Issuer_ce_ptr, &oIssuer, TElX509Certificate_ce_ptr, &l4DigestAlg, &zaaIssuerNameHash, &zaIssuerKeyHash) == SUCCESS) && PZVAL_IS_REF(zaaIssuerNameHash) && ((IS_STRING == Z_TYPE_P(zaaIssuerNameHash)) || (IS_ARRAY == Z_TYPE_P(zaaIssuerNameHash))) && PZVAL_IS_REF(zaIssuerKeyHash) && ((IS_STRING == Z_TYPE_P(zaIssuerKeyHash)) || (IS_ARRAY == Z_TYPE_P(zaIssuerKeyHash))))
	{
		if (!SBGetByteArrayFromZVal(zaaIssuerNameHash, &aiaIssuerNameHash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIssuerKeyHash, &aiIssuerKeyHash TSRMLS_CC)) RETURN_FALSE;
		_err = SBOCSPClient_GetOCSPCertID_1(SBGetObjectHandle(oSigner TSRMLS_CC), SBGetObjectHandle(oIssuer TSRMLS_CC), (int32_t)l4DigestAlg, aiaIssuerNameHash.data, &aiaIssuerNameHash.len, aiIssuerKeyHash.data, &aiIssuerKeyHash.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaaIssuerNameHash, &aiaIssuerNameHash TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1339082539, 3, aiaIssuerNameHash.data, &aiaIssuerNameHash.len) TSRMLS_CC);
			((char *)aiaIssuerNameHash.data)[aiaIssuerNameHash.len] = 0;
			SBDetachDataFromZValAndResize(zaIssuerKeyHash, &aiIssuerKeyHash TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1339082539, 4, aiIssuerKeyHash.data, &aiIssuerKeyHash.len) TSRMLS_CC);
			((char *)aiIssuerKeyHash.data)[aiIssuerKeyHash.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiaIssuerNameHash);
			SBFreeArrayZValInfo(&aiIssuerKeyHash);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiaIssuerNameHash, zaaIssuerNameHash);
		SBSetByteArrayToZVal(&aiIssuerKeyHash, zaIssuerKeyHash);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElX509Certificate, integer, &array of byte|string, &array of byte|string) or (TElPKCS7Issuer, TElX509Certificate, integer, &array of byte|string, &array of byte|string)" TSRMLS_CC);
	}
}

void Register_SBOCSPClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBOCSPClientOption", NULL);
	TSBOCSPClientOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBOCSPClientOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBOCSPClientOption_ce_ptr, "ocoIncludeVersion", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBOCSPClientOption_ce_ptr, "ocoIncludeSupportedResponseTypes", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBOCSPClientOptions", NULL);
	TSBOCSPClientOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBOCSPClientOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBOCSPClientOptions_ce_ptr, "ocoIncludeVersion", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBOCSPClientOptions_ce_ptr, "ocoIncludeSupportedResponseTypes", 2)
}

void Register_SBOCSPClient_Aliases(TSRMLS_D)
{
	if (NULL == TElOCSPClient_ce_ptr)
		Register_TElOCSPClient(TSRMLS_C);
	zend_register_class_alias("ElOCSPClient", TElOCSPClient_ce_ptr);
	if (NULL == TElFileOCSPClient_ce_ptr)
		Register_TElFileOCSPClient(TSRMLS_C);
	zend_register_class_alias("ElFileOCSPClient", TElFileOCSPClient_ce_ptr);
	if (NULL == TElCustomOCSPClientFactory_ce_ptr)
		Register_TElCustomOCSPClientFactory(TSRMLS_C);
	zend_register_class_alias("ElCustomOCSPClientFactory", TElCustomOCSPClientFactory_ce_ptr);
	if (NULL == TElOCSPClientManager_ce_ptr)
		Register_TElOCSPClientManager(TSRMLS_C);
	zend_register_class_alias("ElOCSPClientManager", TElOCSPClientManager_ce_ptr);
}

