#include "sbocspcommon.h"

zend_class_entry *TElOCSPServerError_ce_ptr = NULL;

zend_class_entry *TElOCSPCertificateStatus_ce_ptr = NULL;

zend_class_entry *TElResponderIDType_ce_ptr = NULL;

void SB_CALLBACK TSBCertificateOCSPCheckEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pHashAlgOID[], int32_t szHashAlgOID, const uint8_t pIssuerNameHash[], int32_t szIssuerNameHash, const uint8_t pIssuerKeyHash[], int32_t szIssuerKeyHash, const uint8_t pCertificateSerial[], int32_t szCertificateSerial, TElOCSPCertificateStatusRaw * CertStatus, TSBCRLReasonFlagRaw * Reason, int64_t * RevocationTime, int64_t * ThisUpdate, int64_t * NextUpdate)
{
	zval *retval_ptr;
	zval **params[10];
	zval * zSender;
	zval * zHashAlgOID;
	zval * zIssuerNameHash;
	zval * zIssuerKeyHash;
	zval * zCertificateSerial;
	zval * zCertStatus;
	zval * zReason;
	zval * zRevocationTime;
	zval * zThisUpdate;
	zval * zNextUpdate;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHashAlgOID);
	ZVAL_STRINGL(zHashAlgOID, pHashAlgOID, szHashAlgOID, 1);
	MAKE_STD_ZVAL(zIssuerNameHash);
	ZVAL_STRINGL(zIssuerNameHash, pIssuerNameHash, szIssuerNameHash, 1);
	MAKE_STD_ZVAL(zIssuerKeyHash);
	ZVAL_STRINGL(zIssuerKeyHash, pIssuerKeyHash, szIssuerKeyHash, 1);
	MAKE_STD_ZVAL(zCertificateSerial);
	ZVAL_STRINGL(zCertificateSerial, pCertificateSerial, szCertificateSerial, 1);
	MAKE_STD_ZVAL(zCertStatus);
	ZVAL_LONG(zCertStatus, (long)*CertStatus);
	MAKE_STD_ZVAL(zReason);
	ZVAL_LONG(zReason, (long)*Reason);
	MAKE_STD_ZVAL(zRevocationTime);
	object_init_ex(zRevocationTime, php_date_get_date_ce());
	SBSetDateTime(zRevocationTime, *RevocationTime TSRMLS_CC);
	MAKE_STD_ZVAL(zThisUpdate);
	object_init_ex(zThisUpdate, php_date_get_date_ce());
	SBSetDateTime(zThisUpdate, *ThisUpdate TSRMLS_CC);
	MAKE_STD_ZVAL(zNextUpdate);
	object_init_ex(zNextUpdate, php_date_get_date_ce());
	SBSetDateTime(zNextUpdate, *NextUpdate TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHashAlgOID;
	params[2] = &zIssuerNameHash;
	params[3] = &zIssuerKeyHash;
	params[4] = &zCertificateSerial;
	params[5] = &zCertStatus;
	params[6] = &zReason;
	params[7] = &zRevocationTime;
	params[8] = &zThisUpdate;
	params[9] = &zNextUpdate;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 10, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHashAlgOID);
	zval_ptr_dtor(&zIssuerNameHash);
	zval_ptr_dtor(&zIssuerKeyHash);
	zval_ptr_dtor(&zCertificateSerial);
	*CertStatus = (TElOCSPCertificateStatusRaw)Z_LVAL_P(zCertStatus);
	zval_ptr_dtor(&zCertStatus);
	*Reason = (TSBCRLReasonFlagRaw)Z_LVAL_P(zReason);
	zval_ptr_dtor(&zReason);
	*RevocationTime = SBGetDateTime(zRevocationTime TSRMLS_CC);
	zval_ptr_dtor(&zRevocationTime);
	*ThisUpdate = SBGetDateTime(zThisUpdate TSRMLS_CC);
	zval_ptr_dtor(&zThisUpdate);
	*NextUpdate = SBGetDateTime(zNextUpdate TSRMLS_CC);
	zval_ptr_dtor(&zNextUpdate);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBOCSPSignatureValidateEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t * Valid)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zValid;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zValid);
	ZVAL_BOOL(zValid, (zend_bool)*Valid);

	params[0] = &zSender;
	params[1] = &zValid;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Valid = (int8_t)Z_BVAL_P(zValid);
	zval_ptr_dtor(&zValid);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBOCSPCertificateNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle * Certificate)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCertificate;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, *Certificate TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Certificate = SBGetObjectHandleCE(zCertificate, TElX509Certificate_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCertificate TSRMLS_CC);
	zval_ptr_dtor(&zCertificate);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElOCSPClass_ce_ptr = NULL;

SB_PHP_METHOD(TElOCSPClass, get_RequestorName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClass_get_RequestorName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGeneralName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClass, get_IncludeCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOCSPClass_get_IncludeCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClass, set_IncludeCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOCSPClass_set_IncludeCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClass, get_SigningCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClass_get_SigningCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClass, set_SigningCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOCSPClass_set_SigningCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClass, get_OnCertificateNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOCSPCertificateNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOCSPClass_get_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClass, set_OnCertificateNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOCSPClass_set_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOCSPCertificateNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOCSPCertificateNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOCSPClass, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOCSPClass_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClass_get_RequestorName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClass_get_IncludeCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClass_set_IncludeCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClass_get_SigningCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClass_set_SigningCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClass_get_OnCertificateNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClass_set_OnCertificateNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOCSPClass___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOCSPClass_methods[] = {
	PHP_ME(TElOCSPClass, get_RequestorName, arginfo_TElOCSPClass_get_RequestorName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClass, get_IncludeCertificates, arginfo_TElOCSPClass_get_IncludeCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClass, set_IncludeCertificates, arginfo_TElOCSPClass_set_IncludeCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClass, get_SigningCertStorage, arginfo_TElOCSPClass_get_SigningCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClass, set_SigningCertStorage, arginfo_TElOCSPClass_set_SigningCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClass, get_OnCertificateNeeded, arginfo_TElOCSPClass_get_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClass, set_OnCertificateNeeded, arginfo_TElOCSPClass_set_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElOCSPClass, __construct, arginfo_TElOCSPClass___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOCSPClass(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOCSPClass_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOCSPClass", TElOCSPClass_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElOCSPClass_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBOCSPCommon, ReasonFlagToEnum)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBOCSPCommon_ReasonFlagToEnum((TSBCRLReasonFlagRaw)fValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOCSPCommon, EnumToReasonFlag)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		TSBCRLReasonFlagRaw fOutResultRaw = 0;
		SBCheckError(SBOCSPCommon_EnumToReasonFlag((int32_t)l4Value, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOCSPCommon, ReadAsnInteger)
{
	SBArrayZValInfo aiIntBuf;
	uint32_t _err;
	zval *zaIntBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaIntBuf) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaIntBuf)) || (IS_ARRAY == Z_TYPE_P(zaIntBuf)) || (IS_NULL == Z_TYPE_P(zaIntBuf))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaIntBuf, &aiIntBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBOCSPCommon_ReadAsnInteger(aiIntBuf.data, aiIntBuf.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(773542451, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiIntBuf);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

void Register_SBOCSPCommon_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, ERROR_FACILITY_OCSP, SB_ERROR_FACILITY_OCSP, SB_ERROR_FACILITY_OCSP);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, ERROR_OCSP_PROTOCOL_ERROR_FLAG, SB_ERROR_OCSP_PROTOCOL_ERROR_FLAG, SB_ERROR_OCSP_PROTOCOL_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, SB_OCSP_ERROR_NO_CERTIFICATES, SB_OCSP_ERROR_NO_CERTIFICATES, SB_OCSP_ERROR_NO_CERTIFICATES);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, SB_OCSP_ERROR_NO_ISSUER_CERTIFICATES, SB_OCSP_ERROR_NO_ISSUER_CERTIFICATES, SB_OCSP_ERROR_NO_ISSUER_CERTIFICATES);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, SB_OCSP_ERROR_WRONG_DATA, SB_OCSP_ERROR_WRONG_DATA, SB_OCSP_ERROR_WRONG_DATA);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, SB_OCSP_ERROR_NO_EVENT_HANDLER, SB_OCSP_ERROR_NO_EVENT_HANDLER, SB_OCSP_ERROR_NO_EVENT_HANDLER);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, SB_OCSP_ERROR_NO_PARAMETERS, SB_OCSP_ERROR_NO_PARAMETERS, SB_OCSP_ERROR_NO_PARAMETERS);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, SB_OCSP_ERROR_NO_REPLY, SB_OCSP_ERROR_NO_REPLY, SB_OCSP_ERROR_NO_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, SB_OCSP_ERROR_WRONG_SIGNATURE, SB_OCSP_ERROR_WRONG_SIGNATURE, SB_OCSP_ERROR_WRONG_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, SB_OCSP_ERROR_UNSUPPORTED_ALGORITHM, SB_OCSP_ERROR_UNSUPPORTED_ALGORITHM, SB_OCSP_ERROR_UNSUPPORTED_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBOCSPCommon, SB_OCSP_ERROR_INVALID_RESPONSE, SB_OCSP_ERROR_INVALID_RESPONSE, SB_OCSP_ERROR_INVALID_RESPONSE);
	SB_REGISTER_STRING_CONSTANT(SBOCSPCommon, SB_OCSP_OID_BASIC_RESPONSE, SB_OCSP_OID_BASIC_RESPONSE, SB_OCSP_OID_BASIC_RESPONSE);
	SB_REGISTER_STRING_CONSTANT(SBOCSPCommon, SB_OCSP_OID_NONCE, SB_OCSP_OID_NONCE, SB_OCSP_OID_NONCE);
	SB_REGISTER_STRING_CONSTANT(SBOCSPCommon, SB_OCSP_OID_OCSP_RESPONSE, SB_OCSP_OID_OCSP_RESPONSE, SB_OCSP_OID_OCSP_RESPONSE);
	SB_REGISTER_STRING_CONSTANT(SBOCSPCommon, SB_OID_OCSP_RESPONSE, SB_OID_OCSP_RESPONSE, SB_OID_OCSP_RESPONSE);
}

void Register_SBOCSPCommon_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElOCSPServerError", NULL);
	TElOCSPServerError_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElOCSPServerError_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPServerError_ce_ptr, "oseSuccessful", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPServerError_ce_ptr, "oseMalformedRequest", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPServerError_ce_ptr, "oseInternalError", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPServerError_ce_ptr, "oseTryLater", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPServerError_ce_ptr, "oseUnused1", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPServerError_ce_ptr, "oseSigRequired", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPServerError_ce_ptr, "oseUnauthorized", 6)
	
	INIT_CLASS_ENTRY(ce, "TElOCSPCertificateStatus", NULL);
	TElOCSPCertificateStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElOCSPCertificateStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPCertificateStatus_ce_ptr, "csGood", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPCertificateStatus_ce_ptr, "csRevoked", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElOCSPCertificateStatus_ce_ptr, "csUnknown", 2)
	
	INIT_CLASS_ENTRY(ce, "TElResponderIDType", NULL);
	TElResponderIDType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElResponderIDType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElResponderIDType_ce_ptr, "ritName", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElResponderIDType_ce_ptr, "ritKeyHash", 1)
}

void Register_SBOCSPCommon_Aliases(TSRMLS_D)
{
	if (NULL == TElOCSPClass_ce_ptr)
		Register_TElOCSPClass(TSRMLS_C);
	zend_register_class_alias("ElOCSPClass", TElOCSPClass_ce_ptr);
}

