#include "sbpdfsecurity.h"

zend_class_entry *TSBPDFPublicKeySignatureType_ce_ptr = NULL;

zend_class_entry *TElPDFPasswordSecurityHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFPasswordSecurityHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, IsUserPasswordValid)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPasswordSecurityHandler_IsUserPasswordValid(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, IsOwnerPasswordValid)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPasswordSecurityHandler_IsOwnerPasswordValid(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPasswordSecurityHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1218976724, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPasswordSecurityHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1218976724, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, GetDescription_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPasswordSecurityHandler_GetDescription_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(705504363, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPasswordSecurityHandler_GetDescription(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(705504363, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPasswordSecurityHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, get_UserPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPasswordSecurityHandler_get_UserPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1791202380, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, set_UserPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPDFPasswordSecurityHandler_set_UserPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, get_OwnerPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPasswordSecurityHandler_get_OwnerPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1876877172, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, set_OwnerPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPDFPasswordSecurityHandler_set_OwnerPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, get_Permissions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPasswordSecurityHandler_get_Permissions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFPermissions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, get_RevisionNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPasswordSecurityHandler_get_RevisionNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, set_RevisionNumber)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFPasswordSecurityHandler_set_RevisionNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPasswordSecurityHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPasswordSecurityHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_IsUserPasswordValid, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_IsOwnerPasswordValid, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_GetDescription_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_get_UserPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_set_UserPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_get_OwnerPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_set_OwnerPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_get_Permissions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_get_RevisionNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler_set_RevisionNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPasswordSecurityHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFPasswordSecurityHandler_methods[] = {
	PHP_ME(TElPDFPasswordSecurityHandler, Reset, arginfo_TElPDFPasswordSecurityHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, IsUserPasswordValid, arginfo_TElPDFPasswordSecurityHandler_IsUserPasswordValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, IsOwnerPasswordValid, arginfo_TElPDFPasswordSecurityHandler_IsOwnerPasswordValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, GetName_Inst, arginfo_TElPDFPasswordSecurityHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, GetName, arginfo_TElPDFPasswordSecurityHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPDFPasswordSecurityHandler, GetDescription_Inst, arginfo_TElPDFPasswordSecurityHandler_GetDescription_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, GetDescription, arginfo_TElPDFPasswordSecurityHandler_GetDescription, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPDFPasswordSecurityHandler, ClassType, arginfo_TElPDFPasswordSecurityHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPDFPasswordSecurityHandler, get_UserPassword, arginfo_TElPDFPasswordSecurityHandler_get_UserPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, set_UserPassword, arginfo_TElPDFPasswordSecurityHandler_set_UserPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, get_OwnerPassword, arginfo_TElPDFPasswordSecurityHandler_get_OwnerPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, set_OwnerPassword, arginfo_TElPDFPasswordSecurityHandler_set_OwnerPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, get_Permissions, arginfo_TElPDFPasswordSecurityHandler_get_Permissions, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, get_RevisionNumber, arginfo_TElPDFPasswordSecurityHandler_get_RevisionNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, set_RevisionNumber, arginfo_TElPDFPasswordSecurityHandler_set_RevisionNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPasswordSecurityHandler, __construct, arginfo_TElPDFPasswordSecurityHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFPasswordSecurityHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFPasswordSecurityHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFPasswordSecurityHandler", TElPDFPasswordSecurityHandler_methods);
	if (NULL == TElPDFSecurityHandler_ce_ptr)
		Register_TElPDFSecurityHandler(TSRMLS_C);
	TElPDFPasswordSecurityHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFSecurityHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFPublicKeySecurityHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeySecurityHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, AddRecipientGroup)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeySecurityHandler_AddRecipientGroup(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, RemoveRecipientGroup)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeySecurityHandler_RemoveRecipientGroup(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, ClearRecipientGroups)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeySecurityHandler_ClearRecipientGroups(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPublicKeySecurityHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(986111446, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPublicKeySecurityHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(986111446, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, GetDescription_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPublicKeySecurityHandler_GetDescription_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1659409968, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFPublicKeySecurityHandler_GetDescription(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1659409968, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, GetSignerCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_GetSignerCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_RecipientGroups)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_RecipientGroups(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFPublicKeyRecipientGroup_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_CertIDs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_CertIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Issuer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_Timestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_Timestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_RecipientGroupCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_RecipientGroupCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeySecurityHandler_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMemoryCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_SignatureType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPDFPublicKeySignatureTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_SignatureType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, set_SignatureType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeySecurityHandler_set_SignatureType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPDFPublicKeySignatureTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeySecurityHandler_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_Detached)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_Detached(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, set_Detached)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeySecurityHandler_set_Detached(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_CertIDCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_CertIDCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_TimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_TimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_RevocationInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_RevocationInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFPublicKeyRevocationInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_LastValidationResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_LastValidationResult(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_SignatureContents)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFPublicKeySecurityHandler_get_SignatureContents(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(999625635, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_TSPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_TSPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomTSPClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, set_TSPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeySecurityHandler_set_TSPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, get_IgnoreTimestampFailure)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPublicKeySecurityHandler_get_IgnoreTimestampFailure(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, set_IgnoreTimestampFailure)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeySecurityHandler_set_IgnoreTimestampFailure(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeySecurityHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeySecurityHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_AddRecipientGroup, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_RemoveRecipientGroup, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_ClearRecipientGroups, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_GetDescription_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_GetSignerCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_RecipientGroups, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_CertIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_Timestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_RecipientGroupCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_SignatureType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_set_SignatureType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_Detached, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_set_Detached, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_CertIDCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_TimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_RevocationInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_LastValidationResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_SignatureContents, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_TSPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_set_TSPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomTSPClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_get_IgnoreTimestampFailure, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler_set_IgnoreTimestampFailure, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeySecurityHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFPublicKeySecurityHandler_methods[] = {
	PHP_ME(TElPDFPublicKeySecurityHandler, Reset, arginfo_TElPDFPublicKeySecurityHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, AddRecipientGroup, arginfo_TElPDFPublicKeySecurityHandler_AddRecipientGroup, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, RemoveRecipientGroup, arginfo_TElPDFPublicKeySecurityHandler_RemoveRecipientGroup, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, ClearRecipientGroups, arginfo_TElPDFPublicKeySecurityHandler_ClearRecipientGroups, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, GetName_Inst, arginfo_TElPDFPublicKeySecurityHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, GetName, arginfo_TElPDFPublicKeySecurityHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, GetDescription_Inst, arginfo_TElPDFPublicKeySecurityHandler_GetDescription_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, GetDescription, arginfo_TElPDFPublicKeySecurityHandler_GetDescription, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, GetSignerCertificate, arginfo_TElPDFPublicKeySecurityHandler_GetSignerCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, ClassType, arginfo_TElPDFPublicKeySecurityHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_RecipientGroups, arginfo_TElPDFPublicKeySecurityHandler_get_RecipientGroups, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_CertIDs, arginfo_TElPDFPublicKeySecurityHandler_get_CertIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_Timestamps, arginfo_TElPDFPublicKeySecurityHandler_get_Timestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_RecipientGroupCount, arginfo_TElPDFPublicKeySecurityHandler_get_RecipientGroupCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_CertStorage, arginfo_TElPDFPublicKeySecurityHandler_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, set_CertStorage, arginfo_TElPDFPublicKeySecurityHandler_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_Certificates, arginfo_TElPDFPublicKeySecurityHandler_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_SignatureType, arginfo_TElPDFPublicKeySecurityHandler_get_SignatureType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, set_SignatureType, arginfo_TElPDFPublicKeySecurityHandler_set_SignatureType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_HashAlgorithm, arginfo_TElPDFPublicKeySecurityHandler_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, set_HashAlgorithm, arginfo_TElPDFPublicKeySecurityHandler_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_Detached, arginfo_TElPDFPublicKeySecurityHandler_get_Detached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, set_Detached, arginfo_TElPDFPublicKeySecurityHandler_set_Detached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_CertIDCount, arginfo_TElPDFPublicKeySecurityHandler_get_CertIDCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_TimestampCount, arginfo_TElPDFPublicKeySecurityHandler_get_TimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_RevocationInfo, arginfo_TElPDFPublicKeySecurityHandler_get_RevocationInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_LastValidationResult, arginfo_TElPDFPublicKeySecurityHandler_get_LastValidationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_SignatureContents, arginfo_TElPDFPublicKeySecurityHandler_get_SignatureContents, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_TSPClient, arginfo_TElPDFPublicKeySecurityHandler_get_TSPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, set_TSPClient, arginfo_TElPDFPublicKeySecurityHandler_set_TSPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, get_IgnoreTimestampFailure, arginfo_TElPDFPublicKeySecurityHandler_get_IgnoreTimestampFailure, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, set_IgnoreTimestampFailure, arginfo_TElPDFPublicKeySecurityHandler_set_IgnoreTimestampFailure, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeySecurityHandler, __construct, arginfo_TElPDFPublicKeySecurityHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFPublicKeySecurityHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFPublicKeySecurityHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFPublicKeySecurityHandler", TElPDFPublicKeySecurityHandler_methods);
	if (NULL == TElPDFSecurityHandler_ce_ptr)
		Register_TElPDFSecurityHandler(TSRMLS_C);
	TElPDFPublicKeySecurityHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFSecurityHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFPublicKeyRecipientGroup_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, AddRecipient)
{
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRecipientGroup_AddRecipient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, RemoveRecipient)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRecipientGroup_RemoveRecipient(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, ClearRecipients)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRecipientGroup_ClearRecipients(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, get_Recipients)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeyRecipientGroup_get_Recipients(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, get_RecipientInfos)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeyRecipientGroup_get_RecipientInfos(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Issuer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, get_RecipientCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRecipientGroup_get_RecipientCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, get_RecipientInfoCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRecipientGroup_get_RecipientInfoCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, get_KeyEncryptionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRecipientGroup_get_KeyEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, set_KeyEncryptionAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRecipientGroup_set_KeyEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, get_Permissions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeyRecipientGroup_get_Permissions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFPermissions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRecipientGroup, __construct)
{
	zval *oMsg;
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeyRecipientGroup_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oMsg, TElPKCS7Message_ce_ptr, &oOwner, TElPDFPublicKeySecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeyRecipientGroup_Create_1(SBGetObjectHandle(oMsg TSRMLS_CC), SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPKCS7Message, TElPDFPublicKeySecurityHandler)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_AddRecipient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_RemoveRecipient, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_ClearRecipients, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_get_Recipients, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_get_RecipientInfos, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_get_RecipientCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_get_RecipientInfoCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_get_KeyEncryptionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_set_KeyEncryptionAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup_get_Permissions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRecipientGroup___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Msg, TElPKCS7Message, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFPublicKeySecurityHandler, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFPublicKeyRecipientGroup_methods[] = {
	PHP_ME(TElPDFPublicKeyRecipientGroup, AddRecipient, arginfo_TElPDFPublicKeyRecipientGroup_AddRecipient, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, RemoveRecipient, arginfo_TElPDFPublicKeyRecipientGroup_RemoveRecipient, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, ClearRecipients, arginfo_TElPDFPublicKeyRecipientGroup_ClearRecipients, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, get_Recipients, arginfo_TElPDFPublicKeyRecipientGroup_get_Recipients, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, get_RecipientInfos, arginfo_TElPDFPublicKeyRecipientGroup_get_RecipientInfos, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, get_RecipientCount, arginfo_TElPDFPublicKeyRecipientGroup_get_RecipientCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, get_RecipientInfoCount, arginfo_TElPDFPublicKeyRecipientGroup_get_RecipientInfoCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, get_KeyEncryptionAlgorithm, arginfo_TElPDFPublicKeyRecipientGroup_get_KeyEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, set_KeyEncryptionAlgorithm, arginfo_TElPDFPublicKeyRecipientGroup_set_KeyEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, get_Permissions, arginfo_TElPDFPublicKeyRecipientGroup_get_Permissions, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRecipientGroup, __construct, arginfo_TElPDFPublicKeyRecipientGroup___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFPublicKeyRecipientGroup(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFPublicKeyRecipientGroup_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFPublicKeyRecipientGroup", TElPDFPublicKeyRecipientGroup_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPDFPublicKeyRecipientGroup_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFPublicKeyRevocationInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, Assign)
{
	zend_bool bClear;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElPDFPublicKeyRevocationInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRevocationInfo_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElPDFPublicKeyRevocationInfo_ce_ptr, &bClear) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRevocationInfo_Assign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bClear) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFPublicKeyRevocationInfo) or (TElPDFPublicKeyRevocationInfo, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, AddCRL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRevocationInfo_AddCRL(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, RemoveCRL)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRevocationInfo_RemoveCRL(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, ClearCRLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRevocationInfo_ClearCRLs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, ContainsCRL)
{
	zval *oCrl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCrl, TElCertificateRevocationList_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRevocationInfo_ContainsCRL(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCrl TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, AddOCSPResponse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRevocationInfo_AddOCSPResponse(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, RemoveOCSPRespose)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRevocationInfo_RemoveOCSPRespose(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, ClearOCSPResponses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRevocationInfo_ClearOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, ContainsOCSPResponse)
{
	SBArrayZValInfo aiResponse;
	zval *zaResponse;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaResponse) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaResponse)) || (IS_ARRAY == Z_TYPE_P(zaResponse)) || (IS_NULL == Z_TYPE_P(zaResponse))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaResponse, &aiResponse TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFPublicKeyRevocationInfo_ContainsOCSPResponse(SBGetObjectHandle(getThis() TSRMLS_CC), aiResponse.data, aiResponse.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiResponse);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFPublicKeyRevocationInfo_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRevocationInfo_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, get_CRLs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeyRevocationInfo_get_CRLs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateRevocationList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, get_OCSPResponses)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFPublicKeyRevocationInfo_get_OCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1444521565, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, set_OCSPResponses)
{
	long l4Index;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFPublicKeyRevocationInfo_set_OCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, get_CRLCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRevocationInfo_get_CRLCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, get_OCSPResponseCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFPublicKeyRevocationInfo_get_OCSPResponseCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeyRevocationInfo_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMemoryCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, get_OtherInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeyRevocationInfo_get_OtherInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPublicKeyRevocationInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPublicKeyRevocationInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElPDFPublicKeyRevocationInfo, 1)
	ZEND_ARG_INFO(0, Clear)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_AddCRL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_RemoveCRL, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_ClearCRLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_ContainsCRL, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Crl, TElCertificateRevocationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_AddOCSPResponse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_RemoveOCSPRespose, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_ClearOCSPResponses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_ContainsOCSPResponse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Response, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_get_CRLs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_get_OCSPResponses, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_set_OCSPResponses, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_get_CRLCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_get_OCSPResponseCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo_get_OtherInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPublicKeyRevocationInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFPublicKeyRevocationInfo_methods[] = {
	PHP_ME(TElPDFPublicKeyRevocationInfo, Assign, arginfo_TElPDFPublicKeyRevocationInfo_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, AddCRL, arginfo_TElPDFPublicKeyRevocationInfo_AddCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, RemoveCRL, arginfo_TElPDFPublicKeyRevocationInfo_RemoveCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, ClearCRLs, arginfo_TElPDFPublicKeyRevocationInfo_ClearCRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, ContainsCRL, arginfo_TElPDFPublicKeyRevocationInfo_ContainsCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, AddOCSPResponse, arginfo_TElPDFPublicKeyRevocationInfo_AddOCSPResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, RemoveOCSPRespose, arginfo_TElPDFPublicKeyRevocationInfo_RemoveOCSPRespose, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, ClearOCSPResponses, arginfo_TElPDFPublicKeyRevocationInfo_ClearOCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, ContainsOCSPResponse, arginfo_TElPDFPublicKeyRevocationInfo_ContainsOCSPResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, Clear, arginfo_TElPDFPublicKeyRevocationInfo_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, IsEmpty, arginfo_TElPDFPublicKeyRevocationInfo_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, get_CRLs, arginfo_TElPDFPublicKeyRevocationInfo_get_CRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, get_OCSPResponses, arginfo_TElPDFPublicKeyRevocationInfo_get_OCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, set_OCSPResponses, arginfo_TElPDFPublicKeyRevocationInfo_set_OCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, get_CRLCount, arginfo_TElPDFPublicKeyRevocationInfo_get_CRLCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, get_OCSPResponseCount, arginfo_TElPDFPublicKeyRevocationInfo_get_OCSPResponseCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, get_Certificates, arginfo_TElPDFPublicKeyRevocationInfo_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, get_OtherInfo, arginfo_TElPDFPublicKeyRevocationInfo_get_OtherInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPublicKeyRevocationInfo, __construct, arginfo_TElPDFPublicKeyRevocationInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFPublicKeyRevocationInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFPublicKeyRevocationInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFPublicKeyRevocationInfo", TElPDFPublicKeyRevocationInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPDFPublicKeyRevocationInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPDFSecurity_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBPDFSecurity, SPDFNoSigningCertificate, SB_SPDFNoSigningCertificate, SB_SPDFNoSigningCertificate);
	SB_REGISTER_STRING_CONSTANT(SBPDFSecurity, SPDFInvalidPKCS7Data, SB_SPDFInvalidPKCS7Data, SB_SPDFInvalidPKCS7Data);
	SB_REGISTER_STRING_CONSTANT(SBPDFSecurity, SPDFTSPClientNotFound, SB_SPDFTSPClientNotFound, SB_SPDFTSPClientNotFound);
}

void Register_SBPDFSecurity_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPDFPublicKeySignatureType", NULL);
	TSBPDFPublicKeySignatureType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPDFPublicKeySignatureType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPDFPublicKeySignatureType_ce_ptr, "pstX509RSASHA1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPDFPublicKeySignatureType_ce_ptr, "pstPKCS7SHA1", 1)
}

void Register_SBPDFSecurity_Aliases(TSRMLS_D)
{
	if (NULL == TElPDFPasswordSecurityHandler_ce_ptr)
		Register_TElPDFPasswordSecurityHandler(TSRMLS_C);
	zend_register_class_alias("ElPDFPasswordSecurityHandler", TElPDFPasswordSecurityHandler_ce_ptr);
	if (NULL == TElPDFPublicKeySecurityHandler_ce_ptr)
		Register_TElPDFPublicKeySecurityHandler(TSRMLS_C);
	zend_register_class_alias("ElPDFPublicKeySecurityHandler", TElPDFPublicKeySecurityHandler_ce_ptr);
	if (NULL == TElPDFPublicKeyRecipientGroup_ce_ptr)
		Register_TElPDFPublicKeyRecipientGroup(TSRMLS_C);
	zend_register_class_alias("ElPDFPublicKeyRecipientGroup", TElPDFPublicKeyRecipientGroup_ce_ptr);
}

