#include "sbpgputils.h"

SB_PHP_METHOD(TSBKeyID, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBKeyID));
		intern->len = sizeof(TSBKeyID);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBKeyID, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBKeyID));
}

zend_class_entry *TSBKeyID_ce_ptr = NULL;

static zend_function_entry TSBKeyID_methods[] = {
	PHP_ME(TSBKeyID, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBKeyID, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSBKeyID(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBKeyID_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBKeyID", TSBKeyID_methods);
	TSBKeyID_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBPGPSignatureMaterial, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBPGPSignatureMaterial));
		intern->len = sizeof(TSBPGPSignatureMaterial);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBPGPSignatureMaterial, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBPGPSignatureMaterial));
}

zend_class_entry *TSBPGPSignatureMaterial_ce_ptr = NULL;

static zend_function_entry TSBPGPSignatureMaterial_methods[] = {
	PHP_ME(TSBPGPSignatureMaterial, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPGPSignatureMaterial, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSBPGPSignatureMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBPGPSignatureMaterial_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBPGPSignatureMaterial", TSBPGPSignatureMaterial_methods);
	TSBPGPSignatureMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBPGPEncryptedSymmetricKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBPGPEncryptedSymmetricKey));
		intern->len = sizeof(TSBPGPEncryptedSymmetricKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBPGPEncryptedSymmetricKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBPGPEncryptedSymmetricKey));
}

zend_class_entry *TSBPGPEncryptedSymmetricKey_ce_ptr = NULL;

static zend_function_entry TSBPGPEncryptedSymmetricKey_methods[] = {
	PHP_ME(TSBPGPEncryptedSymmetricKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPGPEncryptedSymmetricKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSBPGPEncryptedSymmetricKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBPGPEncryptedSymmetricKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBPGPEncryptedSymmetricKey", TSBPGPEncryptedSymmetricKey_methods);
	TSBPGPEncryptedSymmetricKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBPGPSignatureType_ce_ptr = NULL;

zend_class_entry *TSBPGPSignatureExtension_ce_ptr = NULL;

SB_PHP_FUNCTION(SBPGPUtils, UTCTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBPGPUtils_UTCTime(&dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, TimestampToDateTime)
{
	long u4Timestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Timestamp) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBPGPUtils_TimestampToDateTime((uint32_t)u4Timestamp, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, DateTimeToTimestamp)
{
	zval *dtDateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtDateTime, php_date_get_date_ce()) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_DateTimeToTimestamp(SBGetDateTime(dtDateTime TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, ReadMPInt)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	TLInt * proDest;
	zval *oDest;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllO", &zaBuffer, &l4Index, &l4Size, &oDest, TLInt_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(oDest))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		proDest = (TLInt *)SBGetStructPointer(oDest TSRMLS_CC);
		SBCheckError(SBPGPUtils_ReadMPInt(aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size, &proDest, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		SBSetStructPointer(oDest, proDest, sizeof(TLInt) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, WriteMPInt)
{
	uint32_t _err;
	zval *oSrc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSrc, TLInt_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPGPUtils_WriteMPInt((TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(296691847, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt)" TSRMLS_CC);
	}
}

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_FUNCTION(SBPGPUtils, WriteMPInt2)
{
	SBArrayZValInfo aiSrc;
	uint32_t _err;
	zval *zaSrc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaSrc) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSrc)) || (IS_ARRAY == Z_TYPE_P(zaSrc)) || (IS_NULL == Z_TYPE_P(zaSrc))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaSrc, &aiSrc TSRMLS_CC)) RETURN_FALSE;
		_err = SBPGPUtils_WriteMPInt2(aiSrc.data, aiSrc.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-967208149, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSrc);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

SB_PHP_FUNCTION(SBPGPUtils, GetPGPPacketHeaderSize)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_GetPGPPacketHeaderSize(aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, GetSigSubpktTypeByExtension)
{
	long fExtType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fExtType) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(SBPGPUtils_GetSigSubpktTypeByExtension((TSBPGPSignatureExtensionRaw)fExtType, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, WriteSizeInt)
{
	int32_t l4ResSizeRaw;
	long u4Size;
	SBArrayZValInfo piBuffer;
	zval *zl4ResSize;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &u4Size, &zpBuffer, &zl4ResSize) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4ResSize) && (IS_LONG == Z_TYPE_P(zl4ResSize)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4ResSizeRaw = (int32_t)Z_LVAL_P(zl4ResSize);
		SBCheckError(SBPGPUtils_WriteSizeInt((uint32_t)u4Size, piBuffer.data, &l4ResSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4ResSize, (long)l4ResSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, MPIntToByteArray)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo aiDest;
	SBArrayZValInfo aiSrc;
	uint32_t _err;
	zval *zaDest;
	zval *zaSrc;
	zval *zl4OutSize;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzz", &zaSrc, &zaDest, &zl4OutSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSrc)) || (IS_ARRAY == Z_TYPE_P(zaSrc)) || (IS_NULL == Z_TYPE_P(zaSrc))) && PZVAL_IS_REF(zaDest) && ((IS_STRING == Z_TYPE_P(zaDest)) || (IS_ARRAY == Z_TYPE_P(zaDest))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetByteArrayFromZVal(zaSrc, &aiSrc TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDest, &aiDest TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		_err = SBPGPUtils_MPIntToByteArray(aiSrc.data, aiSrc.len, aiDest.data, &aiDest.len, &l4OutSizeRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaDest, &aiDest TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-165285324, 1, aiDest.data, &aiDest.len) TSRMLS_CC);
			((char *)aiDest.data)[aiDest.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiDest);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSrc);
		SBSetByteArrayToZVal(&aiDest, zaDest);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, IsCorrectHashAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_IsCorrectHashAlgorithm((int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, IsCorrectSymmetricAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_IsCorrectSymmetricAlgorithm((int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, AlgorithmCanSign)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_AlgorithmCanSign((int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, AlgorithmCanEncrypt)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_AlgorithmCanEncrypt((int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, TranslateMDAlgorithmFromPGP)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_TranslateMDAlgorithmFromPGP((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, TranslateMDAlgorithmToPGP)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_TranslateMDAlgorithmToPGP((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, TranslateSKAlgorithmFromPGP)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_TranslateSKAlgorithmFromPGP((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, TranslateSKAlgorithmToPGP)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_TranslateSKAlgorithmToPGP((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, TranslateMDAlgorithmToECDSA)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_TranslateMDAlgorithmToECDSA((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, AddPKCS1Prefix)
{
	long l4Algorithm;
	SBArrayZValInfo aiHash;
	uint32_t _err;
	zval *zaHash;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaHash, &l4Algorithm) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHash)) || (IS_ARRAY == Z_TYPE_P(zaHash)) || (IS_NULL == Z_TYPE_P(zaHash))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaHash, &aiHash TSRMLS_CC)) RETURN_FALSE;
		_err = SBPGPUtils_AddPKCS1Prefix(aiHash.data, aiHash.len, (int32_t)l4Algorithm, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(788156586, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHash);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, SymmetricInitialize)
{
	long l4Algorithm;
	SBArrayZValInfo aiInitialVector;
	SBArrayZValInfo aiKey;
	TElClassHandle hoCrypto;
	zval *oCrypto;
	zval *zaInitialVector;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lOzz", &l4Algorithm, &oCrypto, TElSymmetricCrypto_ce_ptr, &zaKey, &zaInitialVector) == SUCCESS) && PZVAL_IS_REF(oCrypto) && (IS_OBJECT == Z_TYPE_P(oCrypto)) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaInitialVector)) || (IS_ARRAY == Z_TYPE_P(zaInitialVector)) || (IS_NULL == Z_TYPE_P(zaInitialVector))))
	{
		hoCrypto = SBGetObjectHandle(oCrypto TSRMLS_CC);
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaInitialVector, &aiInitialVector TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_SymmetricInitialize((int32_t)l4Algorithm, &hoCrypto, aiKey.data, aiKey.len, aiInitialVector.data, aiInitialVector.len) TSRMLS_CC);
		SBUpdateObjectHandle(oCrypto, hoCrypto TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiInitialVector);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &TElSymmetricCrypto, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, SymmetricFinalize)
{
	TElClassHandle hoCrypto;
	zval *oCrypto;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oCrypto, TElSymmetricCrypto_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCrypto) && (IS_OBJECT == Z_TYPE_P(oCrypto)))
	{
		hoCrypto = SBGetObjectHandle(oCrypto TSRMLS_CC);
		SBCheckError(SBPGPUtils_SymmetricFinalize(&hoCrypto) TSRMLS_CC);
		SBUpdateObjectHandle(oCrypto, hoCrypto TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElSymmetricCrypto)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, MPIntSize)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_MPIntSize(aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, MPIntBitCount)
{
	SBArrayZValInfo aiMPInt;
	zval *zaMPInt;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaMPInt) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMPInt)) || (IS_ARRAY == Z_TYPE_P(zaMPInt)) || (IS_NULL == Z_TYPE_P(zaMPInt))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMPInt, &aiMPInt TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_MPIntBitCount(aiMPInt.data, aiMPInt.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMPInt);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, CRC24)
{
	long l4Size;
	long u4Init;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zpBuffer, &l4Size, &u4Init) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_CRC24(piBuffer.data, (int32_t)l4Size, (uint32_t)u4Init, &u4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, CalculateChecksum)
{
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint16_t u2OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_CalculateChecksum(aiBuffer.data, aiBuffer.len, &u2OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_FUNCTION(SBPGPUtils, ToBase64_32)
{
	long l4Index;
	SBArrayZValInfo aiInBuffer;
	SBArrayZValInfo aiOutBuffer;
	uint32_t _err;
	zval *zaInBuffer;
	zval *zaOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaInBuffer, &l4Index, &zaOutBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuffer)) || (IS_ARRAY == Z_TYPE_P(zaInBuffer)) || (IS_NULL == Z_TYPE_P(zaInBuffer))) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaInBuffer, &aiInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBPGPUtils_ToBase64_32(aiInBuffer.data, aiInBuffer.len, (int32_t)l4Index, aiOutBuffer.data, &aiOutBuffer.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-158631730, 2, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuffer);
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &array of byte|string)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

SB_PHP_FUNCTION(SBPGPUtils, ToBase64_2)
{
	long l4Index;
	SBArrayZValInfo aiInBuffer;
	SBArrayZValInfo aiOutBuffer;
	uint32_t _err;
	zval *zaInBuffer;
	zval *zaOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaInBuffer, &l4Index, &zaOutBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuffer)) || (IS_ARRAY == Z_TYPE_P(zaInBuffer)) || (IS_NULL == Z_TYPE_P(zaInBuffer))) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaInBuffer, &aiInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBPGPUtils_ToBase64_2(aiInBuffer.data, aiInBuffer.len, (int32_t)l4Index, aiOutBuffer.data, &aiOutBuffer.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1092323195, 2, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuffer);
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, ToBase64_1)
{
	long l4Index;
	SBArrayZValInfo aiInBuffer;
	SBArrayZValInfo aiOutBuffer;
	uint32_t _err;
	zval *zaInBuffer;
	zval *zaOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaInBuffer, &l4Index, &zaOutBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuffer)) || (IS_ARRAY == Z_TYPE_P(zaInBuffer)) || (IS_NULL == Z_TYPE_P(zaInBuffer))) && PZVAL_IS_REF(zaOutBuffer) && ((IS_STRING == Z_TYPE_P(zaOutBuffer)) || (IS_ARRAY == Z_TYPE_P(zaOutBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaInBuffer, &aiInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuffer, &aiOutBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBPGPUtils_ToBase64_1(aiInBuffer.data, aiInBuffer.len, (int32_t)l4Index, aiOutBuffer.data, &aiOutBuffer.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuffer, &aiOutBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-468456425, 2, aiOutBuffer.data, &aiOutBuffer.len) TSRMLS_CC);
			((char *)aiOutBuffer.data)[aiOutBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuffer);
		SBSetByteArrayToZVal(&aiOutBuffer, zaOutBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, SKGetBlockSize)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_SKGetBlockSize((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, SKGetKeySize)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_SKGetKeySize((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, CreateAndInitRandom)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPGPUtils_CreateAndInitRandom(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRandom_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, Max64)
{
	long l8X;
	long l8Y;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8X, &l8Y) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBPGPUtils_Max64((int64_t)l8X, (int64_t)l8Y, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, Min64)
{
	long l8X;
	long l8Y;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8X, &l8Y) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBPGPUtils_Min64((int64_t)l8X, (int64_t)l8Y, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, IsPublicKeyEncryptionAlgorithm)
{
	long l4Alg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_IsPublicKeyEncryptionAlgorithm((int32_t)l4Alg, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, IsPublicKeySigningAlgorithm)
{
	long l4Alg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_IsPublicKeySigningAlgorithm((int32_t)l4Alg, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, AlgorithmMPIntsPublic)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_AlgorithmMPIntsPublic((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, AlgorithmMPIntsSecret)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_AlgorithmMPIntsSecret((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, CompareKeyID)
{
	zval *oID1;
	zval *oID2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oID1, TSBKeyID_ce_ptr, &oID2, TSBKeyID_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_CompareKeyID((TSBKeyID *)SBGetStructPointer(oID1 TSRMLS_CC), (TSBKeyID *)SBGetStructPointer(oID2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBKeyID, TSBKeyID)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, CompareKeyFP)
{
	SBArrayZValInfo aiFP1;
	SBArrayZValInfo aiFP2;
	zval *zaFP1;
	zval *zaFP2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaFP1, &zaFP2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaFP1)) || (IS_ARRAY == Z_TYPE_P(zaFP1)) || (IS_NULL == Z_TYPE_P(zaFP1))) && ((IS_STRING == Z_TYPE_P(zaFP2)) || (IS_ARRAY == Z_TYPE_P(zaFP2)) || (IS_NULL == Z_TYPE_P(zaFP2))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaFP1, &aiFP1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaFP2, &aiFP2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_CompareKeyFP(aiFP1.data, aiFP1.len, aiFP2.data, aiFP2.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiFP1);
		SBFreeArrayZValInfo(&aiFP2);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, CompareKeyIDArrays)
{
	SBArrayZValInfo aiID1;
	SBArrayZValInfo aiID2;
	zval *zaID1;
	zval *zaID2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaID1, &zaID2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaID1)) || (IS_ARRAY == Z_TYPE_P(zaID1)) || (IS_NULL == Z_TYPE_P(zaID1))) && ((IS_STRING == Z_TYPE_P(zaID2)) || (IS_ARRAY == Z_TYPE_P(zaID2)) || (IS_NULL == Z_TYPE_P(zaID2))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaID1, &aiID1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaID2, &aiID2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_CompareKeyIDArrays(aiID1.data, aiID1.len, aiID2.data, aiID2.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiID1);
		SBFreeArrayZValInfo(&aiID2);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, GetSymmetricKeyAlgorithmName)
{
	long l4Alg;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBPGPUtils_GetSymmetricKeyAlgorithmName((int32_t)l4Alg, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1734895530, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, GetSymmetricKeyAlgorithmByName)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_GetSymmetricKeyAlgorithmByName(sName, (int32_t)sName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, FormatPKCS1)
{
	long u1BlockType;
	SBArrayZValInfo aiData;
	SBArrayZValInfo aiModulus;
	uint32_t _err;
	zval *oModulus;
	zval *zaData;
	zval *zaModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaModulus, &zaData, &u1BlockType) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaModulus)) || (IS_ARRAY == Z_TYPE_P(zaModulus)) || (IS_NULL == Z_TYPE_P(zaModulus))) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaModulus, &aiModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBPGPUtils_FormatPKCS1(aiModulus.data, aiModulus.len, aiData.data, aiData.len, (uint8_t)u1BlockType, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(299555139, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiModulus);
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zl", &oModulus, TLInt_ce_ptr, &zaData, &u1BlockType) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBPGPUtils_FormatPKCS1_1((TLInt *)SBGetStructPointer(oModulus TSRMLS_CC), aiData.data, aiData.len, (uint8_t)u1BlockType, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(264231217, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, integer) or (TLInt, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, UnformatPKCS1)
{
	SBArrayZValInfo aiData;
	uint32_t _err;
	uint8_t u1BlockTypeRaw;
	zval *oData;
	zval *zaData;
	zval *zu1BlockType;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaData, &zu1BlockType) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))) && PZVAL_IS_REF(zu1BlockType) && (IS_LONG == Z_TYPE_P(zu1BlockType)))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		u1BlockTypeRaw = (uint8_t)Z_LVAL_P(zu1BlockType);
		_err = SBPGPUtils_UnformatPKCS1(aiData.data, aiData.len, &u1BlockTypeRaw, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(132469661, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		ZVAL_LONG(zu1BlockType, (long)u1BlockTypeRaw);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oData, TLInt_ce_ptr, &zu1BlockType) == SUCCESS) && PZVAL_IS_REF(zu1BlockType) && (IS_LONG == Z_TYPE_P(zu1BlockType)))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		u1BlockTypeRaw = (uint8_t)Z_LVAL_P(zu1BlockType);
		_err = SBPGPUtils_UnformatPKCS1_1((TLInt *)SBGetStructPointer(oData TSRMLS_CC), &u1BlockTypeRaw, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-489064504, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zu1BlockType, (long)u1BlockTypeRaw);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer) or (TLInt, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, PGPCurveByOID)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_PGPCurveByOID(aiOID.data, aiOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, OIDByPGPCurve)
{
	long l4Curve;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Curve) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPGPUtils_OIDByPGPCurve((int32_t)l4Curve, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1256322168, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, PGPCurveByBits)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_PGPCurveByBits((int32_t)l4Bits, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, BitsInPGPCurve)
{
	long l4Curve;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Curve) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_BitsInPGPCurve((int32_t)l4Curve, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, HashAlgorithmByPGPCurve)
{
	long l4Curve;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Curve) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_HashAlgorithmByPGPCurve((int32_t)l4Curve, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, SymmetricAlgorithmByPGPCurve)
{
	long l4Curve;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Curve) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_SymmetricAlgorithmByPGPCurve((int32_t)l4Curve, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, DetectMessageEncoding)
{
	int32_t l4BOMSizeRaw;
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiMsg;
	zval *zaMsg;
	zval *zl4BOMSize;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllz", &zaMsg, &l4Index, &l4Size, &zl4BOMSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMsg)) || (IS_ARRAY == Z_TYPE_P(zaMsg)) || (IS_NULL == Z_TYPE_P(zaMsg))) && PZVAL_IS_REF(zl4BOMSize) && (IS_LONG == Z_TYPE_P(zl4BOMSize)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMsg, &aiMsg TSRMLS_CC)) RETURN_FALSE;
		l4BOMSizeRaw = (int32_t)Z_LVAL_P(zl4BOMSize);
		SBCheckError(SBPGPUtils_DetectMessageEncoding(aiMsg.data, aiMsg.len, (int32_t)l4Index, (int32_t)l4Size, &l4BOMSizeRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMsg);
		ZVAL_LONG(zl4BOMSize, (long)l4BOMSizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, BytesInEncoding)
{
	long l4Encoding;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Encoding) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_BytesInEncoding((int32_t)l4Encoding, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, UnicodeMessageToUtf8)
{
	int32_t l4OutSizeRaw;
	int32_t l4SizeRaw;
	long l4Encoding;
	long l4Index;
	long l4OutIndex;
	SBArrayZValInfo aiMsg;
	SBArrayZValInfo aiOutBuf;
	zval *zaMsg;
	zval *zaOutBuf;
	zval *zl4OutSize;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzlzzlz", &l4Encoding, &zaMsg, &l4Index, &zl4Size, &zaOutBuf, &l4OutIndex, &zl4OutSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMsg)) || (IS_ARRAY == Z_TYPE_P(zaMsg)) || (IS_NULL == Z_TYPE_P(zaMsg))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zaOutBuf)) || (IS_ARRAY == Z_TYPE_P(zaOutBuf)) || (IS_NULL == Z_TYPE_P(zaOutBuf))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetByteArrayFromZVal(zaMsg, &aiMsg TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		if (!SBGetByteArrayFromZVal(zaOutBuf, &aiOutBuf TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBPGPUtils_UnicodeMessageToUtf8((int32_t)l4Encoding, aiMsg.data, aiMsg.len, (int32_t)l4Index, &l4SizeRaw, aiOutBuf.data, aiOutBuf.len, (int32_t)l4OutIndex, &l4OutSizeRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMsg);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreeArrayZValInfo(&aiOutBuf);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, integer, &integer, array of byte|string|NULL, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, IsCleartextMessage)
{
	long l4Encoding;
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiMsg;
	zval *zaMsg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzll", &l4Encoding, &zaMsg, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMsg)) || (IS_ARRAY == Z_TYPE_P(zaMsg)) || (IS_NULL == Z_TYPE_P(zaMsg))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMsg, &aiMsg TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_IsCleartextMessage((int32_t)l4Encoding, aiMsg.data, aiMsg.len, (int32_t)l4Index, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMsg);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, SizeOfMessageInEncoding)
{
	long l4Encoding;
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiMsg;
	zval *zaMsg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzll", &l4Encoding, &zaMsg, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMsg)) || (IS_ARRAY == Z_TYPE_P(zaMsg)) || (IS_NULL == Z_TYPE_P(zaMsg))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMsg, &aiMsg TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPGPUtils_SizeOfMessageInEncoding((int32_t)l4Encoding, aiMsg.data, aiMsg.len, (int32_t)l4Index, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMsg);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, IsWhitespace)
{
	long u1B;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1B) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_IsWhitespace((uint8_t)u1B, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, IsEOL)
{
	long u1B;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1B) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_IsEOL((uint8_t)u1B, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, IsEmailChar)
{
	long u1B;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1B) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_IsEmailChar((uint8_t)u1B, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, UserIDCorrespondsToEmail)
{
	char *sEmail;
	char *sUserID;
	int sEmail_len;
	int sUserID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sUserID, &sUserID_len, &sEmail, &sEmail_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPGPUtils_UserIDCorrespondsToEmail(sUserID, (int32_t)sUserID_len, sEmail, (int32_t)sEmail_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, KeyID2Str)
{
	uint32_t _err;
	zend_bool bOnlyLowBytes;
	zval *oKeyID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oKeyID, TSBKeyID_ce_ptr, &bOnlyLowBytes) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBPGPUtils_KeyID2Str((TSBKeyID *)SBGetStructPointer(oKeyID TSRMLS_CC), (int8_t)bOnlyLowBytes, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1382129249, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TSBKeyID, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, KeyID2Array)
{
	uint32_t _err;
	zval *oKeyID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKeyID, TSBKeyID_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPGPUtils_KeyID2Array((TSBKeyID *)SBGetStructPointer(oKeyID TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-62333045, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TSBKeyID)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, KeyFP2Str)
{
	SBArrayZValInfo aiKeyFP;
	uint32_t _err;
	zval *zaKeyFP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaKeyFP) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKeyFP)) || (IS_ARRAY == Z_TYPE_P(zaKeyFP)) || (IS_NULL == Z_TYPE_P(zaKeyFP))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaKeyFP, &aiKeyFP TSRMLS_CC)) RETURN_FALSE;
		_err = SBPGPUtils_KeyFP2Str(aiKeyFP.data, aiKeyFP.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-213283502, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiKeyFP);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, PKAlg2Str)
{
	long l4Alg;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBPGPUtils_PKAlg2Str((int32_t)l4Alg, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1765591422, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, HashAlg2Str)
{
	long l4Alg;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBPGPUtils_HashAlg2Str((int32_t)l4Alg, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(480117847, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, Str2HashAlg)
{
	char *sAlg;
	int sAlg_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAlg, &sAlg_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_Str2HashAlg(sAlg, (int32_t)sAlg_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, ComprAlg2Str)
{
	long l4Alg;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBPGPUtils_ComprAlg2Str((int32_t)l4Alg, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1777262187, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, ConvertDaysToSeconds)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_ConvertDaysToSeconds((int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, ConvertSecondsToDays)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPGPUtils_ConvertSecondsToDays((int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, EncodePassword)
{
	char *sPassword;
	int sPassword_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPassword, &sPassword_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPGPUtils_EncodePassword(sPassword, (int32_t)sPassword_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-821304808, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, GetOpenPGPPasswordCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBPGPUtils_GetOpenPGPPasswordCharset(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1630014405, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPUtils, SetOpenPGPPasswordCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBPGPUtils_SetOpenPGPPasswordCharset(sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

void Register_SBPGPUtils_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPGPUtils, SB_PGP_FILE_CREATE, SB_PGP_FILE_CREATE, SB_PGP_FILE_CREATE);
	SB_REGISTER_LONG_CONSTANT(SBPGPUtils, SB_PGP_FILE_READ, SB_PGP_FILE_READ, SB_PGP_FILE_READ);
	SB_REGISTER_LONG_CONSTANT(SBPGPUtils, SB_PGP_FILE_WRITE, SB_PGP_FILE_WRITE, SB_PGP_FILE_WRITE);
}

void Register_SBPGPUtils_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPGPSignatureType", NULL);
	TSBPGPSignatureType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPSignatureType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureType_ce_ptr, "stNormal", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureType_ce_ptr, "stOnePass", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureType_ce_ptr, "stDetached", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureType_ce_ptr, "stCleartext", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPSignatureExtension", NULL);
	TSBPGPSignatureExtension_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPSignatureExtension_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seUndefined", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seCreationTime", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seExpirationTime", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seExportable", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seTrust", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seRegExp", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seRevocable", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seKeyExpirationTime", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "sePreferredSymAlg", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seRevocationKey", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seIssuerKeyID", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seNotationData", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "sePreferredHashAlg", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "sePreferredComprAlg", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seKeyServerPreferences", 14)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "sePreferredKeyServer", 15)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "sePrimaryUserID", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "sePolicyURL", 17)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seKeyFlags", 18)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seSignerUserID", 19)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seReasonForRevocation", 20)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seFeatures", 21)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seTarget", 22)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seEmbeddedSig", 23)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSignatureExtension_ce_ptr, "seX509Certificate", 24)
}

