#include "sbpkcs11certstorage.h"

zend_class_entry *TSBPKCS11StgCtxType_ce_ptr = NULL;

zend_class_entry *TSBPKCS11CertStorageImportOrder_ce_ptr = NULL;

zend_class_entry *TElPKCS11CertStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11CertStorage, Add)
{
	long l4SessionIndex;
	SBArrayZValInfo aiID;
	SBArrayZValInfo aiKeyLabel;
	zend_bool bCopyPrivateKey;
	zend_bool bExportable;
	zval *oX509Certificate;
	zval *zaID;
	zval *zaKeyLabel;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oX509Certificate, TElX509Certificate_ce_ptr, &bCopyPrivateKey) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oX509Certificate TSRMLS_CC), (int8_t)bCopyPrivateKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bb", &l4SessionIndex, &oX509Certificate, TElX509Certificate_ce_ptr, &bCopyPrivateKey, &bExportable) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SessionIndex, SBGetObjectHandle(oX509Certificate TSRMLS_CC), (int8_t)bCopyPrivateKey, (int8_t)bExportable) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bbzz", &l4SessionIndex, &oX509Certificate, TElX509Certificate_ce_ptr, &bCopyPrivateKey, &bExportable, &zaID, &zaKeyLabel) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaID)) || (IS_ARRAY == Z_TYPE_P(zaID)) || (IS_NULL == Z_TYPE_P(zaID))) && ((IS_STRING == Z_TYPE_P(zaKeyLabel)) || (IS_ARRAY == Z_TYPE_P(zaKeyLabel)) || (IS_NULL == Z_TYPE_P(zaKeyLabel))))
	{
		if (!SBGetByteArrayFromZVal(zaID, &aiID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyLabel, &aiKeyLabel TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CertStorage_Add_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SessionIndex, SBGetObjectHandle(oX509Certificate TSRMLS_CC), (int8_t)bCopyPrivateKey, (int8_t)bExportable, aiID.data, aiID.len, aiKeyLabel.data, aiKeyLabel.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiID);
		SBFreeArrayZValInfo(&aiKeyLabel);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, bool) or (integer, TElX509Certificate, bool, bool) or (integer, TElX509Certificate, bool, bool, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, AddKey)
{
	long l4SessionIndex;
	SBArrayZValInfo aiID;
	SBArrayZValInfo aiKeyLabel;
	zend_bool bCopyPrivateKey;
	zend_bool bExportable;
	zval *oKeyMaterial;
	zval *zaID;
	zval *zaKeyLabel;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bbzz", &l4SessionIndex, &oKeyMaterial, TElKeyMaterial_ce_ptr, &bCopyPrivateKey, &bExportable, &zaID, &zaKeyLabel) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaID)) || (IS_ARRAY == Z_TYPE_P(zaID)) || (IS_NULL == Z_TYPE_P(zaID))) && ((IS_STRING == Z_TYPE_P(zaKeyLabel)) || (IS_ARRAY == Z_TYPE_P(zaKeyLabel)) || (IS_NULL == Z_TYPE_P(zaKeyLabel))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaID, &aiID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyLabel, &aiKeyLabel TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CertStorage_AddKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SessionIndex, SBGetObjectHandle(oKeyMaterial TSRMLS_CC), (int8_t)bCopyPrivateKey, (int8_t)bExportable, aiID.data, aiID.len, aiKeyLabel.data, aiKeyLabel.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiID);
		SBFreeArrayZValInfo(&aiKeyLabel);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbzz", &oKeyMaterial, TElKeyMaterial_ce_ptr, &bCopyPrivateKey, &bExportable, &zaID, &zaKeyLabel) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaID)) || (IS_ARRAY == Z_TYPE_P(zaID)) || (IS_NULL == Z_TYPE_P(zaID))) && ((IS_STRING == Z_TYPE_P(zaKeyLabel)) || (IS_ARRAY == Z_TYPE_P(zaKeyLabel)) || (IS_NULL == Z_TYPE_P(zaKeyLabel))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaID, &aiID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyLabel, &aiKeyLabel TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CertStorage_AddKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyMaterial TSRMLS_CC), (int8_t)bCopyPrivateKey, (int8_t)bExportable, aiID.data, aiID.len, aiKeyLabel.data, aiKeyLabel.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiID);
		SBFreeArrayZValInfo(&aiKeyLabel);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElKeyMaterial, bool, bool, array of byte|string|NULL, array of byte|string|NULL) or (TElKeyMaterial, bool, bool, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, CloseAllSessions)
{
	zval *oSlotInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSlotInfo, TElPKCS11SlotInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_CloseAllSessions(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSlotInfo TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11SlotInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, CloseSession)
{
	long l4SessionIndex;
	zval *oSession;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SessionIndex) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_CloseSession(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SessionIndex) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSession, TElPKCS11SessionInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_CloseSession_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSession TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPKCS11SessionInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, OpenSession)
{
	long l4SlotIndex;
	zend_bool bReadOnly;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4SlotIndex, &bReadOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_OpenSession(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SlotIndex, (int8_t)bReadOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SessionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, RefreshObjectList)
{
	long l4SessionIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SessionIndex) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_RefreshObjectList(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SessionIndex) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, RefreshCertificateContexts)
{
	zval *oSessionInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSessionInfo, TElPKCS11SessionInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_RefreshCertificateContexts(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSessionInfo TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11SessionInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, UpdateCertificateContexts)
{
	zval *oSessionInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSessionInfo, TElPKCS11SessionInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_UpdateCertificateContexts(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSessionInfo TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11SessionInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, RemoveKey)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_RemoveKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, AddObject)
{
	long fObjectType;
	long l4SessionIndex;
	zend_bool bModifiable;
	zend_bool bPrivate;
	zend_bool bToken;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbbbO!", &fObjectType, &bToken, &bPrivate, &bModifiable, &oAttributes, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_AddObject(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11ObjectTypeRaw)fObjectType, (int8_t)bToken, (int8_t)bPrivate, (int8_t)bModifiable, SBGetObjectHandle(oAttributes TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llbbbO!", &l4SessionIndex, &fObjectType, &bToken, &bPrivate, &bModifiable, &oAttributes, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_AddObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SessionIndex, (TSBPKCS11ObjectTypeRaw)fObjectType, (int8_t)bToken, (int8_t)bPrivate, (int8_t)bModifiable, SBGetObjectHandle(oAttributes TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, bool, bool, TElPKCS11AttributeList) or (integer, integer, bool, bool, bool, TElPKCS11AttributeList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, RemoveObject)
{
	long l4Index;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_RemoveObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElPKCS11Object_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_RemoveObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPKCS11Object)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, ClearObjects)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_ClearObjects(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, CopyObject)
{
	long l4Index;
	zend_bool bModifiable;
	zend_bool bPrivate;
	zend_bool bToken;
	zval *oAttributes;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbbbO!", &l4Index, &bToken, &bPrivate, &bModifiable, &oAttributes, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bToken, (int8_t)bPrivate, (int8_t)bModifiable, SBGetObjectHandle(oAttributes TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbbO!", &oObj, TElPKCS11Object_ce_ptr, &bToken, &bPrivate, &bModifiable, &oAttributes, TElPKCS11AttributeList_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), (int8_t)bToken, (int8_t)bPrivate, (int8_t)bModifiable, SBGetObjectHandle(oAttributes TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, bool, bool, TElPKCS11AttributeList) or (TElPKCS11Object, bool, bool, bool, TElPKCS11AttributeList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, GetObjects)
{
	long l4CertIndex;
	TElClassHandle hoCertObject;
	TElClassHandle hoPrivKeyObject;
	TElClassHandle hoPubKeyObject;
	zval *oCertObject;
	zval *oPrivKeyObject;
	zval *oPubKeyObject;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lOOO", &l4CertIndex, &oCertObject, TElPKCS11X509CertificateObject_ce_ptr, &oPrivKeyObject, TElPKCS11PrivateKeyObject_ce_ptr, &oPubKeyObject, TElPKCS11PublicKeyObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCertObject) && (IS_OBJECT == Z_TYPE_P(oCertObject)) && PZVAL_IS_REF(oPrivKeyObject) && (IS_OBJECT == Z_TYPE_P(oPrivKeyObject)) && PZVAL_IS_REF(oPubKeyObject) && (IS_OBJECT == Z_TYPE_P(oPubKeyObject)))
	{
		hoCertObject = SBGetObjectHandle(oCertObject TSRMLS_CC);
		hoPrivKeyObject = SBGetObjectHandle(oPrivKeyObject TSRMLS_CC);
		hoPubKeyObject = SBGetObjectHandle(oPubKeyObject TSRMLS_CC);
		SBCheckError(TElPKCS11CertStorage_GetObjects(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4CertIndex, &hoCertObject, &hoPrivKeyObject, &hoPubKeyObject) TSRMLS_CC);
		SBUpdateObjectHandle(oCertObject, hoCertObject TSRMLS_CC);
		SBUpdateObjectHandle(oPrivKeyObject, hoPrivKeyObject TSRMLS_CC);
		SBUpdateObjectHandle(oPubKeyObject, hoPubKeyObject TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &TElPKCS11X509CertificateObject, &TElPKCS11PrivateKeyObject, &TElPKCS11PublicKeyObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_Certificates)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_Keys)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_get_Keys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_KeyIDs)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11CertStorage_get_KeyIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2000849451, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_KeyIDs)
{
	long l4Index;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CertStorage_set_KeyIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_Session)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_get_Session(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SessionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_Objects)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_get_Objects(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Object_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_KeyCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_KeyCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_ObjectCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_ObjectCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_SessionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_SessionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_UniqueID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11CertStorage_get_UniqueID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1117642878, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_Module)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_get_Module(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Module_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_Opened)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_Opened(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_TrySingleThreadedMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_TrySingleThreadedMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_TrySingleThreadedMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_TrySingleThreadedMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_MonitorSlotEvents)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_MonitorSlotEvents(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_MonitorSlotEvents)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_MonitorSlotEvents(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_SlotEventMonitoringMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11SlotEventMonitoringModeRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_SlotEventMonitoringMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_SlotEventMonitoringMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_SlotEventMonitoringMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11SlotEventMonitoringModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_SlotEventMonitoringDelay)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_SlotEventMonitoringDelay(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_SlotEventMonitoringDelay)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_SlotEventMonitoringDelay(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_SynchronizeGUI)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_SynchronizeGUI(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_SynchronizeGUI)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_SynchronizeGUI(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_DLLName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11CertStorage_get_DLLName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-453868306, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_DLLName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_DLLName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_CryptoProvider)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_PKCS11Options)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11StorageOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_PKCS11Options(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_PKCS11Options)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_PKCS11Options(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11StorageOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_TokenAccessMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11TokenAccessModeRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_TokenAccessMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_TokenAccessMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_TokenAccessMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11TokenAccessModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_ImportOrder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11CertStorageImportOrderRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11CertStorage_get_ImportOrder(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_ImportOrder)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CertStorage_set_ImportOrder(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11CertStorageImportOrderRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_NSSParams)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_get_NSSParams(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11NSSParams_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_OnNotification)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElPKCSNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_get_OnNotification(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_OnNotification)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPKCS11CertStorage_set_OnNotification(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElPKCSNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCSNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, get_OnSlotEvent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElPKCSSlotEventEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_get_OnSlotEvent(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, set_OnSlotEvent)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPKCS11CertStorage_set_OnSlotEvent(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElPKCSSlotEventEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCSSlotEventEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CertStorage, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CertStorage_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_Add, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, X509Certificate_or_SessionIndex, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CopyPrivateKey_or_X509Certificate, 0, 1)
	ZEND_ARG_INFO(0, CopyPrivateKey)
	ZEND_ARG_INFO(0, Exportable)
	ZEND_ARG_TYPE_INFO(0, ID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeyLabel, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_AddKey, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, SessionIndex_or_KeyMaterial, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeyMaterial_or_CopyPrivateKey, 0, 1)
	ZEND_ARG_INFO(0, CopyPrivateKey_or_Exportable)
	ZEND_ARG_TYPE_INFO(0, Exportable_or_ID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ID_or_KeyLabel, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeyLabel, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_CloseAllSessions, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, SlotInfo, TElPKCS11SlotInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_CloseSession, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SessionIndex_or_Session, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_OpenSession, 0, 0, 2)
	ZEND_ARG_INFO(0, SlotIndex)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_RefreshObjectList, 0, 0, 1)
	ZEND_ARG_INFO(0, SessionIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_RefreshCertificateContexts, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, SessionInfo, TElPKCS11SessionInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_UpdateCertificateContexts, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, SessionInfo, TElPKCS11SessionInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_RemoveKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_AddObject, 0, 0, 5)
	ZEND_ARG_INFO(0, ObjectType_or_SessionIndex)
	ZEND_ARG_INFO(0, Token_or_ObjectType)
	ZEND_ARG_INFO(0, Private_or_Token)
	ZEND_ARG_INFO(0, Modifiable_or_Private)
	ZEND_ARG_TYPE_INFO(0, Attributes_or_Modifiable, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElPKCS11AttributeList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_RemoveObject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Index_or_Obj, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_ClearObjects, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_CopyObject, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Index_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Token)
	ZEND_ARG_INFO(0, Private)
	ZEND_ARG_INFO(0, Modifiable)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElPKCS11AttributeList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_GetObjects, 0, 0, 4)
	ZEND_ARG_INFO(0, CertIndex)
	ZEND_ARG_OBJ_INFO(1, CertObject, TElPKCS11X509CertificateObject, 0)
	ZEND_ARG_OBJ_INFO(1, PrivKeyObject, TElPKCS11PrivateKeyObject, 0)
	ZEND_ARG_OBJ_INFO(1, PubKeyObject, TElPKCS11PublicKeyObject, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_Certificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_Keys, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_KeyIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_KeyIDs, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_Session, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_Objects, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_KeyCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_ObjectCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_SessionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_UniqueID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_Module, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_Opened, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_TrySingleThreadedMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_TrySingleThreadedMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_MonitorSlotEvents, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_MonitorSlotEvents, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_SlotEventMonitoringMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_SlotEventMonitoringMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_SlotEventMonitoringDelay, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_SlotEventMonitoringDelay, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_SynchronizeGUI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_SynchronizeGUI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_DLLName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_DLLName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_CryptoProvider, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_PKCS11Options, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_PKCS11Options, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_TokenAccessMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_TokenAccessMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_ImportOrder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_ImportOrder, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_NSSParams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_OnNotification, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_OnNotification, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_get_OnSlotEvent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage_set_OnSlotEvent, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CertStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11CertStorage_methods[] = {
	PHP_ME(TElPKCS11CertStorage, Add, arginfo_TElPKCS11CertStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, AddKey, arginfo_TElPKCS11CertStorage_AddKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, Close, arginfo_TElPKCS11CertStorage_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, CloseAllSessions, arginfo_TElPKCS11CertStorage_CloseAllSessions, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, Open, arginfo_TElPKCS11CertStorage_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, CloseSession, arginfo_TElPKCS11CertStorage_CloseSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, OpenSession, arginfo_TElPKCS11CertStorage_OpenSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, RefreshObjectList, arginfo_TElPKCS11CertStorage_RefreshObjectList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, RefreshCertificateContexts, arginfo_TElPKCS11CertStorage_RefreshCertificateContexts, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, UpdateCertificateContexts, arginfo_TElPKCS11CertStorage_UpdateCertificateContexts, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, Remove, arginfo_TElPKCS11CertStorage_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, RemoveKey, arginfo_TElPKCS11CertStorage_RemoveKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, AddObject, arginfo_TElPKCS11CertStorage_AddObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, RemoveObject, arginfo_TElPKCS11CertStorage_RemoveObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, ClearObjects, arginfo_TElPKCS11CertStorage_ClearObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, CopyObject, arginfo_TElPKCS11CertStorage_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, GetObjects, arginfo_TElPKCS11CertStorage_GetObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_Certificates, arginfo_TElPKCS11CertStorage_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_Keys, arginfo_TElPKCS11CertStorage_get_Keys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_KeyIDs, arginfo_TElPKCS11CertStorage_get_KeyIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_KeyIDs, arginfo_TElPKCS11CertStorage_set_KeyIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_Session, arginfo_TElPKCS11CertStorage_get_Session, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_Objects, arginfo_TElPKCS11CertStorage_get_Objects, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_Count, arginfo_TElPKCS11CertStorage_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_KeyCount, arginfo_TElPKCS11CertStorage_get_KeyCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_ObjectCount, arginfo_TElPKCS11CertStorage_get_ObjectCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_SessionCount, arginfo_TElPKCS11CertStorage_get_SessionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_UniqueID, arginfo_TElPKCS11CertStorage_get_UniqueID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_Module, arginfo_TElPKCS11CertStorage_get_Module, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_Opened, arginfo_TElPKCS11CertStorage_get_Opened, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_TrySingleThreadedMode, arginfo_TElPKCS11CertStorage_get_TrySingleThreadedMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_TrySingleThreadedMode, arginfo_TElPKCS11CertStorage_set_TrySingleThreadedMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_MonitorSlotEvents, arginfo_TElPKCS11CertStorage_get_MonitorSlotEvents, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_MonitorSlotEvents, arginfo_TElPKCS11CertStorage_set_MonitorSlotEvents, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_SlotEventMonitoringMode, arginfo_TElPKCS11CertStorage_get_SlotEventMonitoringMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_SlotEventMonitoringMode, arginfo_TElPKCS11CertStorage_set_SlotEventMonitoringMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_SlotEventMonitoringDelay, arginfo_TElPKCS11CertStorage_get_SlotEventMonitoringDelay, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_SlotEventMonitoringDelay, arginfo_TElPKCS11CertStorage_set_SlotEventMonitoringDelay, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_SynchronizeGUI, arginfo_TElPKCS11CertStorage_get_SynchronizeGUI, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_SynchronizeGUI, arginfo_TElPKCS11CertStorage_set_SynchronizeGUI, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_DLLName, arginfo_TElPKCS11CertStorage_get_DLLName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_DLLName, arginfo_TElPKCS11CertStorage_set_DLLName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_CryptoProvider, arginfo_TElPKCS11CertStorage_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_CryptoProvider, arginfo_TElPKCS11CertStorage_set_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_PKCS11Options, arginfo_TElPKCS11CertStorage_get_PKCS11Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_PKCS11Options, arginfo_TElPKCS11CertStorage_set_PKCS11Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_TokenAccessMode, arginfo_TElPKCS11CertStorage_get_TokenAccessMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_TokenAccessMode, arginfo_TElPKCS11CertStorage_set_TokenAccessMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_ImportOrder, arginfo_TElPKCS11CertStorage_get_ImportOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_ImportOrder, arginfo_TElPKCS11CertStorage_set_ImportOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_NSSParams, arginfo_TElPKCS11CertStorage_get_NSSParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_OnNotification, arginfo_TElPKCS11CertStorage_get_OnNotification, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_OnNotification, arginfo_TElPKCS11CertStorage_set_OnNotification, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, get_OnSlotEvent, arginfo_TElPKCS11CertStorage_get_OnSlotEvent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, set_OnSlotEvent, arginfo_TElPKCS11CertStorage_set_OnSlotEvent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CertStorage, __construct, arginfo_TElPKCS11CertStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11CertStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11CertStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11CertStorage", TElPKCS11CertStorage_methods);
	if (NULL == TElCustomCertStorage_ce_ptr)
		Register_TElCustomCertStorage(TSRMLS_C);
	TElPKCS11CertStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCertStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11StgCtx_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11StgCtx, SetCertStorageName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11StgCtx_SetCertStorageName(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11StgCtx, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11StgCtx_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11StgCtx_SetCertStorageName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11StgCtx___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11StgCtx_methods[] = {
	PHP_ME(TElPKCS11StgCtx, SetCertStorageName, arginfo_TElPKCS11StgCtx_SetCertStorageName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11StgCtx, __construct, arginfo_TElPKCS11StgCtx___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11StgCtx(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11StgCtx_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11StgCtx", TElPKCS11StgCtx_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11StgCtx_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ConsumerCertStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ConsumerCertStorage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ConsumerCertStorage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ConsumerCertStorage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ConsumerCertStorage_methods[] = {
	PHP_ME(TElPKCS11ConsumerCertStorage, __construct, arginfo_TElPKCS11ConsumerCertStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ConsumerCertStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ConsumerCertStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ConsumerCertStorage", TElPKCS11ConsumerCertStorage_methods);
	if (NULL == TElPKCS11Consumer_ce_ptr)
		Register_TElPKCS11Consumer(TSRMLS_C);
	TElPKCS11ConsumerCertStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11Consumer_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBPKCS11CertStorage, GetContextByCertificate)
{
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPKCS11CertStorage_GetContextByCertificate(SBGetObjectHandle(oCert TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11StgCtx_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

void Register_SBPKCS11CertStorage_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPKCS11StgCtxType", NULL);
	TSBPKCS11StgCtxType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11StgCtxType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StgCtxType_ce_ptr, "sctCertificate", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11StgCtxType_ce_ptr, "sctKey", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11CertStorageImportOrder", NULL);
	TSBPKCS11CertStorageImportOrder_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11CertStorageImportOrder_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertStorageImportOrder_ce_ptr, "csioAuto", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertStorageImportOrder_ce_ptr, "csioCertificateFirst", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CertStorageImportOrder_ce_ptr, "csioKeyFirst", 2)
}

void Register_SBPKCS11CertStorage_Aliases(TSRMLS_D)
{
	if (NULL == TElPKCS11CertStorage_ce_ptr)
		Register_TElPKCS11CertStorage(TSRMLS_C);
	zend_register_class_alias("ElPKCS11CertStorage", TElPKCS11CertStorage_ce_ptr);
	if (NULL == TElPKCS11StgCtx_ce_ptr)
		Register_TElPKCS11StgCtx(TSRMLS_C);
	zend_register_class_alias("ElPKCS11StgCtx", TElPKCS11StgCtx_ce_ptr);
	if (NULL == TElPKCS11ConsumerCertStorage_ce_ptr)
		Register_TElPKCS11ConsumerCertStorage(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ConsumerCertStorage", TElPKCS11ConsumerCertStorage_ce_ptr);
}

