#include "sbpkcs11manager.h"

zend_class_entry *TElPKCS11Manager_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11Manager, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11Manager_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11Manager_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, OpenSession)
{
	long l4SlotIndex;
	zend_bool bReadOnly;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4SlotIndex, &bReadOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Manager_OpenSession(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4SlotIndex, (int8_t)bReadOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11SessionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, CloseSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11Manager_CloseSession(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, IndexOfObject)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zval *oAnObject;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Handle) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Handle) == SUCCESS)
#endif
	{
		int32_t l4OutResultRaw = 0;
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Manager_IndexOfObject(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Handle, &l4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Manager_IndexOfObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Handle, &l4OutResultRaw) TSRMLS_CC);
#endif
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAnObject, TElPKCS11ManagerObject_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11Manager_IndexOfObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAnObject TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPKCS11ManagerObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, RemoveObject)
{
	long l4Index;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Handle;
#else
	long l8Handle;
#endif
	zval *oAnObject;
#ifdef SB_NOT_CPU64_OR_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Handle) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Handle) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPKCS11Manager_RemoveObject(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Handle) TSRMLS_CC);
#else
		SBCheckError(TElPKCS11Manager_RemoveObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Handle) TSRMLS_CC);
#endif
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAnObject, TElPKCS11ManagerObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11Manager_RemoveObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAnObject TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPKCS11Manager_RemoveObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPKCS11ManagerObject) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, RefreshObjects)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11Manager_RefreshObjects(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, AddObject)
{
	zval *oAnObject;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAnObject, TElPKCS11ManagerObject_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11Manager_AddObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAnObject TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11ManagerObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, get_Objects)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Manager_get_Objects(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11ManagerObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11Manager_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, get_Module)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Manager_get_Module(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS11Module_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, get_DLLName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11Manager_get_DLLName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-78709159, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, set_DLLName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11Manager_set_DLLName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, get_PKCS11Options)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11StorageOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11Manager_get_PKCS11Options(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, set_PKCS11Options)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11Manager_set_PKCS11Options(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKCS11StorageOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, get_OnNotification)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElPKCSNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPKCS11Manager_get_OnNotification(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, set_OnNotification)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPKCS11Manager_set_OnNotification(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElPKCSNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCSNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11Manager, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11Manager_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_OpenSession, 0, 0, 2)
	ZEND_ARG_INFO(0, SlotIndex)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_CloseSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_IndexOfObject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle_or_AnObject, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_RemoveObject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle_or_AnObject_or_Index, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_RefreshObjects, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_AddObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AnObject, TElPKCS11ManagerObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_get_Objects, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_get_Module, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_get_DLLName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_set_DLLName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_get_PKCS11Options, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_set_PKCS11Options, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_get_OnNotification, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager_set_OnNotification, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11Manager___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11Manager_methods[] = {
	PHP_ME(TElPKCS11Manager, Close, arginfo_TElPKCS11Manager_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, Open, arginfo_TElPKCS11Manager_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, OpenSession, arginfo_TElPKCS11Manager_OpenSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, CloseSession, arginfo_TElPKCS11Manager_CloseSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, IndexOfObject, arginfo_TElPKCS11Manager_IndexOfObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, RemoveObject, arginfo_TElPKCS11Manager_RemoveObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, RefreshObjects, arginfo_TElPKCS11Manager_RefreshObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, AddObject, arginfo_TElPKCS11Manager_AddObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, get_Objects, arginfo_TElPKCS11Manager_get_Objects, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, get_Count, arginfo_TElPKCS11Manager_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, get_Module, arginfo_TElPKCS11Manager_get_Module, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, get_DLLName, arginfo_TElPKCS11Manager_get_DLLName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, set_DLLName, arginfo_TElPKCS11Manager_set_DLLName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, get_PKCS11Options, arginfo_TElPKCS11Manager_get_PKCS11Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, set_PKCS11Options, arginfo_TElPKCS11Manager_set_PKCS11Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, get_OnNotification, arginfo_TElPKCS11Manager_get_OnNotification, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, set_OnNotification, arginfo_TElPKCS11Manager_set_OnNotification, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11Manager, __construct, arginfo_TElPKCS11Manager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11Manager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11Manager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11Manager", TElPKCS11Manager_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElPKCS11Manager_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ManagerObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ManagerObject, get_Handle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerObject_get_Handle(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerObject_get_Handle(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, get_HWSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerObject_get_HWSize(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerObject_get_HWSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerObject_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2144509034, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, get_Label_)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11ManagerObject_get_Label_(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1419018876, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, set_Label_)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerObject_set_Label_(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, get_Modifiable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerObject_get_Modifiable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, set_Modifiable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerObject_set_Modifiable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, get_Private_)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerObject_get_Private_(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, set_Private_)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerObject_set_Private_(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, get_Token)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerObject_get_Token(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, set_Token)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerObject_set_Token(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPKCS11Manager_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ManagerObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Manager)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_get_Handle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_get_HWSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_get_Label_, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_set_Label_, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_get_Modifiable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_set_Modifiable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_get_Private_, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_set_Private_, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_get_Token, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject_set_Token, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPKCS11Manager, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ManagerObject_methods[] = {
	PHP_ME(TElPKCS11ManagerObject, get_Handle, arginfo_TElPKCS11ManagerObject_get_Handle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, get_HWSize, arginfo_TElPKCS11ManagerObject_get_HWSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, get_ID, arginfo_TElPKCS11ManagerObject_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, get_Label_, arginfo_TElPKCS11ManagerObject_get_Label_, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, set_Label_, arginfo_TElPKCS11ManagerObject_set_Label_, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, get_Modifiable, arginfo_TElPKCS11ManagerObject_get_Modifiable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, set_Modifiable, arginfo_TElPKCS11ManagerObject_set_Modifiable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, get_Private_, arginfo_TElPKCS11ManagerObject_get_Private_, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, set_Private_, arginfo_TElPKCS11ManagerObject_set_Private_, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, get_Token, arginfo_TElPKCS11ManagerObject_get_Token, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, set_Token, arginfo_TElPKCS11ManagerObject_set_Token, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerObject, __construct, arginfo_TElPKCS11ManagerObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ManagerObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ManagerObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ManagerObject", TElPKCS11ManagerObject_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11ManagerObject_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ManagerDataObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ManagerDataObject, get_Application)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11ManagerDataObject_get_Application(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(664110052, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerDataObject, set_Application)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerDataObject_set_Application(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerDataObject, get_OID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerDataObject_get_OID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1941213059, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerDataObject, set_OID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerDataObject_set_OID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerDataObject, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerDataObject_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1691580462, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerDataObject, set_Value)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerDataObject_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerDataObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPKCS11Manager_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ManagerDataObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Manager)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerDataObject_get_Application, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerDataObject_set_Application, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerDataObject_get_OID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerDataObject_set_OID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerDataObject_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerDataObject_set_Value, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerDataObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPKCS11Manager, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ManagerDataObject_methods[] = {
	PHP_ME(TElPKCS11ManagerDataObject, get_Application, arginfo_TElPKCS11ManagerDataObject_get_Application, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerDataObject, set_Application, arginfo_TElPKCS11ManagerDataObject_set_Application, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerDataObject, get_OID, arginfo_TElPKCS11ManagerDataObject_get_OID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerDataObject, set_OID, arginfo_TElPKCS11ManagerDataObject_set_OID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerDataObject, get_Value, arginfo_TElPKCS11ManagerDataObject_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerDataObject, set_Value, arginfo_TElPKCS11ManagerDataObject_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerDataObject, __construct, arginfo_TElPKCS11ManagerDataObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ManagerDataObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ManagerDataObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ManagerDataObject", TElPKCS11ManagerDataObject_methods);
	if (NULL == TElPKCS11ManagerObject_ce_ptr)
		Register_TElPKCS11ManagerObject(TSRMLS_C);
	TElPKCS11ManagerDataObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11ManagerObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ManagerCertificateObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_ACAttrTypes)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerCertificateObject_get_ACAttrTypes(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1136830989, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_ACAttrTypes)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerCertificateObject_set_ACAttrTypes(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_ACIssuer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerCertificateObject_get_ACIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(531136455, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_ACIssuer)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerCertificateObject_set_ACIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_ACOwner)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerCertificateObject_get_ACOwner(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1355715357, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_ACOwner)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerCertificateObject_set_ACOwner(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_Category)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElPKCS11CertificateCategoryRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerCertificateObject_get_Category(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_Category)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerCertificateObject_set_Category(SBGetObjectHandle(getThis() TSRMLS_CC), (TElPKCS11CertificateCategoryRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_CertificateType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElPKCS11CertificateTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerCertificateObject_get_CertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_CertificateType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerCertificateObject_set_CertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), (TElPKCS11CertificateTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_Issuer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerCertificateObject_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1352967605, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_Issuer)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerCertificateObject_set_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerCertificateObject_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1327185117, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_SerialNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerCertificateObject_set_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_Subject)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerCertificateObject_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1524790255, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_Subject)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerCertificateObject_set_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_Trusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerCertificateObject_get_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_Trusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerCertificateObject_set_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_ValidFrom)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerCertificateObject_get_ValidFrom(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_ValidFrom)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerCertificateObject_set_ValidFrom(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_ValidTo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerCertificateObject_get_ValidTo(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_ValidTo)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerCertificateObject_set_ValidTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11ManagerCertificateObject_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1748986887, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerCertificateObject_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerCertificateObject_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1587248337, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, set_Value)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerCertificateObject_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerCertificateObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPKCS11Manager_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ManagerCertificateObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Manager)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_ACAttrTypes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_ACAttrTypes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_ACIssuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_ACIssuer, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_ACOwner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_ACOwner, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_Category, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_Category, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_CertificateType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_CertificateType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_Issuer, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_SerialNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_Subject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_Trusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_Trusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_ValidFrom, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_ValidFrom, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_ValidTo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_ValidTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject_set_Value, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerCertificateObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPKCS11Manager, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ManagerCertificateObject_methods[] = {
	PHP_ME(TElPKCS11ManagerCertificateObject, get_ACAttrTypes, arginfo_TElPKCS11ManagerCertificateObject_get_ACAttrTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_ACAttrTypes, arginfo_TElPKCS11ManagerCertificateObject_set_ACAttrTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_ACIssuer, arginfo_TElPKCS11ManagerCertificateObject_get_ACIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_ACIssuer, arginfo_TElPKCS11ManagerCertificateObject_set_ACIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_ACOwner, arginfo_TElPKCS11ManagerCertificateObject_get_ACOwner, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_ACOwner, arginfo_TElPKCS11ManagerCertificateObject_set_ACOwner, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_Category, arginfo_TElPKCS11ManagerCertificateObject_get_Category, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_Category, arginfo_TElPKCS11ManagerCertificateObject_set_Category, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_CertificateType, arginfo_TElPKCS11ManagerCertificateObject_get_CertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_CertificateType, arginfo_TElPKCS11ManagerCertificateObject_set_CertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_Issuer, arginfo_TElPKCS11ManagerCertificateObject_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_Issuer, arginfo_TElPKCS11ManagerCertificateObject_set_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_SerialNumber, arginfo_TElPKCS11ManagerCertificateObject_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_SerialNumber, arginfo_TElPKCS11ManagerCertificateObject_set_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_Subject, arginfo_TElPKCS11ManagerCertificateObject_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_Subject, arginfo_TElPKCS11ManagerCertificateObject_set_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_Trusted, arginfo_TElPKCS11ManagerCertificateObject_get_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_Trusted, arginfo_TElPKCS11ManagerCertificateObject_set_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_ValidFrom, arginfo_TElPKCS11ManagerCertificateObject_get_ValidFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_ValidFrom, arginfo_TElPKCS11ManagerCertificateObject_set_ValidFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_ValidTo, arginfo_TElPKCS11ManagerCertificateObject_get_ValidTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_ValidTo, arginfo_TElPKCS11ManagerCertificateObject_set_ValidTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_URL, arginfo_TElPKCS11ManagerCertificateObject_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_URL, arginfo_TElPKCS11ManagerCertificateObject_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, get_Value, arginfo_TElPKCS11ManagerCertificateObject_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, set_Value, arginfo_TElPKCS11ManagerCertificateObject_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerCertificateObject, __construct, arginfo_TElPKCS11ManagerCertificateObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ManagerCertificateObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ManagerCertificateObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ManagerCertificateObject", TElPKCS11ManagerCertificateObject_methods);
	if (NULL == TElPKCS11ManagerObject_ce_ptr)
		Register_TElPKCS11ManagerObject(TSRMLS_C);
	TElPKCS11ManagerCertificateObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11ManagerObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ManagerKeyObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ManagerKeyObject, get_ValidFrom)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerKeyObject_get_ValidFrom(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerKeyObject, set_ValidFrom)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerKeyObject_set_ValidFrom(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerKeyObject, get_ValidTo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerKeyObject_get_ValidTo(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerKeyObject, set_ValidTo)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerKeyObject_set_ValidTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerKeyObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPKCS11Manager_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ManagerKeyObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Manager)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerKeyObject_get_ValidFrom, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerKeyObject_set_ValidFrom, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerKeyObject_get_ValidTo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerKeyObject_set_ValidTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerKeyObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPKCS11Manager, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ManagerKeyObject_methods[] = {
	PHP_ME(TElPKCS11ManagerKeyObject, get_ValidFrom, arginfo_TElPKCS11ManagerKeyObject_get_ValidFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerKeyObject, set_ValidFrom, arginfo_TElPKCS11ManagerKeyObject_set_ValidFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerKeyObject, get_ValidTo, arginfo_TElPKCS11ManagerKeyObject_get_ValidTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerKeyObject, set_ValidTo, arginfo_TElPKCS11ManagerKeyObject_set_ValidTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerKeyObject, __construct, arginfo_TElPKCS11ManagerKeyObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ManagerKeyObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ManagerKeyObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ManagerKeyObject", TElPKCS11ManagerKeyObject_methods);
	if (NULL == TElPKCS11ManagerObject_ce_ptr)
		Register_TElPKCS11ManagerObject(TSRMLS_C);
	TElPKCS11ManagerKeyObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11ManagerObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ManagerPublicKeyObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, get_Encrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPublicKeyObject_get_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, set_Encrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPublicKeyObject_set_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, get_Subject)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerPublicKeyObject_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-39083869, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, set_Subject)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerPublicKeyObject_set_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, get_Trusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPublicKeyObject_get_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, set_Trusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPublicKeyObject_set_Trusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, get_Verify)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPublicKeyObject_get_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, set_Verify)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPublicKeyObject_set_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, get_VerifyRecover)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPublicKeyObject_get_VerifyRecover(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, set_VerifyRecover)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPublicKeyObject_set_VerifyRecover(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, get_Wrap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPublicKeyObject_get_Wrap(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, set_Wrap)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPublicKeyObject_set_Wrap(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPublicKeyObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPKCS11Manager_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ManagerPublicKeyObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Manager)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_get_Encrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_set_Encrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_set_Subject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_get_Trusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_set_Trusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_get_Verify, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_set_Verify, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_get_VerifyRecover, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_set_VerifyRecover, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_get_Wrap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject_set_Wrap, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPublicKeyObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPKCS11Manager, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ManagerPublicKeyObject_methods[] = {
	PHP_ME(TElPKCS11ManagerPublicKeyObject, get_Encrypt, arginfo_TElPKCS11ManagerPublicKeyObject_get_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, set_Encrypt, arginfo_TElPKCS11ManagerPublicKeyObject_set_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, get_Subject, arginfo_TElPKCS11ManagerPublicKeyObject_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, set_Subject, arginfo_TElPKCS11ManagerPublicKeyObject_set_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, get_Trusted, arginfo_TElPKCS11ManagerPublicKeyObject_get_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, set_Trusted, arginfo_TElPKCS11ManagerPublicKeyObject_set_Trusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, get_Verify, arginfo_TElPKCS11ManagerPublicKeyObject_get_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, set_Verify, arginfo_TElPKCS11ManagerPublicKeyObject_set_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, get_VerifyRecover, arginfo_TElPKCS11ManagerPublicKeyObject_get_VerifyRecover, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, set_VerifyRecover, arginfo_TElPKCS11ManagerPublicKeyObject_set_VerifyRecover, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, get_Wrap, arginfo_TElPKCS11ManagerPublicKeyObject_get_Wrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, set_Wrap, arginfo_TElPKCS11ManagerPublicKeyObject_set_Wrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPublicKeyObject, __construct, arginfo_TElPKCS11ManagerPublicKeyObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ManagerPublicKeyObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ManagerPublicKeyObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ManagerPublicKeyObject", TElPKCS11ManagerPublicKeyObject_methods);
	if (NULL == TElPKCS11ManagerKeyObject_ce_ptr)
		Register_TElPKCS11ManagerKeyObject(TSRMLS_C);
	TElPKCS11ManagerPublicKeyObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11ManagerKeyObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ManagerPrivateKeyObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, get_AlwaysAuthenticate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_get_AlwaysAuthenticate(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, set_AlwaysAuthenticate)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_set_AlwaysAuthenticate(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, get_Decrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_get_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, set_Decrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_set_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, get_Extractable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_get_Extractable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, set_Extractable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_set_Extractable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, get_Sensitive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_get_Sensitive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, set_Sensitive)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_set_Sensitive(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, get_Sign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_get_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, set_Sign)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_set_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, get_SignRecover)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_get_SignRecover(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, set_SignRecover)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_set_SignRecover(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, get_Subject)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11ManagerPrivateKeyObject_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-709309662, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, set_Subject)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_set_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, get_Unwrap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_get_Unwrap(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, set_Unwrap)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_set_Unwrap(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerPrivateKeyObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPKCS11Manager_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ManagerPrivateKeyObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Manager)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_get_AlwaysAuthenticate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_set_AlwaysAuthenticate, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_get_Decrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_set_Decrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_get_Extractable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_set_Extractable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_get_Sensitive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_set_Sensitive, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_get_Sign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_set_Sign, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_get_SignRecover, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_set_SignRecover, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_set_Subject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_get_Unwrap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject_set_Unwrap, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerPrivateKeyObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPKCS11Manager, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ManagerPrivateKeyObject_methods[] = {
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, get_AlwaysAuthenticate, arginfo_TElPKCS11ManagerPrivateKeyObject_get_AlwaysAuthenticate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, set_AlwaysAuthenticate, arginfo_TElPKCS11ManagerPrivateKeyObject_set_AlwaysAuthenticate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, get_Decrypt, arginfo_TElPKCS11ManagerPrivateKeyObject_get_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, set_Decrypt, arginfo_TElPKCS11ManagerPrivateKeyObject_set_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, get_Extractable, arginfo_TElPKCS11ManagerPrivateKeyObject_get_Extractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, set_Extractable, arginfo_TElPKCS11ManagerPrivateKeyObject_set_Extractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, get_Sensitive, arginfo_TElPKCS11ManagerPrivateKeyObject_get_Sensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, set_Sensitive, arginfo_TElPKCS11ManagerPrivateKeyObject_set_Sensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, get_Sign, arginfo_TElPKCS11ManagerPrivateKeyObject_get_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, set_Sign, arginfo_TElPKCS11ManagerPrivateKeyObject_set_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, get_SignRecover, arginfo_TElPKCS11ManagerPrivateKeyObject_get_SignRecover, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, set_SignRecover, arginfo_TElPKCS11ManagerPrivateKeyObject_set_SignRecover, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, get_Subject, arginfo_TElPKCS11ManagerPrivateKeyObject_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, set_Subject, arginfo_TElPKCS11ManagerPrivateKeyObject_set_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, get_Unwrap, arginfo_TElPKCS11ManagerPrivateKeyObject_get_Unwrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, set_Unwrap, arginfo_TElPKCS11ManagerPrivateKeyObject_set_Unwrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerPrivateKeyObject, __construct, arginfo_TElPKCS11ManagerPrivateKeyObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ManagerPrivateKeyObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ManagerPrivateKeyObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ManagerPrivateKeyObject", TElPKCS11ManagerPrivateKeyObject_methods);
	if (NULL == TElPKCS11ManagerKeyObject_ce_ptr)
		Register_TElPKCS11ManagerKeyObject(TSRMLS_C);
	TElPKCS11ManagerPrivateKeyObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11ManagerKeyObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ManagerSecretKeyObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, get_Decrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerSecretKeyObject_get_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, set_Decrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerSecretKeyObject_set_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, get_Encrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerSecretKeyObject_get_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, set_Encrypt)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerSecretKeyObject_set_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, get_Extractable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerSecretKeyObject_get_Extractable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, set_Extractable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerSecretKeyObject_set_Extractable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, get_Sensitive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerSecretKeyObject_get_Sensitive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, set_Sensitive)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerSecretKeyObject_set_Sensitive(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, get_Sign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerSecretKeyObject_get_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, set_Sign)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerSecretKeyObject_set_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, get_Unwrap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerSecretKeyObject_get_Unwrap(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, set_Unwrap)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerSecretKeyObject_set_Unwrap(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, get_Verify)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerSecretKeyObject_get_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, set_Verify)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerSecretKeyObject_set_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, get_Wrap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11ManagerSecretKeyObject_get_Wrap(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, set_Wrap)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11ManagerSecretKeyObject_set_Wrap(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ManagerSecretKeyObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPKCS11Manager_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ManagerSecretKeyObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPKCS11Manager)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_get_Decrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_set_Decrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_get_Encrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_set_Encrypt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_get_Extractable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_set_Extractable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_get_Sensitive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_set_Sensitive, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_get_Sign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_set_Sign, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_get_Unwrap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_set_Unwrap, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_get_Verify, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_set_Verify, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_get_Wrap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject_set_Wrap, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ManagerSecretKeyObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPKCS11Manager, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ManagerSecretKeyObject_methods[] = {
	PHP_ME(TElPKCS11ManagerSecretKeyObject, get_Decrypt, arginfo_TElPKCS11ManagerSecretKeyObject_get_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, set_Decrypt, arginfo_TElPKCS11ManagerSecretKeyObject_set_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, get_Encrypt, arginfo_TElPKCS11ManagerSecretKeyObject_get_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, set_Encrypt, arginfo_TElPKCS11ManagerSecretKeyObject_set_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, get_Extractable, arginfo_TElPKCS11ManagerSecretKeyObject_get_Extractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, set_Extractable, arginfo_TElPKCS11ManagerSecretKeyObject_set_Extractable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, get_Sensitive, arginfo_TElPKCS11ManagerSecretKeyObject_get_Sensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, set_Sensitive, arginfo_TElPKCS11ManagerSecretKeyObject_set_Sensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, get_Sign, arginfo_TElPKCS11ManagerSecretKeyObject_get_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, set_Sign, arginfo_TElPKCS11ManagerSecretKeyObject_set_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, get_Unwrap, arginfo_TElPKCS11ManagerSecretKeyObject_get_Unwrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, set_Unwrap, arginfo_TElPKCS11ManagerSecretKeyObject_set_Unwrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, get_Verify, arginfo_TElPKCS11ManagerSecretKeyObject_get_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, set_Verify, arginfo_TElPKCS11ManagerSecretKeyObject_set_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, get_Wrap, arginfo_TElPKCS11ManagerSecretKeyObject_get_Wrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, set_Wrap, arginfo_TElPKCS11ManagerSecretKeyObject_set_Wrap, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ManagerSecretKeyObject, __construct, arginfo_TElPKCS11ManagerSecretKeyObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ManagerSecretKeyObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ManagerSecretKeyObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ManagerSecretKeyObject", TElPKCS11ManagerSecretKeyObject_methods);
	if (NULL == TElPKCS11ManagerKeyObject_ce_ptr)
		Register_TElPKCS11ManagerKeyObject(TSRMLS_C);
	TElPKCS11ManagerSecretKeyObject_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11ManagerKeyObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ConsumerManager_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ConsumerManager, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ConsumerManager_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ConsumerManager___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ConsumerManager_methods[] = {
	PHP_ME(TElPKCS11ConsumerManager, __construct, arginfo_TElPKCS11ConsumerManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ConsumerManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ConsumerManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ConsumerManager", TElPKCS11ConsumerManager_methods);
	if (NULL == TElPKCS11Consumer_ce_ptr)
		Register_TElPKCS11Consumer(TSRMLS_C);
	TElPKCS11ConsumerManager_ce_ptr = zend_register_internal_class_ex(&ce, TElPKCS11Consumer_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPKCS11Manager_Aliases(TSRMLS_D)
{
	if (NULL == TElPKCS11Manager_ce_ptr)
		Register_TElPKCS11Manager(TSRMLS_C);
	zend_register_class_alias("ElPKCS11Manager", TElPKCS11Manager_ce_ptr);
	if (NULL == TElPKCS11ManagerObject_ce_ptr)
		Register_TElPKCS11ManagerObject(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ManagerObject", TElPKCS11ManagerObject_ce_ptr);
	if (NULL == TElPKCS11ManagerDataObject_ce_ptr)
		Register_TElPKCS11ManagerDataObject(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ManagerDataObject", TElPKCS11ManagerDataObject_ce_ptr);
	if (NULL == TElPKCS11ManagerCertificateObject_ce_ptr)
		Register_TElPKCS11ManagerCertificateObject(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ManagerCertificateObject", TElPKCS11ManagerCertificateObject_ce_ptr);
	if (NULL == TElPKCS11ManagerKeyObject_ce_ptr)
		Register_TElPKCS11ManagerKeyObject(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ManagerKeyObject", TElPKCS11ManagerKeyObject_ce_ptr);
	if (NULL == TElPKCS11ManagerPublicKeyObject_ce_ptr)
		Register_TElPKCS11ManagerPublicKeyObject(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ManagerPublicKeyObject", TElPKCS11ManagerPublicKeyObject_ce_ptr);
	if (NULL == TElPKCS11ManagerPrivateKeyObject_ce_ptr)
		Register_TElPKCS11ManagerPrivateKeyObject(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ManagerPrivateKeyObject", TElPKCS11ManagerPrivateKeyObject_ce_ptr);
	if (NULL == TElPKCS11ManagerSecretKeyObject_ce_ptr)
		Register_TElPKCS11ManagerSecretKeyObject(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ManagerSecretKeyObject", TElPKCS11ManagerSecretKeyObject_ce_ptr);
	if (NULL == TElPKCS11ConsumerManager_ce_ptr)
		Register_TElPKCS11ConsumerManager(TSRMLS_C);
	zend_register_class_alias("ElPKCS11ConsumerManager", TElPKCS11ConsumerManager_ce_ptr);
}
