#include "sbseed.h"

SB_PHP_METHOD(TSEEDKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSEEDKey));
		intern->len = sizeof(TSEEDKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSEEDKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSEEDKey));
}

zend_class_entry *TSEEDKey_ce_ptr = NULL;

static zend_function_entry TSEEDKey_methods[] = {
	PHP_ME(TSEEDKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSEEDKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSEEDKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSEEDKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSEEDKey", TSEEDKey_methods);
	TSEEDKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBSeed, SeedCoding)
{
	long u1Direction;
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oKey;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzOl", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oKey, TSEEDKey_ce_ptr, &u1Direction) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBSeed_SeedCoding(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TSEEDKey *)SBGetStructPointer(oKey TSRMLS_CC), (uint8_t)u1Direction) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer, &integer, &integer, TSEEDKey, integer)" TSRMLS_CC);
	}
}

void Register_SBSeed_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSeed, SEED_ENCODE, SB_SEED_ENCODE, SB_SEED_ENCODE);
	SB_REGISTER_LONG_CONSTANT(SBSeed, SEED_DECODE, SB_SEED_DECODE, SB_SEED_DECODE);
}

