#include "sbserpent.h"

SB_PHP_METHOD(TSerpentBuffer, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSerpentBuffer));
		intern->len = sizeof(TSerpentBuffer);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSerpentBuffer, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSerpentBuffer));
}

zend_class_entry *TSerpentBuffer_ce_ptr = NULL;

static zend_function_entry TSerpentBuffer_methods[] = {
	PHP_ME(TSerpentBuffer, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSerpentBuffer, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSerpentBuffer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSerpentBuffer_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSerpentBuffer", TSerpentBuffer_methods);
	TSerpentBuffer_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSerpentExpandedKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSerpentExpandedKey));
		intern->len = sizeof(TSerpentExpandedKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSerpentExpandedKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSerpentExpandedKey));
}

zend_class_entry *TSerpentExpandedKey_ce_ptr = NULL;

static zend_function_entry TSerpentExpandedKey_methods[] = {
	PHP_ME(TSerpentExpandedKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSerpentExpandedKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSerpentExpandedKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSerpentExpandedKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSerpentExpandedKey", TSerpentExpandedKey_methods);
	TSerpentExpandedKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSerpentExpandedKeyEx, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSerpentExpandedKeyEx));
		intern->len = sizeof(TSerpentExpandedKeyEx);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSerpentExpandedKeyEx, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSerpentExpandedKeyEx));
}

zend_class_entry *TSerpentExpandedKeyEx_ce_ptr = NULL;

static zend_function_entry TSerpentExpandedKeyEx_methods[] = {
	PHP_ME(TSerpentExpandedKeyEx, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSerpentExpandedKeyEx, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSerpentExpandedKeyEx(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSerpentExpandedKeyEx_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSerpentExpandedKeyEx", TSerpentExpandedKeyEx_methods);
	TSerpentExpandedKeyEx_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBSerpent, ExpandKey)
{
	SBArrayZValInfo aiKey;
	zval *oExpandedKey;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaKey, &oExpandedKey, TSerpentExpandedKey_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && PZVAL_IS_REF(oExpandedKey))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSerpent_ExpandKey(aiKey.data, aiKey.len, (TSerpentExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TSerpentExpandedKey)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSerpent, EncryptBlock)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oExpandedKey;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzO", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oExpandedKey, TSerpentExpandedKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBSerpent_EncryptBlock(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TSerpentExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer, &integer, &integer, TSerpentExpandedKey)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSerpent, DecryptBlock)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oExpandedKey;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzO", &zu4B0, &zu4B1, &zu4B2, &zu4B3, &oExpandedKey, TSerpentExpandedKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBSerpent_DecryptBlock(&u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw, (TSerpentExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer, &integer, &integer, TSerpentExpandedKey)" TSRMLS_CC);
	}
}

