#include "sbsha2.h"

SB_PHP_METHOD(TSHA256Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSHA256Context));
		intern->len = sizeof(TSHA256Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSHA256Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSHA256Context));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSHA256Context, get_Size)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSHA256Context, set_Size)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSHA256Context, get_BufSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TSHA256Context, set_BufSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TSHA256Context, get_A)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(TSHA256Context, set_A)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(TSHA256Context, get_B)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(TSHA256Context, set_B)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(TSHA256Context, get_C)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(TSHA256Context, set_C)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(TSHA256Context, get_D)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(TSHA256Context, set_D)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(TSHA256Context, get_E)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

SB_PHP_METHOD(TSHA256Context, set_E)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

SB_PHP_METHOD(TSHA256Context, get_F)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(TSHA256Context, set_F)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(TSHA256Context, get_G)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 100);
}

SB_PHP_METHOD(TSHA256Context, set_G)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 100);
}

SB_PHP_METHOD(TSHA256Context, get_H)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 104);
}

SB_PHP_METHOD(TSHA256Context, set_H)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 104);
}

zend_class_entry *TSHA256Context_ce_ptr = NULL;

static zend_function_entry TSHA256Context_methods[] = {
	PHP_ME(TSHA256Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSHA256Context, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, get_BufSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_BufSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, get_C, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_C, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, get_D, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_D, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, get_E, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_E, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, get_F, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_F, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, get_G, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_G, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, get_H, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA256Context, set_H, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSHA256Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSHA256Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSHA256Context", TSHA256Context_methods);
	TSHA256Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSHA512Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSHA512Context));
		intern->len = sizeof(TSHA512Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSHA512Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSHA512Context));
}

SB_PHP_METHOD(TSHA512Context, get_Size)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSHA512Context, set_Size)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSHA512Context, get_BufSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 136);
}

SB_PHP_METHOD(TSHA512Context, set_BufSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 136);
}

SB_PHP_METHOD(TSHA512Context, get_A)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 140);
}

SB_PHP_METHOD(TSHA512Context, set_A)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 140);
}

SB_PHP_METHOD(TSHA512Context, get_B)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 148);
}

SB_PHP_METHOD(TSHA512Context, set_B)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 148);
}

SB_PHP_METHOD(TSHA512Context, get_C)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 156);
}

SB_PHP_METHOD(TSHA512Context, set_C)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 156);
}

SB_PHP_METHOD(TSHA512Context, get_D)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 164);
}

SB_PHP_METHOD(TSHA512Context, set_D)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 164);
}

SB_PHP_METHOD(TSHA512Context, get_E)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 172);
}

SB_PHP_METHOD(TSHA512Context, set_E)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 172);
}

SB_PHP_METHOD(TSHA512Context, get_F)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 180);
}

SB_PHP_METHOD(TSHA512Context, set_F)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 180);
}

SB_PHP_METHOD(TSHA512Context, get_G)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 188);
}

SB_PHP_METHOD(TSHA512Context, set_G)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 188);
}

SB_PHP_METHOD(TSHA512Context, get_H)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 196);
}

SB_PHP_METHOD(TSHA512Context, set_H)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 196);
}

zend_class_entry *TSHA512Context_ce_ptr = NULL;

static zend_function_entry TSHA512Context_methods[] = {
	PHP_ME(TSHA512Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSHA512Context, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, get_BufSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_BufSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, get_C, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_C, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, get_D, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_D, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, get_E, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_E, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, get_F, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_F, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, get_G, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_G, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, get_H, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSHA512Context, set_H, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSHA512Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSHA512Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSHA512Context", TSHA512Context_methods);
	TSHA512Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBSHA2, InitializeSHA224)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA256Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBSHA2_InitializeSHA224((TSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA256Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, HashSHA224)
{
	long u4Size;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaS;
	zval *zpBuffer;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TSHA256Context_ce_ptr, &zpChunk, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA224((TSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (uint32_t)u4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &u4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TMessageDigest224 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA224_1(piBuffer.data, (uint32_t)u4Size, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		object_init_ex(return_value, TMessageDigest224_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest224) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		TMessageDigest224 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA224_2(aiS.data, aiS.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		object_init_ex(return_value, TMessageDigest224_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest224) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA256Context, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, FinalizeSHA224)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA256Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest224 roOutResult;
		SBCheckError(SBSHA2_FinalizeSHA224((TSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest224_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest224) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA256Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, InitializeSHA256)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA256Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBSHA2_InitializeSHA256((TSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA256Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, HashSHA256)
{
	long u4Size;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaS;
	zval *zpBuffer;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TSHA256Context_ce_ptr, &zpChunk, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA256((TSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (uint32_t)u4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &u4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TMessageDigest256 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA256_1(piBuffer.data, (uint32_t)u4Size, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		object_init_ex(return_value, TMessageDigest256_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest256) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		TMessageDigest256 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA256_2(aiS.data, aiS.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		object_init_ex(return_value, TMessageDigest256_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest256) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA256Context, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, FinalizeSHA256)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA256Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest256 roOutResult;
		SBCheckError(SBSHA2_FinalizeSHA256((TSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest256_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest256) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA256Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, InitializeSHA384)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA512Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBSHA2_InitializeSHA384((TSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA512Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, HashSHA384)
{
	long u4Size;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaS;
	zval *zpBuffer;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TSHA512Context_ce_ptr, &zpChunk, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA384((TSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (uint32_t)u4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &u4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TMessageDigest384 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA384_1(piBuffer.data, (uint32_t)u4Size, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		object_init_ex(return_value, TMessageDigest384_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest384) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		TMessageDigest384 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA384_2(aiS.data, aiS.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		object_init_ex(return_value, TMessageDigest384_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest384) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA512Context, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, FinalizeSHA384)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA512Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest384 roOutResult;
		SBCheckError(SBSHA2_FinalizeSHA384((TSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest384_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest384) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA512Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, InitializeSHA512)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA512Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBSHA2_InitializeSHA512((TSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA512Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, HashSHA512)
{
	long u4Size;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaS;
	zval *zpBuffer;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TSHA512Context_ce_ptr, &zpChunk, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA512((TSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (uint32_t)u4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &u4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TMessageDigest512 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA512_1(piBuffer.data, (uint32_t)u4Size, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		object_init_ex(return_value, TMessageDigest512_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest512) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		TMessageDigest512 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBSHA2_HashSHA512_2(aiS.data, aiS.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		object_init_ex(return_value, TMessageDigest512_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest512) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA512Context, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSHA2, FinalizeSHA512)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TSHA512Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest512 roOutResult;
		SBCheckError(SBSHA2_FinalizeSHA512((TSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest512_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest512) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSHA512Context)" TSRMLS_CC);
	}
}

void Register_SBSHA2_Aliases(TSRMLS_D)
{
	if (NULL == TSHA512Context_ce_ptr)
		Register_TSHA512Context(TSRMLS_C);
	zend_register_class_alias("TSHA384Context", TSHA512Context_ce_ptr);
}

