#include "sbsshpubkeycommon.h"

void SB_CALLBACK TSBSSHPublicKeyErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ErrorCode, const char * pcComment, int32_t szComment)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zErrorCode;
	zval * zComment;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)ErrorCode);
	MAKE_STD_ZVAL(zComment);
	ZVAL_STRINGL(zComment, pcComment, szComment, 1);

	params[0] = &zSender;
	params[1] = &zErrorCode;
	params[2] = &zComment;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zErrorCode);
	zval_ptr_dtor(&zComment);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyInvalidReplyEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyStatusEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Status, const char * pcDescr, int32_t szDescr, const char * pcTag, int32_t szTag)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zStatus;
	zval * zDescr;
	zval * zTag;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStatus);
	ZVAL_LONG(zStatus, (long)Status);
	MAKE_STD_ZVAL(zDescr);
	ZVAL_STRINGL(zDescr, pcDescr, szDescr, 1);
	MAKE_STD_ZVAL(zTag);
	ZVAL_STRINGL(zTag, pcTag, szTag, 1);

	params[0] = &zSender;
	params[1] = &zStatus;
	params[2] = &zDescr;
	params[3] = &zTag;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStatus);
	zval_ptr_dtor(&zDescr);
	zval_ptr_dtor(&zTag);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyAttributeEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcAttr, int32_t szAttr, int8_t Compulsory)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zAttr;
	zval * zCompulsory;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAttr);
	ZVAL_STRINGL(zAttr, pcAttr, szAttr, 1);
	MAKE_STD_ZVAL(zCompulsory);
	ZVAL_BOOL(zCompulsory, (zend_bool)Compulsory);

	params[0] = &zSender;
	params[1] = &zAttr;
	params[2] = &zCompulsory;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zAttr);
	zval_ptr_dtor(&zCompulsory);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyPublicKeyEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHKeyHandle Key, TElSSHPublicKeyAttributesHandle Attributes)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zKey;
	zval * zAttributes;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElSSHKey_ce_ptr, Key TSRMLS_CC);
	MAKE_STD_ZVAL(zAttributes);
	SBInitObject(zAttributes, TElSSHPublicKeyAttributes_ce_ptr, Attributes TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zKey;
	params[2] = &zAttributes;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKey);
	zval_ptr_dtor(&zAttributes);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeySendEventRaw(void * _ObjectData, TObjectHandle Sender, void * Buffer, int32_t Size)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zBuffer;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);

	params[0] = &zSender;
	params[1] = &zBuffer;
	params[2] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyReceiveEventRaw(void * _ObjectData, TObjectHandle Sender, void * Buffer, int32_t MaxSize, int32_t * Written)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zBuffer;
	zval * zMaxSize;
	zval * zWritten;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zMaxSize);
	ZVAL_LONG(zMaxSize, (long)MaxSize);
	MAKE_STD_ZVAL(zWritten);
	ZVAL_LONG(zWritten, (long)*Written);

	params[0] = &zSender;
	params[1] = &zBuffer;
	params[2] = &zMaxSize;
	params[3] = &zWritten;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zMaxSize);
	*Written = (int32_t)Z_LVAL_P(zWritten);
	zval_ptr_dtor(&zWritten);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyAddEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHKeyHandle Key, TElSSHPublicKeyAttributesHandle Attributes, int8_t Overwrite, int32_t * ErrorCode, char * pcComment, int32_t * szComment)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zKey;
	zval * zAttributes;
	zval * zOverwrite;
	zval * zErrorCode;
	zval * zComment;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElSSHKey_ce_ptr, Key TSRMLS_CC);
	MAKE_STD_ZVAL(zAttributes);
	SBInitObject(zAttributes, TElSSHPublicKeyAttributes_ce_ptr, Attributes TSRMLS_CC);
	MAKE_STD_ZVAL(zOverwrite);
	ZVAL_BOOL(zOverwrite, (zend_bool)Overwrite);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);
	MAKE_STD_ZVAL(zComment);
	ZVAL_STRINGL(zComment, pcComment, *szComment, 1);

	params[0] = &zSender;
	params[1] = &zKey;
	params[2] = &zAttributes;
	params[3] = &zOverwrite;
	params[4] = &zErrorCode;
	params[5] = &zComment;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKey);
	zval_ptr_dtor(&zAttributes);
	zval_ptr_dtor(&zOverwrite);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	SBCheckError(SBSetEventReturnStringA(6, Z_STRVAL_P(zComment), (int32_t)Z_STRLEN_P(zComment)) TSRMLS_CC);
	zval_ptr_dtor(&zComment);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyRemoveEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHKeyHandle Key, int32_t * ErrorCode, char * pcComment, int32_t * szComment)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zKey;
	zval * zErrorCode;
	zval * zComment;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElSSHKey_ce_ptr, Key TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);
	MAKE_STD_ZVAL(zComment);
	ZVAL_STRINGL(zComment, pcComment, *szComment, 1);

	params[0] = &zSender;
	params[1] = &zKey;
	params[2] = &zErrorCode;
	params[3] = &zComment;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKey);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zComment), (int32_t)Z_STRLEN_P(zComment)) TSRMLS_CC);
	zval_ptr_dtor(&zComment);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyListEventRaw(void * _ObjectData, TObjectHandle Sender, TListHandle Keys, TListHandle Attributes, int8_t * FreeObjects, int32_t * ErrorCode, char * pcComment, int32_t * szComment)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zKeys;
	zval * zAttributes;
	zval * zFreeObjects;
	zval * zErrorCode;
	zval * zComment;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKeys);
	SBInitObject(zKeys, TList_ce_ptr, Keys TSRMLS_CC);
	MAKE_STD_ZVAL(zAttributes);
	SBInitObject(zAttributes, TList_ce_ptr, Attributes TSRMLS_CC);
	MAKE_STD_ZVAL(zFreeObjects);
	ZVAL_BOOL(zFreeObjects, (zend_bool)*FreeObjects);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);
	MAKE_STD_ZVAL(zComment);
	ZVAL_STRINGL(zComment, pcComment, *szComment, 1);

	params[0] = &zSender;
	params[1] = &zKeys;
	params[2] = &zAttributes;
	params[3] = &zFreeObjects;
	params[4] = &zErrorCode;
	params[5] = &zComment;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKeys);
	zval_ptr_dtor(&zAttributes);
	*FreeObjects = (int8_t)Z_BVAL_P(zFreeObjects);
	zval_ptr_dtor(&zFreeObjects);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	SBCheckError(SBSetEventReturnStringA(6, Z_STRVAL_P(zComment), (int32_t)Z_STRLEN_P(zComment)) TSRMLS_CC);
	zval_ptr_dtor(&zComment);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyListAttributesEventRaw(void * _ObjectData, TObjectHandle Sender, TStringListHandle Names, TBitsHandle Compulsories, int32_t * ErrorCode, char * pcComment, int32_t * szComment)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zNames;
	zval * zCompulsories;
	zval * zErrorCode;
	zval * zComment;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zNames);
	SBInitObject(zNames, TStringList_ce_ptr, Names TSRMLS_CC);
	MAKE_STD_ZVAL(zCompulsories);
	SBInitObject(zCompulsories, TBits_ce_ptr, Compulsories TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);
	MAKE_STD_ZVAL(zComment);
	ZVAL_STRINGL(zComment, pcComment, *szComment, 1);

	params[0] = &zSender;
	params[1] = &zNames;
	params[2] = &zCompulsories;
	params[3] = &zErrorCode;
	params[4] = &zComment;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zNames);
	zval_ptr_dtor(&zCompulsories);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zComment), (int32_t)Z_STRLEN_P(zComment)) TSRMLS_CC);
	zval_ptr_dtor(&zComment);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHPublicKeyAttrubuteSupportedEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcAttr, int32_t szAttr, int8_t * Supported)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zAttr;
	zval * zSupported;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAttr);
	ZVAL_STRINGL(zAttr, pcAttr, szAttr, 1);
	MAKE_STD_ZVAL(zSupported);
	ZVAL_BOOL(zSupported, (zend_bool)*Supported);

	params[0] = &zSender;
	params[1] = &zAttr;
	params[2] = &zSupported;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zAttr);
	*Supported = (int8_t)Z_BVAL_P(zSupported);
	zval_ptr_dtor(&zSupported);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElSSHPublicKeyAttributes_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHPublicKeyAttributes, Add)
{
	char *sAName;
	char *sAValue;
	int sAName_len;
	int sAValue_len;
	zend_bool bAMandatory;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sAName, &sAName_len, &sAValue, &sAValue_len, &bAMandatory) == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyAttributes_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sAName, (int32_t)sAName_len, sAValue, (int32_t)sAValue_len, (int8_t)bAMandatory) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyAttributes_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyAttributes_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPublicKeyAttributes_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, get_Names)
{
	long l4i;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4i) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHPublicKeyAttributes_get_Names(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4i, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-740854253, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, set_Names)
{
	char *sv;
	int sv_len;
	long l4i;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4i, &sv, &sv_len) == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyAttributes_set_Names(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4i, sv, (int32_t)sv_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, get_Values)
{
	long l4i;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4i) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHPublicKeyAttributes_get_Values(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4i, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-497863317, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, set_Values)
{
	char *sv;
	int sv_len;
	long l4i;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4i, &sv, &sv_len) == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyAttributes_set_Values(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4i, sv, (int32_t)sv_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, get_Mandatory)
{
	long l4i;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4i) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHPublicKeyAttributes_get_Mandatory(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4i, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, set_Mandatory)
{
	long l4i;
	zend_bool bv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4i, &bv) == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyAttributes_set_Mandatory(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4i, (int8_t)bv) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyAttributes, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPublicKeyAttributes_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_Add, 0, 0, 3)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, AValue)
	ZEND_ARG_INFO(0, AMandatory)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_get_Names, 0, 0, 1)
	ZEND_ARG_INFO(0, i)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_set_Names, 0, 0, 2)
	ZEND_ARG_INFO(0, i)
	ZEND_ARG_INFO(0, v)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_get_Values, 0, 0, 1)
	ZEND_ARG_INFO(0, i)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_set_Values, 0, 0, 2)
	ZEND_ARG_INFO(0, i)
	ZEND_ARG_INFO(0, v)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_get_Mandatory, 0, 0, 1)
	ZEND_ARG_INFO(0, i)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes_set_Mandatory, 0, 0, 2)
	ZEND_ARG_INFO(0, i)
	ZEND_ARG_INFO(0, v)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyAttributes___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHPublicKeyAttributes_methods[] = {
	PHP_ME(TElSSHPublicKeyAttributes, Add, arginfo_TElSSHPublicKeyAttributes_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, Remove, arginfo_TElSSHPublicKeyAttributes_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, Clear, arginfo_TElSSHPublicKeyAttributes_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, get_Count, arginfo_TElSSHPublicKeyAttributes_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, get_Names, arginfo_TElSSHPublicKeyAttributes_get_Names, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, set_Names, arginfo_TElSSHPublicKeyAttributes_set_Names, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, get_Values, arginfo_TElSSHPublicKeyAttributes_get_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, set_Values, arginfo_TElSSHPublicKeyAttributes_set_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, get_Mandatory, arginfo_TElSSHPublicKeyAttributes_get_Mandatory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, set_Mandatory, arginfo_TElSSHPublicKeyAttributes_set_Mandatory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyAttributes, __construct, arginfo_TElSSHPublicKeyAttributes___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHPublicKeyAttributes(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHPublicKeyAttributes_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHPublicKeyAttributes", TElSSHPublicKeyAttributes_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSSHPublicKeyAttributes_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSSHPubKeyCommon_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_SUCCESS, SB_SSH_PUBLICKEY_SUCCESS, SB_SSH_PUBLICKEY_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_ACCESS_DENIED, SB_SSH_PUBLICKEY_ACCESS_DENIED, SB_SSH_PUBLICKEY_ACCESS_DENIED);
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_STORAGE_EXCEEDED, SB_SSH_PUBLICKEY_STORAGE_EXCEEDED, SB_SSH_PUBLICKEY_STORAGE_EXCEEDED);
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_VERSION_NOT_SUPPORTED, SB_SSH_PUBLICKEY_VERSION_NOT_SUPPORTED, SB_SSH_PUBLICKEY_VERSION_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_KEY_NOT_FOUND, SB_SSH_PUBLICKEY_KEY_NOT_FOUND, SB_SSH_PUBLICKEY_KEY_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_KEY_NOT_SUPPORTED, SB_SSH_PUBLICKEY_KEY_NOT_SUPPORTED, SB_SSH_PUBLICKEY_KEY_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_KEY_ALREADY_PRESENT, SB_SSH_PUBLICKEY_KEY_ALREADY_PRESENT, SB_SSH_PUBLICKEY_KEY_ALREADY_PRESENT);
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_GENERAL_FAILURE, SB_SSH_PUBLICKEY_GENERAL_FAILURE, SB_SSH_PUBLICKEY_GENERAL_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_REQUEST_NOT_SUPPORTED, SB_SSH_PUBLICKEY_REQUEST_NOT_SUPPORTED, SB_SSH_PUBLICKEY_REQUEST_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBSSHPubKeyCommon, SSH_PUBLICKEY_ATTRIBUTE_NOT_SUPPORTED, SB_SSH_PUBLICKEY_ATTRIBUTE_NOT_SUPPORTED, SB_SSH_PUBLICKEY_ATTRIBUTE_NOT_SUPPORTED);
}

void Register_SBSSHPubKeyCommon_Aliases(TSRMLS_D)
{
	if (NULL == TElSSHPublicKeyAttributes_ce_ptr)
		Register_TElSSHPublicKeyAttributes(TSRMLS_C);
	zend_register_class_alias("ElSSHPublicKeyAttributes", TElSSHPublicKeyAttributes_ce_ptr);
}

