#include "sbsshpubkeyhandler.h"

zend_class_entry *TElPublicKeySSHSubsystemHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElPublicKeySSHSubsystemHandler, HandlerType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHSubsystemHandlerTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeySSHSubsystemHandler_HandlerType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeySSHSubsystemHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeySSHSubsystemHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeySSHSubsystemHandler, get_Server)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeySSHSubsystemHandler_get_Server(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHPublicKeyServer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeySSHSubsystemHandler, set_Server)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSSHPublicKeyServer_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeySSHSubsystemHandler_set_Server(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHPublicKeyServer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeySSHSubsystemHandler, __construct)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeySSHSubsystemHandler_Create(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeySSHSubsystemHandler, CreateDelayed)
{
	zval *oConnection;
	zval *oServer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oConnection, TElSSHTunnelConnection_ce_ptr, &oServer, TElSSHPublicKeyServer_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeySSHSubsystemHandler_CreateDelayed(SBGetObjectHandle(oConnection TSRMLS_CC), SBGetObjectHandle(oServer TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElPublicKeySSHSubsystemHandler_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection, TElSSHPublicKeyServer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeySSHSubsystemHandler_HandlerType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeySSHSubsystemHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeySSHSubsystemHandler_get_Server, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeySSHSubsystemHandler_set_Server, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSSHPublicKeyServer, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeySSHSubsystemHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeySSHSubsystemHandler_CreateDelayed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
	ZEND_ARG_OBJ_INFO(0, Server, TElSSHPublicKeyServer, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPublicKeySSHSubsystemHandler_methods[] = {
	PHP_ME(TElPublicKeySSHSubsystemHandler, HandlerType, arginfo_TElPublicKeySSHSubsystemHandler_HandlerType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeySSHSubsystemHandler, ClassType, arginfo_TElPublicKeySSHSubsystemHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPublicKeySSHSubsystemHandler, get_Server, arginfo_TElPublicKeySSHSubsystemHandler_get_Server, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeySSHSubsystemHandler, set_Server, arginfo_TElPublicKeySSHSubsystemHandler_set_Server, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeySSHSubsystemHandler, __construct, arginfo_TElPublicKeySSHSubsystemHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeySSHSubsystemHandler, CreateDelayed, arginfo_TElPublicKeySSHSubsystemHandler_CreateDelayed, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElPublicKeySSHSubsystemHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPublicKeySSHSubsystemHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPublicKeySSHSubsystemHandler", TElPublicKeySSHSubsystemHandler_methods);
	if (NULL == TElCustomSSHSubsystemHandler_ce_ptr)
		Register_TElCustomSSHSubsystemHandler(TSRMLS_C);
	TElPublicKeySSHSubsystemHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSSHSubsystemHandler_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSSHPubKeyHandler_Aliases(TSRMLS_D)
{
	if (NULL == TElPublicKeySSHSubsystemHandler_ce_ptr)
		Register_TElPublicKeySSHSubsystemHandler(TSRMLS_C);
	zend_register_class_alias("ElPublicKeySSHSubsystemHandler", TElPublicKeySSHSubsystemHandler_ce_ptr);
}

