#include "sbsslclient.h"

zend_class_entry *TClientCertificateType_ce_ptr = NULL;

void SB_CALLBACK TSBChooseCertificateEventRaw(void * _ObjectData, TObjectHandle Sender, const TElX509CertificateHandle pCertificates[], int32_t szCertificates, int32_t * CertificateIndex)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zCertificates;
	zval * zCertificateIndex;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificates);
	SBSetObjectArrayToZValP((TElClassHandle *)pCertificates, szCertificates, TElX509Certificate_ce_ptr, zCertificates TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificateIndex);
	ZVAL_LONG(zCertificateIndex, (long)*CertificateIndex);

	params[0] = &zSender;
	params[1] = &zCertificates;
	params[2] = &zCertificateIndex;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificates);
	*CertificateIndex = (int32_t)Z_LVAL_P(zCertificateIndex);
	zval_ptr_dtor(&zCertificateIndex);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCertificateNeededEventRaw(void * _ObjectData, TObjectHandle Sender, void * CertificateBuffer, int32_t * CertificateSize, void * PrivateKeyBuffer, int32_t * PrivateKeySize, TClientCertificateTypeRaw CertificateType)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zCertificateBuffer;
	zval * zCertificateSize;
	zval * zPrivateKeyBuffer;
	zval * zPrivateKeySize;
	zval * zCertificateType;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificateBuffer);
	SBInitPointerObject(zCertificateBuffer, CertificateBuffer TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificateSize);
	ZVAL_LONG(zCertificateSize, (long)*CertificateSize);
	MAKE_STD_ZVAL(zPrivateKeyBuffer);
	SBInitPointerObject(zPrivateKeyBuffer, PrivateKeyBuffer TSRMLS_CC);
	MAKE_STD_ZVAL(zPrivateKeySize);
	ZVAL_LONG(zPrivateKeySize, (long)*PrivateKeySize);
	MAKE_STD_ZVAL(zCertificateType);
	ZVAL_LONG(zCertificateType, (long)CertificateType);

	params[0] = &zSender;
	params[1] = &zCertificateBuffer;
	params[2] = &zCertificateSize;
	params[3] = &zPrivateKeyBuffer;
	params[4] = &zPrivateKeySize;
	params[5] = &zCertificateType;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificateBuffer);
	*CertificateSize = (int32_t)Z_LVAL_P(zCertificateSize);
	zval_ptr_dtor(&zCertificateSize);
	zval_ptr_dtor(&zPrivateKeyBuffer);
	*PrivateKeySize = (int32_t)Z_LVAL_P(zPrivateKeySize);
	zval_ptr_dtor(&zPrivateKeySize);
	zval_ptr_dtor(&zCertificateType);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCertificateNeededExEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle * Certificate)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCertificate;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, *Certificate TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Certificate = SBGetObjectHandleCE(zCertificate, TElX509Certificate_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCertificate TSRMLS_CC);
	zval_ptr_dtor(&zCertificate);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBRawPublicKeyNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElPublicKeyMaterialHandle * RawPublicKey)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zRawPublicKey;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRawPublicKey);
	SBInitObject(zRawPublicKey, TElPublicKeyMaterial_ce_ptr, *RawPublicKey TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zRawPublicKey;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*RawPublicKey = SBGetObjectHandleCE(zRawPublicKey, TElPublicKeyMaterial_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zRawPublicKey TSRMLS_CC);
	zval_ptr_dtor(&zRawPublicKey);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBClientKeyNeededEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcHint, int32_t szHint, char * pcIdentity, int32_t * szIdentity, uint8_t pKey[], int32_t * szKey)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zHint;
	zval * zIdentity;
	zval * zKey;
	SBArrayZValInfo aiKey;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHint);
	ZVAL_STRINGL(zHint, pcHint, szHint, 1);
	MAKE_STD_ZVAL(zIdentity);
	ZVAL_STRINGL(zIdentity, pcIdentity, *szIdentity, 1);
	MAKE_STD_ZVAL(zKey);
	ZVAL_STRINGL(zKey, pKey, *szKey, 1);

	params[0] = &zSender;
	params[1] = &zHint;
	params[2] = &zIdentity;
	params[3] = &zKey;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHint);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zIdentity), (int32_t)Z_STRLEN_P(zIdentity)) TSRMLS_CC);
	zval_ptr_dtor(&zIdentity);
	if (SBGetByteArrayFromZVal(zKey, &aiKey TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(4, aiKey.data, aiKey.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiKey);
	zval_ptr_dtor(&zKey);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCertificateStatusEventRaw(void * _ObjectData, TObjectHandle Sender, TSBCertificateStatusTypeRaw StatusType, TListHandle Data)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zStatusType;
	zval * zData;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStatusType);
	ZVAL_LONG(zStatusType, (long)StatusType);
	MAKE_STD_ZVAL(zData);
	SBInitObject(zData, TList_ce_ptr, Data TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStatusType;
	params[2] = &zData;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStatusType);
	zval_ptr_dtor(&zData);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *SBSSLClient_TSBReceiveState_ce_ptr = NULL;

zend_class_entry *TSBRole_ce_ptr = NULL;

zend_class_entry *TSSL2ContentType_ce_ptr = NULL;

SB_PHP_METHOD(TSSL2CipherSuite, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSSL2CipherSuite));
		intern->len = sizeof(TSSL2CipherSuite);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSSL2CipherSuite, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSSL2CipherSuite));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSSL2CipherSuite, get_Index)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSSL2CipherSuite, set_Index)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSSL2CipherSuite, get_First)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TSSL2CipherSuite, set_First)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TSSL2CipherSuite, get_Second)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(TSSL2CipherSuite, set_Second)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(TSSL2CipherSuite, get_Third)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 3);
}

SB_PHP_METHOD(TSSL2CipherSuite, set_Third)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 3);
}

SB_PHP_METHOD(TSSL2CipherSuite, get_HashSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(TSSL2CipherSuite, set_HashSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

zend_class_entry *TSSL2CipherSuite_ce_ptr = NULL;

static zend_function_entry TSSL2CipherSuite_methods[] = {
	PHP_ME(TSSL2CipherSuite, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSSL2CipherSuite, get_Index, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, set_Index, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, get_First, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, set_First, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, get_Second, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, set_Second, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, get_Third, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, set_Third, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, get_HashSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL2CipherSuite, set_HashSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSSL2CipherSuite(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSSL2CipherSuite_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSSL2CipherSuite", TSSL2CipherSuite_methods);
	TSSL2CipherSuite_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSSL2State_ce_ptr = NULL;

zend_class_entry *TSSL2SequenceNumberOwner_ce_ptr = NULL;

zend_class_entry *TSSL3State_ce_ptr = NULL;

SB_PHP_METHOD(TSSL3CipherSuite, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSSL3CipherSuite));
		intern->len = sizeof(TSSL3CipherSuite);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSSL3CipherSuite, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSSL3CipherSuite));
}

SB_PHP_METHOD(TSSL3CipherSuite, get_Index)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_Index)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSSL3CipherSuite, get_First)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_First)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TSSL3CipherSuite, get_Second)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_Second)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(TSSL3CipherSuite, get_PRFHashAlgorithm)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_PRFHashAlgorithm)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSSL3CipherSuite, get_HashSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_HashSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TSSL3CipherSuite, get_RealHashSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 13);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_RealHashSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 13);
}

SB_PHP_METHOD(TSSL3CipherSuite, get_KeySize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 14);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_KeySize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 14);
}

SB_PHP_METHOD(TSSL3CipherSuite, get_IVSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 15);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_IVSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 15);
}

SB_PHP_METHOD(TSSL3CipherSuite, get_BlockSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_BlockSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TSSL3CipherSuite, get_PaddingSize)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 17);
}

SB_PHP_METHOD(TSSL3CipherSuite, set_PaddingSize)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 17);
}

zend_class_entry *TSSL3CipherSuite_ce_ptr = NULL;

static zend_function_entry TSSL3CipherSuite_methods[] = {
	PHP_ME(TSSL3CipherSuite, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSSL3CipherSuite, get_Index, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_Index, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, get_First, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_First, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, get_Second, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_Second, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, get_PRFHashAlgorithm, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_PRFHashAlgorithm, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, get_HashSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_HashSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, get_RealHashSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_RealHashSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, get_KeySize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_KeySize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, get_IVSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_IVSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, get_BlockSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_BlockSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, get_PaddingSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSL3CipherSuite, set_PaddingSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSSL3CipherSuite(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSSL3CipherSuite_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSSL3CipherSuite", TSSL3CipherSuite_methods);
	TSSL3CipherSuite_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TCloseExplain_ce_ptr = NULL;

SB_PHP_METHOD(TClientCertificate, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TClientCertificate));
		intern->len = sizeof(TClientCertificate);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TClientCertificate, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TClientCertificate));
}

SB_PHP_METHOD(TClientCertificate, get_CertificateSize)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TClientCertificate, set_CertificateSize)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TClientCertificate, get_PrivateKeySize)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TClientCertificate, set_PrivateKeySize)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

zend_class_entry *TClientCertificate_ce_ptr = NULL;

static zend_function_entry TClientCertificate_methods[] = {
	PHP_ME(TClientCertificate, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TClientCertificate, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TClientCertificate, get_CertificateSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TClientCertificate, set_CertificateSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TClientCertificate, get_PrivateKeySize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TClientCertificate, set_PrivateKeySize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TClientCertificate(TSRMLS_D)
{
	zend_class_entry ce;
	if (TClientCertificate_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TClientCertificate", TClientCertificate_methods);
	TClientCertificate_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBClientSSLPredefinedConfiguration_ce_ptr = NULL;

zend_class_entry *TElClientSSLConnectionInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElClientSSLConnectionInfo, Initialize)
{
	long fVersion;
	long u1Ciphersuite;
	SBArrayZValInfo aiSessionID;
	zend_bool bResumedSession;
	zval *oClientChain;
	zval *oServerChain;
	zval *zaSessionID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zb", &fVersion, &u1Ciphersuite, &oServerChain, TElCustomCertStorage_ce_ptr, &oClientChain, TElCustomCertStorage_ce_ptr, &zaSessionID, &bResumedSession) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSessionID)) || (IS_ARRAY == Z_TYPE_P(zaSessionID)) || (IS_NULL == Z_TYPE_P(zaSessionID))))
	{
		if (!SBGetByteArrayFromZVal(zaSessionID, &aiSessionID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElClientSSLConnectionInfo_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBVersionRaw)fVersion, (uint8_t)u1Ciphersuite, SBGetObjectHandle(oServerChain TSRMLS_CC), SBGetObjectHandle(oClientChain TSRMLS_CC), aiSessionID.data, aiSessionID.len, (int8_t)bResumedSession) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSessionID);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCertStorage, TElCustomCertStorage, array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionInfo, Initialize2)
{
	long fVersion;
	long l4ECCurve;
	long u1Ciphersuite;
	SBArrayZValInfo aiSessionID;
	zend_bool bResumedSession;
	zval *oClientChain;
	zval *oServerChain;
	zval *zaSessionID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zbl", &fVersion, &u1Ciphersuite, &oServerChain, TElX509CertificateChain_ce_ptr, &oClientChain, TElCustomCertStorage_ce_ptr, &zaSessionID, &bResumedSession, &l4ECCurve) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSessionID)) || (IS_ARRAY == Z_TYPE_P(zaSessionID)) || (IS_NULL == Z_TYPE_P(zaSessionID))))
	{
		if (!SBGetByteArrayFromZVal(zaSessionID, &aiSessionID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElClientSSLConnectionInfo_Initialize2(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBVersionRaw)fVersion, (uint8_t)u1Ciphersuite, SBGetObjectHandle(oServerChain TSRMLS_CC), SBGetObjectHandle(oClientChain TSRMLS_CC), aiSessionID.data, aiSessionID.len, (int8_t)bResumedSession, (int32_t)l4ECCurve) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSessionID);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElX509CertificateChain, TElCustomCertStorage, array of byte|string|NULL, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionInfo, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionInfo_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionInfo, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElSSLClass_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElClientSSLConnectionInfo_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSLClass)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionInfo_Initialize, 0, 0, 6)
	ZEND_ARG_INFO(0, Version)
	ZEND_ARG_INFO(0, Ciphersuite)
	ZEND_ARG_OBJ_INFO(0, ServerChain, TElCustomCertStorage, 1)
	ZEND_ARG_OBJ_INFO(0, ClientChain, TElCustomCertStorage, 1)
	ZEND_ARG_TYPE_INFO(0, SessionID, 0, 1)
	ZEND_ARG_INFO(0, ResumedSession)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionInfo_Initialize2, 0, 0, 7)
	ZEND_ARG_INFO(0, Version)
	ZEND_ARG_INFO(0, Ciphersuite)
	ZEND_ARG_OBJ_INFO(0, ServerChain, TElX509CertificateChain, 1)
	ZEND_ARG_OBJ_INFO(0, ClientChain, TElCustomCertStorage, 1)
	ZEND_ARG_TYPE_INFO(0, SessionID, 0, 1)
	ZEND_ARG_INFO(0, ResumedSession)
	ZEND_ARG_INFO(0, ECCurve)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionInfo_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionInfo___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElSSLClass, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElClientSSLConnectionInfo_methods[] = {
	PHP_ME(TElClientSSLConnectionInfo, Initialize, arginfo_TElClientSSLConnectionInfo_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionInfo, Initialize2, arginfo_TElClientSSLConnectionInfo_Initialize2, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionInfo, Reset, arginfo_TElClientSSLConnectionInfo_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionInfo, __construct, arginfo_TElClientSSLConnectionInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElClientSSLConnectionInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElClientSSLConnectionInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElClientSSLConnectionInfo", TElClientSSLConnectionInfo_methods);
	if (NULL == TElSSLConnectionInfo_ce_ptr)
		Register_TElSSLConnectionInfo(TSRMLS_C);
	TElClientSSLConnectionInfo_ce_ptr = zend_register_internal_class_ex(&ce, TElSSLConnectionInfo_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSLClient_ce_ptr = NULL;

SB_PHP_METHOD(TElSSLClient, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSLClient_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, Close)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElSSLClient_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSLClient_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, SendData)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSLClient_SendData(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, SendText)
{
	SBArrayZValInfo aiS;
	zval *zaS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSLClient_SendText(SBGetObjectHandle(getThis() TSRMLS_CC), aiS.data, aiS.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, SendKeepAlive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLClient_SendKeepAlive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, InternalValidate)
{
	TSBCertificateValidityRaw fValidityRaw;
	TSBCertificateValidityReasonRaw fReasonRaw;
	zval *zfReason;
	zval *zfValidity;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zfValidity, &zfReason) == SUCCESS) && PZVAL_IS_REF(zfValidity) && (IS_LONG == Z_TYPE_P(zfValidity)) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		fValidityRaw = (TSBCertificateValidityRaw)Z_LVAL_P(zfValidity);
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElSSLClient_InternalValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &fValidityRaw, &fReasonRaw) TSRMLS_CC);
		ZVAL_LONG(zfValidity, (long)fValidityRaw);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, Resume)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSLClient_Resume(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, Join)
{
	zval *oElSecureClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElSecureClient, TElSSLClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLClient_Join(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElSecureClient TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSLClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, RenegotiateCiphers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSLClient_RenegotiateCiphers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, AddCertificateType)
{
	long fC_Type;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fC_Type) == SUCCESS)
	{
		SBCheckError(TElSSLClient_AddCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSSLCertificateTypeRaw)fC_Type) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, DelCertificateType)
{
	long fC_Type;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fC_Type) == SUCCESS)
	{
		SBCheckError(TElSSLClient_DelCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSSLCertificateTypeRaw)fC_Type) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, GetCertTypesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSLClient_GetCertTypesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, ClearCertificateType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSLClient_ClearCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, AddClientCertificateType)
{
	long fC_Type;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fC_Type) == SUCCESS)
	{
		SBCheckError(TElSSLClient_AddClientCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSSLCertificateTypeRaw)fC_Type) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, DelClientCertificateType)
{
	long fC_Type;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fC_Type) == SUCCESS)
	{
		SBCheckError(TElSSLClient_DelClientCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSSLCertificateTypeRaw)fC_Type) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, GetClientCertTypesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSLClient_GetClientCertTypesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, ClearClientCertificateType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSLClient_ClearClientCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_CipherSuite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSSLClient_get_CipherSuite(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_CertTypes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElSSLCertificateTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSSLClient_get_CertTypes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_CertTypes)
{
	long fValue;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &fValue) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_CertTypes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (TElSSLCertificateTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_ClientCertTypes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElSSLCertificateTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSSLClient_get_ClientCertTypes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_ClientCertTypes)
{
	long fValue;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &fValue) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_ClientCertTypes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (TElSSLCertificateTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_ECCurves)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLClient_get_ECCurves(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_ECCurves)
{
	long l4Index;
	zend_bool bEnabled;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Index, &bEnabled) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_ECCurves(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bEnabled) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_ECPoints)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLClient_get_ECPoints(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_ECPoints)
{
	long l4Index;
	zend_bool bEnabled;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Index, &bEnabled) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_ECPoints(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bEnabled) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_CanResume)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLClient_get_CanResume(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_ClientState)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSL3StateRaw fOutResultRaw = 0;
		SBCheckError(TElSSLClient_get_ClientState(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLClient_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLClient_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_UsedCertificateTypeExtension)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateTypeExtensionRaw fOutResultRaw = 0;
		SBCheckError(TElSSLClient_get_UsedCertificateTypeExtension(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_UsedCertificateTypeExtension)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_UsedCertificateTypeExtension(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCertificateTypeExtensionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_UseExtendedMasterSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSLClient_get_UseExtendedMasterSecret(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_UseExtendedMasterSecret)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_UseExtendedMasterSecret(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLClient_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_ClientCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLClient_get_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_ClientCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_ClientRawKeyStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLClient_get_ClientRawKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterialStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_ClientRawKeyStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElKeyMaterialStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_ClientRawKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterialStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLClient_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSSLExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_PeerExtensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLClient_get_PeerExtensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElServerSSLExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_SRPUsername)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSLClient_get_SRPUsername(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-269969591, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_SRPUsername)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_SRPUsername(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_SRPPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSLClient_get_SRPPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(578082795, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_SRPPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSLClient_set_SRPPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLClient_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLClient_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_OnCertificateChoose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBChooseCertificateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLClient_get_OnCertificateChoose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_OnCertificateChoose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLClient_set_OnCertificateChoose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBChooseCertificateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBChooseCertificateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_OnCertificateNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLClient_get_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_OnCertificateNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLClient_set_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_OnCertificateNeededEx)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateNeededExEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLClient_get_OnCertificateNeededEx(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_OnCertificateNeededEx)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLClient_set_OnCertificateNeededEx(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateNeededExEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateNeededExEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_OnCertificateStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateStatusEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLClient_get_OnCertificateStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_OnCertificateStatus)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLClient_set_OnCertificateStatus(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateStatusEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateStatusEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_OnKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBClientKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLClient_get_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_OnKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLClient_set_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBClientKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBClientKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, get_OnRenegotiationRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRenegotiationRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLClient_get_OnRenegotiationRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, set_OnRenegotiationRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLClient_set_OnRenegotiationRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBRenegotiationRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBRenegotiationRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLClient, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLClient_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_SendData, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_SendText, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, S, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_SendKeepAlive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_InternalValidate, 0, 0, 2)
	ZEND_ARG_INFO(1, Validity)
	ZEND_ARG_INFO(1, Reason)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_Resume, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_Join, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ElSecureClient, TElSSLClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_RenegotiateCiphers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_AddCertificateType, 0, 0, 1)
	ZEND_ARG_INFO(0, C_Type)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_DelCertificateType, 0, 0, 1)
	ZEND_ARG_INFO(0, C_Type)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_GetCertTypesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_ClearCertificateType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_AddClientCertificateType, 0, 0, 1)
	ZEND_ARG_INFO(0, C_Type)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_DelClientCertificateType, 0, 0, 1)
	ZEND_ARG_INFO(0, C_Type)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_GetClientCertTypesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_ClearClientCertificateType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_CipherSuite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_CertTypes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_CertTypes, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_ClientCertTypes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_ClientCertTypes, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_ECCurves, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_ECCurves, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Enabled)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_ECPoints, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_ECPoints, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Enabled)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_CanResume, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_ClientState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_UsedCertificateTypeExtension, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_UsedCertificateTypeExtension, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_UseExtendedMasterSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_UseExtendedMasterSecret, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_ClientCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_ClientCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_ClientRawKeyStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_ClientRawKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElKeyMaterialStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_PeerExtensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_SRPUsername, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_SRPUsername, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_SRPPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_SRPPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_OnCertificateChoose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_OnCertificateChoose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_OnCertificateNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_OnCertificateNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_OnCertificateNeededEx, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_OnCertificateNeededEx, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_OnCertificateStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_OnCertificateStatus, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_OnKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_OnKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_get_OnRenegotiationRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient_set_OnRenegotiationRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSLClient_methods[] = {
	PHP_ME(TElSSLClient, Open, arginfo_TElSSLClient_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, Close, arginfo_TElSSLClient_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, DataAvailable, arginfo_TElSSLClient_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, SendData, arginfo_TElSSLClient_SendData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, SendText, arginfo_TElSSLClient_SendText, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, SendKeepAlive, arginfo_TElSSLClient_SendKeepAlive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, InternalValidate, arginfo_TElSSLClient_InternalValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, Resume, arginfo_TElSSLClient_Resume, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, Join, arginfo_TElSSLClient_Join, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, RenegotiateCiphers, arginfo_TElSSLClient_RenegotiateCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, AddCertificateType, arginfo_TElSSLClient_AddCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, DelCertificateType, arginfo_TElSSLClient_DelCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, GetCertTypesCount, arginfo_TElSSLClient_GetCertTypesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, ClearCertificateType, arginfo_TElSSLClient_ClearCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, AddClientCertificateType, arginfo_TElSSLClient_AddClientCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, DelClientCertificateType, arginfo_TElSSLClient_DelClientCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, GetClientCertTypesCount, arginfo_TElSSLClient_GetClientCertTypesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, ClearClientCertificateType, arginfo_TElSSLClient_ClearClientCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_CipherSuite, arginfo_TElSSLClient_get_CipherSuite, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_CertTypes, arginfo_TElSSLClient_get_CertTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_CertTypes, arginfo_TElSSLClient_set_CertTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_ClientCertTypes, arginfo_TElSSLClient_get_ClientCertTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_ClientCertTypes, arginfo_TElSSLClient_set_ClientCertTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_ECCurves, arginfo_TElSSLClient_get_ECCurves, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_ECCurves, arginfo_TElSSLClient_set_ECCurves, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_ECPoints, arginfo_TElSSLClient_get_ECPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_ECPoints, arginfo_TElSSLClient_set_ECPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_CanResume, arginfo_TElSSLClient_get_CanResume, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_ClientState, arginfo_TElSSLClient_get_ClientState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_Enabled, arginfo_TElSSLClient_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_Enabled, arginfo_TElSSLClient_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_CryptoProviderManager, arginfo_TElSSLClient_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_CryptoProviderManager, arginfo_TElSSLClient_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_UsedCertificateTypeExtension, arginfo_TElSSLClient_get_UsedCertificateTypeExtension, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_UsedCertificateTypeExtension, arginfo_TElSSLClient_set_UsedCertificateTypeExtension, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_UseExtendedMasterSecret, arginfo_TElSSLClient_get_UseExtendedMasterSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_UseExtendedMasterSecret, arginfo_TElSSLClient_set_UseExtendedMasterSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_CertStorage, arginfo_TElSSLClient_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_CertStorage, arginfo_TElSSLClient_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_ClientCertStorage, arginfo_TElSSLClient_get_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_ClientCertStorage, arginfo_TElSSLClient_set_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_ClientRawKeyStorage, arginfo_TElSSLClient_get_ClientRawKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_ClientRawKeyStorage, arginfo_TElSSLClient_set_ClientRawKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_Extensions, arginfo_TElSSLClient_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_PeerExtensions, arginfo_TElSSLClient_get_PeerExtensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_SRPUsername, arginfo_TElSSLClient_get_SRPUsername, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_SRPUsername, arginfo_TElSSLClient_set_SRPUsername, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_SRPPassword, arginfo_TElSSLClient_get_SRPPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_SRPPassword, arginfo_TElSSLClient_set_SRPPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_OnCloseConnection, arginfo_TElSSLClient_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_OnCloseConnection, arginfo_TElSSLClient_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_OnCertificateChoose, arginfo_TElSSLClient_get_OnCertificateChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_OnCertificateChoose, arginfo_TElSSLClient_set_OnCertificateChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_OnCertificateNeeded, arginfo_TElSSLClient_get_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_OnCertificateNeeded, arginfo_TElSSLClient_set_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_OnCertificateNeededEx, arginfo_TElSSLClient_get_OnCertificateNeededEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_OnCertificateNeededEx, arginfo_TElSSLClient_set_OnCertificateNeededEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_OnCertificateStatus, arginfo_TElSSLClient_get_OnCertificateStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_OnCertificateStatus, arginfo_TElSSLClient_set_OnCertificateStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_OnKeyNeeded, arginfo_TElSSLClient_get_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_OnKeyNeeded, arginfo_TElSSLClient_set_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, get_OnRenegotiationRequest, arginfo_TElSSLClient_get_OnRenegotiationRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, set_OnRenegotiationRequest, arginfo_TElSSLClient_set_OnRenegotiationRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLClient, __construct, arginfo_TElSSLClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSLClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSLClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSLClient", TElSSLClient_methods);
	if (NULL == TElSSLClass_ce_ptr)
		Register_TElSSLClass(TSRMLS_C);
	TElSSLClient_ce_ptr = zend_register_internal_class_ex(&ce, TElSSLClass_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElClientSSLConnectionSettings_ce_ptr = NULL;

SB_PHP_METHOD(TElClientSSLConnectionSettings, ActivatePredefinedConfiguration)
{
	long fConfig;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fConfig) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_ActivatePredefinedConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBClientSSLPredefinedConfigurationRaw)fConfig) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, EnableAllCiphers)
{
	zend_bool bExcludeInsecure;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_EnableAllCiphers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bExcludeInsecure) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_EnableAllCiphers_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bExcludeInsecure) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, EnableCiphers)
{
	long l4MaxLevel;
	long l4MinLevel;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4MinLevel, &l4MaxLevel) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_EnableCiphers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4MinLevel, (int32_t)l4MaxLevel) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, DisableAllCiphers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableAllCiphers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, DisableCiphers)
{
	long l4MaxLevel;
	long l4MinLevel;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4MinLevel, &l4MaxLevel) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableCiphers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4MinLevel, (int32_t)l4MaxLevel) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, DisableEncryptionAlgorithm)
{
	long fAlgorithm;
	zend_bool bInverted;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAlgorithm) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBEncryptAlgorithmRaw)fAlgorithm) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &fAlgorithm, &bInverted) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableEncryptionAlgorithm_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBEncryptAlgorithmRaw)fAlgorithm, (int8_t)bInverted) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, DisableKeyExchangeAlgorithm)
{
	long fAlgorithm;
	zend_bool bInverted;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAlgorithm) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableKeyExchangeAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBKeyExchangeAlgorithmRaw)fAlgorithm) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &fAlgorithm, &bInverted) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableKeyExchangeAlgorithm_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBKeyExchangeAlgorithmRaw)fAlgorithm, (int8_t)bInverted) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, DisableDigestAlgorithm)
{
	long fAlgorithm;
	zend_bool bInverted;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAlgorithm) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableDigestAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDigestAlgorithmRaw)fAlgorithm) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &fAlgorithm, &bInverted) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableDigestAlgorithm_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDigestAlgorithmRaw)fAlgorithm, (int8_t)bInverted) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, DisableSignatureAlgorithm)
{
	long fAlgorithm;
	zend_bool bInverted;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAlgorithm) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableSignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSignatureAlgorithmRaw)fAlgorithm) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &fAlgorithm, &bInverted) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_DisableSignatureAlgorithm_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSignatureAlgorithmRaw)fAlgorithm, (int8_t)bInverted) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, Load)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_Load(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, Save)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElClientSSLConnectionSettings_Save(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1748379183, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElClientSSLConnectionSettings_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElClientSSLConnectionSettings_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientSSLConnectionSettings, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElSSLClient_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElClientSSLConnectionSettings_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSLClient)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_ActivatePredefinedConfiguration, 0, 0, 1)
	ZEND_ARG_INFO(0, Config)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_EnableAllCiphers, 0, 0, 0)
	ZEND_ARG_INFO(0, ExcludeInsecure)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_EnableCiphers, 0, 0, 2)
	ZEND_ARG_INFO(0, MinLevel)
	ZEND_ARG_INFO(0, MaxLevel)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_DisableAllCiphers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_DisableCiphers, 0, 0, 2)
	ZEND_ARG_INFO(0, MinLevel)
	ZEND_ARG_INFO(0, MaxLevel)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_DisableEncryptionAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, Inverted)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_DisableKeyExchangeAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, Inverted)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_DisableDigestAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, Inverted)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_DisableSignatureAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, Inverted)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_Load, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_Save, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientSSLConnectionSettings___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElSSLClient, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElClientSSLConnectionSettings_methods[] = {
	PHP_ME(TElClientSSLConnectionSettings, ActivatePredefinedConfiguration, arginfo_TElClientSSLConnectionSettings_ActivatePredefinedConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, EnableAllCiphers, arginfo_TElClientSSLConnectionSettings_EnableAllCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, EnableCiphers, arginfo_TElClientSSLConnectionSettings_EnableCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, DisableAllCiphers, arginfo_TElClientSSLConnectionSettings_DisableAllCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, DisableCiphers, arginfo_TElClientSSLConnectionSettings_DisableCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, DisableEncryptionAlgorithm, arginfo_TElClientSSLConnectionSettings_DisableEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, DisableKeyExchangeAlgorithm, arginfo_TElClientSSLConnectionSettings_DisableKeyExchangeAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, DisableDigestAlgorithm, arginfo_TElClientSSLConnectionSettings_DisableDigestAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, DisableSignatureAlgorithm, arginfo_TElClientSSLConnectionSettings_DisableSignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, Load, arginfo_TElClientSSLConnectionSettings_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, Save, arginfo_TElClientSSLConnectionSettings_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, get_Versions, arginfo_TElClientSSLConnectionSettings_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, set_Versions, arginfo_TElClientSSLConnectionSettings_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientSSLConnectionSettings, __construct, arginfo_TElClientSSLConnectionSettings___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElClientSSLConnectionSettings(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElClientSSLConnectionSettings_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElClientSSLConnectionSettings", TElClientSSLConnectionSettings_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElClientSSLConnectionSettings_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSSLClient_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSSLClient, SSLBufferSize, SB_SSLBufferSize, SB_SSLBufferSize);
	SB_REGISTER_LONG_CONSTANT(SBSSLClient, SSLPacketSize, SB_SSLPacketSize, SB_SSLPacketSize);
	SB_REGISTER_LONG_CONSTANT(SBSSLClient, SSLSmallBufferSize, SB_SSLSmallBufferSize, SB_SSLSmallBufferSize);
	SB_REGISTER_LONG_CONSTANT(SBSSLClient, SSLMaxBufferSize, SB_SSLMaxBufferSize, SB_SSLMaxBufferSize);
	SB_REGISTER_LONG_CONSTANT(SBSSLClient, SB_MIN_SRP_PRIME_LEN, SB_MIN_SRP_PRIME_LEN, SB_MIN_SRP_PRIME_LEN);
}

void Register_SBSSLClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TClientCertificateType", NULL);
	TClientCertificateType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TClientCertificateType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TClientCertificateType_ce_ptr, "ccRSA", 0)
	SB_DECLARE_CLASS_LONG_CONST(TClientCertificateType_ce_ptr, "ccDSS", 1)
	SB_DECLARE_CLASS_LONG_CONST(TClientCertificateType_ce_ptr, "ccRSADH", 2)
	SB_DECLARE_CLASS_LONG_CONST(TClientCertificateType_ce_ptr, "ccDSSDH", 3)
	SB_DECLARE_CLASS_LONG_CONST(TClientCertificateType_ce_ptr, "ccECDSA", 4)
	SB_DECLARE_CLASS_LONG_CONST(TClientCertificateType_ce_ptr, "ccRSA_ECDH", 5)
	SB_DECLARE_CLASS_LONG_CONST(TClientCertificateType_ce_ptr, "ccECDSA_ECDH", 6)
	
	INIT_CLASS_ENTRY(ce, "SBSSLClient_TSBReceiveState", NULL);
	SBSSLClient_TSBReceiveState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SBSSLClient_TSBReceiveState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SBSSLClient_TSBReceiveState_ce_ptr, "rsRecordHeaderWanted", 0)
	SB_DECLARE_CLASS_LONG_CONST(SBSSLClient_TSBReceiveState_ce_ptr, "rsRecordWanted", 1)
	SB_DECLARE_CLASS_LONG_CONST(SBSSLClient_TSBReceiveState_ce_ptr, "rsOneByteWanted", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBRole", NULL);
	TSBRole_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBRole_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBRole_ce_ptr, "sClient", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBRole_ce_ptr, "sServer", 1)
	
	INIT_CLASS_ENTRY(ce, "TSSL2ContentType", NULL);
	TSSL2ContentType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSSL2ContentType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSSL2ContentType_ce_ptr, "ctError", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2ContentType_ce_ptr, "ctClientHello", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2ContentType_ce_ptr, "ctClientMasterKey", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2ContentType_ce_ptr, "ctClientFinished", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2ContentType_ce_ptr, "ctServerHello", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2ContentType_ce_ptr, "ctServerVerify", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2ContentType_ce_ptr, "ctServerFinished", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2ContentType_ce_ptr, "ctRequestCertificate", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2ContentType_ce_ptr, "ctClientCertificate", 8)
	
	INIT_CLASS_ENTRY(ce, "TSSL2State", NULL);
	TSSL2State_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSSL2State_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSSL2State_ce_ptr, "stAlone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2State_ce_ptr, "stClientHelloSent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2State_ce_ptr, "stServerHelloReceived", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2State_ce_ptr, "stClientMasterKeySent", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2State_ce_ptr, "stServerVerifyReceived", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2State_ce_ptr, "stClientFinishedSent", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2State_ce_ptr, "stServerFinishedReceived", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2State_ce_ptr, "stEncryptedDataTransfer", 7)
	
	INIT_CLASS_ENTRY(ce, "TSSL2SequenceNumberOwner", NULL);
	TSSL2SequenceNumberOwner_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSSL2SequenceNumberOwner_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSSL2SequenceNumberOwner_ce_ptr, "snServer", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSSL2SequenceNumberOwner_ce_ptr, "snClient", 1)
	
	INIT_CLASS_ENTRY(ce, "TSSL3State", NULL);
	TSSL3State_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSSL3State_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3Alone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3ClientHelloSent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3ServerHelloReceived", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3CertificateReceived", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3ServerKeyExchangeReceived", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3CertificateSent", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3ClientKeyExchangeSent", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3CertificateVerifySent", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3ClientChangeCipherSpecSent", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3FinishedSent", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3ServerChangeCipherSpecReceived", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3ServerFinishedReceived", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3EncryptedDataTransfer", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "st3ServerHelloDoneReceived", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSSL3State_ce_ptr, "stUnknown", 14)
	
	INIT_CLASS_ENTRY(ce, "TCloseExplain", NULL);
	TCloseExplain_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TCloseExplain_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TCloseExplain_ce_ptr, "ceNormal", 0)
	SB_DECLARE_CLASS_LONG_CONST(TCloseExplain_ce_ptr, "ceBadHandshake", 1)
	SB_DECLARE_CLASS_LONG_CONST(TCloseExplain_ce_ptr, "ceServerClose", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBClientSSLPredefinedConfiguration", NULL);
	TSBClientSSLPredefinedConfiguration_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBClientSSLPredefinedConfiguration_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBClientSSLPredefinedConfiguration_ce_ptr, "scpcDefault", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBClientSSLPredefinedConfiguration_ce_ptr, "scpcComprehensive", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBClientSSLPredefinedConfiguration_ce_ptr, "scpcHighlySecure", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBClientSSLPredefinedConfiguration_ce_ptr, "scpcOld", 3)
}

void Register_SBSSLClient_Aliases(TSRMLS_D)
{
	if (NULL == TElSSLClient_ce_ptr)
		Register_TElSSLClient(TSRMLS_C);
	zend_register_class_alias("ElSSLClient", TElSSLClient_ce_ptr);
}

