#include "sbtspclient.h"

zend_class_entry *TSBTSPOption_ce_ptr = NULL;

zend_class_entry *TSBTSPOptions_ce_ptr = NULL;

zend_class_entry *TSBTSPRequestFormat_ce_ptr = NULL;

void SB_CALLBACK TSBTSPBeforeSignEventRaw(void * _ObjectData, TObjectHandle Sender, TObjectHandle Signer)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSigner;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSigner);
	SBInitObject(zSigner, TObject_ce_ptr, Signer TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSigner;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSigner);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTSPErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ResultCode)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zResultCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zResultCode);
	ZVAL_LONG(zResultCode, (long)ResultCode);

	params[0] = &zSender;
	params[1] = &zResultCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zResultCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTimestampNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle RequestStream, TStreamHandle ReplyStream, int8_t * Succeeded)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zRequestStream;
	zval * zReplyStream;
	zval * zSucceeded;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRequestStream);
	SBInitObject(zRequestStream, TStream_ce_ptr, RequestStream TSRMLS_CC);
	MAKE_STD_ZVAL(zReplyStream);
	SBInitObject(zReplyStream, TStream_ce_ptr, ReplyStream TSRMLS_CC);
	MAKE_STD_ZVAL(zSucceeded);
	ZVAL_BOOL(zSucceeded, (zend_bool)*Succeeded);

	params[0] = &zSender;
	params[1] = &zRequestStream;
	params[2] = &zReplyStream;
	params[3] = &zSucceeded;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRequestStream);
	zval_ptr_dtor(&zReplyStream);
	*Succeeded = (int8_t)Z_BVAL_P(zSucceeded);
	zval_ptr_dtor(&zSucceeded);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElClientTSPInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElClientTSPInfo, ParseCMS)
{
	SBArrayZValInfo aiCMSData;
	zend_bool bNoOuterInfo;
	zval *zaCMSData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaCMSData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaCMSData)) || (IS_ARRAY == Z_TYPE_P(zaCMSData)) || (IS_NULL == Z_TYPE_P(zaCMSData))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaCMSData, &aiCMSData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElClientTSPInfo_ParseCMS(SBGetObjectHandle(getThis() TSRMLS_CC), aiCMSData.data, aiCMSData.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiCMSData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaCMSData, &bNoOuterInfo) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaCMSData)) || (IS_ARRAY == Z_TYPE_P(zaCMSData)) || (IS_NULL == Z_TYPE_P(zaCMSData))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaCMSData, &aiCMSData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElClientTSPInfo_ParseCMS_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiCMSData.data, aiCMSData.len, (int8_t)bNoOuterInfo, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiCMSData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElClientTSPInfo_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, GetSignerCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElClientTSPInfo_GetSignerCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, get_Nonce)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElClientTSPInfo_get_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1541056161, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, set_Nonce)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElClientTSPInfo_set_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElClientTSPInfo_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, get_MessageImprint)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElClientTSPInfo_get_MessageImprint(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1659237072, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, get_ResponseNonce)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElClientTSPInfo_get_ResponseNonce(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-439516650, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, get_CMS)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElClientTSPInfo_get_CMS(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1098527977, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, get_IgnoreBadSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElClientTSPInfo_get_IgnoreBadSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, set_IgnoreBadSignature)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElClientTSPInfo_set_IgnoreBadSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, get_LastValidationResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElClientTSPInfo_get_LastValidationResult(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElClientTSPInfo_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, get_HashedData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElClientTSPInfo_get_HashedData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1728484147, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElClientTSPInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElClientTSPInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_ParseCMS, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CMSData, 0, 1)
	ZEND_ARG_INFO(0, NoOuterInfo)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_GetSignerCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_get_Nonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_set_Nonce, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_get_MessageImprint, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_get_ResponseNonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_get_CMS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_get_IgnoreBadSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_set_IgnoreBadSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_get_LastValidationResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo_get_HashedData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElClientTSPInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElClientTSPInfo_methods[] = {
	PHP_ME(TElClientTSPInfo, ParseCMS, arginfo_TElClientTSPInfo_ParseCMS, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, Reset, arginfo_TElClientTSPInfo_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, GetSignerCertificate, arginfo_TElClientTSPInfo_GetSignerCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, get_Nonce, arginfo_TElClientTSPInfo_get_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, set_Nonce, arginfo_TElClientTSPInfo_set_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, get_Certificates, arginfo_TElClientTSPInfo_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, get_MessageImprint, arginfo_TElClientTSPInfo_get_MessageImprint, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, get_ResponseNonce, arginfo_TElClientTSPInfo_get_ResponseNonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, get_CMS, arginfo_TElClientTSPInfo_get_CMS, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, get_IgnoreBadSignature, arginfo_TElClientTSPInfo_get_IgnoreBadSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, set_IgnoreBadSignature, arginfo_TElClientTSPInfo_set_IgnoreBadSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, get_LastValidationResult, arginfo_TElClientTSPInfo_get_LastValidationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, get_HashAlgorithm, arginfo_TElClientTSPInfo_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, get_HashedData, arginfo_TElClientTSPInfo_get_HashedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElClientTSPInfo, __construct, arginfo_TElClientTSPInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElClientTSPInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElClientTSPInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElClientTSPInfo", TElClientTSPInfo_methods);
	if (NULL == TElTSPInfo_ce_ptr)
		Register_TElTSPInfo(TSRMLS_C);
	TElClientTSPInfo_ce_ptr = zend_register_internal_class_ex(&ce, TElTSPInfo_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomTSPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomTSPClient, Timestamp)
{
	int32_t l4FailureInfoRaw = 0;
	SBArrayZValInfo aiHashedData;
	SBArrayZValInfo aiReplyCMS;
	TSBPKIStatusRaw fServerResultRaw = 0;
	uint32_t _err;
	zval *zaHashedData;
	zval *zaReplyCMS;
	zval *zfServerResult;
	zval *zl4FailureInfo;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zaHashedData, &zfServerResult, &zl4FailureInfo, &zaReplyCMS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHashedData)) || (IS_ARRAY == Z_TYPE_P(zaHashedData)) || (IS_NULL == Z_TYPE_P(zaHashedData))) && PZVAL_IS_REF(zfServerResult) && (IS_LONG == Z_TYPE_P(zfServerResult)) && PZVAL_IS_REF(zl4FailureInfo) && (IS_LONG == Z_TYPE_P(zl4FailureInfo)) && PZVAL_IS_REF(zaReplyCMS) && ((IS_STRING == Z_TYPE_P(zaReplyCMS)) || (IS_ARRAY == Z_TYPE_P(zaReplyCMS))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHashedData, &aiHashedData TSRMLS_CC)) RETURN_FALSE;
		SBInitArrayZValInfo(&aiReplyCMS);
		_err = TElCustomTSPClient_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), aiHashedData.data, aiHashedData.len, &fServerResultRaw, &l4FailureInfoRaw, aiReplyCMS.data, &aiReplyCMS.len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaReplyCMS, &aiReplyCMS TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(629492182, 4, aiReplyCMS.data, &aiReplyCMS.len) TSRMLS_CC);
			((char *)aiReplyCMS.data)[aiReplyCMS.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiReplyCMS);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHashedData);
		ZVAL_LONG(zfServerResult, (long)fServerResultRaw);
		ZVAL_LONG(zl4FailureInfo, (long)l4FailureInfoRaw);
		SBSetByteArrayToZVal(&aiReplyCMS, zaReplyCMS);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer, &integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_TSPInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomTSPClient_get_TSPInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_ReqPolicy)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCustomTSPClient_get_ReqPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(259378677, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, set_ReqPolicy)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomTSPClient_set_ReqPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomTSPClient_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomTSPClient_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_IncludeCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomTSPClient_get_IncludeCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, set_IncludeCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomTSPClient_set_IncludeCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_Options)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTSPOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElCustomTSPClient_get_Options(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, set_Options)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCustomTSPClient_set_Options(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBTSPOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_RequestFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTSPRequestFormatRaw fOutResultRaw = 0;
		SBCheckError(TElCustomTSPClient_get_RequestFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, set_RequestFormat)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCustomTSPClient_set_RequestFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBTSPRequestFormatRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomTSPClient_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomTSPClient_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_OnCertificateValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidationEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCustomTSPClient_get_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, set_OnCertificateValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCustomTSPClient_set_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateValidationEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateValidationEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_OnBeforeSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTSPBeforeSignEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCustomTSPClient_get_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, set_OnBeforeSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCustomTSPClient_set_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTSPBeforeSignEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTSPBeforeSignEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, get_OnTSPError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTSPErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCustomTSPClient_get_OnTSPError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, set_OnTSPError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCustomTSPClient_set_OnTSPError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTSPErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTSPErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClient, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomTSPClient_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_Timestamp, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, HashedData, 0, 1)
	ZEND_ARG_INFO(1, ServerResult)
	ZEND_ARG_INFO(1, FailureInfo)
	ZEND_ARG_INFO(1, ReplyCMS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_TSPInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_ReqPolicy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_set_ReqPolicy, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_IncludeCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_set_IncludeCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_Options, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_set_Options, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_RequestFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_set_RequestFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_OnCertificateValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_set_OnCertificateValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_OnBeforeSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_set_OnBeforeSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_get_OnTSPError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient_set_OnTSPError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomTSPClient_methods[] = {
	PHP_ME(TElCustomTSPClient, Timestamp, arginfo_TElCustomTSPClient_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_TSPInfo, arginfo_TElCustomTSPClient_get_TSPInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_ReqPolicy, arginfo_TElCustomTSPClient_get_ReqPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, set_ReqPolicy, arginfo_TElCustomTSPClient_set_ReqPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_HashAlgorithm, arginfo_TElCustomTSPClient_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, set_HashAlgorithm, arginfo_TElCustomTSPClient_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_IncludeCertificates, arginfo_TElCustomTSPClient_get_IncludeCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, set_IncludeCertificates, arginfo_TElCustomTSPClient_set_IncludeCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_Options, arginfo_TElCustomTSPClient_get_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, set_Options, arginfo_TElCustomTSPClient_set_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_RequestFormat, arginfo_TElCustomTSPClient_get_RequestFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, set_RequestFormat, arginfo_TElCustomTSPClient_set_RequestFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_CertStorage, arginfo_TElCustomTSPClient_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, set_CertStorage, arginfo_TElCustomTSPClient_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_OnCertificateValidate, arginfo_TElCustomTSPClient_get_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, set_OnCertificateValidate, arginfo_TElCustomTSPClient_set_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_OnBeforeSign, arginfo_TElCustomTSPClient_get_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, set_OnBeforeSign, arginfo_TElCustomTSPClient_set_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, get_OnTSPError, arginfo_TElCustomTSPClient_get_OnTSPError, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, set_OnTSPError, arginfo_TElCustomTSPClient_set_OnTSPError, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClient, __construct, arginfo_TElCustomTSPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomTSPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomTSPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomTSPClient", TElCustomTSPClient_methods);
	if (NULL == TElTSPClass_ce_ptr)
		Register_TElTSPClass(TSRMLS_C);
	TElCustomTSPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElTSPClass_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFileTSPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElFileTSPClient, Timestamp)
{
	int32_t l4FailureInfoRaw = 0;
	SBArrayZValInfo aiHashedData;
	SBArrayZValInfo aiReplyCMS;
	TSBPKIStatusRaw fServerResultRaw = 0;
	uint32_t _err;
	zval *zaHashedData;
	zval *zaReplyCMS;
	zval *zfServerResult;
	zval *zl4FailureInfo;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zaHashedData, &zfServerResult, &zl4FailureInfo, &zaReplyCMS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHashedData)) || (IS_ARRAY == Z_TYPE_P(zaHashedData)) || (IS_NULL == Z_TYPE_P(zaHashedData))) && PZVAL_IS_REF(zfServerResult) && (IS_LONG == Z_TYPE_P(zfServerResult)) && PZVAL_IS_REF(zl4FailureInfo) && (IS_LONG == Z_TYPE_P(zl4FailureInfo)) && PZVAL_IS_REF(zaReplyCMS) && ((IS_STRING == Z_TYPE_P(zaReplyCMS)) || (IS_ARRAY == Z_TYPE_P(zaReplyCMS))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHashedData, &aiHashedData TSRMLS_CC)) RETURN_FALSE;
		SBInitArrayZValInfo(&aiReplyCMS);
		_err = TElFileTSPClient_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), aiHashedData.data, aiHashedData.len, &fServerResultRaw, &l4FailureInfoRaw, aiReplyCMS.data, &aiReplyCMS.len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaReplyCMS, &aiReplyCMS TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-770732630, 4, aiReplyCMS.data, &aiReplyCMS.len) TSRMLS_CC);
			((char *)aiReplyCMS.data)[aiReplyCMS.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiReplyCMS);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHashedData);
		ZVAL_LONG(zfServerResult, (long)fServerResultRaw);
		ZVAL_LONG(zl4FailureInfo, (long)l4FailureInfoRaw);
		SBSetByteArrayToZVal(&aiReplyCMS, zaReplyCMS);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer, &integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileTSPClient, get_HashOnlyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFileTSPClient_get_HashOnlyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileTSPClient, set_HashOnlyNeeded)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElFileTSPClient_set_HashOnlyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileTSPClient, get_OnTimestampNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTimestampNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFileTSPClient_get_OnTimestampNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileTSPClient, set_OnTimestampNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFileTSPClient_set_OnTimestampNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTimestampNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTimestampNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileTSPClient, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFileTSPClient_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileTSPClient_Timestamp, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, HashedData, 0, 1)
	ZEND_ARG_INFO(1, ServerResult)
	ZEND_ARG_INFO(1, FailureInfo)
	ZEND_ARG_INFO(1, ReplyCMS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileTSPClient_get_HashOnlyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileTSPClient_set_HashOnlyNeeded, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileTSPClient_get_OnTimestampNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileTSPClient_set_OnTimestampNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileTSPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElFileTSPClient_methods[] = {
	PHP_ME(TElFileTSPClient, Timestamp, arginfo_TElFileTSPClient_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTSPClient, get_HashOnlyNeeded, arginfo_TElFileTSPClient_get_HashOnlyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTSPClient, set_HashOnlyNeeded, arginfo_TElFileTSPClient_set_HashOnlyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTSPClient, get_OnTimestampNeeded, arginfo_TElFileTSPClient_get_OnTimestampNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTSPClient, set_OnTimestampNeeded, arginfo_TElFileTSPClient_set_OnTimestampNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTSPClient, __construct, arginfo_TElFileTSPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFileTSPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFileTSPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFileTSPClient", TElFileTSPClient_methods);
	if (NULL == TElCustomTSPClient_ce_ptr)
		Register_TElCustomTSPClient(TSRMLS_C);
	TElFileTSPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomTSPClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBTSPClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBTSPOption", NULL);
	TSBTSPOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBTSPOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBTSPOption_ce_ptr, "tsoIncludeReqPolicy", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBTSPOption_ce_ptr, "tsoIgnoreBadSignature", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBTSPOption_ce_ptr, "tsoIgnoreBadNonce", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBTSPOptions", NULL);
	TSBTSPOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBTSPOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBTSPOptions_ce_ptr, "tsoIncludeReqPolicy", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBTSPOptions_ce_ptr, "tsoIgnoreBadSignature", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBTSPOptions_ce_ptr, "tsoIgnoreBadNonce", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBTSPRequestFormat", NULL);
	TSBTSPRequestFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBTSPRequestFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBTSPRequestFormat_ce_ptr, "tsfRFC3161", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBTSPRequestFormat_ce_ptr, "tsfCMS", 1)
}

void Register_SBTSPClient_Aliases(TSRMLS_D)
{
	if (NULL == TElClientTSPInfo_ce_ptr)
		Register_TElClientTSPInfo(TSRMLS_C);
	zend_register_class_alias("ElClientTSPInfo", TElClientTSPInfo_ce_ptr);
	if (NULL == TElCustomTSPClient_ce_ptr)
		Register_TElCustomTSPClient(TSRMLS_C);
	zend_register_class_alias("ElCustomTSPClient", TElCustomTSPClient_ce_ptr);
	if (NULL == TElFileTSPClient_ce_ptr)
		Register_TElFileTSPClient(TSRMLS_C);
	zend_register_class_alias("ElFileTSPClient", TElFileTSPClient_ce_ptr);
}

