#include "sbwebsocketclient.h"

zend_class_entry *TElWebSocketClient_ce_ptr = NULL;

SB_PHP_METHOD(TElWebSocketClient, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebSocketClient_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketClient, CreateWebSocketKey_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketClient_CreateWebSocketKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-445041530, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketClient, CreateWebSocketKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketClient_CreateWebSocketKey(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-445041530, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketClient, __construct)
{
	zval *oControl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketClient_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oControl, TElSSLClass_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketClient_Create_1(SBGetObjectHandle(oControl TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElSSLClass)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketClient_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketClient_CreateWebSocketKey_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketClient_CreateWebSocketKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketClient___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Control, TElSSLClass, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebSocketClient_methods[] = {
	PHP_ME(TElWebSocketClient, DataAvailable, arginfo_TElWebSocketClient_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketClient, CreateWebSocketKey_Inst, arginfo_TElWebSocketClient_CreateWebSocketKey_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketClient, CreateWebSocketKey, arginfo_TElWebSocketClient_CreateWebSocketKey, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElWebSocketClient, __construct, arginfo_TElWebSocketClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebSocketClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebSocketClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebSocketClient", TElWebSocketClient_methods);
	if (NULL == TElWebSocketBase_ce_ptr)
		Register_TElWebSocketBase(TSRMLS_C);
	TElWebSocketClient_ce_ptr = zend_register_internal_class_ex(&ce, TElWebSocketBase_ce_ptr, NULL TSRMLS_CC);
}

