#include "sbxmldefs.h"

zend_class_entry *TElXMLCanonicalizationMethod_ce_ptr = NULL;

zend_class_entry *TElXMLTextType_ce_ptr = NULL;

zend_class_entry *TElVersionURI_ce_ptr = NULL;

SB_PHP_METHOD(TElVersionURI, IsEqual)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElVersionURI_IsEqual(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVersionURI, get_DefaultVersion)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElVersionURI_get_DefaultVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-274675844, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVersionURI, set_DefaultVersion)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElVersionURI_set_DefaultVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVersionURI, get_LatestVersion)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElVersionURI_get_LatestVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1883508564, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVersionURI, __construct)
{
	char *sAAnchor;
	char *sADefaultVersion;
	char *sALatestVersion;
	int sAAnchor_len;
	int sADefaultVersion_len;
	int sALatestVersion_len;
	zval *oABaseURI;
	zval *oAVersions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sADefaultVersion, &sADefaultVersion_len, &sALatestVersion, &sALatestVersion_len, &oAVersions, TStringList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVersionURI_Create(sADefaultVersion, (int32_t)sADefaultVersion_len, sALatestVersion, (int32_t)sALatestVersion_len, SBGetObjectHandle(oAVersions TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oABaseURI, TElVersionURI_ce_ptr, &sAAnchor, &sAAnchor_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVersionURI_Create_1(SBGetObjectHandle(oABaseURI TSRMLS_CC), sAAnchor, (int32_t)sAAnchor_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, TStringList) or (TElVersionURI, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVersionURI_IsEqual, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVersionURI_get_DefaultVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVersionURI_set_DefaultVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVersionURI_get_LatestVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVersionURI___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, ADefaultVersion_or_ABaseURI, 0, 1)
	ZEND_ARG_INFO(0, ALatestVersion_or_AAnchor)
	ZEND_ARG_OBJ_INFO(0, AVersions, TStringList, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElVersionURI_methods[] = {
	PHP_ME(TElVersionURI, IsEqual, arginfo_TElVersionURI_IsEqual, ZEND_ACC_PUBLIC)
	PHP_ME(TElVersionURI, get_DefaultVersion, arginfo_TElVersionURI_get_DefaultVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElVersionURI, set_DefaultVersion, arginfo_TElVersionURI_set_DefaultVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElVersionURI, get_LatestVersion, arginfo_TElVersionURI_get_LatestVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElVersionURI, __construct, arginfo_TElVersionURI___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElVersionURI(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElVersionURI_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElVersionURI", TElVersionURI_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElVersionURI_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBXMLDefs_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_BASE, SB_XML_ERROR_BASE, SB_XML_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UTILS_BASE, SB_XML_ERROR_UTILS_BASE, SB_XML_ERROR_UTILS_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_TRANSFORM_BASE, SB_XML_ERROR_TRANSFORM_BASE, SB_XML_ERROR_TRANSFORM_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_SECURITY_BASE, SB_XML_ERROR_SECURITY_BASE, SB_XML_ERROR_SECURITY_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_ENCRYPTION_BASE, SB_XML_ERROR_ENCRYPTION_BASE, SB_XML_ERROR_ENCRYPTION_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_XADES_BASE, SB_XML_ERROR_XADES_BASE, SB_XML_ERROR_XADES_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_BASE, SB_SOAP_ERROR_BASE, SB_SOAP_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSS_BASE, SB_SOAP_ERROR_WSS_BASE, SB_SOAP_ERROR_WSS_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_SECURITY_BASE, SB_SOAP_ERROR_SECURITY_BASE, SB_SOAP_ERROR_SECURITY_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_CLIENT_BASE, SB_SOAP_ERROR_CLIENT_BASE, SB_SOAP_ERROR_CLIENT_BASE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INTERNAL_ERROR, SB_XML_ERROR_INTERNAL_ERROR, SB_XML_ERROR_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NOT_IMPLEMENTED, SB_XML_ERROR_NOT_IMPLEMENTED, SB_XML_ERROR_NOT_IMPLEMENTED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INDEX_OUT_OF_BOUNDS, SB_XML_ERROR_INDEX_OUT_OF_BOUNDS, SB_XML_ERROR_INDEX_OUT_OF_BOUNDS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_PARAMATER, SB_XML_ERROR_INVALID_PARAMATER, SB_XML_ERROR_INVALID_PARAMATER);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_DOCUMENT_PARAMETER, SB_XML_ERROR_NO_DOCUMENT_PARAMETER, SB_XML_ERROR_NO_DOCUMENT_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_ELEMENT_PARAMETER, SB_XML_ERROR_NO_ELEMENT_PARAMETER, SB_XML_ERROR_NO_ELEMENT_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_NODE_PARAMETER, SB_XML_ERROR_NO_NODE_PARAMETER, SB_XML_ERROR_NO_NODE_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_NODE_LIST_PARAMETER, SB_XML_ERROR_NO_NODE_LIST_PARAMETER, SB_XML_ERROR_NO_NODE_LIST_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_ELEMENT, SB_XML_ERROR_NO_ELEMENT, SB_XML_ERROR_NO_ELEMENT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_NODE, SB_XML_ERROR_NO_NODE, SB_XML_ERROR_NO_NODE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_NODE, SB_XML_ERROR_INVALID_NODE, SB_XML_ERROR_INVALID_NODE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_ELEMENT, SB_XML_ERROR_INVALID_ELEMENT, SB_XML_ERROR_INVALID_ELEMENT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_ELEMENT_NOT_FOUND, SB_XML_ERROR_ELEMENT_NOT_FOUND, SB_XML_ERROR_ELEMENT_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NODE_NOT_FOUND, SB_XML_ERROR_NODE_NOT_FOUND, SB_XML_ERROR_NODE_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_CHARACTER_AT_POSITION, SB_XML_ERROR_INVALID_CHARACTER_AT_POSITION, SB_XML_ERROR_INVALID_CHARACTER_AT_POSITION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNEXPECTED_END_OF_FILE, SB_XML_ERROR_UNEXPECTED_END_OF_FILE, SB_XML_ERROR_UNEXPECTED_END_OF_FILE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_ENCODING, SB_XML_ERROR_NO_ENCODING, SB_XML_ERROR_NO_ENCODING);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_MALFORMED_SEQUENCE, SB_XML_ERROR_MALFORMED_SEQUENCE, SB_XML_ERROR_MALFORMED_SEQUENCE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_SEQUENCE, SB_XML_ERROR_INVALID_SEQUENCE, SB_XML_ERROR_INVALID_SEQUENCE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_CHAR, SB_XML_ERROR_INVALID_CHAR, SB_XML_ERROR_INVALID_CHAR);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_PARSE_FAILED_AT_POSITION, SB_XML_ERROR_PARSE_FAILED_AT_POSITION, SB_XML_ERROR_PARSE_FAILED_AT_POSITION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_DOCUMENT_ELEMENT_EMPTY_NAME, SB_XML_ERROR_DOCUMENT_ELEMENT_EMPTY_NAME, SB_XML_ERROR_DOCUMENT_ELEMENT_EMPTY_NAME);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_ELEMENT_EMPTY_NAME, SB_XML_ERROR_ELEMENT_EMPTY_NAME, SB_XML_ERROR_ELEMENT_EMPTY_NAME);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NODE_EMPTY_NAME, SB_XML_ERROR_NODE_EMPTY_NAME, SB_XML_ERROR_NODE_EMPTY_NAME);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NODE_DATA_RELOAD_FAILED, SB_XML_ERROR_NODE_DATA_RELOAD_FAILED, SB_XML_ERROR_NODE_DATA_RELOAD_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_RAW_DATA_LOAD_FAILED, SB_XML_ERROR_RAW_DATA_LOAD_FAILED, SB_XML_ERROR_RAW_DATA_LOAD_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NODE_NO_CHILD_NODES, SB_XML_ERROR_NODE_NO_CHILD_NODES, SB_XML_ERROR_NODE_NO_CHILD_NODES);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NODE_WRONG_DOCUMENT, SB_XML_ERROR_NODE_WRONG_DOCUMENT, SB_XML_ERROR_NODE_WRONG_DOCUMENT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NODE_INVALID_NODE_TYPE, SB_XML_ERROR_NODE_INVALID_NODE_TYPE, SB_XML_ERROR_NODE_INVALID_NODE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NODE_HAS_PARENT, SB_XML_ERROR_NODE_HAS_PARENT, SB_XML_ERROR_NODE_HAS_PARENT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NODE_PARENT_EQUAL_SELF, SB_XML_ERROR_NODE_PARENT_EQUAL_SELF, SB_XML_ERROR_NODE_PARENT_EQUAL_SELF);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NODE_INVALID_QUOTE, SB_XML_ERROR_NODE_INVALID_QUOTE, SB_XML_ERROR_NODE_INVALID_QUOTE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_PARAMETER_OFFSET, SB_XML_ERROR_INVALID_PARAMETER_OFFSET, SB_XML_ERROR_INVALID_PARAMETER_OFFSET);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_ENCODING, SB_XML_ERROR_INVALID_ENCODING, SB_XML_ERROR_INVALID_ENCODING);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_DEFAULT_PREFIX_OVERRIDE, SB_XML_ERROR_DEFAULT_PREFIX_OVERRIDE, SB_XML_ERROR_DEFAULT_PREFIX_OVERRIDE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_C14N_METHOD, SB_XML_ERROR_INVALID_C14N_METHOD, SB_XML_ERROR_INVALID_C14N_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_C14N_METHOD, SB_XML_ERROR_NO_C14N_METHOD, SB_XML_ERROR_NO_C14N_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_XPATH_NODE_TYPE, SB_XML_ERROR_INVALID_XPATH_NODE_TYPE, SB_XML_ERROR_INVALID_XPATH_NODE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_XPATH_VARIABLE_VALUE, SB_XML_ERROR_INVALID_XPATH_VARIABLE_VALUE, SB_XML_ERROR_INVALID_XPATH_VARIABLE_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_BASE64_ENCODING_FAILED, SB_XML_ERROR_BASE64_ENCODING_FAILED, SB_XML_ERROR_BASE64_ENCODING_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_BASE64_DECODING_FAILED, SB_XML_ERROR_BASE64_DECODING_FAILED, SB_XML_ERROR_BASE64_DECODING_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_ID_EXTRACT_FAILED, SB_XML_ERROR_ID_EXTRACT_FAILED, SB_XML_ERROR_ID_EXTRACT_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_DATETIME_PARSE_FAILED, SB_XML_ERROR_DATETIME_PARSE_FAILED, SB_XML_ERROR_DATETIME_PARSE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_DATETIME_FORMAT, SB_XML_ERROR_UNSUPPORTED_DATETIME_FORMAT, SB_XML_ERROR_UNSUPPORTED_DATETIME_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_PUBLIC_KEY, SB_XML_ERROR_INVALID_PUBLIC_KEY, SB_XML_ERROR_INVALID_PUBLIC_KEY);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_SIGNING_CERTIFICATE, SB_XML_ERROR_NO_SIGNING_CERTIFICATE, SB_XML_ERROR_NO_SIGNING_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_DIGEST_ALGORITHM, SB_XML_ERROR_UNSUPPORTED_DIGEST_ALGORITHM, SB_XML_ERROR_UNSUPPORTED_DIGEST_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_EC_FIELD_TYPE, SB_XML_ERROR_UNSUPPORTED_EC_FIELD_TYPE, SB_XML_ERROR_UNSUPPORTED_EC_FIELD_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_MASK_GENERATION_FUNCTION, SB_XML_ERROR_UNSUPPORTED_MASK_GENERATION_FUNCTION, SB_XML_ERROR_UNSUPPORTED_MASK_GENERATION_FUNCTION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_EC_PRIME_NUMBER_TYPE, SB_XML_ERROR_UNSUPPORTED_EC_PRIME_NUMBER_TYPE, SB_XML_ERROR_UNSUPPORTED_EC_PRIME_NUMBER_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_KEY_DATA, SB_XML_ERROR_NO_KEY_DATA, SB_XML_ERROR_NO_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_HMAC_KEY_DATA, SB_XML_ERROR_NO_HMAC_KEY_DATA, SB_XML_ERROR_NO_HMAC_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_DSA_KEY_DATA, SB_XML_ERROR_NO_DSA_KEY_DATA, SB_XML_ERROR_NO_DSA_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_RSA_KEY_DATA, SB_XML_ERROR_NO_RSA_KEY_DATA, SB_XML_ERROR_NO_RSA_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_ECDSA_KEY_DATA, SB_XML_ERROR_NO_ECDSA_KEY_DATA, SB_XML_ERROR_NO_ECDSA_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_GOST94_KEY_DATA, SB_XML_ERROR_NO_GOST94_KEY_DATA, SB_XML_ERROR_NO_GOST94_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_GOST2001_KEY_DATA, SB_XML_ERROR_NO_GOST2001_KEY_DATA, SB_XML_ERROR_NO_GOST2001_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_KEY_DATA, SB_XML_ERROR_INVALID_KEY_DATA, SB_XML_ERROR_INVALID_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_HMAC_METHOD, SB_XML_ERROR_UNSUPPORTED_HMAC_METHOD, SB_XML_ERROR_UNSUPPORTED_HMAC_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_SIGNATURE_METHOD, SB_XML_ERROR_UNSUPPORTED_SIGNATURE_METHOD, SB_XML_ERROR_UNSUPPORTED_SIGNATURE_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_SIGNATURE_ALGORITHM, SB_XML_ERROR_UNSUPPORTED_SIGNATURE_ALGORITHM, SB_XML_ERROR_UNSUPPORTED_SIGNATURE_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_BAD_ASYNC_STATE, SB_XML_ERROR_BAD_ASYNC_STATE, SB_XML_ERROR_BAD_ASYNC_STATE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_ASYNC_SIGNATURE, SB_XML_ERROR_NO_ASYNC_SIGNATURE, SB_XML_ERROR_NO_ASYNC_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_ASYNC_MODE_NOT_SUPPORTED, SB_XML_ERROR_ASYNC_MODE_NOT_SUPPORTED, SB_XML_ERROR_ASYNC_MODE_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_TIMESTAMP_FAILED, SB_XML_ERROR_TIMESTAMP_FAILED, SB_XML_ERROR_TIMESTAMP_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_SIGNATURE_NOT_LOADED, SB_XML_ERROR_SIGNATURE_NOT_LOADED, SB_XML_ERROR_SIGNATURE_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_RSA_PSS_PARAMETERS, SB_XML_ERROR_NO_RSA_PSS_PARAMETERS, SB_XML_ERROR_NO_RSA_PSS_PARAMETERS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_TOO_MANY_QUALIFYING_PROPERTIES, SB_XML_ERROR_TOO_MANY_QUALIFYING_PROPERTIES, SB_XML_ERROR_TOO_MANY_QUALIFYING_PROPERTIES);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_TOO_MANY_SIGNATURE_PROPERTIES, SB_XML_ERROR_TOO_MANY_SIGNATURE_PROPERTIES, SB_XML_ERROR_TOO_MANY_SIGNATURE_PROPERTIES);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_SIGNATURE_PROPERTIES, SB_XML_ERROR_NO_SIGNATURE_PROPERTIES, SB_XML_ERROR_NO_SIGNATURE_PROPERTIES);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_AES_KEY_LENGTH, SB_XML_ERROR_INVALID_AES_KEY_LENGTH, SB_XML_ERROR_INVALID_AES_KEY_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_CAMELLIA_KEY_LENGTH, SB_XML_ERROR_INVALID_CAMELLIA_KEY_LENGTH, SB_XML_ERROR_INVALID_CAMELLIA_KEY_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_AES_WRAPPED_KEY_LENGTH, SB_XML_ERROR_INVALID_AES_WRAPPED_KEY_LENGTH, SB_XML_ERROR_INVALID_AES_WRAPPED_KEY_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_EXTERNAL_MODE_FOR_NODE_ENCRYPTION, SB_XML_ERROR_INVALID_EXTERNAL_MODE_FOR_NODE_ENCRYPTION, SB_XML_ERROR_INVALID_EXTERNAL_MODE_FOR_NODE_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_EXTERNAL_MODE_FOR_NODE_LIST_ENCRYPTION, SB_XML_ERROR_INVALID_EXTERNAL_MODE_FOR_NODE_LIST_ENCRYPTION, SB_XML_ERROR_INVALID_EXTERNAL_MODE_FOR_NODE_LIST_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_ELEMENT_MODE_FOR_NODE_LIST_ENCRYPTION, SB_XML_ERROR_INVALID_ELEMENT_MODE_FOR_NODE_LIST_ENCRYPTION, SB_XML_ERROR_INVALID_ELEMENT_MODE_FOR_NODE_LIST_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_ELEMENT_MODE_FOR_BINARY_ENCRYPTION, SB_XML_ERROR_INVALID_ELEMENT_MODE_FOR_BINARY_ENCRYPTION, SB_XML_ERROR_INVALID_ELEMENT_MODE_FOR_BINARY_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_CONTENT_MODE_FOR_BINARY_ENCRYPTION, SB_XML_ERROR_INVALID_CONTENT_MODE_FOR_BINARY_ENCRYPTION, SB_XML_ERROR_INVALID_CONTENT_MODE_FOR_BINARY_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_ENCRYPTED_DATA_NOT_LOADED, SB_XML_ERROR_ENCRYPTED_DATA_NOT_LOADED, SB_XML_ERROR_ENCRYPTED_DATA_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_KEY_ENCRYPTION_KEY_DATA, SB_XML_ERROR_NO_KEY_ENCRYPTION_KEY_DATA, SB_XML_ERROR_NO_KEY_ENCRYPTION_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_KEY_ENCRYPTION_KEY_DATA, SB_XML_ERROR_INVALID_KEY_ENCRYPTION_KEY_DATA, SB_XML_ERROR_INVALID_KEY_ENCRYPTION_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_KEY_WRAP_METHOD, SB_XML_ERROR_INVALID_KEY_WRAP_METHOD, SB_XML_ERROR_INVALID_KEY_WRAP_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_ENCRYPTION_METHOD, SB_XML_ERROR_UNSUPPORTED_ENCRYPTION_METHOD, SB_XML_ERROR_UNSUPPORTED_ENCRYPTION_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_ENCRYPTION_ALGORITHM, SB_XML_ERROR_UNSUPPORTED_ENCRYPTION_ALGORITHM, SB_XML_ERROR_UNSUPPORTED_ENCRYPTION_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_KEY_ENCRYPTION_KEY_METHOD, SB_XML_ERROR_UNSUPPORTED_KEY_ENCRYPTION_KEY_METHOD, SB_XML_ERROR_UNSUPPORTED_KEY_ENCRYPTION_KEY_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_KEY_ENCRYPTION_TYPE, SB_XML_ERROR_UNSUPPORTED_KEY_ENCRYPTION_TYPE, SB_XML_ERROR_UNSUPPORTED_KEY_ENCRYPTION_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_KEY_WRAP_METHOD, SB_XML_ERROR_UNSUPPORTED_KEY_WRAP_METHOD, SB_XML_ERROR_UNSUPPORTED_KEY_WRAP_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_KEY_TRANSPORT_METHOD, SB_XML_ERROR_UNSUPPORTED_KEY_TRANSPORT_METHOD, SB_XML_ERROR_UNSUPPORTED_KEY_TRANSPORT_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_TRIPLE_DES_WRAPPED_KEY_LENGTH, SB_XML_ERROR_INVALID_TRIPLE_DES_WRAPPED_KEY_LENGTH, SB_XML_ERROR_INVALID_TRIPLE_DES_WRAPPED_KEY_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_AES_ENCRYPTED_WRAPPED_KEY_LENGTH, SB_XML_ERROR_INVALID_AES_ENCRYPTED_WRAPPED_KEY_LENGTH, SB_XML_ERROR_INVALID_AES_ENCRYPTED_WRAPPED_KEY_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_ENCRYPTED_WRAPPED_KEY, SB_XML_ERROR_INVALID_ENCRYPTED_WRAPPED_KEY, SB_XML_ERROR_INVALID_ENCRYPTED_WRAPPED_KEY);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_ENCRYPTED_DATA, SB_XML_ERROR_INVALID_ENCRYPTED_DATA, SB_XML_ERROR_INVALID_ENCRYPTED_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_TRIPLE_DES_ENCRYPTED_WRAPPED_KEY_LENGTH, SB_XML_ERROR_INVALID_TRIPLE_DES_ENCRYPTED_WRAPPED_KEY_LENGTH, SB_XML_ERROR_INVALID_TRIPLE_DES_ENCRYPTED_WRAPPED_KEY_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_CANT_ENCRYPT_ATTRIBUTE_NODE, SB_XML_ERROR_CANT_ENCRYPT_ATTRIBUTE_NODE, SB_XML_ERROR_CANT_ENCRYPT_ATTRIBUTE_NODE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_CIPHER_VALUE, SB_XML_ERROR_NO_CIPHER_VALUE, SB_XML_ERROR_NO_CIPHER_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_REFERENCE_NO_CONTEXT, SB_XML_ERROR_REFERENCE_NO_CONTEXT, SB_XML_ERROR_REFERENCE_NO_CONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_TRANSFORM_CHAIN_NO_DATA, SB_XML_ERROR_TRANSFORM_CHAIN_NO_DATA, SB_XML_ERROR_TRANSFORM_CHAIN_NO_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_TRANSFORM, SB_XML_ERROR_UNSUPPORTED_TRANSFORM, SB_XML_ERROR_UNSUPPORTED_TRANSFORM);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_TRANSFORM_ALGORITHM, SB_XML_ERROR_UNSUPPORTED_TRANSFORM_ALGORITHM, SB_XML_ERROR_UNSUPPORTED_TRANSFORM_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_TRANSFORM_ALREADY_REGISTERED, SB_XML_ERROR_TRANSFORM_ALREADY_REGISTERED, SB_XML_ERROR_TRANSFORM_ALREADY_REGISTERED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_TRANSFORM_ORDER, SB_XML_ERROR_INVALID_TRANSFORM_ORDER, SB_XML_ERROR_INVALID_TRANSFORM_ORDER);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_BASE64_TRANSFORM_FAILED, SB_XML_ERROR_BASE64_TRANSFORM_FAILED, SB_XML_ERROR_BASE64_TRANSFORM_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_XPATH_TRANSFORM_NO_CONTEXT, SB_XML_ERROR_XPATH_TRANSFORM_NO_CONTEXT, SB_XML_ERROR_XPATH_TRANSFORM_NO_CONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_XPATH_FILTER2_TRANSFORM_NO_CONTEXT, SB_XML_ERROR_XPATH_FILTER2_TRANSFORM_NO_CONTEXT, SB_XML_ERROR_XPATH_FILTER2_TRANSFORM_NO_CONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_BINARY_DATA_TRANSFORM_FAILED, SB_XML_ERROR_BINARY_DATA_TRANSFORM_FAILED, SB_XML_ERROR_BINARY_DATA_TRANSFORM_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_DECRYPTION_TRANSFORM_FAILED, SB_XML_ERROR_DECRYPTION_TRANSFORM_FAILED, SB_XML_ERROR_DECRYPTION_TRANSFORM_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_BINARY_DECRYPTION_TRANSFORM_FAILED, SB_XML_ERROR_BINARY_DECRYPTION_TRANSFORM_FAILED, SB_XML_ERROR_BINARY_DECRYPTION_TRANSFORM_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_DECRYPTION_TRANSFORM_RESULT, SB_XML_ERROR_INVALID_DECRYPTION_TRANSFORM_RESULT, SB_XML_ERROR_INVALID_DECRYPTION_TRANSFORM_RESULT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_XADES_VERSION, SB_XML_ERROR_INVALID_XADES_VERSION, SB_XML_ERROR_INVALID_XADES_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_XADES_VERSION, SB_XML_ERROR_UNSUPPORTED_XADES_VERSION, SB_XML_ERROR_UNSUPPORTED_XADES_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INVALID_OBJECT_TYPE_PARAMETER, SB_XML_ERROR_INVALID_OBJECT_TYPE_PARAMETER, SB_XML_ERROR_INVALID_OBJECT_TYPE_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_QUALIFIER_TYPE, SB_XML_ERROR_UNSUPPORTED_QUALIFIER_TYPE, SB_XML_ERROR_UNSUPPORTED_QUALIFIER_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_PKI_DATA_ENCODING_METHOD, SB_XML_ERROR_UNSUPPORTED_PKI_DATA_ENCODING_METHOD, SB_XML_ERROR_UNSUPPORTED_PKI_DATA_ENCODING_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_XADES_V111_PROPERTY, SB_XML_ERROR_UNSUPPORTED_XADES_V111_PROPERTY, SB_XML_ERROR_UNSUPPORTED_XADES_V111_PROPERTY);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_XADES_V111_V122_PROPERTY, SB_XML_ERROR_UNSUPPORTED_XADES_V111_V122_PROPERTY, SB_XML_ERROR_UNSUPPORTED_XADES_V111_V122_PROPERTY);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSUPPORTED_XADES_FORM, SB_XML_ERROR_UNSUPPORTED_XADES_FORM, SB_XML_ERROR_UNSUPPORTED_XADES_FORM);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INCLUCE_NO_CONTEXT, SB_XML_ERROR_INCLUCE_NO_CONTEXT, SB_XML_ERROR_INCLUCE_NO_CONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_INCLUDE_INVALID_CONTEXT, SB_XML_ERROR_INCLUDE_INVALID_CONTEXT, SB_XML_ERROR_INCLUDE_INVALID_CONTEXT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_NO_TSP_CLIENT, SB_XML_ERROR_NO_TSP_CLIENT, SB_XML_ERROR_NO_TSP_CLIENT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_SIGNING_CERTIFICATE_NOT_FOUND, SB_XML_ERROR_SIGNING_CERTIFICATE_NOT_FOUND, SB_XML_ERROR_SIGNING_CERTIFICATE_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_QUALIFYING_PROPERTIES_NOT_FOUND, SB_XML_ERROR_QUALIFYING_PROPERTIES_NOT_FOUND, SB_XML_ERROR_QUALIFYING_PROPERTIES_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_VALIDATION_INFORMATION_INCOMPLETE, SB_XML_ERROR_VALIDATION_INFORMATION_INCOMPLETE, SB_XML_ERROR_VALIDATION_INFORMATION_INCOMPLETE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_SIGNER_PROCESSOR_EXPECTED, SB_XML_ERROR_SIGNER_PROCESSOR_EXPECTED, SB_XML_ERROR_SIGNER_PROCESSOR_EXPECTED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_RETRIEVED_CERTIFICATE_NOT_MATCH, SB_XML_ERROR_RETRIEVED_CERTIFICATE_NOT_MATCH, SB_XML_ERROR_RETRIEVED_CERTIFICATE_NOT_MATCH);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_RETRIEVED_CRL_NOT_MATCH, SB_XML_ERROR_RETRIEVED_CRL_NOT_MATCH, SB_XML_ERROR_RETRIEVED_CRL_NOT_MATCH);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_RETRIEVED_OCSP_RESPONSE_NOT_MATCH, SB_XML_ERROR_RETRIEVED_OCSP_RESPONSE_NOT_MATCH, SB_XML_ERROR_RETRIEVED_OCSP_RESPONSE_NOT_MATCH);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSIGNED_SIGNATURE_PROPERTY_ADD_FAILED, SB_XML_ERROR_UNSIGNED_SIGNATURE_PROPERTY_ADD_FAILED, SB_XML_ERROR_UNSIGNED_SIGNATURE_PROPERTY_ADD_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_UNSIGNED_SIGNATURE_PROPERTY_ALREADY_EXISTS, SB_XML_ERROR_UNSIGNED_SIGNATURE_PROPERTY_ALREADY_EXISTS, SB_XML_ERROR_UNSIGNED_SIGNATURE_PROPERTY_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_DOCUMENT_SIGNED_CANT_ADD_ALL_DATA_OBJECTS_TIMESTAMP, SB_XML_ERROR_DOCUMENT_SIGNED_CANT_ADD_ALL_DATA_OBJECTS_TIMESTAMP, SB_XML_ERROR_DOCUMENT_SIGNED_CANT_ADD_ALL_DATA_OBJECTS_TIMESTAMP);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_CANT_ADD_ARCHIVE_TIMESTAMP, SB_XML_ERROR_CANT_ADD_ARCHIVE_TIMESTAMP, SB_XML_ERROR_CANT_ADD_ARCHIVE_TIMESTAMP);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_XML_ERROR_VERIFIER_PROCESSOR_EXPECTED, SB_XML_ERROR_VERIFIER_PROCESSOR_EXPECTED, SB_XML_ERROR_VERIFIER_PROCESSOR_EXPECTED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_INTERNAL_ERROR, SB_SOAP_ERROR_INTERNAL_ERROR, SB_SOAP_ERROR_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_NOT_IMPLEMENTED, SB_SOAP_ERROR_NOT_IMPLEMENTED, SB_SOAP_ERROR_NOT_IMPLEMENTED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_UNSUPPORTED_OPERATION, SB_SOAP_ERROR_UNSUPPORTED_OPERATION, SB_SOAP_ERROR_UNSUPPORTED_OPERATION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_DOCUMENT_ELEMENT_EXISTS, SB_SOAP_ERROR_DOCUMENT_ELEMENT_EXISTS, SB_SOAP_ERROR_DOCUMENT_ELEMENT_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_ENVELOPE_BODY_ELEMENT_EXISTS, SB_SOAP_ERROR_ENVELOPE_BODY_ELEMENT_EXISTS, SB_SOAP_ERROR_ENVELOPE_BODY_ELEMENT_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_ENVELOPE_HEADER_ELEMENT_EXISTS, SB_SOAP_ERROR_ENVELOPE_HEADER_ELEMENT_EXISTS, SB_SOAP_ERROR_ENVELOPE_HEADER_ELEMENT_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_BODY_ELEMENT_NOT_LOADED, SB_SOAP_ERROR_BODY_ELEMENT_NOT_LOADED, SB_SOAP_ERROR_BODY_ELEMENT_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_HEADER_ELEMENT_NOT_LOADED, SB_SOAP_ERROR_HEADER_ELEMENT_NOT_LOADED, SB_SOAP_ERROR_HEADER_ELEMENT_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_HEADER_BLOCK_NOT_LOADED, SB_SOAP_ERROR_HEADER_BLOCK_NOT_LOADED, SB_SOAP_ERROR_HEADER_BLOCK_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_MESSAGE_NOT_LOADED, SB_SOAP_ERROR_MESSAGE_NOT_LOADED, SB_SOAP_ERROR_MESSAGE_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_NO_HEADER_BLOCK, SB_SOAP_ERROR_WSSE_NO_HEADER_BLOCK, SB_SOAP_ERROR_WSSE_NO_HEADER_BLOCK);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_TOKEN_NOT_LOADED, SB_SOAP_ERROR_WSSE_TOKEN_NOT_LOADED, SB_SOAP_ERROR_WSSE_TOKEN_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_ELEMENT_NOT_LOADED, SB_SOAP_ERROR_WSSE_ELEMENT_NOT_LOADED, SB_SOAP_ERROR_WSSE_ELEMENT_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_BINARY_SECURITY_TOKEN_NOT_LOADED, SB_SOAP_ERROR_WSSE_BINARY_SECURITY_TOKEN_NOT_LOADED, SB_SOAP_ERROR_WSSE_BINARY_SECURITY_TOKEN_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_PASSWORD_NOT_LOADED, SB_SOAP_ERROR_WSSE_PASSWORD_NOT_LOADED, SB_SOAP_ERROR_WSSE_PASSWORD_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_NONCE_NOT_LOADED, SB_SOAP_ERROR_WSSE_NONCE_NOT_LOADED, SB_SOAP_ERROR_WSSE_NONCE_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_ADD_TOKEN_FAILED, SB_SOAP_ERROR_WSSE_ADD_TOKEN_FAILED, SB_SOAP_ERROR_WSSE_ADD_TOKEN_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_INVALID_BINARY_SECURITY_TOKEN_VALUE_TYPE, SB_SOAP_ERROR_WSSE_INVALID_BINARY_SECURITY_TOKEN_VALUE_TYPE, SB_SOAP_ERROR_WSSE_INVALID_BINARY_SECURITY_TOKEN_VALUE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_NONCE_ELEMENT_EXISTS, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_NONCE_ELEMENT_EXISTS, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_NONCE_ELEMENT_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_PASSWORD_ELEMENT_EXISTS, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_PASSWORD_ELEMENT_EXISTS, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_PASSWORD_ELEMENT_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_USERNAME_ELEMENT_EXISTS, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_USERNAME_ELEMENT_EXISTS, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_USERNAME_ELEMENT_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSU_DATETIME_NOT_LOADED, SB_SOAP_ERROR_WSU_DATETIME_NOT_LOADED, SB_SOAP_ERROR_WSU_DATETIME_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSU_TIMESTAMP_CREATED_ELEMENT_EXISTS, SB_SOAP_ERROR_WSU_TIMESTAMP_CREATED_ELEMENT_EXISTS, SB_SOAP_ERROR_WSU_TIMESTAMP_CREATED_ELEMENT_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSU_TIMESTAMP_EXPIRES_ELEMENT_EXISTS, SB_SOAP_ERROR_WSU_TIMESTAMP_EXPIRES_ELEMENT_EXISTS, SB_SOAP_ERROR_WSU_TIMESTAMP_EXPIRES_ELEMENT_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_CREATED_ELEMENT_EXISTS, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_CREATED_ELEMENT_EXISTS, SB_SOAP_ERROR_WSSE_USERNAME_TOKEN_CREATED_ELEMENT_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_SECURITY_HANDLER_ALREADY_REGISTERED, SB_SOAP_ERROR_SECURITY_HANDLER_ALREADY_REGISTERED, SB_SOAP_ERROR_SECURITY_HANDLER_ALREADY_REGISTERED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_SIGNATURE_HANDLER_NOT_ATTACHED, SB_SOAP_ERROR_SIGNATURE_HANDLER_NOT_ATTACHED, SB_SOAP_ERROR_SIGNATURE_HANDLER_NOT_ATTACHED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_SIGNATURE_CALCULATED_CANT_SIGN, SB_SOAP_ERROR_SIGNATURE_CALCULATED_CANT_SIGN, SB_SOAP_ERROR_SIGNATURE_CALCULATED_CANT_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_SIGNATURE_NOT_CALCULATED_CANT_VALIDATE, SB_SOAP_ERROR_SIGNATURE_NOT_CALCULATED_CANT_VALIDATE, SB_SOAP_ERROR_SIGNATURE_NOT_CALCULATED_CANT_VALIDATE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_NO_SIGNATURE_CANT_COMPLETE_ASYNC_SIGN, SB_SOAP_ERROR_NO_SIGNATURE_CANT_COMPLETE_ASYNC_SIGN, SB_SOAP_ERROR_NO_SIGNATURE_CANT_COMPLETE_ASYNC_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_TARGET_ELEMENT_HAS_NO_ID, SB_SOAP_ERROR_TARGET_ELEMENT_HAS_NO_ID, SB_SOAP_ERROR_TARGET_ELEMENT_HAS_NO_ID);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_NOTHING_TO_SIGN, SB_SOAP_ERROR_NOTHING_TO_SIGN, SB_SOAP_ERROR_NOTHING_TO_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_NO_CERTIFICATE, SB_SOAP_ERROR_NO_CERTIFICATE, SB_SOAP_ERROR_NO_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_NO_KEY_DATA, SB_SOAP_ERROR_NO_KEY_DATA, SB_SOAP_ERROR_NO_KEY_DATA);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_UNSUPPORTED_CERTIFICATE_PUBLIC_KEY_ALGORITHM, SB_SOAP_ERROR_UNSUPPORTED_CERTIFICATE_PUBLIC_KEY_ALGORITHM, SB_SOAP_ERROR_UNSUPPORTED_CERTIFICATE_PUBLIC_KEY_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_SIGNATURE_ELEMENT_MODIFICATION_FAILED, SB_SOAP_ERROR_SIGNATURE_ELEMENT_MODIFICATION_FAILED, SB_SOAP_ERROR_SIGNATURE_ELEMENT_MODIFICATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_INVALID_PARAMETERS_COMBINATION, SB_SOAP_ERROR_INVALID_PARAMETERS_COMBINATION, SB_SOAP_ERROR_INVALID_PARAMETERS_COMBINATION);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_SIGNATURE_CALCULATED_CANT_CHANGE_SECURITY_HEADER_BLOCK, SB_SOAP_ERROR_SIGNATURE_CALCULATED_CANT_CHANGE_SECURITY_HEADER_BLOCK, SB_SOAP_ERROR_SIGNATURE_CALCULATED_CANT_CHANGE_SECURITY_HEADER_BLOCK);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_UNEXPECTED_HTTP_STATUS_CODE, SB_SOAP_ERROR_UNEXPECTED_HTTP_STATUS_CODE, SB_SOAP_ERROR_UNEXPECTED_HTTP_STATUS_CODE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_NO_HTTP_CLIENT, SB_SOAP_ERROR_NO_HTTP_CLIENT, SB_SOAP_ERROR_NO_HTTP_CLIENT);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_INVALID_PARTS_LIST_PARAMETER, SB_SOAP_ERROR_INVALID_PARTS_LIST_PARAMETER, SB_SOAP_ERROR_INVALID_PARTS_LIST_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_INVALID_BOOLEAN_VALUE, SB_SOAP_ERROR_INVALID_BOOLEAN_VALUE, SB_SOAP_ERROR_INVALID_BOOLEAN_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_INVALID_NUMBER_VALUE, SB_SOAP_ERROR_INVALID_NUMBER_VALUE, SB_SOAP_ERROR_INVALID_NUMBER_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_INVALID_DATETIME_VALUE, SB_SOAP_ERROR_INVALID_DATETIME_VALUE, SB_SOAP_ERROR_INVALID_DATETIME_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_INVALID_BASE64_VALUE, SB_SOAP_ERROR_INVALID_BASE64_VALUE, SB_SOAP_ERROR_INVALID_BASE64_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBXMLDefs, SB_SOAP_ERROR_INVALID_PARAMETER_NAME, SB_SOAP_ERROR_INVALID_PARAMETER_NAME, SB_SOAP_ERROR_INVALID_PARAMETER_NAME);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlNamespace, SB_xmlNamespace, SB_xmlNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSchemaNamespace, SB_xmlSchemaNamespace, SB_xmlSchemaNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSchemaInstanceNamespace, SB_xmlSchemaInstanceNamespace, SB_xmlSchemaInstanceNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionNamespace, SB_xmlEncryptionNamespace, SB_xmlEncryptionNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureNamespace, SB_xmlSignatureNamespace, SB_xmlSignatureNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureNamespaceMore, SB_xmlSignatureNamespaceMore, SB_xmlSignatureNamespaceMore);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureNamespace_v1_1, SB_xmlSignatureNamespace_v1_1, SB_xmlSignatureNamespace_v1_1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureNamespacePSS, SB_xmlSignatureNamespacePSS, SB_xmlSignatureNamespacePSS);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDecryptionNamespace, SB_xmlDecryptionNamespace, SB_xmlDecryptionNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXAdESNamespace_v1_1_1, SB_xmlXAdESNamespace_v1_1_1, SB_xmlXAdESNamespace_v1_1_1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXAdESNamespace_v1_2_2, SB_xmlXAdESNamespace_v1_2_2, SB_xmlXAdESNamespace_v1_2_2);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXAdESNamespace_v1_3_2, SB_xmlXAdESNamespace_v1_3_2, SB_xmlXAdESNamespace_v1_3_2);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXAdESNamespace_v1_4_1, SB_xmlXAdESNamespace_v1_4_1, SB_xmlXAdESNamespace_v1_4_1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlExclCanonicalizationNamespace, SB_xmlExclCanonicalizationNamespace, SB_xmlExclCanonicalizationNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXKMSNamespace, SB_xmlXKMSNamespace, SB_xmlXKMSNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXPathFilter2Namespace, SB_xmlXPathFilter2Namespace, SB_xmlXPathFilter2Namespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXPathFilter2Namespace04, SB_xmlXPathFilter2Namespace04, SB_xmlXPathFilter2Namespace04);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEBICSNamespace, SB_xmlEBICSNamespace, SB_xmlEBICSNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlCPXMLSpecNamespace, SB_xmlCPXMLSpecNamespace, SB_xmlCPXMLSpecNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSOAPEnvelopeNamespace_v1_1, SB_xmlSOAPEnvelopeNamespace_v1_1, SB_xmlSOAPEnvelopeNamespace_v1_1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSOAPSecurityNamespace, SB_xmlSOAPSecurityNamespace, SB_xmlSOAPSecurityNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSENamespace_v1_0, SB_xmlWSSENamespace_v1_0, SB_xmlWSSENamespace_v1_0);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSENamespace_v1_1, SB_xmlWSSENamespace_v1_1, SB_xmlWSSENamespace_v1_1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSUNamespace, SB_xmlWSUNamespace, SB_xmlWSUNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlPrefix, SB_xmlPrefix, SB_xmlPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSchemaInstancePrefix, SB_xmlSchemaInstancePrefix, SB_xmlSchemaInstancePrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionPrefix, SB_xmlEncryptionPrefix, SB_xmlEncryptionPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignaturePrefix, SB_xmlSignaturePrefix, SB_xmlSignaturePrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDSIGPrefix, SB_xmlDSIGPrefix, SB_xmlDSIGPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDSIGPrefix_v1_1, SB_xmlDSIGPrefix_v1_1, SB_xmlDSIGPrefix_v1_1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXAdESPrefix, SB_xmlXAdESPrefix, SB_xmlXAdESPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXAdESPrefix_v1_4_1, SB_xmlXAdESPrefix_v1_4_1, SB_xmlXAdESPrefix_v1_4_1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDecryptionPrefix, SB_xmlDecryptionPrefix, SB_xmlDecryptionPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlExclCanonicalizationPrefix, SB_xmlExclCanonicalizationPrefix, SB_xmlExclCanonicalizationPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXKMSPrefix, SB_xmlXKMSPrefix, SB_xmlXKMSPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlXPathFilter2Prefix, SB_xmlXPathFilter2Prefix, SB_xmlXPathFilter2Prefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlCPXMLSpecPrefix, SB_xmlCPXMLSpecPrefix, SB_xmlCPXMLSpecPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSOAPEnvelopePrefix_v1_1, SB_xmlSOAPEnvelopePrefix_v1_1, SB_xmlSOAPEnvelopePrefix_v1_1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSOAPEnvelopePrefix_v1_2, SB_xmlSOAPEnvelopePrefix_v1_2, SB_xmlSOAPEnvelopePrefix_v1_2);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSOAPSecurityPrefix, SB_xmlSOAPSecurityPrefix, SB_xmlSOAPSecurityPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSEPrefix, SB_xmlWSSEPrefix, SB_xmlWSSEPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSUPrefix, SB_xmlWSUPrefix, SB_xmlWSUPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlECDSAPrefix, SB_xmlECDSAPrefix, SB_xmlECDSAPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlPSSPrefix, SB_xmlPSSPrefix, SB_xmlPSSPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptedDataTypeElement, SB_xmlEncryptedDataTypeElement, SB_xmlEncryptedDataTypeElement);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptedDataTypeContent, SB_xmlEncryptedDataTypeContent, SB_xmlEncryptedDataTypeContent);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlRefTypeSignedProperties_v1_1_1, SB_xmlRefTypeSignedProperties_v1_1_1, SB_xmlRefTypeSignedProperties_v1_1_1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlRefTypeSignedProperties_v1_2_2, SB_xmlRefTypeSignedProperties_v1_2_2, SB_xmlRefTypeSignedProperties_v1_2_2);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlRefTypeSignedProperties, SB_xmlRefTypeSignedProperties, SB_xmlRefTypeSignedProperties);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlRefTypeCountersignedSignature, SB_xmlRefTypeCountersignedSignature, SB_xmlRefTypeCountersignedSignature);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptedKeyType, SB_xmlEncryptedKeyType, SB_xmlEncryptedKeyType);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlMimeTypeXML, SB_xmlMimeTypeXML, SB_xmlMimeTypeXML);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodSHA1, SB_xmlDigestMethodSHA1, SB_xmlDigestMethodSHA1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodMD5, SB_xmlDigestMethodMD5, SB_xmlDigestMethodMD5);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodSHA224, SB_xmlDigestMethodSHA224, SB_xmlDigestMethodSHA224);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodSHA256, SB_xmlDigestMethodSHA256, SB_xmlDigestMethodSHA256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodSHA384, SB_xmlDigestMethodSHA384, SB_xmlDigestMethodSHA384);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodSHA512, SB_xmlDigestMethodSHA512, SB_xmlDigestMethodSHA512);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodRIPEMD160, SB_xmlDigestMethodRIPEMD160, SB_xmlDigestMethodRIPEMD160);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodWhirlpool, SB_xmlDigestMethodWhirlpool, SB_xmlDigestMethodWhirlpool);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodSHA3_224, SB_xmlDigestMethodSHA3_224, SB_xmlDigestMethodSHA3_224);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodSHA3_256, SB_xmlDigestMethodSHA3_256, SB_xmlDigestMethodSHA3_256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodSHA3_384, SB_xmlDigestMethodSHA3_384, SB_xmlDigestMethodSHA3_384);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodSHA3_512, SB_xmlDigestMethodSHA3_512, SB_xmlDigestMethodSHA3_512);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodGOSTR3411_Draft0, SB_xmlDigestMethodGOSTR3411_Draft0, SB_xmlDigestMethodGOSTR3411_Draft0);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodGOSTR3411_Draft1, SB_xmlDigestMethodGOSTR3411_Draft1, SB_xmlDigestMethodGOSTR3411_Draft1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodGOSTR3411_Draft2, SB_xmlDigestMethodGOSTR3411_Draft2, SB_xmlDigestMethodGOSTR3411_Draft2);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlDigestMethodGOSTR3411_URN, SB_xmlDigestMethodGOSTR3411_URN, SB_xmlDigestMethodGOSTR3411_URN);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethod3DES, SB_xmlEncryptionMethod3DES, SB_xmlEncryptionMethod3DES);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodAES128, SB_xmlEncryptionMethodAES128, SB_xmlEncryptionMethodAES128);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodAES192, SB_xmlEncryptionMethodAES192, SB_xmlEncryptionMethodAES192);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodAES256, SB_xmlEncryptionMethodAES256, SB_xmlEncryptionMethodAES256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodDES, SB_xmlEncryptionMethodDES, SB_xmlEncryptionMethodDES);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodCamellia128, SB_xmlEncryptionMethodCamellia128, SB_xmlEncryptionMethodCamellia128);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodCamellia192, SB_xmlEncryptionMethodCamellia192, SB_xmlEncryptionMethodCamellia192);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodCamellia256, SB_xmlEncryptionMethodCamellia256, SB_xmlEncryptionMethodCamellia256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodRC4, SB_xmlEncryptionMethodRC4, SB_xmlEncryptionMethodRC4);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodSEED, SB_xmlEncryptionMethodSEED, SB_xmlEncryptionMethodSEED);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodAES128_GCM, SB_xmlEncryptionMethodAES128_GCM, SB_xmlEncryptionMethodAES128_GCM);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodAES192_GCM, SB_xmlEncryptionMethodAES192_GCM, SB_xmlEncryptionMethodAES192_GCM);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlEncryptionMethodAES256_GCM, SB_xmlEncryptionMethodAES256_GCM, SB_xmlEncryptionMethodAES256_GCM);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyWrapMethod3DES, SB_xmlKeyWrapMethod3DES, SB_xmlKeyWrapMethod3DES);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyWrapMethodAES128, SB_xmlKeyWrapMethodAES128, SB_xmlKeyWrapMethodAES128);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyWrapMethodAES192, SB_xmlKeyWrapMethodAES192, SB_xmlKeyWrapMethodAES192);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyWrapMethodAES256, SB_xmlKeyWrapMethodAES256, SB_xmlKeyWrapMethodAES256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyWrapMethodCamellia128, SB_xmlKeyWrapMethodCamellia128, SB_xmlKeyWrapMethodCamellia128);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyWrapMethodCamellia192, SB_xmlKeyWrapMethodCamellia192, SB_xmlKeyWrapMethodCamellia192);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyWrapMethodCamellia256, SB_xmlKeyWrapMethodCamellia256, SB_xmlKeyWrapMethodCamellia256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyWrapMethodSEED, SB_xmlKeyWrapMethodSEED, SB_xmlKeyWrapMethodSEED);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyTransportMethodRSA15, SB_xmlKeyTransportMethodRSA15, SB_xmlKeyTransportMethodRSA15);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyTransportMethodRSAOAEP, SB_xmlKeyTransportMethodRSAOAEP, SB_xmlKeyTransportMethodRSAOAEP);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlTransformBase64, SB_xmlTransformBase64, SB_xmlTransformBase64);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlTransformEnvelopedSignature, SB_xmlTransformEnvelopedSignature, SB_xmlTransformEnvelopedSignature);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlTransformNull, SB_xmlTransformNull, SB_xmlTransformNull);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlTransformDecryptBinary, SB_xmlTransformDecryptBinary, SB_xmlTransformDecryptBinary);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlTransformDecryptXML, SB_xmlTransformDecryptXML, SB_xmlTransformDecryptXML);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlCanonicalizationMinimal, SB_xmlCanonicalizationMinimal, SB_xmlCanonicalizationMinimal);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmDSASHA1, SB_xmlSignatureAlgorithmDSASHA1, SB_xmlSignatureAlgorithmDSASHA1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmDSASHA256, SB_xmlSignatureAlgorithmDSASHA256, SB_xmlSignatureAlgorithmDSASHA256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSASHA1, SB_xmlSignatureAlgorithmRSASHA1, SB_xmlSignatureAlgorithmRSASHA1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAMD5, SB_xmlSignatureAlgorithmRSAMD5, SB_xmlSignatureAlgorithmRSAMD5);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSASHA224, SB_xmlSignatureAlgorithmRSASHA224, SB_xmlSignatureAlgorithmRSASHA224);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSASHA256, SB_xmlSignatureAlgorithmRSASHA256, SB_xmlSignatureAlgorithmRSASHA256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSASHA384, SB_xmlSignatureAlgorithmRSASHA384, SB_xmlSignatureAlgorithmRSASHA384);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSASHA512, SB_xmlSignatureAlgorithmRSASHA512, SB_xmlSignatureAlgorithmRSASHA512);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSARIPEMD160, SB_xmlSignatureAlgorithmRSARIPEMD160, SB_xmlSignatureAlgorithmRSARIPEMD160);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSARIPEMD160Typo, SB_xmlSignatureAlgorithmRSARIPEMD160Typo, SB_xmlSignatureAlgorithmRSARIPEMD160Typo);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAWhirlpool, SB_xmlSignatureAlgorithmRSAWhirlpool, SB_xmlSignatureAlgorithmRSAWhirlpool);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmECDSASHA1, SB_xmlSignatureAlgorithmECDSASHA1, SB_xmlSignatureAlgorithmECDSASHA1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmECDSASHA224, SB_xmlSignatureAlgorithmECDSASHA224, SB_xmlSignatureAlgorithmECDSASHA224);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmECDSASHA256, SB_xmlSignatureAlgorithmECDSASHA256, SB_xmlSignatureAlgorithmECDSASHA256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmECDSASHA384, SB_xmlSignatureAlgorithmECDSASHA384, SB_xmlSignatureAlgorithmECDSASHA384);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmECDSASHA512, SB_xmlSignatureAlgorithmECDSASHA512, SB_xmlSignatureAlgorithmECDSASHA512);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmECDSARIPEMD160, SB_xmlSignatureAlgorithmECDSARIPEMD160, SB_xmlSignatureAlgorithmECDSARIPEMD160);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmECDSAWhirlpool, SB_xmlSignatureAlgorithmECDSAWhirlpool, SB_xmlSignatureAlgorithmECDSAWhirlpool);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmGOSTR341094_GOSTR3411_Draft0, SB_xmlSignatureAlgorithmGOSTR341094_GOSTR3411_Draft0, SB_xmlSignatureAlgorithmGOSTR341094_GOSTR3411_Draft0);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmGOSTR341094_GOSTR3411_Draft1, SB_xmlSignatureAlgorithmGOSTR341094_GOSTR3411_Draft1, SB_xmlSignatureAlgorithmGOSTR341094_GOSTR3411_Draft1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_Draft0, SB_xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_Draft0, SB_xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_Draft0);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_Draft1, SB_xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_Draft1, SB_xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_Draft1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_Draft2, SB_xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_Draft2, SB_xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_Draft2);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_URN, SB_xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_URN, SB_xmlSignatureAlgorithmGOSTR34102001_GOSTR3411_URN);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAPSS, SB_xmlSignatureAlgorithmRSAPSS, SB_xmlSignatureAlgorithmRSAPSS);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAPSS_MD5_MGF1, SB_xmlSignatureAlgorithmRSAPSS_MD5_MGF1, SB_xmlSignatureAlgorithmRSAPSS_MD5_MGF1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAPSS_SHA1_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA1_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA1_MGF1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAPSS_SHA224_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA224_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA224_MGF1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAPSS_SHA256_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA256_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA256_MGF1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAPSS_SHA384_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA384_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA384_MGF1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAPSS_SHA512_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA512_MGF1, SB_xmlSignatureAlgorithmRSAPSS_SHA512_MGF1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAPSS_RIPEMD160_MGF1, SB_xmlSignatureAlgorithmRSAPSS_RIPEMD160_MGF1, SB_xmlSignatureAlgorithmRSAPSS_RIPEMD160_MGF1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureAlgorithmRSAPSS_Whirlpool_MGF1, SB_xmlSignatureAlgorithmRSAPSS_Whirlpool_MGF1, SB_xmlSignatureAlgorithmRSAPSS_Whirlpool_MGF1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlMaskGenerationFunctionMGF1, SB_xmlMaskGenerationFunctionMGF1, SB_xmlMaskGenerationFunctionMGF1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureHMACSHA1, SB_xmlSignatureHMACSHA1, SB_xmlSignatureHMACSHA1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureHMACMD5, SB_xmlSignatureHMACMD5, SB_xmlSignatureHMACMD5);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureHMACSHA224, SB_xmlSignatureHMACSHA224, SB_xmlSignatureHMACSHA224);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureHMACSHA256, SB_xmlSignatureHMACSHA256, SB_xmlSignatureHMACSHA256);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureHMACSHA384, SB_xmlSignatureHMACSHA384, SB_xmlSignatureHMACSHA384);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureHMACSHA512, SB_xmlSignatureHMACSHA512, SB_xmlSignatureHMACSHA512);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlSignatureHMACRIPEMD160, SB_xmlSignatureHMACRIPEMD160, SB_xmlSignatureHMACRIPEMD160);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoDSA, SB_xmlKeyInfoDSA, SB_xmlKeyInfoDSA);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoRSA, SB_xmlKeyInfoRSA, SB_xmlKeyInfoRSA);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoGOST, SB_xmlKeyInfoGOST, SB_xmlKeyInfoGOST);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoGOST_URN, SB_xmlKeyInfoGOST_URN, SB_xmlKeyInfoGOST_URN);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoX509Data, SB_xmlKeyInfoX509Data, SB_xmlKeyInfoX509Data);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoPGPData, SB_xmlKeyInfoPGPData, SB_xmlKeyInfoPGPData);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoSPKIData, SB_xmlKeyInfoSPKIData, SB_xmlKeyInfoSPKIData);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoMgmtData, SB_xmlKeyInfoMgmtData, SB_xmlKeyInfoMgmtData);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoRawX509Certificate, SB_xmlKeyInfoRawX509Certificate, SB_xmlKeyInfoRawX509Certificate);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoPKCS7signedData, SB_xmlKeyInfoPKCS7signedData, SB_xmlKeyInfoPKCS7signedData);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoRawPKCS7signedData, SB_xmlKeyInfoRawPKCS7signedData, SB_xmlKeyInfoRawPKCS7signedData);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoECKeyValue, SB_xmlKeyInfoECKeyValue, SB_xmlKeyInfoECKeyValue);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlKeyInfoDEREncodedKeyValue, SB_xmlKeyInfoDEREncodedKeyValue, SB_xmlKeyInfoDEREncodedKeyValue);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlReferenceObject, SB_xmlReferenceObject, SB_xmlReferenceObject);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlReferenceManifest, SB_xmlReferenceManifest, SB_xmlReferenceManifest);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlReferenceSignatureProperties, SB_xmlReferenceSignatureProperties, SB_xmlReferenceSignatureProperties);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlReferenceSignatureProperty, SB_xmlReferenceSignatureProperty, SB_xmlReferenceSignatureProperty);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSEncodingBase64Binary, SB_xmlWSSEncodingBase64Binary, SB_xmlWSSEncodingBase64Binary);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSTransformSTR, SB_xmlWSSTransformSTR, SB_xmlWSSTransformSTR);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSBinaryTokenPKCS7, SB_xmlWSSBinaryTokenPKCS7, SB_xmlWSSBinaryTokenPKCS7);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSBinaryTokenX509v3, SB_xmlWSSBinaryTokenX509v3, SB_xmlWSSBinaryTokenX509v3);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSBinaryTokenX509v1, SB_xmlWSSBinaryTokenX509v1, SB_xmlWSSBinaryTokenX509v1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSBinaryTokenX509PKIPathv1, SB_xmlWSSBinaryTokenX509PKIPathv1, SB_xmlWSSBinaryTokenX509PKIPathv1);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, xmlWSSBinaryTokenX509SubjectKeyIdentifier, SB_xmlWSSBinaryTokenX509SubjectKeyIdentifier, SB_xmlWSSBinaryTokenX509SubjectKeyIdentifier);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SXMLNoNodeAvailable, SB_SXMLNoNodeAvailable, SB_SXMLNoNodeAvailable);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SXMLNoDocumentAvailable, SB_SXMLNoDocumentAvailable, SB_SXMLNoDocumentAvailable);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SXMLNoElementAvailable, SB_SXMLNoElementAvailable, SB_SXMLNoElementAvailable);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SXMLNoNodeListAvailable, SB_SXMLNoNodeListAvailable, SB_SXMLNoNodeListAvailable);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SXMLNoKeyDataAvailable, SB_SXMLNoKeyDataAvailable, SB_SXMLNoKeyDataAvailable);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SXMLInvalidNode, SB_SXMLInvalidNode, SB_SXMLInvalidNode);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SXMLInvalidElement, SB_SXMLInvalidElement, SB_SXMLInvalidElement);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SXMLNoInclusiveNamespacesPrefixList, SB_SXMLNoInclusiveNamespacesPrefixList, SB_SXMLNoInclusiveNamespacesPrefixList);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SFXMLElementNotFound, SB_SFXMLElementNotFound, SB_SFXMLElementNotFound);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SFXMLIndexOutOfBounds, SB_SFXMLIndexOutOfBounds, SB_SFXMLIndexOutOfBounds);
	SB_REGISTER_STRING_CONSTANT(SBXMLDefs, SFXMLInvalidElement, SB_SFXMLInvalidElement, SB_SFXMLInvalidElement);
}

void Register_SBXMLDefs_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElXMLCanonicalizationMethod", NULL);
	TElXMLCanonicalizationMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLCanonicalizationMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLCanonicalizationMethod_ce_ptr, "xcmNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLCanonicalizationMethod_ce_ptr, "xcmCanon", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLCanonicalizationMethod_ce_ptr, "xcmCanonComment", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLCanonicalizationMethod_ce_ptr, "xcmExclCanon", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLCanonicalizationMethod_ce_ptr, "xcmExclCanonComment", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLCanonicalizationMethod_ce_ptr, "xcmMinCanon", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLCanonicalizationMethod_ce_ptr, "xcmCanon_v1_1", 6)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLCanonicalizationMethod_ce_ptr, "xcmCanonComment_v1_1", 7)
	
	INIT_CLASS_ENTRY(ce, "TElXMLTextType", NULL);
	TElXMLTextType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLTextType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLTextType_ce_ptr, "ttNormal", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLTextType_ce_ptr, "ttBase64", 1)
}

void Register_SBXMLDefs_Aliases(TSRMLS_D)
{
	if (NULL == TElVersionURI_ce_ptr)
		Register_TElVersionURI(TSRMLS_C);
	zend_register_class_alias("ElVersionURI", TElVersionURI_ce_ptr);
	if (NULL == TElXMLCanonicalizationMethod_ce_ptr)
		Register_SBXMLDefs_Enum_Flags(TSRMLS_C);
	zend_register_class_alias("ElXMLCanonicalizationMethod", TElXMLCanonicalizationMethod_ce_ptr);
	if (NULL == TElXMLTextType_ce_ptr)
		Register_SBXMLDefs_Enum_Flags(TSRMLS_C);
	zend_register_class_alias("ElXMLTextType", TElXMLTextType_ce_ptr);
}

