#include "sbxmlpath.h"

zend_class_entry *TXPathNodeType_ce_ptr = NULL;

zend_class_entry *TElAxisType_ce_ptr = NULL;

zend_class_entry *TElNodeTestType_ce_ptr = NULL;

zend_class_entry *TElEqualityExprType_ce_ptr = NULL;

zend_class_entry *TElRelationalExprType_ce_ptr = NULL;

zend_class_entry *TElAdditiveExprType_ce_ptr = NULL;

zend_class_entry *TElMultiplicativeExprType_ce_ptr = NULL;

void SB_CALLBACK TSBXPathCustomFunctionEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcFunctionName, int32_t szFunctionName, TListHandle * List)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zFunctionName;
	zval * zList;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zFunctionName);
	ZVAL_STRINGL(zFunctionName, pcFunctionName, szFunctionName, 1);
	MAKE_STD_ZVAL(zList);
	SBInitObject(zList, TList_ce_ptr, *List TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zFunctionName;
	params[2] = &zList;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zFunctionName);
	*List = SBGetObjectHandleCE(zList, TList_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zList TSRMLS_CC);
	zval_ptr_dtor(&zList);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElXPath_ce_ptr = NULL;

SB_PHP_METHOD(TElXPath, ProcessQuery)
{
	char *sXPathQuery;
	int sXPathQuery_len;
	zval *oList;
	zval *oNode;
	zval *oNSList;
	zval *oVarMap;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!O!O!", &sXPathQuery, &sXPathQuery_len, &oList, TElXMLNodeSet_ce_ptr, &oNode, TElXMLDOMNode_ce_ptr, &oNSList, TElXMLNamespaceMap_ce_ptr, &oVarMap, TElXMLVarMap_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXPath_ProcessQuery(SBGetObjectHandle(getThis() TSRMLS_CC), sXPathQuery, (int32_t)sXPathQuery_len, SBGetObjectHandle(oList TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), SBGetObjectHandle(oNSList TSRMLS_CC), SBGetObjectHandle(oVarMap TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXMLNodeSet, TElXMLDOMNode, TElXMLNamespaceMap, TElXMLVarMap)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPath, get_OnCustomFunction)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXPathCustomFunctionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXPath_get_OnCustomFunction(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPath, set_OnCustomFunction)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXPath_set_OnCustomFunction(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXPathCustomFunctionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXPathCustomFunctionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPath, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXPath_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPath_ProcessQuery, 0, 0, 5)
	ZEND_ARG_INFO(0, XPathQuery)
	ZEND_ARG_OBJ_INFO(0, List, TElXMLNodeSet, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, NSList, TElXMLNamespaceMap, 1)
	ZEND_ARG_OBJ_INFO(0, VarMap, TElXMLVarMap, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPath_get_OnCustomFunction, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPath_set_OnCustomFunction, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPath___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXPath_methods[] = {
	PHP_ME(TElXPath, ProcessQuery, arginfo_TElXPath_ProcessQuery, ZEND_ACC_PUBLIC)
	PHP_ME(TElXPath, get_OnCustomFunction, arginfo_TElXPath_get_OnCustomFunction, ZEND_ACC_PUBLIC)
	PHP_ME(TElXPath, set_OnCustomFunction, arginfo_TElXPath_set_OnCustomFunction, ZEND_ACC_PUBLIC)
	PHP_ME(TElXPath, __construct, arginfo_TElXPath___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXPath(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXPath_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXPath", TElXPath_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXPath_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElNumber_ce_ptr = NULL;

SB_PHP_METHOD(TElNumber, IsNaN)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElNumber_IsNaN(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElNumber, IsInteger)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElNumber_IsInteger(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElNumber, GetInteger)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElNumber_GetInteger(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElNumber, GetReal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElNumber_GetReal(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElNumber, SetReal)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElNumber_SetReal(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElNumber, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElNumber_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumber_IsNaN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumber_IsInteger, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumber_GetInteger, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumber_GetReal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumber_SetReal, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumber___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElNumber_methods[] = {
	PHP_ME(TElNumber, IsNaN, arginfo_TElNumber_IsNaN, ZEND_ACC_PUBLIC)
	PHP_ME(TElNumber, IsInteger, arginfo_TElNumber_IsInteger, ZEND_ACC_PUBLIC)
	PHP_ME(TElNumber, GetInteger, arginfo_TElNumber_GetInteger, ZEND_ACC_PUBLIC)
	PHP_ME(TElNumber, GetReal, arginfo_TElNumber_GetReal, ZEND_ACC_PUBLIC)
	PHP_ME(TElNumber, SetReal, arginfo_TElNumber_SetReal, ZEND_ACC_PUBLIC)
	PHP_ME(TElNumber, __construct, arginfo_TElNumber___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElNumber(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElNumber_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElNumber", TElNumber_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElNumber_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoolean_ce_ptr = NULL;

SB_PHP_METHOD(TElBoolean, IsNaN)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoolean_IsNaN(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoolean, GetValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoolean_GetValue(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoolean, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoolean_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoolean_IsNaN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoolean_GetValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoolean___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoolean_methods[] = {
	PHP_ME(TElBoolean, IsNaN, arginfo_TElBoolean_IsNaN, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoolean, GetValue, arginfo_TElBoolean_GetValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoolean, __construct, arginfo_TElBoolean___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoolean(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoolean_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoolean", TElBoolean_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoolean_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElString_ce_ptr = NULL;

SB_PHP_METHOD(TElString, IsNaN)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElString_IsNaN(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElString, GetValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElString_GetValue(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-198811903, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElString, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElString_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElString_IsNaN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElString_GetValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElString___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElString_methods[] = {
	PHP_ME(TElString, IsNaN, arginfo_TElString_IsNaN, ZEND_ACC_PUBLIC)
	PHP_ME(TElString, GetValue, arginfo_TElString_GetValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElString, __construct, arginfo_TElString___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElString(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElString_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElString", TElString_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElString_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLVarMap_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLVarMap, Add)
{
	char *sVarName;
	int sVarName_len;
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sVarName, &sVarName_len, &oValue, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLVarMap_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sVarName, (int32_t)sVarName_len, SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLVarMap, AddNodeList)
{
	char *sVarName;
	int sVarName_len;
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sVarName, &sVarName_len, &oValue, TElXMLNodeSet_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLVarMap_AddNodeList(SBGetObjectHandle(getThis() TSRMLS_CC), sVarName, (int32_t)sVarName_len, SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXMLNodeSet)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLVarMap, AddBoolean)
{
	char *sVarName;
	int sVarName_len;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sVarName, &sVarName_len, &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLVarMap_AddBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), sVarName, (int32_t)sVarName_len, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLVarMap, AddNumber)
{
	char *sVarName;
	double dValue;
	int sVarName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sd", &sVarName, &sVarName_len, &dValue) == SUCCESS)
	{
		SBCheckError(TElXMLVarMap_AddNumber(SBGetObjectHandle(getThis() TSRMLS_CC), sVarName, (int32_t)sVarName_len, (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLVarMap, AddString)
{
	char *sValue;
	char *sVarName;
	int sValue_len;
	int sVarName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sVarName, &sVarName_len, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLVarMap_AddString(SBGetObjectHandle(getThis() TSRMLS_CC), sVarName, (int32_t)sVarName_len, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLVarMap, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLVarMap_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLVarMap, Delete)
{
	char *sVarName;
	int sVarName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sVarName, &sVarName_len) == SUCCESS)
	{
		SBCheckError(TElXMLVarMap_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), sVarName, (int32_t)sVarName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLVarMap, GetValue)
{
	char *sVarName;
	int sVarName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sVarName, &sVarName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLVarMap_GetValue(SBGetObjectHandle(getThis() TSRMLS_CC), sVarName, (int32_t)sVarName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLVarMap, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLVarMap_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLVarMap_Add, 0, 0, 2)
	ZEND_ARG_INFO(0, VarName)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLVarMap_AddNodeList, 0, 0, 2)
	ZEND_ARG_INFO(0, VarName)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLNodeSet, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLVarMap_AddBoolean, 0, 0, 2)
	ZEND_ARG_INFO(0, VarName)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLVarMap_AddNumber, 0, 0, 2)
	ZEND_ARG_INFO(0, VarName)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLVarMap_AddString, 0, 0, 2)
	ZEND_ARG_INFO(0, VarName)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLVarMap_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLVarMap_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, VarName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLVarMap_GetValue, 0, 0, 1)
	ZEND_ARG_INFO(0, VarName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLVarMap___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLVarMap_methods[] = {
	PHP_ME(TElXMLVarMap, Add, arginfo_TElXMLVarMap_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLVarMap, AddNodeList, arginfo_TElXMLVarMap_AddNodeList, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLVarMap, AddBoolean, arginfo_TElXMLVarMap_AddBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLVarMap, AddNumber, arginfo_TElXMLVarMap_AddNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLVarMap, AddString, arginfo_TElXMLVarMap_AddString, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLVarMap, Clear, arginfo_TElXMLVarMap_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLVarMap, Delete, arginfo_TElXMLVarMap_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLVarMap, GetValue, arginfo_TElXMLVarMap_GetValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLVarMap, __construct, arginfo_TElXMLVarMap___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLVarMap(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLVarMap_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLVarMap", TElXMLVarMap_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLVarMap_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXPathNode_ce_ptr = NULL;

SB_PHP_METHOD(TElXPathNode, DestroyNode_Inst)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXPathNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXPathNode_DestroyNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPathNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPathNode, DestroyNode)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXPathNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXPathNode_DestroyNode(SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPathNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPathNode, GetResultList)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXPathNode_GetResultList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPathNode, GetResultNumber)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXPathNode_GetResultNumber(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElNumber_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPathNode, GetResultBoolean)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXPathNode_GetResultBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoolean_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPathNode, GetResultString)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXPathNode_GetResultString(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElString_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPathNode, GetResult)
{
	int32_t l4iTypeRaw;
	TElClassHandle hoBoolean;
	TElClassHandle hoList;
	TElClassHandle hoNumber;
	TElClassHandle hosString;
	zval *oBoolean;
	zval *oContext;
	zval *oInList;
	zval *oList;
	zval *oNumber;
	zval *osString;
	zval *zl4iType;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zOOOO", &oContext, TElXMLDOMNode_ce_ptr, &oInList, TList_ce_ptr, &zl4iType, &oList, TList_ce_ptr, &oBoolean, TElBoolean_ce_ptr, &oNumber, TElNumber_ce_ptr, &osString, TElString_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zl4iType) && (IS_LONG == Z_TYPE_P(zl4iType)) && PZVAL_IS_REF(oList) && (IS_OBJECT == Z_TYPE_P(oList)) && PZVAL_IS_REF(oBoolean) && (IS_OBJECT == Z_TYPE_P(oBoolean)) && PZVAL_IS_REF(oNumber) && (IS_OBJECT == Z_TYPE_P(oNumber)) && PZVAL_IS_REF(osString) && (IS_OBJECT == Z_TYPE_P(osString)))
	{
		l4iTypeRaw = (int32_t)Z_LVAL_P(zl4iType);
		hoList = SBGetObjectHandle(oList TSRMLS_CC);
		hoBoolean = SBGetObjectHandle(oBoolean TSRMLS_CC);
		hoNumber = SBGetObjectHandle(oNumber TSRMLS_CC);
		hosString = SBGetObjectHandle(osString TSRMLS_CC);
		SBCheckError(TElXPathNode_GetResult(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oInList TSRMLS_CC), &l4iTypeRaw, &hoList, &hoBoolean, &hoNumber, &hosString) TSRMLS_CC);
		ZVAL_LONG(zl4iType, (long)l4iTypeRaw);
		SBUpdateObjectHandle(oList, hoList TSRMLS_CC);
		SBUpdateObjectHandle(oBoolean, hoBoolean TSRMLS_CC);
		SBUpdateObjectHandle(oNumber, hoNumber TSRMLS_CC);
		SBUpdateObjectHandle(osString, hosString TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList, &integer, &TList, &TElBoolean, &TElNumber, &TElString)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXPathNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXPathNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPathNode_DestroyNode_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXPathNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPathNode_DestroyNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXPathNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPathNode_GetResultList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPathNode_GetResultNumber, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPathNode_GetResultBoolean, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPathNode_GetResultString, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPathNode_GetResult, 0, 0, 7)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, InList, TList, 1)
	ZEND_ARG_INFO(1, iType)
	ZEND_ARG_OBJ_INFO(1, List, TList, 0)
	ZEND_ARG_OBJ_INFO(1, Boolean, TElBoolean, 0)
	ZEND_ARG_OBJ_INFO(1, Number, TElNumber, 0)
	ZEND_ARG_OBJ_INFO(1, sString, TElString, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXPathNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXPathNode_methods[] = {
	PHP_ME(TElXPathNode, DestroyNode_Inst, arginfo_TElXPathNode_DestroyNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXPathNode, DestroyNode, arginfo_TElXPathNode_DestroyNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXPathNode, GetResultList, arginfo_TElXPathNode_GetResultList, ZEND_ACC_PUBLIC)
	PHP_ME(TElXPathNode, GetResultNumber, arginfo_TElXPathNode_GetResultNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElXPathNode, GetResultBoolean, arginfo_TElXPathNode_GetResultBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElXPathNode, GetResultString, arginfo_TElXPathNode_GetResultString, ZEND_ACC_PUBLIC)
	PHP_ME(TElXPathNode, GetResult, arginfo_TElXPathNode_GetResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElXPathNode, __construct, arginfo_TElXPathNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXPathNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXPathNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXPathNode", TElXPathNode_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXPathNode_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElUnionExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElUnionExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUnionExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnionExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUnionExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnionExprNode, GetResList)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUnionExprNode_GetResList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnionExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUnionExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnionExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnionExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnionExprNode_GetResList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnionExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElUnionExprNode_methods[] = {
	PHP_ME(TElUnionExprNode, CreateNode_Inst, arginfo_TElUnionExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElUnionExprNode, CreateNode, arginfo_TElUnionExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElUnionExprNode, GetResList, arginfo_TElUnionExprNode_GetResList, ZEND_ACC_PUBLIC)
	PHP_ME(TElUnionExprNode, __construct, arginfo_TElUnionExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElUnionExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElUnionExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElUnionExprNode", TElUnionExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElUnionExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPathExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElPathExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPathExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPathExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPathExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPathExprNode, GetResList)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPathExprNode_GetResList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPathExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPathExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPathExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPathExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPathExprNode_GetResList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPathExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPathExprNode_methods[] = {
	PHP_ME(TElPathExprNode, CreateNode_Inst, arginfo_TElPathExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPathExprNode, CreateNode, arginfo_TElPathExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPathExprNode, GetResList, arginfo_TElPathExprNode_GetResList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPathExprNode, __construct, arginfo_TElPathExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPathExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPathExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPathExprNode", TElPathExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElPathExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLocationPathNode_ce_ptr = NULL;

SB_PHP_METHOD(TElLocationPathNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLocationPathNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLocationPathNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLocationPathNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLocationPathNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLocationPathNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLocationPathNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLocationPathNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLocationPathNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElLocationPathNode_methods[] = {
	PHP_ME(TElLocationPathNode, CreateNode_Inst, arginfo_TElLocationPathNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElLocationPathNode, CreateNode, arginfo_TElLocationPathNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElLocationPathNode, __construct, arginfo_TElLocationPathNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLocationPathNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLocationPathNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLocationPathNode", TElLocationPathNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElLocationPathNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAbsoluteLocationPathNode_ce_ptr = NULL;

SB_PHP_METHOD(TElAbsoluteLocationPathNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAbsoluteLocationPathNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAbsoluteLocationPathNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAbsoluteLocationPathNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAbsoluteLocationPathNode, GetResList)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAbsoluteLocationPathNode_GetResList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAbsoluteLocationPathNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAbsoluteLocationPathNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAbsoluteLocationPathNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAbsoluteLocationPathNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAbsoluteLocationPathNode_GetResList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAbsoluteLocationPathNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAbsoluteLocationPathNode_methods[] = {
	PHP_ME(TElAbsoluteLocationPathNode, CreateNode_Inst, arginfo_TElAbsoluteLocationPathNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAbsoluteLocationPathNode, CreateNode, arginfo_TElAbsoluteLocationPathNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAbsoluteLocationPathNode, GetResList, arginfo_TElAbsoluteLocationPathNode_GetResList, ZEND_ACC_PUBLIC)
	PHP_ME(TElAbsoluteLocationPathNode, __construct, arginfo_TElAbsoluteLocationPathNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAbsoluteLocationPathNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAbsoluteLocationPathNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAbsoluteLocationPathNode", TElAbsoluteLocationPathNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElAbsoluteLocationPathNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRelativeLocationPathNode_ce_ptr = NULL;

SB_PHP_METHOD(TElRelativeLocationPathNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRelativeLocationPathNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeLocationPathNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRelativeLocationPathNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeLocationPathNode, GetResList)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRelativeLocationPathNode_GetResList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeLocationPathNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRelativeLocationPathNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeLocationPathNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeLocationPathNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeLocationPathNode_GetResList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeLocationPathNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElRelativeLocationPathNode_methods[] = {
	PHP_ME(TElRelativeLocationPathNode, CreateNode_Inst, arginfo_TElRelativeLocationPathNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeLocationPathNode, CreateNode, arginfo_TElRelativeLocationPathNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRelativeLocationPathNode, GetResList, arginfo_TElRelativeLocationPathNode_GetResList, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeLocationPathNode, __construct, arginfo_TElRelativeLocationPathNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRelativeLocationPathNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRelativeLocationPathNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRelativeLocationPathNode", TElRelativeLocationPathNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElRelativeLocationPathNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElStepNode_ce_ptr = NULL;

SB_PHP_METHOD(TElStepNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElStepNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStepNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElStepNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStepNode, GetResList)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElStepNode_GetResList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStepNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElStepNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStepNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStepNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStepNode_GetResList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStepNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElStepNode_methods[] = {
	PHP_ME(TElStepNode, CreateNode_Inst, arginfo_TElStepNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElStepNode, CreateNode, arginfo_TElStepNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElStepNode, GetResList, arginfo_TElStepNode_GetResList, ZEND_ACC_PUBLIC)
	PHP_ME(TElStepNode, __construct, arginfo_TElStepNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElStepNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElStepNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElStepNode", TElStepNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElStepNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPredicateNode_ce_ptr = NULL;

SB_PHP_METHOD(TElPredicateNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPredicateNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPredicateNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPredicateNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPredicateNode, GetResList)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPredicateNode_GetResList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPredicateNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPredicateNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPredicateNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPredicateNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPredicateNode_GetResList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPredicateNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPredicateNode_methods[] = {
	PHP_ME(TElPredicateNode, CreateNode_Inst, arginfo_TElPredicateNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPredicateNode, CreateNode, arginfo_TElPredicateNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPredicateNode, GetResList, arginfo_TElPredicateNode_GetResList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPredicateNode, __construct, arginfo_TElPredicateNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPredicateNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPredicateNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPredicateNode", TElPredicateNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElPredicateNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOrExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElOrExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOrExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOrExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOrExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOrExprNode, GetResBoolean)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOrExprNode_GetResBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoolean_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOrExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOrExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOrExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOrExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOrExprNode_GetResBoolean, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOrExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOrExprNode_methods[] = {
	PHP_ME(TElOrExprNode, CreateNode_Inst, arginfo_TElOrExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOrExprNode, CreateNode, arginfo_TElOrExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOrExprNode, GetResBoolean, arginfo_TElOrExprNode_GetResBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElOrExprNode, __construct, arginfo_TElOrExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOrExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOrExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOrExprNode", TElOrExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElOrExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAndExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElAndExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAndExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAndExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAndExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAndExprNode, GetResBoolean)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAndExprNode_GetResBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoolean_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAndExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAndExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAndExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAndExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAndExprNode_GetResBoolean, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAndExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAndExprNode_methods[] = {
	PHP_ME(TElAndExprNode, CreateNode_Inst, arginfo_TElAndExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAndExprNode, CreateNode, arginfo_TElAndExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAndExprNode, GetResBoolean, arginfo_TElAndExprNode_GetResBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElAndExprNode, __construct, arginfo_TElAndExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAndExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAndExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAndExprNode", TElAndExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElAndExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElEqualityExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElEqualityExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElEqualityExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElEqualityExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElEqualityExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElEqualityExprNode, GetResBoolean)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElEqualityExprNode_GetResBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoolean_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElEqualityExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElEqualityExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElEqualityExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElEqualityExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElEqualityExprNode_GetResBoolean, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElEqualityExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElEqualityExprNode_methods[] = {
	PHP_ME(TElEqualityExprNode, CreateNode_Inst, arginfo_TElEqualityExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElEqualityExprNode, CreateNode, arginfo_TElEqualityExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElEqualityExprNode, GetResBoolean, arginfo_TElEqualityExprNode_GetResBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElEqualityExprNode, __construct, arginfo_TElEqualityExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElEqualityExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElEqualityExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElEqualityExprNode", TElEqualityExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElEqualityExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRelationalExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElRelationalExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRelationalExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelationalExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRelationalExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelationalExprNode, GetResBoolean)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRelationalExprNode_GetResBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoolean_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelationalExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRelationalExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelationalExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelationalExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelationalExprNode_GetResBoolean, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelationalExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElRelationalExprNode_methods[] = {
	PHP_ME(TElRelationalExprNode, CreateNode_Inst, arginfo_TElRelationalExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelationalExprNode, CreateNode, arginfo_TElRelationalExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRelationalExprNode, GetResBoolean, arginfo_TElRelationalExprNode_GetResBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelationalExprNode, __construct, arginfo_TElRelationalExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRelationalExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRelationalExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRelationalExprNode", TElRelationalExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElRelationalExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAdditiveExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElAdditiveExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAdditiveExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAdditiveExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAdditiveExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAdditiveExprNode, GetResNumber)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAdditiveExprNode_GetResNumber(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElNumber_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAdditiveExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAdditiveExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAdditiveExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAdditiveExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAdditiveExprNode_GetResNumber, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAdditiveExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAdditiveExprNode_methods[] = {
	PHP_ME(TElAdditiveExprNode, CreateNode_Inst, arginfo_TElAdditiveExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAdditiveExprNode, CreateNode, arginfo_TElAdditiveExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAdditiveExprNode, GetResNumber, arginfo_TElAdditiveExprNode_GetResNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElAdditiveExprNode, __construct, arginfo_TElAdditiveExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAdditiveExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAdditiveExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAdditiveExprNode", TElAdditiveExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElAdditiveExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElMultiplicativeExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElMultiplicativeExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMultiplicativeExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMultiplicativeExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMultiplicativeExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMultiplicativeExprNode, GetResNumber)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMultiplicativeExprNode_GetResNumber(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElNumber_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMultiplicativeExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMultiplicativeExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMultiplicativeExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMultiplicativeExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMultiplicativeExprNode_GetResNumber, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMultiplicativeExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElMultiplicativeExprNode_methods[] = {
	PHP_ME(TElMultiplicativeExprNode, CreateNode_Inst, arginfo_TElMultiplicativeExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElMultiplicativeExprNode, CreateNode, arginfo_TElMultiplicativeExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElMultiplicativeExprNode, GetResNumber, arginfo_TElMultiplicativeExprNode_GetResNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElMultiplicativeExprNode, __construct, arginfo_TElMultiplicativeExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElMultiplicativeExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElMultiplicativeExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElMultiplicativeExprNode", TElMultiplicativeExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElMultiplicativeExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElUnaryExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElUnaryExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUnaryExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnaryExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUnaryExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnaryExprNode, GetResNumber)
{
	zval *oContext;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContext, TElXMLDOMNode_ce_ptr, &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUnaryExprNode_GetResNumber(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElNumber_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnaryExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUnaryExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnaryExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnaryExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnaryExprNode_GetResNumber, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnaryExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElUnaryExprNode_methods[] = {
	PHP_ME(TElUnaryExprNode, CreateNode_Inst, arginfo_TElUnaryExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElUnaryExprNode, CreateNode, arginfo_TElUnaryExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElUnaryExprNode, GetResNumber, arginfo_TElUnaryExprNode_GetResNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElUnaryExprNode, __construct, arginfo_TElUnaryExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElUnaryExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElUnaryExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElUnaryExprNode", TElUnaryExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElUnaryExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFilterExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElFilterExprNode, CreateNode_Inst)
{
	char *ssQuery;
	char *ssQueryTail;
	int ssQuery_len;
	int32_t ssQueryTail_len;
	uint32_t _err;
	zval *oXPath;
	zval *zssQueryTail;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szO!", &ssQuery, &ssQuery_len, &zssQueryTail, &oXPath, TElXPath_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zssQueryTail) && (IS_STRING == Z_TYPE_P(zssQueryTail)))
	{
		TElClassHandle hoOutResult = NULL;
		ssQueryTail = Z_STRVAL_P(zssQueryTail);
		ssQueryTail_len = (int32_t)Z_STRLEN_P(zssQueryTail);
		_err = TElFilterExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, ssQueryTail, &ssQueryTail_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			ssQueryTail = emalloc(ssQueryTail_len + 1);
			SBCheckError(SBGetLastReturnStringA(772249392, 2, ssQueryTail, &ssQueryTail_len) TSRMLS_CC);
			zval_dtor(zssQueryTail);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ssQueryTail[ssQueryTail_len] = 0;
		ZVAL_STRINGL(zssQueryTail, ssQueryTail, ssQueryTail_len, 0);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFilterExprNode, CreateNode)
{
	char *ssQuery;
	char *ssQueryTail;
	int ssQuery_len;
	int32_t ssQueryTail_len;
	uint32_t _err;
	zval *oXPath;
	zval *zssQueryTail;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szO!", &ssQuery, &ssQuery_len, &zssQueryTail, &oXPath, TElXPath_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zssQueryTail) && (IS_STRING == Z_TYPE_P(zssQueryTail)))
	{
		TElClassHandle hoOutResult = NULL;
		ssQueryTail = Z_STRVAL_P(zssQueryTail);
		ssQueryTail_len = (int32_t)Z_STRLEN_P(zssQueryTail);
		_err = TElFilterExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, ssQueryTail, &ssQueryTail_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			ssQueryTail = emalloc(ssQueryTail_len + 1);
			SBCheckError(SBGetLastReturnStringA(772249392, 1, ssQueryTail, &ssQueryTail_len) TSRMLS_CC);
			zval_dtor(zssQueryTail);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ssQueryTail[ssQueryTail_len] = 0;
		ZVAL_STRINGL(zssQueryTail, ssQueryTail, ssQueryTail_len, 0);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFilterExprNode, GetResList)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFilterExprNode_GetResList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFilterExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFilterExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFilterExprNode_CreateNode_Inst, 0, 0, 3)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_INFO(1, sQueryTail)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFilterExprNode_CreateNode, 0, 0, 3)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_INFO(1, sQueryTail)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFilterExprNode_GetResList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFilterExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElFilterExprNode_methods[] = {
	PHP_ME(TElFilterExprNode, CreateNode_Inst, arginfo_TElFilterExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElFilterExprNode, CreateNode, arginfo_TElFilterExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElFilterExprNode, GetResList, arginfo_TElFilterExprNode_GetResList, ZEND_ACC_PUBLIC)
	PHP_ME(TElFilterExprNode, __construct, arginfo_TElFilterExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFilterExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFilterExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFilterExprNode", TElFilterExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElFilterExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPrimaryExprNode_ce_ptr = NULL;

SB_PHP_METHOD(TElPrimaryExprNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPrimaryExprNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPrimaryExprNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPrimaryExprNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPrimaryExprNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPrimaryExprNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPrimaryExprNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPrimaryExprNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPrimaryExprNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPrimaryExprNode_methods[] = {
	PHP_ME(TElPrimaryExprNode, CreateNode_Inst, arginfo_TElPrimaryExprNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPrimaryExprNode, CreateNode, arginfo_TElPrimaryExprNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPrimaryExprNode, __construct, arginfo_TElPrimaryExprNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPrimaryExprNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPrimaryExprNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPrimaryExprNode", TElPrimaryExprNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElPrimaryExprNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElVariableReferenceNode_ce_ptr = NULL;

SB_PHP_METHOD(TElVariableReferenceNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVariableReferenceNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVariableReferenceNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVariableReferenceNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVariableReferenceNode, GetResultLocal)
{
	int32_t l4iTypeRaw;
	TElClassHandle hobBoolean;
	TElClassHandle hoList;
	TElClassHandle honNumber;
	TElClassHandle hosString;
	zval *obBoolean;
	zval *oContext;
	zval *oInList;
	zval *oList;
	zval *onNumber;
	zval *osString;
	zval *zl4iType;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zOOOO", &oContext, TElXMLDOMNode_ce_ptr, &oInList, TList_ce_ptr, &zl4iType, &oList, TList_ce_ptr, &obBoolean, TElBoolean_ce_ptr, &onNumber, TElNumber_ce_ptr, &osString, TElString_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zl4iType) && (IS_LONG == Z_TYPE_P(zl4iType)) && PZVAL_IS_REF(oList) && (IS_OBJECT == Z_TYPE_P(oList)) && PZVAL_IS_REF(obBoolean) && (IS_OBJECT == Z_TYPE_P(obBoolean)) && PZVAL_IS_REF(onNumber) && (IS_OBJECT == Z_TYPE_P(onNumber)) && PZVAL_IS_REF(osString) && (IS_OBJECT == Z_TYPE_P(osString)))
	{
		l4iTypeRaw = (int32_t)Z_LVAL_P(zl4iType);
		hoList = SBGetObjectHandle(oList TSRMLS_CC);
		hobBoolean = SBGetObjectHandle(obBoolean TSRMLS_CC);
		honNumber = SBGetObjectHandle(onNumber TSRMLS_CC);
		hosString = SBGetObjectHandle(osString TSRMLS_CC);
		SBCheckError(TElVariableReferenceNode_GetResultLocal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oInList TSRMLS_CC), &l4iTypeRaw, &hoList, &hobBoolean, &honNumber, &hosString) TSRMLS_CC);
		ZVAL_LONG(zl4iType, (long)l4iTypeRaw);
		SBUpdateObjectHandle(oList, hoList TSRMLS_CC);
		SBUpdateObjectHandle(obBoolean, hobBoolean TSRMLS_CC);
		SBUpdateObjectHandle(onNumber, honNumber TSRMLS_CC);
		SBUpdateObjectHandle(osString, hosString TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList, &integer, &TList, &TElBoolean, &TElNumber, &TElString)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElVariableReferenceNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElVariableReferenceNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVariableReferenceNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVariableReferenceNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVariableReferenceNode_GetResultLocal, 0, 0, 7)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, InList, TList, 1)
	ZEND_ARG_INFO(1, iType)
	ZEND_ARG_OBJ_INFO(1, List, TList, 0)
	ZEND_ARG_OBJ_INFO(1, bBoolean, TElBoolean, 0)
	ZEND_ARG_OBJ_INFO(1, nNumber, TElNumber, 0)
	ZEND_ARG_OBJ_INFO(1, sString, TElString, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElVariableReferenceNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElVariableReferenceNode_methods[] = {
	PHP_ME(TElVariableReferenceNode, CreateNode_Inst, arginfo_TElVariableReferenceNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElVariableReferenceNode, CreateNode, arginfo_TElVariableReferenceNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElVariableReferenceNode, GetResultLocal, arginfo_TElVariableReferenceNode_GetResultLocal, ZEND_ACC_PUBLIC)
	PHP_ME(TElVariableReferenceNode, __construct, arginfo_TElVariableReferenceNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElVariableReferenceNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElVariableReferenceNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElVariableReferenceNode", TElVariableReferenceNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElVariableReferenceNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLiteralNode_ce_ptr = NULL;

SB_PHP_METHOD(TElLiteralNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLiteralNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLiteralNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLiteralNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLiteralNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLiteralNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLiteralNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLiteralNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLiteralNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElLiteralNode_methods[] = {
	PHP_ME(TElLiteralNode, CreateNode_Inst, arginfo_TElLiteralNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElLiteralNode, CreateNode, arginfo_TElLiteralNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElLiteralNode, __construct, arginfo_TElLiteralNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLiteralNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLiteralNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLiteralNode", TElLiteralNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElLiteralNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElNumberNode_ce_ptr = NULL;

SB_PHP_METHOD(TElNumberNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElNumberNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElNumberNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElNumberNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElNumberNode, GetResNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElNumberNode_GetResNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElNumber_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElNumberNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElNumberNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumberNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumberNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumberNode_GetResNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElNumberNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElNumberNode_methods[] = {
	PHP_ME(TElNumberNode, CreateNode_Inst, arginfo_TElNumberNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElNumberNode, CreateNode, arginfo_TElNumberNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElNumberNode, GetResNumber, arginfo_TElNumberNode_GetResNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElNumberNode, __construct, arginfo_TElNumberNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElNumberNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElNumberNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElNumberNode", TElNumberNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElNumberNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFunctionCallNode_ce_ptr = NULL;

SB_PHP_METHOD(TElFunctionCallNode, CreateNode_Inst)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFunctionCallNode_CreateNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFunctionCallNode, CreateNode)
{
	char *ssQuery;
	int ssQuery_len;
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &ssQuery, &ssQuery_len, &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFunctionCallNode_CreateNode(ssQuery, (int32_t)ssQuery_len, SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXPathNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXPath)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFunctionCallNode, GetResultLocal)
{
	int32_t l4iTypeRaw;
	TElClassHandle hobBoolean;
	TElClassHandle hoList;
	TElClassHandle honNumber;
	TElClassHandle hosString;
	zval *obBoolean;
	zval *oContext;
	zval *oInList;
	zval *oList;
	zval *onNumber;
	zval *osString;
	zval *zl4iType;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zOOOO", &oContext, TElXMLDOMNode_ce_ptr, &oInList, TList_ce_ptr, &zl4iType, &oList, TList_ce_ptr, &obBoolean, TElBoolean_ce_ptr, &onNumber, TElNumber_ce_ptr, &osString, TElString_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zl4iType) && (IS_LONG == Z_TYPE_P(zl4iType)) && PZVAL_IS_REF(oList) && (IS_OBJECT == Z_TYPE_P(oList)) && PZVAL_IS_REF(obBoolean) && (IS_OBJECT == Z_TYPE_P(obBoolean)) && PZVAL_IS_REF(onNumber) && (IS_OBJECT == Z_TYPE_P(onNumber)) && PZVAL_IS_REF(osString) && (IS_OBJECT == Z_TYPE_P(osString)))
	{
		l4iTypeRaw = (int32_t)Z_LVAL_P(zl4iType);
		hoList = SBGetObjectHandle(oList TSRMLS_CC);
		hobBoolean = SBGetObjectHandle(obBoolean TSRMLS_CC);
		honNumber = SBGetObjectHandle(onNumber TSRMLS_CC);
		hosString = SBGetObjectHandle(osString TSRMLS_CC);
		SBCheckError(TElFunctionCallNode_GetResultLocal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oInList TSRMLS_CC), &l4iTypeRaw, &hoList, &hobBoolean, &honNumber, &hosString) TSRMLS_CC);
		ZVAL_LONG(zl4iType, (long)l4iTypeRaw);
		SBUpdateObjectHandle(oList, hoList TSRMLS_CC);
		SBUpdateObjectHandle(obBoolean, hobBoolean TSRMLS_CC);
		SBUpdateObjectHandle(onNumber, honNumber TSRMLS_CC);
		SBUpdateObjectHandle(osString, hosString TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TList, &integer, &TList, &TElBoolean, &TElNumber, &TElString)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFunctionCallNode, __construct)
{
	zval *oXPath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXPath, TElXPath_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFunctionCallNode_Create(SBGetObjectHandle(oXPath TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXPath)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFunctionCallNode_CreateNode_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFunctionCallNode_CreateNode, 0, 0, 2)
	ZEND_ARG_INFO(0, sQuery)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFunctionCallNode_GetResultLocal, 0, 0, 7)
	ZEND_ARG_OBJ_INFO(0, Context, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, InList, TList, 1)
	ZEND_ARG_INFO(1, iType)
	ZEND_ARG_OBJ_INFO(1, List, TList, 0)
	ZEND_ARG_OBJ_INFO(1, bBoolean, TElBoolean, 0)
	ZEND_ARG_OBJ_INFO(1, nNumber, TElNumber, 0)
	ZEND_ARG_OBJ_INFO(1, sString, TElString, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFunctionCallNode___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, XPath, TElXPath, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElFunctionCallNode_methods[] = {
	PHP_ME(TElFunctionCallNode, CreateNode_Inst, arginfo_TElFunctionCallNode_CreateNode_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElFunctionCallNode, CreateNode, arginfo_TElFunctionCallNode_CreateNode, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElFunctionCallNode, GetResultLocal, arginfo_TElFunctionCallNode_GetResultLocal, ZEND_ACC_PUBLIC)
	PHP_ME(TElFunctionCallNode, __construct, arginfo_TElFunctionCallNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFunctionCallNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFunctionCallNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFunctionCallNode", TElFunctionCallNode_methods);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	TElFunctionCallNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXPathNode_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBXMLPath_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TXPathNodeType", NULL);
	TXPathNodeType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TXPathNodeType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntUnionExpr", 1)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntPathExpr", 2)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntFilterExpr", 3)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntAbsoluteLocationPath", 4)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntRelativeLocationPath", 5)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntStep", 6)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntPredicate", 7)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntOrExpr", 8)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntAndExpr", 9)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntEqualityExpr", 10)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntRelationalExpr", 11)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntAdditiveExpr", 12)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntMultiplicativeExpr", 13)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntUnaryExpr", 14)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntPrimaryExpr", 15)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntVariableReference", 16)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntLiteral", 17)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntNumber", 18)
	SB_DECLARE_CLASS_LONG_CONST(TXPathNodeType_ce_ptr, "pntFunctionCall", 19)
	
	INIT_CLASS_ENTRY(ce, "TElAxisType", NULL);
	TElAxisType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElAxisType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atAncestor", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atAncestor_or_self", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atAttribute", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atChild", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atDescendant", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atDescendant_or_self", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atFollowing", 6)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atFollowing_sibling", 7)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atNamespace", 8)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atParent", 9)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atPreceding", 10)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atPreceding_sibling", 11)
	SB_DECLARE_CLASS_LONG_CONST(TElAxisType_ce_ptr, "atSelf", 12)
	
	INIT_CLASS_ENTRY(ce, "TElNodeTestType", NULL);
	TElNodeTestType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElNodeTestType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElNodeTestType_ce_ptr, "ntNameTest", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElNodeTestType_ce_ptr, "ntNodeTypeComent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElNodeTestType_ce_ptr, "ntNodeTypeText", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElNodeTestType_ce_ptr, "ntNodeTypeProcessingInstruction", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElNodeTestType_ce_ptr, "ntNodeTypeNode", 4)
	
	INIT_CLASS_ENTRY(ce, "TElEqualityExprType", NULL);
	TElEqualityExprType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElEqualityExprType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElEqualityExprType_ce_ptr, "eetEqual", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElEqualityExprType_ce_ptr, "eetUnequal", 1)
	
	INIT_CLASS_ENTRY(ce, "TElRelationalExprType", NULL);
	TElRelationalExprType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElRelationalExprType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElRelationalExprType_ce_ptr, "retLess", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElRelationalExprType_ce_ptr, "retAdvance", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElRelationalExprType_ce_ptr, "retLessOrEqual", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElRelationalExprType_ce_ptr, "retAdvanceOrEqual", 3)
	
	INIT_CLASS_ENTRY(ce, "TElAdditiveExprType", NULL);
	TElAdditiveExprType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElAdditiveExprType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElAdditiveExprType_ce_ptr, "aetAdd", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElAdditiveExprType_ce_ptr, "retSub", 1)
	
	INIT_CLASS_ENTRY(ce, "TElMultiplicativeExprType", NULL);
	TElMultiplicativeExprType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElMultiplicativeExprType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElMultiplicativeExprType_ce_ptr, "metMul", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElMultiplicativeExprType_ce_ptr, "metDiv", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElMultiplicativeExprType_ce_ptr, "metMod", 2)
}

void Register_SBXMLPath_Aliases(TSRMLS_D)
{
	if (NULL == TElXPath_ce_ptr)
		Register_TElXPath(TSRMLS_C);
	zend_register_class_alias("ElXPath", TElXPath_ce_ptr);
	if (NULL == TElNumber_ce_ptr)
		Register_TElNumber(TSRMLS_C);
	zend_register_class_alias("ElNumber", TElNumber_ce_ptr);
	if (NULL == TElBoolean_ce_ptr)
		Register_TElBoolean(TSRMLS_C);
	zend_register_class_alias("ElBoolean", TElBoolean_ce_ptr);
	if (NULL == TElString_ce_ptr)
		Register_TElString(TSRMLS_C);
	zend_register_class_alias("ElString", TElString_ce_ptr);
	if (NULL == TElXMLVarMap_ce_ptr)
		Register_TElXMLVarMap(TSRMLS_C);
	zend_register_class_alias("ElXMLVarMap", TElXMLVarMap_ce_ptr);
	if (NULL == TElXPathNode_ce_ptr)
		Register_TElXPathNode(TSRMLS_C);
	zend_register_class_alias("ElXPathNode", TElXPathNode_ce_ptr);
	if (NULL == TElUnionExprNode_ce_ptr)
		Register_TElUnionExprNode(TSRMLS_C);
	zend_register_class_alias("ElUnionExprNode", TElUnionExprNode_ce_ptr);
	if (NULL == TElPathExprNode_ce_ptr)
		Register_TElPathExprNode(TSRMLS_C);
	zend_register_class_alias("ElPathExprNode", TElPathExprNode_ce_ptr);
	if (NULL == TElLocationPathNode_ce_ptr)
		Register_TElLocationPathNode(TSRMLS_C);
	zend_register_class_alias("ElLocationPathNode", TElLocationPathNode_ce_ptr);
	if (NULL == TElAbsoluteLocationPathNode_ce_ptr)
		Register_TElAbsoluteLocationPathNode(TSRMLS_C);
	zend_register_class_alias("ElAbsoluteLocationPathNode", TElAbsoluteLocationPathNode_ce_ptr);
	if (NULL == TElRelativeLocationPathNode_ce_ptr)
		Register_TElRelativeLocationPathNode(TSRMLS_C);
	zend_register_class_alias("ElRelativeLocationPathNode", TElRelativeLocationPathNode_ce_ptr);
	if (NULL == TElStepNode_ce_ptr)
		Register_TElStepNode(TSRMLS_C);
	zend_register_class_alias("ElStepNode", TElStepNode_ce_ptr);
	if (NULL == TElPredicateNode_ce_ptr)
		Register_TElPredicateNode(TSRMLS_C);
	zend_register_class_alias("ElPredicateNode", TElPredicateNode_ce_ptr);
	if (NULL == TElOrExprNode_ce_ptr)
		Register_TElOrExprNode(TSRMLS_C);
	zend_register_class_alias("ElOrExprNode", TElOrExprNode_ce_ptr);
	if (NULL == TElAndExprNode_ce_ptr)
		Register_TElAndExprNode(TSRMLS_C);
	zend_register_class_alias("ElAndExprNode", TElAndExprNode_ce_ptr);
	if (NULL == TElEqualityExprNode_ce_ptr)
		Register_TElEqualityExprNode(TSRMLS_C);
	zend_register_class_alias("ElEqualityExprNode", TElEqualityExprNode_ce_ptr);
	if (NULL == TElRelationalExprNode_ce_ptr)
		Register_TElRelationalExprNode(TSRMLS_C);
	zend_register_class_alias("ElRelationalExprNode", TElRelationalExprNode_ce_ptr);
	if (NULL == TElAdditiveExprNode_ce_ptr)
		Register_TElAdditiveExprNode(TSRMLS_C);
	zend_register_class_alias("ElAdditiveExprNode", TElAdditiveExprNode_ce_ptr);
	if (NULL == TElMultiplicativeExprNode_ce_ptr)
		Register_TElMultiplicativeExprNode(TSRMLS_C);
	zend_register_class_alias("ElMultiplicativeExprNode", TElMultiplicativeExprNode_ce_ptr);
	if (NULL == TElUnaryExprNode_ce_ptr)
		Register_TElUnaryExprNode(TSRMLS_C);
	zend_register_class_alias("ElUnaryExprNode", TElUnaryExprNode_ce_ptr);
	if (NULL == TElFilterExprNode_ce_ptr)
		Register_TElFilterExprNode(TSRMLS_C);
	zend_register_class_alias("ElFilterExprNode", TElFilterExprNode_ce_ptr);
	if (NULL == TElPrimaryExprNode_ce_ptr)
		Register_TElPrimaryExprNode(TSRMLS_C);
	zend_register_class_alias("ElPrimaryExprNode", TElPrimaryExprNode_ce_ptr);
	if (NULL == TElVariableReferenceNode_ce_ptr)
		Register_TElVariableReferenceNode(TSRMLS_C);
	zend_register_class_alias("ElVariableReferenceNode", TElVariableReferenceNode_ce_ptr);
	if (NULL == TElLiteralNode_ce_ptr)
		Register_TElLiteralNode(TSRMLS_C);
	zend_register_class_alias("ElLiteralNode", TElLiteralNode_ce_ptr);
	if (NULL == TElNumberNode_ce_ptr)
		Register_TElNumberNode(TSRMLS_C);
	zend_register_class_alias("ElNumberNode", TElNumberNode_ce_ptr);
	if (NULL == TElFunctionCallNode_ce_ptr)
		Register_TElFunctionCallNode(TSRMLS_C);
	zend_register_class_alias("ElFunctionCallNode", TElFunctionCallNode_ce_ptr);
}

