#ifndef __INC_SBAS3
#define __INC_SBAS3

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbconstants.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstrutils.h"
#include "sbcustomcertstorage.h"
#include "sbx509.h"
#include "sbsocket.h"
#include "sbsslcommon.h"
#include "sbsslconstants.h"
#include "sbsslclient.h"
#include "sbsimpleftps.h"
#include "sbmime.h"
#ifdef SB_WINDOWS
#include "sbdnssecconsts.h"
#include "sbdnssectypes.h"
#endif
#include "sbascommon.h"
#include "sbasutils.h"
#include "sbstreams.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElAS3ReceiptRequestHandle;

typedef TElClassHandle TElAS3EncryptionHandle;

typedef TElClassHandle TElAS3SignatureHandle;

typedef TElClassHandle TElAS3CompressionHandle;

typedef TElClassHandle TElAS3ReceiptHandle;

typedef TElClassHandle TElAS3MessageHandle;

typedef TElClassHandle TElAS3SocksOptionsHandle;

typedef TElClassHandle TElAS3SSLOptionsHandle;

typedef TElClassHandle TElAS3WebTunnelOptionsHandle;

typedef TElClassHandle TElAS3FTPOptionsHandle;

typedef TElClassHandle TElAS3ProxyOptionsHandle;

typedef TElClassHandle TElAS3SocketOptionsHandle;

typedef TElClassHandle TElAS3ClientHandle;

typedef uint8_t TSBAS3VersionRaw;

typedef enum
{
	as3Ver10 = 0,
	as3Ver11 = 1,
	as3Ver12 = 2
} TSBAS3Version;

#ifdef SB_USE_CLASS_TELAS3RECEIPTREQUEST
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_Assign(TElAS3ReceiptRequestHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_get_DigestAlgorithm(TElAS3ReceiptRequestHandle _Handle, TSBASSignatureDigestAlgorithmRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_set_DigestAlgorithm(TElAS3ReceiptRequestHandle _Handle, TSBASSignatureDigestAlgorithmRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_get_DigestAlgorithmOnly(TElAS3ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_set_DigestAlgorithmOnly(TElAS3ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_get_DigestAlgorithmRequired(TElAS3ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_set_DigestAlgorithmRequired(TElAS3ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_get_Enabled(TElAS3ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_set_Enabled(TElAS3ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_get_SignatureProtocolRequired(TElAS3ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_set_SignatureProtocolRequired(TElAS3ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_get_Signed(TElAS3ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_set_Signed(TElAS3ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_get_URL(TElAS3ReceiptRequestHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_set_URL(TElAS3ReceiptRequestHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ReceiptRequest_Create(TElAS3ReceiptRequestHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3RECEIPTREQUEST */

#ifdef SB_USE_CLASS_TELAS3ENCRYPTION
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_get_Algorithm(TElAS3EncryptionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_set_Algorithm(TElAS3EncryptionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_get_AlignEncryptedKey(TElAS3EncryptionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_set_AlignEncryptedKey(TElAS3EncryptionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_get_BitsInKey(TElAS3EncryptionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_set_BitsInKey(TElAS3EncryptionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_get_CertStorage(TElAS3EncryptionHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_set_CertStorage(TElAS3EncryptionHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_get_Enabled(TElAS3EncryptionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_set_Enabled(TElAS3EncryptionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_get_Encoding(TElAS3EncryptionHandle _Handle, TSBASEncryptionTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_set_Encoding(TElAS3EncryptionHandle _Handle, TSBASEncryptionTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_get_UseUndefSize(TElAS3EncryptionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_set_UseUndefSize(TElAS3EncryptionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Encryption_Create(TComponentHandle AOwner, TElASSMIMEEncryptionHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3ENCRYPTION */

#ifdef SB_USE_CLASS_TELAS3SIGNATURE
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_VerificationResult(TElAS3SignatureHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_CertStorage(TElAS3SignatureHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_set_CertStorage(TElAS3SignatureHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_Compressed(TElAS3SignatureHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_set_Compressed(TElAS3SignatureHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_DigestAlgorithm(TElAS3SignatureHandle _Handle, TSBASSignatureDigestAlgorithmRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_set_DigestAlgorithm(TElAS3SignatureHandle _Handle, TSBASSignatureDigestAlgorithmRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_Enabled(TElAS3SignatureHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_set_Enabled(TElAS3SignatureHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_Encoding(TElAS3SignatureHandle _Handle, TSBASSignatureTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_set_Encoding(TElAS3SignatureHandle _Handle, TSBASSignatureTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_IncludeChain(TElAS3SignatureHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_set_IncludeChain(TElAS3SignatureHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_Time(TElAS3SignatureHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_set_Time(TElAS3SignatureHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_UseUndefSize(TElAS3SignatureHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_set_UseUndefSize(TElAS3SignatureHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_get_VerificationOptions(TElAS3SignatureHandle _Handle, TSBASSMIMEVerificationOptionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_set_VerificationOptions(TElAS3SignatureHandle _Handle, TSBASSMIMEVerificationOptionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Signature_Create(TComponentHandle AOwner, TElASSMIMESignatureHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3SIGNATURE */

#ifdef SB_USE_CLASS_TELAS3COMPRESSION
SB_IMPORT uint32_t SB_APIENTRY TElAS3Compression_get_Enabled(TElAS3CompressionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Compression_set_Enabled(TElAS3CompressionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Compression_get_Encoding(TElAS3CompressionHandle _Handle, TSBASCompressionTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Compression_set_Encoding(TElAS3CompressionHandle _Handle, TSBASCompressionTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Compression_get_Level(TElAS3CompressionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Compression_set_Level(TElAS3CompressionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Compression_Create(TComponentHandle AOwner, TElASSMIMECompressionHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3COMPRESSION */

#ifdef SB_USE_CLASS_TELAS3RECEIPT
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_Assign(TElAS3ReceiptHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_Errors(TElAS3ReceiptHandle _Handle, TElASMessageErrorListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_ReceivedContentDigest(TElAS3ReceiptHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_ReceivedContentDigest(TElAS3ReceiptHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_ReceivedContentDigestAlgorithm(TElAS3ReceiptHandle _Handle, TSBASSignatureDigestAlgorithmRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_ReceivedContentDigestAlgorithm(TElAS3ReceiptHandle _Handle, TSBASSignatureDigestAlgorithmRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_ActionMode(TElAS3ReceiptHandle _Handle, TSBASDispositionActionModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_ActionMode(TElAS3ReceiptHandle _Handle, TSBASDispositionActionModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_AS3From(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_AS3From(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_AS3To(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_AS3To(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_Date(TElAS3ReceiptHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_Date(TElAS3ReceiptHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_DetailedErrors(TElAS3ReceiptHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_DetailedErrors(TElAS3ReceiptHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_FinalRecipient(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_FinalRecipient(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_MDNGateway(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_MDNGateway(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_MessageID(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_MessageID(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OriginalMessageID(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OriginalMessageID(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OriginalRecipient(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OriginalRecipient(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_ReportCharset(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_ReportCharset(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_ReportCharsetMode(TElAS3ReceiptHandle _Handle, TSBASCharsetModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_ReportCharsetMode(TElAS3ReceiptHandle _Handle, TSBASCharsetModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_ReportEncoding(TElAS3ReceiptHandle _Handle, TSBASHeaderTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_ReportEncoding(TElAS3ReceiptHandle _Handle, TSBASHeaderTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_ReportingUA(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_ReportingUA(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_SendingMode(TElAS3ReceiptHandle _Handle, TSBASDispositionSendingModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_SendingMode(TElAS3ReceiptHandle _Handle, TSBASDispositionSendingModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_Signature(TElAS3ReceiptHandle _Handle, TElAS3SignatureHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_Signature(TElAS3ReceiptHandle _Handle, TElAS3SignatureHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_SortErrors(TElAS3ReceiptHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_SortErrors(TElAS3ReceiptHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_Subject(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_Subject(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_Text(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_Text(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_TextCharset(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_TextCharset(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_TextCharsetMode(TElAS3ReceiptHandle _Handle, TSBASCharsetModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_TextCharsetMode(TElAS3ReceiptHandle _Handle, TSBASCharsetModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_TextContentType(TElAS3ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_TextContentType(TElAS3ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_TextEncoding(TElAS3ReceiptHandle _Handle, TSBASHeaderTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_TextEncoding(TElAS3ReceiptHandle _Handle, TSBASHeaderTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_Version(TElAS3ReceiptHandle _Handle, TSBAS3VersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_Version(TElAS3ReceiptHandle _Handle, TSBAS3VersionRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OnError(TElAS3ReceiptHandle _Handle, TSBASReceiptErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OnError(TElAS3ReceiptHandle _Handle, TSBASReceiptErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OnHeaderAssembled(TElAS3ReceiptHandle _Handle, TSBASHeaderEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OnHeaderAssembled(TElAS3ReceiptHandle _Handle, TSBASHeaderEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OnHeaderParsed(TElAS3ReceiptHandle _Handle, TSBASHeaderEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OnHeaderParsed(TElAS3ReceiptHandle _Handle, TSBASHeaderEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OnSign(TElAS3ReceiptHandle _Handle, TSBASMessageSignEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OnSign(TElAS3ReceiptHandle _Handle, TSBASMessageSignEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OnSigning(TElAS3ReceiptHandle _Handle, TSBASMessageSignEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OnSigning(TElAS3ReceiptHandle _Handle, TSBASMessageSignEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OnStepStart(TElAS3ReceiptHandle _Handle, TSBASProcessingStepStart * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OnStepStart(TElAS3ReceiptHandle _Handle, TSBASProcessingStepStart pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OnVerify(TElAS3ReceiptHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OnVerify(TElAS3ReceiptHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OnVerifyIDs(TElAS3ReceiptHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OnVerifyIDs(TElAS3ReceiptHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_get_OnVerifying(TElAS3ReceiptHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_set_OnVerifying(TElAS3ReceiptHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Receipt_Create(TComponentHandle AOwner, TElAS3ReceiptHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3RECEIPT */

#ifdef SB_USE_CLASS_TELAS3MESSAGE
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_Assign(TElAS3MessageHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Cancelled(TElAS3MessageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_ContentDigest(TElAS3MessageHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_ContentDigestAlgorithm(TElAS3MessageHandle _Handle, TSBASSignatureDigestAlgorithmRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Errors(TElAS3MessageHandle _Handle, TElASMessageErrorListHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Features(TElAS3MessageHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Features(TElAS3MessageHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_AS3From(TElAS3MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_AS3From(TElAS3MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_AS3To(TElAS3MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_AS3To(TElAS3MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Charset(TElAS3MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_Charset(TElAS3MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_CharsetMode(TElAS3MessageHandle _Handle, TSBASCharsetModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_CharsetMode(TElAS3MessageHandle _Handle, TSBASCharsetModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_ContentType(TElAS3MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_ContentType(TElAS3MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Compression(TElAS3MessageHandle _Handle, TElAS3CompressionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_Compression(TElAS3MessageHandle _Handle, TElAS3CompressionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_DataEncoding(TElAS3MessageHandle _Handle, TSBASDataTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_DataEncoding(TElAS3MessageHandle _Handle, TSBASDataTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Date(TElAS3MessageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_Date(TElAS3MessageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Encryption(TElAS3MessageHandle _Handle, TElAS3EncryptionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_Encryption(TElAS3MessageHandle _Handle, TElAS3EncryptionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_FileCreated(TElAS3MessageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_FileCreated(TElAS3MessageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_FileModified(TElAS3MessageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_FileModified(TElAS3MessageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_FileName(TElAS3MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_FileName(TElAS3MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_HeaderEncoding(TElAS3MessageHandle _Handle, TSBASHeaderTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_HeaderEncoding(TElAS3MessageHandle _Handle, TSBASHeaderTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_IgnoreFileWarnings(TElAS3MessageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_IgnoreFileWarnings(TElAS3MessageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_MessageID(TElAS3MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_MessageID(TElAS3MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_ReceiptRequest(TElAS3MessageHandle _Handle, TElAS3ReceiptRequestHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_ReceiptRequest(TElAS3MessageHandle _Handle, TElAS3ReceiptRequestHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Signature(TElAS3MessageHandle _Handle, TElAS3SignatureHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_Signature(TElAS3MessageHandle _Handle, TElAS3SignatureHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Subject(TElAS3MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_Subject(TElAS3MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_Version(TElAS3MessageHandle _Handle, TSBAS3VersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_Version(TElAS3MessageHandle _Handle, TSBAS3VersionRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnDecrypt(TElAS3MessageHandle _Handle, TSBASMessageDecryptEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnDecrypt(TElAS3MessageHandle _Handle, TSBASMessageDecryptEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnDecryptIDs(TElAS3MessageHandle _Handle, TSBASMessageDecryptEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnDecryptIDs(TElAS3MessageHandle _Handle, TSBASMessageDecryptEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnDecrypting(TElAS3MessageHandle _Handle, TSBASMessageDecryptEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnDecrypting(TElAS3MessageHandle _Handle, TSBASMessageDecryptEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnError(TElAS3MessageHandle _Handle, TSBASMessageErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnError(TElAS3MessageHandle _Handle, TSBASMessageErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnHeaderAssembled(TElAS3MessageHandle _Handle, TSBASHeaderEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnHeaderAssembled(TElAS3MessageHandle _Handle, TSBASHeaderEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnHeaderParsed(TElAS3MessageHandle _Handle, TSBASHeaderEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnHeaderParsed(TElAS3MessageHandle _Handle, TSBASHeaderEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnProgress(TElAS3MessageHandle _Handle, TSBProgressEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnProgress(TElAS3MessageHandle _Handle, TSBProgressEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnSign(TElAS3MessageHandle _Handle, TSBASMessageSignEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnSign(TElAS3MessageHandle _Handle, TSBASMessageSignEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnSigning(TElAS3MessageHandle _Handle, TSBASMessageSignEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnSigning(TElAS3MessageHandle _Handle, TSBASMessageSignEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnStepStart(TElAS3MessageHandle _Handle, TSBASProcessingStepStart * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnStepStart(TElAS3MessageHandle _Handle, TSBASProcessingStepStart pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnTempRelease(TElAS3MessageHandle _Handle, TSBASStreamReleaseEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnTempRelease(TElAS3MessageHandle _Handle, TSBASStreamReleaseEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnTempRequest(TElAS3MessageHandle _Handle, TSBASStreamRequestEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnTempRequest(TElAS3MessageHandle _Handle, TSBASStreamRequestEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnVerify(TElAS3MessageHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnVerify(TElAS3MessageHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnVerifyIDs(TElAS3MessageHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnVerifyIDs(TElAS3MessageHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_get_OnVerifying(TElAS3MessageHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_set_OnVerifying(TElAS3MessageHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Message_Create(TComponentHandle AOwner, TElAS3MessageHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3MESSAGE */

#ifdef SB_USE_CLASS_TELAS3SOCKSOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_Assign(TElAS3SocksOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_get_Authentication(TElAS3SocksOptionsHandle _Handle, TElSocksAuthenticationRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_set_Authentication(TElAS3SocksOptionsHandle _Handle, TElSocksAuthenticationRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_get_Enabled(TElAS3SocksOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_set_Enabled(TElAS3SocksOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_get_Host(TElAS3SocksOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_set_Host(TElAS3SocksOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_get_Password(TElAS3SocksOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_set_Password(TElAS3SocksOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_get_Port(TElAS3SocksOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_set_Port(TElAS3SocksOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_get_ResolveAddress(TElAS3SocksOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_set_ResolveAddress(TElAS3SocksOptionsHandle _Handle, int8_t Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_get_UseIPv6(TElAS3SocksOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_set_UseIPv6(TElAS3SocksOptionsHandle _Handle, int8_t Value);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_get_UserCode(TElAS3SocksOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_set_UserCode(TElAS3SocksOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_get_Version(TElAS3SocksOptionsHandle _Handle, TElSocksVersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_set_Version(TElAS3SocksOptionsHandle _Handle, TElSocksVersionRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocksOptions_Create(TElSimpleFTPSClientHandle AClient, TElAS3SocksOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3SOCKSOPTIONS */

#ifdef SB_USE_CLASS_TELAS3SSLOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_Assign(TElAS3SSLOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_InternalValidate(TElAS3SSLOptionsHandle _Handle, TSBCertificateValidityRaw * Validity, TSBCertificateValidityReasonRaw * Reason);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_RenegotiateCiphers(TElAS3SSLOptionsHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_Active(TElAS3SSLOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_CurrentCipherSuite(TElAS3SSLOptionsHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_CurrentCompression(TElAS3SSLOptionsHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_CurrentVersion(TElAS3SSLOptionsHandle _Handle, TSBVersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_Extensions(TElAS3SSLOptionsHandle _Handle, TElClientSSLExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_ServerExtensions(TElAS3SSLOptionsHandle _Handle, TElCustomSSLExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_CipherSuitePriorities(TElAS3SSLOptionsHandle _Handle, uint8_t Index, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_CipherSuitePriorities(TElAS3SSLOptionsHandle _Handle, uint8_t Index, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_CipherSuites(TElAS3SSLOptionsHandle _Handle, uint8_t Index, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_CipherSuites(TElAS3SSLOptionsHandle _Handle, uint8_t Index, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_CompressionAlgorithms(TElAS3SSLOptionsHandle _Handle, uint8_t Index, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_CompressionAlgorithms(TElAS3SSLOptionsHandle _Handle, uint8_t Index, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_CertStorage(TElAS3SSLOptionsHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_CertStorage(TElAS3SSLOptionsHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_ClientCertStorage(TElAS3SSLOptionsHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_ClientCertStorage(TElAS3SSLOptionsHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_Enabled(TElAS3SSLOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_Enabled(TElAS3SSLOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_EncryptData(TElAS3SSLOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_EncryptData(TElAS3SSLOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_Mode(TElAS3SSLOptionsHandle _Handle, TSBSSLModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_Mode(TElAS3SSLOptionsHandle _Handle, TSBSSLModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_ResumeSessions(TElAS3SSLOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_ResumeSessions(TElAS3SSLOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_get_Versions(TElAS3SSLOptionsHandle _Handle, TSBVersionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_set_Versions(TElAS3SSLOptionsHandle _Handle, TSBVersionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SSLOptions_Create(TElSimpleFTPSClientHandle AClient, TElAS3SSLOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3SSLOPTIONS */

#ifdef SB_USE_CLASS_TELAS3WEBTUNNELOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_Assign(TElAS3WebTunnelOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_get_ServerResult(TElAS3WebTunnelOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_get_Authentication(TElAS3WebTunnelOptionsHandle _Handle, TElWebTunnelAuthenticationRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_set_Authentication(TElAS3WebTunnelOptionsHandle _Handle, TElWebTunnelAuthenticationRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_get_Enabled(TElAS3WebTunnelOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_set_Enabled(TElAS3WebTunnelOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_get_Host(TElAS3WebTunnelOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_set_Host(TElAS3WebTunnelOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_get_Password(TElAS3WebTunnelOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_set_Password(TElAS3WebTunnelOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_get_Port(TElAS3WebTunnelOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_set_Port(TElAS3WebTunnelOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_get_UserID(TElAS3WebTunnelOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_set_UserID(TElAS3WebTunnelOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3WebTunnelOptions_Create(TElSimpleFTPSClientHandle AClient, TElAS3WebTunnelOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3WEBTUNNELOPTIONS */

#ifdef SB_USE_CLASS_TELAS3FTPOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_Assign(TElAS3FTPOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ExtMDTMSupported(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ExtMLSTSupported(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ExtRESTSupported(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ExtSIZESupported(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ExtXCRCSupported(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ExtXMD5Supported(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ExtXSHA1Supported(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_LastReply(TElAS3FTPOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ModeZSupported(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_AccountInfo(TElAS3FTPOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_AccountInfo(TElAS3FTPOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_AdjustPasvAddress(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_AdjustPasvAddress(TElAS3FTPOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_AuthCmd(TElAS3FTPOptionsHandle _Handle, TSBFTPAuthCmdRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_AuthCmd(TElAS3FTPOptionsHandle _Handle, TSBFTPAuthCmdRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_LocalCharset(TElAS3FTPOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_LocalCharset(TElAS3FTPOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ModeZ(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_ModeZ(TElAS3FTPOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_ModeZLevel(TElAS3FTPOptionsHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_ModeZLevel(TElAS3FTPOptionsHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_Options(TElAS3FTPOptionsHandle _Handle, TSBFTPOptionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_Options(TElAS3FTPOptionsHandle _Handle, TSBFTPOptionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_PassiveMode(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_PassiveMode(TElAS3FTPOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_Password(TElAS3FTPOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_Password(TElAS3FTPOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_RemoteCharset(TElAS3FTPOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_RemoteCharset(TElAS3FTPOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_TransferType(TElAS3FTPOptionsHandle _Handle, TSBFTPTransferTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_TransferType(TElAS3FTPOptionsHandle _Handle, TSBFTPTransferTypeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_UseFEATCmd(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_UseFEATCmd(TElAS3FTPOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_UserName(TElAS3FTPOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_UserName(TElAS3FTPOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_get_UseSIZECmd(TElAS3FTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_set_UseSIZECmd(TElAS3FTPOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3FTPOptions_Create(TElSimpleFTPSClientHandle AClient, TElAS3FTPOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3FTPOPTIONS */

#ifdef SB_USE_CLASS_TELAS3PROXYOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_Assign(TElAS3ProxyOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_get_Host(TElAS3ProxyOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_set_Host(TElAS3ProxyOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_get_Password(TElAS3ProxyOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_set_Password(TElAS3ProxyOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_get_Port(TElAS3ProxyOptionsHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_set_Port(TElAS3ProxyOptionsHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_get_ProxyType(TElAS3ProxyOptionsHandle _Handle, TSBFTPProxyTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_set_ProxyType(TElAS3ProxyOptionsHandle _Handle, TSBFTPProxyTypeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_get_UserName(TElAS3ProxyOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_set_UserName(TElAS3ProxyOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3ProxyOptions_Create(TElSimpleFTPSClientHandle AClient, TElAS3ProxyOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3PROXYOPTIONS */

#ifdef SB_USE_CLASS_TELAS3SOCKETOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_Assign(TElAS3SocketOptionsHandle _Handle, TPersistentHandle Source);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_UsingIPv6(TElAS3SocketOptionsHandle _Handle, int8_t * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_Address(TElAS3SocketOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_Address(TElAS3SocketOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_BufferSize(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_BufferSize(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_CommandBinding(TElAS3SocketOptionsHandle _Handle, TElClientSocketBindingHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_CommandBinding(TElAS3SocketOptionsHandle _Handle, TElClientSocketBindingHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_ConcurrentConnections(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_ConcurrentConnections(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_DataBinding(TElAS3SocketOptionsHandle _Handle, TElClientSocketBindingHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_DataBinding(TElAS3SocketOptionsHandle _Handle, TElClientSocketBindingHandle Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_DNS(TElAS3SocketOptionsHandle _Handle, TElDNSSettingsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_DNS(TElAS3SocketOptionsHandle _Handle, TElDNSSettingsHandle Value);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_IncomingSpeedLimit(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_IncomingSpeedLimit(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_ListenTimeout(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_ListenTimeout(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_MinSizeForConcurrentDownload(TElAS3SocketOptionsHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_MinSizeForConcurrentDownload(TElAS3SocketOptionsHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_OutgoingSpeedLimit(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_OutgoingSpeedLimit(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_Port(TElAS3SocketOptionsHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_Port(TElAS3SocketOptionsHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_Timeout(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_Timeout(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_TransferTimeout(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_TransferTimeout(TElAS3SocketOptionsHandle _Handle, int32_t Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_UseIPv6(TElAS3SocketOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_UseIPv6(TElAS3SocketOptionsHandle _Handle, int8_t Value);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_UseProxyForData(TElAS3SocketOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_UseProxyForData(TElAS3SocketOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_AutoAdjustBuffersSize(TElAS3SocketOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_AutoAdjustBuffersSize(TElAS3SocketOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_BuffersAdjustStep(TElAS3SocketOptionsHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_BuffersAdjustStep(TElAS3SocketOptionsHandle _Handle, double Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_MaxBufferSize(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_MaxBufferSize(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_MinBufferSize(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_MinBufferSize(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_RecvBufferSize(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_RecvBufferSize(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_get_SendBufferSize(TElAS3SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_set_SendBufferSize(TElAS3SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3SocketOptions_Create(TElSimpleFTPSClientHandle AClient, TElAS3SocketOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3SOCKETOPTIONS */

#ifdef SB_USE_CLASS_TELAS3CLIENT
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Abort(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Acct(TElAS3ClientHandle _Handle, const char * pcAcctInfo, int32_t szAcctInfo);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Allocate(TElAS3ClientHandle _Handle, int32_t Size);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_CDUp(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_ClearCommandChannel(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_ClearCommandChannel_1(TElAS3ClientHandle _Handle, int8_t GracefulSSLClosure);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Close(TElAS3ClientHandle _Handle, int8_t Silent);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Cwd(TElAS3ClientHandle _Handle, const char * pcAPath, int32_t szAPath);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Delete(TElAS3ClientHandle _Handle, const char * pcAFileName, int32_t szAFileName);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_GetCurrentDir(TElAS3ClientHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_GetFileList(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_GetFileSize(TElAS3ClientHandle _Handle, const char * pcAFileName, int32_t szAFileName, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_GetFileTime(TElAS3ClientHandle _Handle, const char * pcAFileName, int32_t szAFileName, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_GetLocalChecksum(TElAS3ClientHandle _Handle, const char * pcAFileName, int32_t szAFileName, TSBFTPCheckMethodRaw CheckMethod, int64_t StartPoint, int64_t EndPoint, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_GetNameList(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_GetNameList_1(TElAS3ClientHandle _Handle, const char * pcParameters, int32_t szParameters);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_GetRemoteChecksum(TElAS3ClientHandle _Handle, const char * pcAFileName, int32_t szAFileName, TSBFTPCheckMethodRaw CheckMethod, int64_t StartPoint, int64_t EndPoint, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_GetServerSystem(TElAS3ClientHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_InternalValidate(TElAS3ClientHandle _Handle, TSBCertificateValidityRaw * Validity, TSBCertificateValidityReasonRaw * Reason);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Login(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_MakeDir(TElAS3ClientHandle _Handle, const char * pcPath, int32_t szPath);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_MLSD(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_MountStruct(TElAS3ClientHandle _Handle, const char * pcPath, int32_t szPath);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_NoOp(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Open(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Receive(TElAS3ClientHandle _Handle, const char * pcFileName, int32_t szFileName, int64_t StartPos, int64_t EndPos);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Receive_1(TElAS3ClientHandle _Handle, const char * pcFileName, int32_t szFileName, TStreamHandle Stream, int64_t StartPos, int64_t EndPos);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Reinitialize(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_RemoveDir(TElAS3ClientHandle _Handle, const char * pcPath, int32_t szPath);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Rename(TElAS3ClientHandle _Handle, const char * pcSourceFile, int32_t szSourceFile, const char * pcDestFile, int32_t szDestFile);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_RenegotiateCiphers(TElAS3ClientHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_SendCmd(TElAS3ClientHandle _Handle, const char * pcCommand, int32_t szCommand, const int16_t pAcceptCodes[], int32_t szAcceptCodes, int16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Send(TElAS3ClientHandle _Handle, TStreamHandle Stream, const char * pcFileName, int32_t szFileName, int64_t StartPos, int64_t EndPos, int8_t Append, int64_t RestartFrom);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Send_1(TElAS3ClientHandle _Handle, TStreamHandle Stream, const char * pcFileName, int32_t szFileName, int64_t RestartFrom);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Send_2(TElAS3ClientHandle _Handle, TStreamHandle Stream, const char * pcFileName, int32_t szFileName);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_FTP(TElAS3ClientHandle _Handle, TElAS3FTPOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_FTP(TElAS3ClientHandle _Handle, TElAS3FTPOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_Proxy(TElAS3ClientHandle _Handle, TElAS3ProxyOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_Proxy(TElAS3ClientHandle _Handle, TElAS3ProxyOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_Sockets(TElAS3ClientHandle _Handle, TElAS3SocketOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_Sockets(TElAS3ClientHandle _Handle, TElAS3SocketOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_Socks(TElAS3ClientHandle _Handle, TElAS3SocksOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_Socks(TElAS3ClientHandle _Handle, TElAS3SocksOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_SSL(TElAS3ClientHandle _Handle, TElAS3SSLOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_SSL(TElAS3ClientHandle _Handle, TElAS3SSLOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_WebTunnel(TElAS3ClientHandle _Handle, TElAS3WebTunnelOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_WebTunnel(TElAS3ClientHandle _Handle, TElAS3WebTunnelOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnBinaryData(TElAS3ClientHandle _Handle, TSBFTPSBinaryDataEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnBinaryData(TElAS3ClientHandle _Handle, TSBFTPSBinaryDataEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnCertificateNeededEx(TElAS3ClientHandle _Handle, TSBCertificateNeededExEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnCertificateNeededEx(TElAS3ClientHandle _Handle, TSBCertificateNeededExEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnCertificateStatus(TElAS3ClientHandle _Handle, TSBCertificateStatusEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnCertificateStatus(TElAS3ClientHandle _Handle, TSBCertificateStatusEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnCertificateValidate(TElAS3ClientHandle _Handle, TSBCertificateValidateEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnCertificateValidate(TElAS3ClientHandle _Handle, TSBCertificateValidateEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnCiphersNegotiated(TElAS3ClientHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnCiphersNegotiated(TElAS3ClientHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnControlSend(TElAS3ClientHandle _Handle, TSBFTPSTextDataEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnControlSend(TElAS3ClientHandle _Handle, TSBFTPSTextDataEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnControlReceive(TElAS3ClientHandle _Handle, TSBFTPSTextDataEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnControlReceive(TElAS3ClientHandle _Handle, TSBFTPSTextDataEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnError(TElAS3ClientHandle _Handle, TSBErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnError(TElAS3ClientHandle _Handle, TSBErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnExtensionsReceived(TElAS3ClientHandle _Handle, TSBExtensionsReceivedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnExtensionsReceived(TElAS3ClientHandle _Handle, TSBExtensionsReceivedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnExtensionsPrepared(TElAS3ClientHandle _Handle, TSBExtensionsPreparedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnExtensionsPrepared(TElAS3ClientHandle _Handle, TSBExtensionsPreparedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnInnerClientCreated(TElAS3ClientHandle _Handle, TSBFTPSInnerClientEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnInnerClientCreated(TElAS3ClientHandle _Handle, TSBFTPSInnerClientEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnInnerClientDestroyed(TElAS3ClientHandle _Handle, TSBFTPSInnerClientEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnInnerClientDestroyed(TElAS3ClientHandle _Handle, TSBFTPSInnerClientEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnInnerClientLoggedIn(TElAS3ClientHandle _Handle, TSBFTPSInnerClientEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnInnerClientLoggedIn(TElAS3ClientHandle _Handle, TSBFTPSInnerClientEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnKeyNeeded(TElAS3ClientHandle _Handle, TSBClientKeyNeededEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnKeyNeeded(TElAS3ClientHandle _Handle, TSBClientKeyNeededEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnProgress(TElAS3ClientHandle _Handle, TSBProgressEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnProgress(TElAS3ClientHandle _Handle, TSBProgressEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnTextDataLine(TElAS3ClientHandle _Handle, TSBFTPSTextDataEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnTextDataLine(TElAS3ClientHandle _Handle, TSBFTPSTextDataEvent pMethodValue, void * pDataValue);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnDNSKeyNeded(TElAS3ClientHandle _Handle, TSBDNSKeyNeededEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnDNSKeyNeded(TElAS3ClientHandle _Handle, TSBDNSKeyNeededEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnDNSKeyValidate(TElAS3ClientHandle _Handle, TSBDNSKeyValidateEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnDNSKeyValidate(TElAS3ClientHandle _Handle, TSBDNSKeyValidateEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_get_OnDNSResolve(TElAS3ClientHandle _Handle, TSBDNSResolveEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_set_OnDNSResolve(TElAS3ClientHandle _Handle, TSBDNSResolveEvent pMethodValue, void * pDataValue);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS3Client_Create(TComponentHandle AOwner, TElAS3ClientHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS3CLIENT */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElAS3ReceiptRequest_ce_ptr;
extern zend_class_entry *TElAS3Encryption_ce_ptr;
extern zend_class_entry *TElAS3Signature_ce_ptr;
extern zend_class_entry *TElAS3Compression_ce_ptr;
extern zend_class_entry *TElAS3Receipt_ce_ptr;
extern zend_class_entry *TElAS3Message_ce_ptr;
extern zend_class_entry *TElAS3SocksOptions_ce_ptr;
extern zend_class_entry *TElAS3SSLOptions_ce_ptr;
extern zend_class_entry *TElAS3WebTunnelOptions_ce_ptr;
extern zend_class_entry *TElAS3FTPOptions_ce_ptr;
extern zend_class_entry *TElAS3ProxyOptions_ce_ptr;
extern zend_class_entry *TElAS3SocketOptions_ce_ptr;
extern zend_class_entry *TElAS3Client_ce_ptr;

void Register_TElAS3ReceiptRequest(TSRMLS_D);
void Register_TElAS3Encryption(TSRMLS_D);
void Register_TElAS3Signature(TSRMLS_D);
void Register_TElAS3Compression(TSRMLS_D);
void Register_TElAS3Receipt(TSRMLS_D);
void Register_TElAS3Message(TSRMLS_D);
void Register_TElAS3SocksOptions(TSRMLS_D);
void Register_TElAS3SSLOptions(TSRMLS_D);
void Register_TElAS3WebTunnelOptions(TSRMLS_D);
void Register_TElAS3FTPOptions(TSRMLS_D);
void Register_TElAS3ProxyOptions(TSRMLS_D);
void Register_TElAS3SocketOptions(TSRMLS_D);
void Register_TElAS3Client(TSRMLS_D);
SB_PHP_FUNCTION(SBAS3, AS3NameNeedsQuoting);
SB_PHP_FUNCTION(SBAS3, DequoteAS3Name);
SB_PHP_FUNCTION(SBAS3, QuoteAS3Name);
SB_PHP_FUNCTION(SBAS3, ValidAS3Name);
void Register_SBAS3_Enum_Flags(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_AS3
SB_IMPORT uint32_t SB_APIENTRY SBAS3_AS3NameNeedsQuoting(const char * pcAS3Name, int32_t szAS3Name, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBAS3_DequoteAS3Name(const char * pcValue, int32_t szValue, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBAS3_QuoteAS3Name(const char * pcAS3Name, int32_t szAS3Name, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBAS3_ValidAS3Name(const char * pcName, int32_t szName, int8_t * OutResult);
#endif /* SB_USE_GLOBAL_PROCS_AS3 */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBAS3 */
