#ifndef __INC_SBGOOGLEDATASTORAGE
#define __INC_SBGOOGLEDATASTORAGE

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbconstants.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstreams.h"
#include "sbencoding.h"
#include "sbdatastorage.h"
#include "sbdatastorageutils.h"
#include "sbhttpsclient.h"
#include "sbxmlutils.h"
#include "sbxmlcore.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElGoogleDataStorageHandle;

typedef TElClassHandle TElGoogleDataStorageObjectCategoriesHandle;

typedef TElClassHandle TElGoogleDataStorageObjectLinksHandle;

typedef TElClassHandle TElGoogleDataStorageObjectHandle;

typedef TElClassHandle TElGooglePrefixedPostfixedUploadStreamHandle;

typedef TElClassHandle TElGoogleBase64EncodingStreamHandle;

typedef TElClassHandle TElGoogleBase64DecodingStreamHandle;

typedef TElClassHandle TElGooglePrefixedMetadataProcessingStreamHandle;

typedef uint8_t TSBGDataVersionRaw;

typedef enum
{
	gvV2 = 0,
	gvV3 = 1
} TSBGDataVersion;

typedef uint8_t TSBGoogleAuthTypeRaw;

typedef enum
{
	gatClientLogin = 0,
	gatAuthSub = 1,
	gatOAuth = 2
} TSBGoogleAuthType;

typedef uint8_t TSBGoogleEntryOrderRaw;

typedef enum
{
	geoTitle = 0,
	geoStarred = 1,
	geoLastModified = 2,
	geoLastViewed = 3,
	geoUnspecified = 4
} TSBGoogleEntryOrder;

typedef uint8_t TSBGoogleDocTypeRaw;

typedef enum
{
	gdtDocument = 0,
	gdtSpreadsheet = 1,
	gdtPresentation = 2,
	gdtUnknown = 3
} TSBGoogleDocType;

typedef uint8_t TSBGoogleDataStorageEncodingRaw;

typedef enum
{
	gdeNone = 0,
	gdeBase64 = 1
} TSBGoogleDataStorageEncoding;

typedef void (SB_CALLBACK *TSBGoogleAuthAttemptEvent)(void * _ObjectData, TObjectHandle Sender);

typedef void (SB_CALLBACK *TSBGoogleAuthCaptchaRequestEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcCaptchaUrl, int32_t szCaptchaUrl, const char * pcPageUrl, int32_t szPageUrl, char * pcCaptcha, int32_t * szCaptcha);

typedef void (SB_CALLBACK *TSBGoogleAuthAttemptFailedEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcErrorMsg, int32_t szErrorMsg, const char * pcPageUrl, int32_t szPageUrl, int8_t * Cancel);

typedef void (SB_CALLBACK *TSBGooglePrefixedMetadataProcessingStreamMetadataFunc)(void * _ObjectData, TObjectHandle Sender, const uint8_t pMetadata[], int32_t szMetadata);

#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGE
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_Authorize(TElGoogleDataStorageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_SecondaryAuthorize(TElGoogleDataStorageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_AcquireObject(TElGoogleDataStorageHandle _Handle, const char * pcTitle, int32_t szTitle, TElGoogleDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_AcquireObject_1(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Folder, const char * pcTitle, int32_t szTitle, TElGoogleDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_AcquireObject_2(TElGoogleDataStorageHandle _Handle, TSBGoogleDocTypeRaw DocType, const char * pcDocID, int32_t szDocID, TElGoogleDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_AcquireObject_3(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_List(TElGoogleDataStorageHandle _Handle, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_List_1(TElGoogleDataStorageHandle _Handle, const char * pcQuery, int32_t szQuery, int8_t ShowFolders, int8_t ShowDeleted, TSBGoogleEntryOrderRaw OrderBy, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_List_2(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Folder, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_List_3(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Folder, const char * pcQuery, int32_t szQuery, int8_t ShowFolders, int8_t ShowDeleted, TSBGoogleEntryOrderRaw OrderBy, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_List_4(TElGoogleDataStorageHandle _Handle, const char * pcQuery, int32_t szQuery, const char * pcAlt, int32_t szAlt, const char * pcAuthor, int32_t szAuthor, int64_t StartIndex, int64_t MaxResults, int64_t UpdatedMin, int64_t UpdatedMax, const char * pcCategory, int32_t szCategory, const char * pcTitle, int32_t szTitle, int8_t ExactTitle, int64_t OpenedMin, int64_t OpenedMax, const char * pcOwner, int32_t szOwner, const char * pcWriter, int32_t szWriter, const char * pcReader, int32_t szReader, int8_t ShowFolders, int8_t ShowDeleted, TSBGoogleEntryOrderRaw OrderBy, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_List_5(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Folder, const char * pcQuery, int32_t szQuery, const char * pcAlt, int32_t szAlt, const char * pcAuthor, int32_t szAuthor, int64_t StartIndex, int64_t MaxResults, int64_t UpdatedMin, int64_t UpdatedMax, const char * pcCategory, int32_t szCategory, const char * pcTitle, int32_t szTitle, int8_t ExactTitle, int64_t OpenedMin, int64_t OpenedMax, const char * pcOwner, int32_t szOwner, const char * pcWriter, int32_t szWriter, const char * pcReader, int32_t szReader, int8_t ShowFolders, int8_t ShowDeleted, TSBGoogleEntryOrderRaw OrderBy, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_CreateObject(TElGoogleDataStorageHandle _Handle, const char * pcTitle, int32_t szTitle, TSBGoogleDocTypeRaw DocType, const char * pcContentType, int32_t szContentType, TElGoogleDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_CreateFolder(TElGoogleDataStorageHandle _Handle, const char * pcTitle, int32_t szTitle, TElGoogleDataStorageObjectHandle ParentFolder, TElGoogleDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_DeleteObject(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle * Obj);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_DeleteObject_1(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle * Obj, int8_t DeletePermanently);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_DeleteObject_2(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Folder, const char * pcTitle, int32_t szTitle, int8_t DeletePermanently);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_DeleteObject_3(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle * Obj);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_ObjectExists(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Obj, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_ObjectExists_1(TElGoogleDataStorageHandle _Handle, TSBGoogleDocTypeRaw DocType, const char * pcDocID, int32_t szDocID, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_ObjectExists_2(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Folder, const char * pcTitle, int32_t szTitle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_RefreshObject(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Obj);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_WriteObject(TElGoogleDataStorageHandle _Handle, const char * pcTitle, int32_t szTitle, TStreamHandle Data, TSBGoogleDocTypeRaw DocType, const char * pcContentType, int32_t szContentType, int8_t Convert, TSBGoogleDataStorageEncodingRaw Encoding, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_WriteObject_1(TElGoogleDataStorageHandle _Handle, const char * pcTitle, int32_t szTitle, TStreamHandle Data, TSBGoogleDocTypeRaw DocType, const char * pcContentType, int32_t szContentType, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_WriteObject_2(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Obj, TStreamHandle Data, int8_t OverwriteChanges, int8_t Append, const char * pcContentType, int32_t szContentType, TSBGoogleDataStorageEncodingRaw Encoding, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_WriteObject_3(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle Obj, TStreamHandle Strm, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_ReadObject(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Obj, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_ReadObject_1(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Obj, TStreamHandle Strm, TSBGoogleDataStorageEncodingRaw Encoding);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_ReadObject_2(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Obj, TStreamHandle Strm, const char * pcFormat, int32_t szFormat, TSBGoogleDataStorageEncodingRaw Encoding);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_ReadObject_3(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Folder, const char * pcTitle, int32_t szTitle, TStreamHandle Strm, const char * pcFormat, int32_t szFormat, TSBGoogleDataStorageEncodingRaw Encoding);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_ReadObject_4(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle Obj, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_CopyObject(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Obj, const char * pcDestTitle, int32_t szDestTitle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_CopyObject_1(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Folder, const char * pcSrcTitle, int32_t szSrcTitle, const char * pcDestTitle, int32_t szDestTitle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_CopyObject_2(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle Obj, TElCustomDataStorageSecurityHandlerHandle NewHandler, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_MoveObject(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Obj, TElGoogleDataStorageObjectHandle DestFolder);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_MoveObject_1(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Folder, const char * pcTitle, int32_t szTitle, TElGoogleDataStorageObjectHandle DestFolder);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_GetObjectFolder(TElGoogleDataStorageHandle _Handle, TElGoogleDataStorageObjectHandle Obj, TElGoogleDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_AuthType(TElGoogleDataStorageHandle _Handle, TSBGoogleAuthTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_AuthType(TElGoogleDataStorageHandle _Handle, TSBGoogleAuthTypeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_DefObjectEncoding(TElGoogleDataStorageHandle _Handle, TSBGoogleDataStorageEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_DefObjectEncoding(TElGoogleDataStorageHandle _Handle, TSBGoogleDataStorageEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_Version(TElGoogleDataStorageHandle _Handle, TSBGDataVersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_Version(TElGoogleDataStorageHandle _Handle, TSBGDataVersionRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_UseSSL(TElGoogleDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_UseSSL(TElGoogleDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_HTTPClient(TElGoogleDataStorageHandle _Handle, TElHTTPSClientHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_HTTPClient(TElGoogleDataStorageHandle _Handle, TElHTTPSClientHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_Username(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_Username(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_Password(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_Password(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_ServiceName(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_ServiceName(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_SecondaryServiceName(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_SecondaryServiceName(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_ServerAddress(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_ServerAddress(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_AuthServerAddress(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_AuthServerAddress(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_AuthSource(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_AuthSource(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_AuthToken(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_AuthToken(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_SecondaryAuthToken(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_SecondaryAuthToken(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_MaxAuthAttempts(TElGoogleDataStorageHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_MaxAuthAttempts(TElGoogleDataStorageHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_SecMetadataID(TElGoogleDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_SecMetadataID(TElGoogleDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_UseURLEncoding(TElGoogleDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_UseURLEncoding(TElGoogleDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_IgnoreContentSrc(TElGoogleDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_IgnoreContentSrc(TElGoogleDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_OnAuthAttempt(TElGoogleDataStorageHandle _Handle, TSBGoogleAuthAttemptEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_OnAuthAttempt(TElGoogleDataStorageHandle _Handle, TSBGoogleAuthAttemptEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_OnAuthCaptchaRequest(TElGoogleDataStorageHandle _Handle, TSBGoogleAuthCaptchaRequestEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_OnAuthCaptchaRequest(TElGoogleDataStorageHandle _Handle, TSBGoogleAuthCaptchaRequestEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_get_OnAuthAttemptFailed(TElGoogleDataStorageHandle _Handle, TSBGoogleAuthAttemptFailedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_set_OnAuthAttemptFailed(TElGoogleDataStorageHandle _Handle, TSBGoogleAuthAttemptFailedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorage_Create(TComponentHandle AOwner, TElGoogleDataStorageHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGE */

#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTCATEGORIES
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectCategories_Assign(TElGoogleDataStorageObjectCategoriesHandle _Handle, TElGoogleDataStorageObjectCategoriesHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectCategories_Clear(TElGoogleDataStorageObjectCategoriesHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectCategories_get_Schemes(TElGoogleDataStorageObjectCategoriesHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectCategories_get_Terms(TElGoogleDataStorageObjectCategoriesHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectCategories_get_Labels(TElGoogleDataStorageObjectCategoriesHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectCategories_get_Count(TElGoogleDataStorageObjectCategoriesHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectCategories_Create(TElGoogleDataStorageObjectCategoriesHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTCATEGORIES */

#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTLINKS
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectLinks_Assign(TElGoogleDataStorageObjectLinksHandle _Handle, TElGoogleDataStorageObjectLinksHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectLinks_Clear(TElGoogleDataStorageObjectLinksHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectLinks_get_Rels(TElGoogleDataStorageObjectLinksHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectLinks_get_Types(TElGoogleDataStorageObjectLinksHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectLinks_get_Hrefs(TElGoogleDataStorageObjectLinksHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectLinks_get_Titles(TElGoogleDataStorageObjectLinksHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectLinks_get_Count(TElGoogleDataStorageObjectLinksHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObjectLinks_Create(TElGoogleDataStorageObjectLinksHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECTLINKS */

#ifdef SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Assign(TElGoogleDataStorageObjectHandle _Handle, TElCustomDataStorageObjectHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Clone(TElGoogleDataStorageObjectHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_ParseEntry(TElGoogleDataStorageObjectHandle _Handle, TElXMLDOMNodeHandle Node);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Clear(TElGoogleDataStorageObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Delete(TElGoogleDataStorageObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Delete_1(TElGoogleDataStorageObjectHandle _Handle, int8_t DeletePermanently);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Exists(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Refresh(TElGoogleDataStorageObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Copy(TElGoogleDataStorageObjectHandle _Handle, const char * pcDestTitle, int32_t szDestTitle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Move(TElGoogleDataStorageObjectHandle _Handle, TElGoogleDataStorageObjectHandle DestFolder);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Write(TElGoogleDataStorageObjectHandle _Handle, TStreamHandle Data, int8_t OverwriteChanges, int8_t Append, const char * pcContentType, int32_t szContentType, TSBGoogleDataStorageEncodingRaw Encoding, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Read(TElGoogleDataStorageObjectHandle _Handle, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Read_1(TElGoogleDataStorageObjectHandle _Handle, TStreamHandle Strm, TSBGoogleDataStorageEncodingRaw Encoding);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Read_2(TElGoogleDataStorageObjectHandle _Handle, TStreamHandle Strm, const char * pcFormat, int32_t szFormat, TSBGoogleDataStorageEncodingRaw Encoding);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_AcquireObject(TElGoogleDataStorageObjectHandle _Handle, const char * pcTitle, int32_t szTitle, TElGoogleDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_ReadObject(TElGoogleDataStorageObjectHandle _Handle, const char * pcTitle, int32_t szTitle, TStreamHandle Strm, const char * pcFormat, int32_t szFormat, TSBGoogleDataStorageEncodingRaw Encoding);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_List(TElGoogleDataStorageObjectHandle _Handle, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_List_1(TElGoogleDataStorageObjectHandle _Handle, const char * pcQuery, int32_t szQuery, int8_t ShowFolders, int8_t ShowDeleted, TSBGoogleEntryOrderRaw OrderBy, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_List_2(TElGoogleDataStorageObjectHandle _Handle, const char * pcQuery, int32_t szQuery, const char * pcAlt, int32_t szAlt, const char * pcAuthor, int32_t szAuthor, int64_t StartIndex, int64_t MaxResults, int64_t UpdatedMin, int64_t UpdatedMax, const char * pcCategory, int32_t szCategory, const char * pcTitle, int32_t szTitle, int8_t ExactTitle, int64_t OpenedMin, int64_t OpenedMax, const char * pcOwner, int32_t szOwner, const char * pcWriter, int32_t szWriter, const char * pcReader, int32_t szReader, int8_t ShowFolders, int8_t ShowDeleted, TSBGoogleEntryOrderRaw OrderBy, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_DeleteObject(TElGoogleDataStorageObjectHandle _Handle, const char * pcTitle, int32_t szTitle, int8_t DeletePermanently);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_ObjectExists(TElGoogleDataStorageObjectHandle _Handle, const char * pcTitle, int32_t szTitle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_CopyObject(TElGoogleDataStorageObjectHandle _Handle, const char * pcSrcTitle, int32_t szSrcTitle, const char * pcDestTitle, int32_t szDestTitle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_MoveObject(TElGoogleDataStorageObjectHandle _Handle, const char * pcTitle, int32_t szTitle, TElGoogleDataStorageObjectHandle DestFolder);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_GetFolder(TElGoogleDataStorageObjectHandle _Handle, TElGoogleDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Folder(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_ObjectType(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_ID(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Title(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Summary(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_ContentSrc(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_ContentType(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_AuthorName(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_AuthorEmail(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Categories(TElGoogleDataStorageObjectHandle _Handle, TElGoogleDataStorageObjectCategoriesHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_PublicationDate(TElGoogleDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_UpdateDate(TElGoogleDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Links(TElGoogleDataStorageObjectHandle _Handle, TElGoogleDataStorageObjectLinksHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_ResourceID(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_CompleteResourceID(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_ResourceType(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_LastModifiedByName(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_LastModifiedByEmail(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_LastViewedDate(TElGoogleDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_QuotaBytesUsed(TElGoogleDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_WritersCanInvite(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Starred(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Trashed(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Hidden(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Viewed(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_Mine(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_PrivateObj(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_SharedWithDomain(TElGoogleDataStorageObjectHandle _Handle, int8_t * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_ContainingFolders(TElGoogleDataStorageObjectHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_ContainingFolders(TElGoogleDataStorageObjectHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_ETag(TElGoogleDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_get_DocType(TElGoogleDataStorageObjectHandle _Handle, TSBGoogleDocTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleDataStorageObject_Create(TElGoogleDataStorageHandle Owner, TElGoogleDataStorageObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOOGLEDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELGOOGLEPREFIXEDPOSTFIXEDUPLOADSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedPostfixedUploadStream_Read(TElGooglePrefixedPostfixedUploadStreamHandle _Handle, void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedPostfixedUploadStream_Write(TElGooglePrefixedPostfixedUploadStreamHandle _Handle, const void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedPostfixedUploadStream_Seek(TElGooglePrefixedPostfixedUploadStreamHandle _Handle, int32_t Offset, uint16_t Origin, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedPostfixedUploadStream_Seek_1(TElGooglePrefixedPostfixedUploadStreamHandle _Handle, int64_t Offset, TSeekOriginRaw Origin, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedPostfixedUploadStream_CreateMultipartRelated(TStreamHandle SourceStream, const char * pcBoundary, int32_t szBoundary, const uint8_t pAtomXmlPart[], int32_t szAtomXmlPart, const char * pcContentType, int32_t szContentType, int64_t Count, int8_t ReleaseSourceStream, TElGooglePrefixedPostfixedUploadStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedPostfixedUploadStream_CreatePrefixed(TStreamHandle SourceStream, const uint8_t pPrefix[], int32_t szPrefix, int64_t Count, int8_t ReleaseSourceStream, TElGooglePrefixedPostfixedUploadStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOOGLEPREFIXEDPOSTFIXEDUPLOADSTREAM */

#ifdef SB_USE_CLASS_TELGOOGLEBASE64ENCODINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64EncodingStream_Read(TElGoogleBase64EncodingStreamHandle _Handle, void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64EncodingStream_Write(TElGoogleBase64EncodingStreamHandle _Handle, const void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64EncodingStream_Seek(TElGoogleBase64EncodingStreamHandle _Handle, int32_t Offset, uint16_t Origin, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64EncodingStream_Seek_1(TElGoogleBase64EncodingStreamHandle _Handle, int64_t Offset, TSeekOriginRaw Origin, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64EncodingStream_Create(TStreamHandle SourceStream, int64_t Count, int32_t LineLen, TSBEOLMarkerRaw EOL, int8_t ReleaseSourceStream, TElGoogleBase64EncodingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOOGLEBASE64ENCODINGSTREAM */

#ifdef SB_USE_CLASS_TELGOOGLEBASE64DECODINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64DecodingStream_Read(TElGoogleBase64DecodingStreamHandle _Handle, void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64DecodingStream_Write(TElGoogleBase64DecodingStreamHandle _Handle, const void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64DecodingStream_Seek(TElGoogleBase64DecodingStreamHandle _Handle, int32_t Offset, uint16_t Origin, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64DecodingStream_Seek_1(TElGoogleBase64DecodingStreamHandle _Handle, int64_t Offset, TSeekOriginRaw Origin, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64DecodingStream_get_DestStream(TElGoogleBase64DecodingStreamHandle _Handle, TStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGoogleBase64DecodingStream_Create(TStreamHandle DestStream, int64_t Count, int8_t ReleaseDestStream, TElGoogleBase64DecodingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOOGLEBASE64DECODINGSTREAM */

#ifdef SB_USE_CLASS_TELGOOGLEPREFIXEDMETADATAPROCESSINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedMetadataProcessingStream_Read(TElGooglePrefixedMetadataProcessingStreamHandle _Handle, void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedMetadataProcessingStream_Write(TElGooglePrefixedMetadataProcessingStreamHandle _Handle, const void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedMetadataProcessingStream_Seek(TElGooglePrefixedMetadataProcessingStreamHandle _Handle, int32_t Offset, uint16_t Origin, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedMetadataProcessingStream_Seek_1(TElGooglePrefixedMetadataProcessingStreamHandle _Handle, int64_t Offset, TSeekOriginRaw Origin, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedMetadataProcessingStream_get_DestStream(TElGooglePrefixedMetadataProcessingStreamHandle _Handle, TStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedMetadataProcessingStream_get_Metadata(TElGooglePrefixedMetadataProcessingStreamHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGooglePrefixedMetadataProcessingStream_Create(TStreamHandle DestStream, const uint8_t pMetadataID[], int32_t szMetadataID, TSBGooglePrefixedMetadataProcessingStreamMetadataFunc pMethodOnMetadata, void * pDataOnMetadata, TNotifyEvent pMethodOnNoMetadata, void * pDataOnNoMetadata, int8_t ReleaseDestStream, TElGooglePrefixedMetadataProcessingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOOGLEPREFIXEDMETADATAPROCESSINGSTREAM */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElGoogleDataStorage_ce_ptr;
extern zend_class_entry *TElGoogleDataStorageObjectCategories_ce_ptr;
extern zend_class_entry *TElGoogleDataStorageObjectLinks_ce_ptr;
extern zend_class_entry *TElGoogleDataStorageObject_ce_ptr;
extern zend_class_entry *TElGooglePrefixedPostfixedUploadStream_ce_ptr;
extern zend_class_entry *TElGoogleBase64EncodingStream_ce_ptr;
extern zend_class_entry *TElGoogleBase64DecodingStream_ce_ptr;
extern zend_class_entry *TElGooglePrefixedMetadataProcessingStream_ce_ptr;

void SB_CALLBACK TSBGoogleAuthAttemptEventRaw(void * _ObjectData, TObjectHandle Sender);
void SB_CALLBACK TSBGoogleAuthCaptchaRequestEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcCaptchaUrl, int32_t szCaptchaUrl, const char * pcPageUrl, int32_t szPageUrl, char * pcCaptcha, int32_t * szCaptcha);
void SB_CALLBACK TSBGoogleAuthAttemptFailedEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcErrorMsg, int32_t szErrorMsg, const char * pcPageUrl, int32_t szPageUrl, int8_t * Cancel);
void SB_CALLBACK TSBGooglePrefixedMetadataProcessingStreamMetadataFuncRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pMetadata[], int32_t szMetadata);
void Register_TElGoogleDataStorage(TSRMLS_D);
void Register_TElGoogleDataStorageObjectCategories(TSRMLS_D);
void Register_TElGoogleDataStorageObjectLinks(TSRMLS_D);
void Register_TElGoogleDataStorageObject(TSRMLS_D);
void Register_TElGooglePrefixedPostfixedUploadStream(TSRMLS_D);
void Register_TElGoogleBase64EncodingStream(TSRMLS_D);
void Register_TElGoogleBase64DecodingStream(TSRMLS_D);
void Register_TElGooglePrefixedMetadataProcessingStream(TSRMLS_D);
void Register_SBGoogleDataStorage_Enum_Flags(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBGOOGLEDATASTORAGE */
