#ifndef __INC_SBSHAREDRESOURCE
#define __INC_SBSHAREDRESOURCE

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbutils.h"
#include "sbtypes.h"
#include "sbrandom.h"
#include "sbconstants.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#ifndef SB_WINDOWS
typedef TElClassHandle TElSemaphoreHandle;
#endif

typedef TElClassHandle TElSharedResourceHandle;

#ifndef SB_WINDOWS
#ifdef SB_USE_CLASS_TELSEMAPHORE
SB_IMPORT uint32_t SB_APIENTRY TElSemaphore_Wait(TElSemaphoreHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSemaphore_Release(TElSemaphoreHandle _Handle, int32_t Count);
SB_IMPORT uint32_t SB_APIENTRY TElSemaphore_get_Count(TElSemaphoreHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSemaphore_Create(TElSemaphoreHandle * OutResult);
#endif /* SB_USE_CLASS_TELSEMAPHORE */
#endif

#ifdef SB_USE_CLASS_TELSHAREDRESOURCE
SB_IMPORT uint32_t SB_APIENTRY TElSharedResource_WaitToRead(TElSharedResourceHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSharedResource_WaitToWrite(TElSharedResourceHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSharedResource_Done(TElSharedResourceHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSharedResource_get_Enabled(TElSharedResourceHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSharedResource_set_Enabled(TElSharedResourceHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSharedResource_Create(TElSharedResourceHandle * OutResult);
#endif /* SB_USE_CLASS_TELSHAREDRESOURCE */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifndef SB_WINDOWS
extern zend_class_entry *TElSemaphore_ce_ptr;
#endif
extern zend_class_entry *TElSharedResource_ce_ptr;

#ifndef SB_WINDOWS
void Register_TElSemaphore(TSRMLS_D);
#endif
void Register_TElSharedResource(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBSHAREDRESOURCE */
