#ifndef __INC_SBSSHFORWARDINGHANDLERS
#define __INC_SBSSHFORWARDINGHANDLERS

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbsshcommon.h"
#include "sbsshhandlers.h"
#include "sbsocket.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElTCPForwardingSSHSubsystemHandlerHandle;

typedef TElTCPForwardingSSHSubsystemHandlerHandle ElTCPForwardingSSHSubsystemHandlerHandle;

typedef TElClassHandle TElClientTCPForwardingSSHSubsystemHandlerHandle;

typedef TElClientTCPForwardingSSHSubsystemHandlerHandle ElClientTCPForwardingSSHSubsystemHandlerHandle;

typedef TElClassHandle TElServerTCPForwardingSSHSubsystemHandlerHandle;

typedef TElServerTCPForwardingSSHSubsystemHandlerHandle ElServerTCPForwardingSSHSubsystemHandlerHandle;

typedef TElClassHandle TElBuiltinTCPForwardingSSHSubsystemHandlerHandle;

typedef TElBuiltinTCPForwardingSSHSubsystemHandlerHandle ElBuiltinTCPForwardingSSHSubsystemHandlerHandle;

typedef TElClassHandle TElBuiltinClientTCPForwardingSSHSubsystemHandlerHandle;

typedef TElBuiltinClientTCPForwardingSSHSubsystemHandlerHandle ElBuiltinClientTCPForwardingSSHSubsystemHandlerHandle;

typedef TElClassHandle TElBuiltinServerTCPForwardingSSHSubsystemHandlerHandle;

typedef TElBuiltinServerTCPForwardingSSHSubsystemHandlerHandle ElBuiltinServerTCPForwardingSSHSubsystemHandlerHandle;

#ifdef SB_USE_CLASS_TELTCPFORWARDINGSSHSUBSYSTEMHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElTCPForwardingSSHSubsystemHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTCPForwardingSSHSubsystemHandler_Create(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElTCPForwardingSSHSubsystemHandler_CreateDelayed(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElClientTCPForwardingSSHSubsystemHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElClientTCPForwardingSSHSubsystemHandler_Create(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElClientTCPForwardingSSHSubsystemHandler_CreateDelayed(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElServerTCPForwardingSSHSubsystemHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElServerTCPForwardingSSHSubsystemHandler_get_Socket(TElServerTCPForwardingSSHSubsystemHandlerHandle _Handle, TElSocketHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElServerTCPForwardingSSHSubsystemHandler_set_Socket(TElServerTCPForwardingSSHSubsystemHandlerHandle _Handle, TElSocketHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElServerTCPForwardingSSHSubsystemHandler_Create(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElServerTCPForwardingSSHSubsystemHandler_CreateDelayed(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELBUILTINTCPFORWARDINGSSHSUBSYSTEMHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinTCPForwardingSSHSubsystemHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinTCPForwardingSSHSubsystemHandler_Create(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinTCPForwardingSSHSubsystemHandler_CreateDelayed(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELBUILTINTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELBUILTINCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinClientTCPForwardingSSHSubsystemHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinClientTCPForwardingSSHSubsystemHandler_Create(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinClientTCPForwardingSSHSubsystemHandler_CreateDelayed(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELBUILTINCLIENTTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef SB_USE_CLASS_TELBUILTINSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinServerTCPForwardingSSHSubsystemHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinServerTCPForwardingSSHSubsystemHandler_get_Socket(TElBuiltinServerTCPForwardingSSHSubsystemHandlerHandle _Handle, TElSocketHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinServerTCPForwardingSSHSubsystemHandler_set_Socket(TElBuiltinServerTCPForwardingSSHSubsystemHandlerHandle _Handle, TElSocketHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinServerTCPForwardingSSHSubsystemHandler_Create(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBuiltinServerTCPForwardingSSHSubsystemHandler_CreateDelayed(TElSSHTunnelConnectionHandle Connection, TElCustomSSHSubsystemHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELBUILTINSERVERTCPFORWARDINGSSHSUBSYSTEMHANDLER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElTCPForwardingSSHSubsystemHandler_ce_ptr;
extern zend_class_entry *TElClientTCPForwardingSSHSubsystemHandler_ce_ptr;
extern zend_class_entry *TElServerTCPForwardingSSHSubsystemHandler_ce_ptr;
extern zend_class_entry *TElBuiltinTCPForwardingSSHSubsystemHandler_ce_ptr;
extern zend_class_entry *TElBuiltinClientTCPForwardingSSHSubsystemHandler_ce_ptr;
extern zend_class_entry *TElBuiltinServerTCPForwardingSSHSubsystemHandler_ce_ptr;

void Register_TElTCPForwardingSSHSubsystemHandler(TSRMLS_D);
void Register_TElClientTCPForwardingSSHSubsystemHandler(TSRMLS_D);
void Register_TElServerTCPForwardingSSHSubsystemHandler(TSRMLS_D);
void Register_TElBuiltinTCPForwardingSSHSubsystemHandler(TSRMLS_D);
void Register_TElBuiltinClientTCPForwardingSSHSubsystemHandler(TSRMLS_D);
void Register_TElBuiltinServerTCPForwardingSSHSubsystemHandler(TSRMLS_D);
void Register_SBSSHForwardingHandlers_Aliases(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBSSHFORWARDINGHANDLERS */

