#ifndef __INC_SBWEBDAVSERVER
#define __INC_SBWEBDAVSERVER

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbconstants.h"
#include "sbstreams.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstringlist.h"
#include "sbx509.h"
#include "sbcustomcertstorage.h"
#include "sbsslcommon.h"
#include "sbsslserver.h"
#include "sbsessionpool.h"
#include "sbxmldefs.h"
#include "sbxmlutils.h"
#include "sbxmlcore.h"
#include "sbxmlcharsets.h"
#include "sbhttpscommon.h"
#include "sbencoding.h"
#include "sbhttpsconstants.h"
#include "sbhttpsserver.h"
#include "sbsharedresource.h"
#include "sbrandom.h"
#include "sbwebdavcommon.h"
#include "sbcustomfsadapter.h"
#include "sbdiskfsadapter.h"
#include "sbhashfunction.h"
#include "sbsrp.h"
#include "sbsslconstants.h"
#include "sbdictionary.h"
#include "sbvcard.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_SServerName 	"EldoS WebDAV Server"
#define SB_SAllowHeader 	"Allow: OPTIONS,PUT,POST,GET,HEAD,DELETE,PROPFIND,PROPPATCH,COPY,MOVE,LOCK,UNLOCK"
#define SB_SMsHeader 	"MS-Author-Via: DAV"
#define SB_SXMLContentType 	"application/xml"
#define SB_SDAV12Header 	"DAV: 1,2,3"
#define SB_SDAV1Header 	"DAV: 1,3"
#define SB_SACLHeader 	",access-control"
#define SB_SCardDAVHeader 	",addressbook"
#define SB_SCalDAVHeader 	",calendar-access"
#define SB_SExtendedMkColHeader 	"DAV: extended-mkcol"
#define SB_SAllowACLHeader 	",REPORT,ACL"
#define SB_SAllowCalDAVHeader 	",MKCALENDAR"
#define SB_SDirContentType 	"httpd/unix-directory"
#define SB_SLockTokenPrefix 	"opaquelocktoken"
#define SB_SSerializeName 	"WebDAVBlackbox"
#define SB_SSerializeNS 	"http://www.eldos.com/sbb/"
#define SB_SLangEn 	"en"
#define SB_SWriteProperties 	"Write properties"
#define SB_SWriteResourceContent 	"Write resource content"
#define SB_SWriteACL 	"Write ACL"
#define SB_SBind 	"Bind"
#define SB_SUnbind 	"Unbind"
#define SB_SReadACL 	"Read ACL"
#define SB_SReadCurrentUserPrivilegeSetProperty 	"Read current user privilege set property"
#define SB_SUnlockResource 	"Unlock resource"
#define SB_SReadAnyObject 	"Read any object"
#define SB_SWriteAnyObject 	"Write any object"
#define SB_SAnyOperation 	"Any operation"
#define SB_wdpCalReadFreeBusy 	256

typedef TElClassHandle TElWebDAVServerHandle;

typedef TElWebDAVServerHandle ElWebDAVServerHandle;

typedef TElClassHandle SBWebDAVServer_TElWebDavPrincipalHandle;

typedef TElClassHandle TElWebDavInMemoryPrincipalHandle;

typedef TElClassHandle TElWebDavPrincipalBackendHandle;

typedef TElClassHandle TElWebDavPrincipalMemoryBackendHandle;

typedef TElClassHandle TElCalDavTextMatchFilterHandle;

typedef TElClassHandle TElCalDavParamFilterHandle;

typedef TElClassHandle TElWebDavTimeRangeBaseHandle;

typedef TElClassHandle TElWebDavTimeRangeHandle;

typedef TElClassHandle TElCalDavPropFilterHandle;

typedef TElClassHandle TElCalDAVCompFilterHandle;

typedef TElClassHandle TElWebDavExtendedRequestHandle;

typedef TElClassHandle TElWebDavAddressBookRequestHandle;

typedef TElClassHandle TElWebDavLimitRecurrenceSetHandle;

typedef TElClassHandle TElWebDavExpandHandle;

typedef TElClassHandle TElWebDavLimitFreeBusySetHandle;

typedef TElClassHandle TElWebDavCompHandle;

typedef TElClassHandle TElWebDavCalendarRequestHandle;

typedef TElClassHandle TElWebDavPropertyHandle;

typedef TElWebDavPropertyHandle ElWebDavPropertyHandle;

typedef TElClassHandle TElWebDavIfStateHandle;

typedef TElWebDavIfStateHandle ElWebDavIfStateHandle;

typedef TElClassHandle TElWebDavIfResourceHandle;

typedef TElWebDavIfResourceHandle ElWebDavIfResourceHandle;

typedef TElClassHandle TElWebDAVIfHeaderHandle;

typedef TElWebDAVIfHeaderHandle ElWebDAVIfHeaderHandle;

typedef TObjectHandle TElWebDavLockFindHandleHandle;

typedef TObjectHandle ElWebDavLockFindHandleHandle;

typedef TElClassHandle TElWebDAVCustomLockListHandle;

typedef TElWebDAVCustomLockListHandle ElWebDAVCustomLockListHandle;

typedef TElClassHandle TElWebDavFindMemoryLockHandleHandle;

typedef TElClassHandle TElWebDAVMemoryLockListHandle;

typedef TElWebDAVMemoryLockListHandle ElWebDAVMemoryLockListHandle;

typedef TElClassHandle TElWebDAVACLOptionsHandle;

typedef TElClassHandle TElCardDAVOptionsHandle;

typedef TElClassHandle TElCalDAVOptionsHandle;

typedef TElClassHandle TElWebDavCollationHandle;

typedef TElClassHandle TElWebDavUnicodeCollationHandle;

typedef TElClassHandle TElWebDavAsciiCollationHandle;

typedef TElClassHandle TElWebDavOctetCollationHandle;

typedef uint8_t TSBWebDavPropfindModeRaw;

typedef enum
{
	pfmProp = 0,
	pfmPropname = 1,
	pfmAllprop = 2
} TSBWebDavPropfindMode;

typedef uint8_t TSBWebDavIfListTypeRaw;

typedef enum
{
	ltNoTagged = 0,
	ltTagged = 1,
	ltUnknown = 2
} TSBWebDavIfListType;

typedef uint8_t TSBWebDavIfStateTypeRaw;

typedef enum
{
	stLockToken = 0,
	stEtag = 1
} TSBWebDavIfStateType;

typedef uint8_t TSBWebDavFileOpenModeRaw;

typedef enum
{
	wdfmOpenRead = 0,
	wdfmOpenWrite = 1
} TSBWebDavFileOpenMode;

typedef void (SB_CALLBACK *TSBWebDavBeforeRequestEvent)(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle Params, int8_t * Accept, int32_t * StatusCode, char * pcReasonPhrase, int32_t * szReasonPhrase);

typedef void (SB_CALLBACK *TSBWebDavRequestEvent)(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle Params, TMemoryStreamHandle Data);

typedef void (SB_CALLBACK *TSBWebDavResponseEvent)(void * _ObjectData, TObjectHandle Sender, TElHTTPServerResponseParamsHandle Params, TMemoryStreamHandle Data);

typedef void (SB_CALLBACK *TSBWebDavStatusCodeEvent)(void * _ObjectData, TObjectHandle Sender, int32_t StatusCode, TElHTTPServerRequestParamsHandle ReqParams, TElHTTPServerResponseParamsHandle RespParams);

typedef void (SB_CALLBACK *TSBWebDavBeforeDownloadEvent)(void * _ObjectData, TObjectHandle Sender, char * pcURL, int32_t * szURL, int8_t * Allow);

typedef void (SB_CALLBACK *TSBWebDavBeforeUploadEvent)(void * _ObjectData, TObjectHandle Sender, char * pcURL, int32_t * szURL, int8_t * Allow);

typedef void (SB_CALLBACK *TSBWebDavTransferFinishedEvent)(void * _ObjectData, TObjectHandle Sender);

typedef void (SB_CALLBACK *TSBWebDavPropertyReadValueEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element, int8_t * Success);

typedef void (SB_CALLBACK *TSBWebDavPropertyReadExValueEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element, TObjectHandle Param, int8_t * Success);

typedef void (SB_CALLBACK *TSBWebDavPropertyAfterReadValueEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element);

typedef void (SB_CALLBACK *TSBWebDavPropertyBeforeWriteValueEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, int8_t * Success);

typedef void (SB_CALLBACK *TSBWebDavPropertyWriteValueEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, const char * pcValue, int32_t szValue, int8_t * Success);

typedef void (SB_CALLBACK *TSBWebDavPropertyRemoveEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, int8_t * Success);

typedef void (SB_CALLBACK *TSBWebDavCheckIfAddressBookEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, int8_t * Success);

typedef void (SB_CALLBACK *TSBWebDavSetAsAddressBookEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int8_t * Success);

typedef void (SB_CALLBACK *TSBWebDavCheckIfCalendarEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, int8_t * Success);

typedef void (SB_CALLBACK *TSBWebDavSetAsCalendarEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int8_t * Success);

typedef void (SB_CALLBACK *TSBWebDavReadPrivilegesEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int32_t * Privileges);

typedef void (SB_CALLBACK *TSBWebDavReadOwnerEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle * Principal);

typedef void (SB_CALLBACK *TSBWebDavReadSupportedPrivilegesEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int32_t * Privileges);

typedef void (SB_CALLBACK *TSBWebDavGetPrivilegeDescriptionEvent)(void * _ObjectData, TObjectHandle Sender, int16_t Privilege, char * pcDescription, int32_t * szDescription, char * pcLanguage, int32_t * szLanguage);

typedef void (SB_CALLBACK *TSBWebDavGetACLRestrictionsEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TElWebDavACLRestrictionsHandle Restrictions);

typedef void (SB_CALLBACK *TSBWebDavGetACLEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TListHandle List, int8_t * OwnList);

typedef void (SB_CALLBACK *TSBWebDavSetACLEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TListHandle List, TSBWebDavACLErrorRaw * Error, int32_t * StatusCode);

#ifdef SB_WINDOWS
typedef void (SB_CALLBACK *TSBWebDavGetURLSetEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TStringListHandle List);
#else
typedef void (SB_CALLBACK *TSBWebDavGetURLSetEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TElStringListHandle List);
#endif

typedef void (SB_CALLBACK *TSBCheckUIDUniquenessEvent)(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TElDirInfoPropertiesListHandle PropList, int8_t * Unique);

#ifdef SB_USE_CLASS_TELWEBDAVSERVER
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_Open(TElWebDAVServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_DataAvailable(TElWebDAVServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_Close(TElWebDAVServerHandle _Handle, int8_t Silent);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_AddProperty(TElWebDAVServerHandle _Handle, const TElWebDavPropertyHandle Prop, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_GetProperty(TElWebDAVServerHandle _Handle, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, TElWebDavPropertyHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_RemoveProperty(TElWebDAVServerHandle _Handle, const TElWebDavPropertyHandle Prop, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_CreateCollection(TElWebDAVServerHandle _Handle, const char * pcURL, int32_t szURL);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_CreateAddressBook(TElWebDAVServerHandle _Handle, const char * pcURL, int32_t szURL, const char * pcDescription, int32_t szDescription, SBWebDAVServer_TElWebDavPrincipalHandle Owner);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_CreateCalendar(TElWebDAVServerHandle _Handle, const char * pcURL, int32_t szURL, const char * pcDescription, int32_t szDescription, SBWebDAVServer_TElWebDavPrincipalHandle Owner);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_PutVCard(TElWebDAVServerHandle _Handle, const char * pcURL, int32_t szURL, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_PutVCard_1(TElWebDAVServerHandle _Handle, const char * pcURL, int32_t szURL, TElVCardHandle VCard);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_PutVCard_2(TElWebDAVServerHandle _Handle, const char * pcURL, int32_t szURL, const char * pcFileName, int32_t szFileName);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_AddCertTypeHandler(TElWebDAVServerHandle _Handle, TElSSLCertificateTypeHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_RemoveCertTypeHandler(TElWebDAVServerHandle _Handle, TElSSLCertificateTypeHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_GetCertTypeHandler(TElWebDAVServerHandle _Handle, TElSSLCertificateTypeRaw CertType, TElSSLCertificateTypeHandlerHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_MIMETypesMap(TElWebDAVServerHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_MIMETypesMap(TElWebDAVServerHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_Properties(TElWebDAVServerHandle _Handle, int32_t Idx, TElWebDavPropertyHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_PropertiesCount(TElWebDAVServerHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_Control(TElWebDAVServerHandle _Handle, TElHTTPSServerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_ACLOptions(TElWebDAVServerHandle _Handle, TElWebDAVACLOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_CardDAVOptions(TElWebDAVServerHandle _Handle, TElCardDAVOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_CalDAVOptions(TElWebDAVServerHandle _Handle, TElCalDAVOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_Active(TElWebDAVServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SSLMode(TElWebDAVServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_SSLMode(TElWebDAVServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SSLClientAuthentication(TElWebDAVServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_SSLClientAuthentication(TElWebDAVServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SSLAuthenticationLevel(TElWebDAVServerHandle _Handle, TSBAuthenticationLevelRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_SSLAuthenticationLevel(TElWebDAVServerHandle _Handle, TSBAuthenticationLevelRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SSLForceCertificateChain(TElWebDAVServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_SSLForceCertificateChain(TElWebDAVServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_CertStorage(TElWebDAVServerHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_CertStorage(TElWebDAVServerHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SSLSessionPool(TElWebDAVServerHandle _Handle, TElSessionPoolHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_SSLSessionPool(TElWebDAVServerHandle _Handle, TElSessionPoolHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_ClientCertStorage(TElWebDAVServerHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_ClientCertStorage(TElWebDAVServerHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SSLVersions(TElWebDAVServerHandle _Handle, TSBVersionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_SSLVersions(TElWebDAVServerHandle _Handle, TSBVersionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SSLExtensions(TElWebDAVServerHandle _Handle, TElServerSSLExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SSLPeerExtensions(TElWebDAVServerHandle _Handle, TElCustomSSLExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SSLSRPCredentialStore(TElWebDAVServerHandle _Handle, TElSRPCredentialStoreHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_SSLSRPCredentialStore(TElWebDAVServerHandle _Handle, TElSRPCredentialStoreHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_FileSystemAdapter(TElWebDAVServerHandle _Handle, TElCustomFileSystemAdapterHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_FileSystemAdapter(TElWebDAVServerHandle _Handle, TElCustomFileSystemAdapterHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_GlobalLockList(TElWebDAVServerHandle _Handle, TElWebDAVCustomLockListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_GlobalLockList(TElWebDAVServerHandle _Handle, TElWebDAVCustomLockListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_SendBufferSize(TElWebDAVServerHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_SendBufferSize(TElWebDAVServerHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_DefaultLockTimeout(TElWebDAVServerHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_DefaultLockTimeout(TElWebDAVServerHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_AllowInfinity(TElWebDAVServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_AllowInfinity(TElWebDAVServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_PublishExclusiveLocks(TElWebDAVServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_PublishExclusiveLocks(TElWebDAVServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_PublishSharedLocks(TElWebDAVServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_PublishSharedLocks(TElWebDAVServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_ResponseContentType(TElWebDAVServerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_ResponseContentType(TElWebDAVServerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_MicrosoftCompatible(TElWebDAVServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_MicrosoftCompatible(TElWebDAVServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_ServerName(TElWebDAVServerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_ServerName(TElWebDAVServerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_UseWellKnownURIs(TElWebDAVServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_UseWellKnownURIs(TElWebDAVServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnGetSrpDb(TElWebDAVServerHandle _Handle, TSBServerSrpDbNeededEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnGetSrpDb(TElWebDAVServerHandle _Handle, TSBServerSrpDbNeededEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnBeforeRequest(TElWebDAVServerHandle _Handle, TSBWebDavBeforeRequestEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnBeforeRequest(TElWebDAVServerHandle _Handle, TSBWebDavBeforeRequestEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnRequest(TElWebDAVServerHandle _Handle, TSBWebDavRequestEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnRequest(TElWebDAVServerHandle _Handle, TSBWebDavRequestEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnResponse(TElWebDAVServerHandle _Handle, TSBWebDavResponseEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnResponse(TElWebDAVServerHandle _Handle, TSBWebDavResponseEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnStatusCode(TElWebDAVServerHandle _Handle, TSBWebDavStatusCodeEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnStatusCode(TElWebDAVServerHandle _Handle, TSBWebDavStatusCodeEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnBeforeUpload(TElWebDAVServerHandle _Handle, TSBWebDavBeforeUploadEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnBeforeUpload(TElWebDAVServerHandle _Handle, TSBWebDavBeforeUploadEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnBeforeDownload(TElWebDAVServerHandle _Handle, TSBWebDavBeforeDownloadEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnBeforeDownload(TElWebDAVServerHandle _Handle, TSBWebDavBeforeDownloadEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnTransferFinished(TElWebDAVServerHandle _Handle, TSBWebDavTransferFinishedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnTransferFinished(TElWebDAVServerHandle _Handle, TSBWebDavTransferFinishedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnGetUserPassword(TElWebDAVServerHandle _Handle, TSBOnGetUserPasswordEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnGetUserPassword(TElWebDAVServerHandle _Handle, TSBOnGetUserPasswordEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnSend(TElWebDAVServerHandle _Handle, TSBSendEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnSend(TElWebDAVServerHandle _Handle, TSBSendEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnReceive(TElWebDAVServerHandle _Handle, TSBReceiveEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnReceive(TElWebDAVServerHandle _Handle, TSBReceiveEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnOpenConnection(TElWebDAVServerHandle _Handle, TSBOpenConnectionEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnOpenConnection(TElWebDAVServerHandle _Handle, TSBOpenConnectionEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnCertificateValidate(TElWebDAVServerHandle _Handle, TSBCertificateValidateEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnCertificateValidate(TElWebDAVServerHandle _Handle, TSBCertificateValidateEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnCiphersNegotiated(TElWebDAVServerHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnCiphersNegotiated(TElWebDAVServerHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnSSLError(TElWebDAVServerHandle _Handle, TSBErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnSSLError(TElWebDAVServerHandle _Handle, TSBErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnExtensionsReceived(TElWebDAVServerHandle _Handle, TSBExtensionsReceivedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnExtensionsReceived(TElWebDAVServerHandle _Handle, TSBExtensionsReceivedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnExtensionsPrepared(TElWebDAVServerHandle _Handle, TSBExtensionsPreparedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnExtensionsPrepared(TElWebDAVServerHandle _Handle, TSBExtensionsPreparedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnKeyNeeded(TElWebDAVServerHandle _Handle, TSBServerKeyNeededEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnKeyNeeded(TElWebDAVServerHandle _Handle, TSBServerKeyNeededEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnCloseConnection(TElWebDAVServerHandle _Handle, TSBCloseConnectionEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnCloseConnection(TElWebDAVServerHandle _Handle, TSBCloseConnectionEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnRenegotiationStart(TElWebDAVServerHandle _Handle, TSBRenegotiationStartEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnRenegotiationStart(TElWebDAVServerHandle _Handle, TSBRenegotiationStartEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_get_OnCertificateURLs(TElWebDAVServerHandle _Handle, TSBCertificateURLsEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_set_OnCertificateURLs(TElWebDAVServerHandle _Handle, TSBCertificateURLsEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVServer_Create(TComponentHandle AOwner, TElWebDAVServerHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVSERVER */

#ifdef SB_USE_CLASS_SBWEBDAVSERVER_TELWEBDAVPRINCIPAL
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_MemberOf(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, const char * pcURL, int32_t szURL, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_AddToGroup(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_Username(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_set_Username(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_DisplayName(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_set_DisplayName(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_URL(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_set_URL(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, const char * pcValue, int32_t szValue);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_AlternateURISet(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, TStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_Groups(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_AlternateURISet(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, TElStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_Groups(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_IsGroup(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_set_IsGroup(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_Address(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_set_Address(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_get_ETag(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_set_ETag(SBWebDAVServer_TElWebDavPrincipalHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_TElWebDavPrincipal_Create(SBWebDAVServer_TElWebDavPrincipalHandle * OutResult);
#endif /* SB_USE_CLASS_SBWEBDAVSERVER_TELWEBDAVPRINCIPAL */

#ifdef SB_USE_CLASS_TELWEBDAVINMEMORYPRINCIPAL
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElWebDavInMemoryPrincipal_get_AddressBookHomeSet(TElWebDavInMemoryPrincipalHandle _Handle, TStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavInMemoryPrincipal_get_CalendarHomeSet(TElWebDavInMemoryPrincipalHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElWebDavInMemoryPrincipal_get_AddressBookHomeSet(TElWebDavInMemoryPrincipalHandle _Handle, TElStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavInMemoryPrincipal_get_CalendarHomeSet(TElWebDavInMemoryPrincipalHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElWebDavInMemoryPrincipal_Create(TElWebDavInMemoryPrincipalHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVINMEMORYPRINCIPAL */

#ifdef SB_USE_CLASS_TELWEBDAVPRINCIPALBACKEND
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_BeginRead(TElWebDavPrincipalBackendHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_BeginWrite(TElWebDavPrincipalBackendHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_Done(TElWebDavPrincipalBackendHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_AddPrincipal(TElWebDavPrincipalBackendHandle _Handle, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_RemovePrincipal(TElWebDavPrincipalBackendHandle _Handle, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_RemovePrincipal_1(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_PrincipalExists(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_FindPrincipalByURL(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_FindPrincipalByName(TElWebDavPrincipalBackendHandle _Handle, const char * pcName, int32_t szName, SBWebDAVServer_TElWebDavPrincipalHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetGroupMemberSet(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetGroupMembership(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetPrincipalCollectionSet(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetPrincipalAddressBookHomeSet(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetPrincipalCalendarHomeSet(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_EnumPrincipals(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetGroupMemberSet(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetGroupMembership(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetPrincipalCollectionSet(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetPrincipalAddressBookHomeSet(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_GetPrincipalCalendarHomeSet(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_EnumPrincipals(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_CollectionExists(TElWebDavPrincipalBackendHandle _Handle, const char * pcURL, int32_t szURL, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalBackend_Create(TElWebDavPrincipalBackendHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVPRINCIPALBACKEND */

#ifdef SB_USE_CLASS_TELWEBDAVPRINCIPALMEMORYBACKEND
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_BeginRead(TElWebDavPrincipalMemoryBackendHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_BeginWrite(TElWebDavPrincipalMemoryBackendHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_Done(TElWebDavPrincipalMemoryBackendHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_AddPrincipal(TElWebDavPrincipalMemoryBackendHandle _Handle, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_RemovePrincipal(TElWebDavPrincipalMemoryBackendHandle _Handle, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_RemovePrincipal_1(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_PrincipalExists(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_FindPrincipalByURL(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_FindPrincipalByName(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcName, int32_t szName, SBWebDAVServer_TElWebDavPrincipalHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetGroupMemberSet(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetGroupMembership(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetPrincipalCollectionSet(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetPrincipalAddressBookHomeSet(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetPrincipalCalendarHomeSet(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_EnumPrincipals(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TStringListHandle List, int8_t * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetGroupMemberSet(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetGroupMembership(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetPrincipalCollectionSet(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetPrincipalAddressBookHomeSet(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_GetPrincipalCalendarHomeSet(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_EnumPrincipals(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcURL, int32_t szURL, TElStringListHandle List, int8_t * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_get_CardDAVPrefix(TElWebDavPrincipalMemoryBackendHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_set_CardDAVPrefix(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_get_CalDAVPrefix(TElWebDavPrincipalMemoryBackendHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_set_CalDAVPrefix(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_get_PrincipalBaseURL(TElWebDavPrincipalMemoryBackendHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_set_PrincipalBaseURL(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_get_GroupBaseURL(TElWebDavPrincipalMemoryBackendHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_set_GroupBaseURL(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_get_ContactFileName(TElWebDavPrincipalMemoryBackendHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_set_ContactFileName(TElWebDavPrincipalMemoryBackendHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavPrincipalMemoryBackend_Create(TElWebDavPrincipalMemoryBackendHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVPRINCIPALMEMORYBACKEND */

#ifdef SB_USE_CLASS_TELCALDAVTEXTMATCHFILTER
SB_IMPORT uint32_t SB_APIENTRY TElCalDavTextMatchFilter_Create(TElWebDavFilterHandle Parent, TElCalDavTextMatchFilterHandle * OutResult);
#endif /* SB_USE_CLASS_TELCALDAVTEXTMATCHFILTER */

#ifdef SB_USE_CLASS_TELCALDAVPARAMFILTER
SB_IMPORT uint32_t SB_APIENTRY TElCalDavParamFilter_LoadFromXML(TElCalDavParamFilterHandle _Handle, TElXMLDOMElementHandle Element, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDavParamFilter_get_IsNotDefined(TElCalDavParamFilterHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDavParamFilter_get_TextMatch(TElCalDavParamFilterHandle _Handle, TElCalDavTextMatchFilterHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDavParamFilter_Create(TElWebDavFilterHandle Parent, TElCalDavParamFilterHandle * OutResult);
#endif /* SB_USE_CLASS_TELCALDAVPARAMFILTER */

#ifdef SB_USE_CLASS_TELWEBDAVTIMERANGEBASE
SB_IMPORT uint32_t SB_APIENTRY TElWebDavTimeRangeBase_LoadFromXML(TElWebDavTimeRangeBaseHandle _Handle, TElXMLDOMElementHandle Element, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavTimeRangeBase_get_Start(TElWebDavTimeRangeBaseHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavTimeRangeBase_get_End_(TElWebDavTimeRangeBaseHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavTimeRangeBase_Create(TElWebDavTimeRangeBaseHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVTIMERANGEBASE */

#ifdef SB_USE_CLASS_TELWEBDAVTIMERANGE
SB_IMPORT uint32_t SB_APIENTRY TElWebDavTimeRange_Create(TElWebDavTimeRangeBaseHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVTIMERANGE */

#ifdef SB_USE_CLASS_TELCALDAVPROPFILTER
SB_IMPORT uint32_t SB_APIENTRY TElCalDavPropFilter_LoadFromXML(TElCalDavPropFilterHandle _Handle, TElXMLDOMElementHandle Element, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDavPropFilter_get_SubFilters(TElCalDavPropFilterHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDavPropFilter_get_IsNotDefined(TElCalDavPropFilterHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDavPropFilter_get_TimeRange(TElCalDavPropFilterHandle _Handle, TElWebDavTimeRangeHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDavPropFilter_get_TextMatch(TElCalDavPropFilterHandle _Handle, TElCalDavTextMatchFilterHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDavPropFilter_Create(TElWebDavFilterHandle Parent, TElCalDavPropFilterHandle * OutResult);
#endif /* SB_USE_CLASS_TELCALDAVPROPFILTER */

#ifdef SB_USE_CLASS_TELCALDAVCOMPFILTER
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVCompFilter_LoadFromXML(TElCalDAVCompFilterHandle _Handle, TElXMLDOMElementHandle Element, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVCompFilter_get_SubFilters(TElCalDAVCompFilterHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVCompFilter_get_IsNotDefined(TElCalDAVCompFilterHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVCompFilter_get_TimeRange(TElCalDAVCompFilterHandle _Handle, TElWebDavTimeRangeHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVCompFilter_Create(TElWebDavFilterHandle Parent, TElCalDAVCompFilterHandle * OutResult);
#endif /* SB_USE_CLASS_TELCALDAVCOMPFILTER */

#ifdef SB_USE_CLASS_TELWEBDAVEXTENDEDREQUEST
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_LoadFromXML(TElWebDavExtendedRequestHandle _Handle, TElXMLDOMElementHandle Element, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_get_ReportName(TElWebDavExtendedRequestHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_set_ReportName(TElWebDavExtendedRequestHandle _Handle, const char * pcValue, int32_t szValue);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_get_Hrefs(TElWebDavExtendedRequestHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_get_Hrefs(TElWebDavExtendedRequestHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_get_AllProp(TElWebDavExtendedRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_set_AllProp(TElWebDavExtendedRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_get_EvaluationResult(TElWebDavExtendedRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_set_EvaluationResult(TElWebDavExtendedRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExtendedRequest_Create(TElWebDavExtendedRequestHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVEXTENDEDREQUEST */

#ifdef SB_USE_CLASS_TELWEBDAVADDRESSBOOKREQUEST
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAddressBookRequest_LoadFromXML(TElWebDavAddressBookRequestHandle _Handle, TElXMLDOMElementHandle Element, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAddressBookRequest_get_Test(TElWebDavAddressBookRequestHandle _Handle, TSBWebDavFilterTestRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAddressBookRequest_set_Test(TElWebDavAddressBookRequestHandle _Handle, TSBWebDavFilterTestRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAddressBookRequest_get_Filters(TElWebDavAddressBookRequestHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAddressBookRequest_get_Limit(TElWebDavAddressBookRequestHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAddressBookRequest_set_Limit(TElWebDavAddressBookRequestHandle _Handle, int32_t Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAddressBookRequest_get_Names(TElWebDavAddressBookRequestHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAddressBookRequest_get_Names(TElWebDavAddressBookRequestHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAddressBookRequest_Create(TElWebDavAddressBookRequestHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVADDRESSBOOKREQUEST */

#ifdef SB_USE_CLASS_TELWEBDAVLIMITRECURRENCESET
SB_IMPORT uint32_t SB_APIENTRY TElWebDavLimitRecurrenceSet_Create(TElWebDavTimeRangeBaseHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVLIMITRECURRENCESET */

#ifdef SB_USE_CLASS_TELWEBDAVEXPAND
SB_IMPORT uint32_t SB_APIENTRY TElWebDavExpand_Create(TElWebDavTimeRangeBaseHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVEXPAND */

#ifdef SB_USE_CLASS_TELWEBDAVLIMITFREEBUSYSET
SB_IMPORT uint32_t SB_APIENTRY TElWebDavLimitFreeBusySet_Create(TElWebDavTimeRangeBaseHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVLIMITFREEBUSYSET */

#ifdef SB_USE_CLASS_TELWEBDAVCOMP
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_LoadFromXML(TElWebDavCompHandle _Handle, TElXMLDOMElementHandle Element, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_get_Parent(TElWebDavCompHandle _Handle, TElWebDavCompHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_get_Name(TElWebDavCompHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_set_Name(TElWebDavCompHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_get_AllProp(TElWebDavCompHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_set_AllProp(TElWebDavCompHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_get_AllComp(TElWebDavCompHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_set_AllComp(TElWebDavCompHandle _Handle, int8_t Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_get_Props(TElWebDavCompHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_get_Props(TElWebDavCompHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_get_Comps(TElWebDavCompHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_get_FullPath(TElWebDavCompHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavComp_Create(TElWebDavCompHandle Parent, TElWebDavCompHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVCOMP */

#ifdef SB_USE_CLASS_TELWEBDAVCALENDARREQUEST
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCalendarRequest_LoadFromXML(TElWebDavCalendarRequestHandle _Handle, TElXMLDOMElementHandle Element, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCalendarRequest_get_CompFilter(TElWebDavCalendarRequestHandle _Handle, TElCalDAVCompFilterHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCalendarRequest_get_Timezone(TElWebDavCalendarRequestHandle _Handle, TElVCalendarHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCalendarRequest_get_Comp(TElWebDavCalendarRequestHandle _Handle, TElWebDavCompHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCalendarRequest_get_Expand(TElWebDavCalendarRequestHandle _Handle, TElWebDavExpandHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCalendarRequest_get_LimitRecurrenceSet(TElWebDavCalendarRequestHandle _Handle, TElWebDavLimitRecurrenceSetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCalendarRequest_get_LimitFreebusySet(TElWebDavCalendarRequestHandle _Handle, TElWebDavLimitFreeBusySetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCalendarRequest_Create(TElWebDavCalendarRequestHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVCALENDARREQUEST */

#ifdef SB_USE_CLASS_TELWEBDAVPROPERTY
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_Write(TElWebDavPropertyHandle _Handle, const char * pcURL, int32_t szURL, const char * pcValue, int32_t szValue, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_Read(TElWebDavPropertyHandle _Handle, const char * pcURL, int32_t szURL, char * pcValue, int32_t * szValue, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_Read_1(TElWebDavPropertyHandle _Handle, const char * pcURL, int32_t szURL, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element, TObjectHandle Param, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_Remove(TElWebDavPropertyHandle _Handle, const char * pcURL, int32_t szURL, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_NS(TElWebDavPropertyHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_Name(TElWebDavPropertyHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_Live(TElWebDavPropertyHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_Protect(TElWebDavPropertyHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_AsXML(TElWebDavPropertyHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_PrincipalMatch(TElWebDavPropertyHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_Principal(TElWebDavPropertyHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_AddressBook(TElWebDavPropertyHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_Calendar(TElWebDavPropertyHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_Copy(TElWebDavPropertyHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_Search(TElWebDavPropertyHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_set_Search(TElWebDavPropertyHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_Description(TElWebDavPropertyHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_set_Description(TElWebDavPropertyHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_DescLang(TElWebDavPropertyHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_set_DescLang(TElWebDavPropertyHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_OnReadValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyReadValueEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_set_OnReadValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyReadValueEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_OnReadExValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyReadExValueEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_set_OnReadExValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyReadExValueEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_OnWriteValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyWriteValueEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_set_OnWriteValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyWriteValueEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_OnAfterReadValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyAfterReadValueEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_set_OnAfterReadValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyAfterReadValueEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_OnBeforeWriteValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyBeforeWriteValueEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_set_OnBeforeWriteValue(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyBeforeWriteValueEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_get_OnRemove(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyRemoveEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_set_OnRemove(TElWebDavPropertyHandle _Handle, TSBWebDavPropertyRemoveEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavProperty_Create(TElWebDAVServerHandle Server, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, int8_t Live, int8_t Protect, int8_t AsXML, int8_t PrincipalMatch, int8_t Principal, int8_t AddressBook, int8_t Calendar, int8_t Copy, TElWebDavPropertyHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVPROPERTY */

#ifdef SB_USE_CLASS_TELWEBDAVIFSTATE
SB_IMPORT uint32_t SB_APIENTRY TElWebDavIfState_get_AType(TElWebDavIfStateHandle _Handle, TSBWebDavIfStateTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavIfState_get_Condition(TElWebDavIfStateHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavIfState_get_Value(TElWebDavIfStateHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavIfState_Create(TSBWebDavIfStateTypeRaw AType, int8_t Condition, const char * pcValue, int32_t szValue, TElWebDavIfStateHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVIFSTATE */

#ifdef SB_USE_CLASS_TELWEBDAVIFRESOURCE
SB_IMPORT uint32_t SB_APIENTRY TElWebDavIfResource_get_URI(TElWebDavIfResourceHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavIfResource_get_States(TElWebDavIfResourceHandle _Handle, int32_t Idx, TElWebDavIfStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavIfResource_get_Count(TElWebDavIfResourceHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavIfResource_Create(const char * pcURI, int32_t szURI, TElWebDavIfResourceHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVIFRESOURCE */

#ifdef SB_USE_CLASS_TELWEBDAVIFHEADER
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVIfHeader_Process(TElWebDAVIfHeaderHandle _Handle, const char * pcS, int32_t szS, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVIfHeader_get_URL(TElWebDAVIfHeaderHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVIfHeader_get_Resources(TElWebDAVIfHeaderHandle _Handle, int32_t Idx, TElWebDavIfResourceHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVIfHeader_get_Count(TElWebDAVIfHeaderHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVIfHeader_Create(const char * pcURL, int32_t szURL, TElWebDAVIfHeaderHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVIFHEADER */

#ifdef SB_USE_CLASS_TELWEBDAVCUSTOMLOCKLIST
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_Enter(TElWebDAVCustomLockListHandle _Handle, int8_t ReadOnly);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_Done(TElWebDAVCustomLockListHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_Add(TElWebDAVCustomLockListHandle _Handle, const TElWebDAVLockHandle Lock);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_Remove(TElWebDAVCustomLockListHandle _Handle, const TElWebDAVLockHandle Lock);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_Find(TElWebDAVCustomLockListHandle _Handle, const char * pcToken, int32_t szToken, TElWebDAVLockHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_FindAll(TElWebDAVCustomLockListHandle _Handle, const char * pcURL, int32_t szURL, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_FindFirst(TElWebDAVCustomLockListHandle _Handle, TObjectHandle * Handle, const char * pcURL, int32_t szURL, TElWebDAVLockHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_FindNext(TElWebDAVCustomLockListHandle _Handle, TObjectHandle Handle, TElWebDAVLockHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_FindClose(TElWebDAVCustomLockListHandle _Handle, TObjectHandle Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_LoadFromStream(TElWebDAVCustomLockListHandle _Handle, TStreamHandle Stream, int8_t Clear);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_SaveToStream(TElWebDAVCustomLockListHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_get_Locks(TElWebDAVCustomLockListHandle _Handle, int32_t Idx, TElWebDAVLockHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_get_Count(TElWebDAVCustomLockListHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVCustomLockList_Create(TComponentHandle AOwner, TElWebDAVCustomLockListHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVCUSTOMLOCKLIST */

#ifdef SB_USE_CLASS_TELWEBDAVFINDMEMORYLOCKHANDLE
SB_IMPORT uint32_t SB_APIENTRY TElWebDavFindMemoryLockHandle_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVFINDMEMORYLOCKHANDLE */

#ifdef SB_USE_CLASS_TELWEBDAVMEMORYLOCKLIST
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_Enter(TElWebDAVMemoryLockListHandle _Handle, int8_t ReadOnly);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_Done(TElWebDAVMemoryLockListHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_Add(TElWebDAVMemoryLockListHandle _Handle, const TElWebDAVLockHandle Lock);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_Remove(TElWebDAVMemoryLockListHandle _Handle, const TElWebDAVLockHandle Lock);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_Find(TElWebDAVMemoryLockListHandle _Handle, const char * pcToken, int32_t szToken, TElWebDAVLockHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_FindAll(TElWebDAVMemoryLockListHandle _Handle, const char * pcURL, int32_t szURL, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_FindFirst(TElWebDAVMemoryLockListHandle _Handle, TObjectHandle * Handle, const char * pcURL, int32_t szURL, TElWebDAVLockHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_FindNext(TElWebDAVMemoryLockListHandle _Handle, TObjectHandle Handle, TElWebDAVLockHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_FindClose(TElWebDAVMemoryLockListHandle _Handle, TObjectHandle Handle);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_LoadFromStream(TElWebDAVMemoryLockListHandle _Handle, TStreamHandle Stream, int8_t Clear);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_SaveToStream(TElWebDAVMemoryLockListHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_Cleanup(TElWebDAVMemoryLockListHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_get_Locks(TElWebDAVMemoryLockListHandle _Handle, int32_t Idx, TElWebDAVLockHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_get_Count(TElWebDAVMemoryLockListHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVMemoryLockList_Create(TComponentHandle AOwner, TElWebDAVMemoryLockListHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVMEMORYLOCKLIST */

#ifdef SB_USE_CLASS_TELWEBDAVACLOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_UseACL(TElWebDAVACLOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_UseACL(TElWebDAVACLOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_PrincipalBackend(TElWebDAVACLOptionsHandle _Handle, TElWebDavPrincipalBackendHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_PrincipalBackend(TElWebDAVACLOptionsHandle _Handle, TElWebDavPrincipalBackendHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_AbstractPrivileges(TElWebDAVACLOptionsHandle _Handle, int16_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_AbstractPrivileges(TElWebDAVACLOptionsHandle _Handle, const int16_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_MatchingPrincipalsLimit(TElWebDAVACLOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_MatchingPrincipalsLimit(TElWebDAVACLOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_OnReadCurrentUserPrivileges(TElWebDAVACLOptionsHandle _Handle, TSBWebDavReadPrivilegesEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_OnReadCurrentUserPrivileges(TElWebDAVACLOptionsHandle _Handle, TSBWebDavReadPrivilegesEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_OnReadSupportedPrivileges(TElWebDAVACLOptionsHandle _Handle, TSBWebDavReadSupportedPrivilegesEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_OnReadSupportedPrivileges(TElWebDAVACLOptionsHandle _Handle, TSBWebDavReadSupportedPrivilegesEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_OnReadOwner(TElWebDAVACLOptionsHandle _Handle, TSBWebDavReadOwnerEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_OnReadOwner(TElWebDAVACLOptionsHandle _Handle, TSBWebDavReadOwnerEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_OnGetPrivilegeDescription(TElWebDAVACLOptionsHandle _Handle, TSBWebDavGetPrivilegeDescriptionEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_OnGetPrivilegeDescription(TElWebDAVACLOptionsHandle _Handle, TSBWebDavGetPrivilegeDescriptionEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_OnGetACLRestrictions(TElWebDAVACLOptionsHandle _Handle, TSBWebDavGetACLRestrictionsEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_OnGetACLRestrictions(TElWebDAVACLOptionsHandle _Handle, TSBWebDavGetACLRestrictionsEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_OnGetACL(TElWebDAVACLOptionsHandle _Handle, TSBWebDavGetACLEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_OnGetACL(TElWebDAVACLOptionsHandle _Handle, TSBWebDavGetACLEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_OnSetACL(TElWebDAVACLOptionsHandle _Handle, TSBWebDavSetACLEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_OnSetACL(TElWebDAVACLOptionsHandle _Handle, TSBWebDavSetACLEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_get_OnGetInheritedACLSet(TElWebDAVACLOptionsHandle _Handle, TSBWebDavGetURLSetEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_set_OnGetInheritedACLSet(TElWebDAVACLOptionsHandle _Handle, TSBWebDavGetURLSetEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElWebDAVACLOptions_Create(TElWebDAVACLOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVACLOPTIONS */

#ifdef SB_USE_CLASS_TELCARDDAVOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_get_UseCardDAV(TElCardDAVOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_set_UseCardDAV(TElCardDAVOptionsHandle _Handle, int8_t Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_get_AddressBookURLs(TElCardDAVOptionsHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_get_AddressBookURLs(TElCardDAVOptionsHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_get_MaxResourceSize(TElCardDAVOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_set_MaxResourceSize(TElCardDAVOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_get_NumberOfMatchesLimit(TElCardDAVOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_set_NumberOfMatchesLimit(TElCardDAVOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_get_AllowExtendedMkCol(TElCardDAVOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_set_AllowExtendedMkCol(TElCardDAVOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_get_OnCheckIfAddressBook(TElCardDAVOptionsHandle _Handle, TSBWebDavCheckIfAddressBookEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_set_OnCheckIfAddressBook(TElCardDAVOptionsHandle _Handle, TSBWebDavCheckIfAddressBookEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_get_OnSetAsAddressBook(TElCardDAVOptionsHandle _Handle, TSBWebDavSetAsAddressBookEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_set_OnSetAsAddressBook(TElCardDAVOptionsHandle _Handle, TSBWebDavSetAsAddressBookEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_get_OnCheckUIDUniqueness(TElCardDAVOptionsHandle _Handle, TSBCheckUIDUniquenessEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_set_OnCheckUIDUniqueness(TElCardDAVOptionsHandle _Handle, TSBCheckUIDUniquenessEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElCardDAVOptions_Create(TElCardDAVOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELCARDDAVOPTIONS */

#ifdef SB_USE_CLASS_TELCALDAVOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_get_UseCalDAV(TElCalDAVOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_set_UseCalDAV(TElCalDAVOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_get_MaxResourceSize(TElCalDAVOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_set_MaxResourceSize(TElCalDAVOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_get_MinDateTime(TElCalDAVOptionsHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_set_MinDateTime(TElCalDAVOptionsHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_get_MaxDateTime(TElCalDAVOptionsHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_set_MaxDateTime(TElCalDAVOptionsHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_get_MaxRecurrenceInstances(TElCalDAVOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_set_MaxRecurrenceInstances(TElCalDAVOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_get_MaxAttendeesPerInstance(TElCalDAVOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_set_MaxAttendeesPerInstance(TElCalDAVOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_get_OnCheckIfCalendar(TElCalDAVOptionsHandle _Handle, TSBWebDavCheckIfCalendarEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_set_OnCheckIfCalendar(TElCalDAVOptionsHandle _Handle, TSBWebDavCheckIfCalendarEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_get_OnSetAsCalendar(TElCalDAVOptionsHandle _Handle, TSBWebDavSetAsCalendarEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_set_OnSetAsCalendar(TElCalDAVOptionsHandle _Handle, TSBWebDavSetAsCalendarEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_get_OnCheckUIDUniqueness(TElCalDAVOptionsHandle _Handle, TSBCheckUIDUniquenessEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_set_OnCheckUIDUniqueness(TElCalDAVOptionsHandle _Handle, TSBCheckUIDUniquenessEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElCalDAVOptions_Create(TElCalDAVOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELCALDAVOPTIONS */

#ifdef SB_USE_CLASS_TELWEBDAVCOLLATION
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCollation_CreateInstance(TSBWebDavFilterTextMatchCollationRaw Collation, TElWebDavCollationHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCollation_CreateInstance_1(TElWebDavCollationHandle _Handle, TSBWebDavFilterTextMatchCollationRaw Collation, TElWebDavCollationHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCollation_Compare(TElWebDavCollationHandle _Handle, const char * pcS1, int32_t szS1, const char * pcS2, int32_t szS2, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCollation_StartsWith(TElWebDavCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCollation_EndsWith(TElWebDavCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCollation_Equals(TElWebDavCollationHandle _Handle, const char * pcS1, int32_t szS1, const char * pcS2, int32_t szS2, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCollation_IndexOf(TElWebDavCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavCollation_Create(TElWebDavCollationHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVCOLLATION */

#ifdef SB_USE_CLASS_TELWEBDAVUNICODECOLLATION
SB_IMPORT uint32_t SB_APIENTRY TElWebDavUnicodeCollation_Compare(TElWebDavUnicodeCollationHandle _Handle, const char * pcS1, int32_t szS1, const char * pcS2, int32_t szS2, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavUnicodeCollation_StartsWith(TElWebDavUnicodeCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavUnicodeCollation_EndsWith(TElWebDavUnicodeCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavUnicodeCollation_Equals(TElWebDavUnicodeCollationHandle _Handle, const char * pcS1, int32_t szS1, const char * pcS2, int32_t szS2, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavUnicodeCollation_IndexOf(TElWebDavUnicodeCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavUnicodeCollation_Create(TElWebDavUnicodeCollationHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVUNICODECOLLATION */

#ifdef SB_USE_CLASS_TELWEBDAVASCIICOLLATION
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAsciiCollation_Compare(TElWebDavAsciiCollationHandle _Handle, const char * pcS1, int32_t szS1, const char * pcS2, int32_t szS2, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAsciiCollation_StartsWith(TElWebDavAsciiCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAsciiCollation_EndsWith(TElWebDavAsciiCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAsciiCollation_Equals(TElWebDavAsciiCollationHandle _Handle, const char * pcS1, int32_t szS1, const char * pcS2, int32_t szS2, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAsciiCollation_IndexOf(TElWebDavAsciiCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavAsciiCollation_Create(TElWebDavAsciiCollationHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVASCIICOLLATION */

#ifdef SB_USE_CLASS_TELWEBDAVOCTETCOLLATION
SB_IMPORT uint32_t SB_APIENTRY TElWebDavOctetCollation_Compare(TElWebDavOctetCollationHandle _Handle, const char * pcS1, int32_t szS1, const char * pcS2, int32_t szS2, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavOctetCollation_StartsWith(TElWebDavOctetCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavOctetCollation_EndsWith(TElWebDavOctetCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavOctetCollation_Equals(TElWebDavOctetCollationHandle _Handle, const char * pcS1, int32_t szS1, const char * pcS2, int32_t szS2, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavOctetCollation_IndexOf(TElWebDavOctetCollationHandle _Handle, const char * pcS, int32_t szS, const char * pcSubS, int32_t szSubS, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElWebDavOctetCollation_Create(TElWebDavOctetCollationHandle * OutResult);
#endif /* SB_USE_CLASS_TELWEBDAVOCTETCOLLATION */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElWebDAVServer_ce_ptr;
extern zend_class_entry *SBWebDAVServer_TElWebDavPrincipal_ce_ptr;
extern zend_class_entry *TElWebDavInMemoryPrincipal_ce_ptr;
extern zend_class_entry *TElWebDavPrincipalBackend_ce_ptr;
extern zend_class_entry *TElWebDavPrincipalMemoryBackend_ce_ptr;
extern zend_class_entry *TElCalDavTextMatchFilter_ce_ptr;
extern zend_class_entry *TElCalDavParamFilter_ce_ptr;
extern zend_class_entry *TElWebDavTimeRangeBase_ce_ptr;
extern zend_class_entry *TElWebDavTimeRange_ce_ptr;
extern zend_class_entry *TElCalDavPropFilter_ce_ptr;
extern zend_class_entry *TElCalDAVCompFilter_ce_ptr;
extern zend_class_entry *TElWebDavExtendedRequest_ce_ptr;
extern zend_class_entry *TElWebDavAddressBookRequest_ce_ptr;
extern zend_class_entry *TElWebDavLimitRecurrenceSet_ce_ptr;
extern zend_class_entry *TElWebDavExpand_ce_ptr;
extern zend_class_entry *TElWebDavLimitFreeBusySet_ce_ptr;
extern zend_class_entry *TElWebDavComp_ce_ptr;
extern zend_class_entry *TElWebDavCalendarRequest_ce_ptr;
extern zend_class_entry *TElWebDavProperty_ce_ptr;
extern zend_class_entry *TElWebDavIfState_ce_ptr;
extern zend_class_entry *TElWebDavIfResource_ce_ptr;
extern zend_class_entry *TElWebDAVIfHeader_ce_ptr;
extern zend_class_entry *TElWebDAVCustomLockList_ce_ptr;
extern zend_class_entry *TElWebDavFindMemoryLockHandle_ce_ptr;
extern zend_class_entry *TElWebDAVMemoryLockList_ce_ptr;
extern zend_class_entry *TElWebDAVACLOptions_ce_ptr;
extern zend_class_entry *TElCardDAVOptions_ce_ptr;
extern zend_class_entry *TElCalDAVOptions_ce_ptr;
extern zend_class_entry *TElWebDavCollation_ce_ptr;
extern zend_class_entry *TElWebDavUnicodeCollation_ce_ptr;
extern zend_class_entry *TElWebDavAsciiCollation_ce_ptr;
extern zend_class_entry *TElWebDavOctetCollation_ce_ptr;

void SB_CALLBACK TSBWebDavBeforeRequestEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle Params, int8_t * Accept, int32_t * StatusCode, char * pcReasonPhrase, int32_t * szReasonPhrase);
void SB_CALLBACK TSBWebDavRequestEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle Params, TMemoryStreamHandle Data);
void SB_CALLBACK TSBWebDavResponseEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerResponseParamsHandle Params, TMemoryStreamHandle Data);
void SB_CALLBACK TSBWebDavStatusCodeEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t StatusCode, TElHTTPServerRequestParamsHandle ReqParams, TElHTTPServerResponseParamsHandle RespParams);
void SB_CALLBACK TSBWebDavBeforeDownloadEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcURL, int32_t * szURL, int8_t * Allow);
void SB_CALLBACK TSBWebDavBeforeUploadEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcURL, int32_t * szURL, int8_t * Allow);
void SB_CALLBACK TSBWebDavTransferFinishedEventRaw(void * _ObjectData, TObjectHandle Sender);
void SB_CALLBACK TSBWebDavPropertyReadValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element, int8_t * Success);
void SB_CALLBACK TSBWebDavPropertyReadExValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element, TObjectHandle Param, int8_t * Success);
void SB_CALLBACK TSBWebDavPropertyAfterReadValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element);
void SB_CALLBACK TSBWebDavPropertyBeforeWriteValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, int8_t * Success);
void SB_CALLBACK TSBWebDavPropertyWriteValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, const char * pcValue, int32_t szValue, int8_t * Success);
void SB_CALLBACK TSBWebDavPropertyRemoveEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, int8_t * Success);
void SB_CALLBACK TSBWebDavCheckIfAddressBookEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, int8_t * Success);
void SB_CALLBACK TSBWebDavSetAsAddressBookEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int8_t * Success);
void SB_CALLBACK TSBWebDavCheckIfCalendarEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, int8_t * Success);
void SB_CALLBACK TSBWebDavSetAsCalendarEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int8_t * Success);
void SB_CALLBACK TSBWebDavReadPrivilegesEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int32_t * Privileges);
void SB_CALLBACK TSBWebDavReadOwnerEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle * Principal);
void SB_CALLBACK TSBWebDavReadSupportedPrivilegesEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int32_t * Privileges);
void SB_CALLBACK TSBWebDavGetPrivilegeDescriptionEventRaw(void * _ObjectData, TObjectHandle Sender, int16_t Privilege, char * pcDescription, int32_t * szDescription, char * pcLanguage, int32_t * szLanguage);
void SB_CALLBACK TSBWebDavGetACLRestrictionsEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TElWebDavACLRestrictionsHandle Restrictions);
void SB_CALLBACK TSBWebDavGetACLEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TListHandle List, int8_t * OwnList);
void SB_CALLBACK TSBWebDavSetACLEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TListHandle List, TSBWebDavACLErrorRaw * Error, int32_t * StatusCode);
#ifdef SB_WINDOWS
void SB_CALLBACK TSBWebDavGetURLSetEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TStringListHandle List);
#else
void SB_CALLBACK TSBWebDavGetURLSetEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TElStringListHandle List);
#endif
void SB_CALLBACK TSBCheckUIDUniquenessEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TElDirInfoPropertiesListHandle PropList, int8_t * Unique);
void Register_TElWebDAVServer(TSRMLS_D);
void Register_SBWebDAVServer_TElWebDavPrincipal(TSRMLS_D);
void Register_TElWebDavInMemoryPrincipal(TSRMLS_D);
void Register_TElWebDavPrincipalBackend(TSRMLS_D);
void Register_TElWebDavPrincipalMemoryBackend(TSRMLS_D);
void Register_TElCalDavTextMatchFilter(TSRMLS_D);
void Register_TElCalDavParamFilter(TSRMLS_D);
void Register_TElWebDavTimeRangeBase(TSRMLS_D);
void Register_TElWebDavTimeRange(TSRMLS_D);
void Register_TElCalDavPropFilter(TSRMLS_D);
void Register_TElCalDAVCompFilter(TSRMLS_D);
void Register_TElWebDavExtendedRequest(TSRMLS_D);
void Register_TElWebDavAddressBookRequest(TSRMLS_D);
void Register_TElWebDavLimitRecurrenceSet(TSRMLS_D);
void Register_TElWebDavExpand(TSRMLS_D);
void Register_TElWebDavLimitFreeBusySet(TSRMLS_D);
void Register_TElWebDavComp(TSRMLS_D);
void Register_TElWebDavCalendarRequest(TSRMLS_D);
void Register_TElWebDavProperty(TSRMLS_D);
void Register_TElWebDavIfState(TSRMLS_D);
void Register_TElWebDavIfResource(TSRMLS_D);
void Register_TElWebDAVIfHeader(TSRMLS_D);
void Register_TElWebDAVCustomLockList(TSRMLS_D);
void Register_TElWebDavFindMemoryLockHandle(TSRMLS_D);
void Register_TElWebDAVMemoryLockList(TSRMLS_D);
void Register_TElWebDAVACLOptions(TSRMLS_D);
void Register_TElCardDAVOptions(TSRMLS_D);
void Register_TElCalDAVOptions(TSRMLS_D);
void Register_TElWebDavCollation(TSRMLS_D);
void Register_TElWebDavUnicodeCollation(TSRMLS_D);
void Register_TElWebDavAsciiCollation(TSRMLS_D);
void Register_TElWebDavOctetCollation(TSRMLS_D);
SB_PHP_FUNCTION(SBWebDAVServer, FindLockInList);
void Register_SBWebDAVServer_Constants(int module_number TSRMLS_DC);
void Register_SBWebDAVServer_Enum_Flags(TSRMLS_D);
void Register_SBWebDAVServer_Aliases(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_WEBDAVSERVER
SB_IMPORT uint32_t SB_APIENTRY SBWebDAVServer_FindLockInList(const TListHandle List, const char * pcToken, int32_t szToken, TElWebDAVLockHandle * OutResult);
#endif /* SB_USE_GLOBAL_PROCS_WEBDAVSERVER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBWEBDAVSERVER */
