#ifndef __INC_SBX509EXT
#define __INC_SBX509EXT

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbrdn.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstrutils.h"
#include "sbconstants.h"
#include "sbasn1.h"
#include "sbpkcs7utils.h"
#include "sbasn1tree.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_PEM_CERTIFICATE_BEGIN_LINE 	"-----BEGIN CERTIFICATE-----"
#define SB_PEM_CERTIFICATE_END_LINE 	"-----END CERTIFICATE-----"
#define SB_PEM_CERTIFICATEX509_BEGIN_LINE 	"-----BEGIN X509 CERTIFICATE-----"
#define SB_PEM_CERTIFICATEX509_END_LINE 	"-----END X509 CERTIFICATE-----"
#define SB_PEM_RSA_PRIVATE_KEY_BEGIN_LINE 	"-----BEGIN RSA PRIVATE KEY-----"
#define SB_PEM_RSA_PRIVATE_KEY_END_LINE 	"-----END RSA PRIVATE KEY-----"
#define SB_PEM_DSA_PRIVATE_KEY_BEGIN_LINE 	"-----BEGIN DSA PRIVATE KEY-----"
#define SB_PEM_DSA_PRIVATE_KEY_END_LINE 	"-----END DSA PRIVATE KEY-----"
#define SB_PEM_DH_PRIVATE_KEY_BEGIN_LINE 	"-----BEGIN DH PRIVATE KEY-----"
#define SB_PEM_DH_PRIVATE_KEY_END_LINE 	"-----END DH PRIVATE KEY-----"
#define SB_PEM_EC_PRIVATE_KEY_BEGIN_LINE 	"-----BEGIN EC PRIVATE KEY-----"
#define SB_PEM_EC_PRIVATE_KEY_END_LINE 	"-----END EC PRIVATE KEY-----"
#define SB_PEM_PRIVATE_KEY_BEGIN_LINE 	"-----BEGIN PRIVATE KEY-----"
#define SB_PEM_PRIVATE_KEY_END_LINE 	"-----END PRIVATE KEY-----"
#define SB_CERT_OID_NETSCAPE_CERT_TYPE 	"`\x86""H\x01""\x86""\xF8""B\x01""\x01"
#define SB_CERT_OID_NETSCAPE_BASE_URL 	"`\x86""H\x01""\x86""\xF8""B\x01""\x02"
#define SB_CERT_OID_NETSCAPE_REVOKE_URL 	"`\x86""H\x01""\x86""\xF8""B\x01""\x03"
#define SB_CERT_OID_NETSCAPE_CA_REVOKE_URL 	"`\x86""H\x01""\x86""\xF8""B\x01""\x04"
#define SB_CERT_OID_NETSCAPE_RENEWAL_URL 	"`\x86""H\x01""\x86""\xF8""B\x01""\a"
#define SB_CERT_OID_NETSCAPE_CA_POLICY 	"`\x86""H\x01""\x86""\xF8""B\x01""\b"
#define SB_CERT_OID_NETSCAPE_SERVER_NAME 	"`\x86""H\x01""\x86""\xF8""B\x01""\f"
#define SB_CERT_OID_NETSCAPE_COMMENT 	"`\x86""H\x01""\x86""\xF8""B\x01""\r"
#define SB_CERT_OID_SUBJECT_DIRECTORY_ATTRIBUTES 	"U\x1D""\t"
#define SB_CERT_OID_SUBJECT_KEY_IDENTIFIER 	"U\x1D""\x0E"
#define SB_CERT_OID_KEY_USAGE 	"U\x1D""\x0F"
#define SB_CERT_OID_PRIVATE_KEY_USAGE_PERIOD 	"U\x1D""\x10"
#define SB_CERT_OID_SUBJECT_ALTERNATIVE_NAME 	"U\x1D""\x11"
#define SB_CERT_OID_ISSUER_ALTERNATIVE_NAME 	"U\x1D""\x12"
#define SB_CERT_OID_BASIC_CONSTRAINTS 	"U\x1D""\x13"
#define SB_CERT_OID_NAME_CONSTRAINTS 	"U\x1D""\x1E"
#define SB_CERT_OID_CRL_DISTRIBUTION_POINTS 	"U\x1D""\x1F"
#define SB_CERT_OID_CERTIFICATE_POLICIES 	"U\x1D"" "
#define SB_CERT_OID_POLICY_MAPPINGS 	"U\x1D""!"
#define SB_CERT_OID_AUTHORITY_KEY_IDENTIFIER 	"U\x1D""#"
#define SB_CERT_OID_POLICY_CONSTRAINTS 	"U\x1D""$"
#define SB_CERT_OID_EXTENDED_KEY_USAGE 	"U\x1D""%"
#define SB_CERT_OID_AUTHORITY_INFORMATION_ACCESS 	"+\x06""\x01""\x05""\x05""\a\x01""\x01"

typedef TElClassHandle TElEDIPartyNameHandle;

typedef TElEDIPartyNameHandle ElEDIPartyNameHandle;

typedef TElClassHandle TElOtherNameHandle;

typedef TElOtherNameHandle ElOtherNameHandle;

typedef TElClassHandle TElPermanentIdentifierHandle;

typedef TElPermanentIdentifierHandle ElPermanentIdentifierHandle;

typedef TElClassHandle TElGeneralNameHandle;

typedef TElGeneralNameHandle ElGeneralNameHandle;

typedef TElClassHandle TElGeneralNamesHandle;

typedef TElGeneralNamesHandle ElGeneralNamesHandle;

typedef TElClassHandle TElCustomExtensionHandle;

typedef TElCustomExtensionHandle ElCustomExtensionHandle;

typedef TElClassHandle TElAuthorityKeyIdentifierExtensionHandle;

typedef TElAuthorityKeyIdentifierExtensionHandle ElAuthorityKeyIdentifierExtensionHandle;

typedef TElClassHandle TElSubjectKeyIdentifierExtensionHandle;

typedef TElSubjectKeyIdentifierExtensionHandle ElSubjectKeyIdentifierExtensionHandle;

typedef TElClassHandle TElKeyUsageExtensionHandle;

typedef TElKeyUsageExtensionHandle ElKeyUsageExtensionHandle;

typedef TElClassHandle TElPrivateKeyUsagePeriodExtensionHandle;

typedef TElPrivateKeyUsagePeriodExtensionHandle ElPrivateKeyUsagePeriodExtensionHandle;

typedef TElClassHandle TElNetscapeCertTypeExtensionHandle;

typedef TElNetscapeCertTypeExtensionHandle ElNetscapeCertTypeExtensionHandle;

typedef TElClassHandle TElNetscapeStringHandle;

typedef TElNetscapeStringHandle ElNetscapeStringHandle;

typedef TElClassHandle TElNetscapeBaseURLHandle;

typedef TElNetscapeBaseURLHandle ElNetscapeBaseURLHandle;

typedef TElClassHandle TElNetscapeRevokeURLHandle;

typedef TElNetscapeRevokeURLHandle ElNetscapeRevokeURLHandle;

typedef TElClassHandle TElNetscapeCARevokeURLHandle;

typedef TElNetscapeCARevokeURLHandle ElNetscapeCARevokeURLHandle;

typedef TElClassHandle TElNetscapeRenewalURLHandle;

typedef TElNetscapeRenewalURLHandle ElNetscapeRenewalURLHandle;

typedef TElClassHandle TElNetscapeCAPolicyHandle;

typedef TElNetscapeCAPolicyHandle ElNetscapeCAPolicyHandle;

typedef TElClassHandle TElNetscapeServerNameHandle;

typedef TElNetscapeServerNameHandle ElNetscapeServerNameHandle;

typedef TElClassHandle TElNetscapeCommentHandle;

typedef TElNetscapeCommentHandle ElNetscapeCommentHandle;

typedef TElClassHandle TElCommonNameHandle;

typedef TElCommonNameHandle ElCommonNameHandle;

typedef TElClassHandle TElUserNoticeHandle;

typedef TElUserNoticeHandle ElUserNoticeHandle;

typedef TElClassHandle TElSinglePolicyQualifierHandle;

typedef TElSinglePolicyQualifierHandle ElSinglePolicyQualifierHandle;

typedef TElClassHandle TElSinglePolicyInformationHandle;

typedef TElSinglePolicyInformationHandle ElSinglePolicyInformationHandle;

typedef TElClassHandle TElCertificatePoliciesExtensionHandle;

typedef TElCertificatePoliciesExtensionHandle ElCertificatePoliciesExtensionHandle;

typedef TElClassHandle TElPolicyMappingHandle;

typedef TElPolicyMappingHandle ElPolicyMappingHandle;

typedef TElClassHandle TElPolicyMappingsExtensionHandle;

typedef TElPolicyMappingsExtensionHandle ElPolicyMappingsExtensionHandle;

typedef TElClassHandle TElAlternativeNameExtensionHandle;

typedef TElAlternativeNameExtensionHandle ElAlternativeNameExtensionHandle;

typedef TElClassHandle TElBasicConstraintsExtensionHandle;

typedef TElBasicConstraintsExtensionHandle ElBasicConstraintsExtensionHandle;

typedef TElClassHandle TElNameConstraintHandle;

typedef TElNameConstraintHandle ElNameConstraintHandle;

typedef TElClassHandle TElNameConstraintsExtensionHandle;

typedef TElNameConstraintsExtensionHandle ElNameConstraintsExtensionHandle;

typedef TElClassHandle TElPolicyConstraintsExtensionHandle;

typedef TElPolicyConstraintsExtensionHandle ElPolicyConstraintsExtensionHandle;

typedef TElClassHandle TElExtendedKeyUsageExtensionHandle;

typedef TElExtendedKeyUsageExtensionHandle ElExtendedKeyUsageExtensionHandle;

typedef TElClassHandle TElDistributionPointHandle;

typedef TElDistributionPointHandle ElDistributionPointHandle;

typedef TElClassHandle TElCRLDistributionPointsExtensionHandle;

typedef TElCRLDistributionPointsExtensionHandle ElCRLDistributionPointsExtensionHandle;

typedef TElClassHandle TElAccessDescriptionHandle;

typedef TElAccessDescriptionHandle ElAccessDescriptionHandle;

typedef TElClassHandle TElAuthorityInformationAccessExtensionHandle;

typedef TElAuthorityInformationAccessExtensionHandle ElAuthorityInformationAccessExtensionHandle;

typedef TElClassHandle TElSubjectDirectoryAttributesExtensionHandle;

typedef TElSubjectDirectoryAttributesExtensionHandle ElSubjectDirectoryAttributesExtensionHandle;

typedef TElClassHandle TElCertificateExtensionsHandle;

typedef TElCertificateExtensionsHandle ElCertificateExtensionsHandle;

typedef TElClassHandle TElExtensionWriterHandle;

typedef TElExtensionWriterHandle ElExtensionWriterHandle;

typedef TElClassHandle TElExtensionReaderHandle;

typedef TElExtensionReaderHandle ElExtensionReaderHandle;

typedef uint8_t TSBCertificateExtensionRaw;

typedef enum
{
	ceAuthorityKeyIdentifier = 0,
	ceSubjectKeyIdentifier = 1,
	ceKeyUsage = 2,
	cePrivateKeyUsagePeriod = 3,
	ceCertificatePolicies = 4,
	cePolicyMappings = 5,
	ceSubjectAlternativeName = 6,
	ceIssuerAlternativeName = 7,
	ceBasicConstraints = 8,
	ceNameConstraints = 9,
	cePolicyConstraints = 10,
	ceExtendedKeyUsage = 11,
	ceCRLDistributionPoints = 12,
	ceAuthorityInformationAccess = 13,
	ceNetscapeCertType = 14,
	ceNetscapeBaseURL = 15,
	ceNetscapeRevokeURL = 16,
	ceNetscapeCARevokeURL = 17,
	ceNetscapeRenewalURL = 18,
	ceNetscapeCAPolicyURL = 19,
	ceNetscapeServerName = 20,
	ceNetscapeComment = 21,
	ceCommonName = 22,
	ceSubjectDirectoryAttributes = 23
} TSBCertificateExtension;

typedef uint32_t TSBCertificateExtensionsRaw;

typedef enum 
{
	f_ceAuthorityKeyIdentifier = 1,
	f_ceSubjectKeyIdentifier = 2,
	f_ceKeyUsage = 4,
	f_cePrivateKeyUsagePeriod = 8,
	f_ceCertificatePolicies = 16,
	f_cePolicyMappings = 32,
	f_ceSubjectAlternativeName = 64,
	f_ceIssuerAlternativeName = 128,
	f_ceBasicConstraints = 256,
	f_ceNameConstraints = 512,
	f_cePolicyConstraints = 1024,
	f_ceExtendedKeyUsage = 2048,
	f_ceCRLDistributionPoints = 4096,
	f_ceAuthorityInformationAccess = 8192,
	f_ceNetscapeCertType = 16384,
	f_ceNetscapeBaseURL = 32768,
	f_ceNetscapeRevokeURL = 65536,
	f_ceNetscapeCARevokeURL = 131072,
	f_ceNetscapeRenewalURL = 262144,
	f_ceNetscapeCAPolicyURL = 524288,
	f_ceNetscapeServerName = 1048576,
	f_ceNetscapeComment = 2097152,
	f_ceCommonName = 4194304,
	f_ceSubjectDirectoryAttributes = 8388608
} TSBCertificateExtensions;

typedef uint8_t TSBKeyUsageTypeRaw;

typedef enum
{
	kuDigitalSignature = 0,
	kuNonRepudiation = 1,
	kuKeyEncipherment = 2,
	kuDataEncipherment = 3,
	kuKeyAgreement = 4,
	kuKeyCertSign = 5,
	kuCRLSign = 6,
	kuEncipherOnly = 7,
	kuDecipherOnly = 8
} TSBKeyUsageType;

typedef uint32_t TSBKeyUsageRaw;

typedef enum 
{
	f_kuDigitalSignature = 1,
	f_kuNonRepudiation = 2,
	f_kuKeyEncipherment = 4,
	f_kuDataEncipherment = 8,
	f_kuKeyAgreement = 16,
	f_kuKeyCertSign = 32,
	f_kuCRLSign = 64,
	f_kuEncipherOnly = 128,
	f_kuDecipherOnly = 256
} TSBKeyUsage;

typedef uint8_t TSBCRLReasonFlagRaw;

typedef enum
{
	rfUnspecified = 0,
	rfKeyCompromise = 1,
	rfCACompromise = 2,
	rfAffiliationChanged = 3,
	rfSuperseded = 4,
	rfCessationOfOperation = 5,
	rfCertificateHold = 6,
	rfObsolete1 = 7,
	rfRemoveFromCRL = 8,
	rfPrivilegeWithdrawn = 9,
	rfAACompromise = 10
} TSBCRLReasonFlag;

typedef uint32_t TSBCRLReasonFlagsRaw;

typedef enum 
{
	f_rfUnspecified = 1,
	f_rfKeyCompromise = 2,
	f_rfCACompromise = 4,
	f_rfAffiliationChanged = 8,
	f_rfSuperseded = 16,
	f_rfCessationOfOperation = 32,
	f_rfCertificateHold = 64,
	f_rfObsolete1 = 128,
	f_rfRemoveFromCRL = 256,
	f_rfPrivilegeWithdrawn = 512,
	f_rfAACompromise = 1024
} TSBCRLReasonFlags;

typedef uint8_t TSBGeneralNameRaw;

typedef enum
{
	gnRFC822Name = 0,
	gnDNSName = 1,
	gnDirectoryName = 2,
	gnEdiPartyName = 3,
	gnUniformResourceIdentifier = 4,
	gnIPAddress = 5,
	gnRegisteredID = 6,
	gnOtherName = 7,
	gnUnknown = 8,
	gnPermanentIdentifier = 9
} TSBGeneralName;

typedef uint8_t TElNetscapeCertTypeFlagRaw;

typedef enum
{
	nsSSLClient = 0,
	nsSSLServer = 1,
	nsSMIME = 2,
	nsObjectSign = 3,
	nsSSLCA = 4,
	nsSMIMECA = 5,
	nsObjectSignCA = 6
} TElNetscapeCertTypeFlag;

typedef uint32_t TElNetscapeCertTypeRaw;

typedef enum 
{
	f_nsSSLClient = 1,
	f_nsSSLServer = 2,
	f_nsSMIME = 4,
	f_nsObjectSign = 8,
	f_nsSSLCA = 16,
	f_nsSMIMECA = 32,
	f_nsObjectSignCA = 64
} TElNetscapeCertType;

typedef uint8_t TElDistributionPointParameterRaw;

typedef enum
{
	dppName = 0,
	dppCRLIssuer = 1,
	dppReasonFlags = 2
} TElDistributionPointParameter;

typedef uint32_t TElDistributionPointParametersRaw;

typedef enum 
{
	f_dppName = 1,
	f_dppCRLIssuer = 2,
	f_dppReasonFlags = 4
} TElDistributionPointParameters;

#ifdef SB_USE_CLASS_TELEDIPARTYNAME
SB_IMPORT uint32_t SB_APIENTRY TElEDIPartyName_get_NameAssigner(TElEDIPartyNameHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElEDIPartyName_set_NameAssigner(TElEDIPartyNameHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElEDIPartyName_get_PartyName(TElEDIPartyNameHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElEDIPartyName_set_PartyName(TElEDIPartyNameHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElEDIPartyName_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELEDIPARTYNAME */

#ifdef SB_USE_CLASS_TELOTHERNAME
SB_IMPORT uint32_t SB_APIENTRY TElOtherName_get_OID(TElOtherNameHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOtherName_set_OID(TElOtherNameHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOtherName_get_Value(TElOtherNameHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOtherName_set_Value(TElOtherNameHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOtherName_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOTHERNAME */

#ifdef SB_USE_CLASS_TELPERMANENTIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElPermanentIdentifier_get_PermanentIdentifier(TElPermanentIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPermanentIdentifier_set_PermanentIdentifier(TElPermanentIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPermanentIdentifier_get_Assigner(TElPermanentIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPermanentIdentifier_set_Assigner(TElPermanentIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPermanentIdentifier_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELPERMANENTIDENTIFIER */

#ifdef SB_USE_CLASS_TELGENERALNAME
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_Assign(TElGeneralNameHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_AssignTo(TElGeneralNameHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_LoadFromTag(TElGeneralNameHandle _Handle, TElASN1CustomTagHandle Tag, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_SaveToTag(TElGeneralNameHandle _Handle, TElASN1SimpleTagHandle Tag, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_RFC822Name(TElGeneralNameHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_set_RFC822Name(TElGeneralNameHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_DNSName(TElGeneralNameHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_set_DNSName(TElGeneralNameHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_DirectoryName(TElGeneralNameHandle _Handle, TElRelativeDistinguishedNameHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_EdiPartyName(TElGeneralNameHandle _Handle, TElEDIPartyNameHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_UniformResourceIdentifier(TElGeneralNameHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_set_UniformResourceIdentifier(TElGeneralNameHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_IpAddress(TElGeneralNameHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_set_IpAddress(TElGeneralNameHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_IpAddressBytes(TElGeneralNameHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_set_IpAddressBytes(TElGeneralNameHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_RegisteredID(TElGeneralNameHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_set_RegisteredID(TElGeneralNameHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_OtherName(TElGeneralNameHandle _Handle, TElOtherNameHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_PermanentIdentifier(TElGeneralNameHandle _Handle, TElPermanentIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_NameType(TElGeneralNameHandle _Handle, TSBGeneralNameRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_set_NameType(TElGeneralNameHandle _Handle, TSBGeneralNameRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_get_IsEmpty(TElGeneralNameHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralName_Create(TElGeneralNameHandle * OutResult);
#endif /* SB_USE_CLASS_TELGENERALNAME */

#ifdef SB_USE_CLASS_TELGENERALNAMES
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_Assign(TElGeneralNamesHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_AssignTo(TElGeneralNamesHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_Equals(TElGeneralNamesHandle _Handle, TElGeneralNamesHandle Other, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_HasCommon(TElGeneralNamesHandle _Handle, TElGeneralNamesHandle Other, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_Add(TElGeneralNamesHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_Remove(TElGeneralNamesHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_Clear(TElGeneralNamesHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_ContainsEmailAddress(TElGeneralNamesHandle _Handle, const char * pcAddr, int32_t szAddr, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_FindNameByType(TElGeneralNamesHandle _Handle, TSBGeneralNameRaw NameType, int32_t StartIndex, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_LoadFromTag(TElGeneralNamesHandle _Handle, TElASN1ConstrainedTagHandle Tag, int8_t AllowRDN, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_SaveToTag(TElGeneralNamesHandle _Handle, TElASN1ConstrainedTagHandle Tag, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_get_Names(TElGeneralNamesHandle _Handle, int32_t Index, TElGeneralNameHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_get_Count(TElGeneralNamesHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGeneralNames_Create(TElGeneralNamesHandle * OutResult);
#endif /* SB_USE_CLASS_TELGENERALNAMES */

#ifdef SB_USE_CLASS_TELCUSTOMEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_SaveToTag(TElCustomExtensionHandle _Handle, TElASN1ConstrainedTagHandle Tag);
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_get_Critical(TElCustomExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_set_Critical(TElCustomExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_get_OID(TElCustomExtensionHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_set_OID(TElCustomExtensionHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_get_Value(TElCustomExtensionHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_set_Value(TElCustomExtensionHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_get_SaveDefaultASN1Tags(TElCustomExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_set_SaveDefaultASN1Tags(TElCustomExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCustomExtension_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELCUSTOMEXTENSION */

#ifdef SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIEREXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityKeyIdentifierExtension_get_KeyIdentifier(TElAuthorityKeyIdentifierExtensionHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityKeyIdentifierExtension_set_KeyIdentifier(TElAuthorityKeyIdentifierExtensionHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityKeyIdentifierExtension_get_AuthorityCertIssuer(TElAuthorityKeyIdentifierExtensionHandle _Handle, TElGeneralNamesHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityKeyIdentifierExtension_get_AuthorityCertSerial(TElAuthorityKeyIdentifierExtensionHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityKeyIdentifierExtension_set_AuthorityCertSerial(TElAuthorityKeyIdentifierExtensionHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityKeyIdentifierExtension_Create(TElAuthorityKeyIdentifierExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELAUTHORITYKEYIDENTIFIEREXTENSION */

#ifdef SB_USE_CLASS_TELSUBJECTKEYIDENTIFIEREXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElSubjectKeyIdentifierExtension_get_KeyIdentifier(TElSubjectKeyIdentifierExtensionHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSubjectKeyIdentifierExtension_set_KeyIdentifier(TElSubjectKeyIdentifierExtensionHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSubjectKeyIdentifierExtension_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELSUBJECTKEYIDENTIFIEREXTENSION */

#ifdef SB_USE_CLASS_TELKEYUSAGEEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_get_DigitalSignature(TElKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_set_DigitalSignature(TElKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_get_NonRepudiation(TElKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_set_NonRepudiation(TElKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_get_KeyEncipherment(TElKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_set_KeyEncipherment(TElKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_get_DataEncipherment(TElKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_set_DataEncipherment(TElKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_get_KeyAgreement(TElKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_set_KeyAgreement(TElKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_get_KeyCertSign(TElKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_set_KeyCertSign(TElKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_get_CRLSign(TElKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_set_CRLSign(TElKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_get_EncipherOnly(TElKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_set_EncipherOnly(TElKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_get_DecipherOnly(TElKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_set_DecipherOnly(TElKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElKeyUsageExtension_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELKEYUSAGEEXTENSION */

#ifdef SB_USE_CLASS_TELPRIVATEKEYUSAGEPERIODEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElPrivateKeyUsagePeriodExtension_get_NotBefore(TElPrivateKeyUsagePeriodExtensionHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPrivateKeyUsagePeriodExtension_set_NotBefore(TElPrivateKeyUsagePeriodExtensionHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPrivateKeyUsagePeriodExtension_get_NotAfter(TElPrivateKeyUsagePeriodExtensionHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPrivateKeyUsagePeriodExtension_set_NotAfter(TElPrivateKeyUsagePeriodExtensionHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPrivateKeyUsagePeriodExtension_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELPRIVATEKEYUSAGEPERIODEXTENSION */

#ifdef SB_USE_CLASS_TELNETSCAPECERTTYPEEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeCertTypeExtension_get_CertType(TElNetscapeCertTypeExtensionHandle _Handle, TElNetscapeCertTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeCertTypeExtension_set_CertType(TElNetscapeCertTypeExtensionHandle _Handle, TElNetscapeCertTypeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeCertTypeExtension_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNETSCAPECERTTYPEEXTENSION */

#ifdef SB_USE_CLASS_TELNETSCAPESTRING
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeString_get_Content(TElNetscapeStringHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeString_set_Content(TElNetscapeStringHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeString_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNETSCAPESTRING */

#ifdef SB_USE_CLASS_TELNETSCAPEBASEURL
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeBaseURL_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNETSCAPEBASEURL */

#ifdef SB_USE_CLASS_TELNETSCAPEREVOKEURL
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeRevokeURL_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNETSCAPEREVOKEURL */

#ifdef SB_USE_CLASS_TELNETSCAPECAREVOKEURL
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeCARevokeURL_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNETSCAPECAREVOKEURL */

#ifdef SB_USE_CLASS_TELNETSCAPERENEWALURL
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeRenewalURL_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNETSCAPERENEWALURL */

#ifdef SB_USE_CLASS_TELNETSCAPECAPOLICY
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeCAPolicy_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNETSCAPECAPOLICY */

#ifdef SB_USE_CLASS_TELNETSCAPESERVERNAME
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeServerName_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNETSCAPESERVERNAME */

#ifdef SB_USE_CLASS_TELNETSCAPECOMMENT
SB_IMPORT uint32_t SB_APIENTRY TElNetscapeComment_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNETSCAPECOMMENT */

#ifdef SB_USE_CLASS_TELCOMMONNAME
SB_IMPORT uint32_t SB_APIENTRY TElCommonName_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELCOMMONNAME */

#ifdef SB_USE_CLASS_TELUSERNOTICE
SB_IMPORT uint32_t SB_APIENTRY TElUserNotice_get_Organization(TElUserNoticeHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUserNotice_set_Organization(TElUserNoticeHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElUserNotice_get_NoticeNumbers(TElUserNoticeHandle _Handle, int32_t Index, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUserNotice_set_NoticeNumbers(TElUserNoticeHandle _Handle, int32_t Index, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElUserNotice_get_NoticeNumbersCount(TElUserNoticeHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUserNotice_set_NoticeNumbersCount(TElUserNoticeHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElUserNotice_get_ExplicitText(TElUserNoticeHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElUserNotice_set_ExplicitText(TElUserNoticeHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElUserNotice_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELUSERNOTICE */

#ifdef SB_USE_CLASS_TELSINGLEPOLICYQUALIFIER
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyQualifier_get_CPSURI(TElSinglePolicyQualifierHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyQualifier_set_CPSURI(TElSinglePolicyQualifierHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyQualifier_get_UserNotice(TElSinglePolicyQualifierHandle _Handle, TElUserNoticeHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyQualifier_Create(TElSinglePolicyQualifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELSINGLEPOLICYQUALIFIER */

#ifdef SB_USE_CLASS_TELSINGLEPOLICYINFORMATION
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyInformation_get_PolicyIdentifier(TElSinglePolicyInformationHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyInformation_set_PolicyIdentifier(TElSinglePolicyInformationHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyInformation_get_QualifierCount(TElSinglePolicyInformationHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyInformation_set_QualifierCount(TElSinglePolicyInformationHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyInformation_get_Qualifiers(TElSinglePolicyInformationHandle _Handle, int32_t Index, TElSinglePolicyQualifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSinglePolicyInformation_Create(TElSinglePolicyInformationHandle * OutResult);
#endif /* SB_USE_CLASS_TELSINGLEPOLICYINFORMATION */

#ifdef SB_USE_CLASS_TELCERTIFICATEPOLICIESEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElCertificatePoliciesExtension_Remove(TElCertificatePoliciesExtensionHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElCertificatePoliciesExtension_get_PolicyInformation(TElCertificatePoliciesExtensionHandle _Handle, int32_t Index, TElSinglePolicyInformationHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificatePoliciesExtension_get_Count(TElCertificatePoliciesExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificatePoliciesExtension_set_Count(TElCertificatePoliciesExtensionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificatePoliciesExtension_Create(TElCertificatePoliciesExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELCERTIFICATEPOLICIESEXTENSION */

#ifdef SB_USE_CLASS_TELPOLICYMAPPING
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMapping_get_IssuerDomainPolicy(TElPolicyMappingHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMapping_set_IssuerDomainPolicy(TElPolicyMappingHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMapping_get_SubjectDomainPolicy(TElPolicyMappingHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMapping_set_SubjectDomainPolicy(TElPolicyMappingHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMapping_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELPOLICYMAPPING */

#ifdef SB_USE_CLASS_TELPOLICYMAPPINGSEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMappingsExtension_Remove(TElPolicyMappingsExtensionHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMappingsExtension_get_Count(TElPolicyMappingsExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMappingsExtension_set_Count(TElPolicyMappingsExtensionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMappingsExtension_get_Policies(TElPolicyMappingsExtensionHandle _Handle, int32_t Index, TElPolicyMappingHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyMappingsExtension_Create(TElPolicyMappingsExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELPOLICYMAPPINGSEXTENSION */

#ifdef SB_USE_CLASS_TELALTERNATIVENAMEEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElAlternativeNameExtension_get_Content(TElAlternativeNameExtensionHandle _Handle, TElGeneralNamesHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlternativeNameExtension_Create(int8_t IssuerAltName, TElAlternativeNameExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELALTERNATIVENAMEEXTENSION */

#ifdef SB_USE_CLASS_TELBASICCONSTRAINTSEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElBasicConstraintsExtension_get_CA(TElBasicConstraintsExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBasicConstraintsExtension_set_CA(TElBasicConstraintsExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElBasicConstraintsExtension_get_PathLenConstraint(TElBasicConstraintsExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElBasicConstraintsExtension_set_PathLenConstraint(TElBasicConstraintsExtensionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElBasicConstraintsExtension_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELBASICCONSTRAINTSEXTENSION */

#ifdef SB_USE_CLASS_TELNAMECONSTRAINT
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraint_get_Base(TElNameConstraintHandle _Handle, TElGeneralNameHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraint_get_Minimum(TElNameConstraintHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraint_set_Minimum(TElNameConstraintHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraint_get_Maximum(TElNameConstraintHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraint_set_Maximum(TElNameConstraintHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraint_Create(TElNameConstraintHandle * OutResult);
#endif /* SB_USE_CLASS_TELNAMECONSTRAINT */

#ifdef SB_USE_CLASS_TELNAMECONSTRAINTSEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_AreNamesAcceptable(TElNameConstraintsExtensionHandle _Handle, TElRelativeDistinguishedNameHandle Subj, TElGeneralNamesHandle SubjAltName, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_RemovePermitted(TElNameConstraintsExtensionHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_RemoveExcluded(TElNameConstraintsExtensionHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_get_PermittedSubtrees(TElNameConstraintsExtensionHandle _Handle, int32_t Index, TElNameConstraintHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_get_ExcludedSubtrees(TElNameConstraintsExtensionHandle _Handle, int32_t Index, TElNameConstraintHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_get_PermittedCount(TElNameConstraintsExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_set_PermittedCount(TElNameConstraintsExtensionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_get_ExcludedCount(TElNameConstraintsExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_set_ExcludedCount(TElNameConstraintsExtensionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElNameConstraintsExtension_Create(TElNameConstraintsExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELNAMECONSTRAINTSEXTENSION */

#ifdef SB_USE_CLASS_TELPOLICYCONSTRAINTSEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElPolicyConstraintsExtension_get_RequireExplicitPolicy(TElPolicyConstraintsExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyConstraintsExtension_set_RequireExplicitPolicy(TElPolicyConstraintsExtensionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyConstraintsExtension_get_InhibitPolicyMapping(TElPolicyConstraintsExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyConstraintsExtension_set_InhibitPolicyMapping(TElPolicyConstraintsExtensionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPolicyConstraintsExtension_Create(TElCustomExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELPOLICYCONSTRAINTSEXTENSION */

#ifdef SB_USE_CLASS_TELEXTENDEDKEYUSAGEEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_AddCustomUsage(TElExtendedKeyUsageExtensionHandle _Handle, const uint8_t pUsageOID[], int32_t szUsageOID, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_RemoveCustomUsage(TElExtendedKeyUsageExtensionHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_ClearCustomUsages(TElExtendedKeyUsageExtensionHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_TotalUsageCount(TElExtendedKeyUsageExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_ServerAuthentication(TElExtendedKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_ServerAuthentication(TElExtendedKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_ClientAuthentication(TElExtendedKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_ClientAuthentication(TElExtendedKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_CodeSigning(TElExtendedKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_CodeSigning(TElExtendedKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_EmailProtection(TElExtendedKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_EmailProtection(TElExtendedKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_TimeStamping(TElExtendedKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_TimeStamping(TElExtendedKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_OCSPSigning(TElExtendedKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_OCSPSigning(TElExtendedKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_SmartCardLogon(TElExtendedKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_SmartCardLogon(TElExtendedKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_KeyPurposeClientAuth(TElExtendedKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_KeyPurposeClientAuth(TElExtendedKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_KeyPurposeKDC(TElExtendedKeyUsageExtensionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_KeyPurposeKDC(TElExtendedKeyUsageExtensionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_CustomUsages(TElExtendedKeyUsageExtensionHandle _Handle, int32_t Index, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_set_CustomUsages(TElExtendedKeyUsageExtensionHandle _Handle, int32_t Index, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_get_CustomUsageCount(TElExtendedKeyUsageExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtendedKeyUsageExtension_Create(TElExtendedKeyUsageExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELEXTENDEDKEYUSAGEEXTENSION */

#ifdef SB_USE_CLASS_TELDISTRIBUTIONPOINT
SB_IMPORT uint32_t SB_APIENTRY TElDistributionPoint_get_Name(TElDistributionPointHandle _Handle, TElGeneralNamesHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDistributionPoint_get_ReasonFlags(TElDistributionPointHandle _Handle, TSBCRLReasonFlagsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDistributionPoint_set_ReasonFlags(TElDistributionPointHandle _Handle, TSBCRLReasonFlagsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElDistributionPoint_get_CRLIssuer(TElDistributionPointHandle _Handle, TElGeneralNamesHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDistributionPoint_get_Included(TElDistributionPointHandle _Handle, TElDistributionPointParametersRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDistributionPoint_set_Included(TElDistributionPointHandle _Handle, TElDistributionPointParametersRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElDistributionPoint_Create(TElDistributionPointHandle * OutResult);
#endif /* SB_USE_CLASS_TELDISTRIBUTIONPOINT */

#ifdef SB_USE_CLASS_TELCRLDISTRIBUTIONPOINTSEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElCRLDistributionPointsExtension_Remove(TElCRLDistributionPointsExtensionHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElCRLDistributionPointsExtension_get_DistributionPoints(TElCRLDistributionPointsExtensionHandle _Handle, int32_t Index, TElDistributionPointHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCRLDistributionPointsExtension_get_Count(TElCRLDistributionPointsExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCRLDistributionPointsExtension_set_Count(TElCRLDistributionPointsExtensionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCRLDistributionPointsExtension_Create(TElCRLDistributionPointsExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELCRLDISTRIBUTIONPOINTSEXTENSION */

#ifdef SB_USE_CLASS_TELACCESSDESCRIPTION
SB_IMPORT uint32_t SB_APIENTRY TElAccessDescription_get_AccessMethod(TElAccessDescriptionHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAccessDescription_set_AccessMethod(TElAccessDescriptionHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAccessDescription_get_AccessLocation(TElAccessDescriptionHandle _Handle, TElGeneralNameHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAccessDescription_Create(TElAccessDescriptionHandle * OutResult);
#endif /* SB_USE_CLASS_TELACCESSDESCRIPTION */

#ifdef SB_USE_CLASS_TELAUTHORITYINFORMATIONACCESSEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityInformationAccessExtension_Remove(TElAuthorityInformationAccessExtensionHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityInformationAccessExtension_get_AccessDescriptions(TElAuthorityInformationAccessExtensionHandle _Handle, int32_t Index, TElAccessDescriptionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityInformationAccessExtension_get_Count(TElAuthorityInformationAccessExtensionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityInformationAccessExtension_set_Count(TElAuthorityInformationAccessExtensionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAuthorityInformationAccessExtension_Create(TElAuthorityInformationAccessExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELAUTHORITYINFORMATIONACCESSEXTENSION */

#ifdef SB_USE_CLASS_TELSUBJECTDIRECTORYATTRIBUTESEXTENSION
SB_IMPORT uint32_t SB_APIENTRY TElSubjectDirectoryAttributesExtension_get_Attributes(TElSubjectDirectoryAttributesExtensionHandle _Handle, TElPKCS7AttributesHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSubjectDirectoryAttributesExtension_Create(TElSubjectDirectoryAttributesExtensionHandle * OutResult);
#endif /* SB_USE_CLASS_TELSUBJECTDIRECTORYATTRIBUTESEXTENSION */

#ifdef SB_USE_CLASS_TELCERTIFICATEEXTENSIONS
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_RemoveOther(TElCertificateExtensionsHandle _Handle, int32_t Index, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_ClearExtensions(TElCertificateExtensionsHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_AuthorityKeyIdentifier(TElCertificateExtensionsHandle _Handle, TElAuthorityKeyIdentifierExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_SubjectKeyIdentifier(TElCertificateExtensionsHandle _Handle, TElSubjectKeyIdentifierExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_KeyUsage(TElCertificateExtensionsHandle _Handle, TElKeyUsageExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_KeyUsage(TElCertificateExtensionsHandle _Handle, TElKeyUsageExtensionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_PrivateKeyUsagePeriod(TElCertificateExtensionsHandle _Handle, TElPrivateKeyUsagePeriodExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_PrivateKeyUsagePeriod(TElCertificateExtensionsHandle _Handle, TElPrivateKeyUsagePeriodExtensionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_CertificatePolicies(TElCertificateExtensionsHandle _Handle, TElCertificatePoliciesExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_PolicyMappings(TElCertificateExtensionsHandle _Handle, TElPolicyMappingsExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_PolicyMappings(TElCertificateExtensionsHandle _Handle, TElPolicyMappingsExtensionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_SubjectAlternativeName(TElCertificateExtensionsHandle _Handle, TElAlternativeNameExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_SubjectAlternativeName(TElCertificateExtensionsHandle _Handle, TElAlternativeNameExtensionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_IssuerAlternativeName(TElCertificateExtensionsHandle _Handle, TElAlternativeNameExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_IssuerAlternativeName(TElCertificateExtensionsHandle _Handle, TElAlternativeNameExtensionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_BasicConstraints(TElCertificateExtensionsHandle _Handle, TElBasicConstraintsExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_BasicConstraints(TElCertificateExtensionsHandle _Handle, TElBasicConstraintsExtensionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_NameConstraints(TElCertificateExtensionsHandle _Handle, TElNameConstraintsExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_PolicyConstraints(TElCertificateExtensionsHandle _Handle, TElPolicyConstraintsExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_PolicyConstraints(TElCertificateExtensionsHandle _Handle, TElPolicyConstraintsExtensionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_ExtendedKeyUsage(TElCertificateExtensionsHandle _Handle, TElExtendedKeyUsageExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_CRLDistributionPoints(TElCertificateExtensionsHandle _Handle, TElCRLDistributionPointsExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_AuthorityInformationAccess(TElCertificateExtensionsHandle _Handle, TElAuthorityInformationAccessExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_NetscapeCertType(TElCertificateExtensionsHandle _Handle, TElNetscapeCertTypeExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_NetscapeCertType(TElCertificateExtensionsHandle _Handle, TElNetscapeCertTypeExtensionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_NetscapeComment(TElCertificateExtensionsHandle _Handle, TElNetscapeCommentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_NetscapeComment(TElCertificateExtensionsHandle _Handle, TElNetscapeCommentHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_NetscapeBaseURL(TElCertificateExtensionsHandle _Handle, TElNetscapeBaseURLHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_NetscapeBaseURL(TElCertificateExtensionsHandle _Handle, TElNetscapeBaseURLHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_NetscapeRevokeURL(TElCertificateExtensionsHandle _Handle, TElNetscapeRevokeURLHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_NetscapeRevokeURL(TElCertificateExtensionsHandle _Handle, TElNetscapeRevokeURLHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_NetscapeCARevokeURL(TElCertificateExtensionsHandle _Handle, TElNetscapeCARevokeURLHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_NetscapeCARevokeURL(TElCertificateExtensionsHandle _Handle, TElNetscapeCARevokeURLHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_NetscapeRenewalURL(TElCertificateExtensionsHandle _Handle, TElNetscapeRenewalURLHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_NetscapeRenewalURL(TElCertificateExtensionsHandle _Handle, TElNetscapeRenewalURLHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_NetscapeCAPolicy(TElCertificateExtensionsHandle _Handle, TElNetscapeCAPolicyHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_NetscapeCAPolicy(TElCertificateExtensionsHandle _Handle, TElNetscapeCAPolicyHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_NetscapeServerName(TElCertificateExtensionsHandle _Handle, TElNetscapeServerNameHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_NetscapeServerName(TElCertificateExtensionsHandle _Handle, TElNetscapeServerNameHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_CommonName(TElCertificateExtensionsHandle _Handle, TElCommonNameHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_CommonName(TElCertificateExtensionsHandle _Handle, TElCommonNameHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_SubjectDirectoryAttributes(TElCertificateExtensionsHandle _Handle, TElSubjectDirectoryAttributesExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_OtherExtensions(TElCertificateExtensionsHandle _Handle, int32_t Index, TElCustomExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_OtherCount(TElCertificateExtensionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_OtherCount(TElCertificateExtensionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_get_Included(TElCertificateExtensionsHandle _Handle, TSBCertificateExtensionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_set_Included(TElCertificateExtensionsHandle _Handle, TSBCertificateExtensionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElCertificateExtensions_Create(TElCertificateExtensionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELCERTIFICATEEXTENSIONS */

#ifdef SB_USE_CLASS_TELEXTENSIONWRITER
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensions(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtension(TElExtensionWriterHandle _Handle, const uint8_t pOID[], int32_t szOID, int8_t Critical, const uint8_t pValue[], int32_t szValue, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionBasicConstraints(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionKeyUsage(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionPrivateKeyUsagePeriod(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionSubjectAltName(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionIssuerAltName(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionExtendedKeyUsage(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionPolicyMappings(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionNameConstraints(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionPolicyConstraints(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionCertificatePolicies(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionAuthorityKeyIdentifier(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionCRLDistributionPoints(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionAuthorityInformationAccess(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionNetscapeCertType(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionNetscapeString(TElExtensionWriterHandle _Handle, const uint8_t pAOID[], int32_t szAOID, const char * pcANetStr, int32_t szANetStr, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionNetscapeString_1(TElExtensionWriterHandle _Handle, const uint8_t pAOID[], int32_t szAOID, const uint8_t pANetStr[], int32_t szANetStr, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionSubjectKeyIdentifier(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WritePolicyInformation(TElExtensionWriterHandle _Handle, TElSinglePolicyInformationHandle P, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteDistributionPoint(TElExtensionWriterHandle _Handle, TElDistributionPointHandle P, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_WriteExtensionSubjectDirectoryAttributes(TElExtensionWriterHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_get_Extensions(TElExtensionWriterHandle _Handle, TElCertificateExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_get_UseA3Prefix(TElExtensionWriterHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_set_UseA3Prefix(TElExtensionWriterHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_get_SaveDefaultASN1Tags(TElExtensionWriterHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_set_SaveDefaultASN1Tags(TElExtensionWriterHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionWriter_Create(TElCertificateExtensionsHandle Exts, int8_t CertExtensions, TElExtensionWriterHandle * OutResult);
#endif /* SB_USE_CLASS_TELEXTENSIONWRITER */

#ifdef SB_USE_CLASS_TELEXTENSIONREADER
SB_IMPORT uint32_t SB_APIENTRY TElExtensionReader_ParseExtension(TElExtensionReaderHandle _Handle, const uint8_t pOID[], int32_t szOID, int8_t Critical, const uint8_t pContent[], int32_t szContent);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionReader_get_Extensions(TElExtensionReaderHandle _Handle, TElCertificateExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElExtensionReader_Create(TElCertificateExtensionsHandle Exts, int8_t StrictMode, TElExtensionReaderHandle * OutResult);
#endif /* SB_USE_CLASS_TELEXTENSIONREADER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElEDIPartyName_ce_ptr;
extern zend_class_entry *TElOtherName_ce_ptr;
extern zend_class_entry *TElPermanentIdentifier_ce_ptr;
extern zend_class_entry *TElGeneralName_ce_ptr;
extern zend_class_entry *TElGeneralNames_ce_ptr;
extern zend_class_entry *TElCustomExtension_ce_ptr;
extern zend_class_entry *TElAuthorityKeyIdentifierExtension_ce_ptr;
extern zend_class_entry *TElSubjectKeyIdentifierExtension_ce_ptr;
extern zend_class_entry *TElKeyUsageExtension_ce_ptr;
extern zend_class_entry *TElPrivateKeyUsagePeriodExtension_ce_ptr;
extern zend_class_entry *TElNetscapeCertTypeExtension_ce_ptr;
extern zend_class_entry *TElNetscapeString_ce_ptr;
extern zend_class_entry *TElNetscapeBaseURL_ce_ptr;
extern zend_class_entry *TElNetscapeRevokeURL_ce_ptr;
extern zend_class_entry *TElNetscapeCARevokeURL_ce_ptr;
extern zend_class_entry *TElNetscapeRenewalURL_ce_ptr;
extern zend_class_entry *TElNetscapeCAPolicy_ce_ptr;
extern zend_class_entry *TElNetscapeServerName_ce_ptr;
extern zend_class_entry *TElNetscapeComment_ce_ptr;
extern zend_class_entry *TElCommonName_ce_ptr;
extern zend_class_entry *TElUserNotice_ce_ptr;
extern zend_class_entry *TElSinglePolicyQualifier_ce_ptr;
extern zend_class_entry *TElSinglePolicyInformation_ce_ptr;
extern zend_class_entry *TElCertificatePoliciesExtension_ce_ptr;
extern zend_class_entry *TElPolicyMapping_ce_ptr;
extern zend_class_entry *TElPolicyMappingsExtension_ce_ptr;
extern zend_class_entry *TElAlternativeNameExtension_ce_ptr;
extern zend_class_entry *TElBasicConstraintsExtension_ce_ptr;
extern zend_class_entry *TElNameConstraint_ce_ptr;
extern zend_class_entry *TElNameConstraintsExtension_ce_ptr;
extern zend_class_entry *TElPolicyConstraintsExtension_ce_ptr;
extern zend_class_entry *TElExtendedKeyUsageExtension_ce_ptr;
extern zend_class_entry *TElDistributionPoint_ce_ptr;
extern zend_class_entry *TElCRLDistributionPointsExtension_ce_ptr;
extern zend_class_entry *TElAccessDescription_ce_ptr;
extern zend_class_entry *TElAuthorityInformationAccessExtension_ce_ptr;
extern zend_class_entry *TElSubjectDirectoryAttributesExtension_ce_ptr;
extern zend_class_entry *TElCertificateExtensions_ce_ptr;
extern zend_class_entry *TElExtensionWriter_ce_ptr;
extern zend_class_entry *TElExtensionReader_ce_ptr;

void Register_TElEDIPartyName(TSRMLS_D);
void Register_TElOtherName(TSRMLS_D);
void Register_TElPermanentIdentifier(TSRMLS_D);
void Register_TElGeneralName(TSRMLS_D);
void Register_TElGeneralNames(TSRMLS_D);
void Register_TElCustomExtension(TSRMLS_D);
void Register_TElAuthorityKeyIdentifierExtension(TSRMLS_D);
void Register_TElSubjectKeyIdentifierExtension(TSRMLS_D);
void Register_TElKeyUsageExtension(TSRMLS_D);
void Register_TElPrivateKeyUsagePeriodExtension(TSRMLS_D);
void Register_TElNetscapeCertTypeExtension(TSRMLS_D);
void Register_TElNetscapeString(TSRMLS_D);
void Register_TElNetscapeBaseURL(TSRMLS_D);
void Register_TElNetscapeRevokeURL(TSRMLS_D);
void Register_TElNetscapeCARevokeURL(TSRMLS_D);
void Register_TElNetscapeRenewalURL(TSRMLS_D);
void Register_TElNetscapeCAPolicy(TSRMLS_D);
void Register_TElNetscapeServerName(TSRMLS_D);
void Register_TElNetscapeComment(TSRMLS_D);
void Register_TElCommonName(TSRMLS_D);
void Register_TElUserNotice(TSRMLS_D);
void Register_TElSinglePolicyQualifier(TSRMLS_D);
void Register_TElSinglePolicyInformation(TSRMLS_D);
void Register_TElCertificatePoliciesExtension(TSRMLS_D);
void Register_TElPolicyMapping(TSRMLS_D);
void Register_TElPolicyMappingsExtension(TSRMLS_D);
void Register_TElAlternativeNameExtension(TSRMLS_D);
void Register_TElBasicConstraintsExtension(TSRMLS_D);
void Register_TElNameConstraint(TSRMLS_D);
void Register_TElNameConstraintsExtension(TSRMLS_D);
void Register_TElPolicyConstraintsExtension(TSRMLS_D);
void Register_TElExtendedKeyUsageExtension(TSRMLS_D);
void Register_TElDistributionPoint(TSRMLS_D);
void Register_TElCRLDistributionPointsExtension(TSRMLS_D);
void Register_TElAccessDescription(TSRMLS_D);
void Register_TElAuthorityInformationAccessExtension(TSRMLS_D);
void Register_TElSubjectDirectoryAttributesExtension(TSRMLS_D);
void Register_TElCertificateExtensions(TSRMLS_D);
void Register_TElExtensionWriter(TSRMLS_D);
void Register_TElExtensionReader(TSRMLS_D);
SB_PHP_FUNCTION(SBX509Ext, OctetsToIPAddress);
SB_PHP_FUNCTION(SBX509Ext, IPAddressToOctets);
void Register_SBX509Ext_Constants(int module_number TSRMLS_DC);
void Register_SBX509Ext_Enum_Flags(TSRMLS_D);
void Register_SBX509Ext_Aliases(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_X509EXT
SB_IMPORT uint32_t SB_APIENTRY SBX509Ext_OctetsToIPAddress(const uint8_t pOctets[], int32_t szOctets, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBX509Ext_IPAddressToOctets(const char * pcIPAddrStr, int32_t szIPAddrStr, uint8_t pOutResult[], int32_t * szOutResult);
#endif /* SB_USE_GLOBAL_PROCS_X509EXT */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBX509EXT */

