<?php 
    date_default_timezone_set("UTC");

    function DoCertificateValidate($Sender, $X509Certificate, &$Validate)
    {
        $Validate = true;
    }

    if (isset($_POST["download"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            die;
        }

        $aname = $_POST["aname"];
        $akey = $_POST["akey"];
        $devmode = (isset($_POST['devmode']) && $_POST['devmode'] == 'yes');
        $cont = $_POST["container"];
        $filename = $_POST["filename"];

        if ((strlen($aname) > 0) and (strlen($akey) > 0) and (strlen($cont) > 0) and (strlen($filename) > 0))
        {
            $storage = new TElWinAzureDataStorage(NULL);
            $https = new TElHTTPSClient(NULL);
            $https->OnCertificateValidate = "DoCertificateValidate";
            $storage->HTTPClient = $https;
            $storage->AccountName = $aname;
            $storage->AccountKey = $akey;
            $storage->DevMode = $devmode;

            try
            {
                if ($storage->ContainerExists($cont))
                {
                    if ($storage->ObjectExists($cont, $filename))
                    {
                        $yourfile = str_replace(' ', '_', $filename);
                        $tempname = tempnam(sys_get_temp_dir(), $yourfile);
                        $out = new TMemoryStream;

                        $storage->ReadObject($cont, $filename, $out);

                        $out->SaveToFile($tempname);

                        if (ob_get_level()) 
                        {
                            ob_end_clean();
                        }

                        header('Content-Description: File Transfer');
                        header('Content-Type: application/octet-stream');
                        header("Content-Disposition: attachment; filename=$yourfile");
                        header('Content-Transfer-Encoding: binary');
                        header('Expires: 0');
                        header('Cache-Control: must-revalidate');
                        header('Pragma: public');
                        header('Content-Length: ' . filesize($tempname));
                        readfile($tempname);

                        unlink($tempname);

                        return;
                    }
                    else
                    {
                        print "Entered file is not in container";
                    }
                }
                else
                {
                    print "Entered container is not in storage";
                }
            }
            catch(SBException $e) 
            {
                print "Failed to connect Azure storage: " . $e->getMessage() ." <br/>";
                return;
            }
        }
        else
        {
            $error_details = "";

            if (strlen($aname) == 0)
            {
                $error_details = $error_details . "Account name is not provided<br/>";
            }
            if (strlen($akey) == 0)
            {
                $error_details = $error_details . "Account key is not provided<br/>";
            }
            if (strlen($cont) == 0)
            {
                $error_details = $error_details . "Container is not provided<br/>";
            }
            if (strlen($filename) == 0)
            {
                $error_details = $error_details . "File to download is not provided<br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS WinAzure download demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox WinAzure download demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox WinAzure components for downloading file from storage. <br/>
              Please provide your WinAzure account name and key, file to download and click the 'Download' button to download file from storage. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">            
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="20%" align="right"> Account name: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="aname" value="eldostest" size="30" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="20%" align="right"> Account key: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="akey" value="" size="60" /> </td>
                  </tr>
                  <tr height="40">
                    <td width="20%" align="right"> </td>
                    <td width="10"></td>  
                    <td width="*" align="left"> <input type="checkbox" name="devmode" value="yes" size="60" /> <span class="mtx4">Development mode (local server)</span> </td>
                 </tr>
                  <tr height="30">
                    <td width="20%" align="right"> Container: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="container" value="" size="40" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="20%" align="right"> File: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="filename" value="" size="40" /> </td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="download" value="Download File"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>