<?php 
    date_default_timezone_set("UTC");

    $doc = new TElOfficeDocument(NULL);
    $filename = "";
    $tempname = "";

    function ShowForm()
    {
        global $doc;
        global $tempname;
        global $filename;

        echo '<html>';
        echo '<head>';
        echo '  <title>EldoS Secure Office demo (Encrypt/Decrypt)</title>';
        echo '  <style type="text/css">';
        echo '  .textheader {';
        echo '    font-family: Arial;';
        echo '    font-size: 16;';
        echo '    font-weight: bold;';
        echo '  }';
        echo '  .textnormal {';
        echo '    font-family: Arial;';
        echo '    font-size: 12;';
        echo '  }';
        echo '  </style>';
        echo '</head>';
        echo '<body>';
        echo '  <div align="center">';
        echo '  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">';
        echo '    <tr height="*"></tr>';
        echo '    <tr height="400">';
        echo '      <td width="600" valign="top">';
        echo '        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">';
        echo '          <tr height="50">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textheader">EldoS SecureBlackbox Secure Office demo (Encrypt/Decrypt)</div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="50">';
        echo '            <td width="100%" height="*" align="center" valign="center" class="textnormal">';
        echo '              <div align="center"> This sample illustrates the use of SecureBlackbox Secure Office components to encrypt/decrypt files. </div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="*">';
        echo '            <td width="100%" height="*">';
        echo '              <form action="SecureOffice_ED.php" method="post" enctype="multipart/form-data">';
        echo '                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                  <tr height="30" valign="bottom">';
        echo '                    <td width="30%" align="left"> <span class="mtx4">File info:</span> </td>';
        echo '                    <td width="10"></td>';
        echo '                    <td width="*" align="right"></td>';
        echo '                  </tr>';
        echo '                  <tr height="50">';
        echo '                    <td colspan="3" align="left">';

        $S = "Document format: " . SBOffice\DocumentFormatToString($doc->get_DocumentFormat()) . "\r\n";
        $rows = 1;
        if (!(empty($doc->get_BinaryDocument())))
        {
            $S = $S . "Document type: " . SBOffice\BinaryDocumentTypeToString($doc->get_BinaryDocument()->get_DocumentType()) . "\r\n";
            $rows++;
        }
        else
        if (!(empty($doc->get_OpenXMLDocument())))
        {
            $S = $S . "Document type: " . SBOffice\OpenXMLDocumentTypeToString($doc->get_OpenXMLDocument()->get_DocumentType()) . "\r\n";
            $rows++;
        }
        $S = $S . "\r\n";
        $rows++;

        if ($doc->get_IsEncrypted())
        {
            if (!(empty($doc->get_EncryptionHandler())))
            {
                $S = $S . "The document is ENCRYPTED using " . $doc->get_EncryptionHandler()->CastTo()->GetName() . " handler \r\n";
            }
            else
            {
                $S = $S . "The document is ENCRYPTED using UNKNOWN handler \r\n";
            }
            $rows++;

            if ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeOpenXMLStandardEncryptionHandler')
            {
                $S = $S . " - Encryption algorithm: " .
                     SBConstants\GetAlgorithmNameByAlgorithm($doc->get_EncryptionHandler()->CastTo()->get_EncryptionAlgorithm()) . " \r\n";
                $rows++;
            }
            else
            if ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeOpenXMLAgileEncryptionHandler')
            {
                $S = $S . " - Key Encryptors: " . $doc->get_EncryptionHandler()->CastTo()->get_KeyEncryptorCount() . " \r\n";
                $S = $S . " - Cipher algorithm: " .
                     SBConstants\GetAlgorithmNameByAlgorithm($doc->get_EncryptionHandler()->CastTo()->get_CipherAlgorithm()) . " \r\n";
                $S = $S . " - Hash algorithm: " .
                     SBConstants\GetAlgorithmNameByAlgorithm($doc->get_EncryptionHandler()->CastTo()->get_HashAlgorithm()) . " \r\n";
                $rows = $rows + 3;
            }
            else
            if ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeBinaryRC4CryptoAPIEncryptionHandler')
            {
                $S = $S . " - Key length: " . $doc->get_EncryptionHandler()->CastTo()->get_KeyLength() . " \r\n";
                if ($doc->get_EncryptionHandler()->CastTo()->get_EncryptDocumentProperties())
                {
                    $S = $S . " - Document properties are encrypted \r\n";
                }
                else
                {
                    $S = $S . " - Document properties are NOT encrypted \r\n";
                }
                $rows = $rows + 2;
            }
        }

        if ($doc->get_IsSigned())
        {
            $S = $S . "Document is SIGNED \r\n";
            $rows++;
        }

        if ((!$doc->get_IsEncrypted()) and (!$doc->get_IsSigned()))
        {
            $S = $S . "Document is neither encrypted nor signed \r\n";
            $rows++;
        }

        if (!empty($doc->get_OpenXMLDocument()))
        {
            if ($doc->get_OpenXMLDocument()->CastTo()->get_SignatureLineCount() > 0)
            {
                $S = $S . "Document contains " . $doc->get_OpenXMLDocument()->CastTo()->get_SignatureLineCount() . " signature line(s) \r\n";
                $rows++;
            }
        }
        else if (!empty($doc->get_OpenXPSDocument()))
        {
            if ($doc->get_OpenXPSDocument()->CastTo()->get_SignatureDefinitionCount() > 0)
            {
                $S = $S . "Document contains " . $doc->get_OpenXMLDocument()->CastTo()->get_SignatureDefinitionCount() . " signature definiotion(s) \r\n";
                $rows++;
            }
        }

        echo '                      <textarea readonly name="info" cols=60 rows=' . $rows . '>';
        echo $S;
        echo '                      </textarea>';
        echo '                    </td>';
        echo '                  </tr>';

        echo '                  <tr height="0" valign="bottom">';
        echo '                    <td colspan="3" align="left"> <input type="hidden" name="inputfile" value="' . $tempname . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="0" valign="bottom">';
        echo '                    <td colspan="3" align="left"> <input type="hidden" name="filename" value="' . $filename . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="60" valign="bottom">';
        echo '                    <td colspan="3" align="left">';
        if ($doc->get_Encryptable())
        {
            if (($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfBinary) or 
                ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXML))
            {
                echo '                      <fieldset class="textnormal">';
            }
            else
            {
                echo '                      <fieldset class="textnormal" disabled="disabled">';
            }
        }
        else
        {
           echo '                      <fieldset class="textnormal" disabled="disabled">';
        }
        echo '                      <legend class="lgd">Encryption options </legend>';
        echo '                        <table class="textnormal" width="100%">';
        echo '                          <tr height="30">';
        echo '                            <td width="30%" align="left"> Encryption type </td>';
        echo '                            <td width="*" align="left">';

        if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfBinary)
        {
            echo '                              <select name="enctype" size="1" onchange="this.form.keylen.disabled=!(this.form.enctype.value == 1);this.form.encprop.disabled=!(this.form.enctype.value == 1)">';
            echo '                                <option value=0 selected>RC4/40 bits</option>';
            echo '                                <option value=1>RC4 CryptoAPI</option>';
        }

        if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXML)
        {
            echo '                              <select name="enctype" size="1" onchange="this.form.hashalg.disabled=!(this.form.enctype.value == 1);this.form.spin.disabled=!(this.form.enctype.value == 1);this.form.salt.disabled=!(this.form.enctype.value == 1)">';
            echo '                                <option value=0 selected>Standard</option>';
            echo '                                <option value=1>Agile (Office 2007 SP2, 2010)</option>';
        }

        echo '                              </select>';
        echo '                            <td>';
        echo '                            <td width="30%" align="left"></td>';
        echo '                            <td width="*" align="left"></td>';
        echo '                          </tr>';

        if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfBinary)
        {
            echo '                          <tr height="30">';
            echo '                            <td width="30%" align="left"> Key length </td>';
            echo '                            <td width="*" align="left"> <input type="text" name="keylen" value="128" size="30" disabled/> </td>';
            echo '                            <td width="30%" align="left"></td>';
            echo '                            <td width="*" align="left"></td>';
            echo '                          </tr>';
            echo '                          <tr height="30">';
            echo '                            <td colspan="6" align="left"> <label><input type="checkbox" name="encprop" value="yes" checked="checked" disabled/> Encrypt document properties </label> </td>';
            echo '                          </tr>';
            echo '                          <tr height="30">';
            echo '                            <td width="30%" align="left"> Password </td>';
            echo '                            <td width="*" align="left"> <input type="password" name="passwordE" value="" size="25" /> </td>';
            echo '                            <td width="30%" align="left"></td>';
            echo '                            <td width="*" align="left"></td>';
            echo '                          </tr>';
        }
        else
        if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXML)
        {
            echo '                          <tr height="30">';
            echo '                            <td width="30%" align="left"> Encryption algorithm </td>';
            echo '                            <td width="*" align="left">';
            echo '                              <select name="encalg" size="1">';
            echo '                                <option value=0 selected>' . SBConstants\GetAlgorithmNameByAlgorithm(SBConstants\SB_ALGORITHM_CNT_AES128) . '</option>';
            echo '                                <option value=1>' . SBConstants\GetAlgorithmNameByAlgorithm(SBConstants\SB_ALGORITHM_CNT_AES192) . '</option>';
            echo '                                <option value=2>' . SBConstants\GetAlgorithmNameByAlgorithm(SBConstants\SB_ALGORITHM_CNT_AES256) . '</option>';
            echo '                              </select>';
            echo '                            </td>';
            echo '                            <td width="30%" align="left"> Hash algorithm</td>';
            echo '                            <td width="*" align="left">';
            echo '                              <select name="hashalg" size="1" disabled>';
            echo '                                <option value=0 selected> SHA-1 </option>';
            echo '                                <option value=1> SHA-256 </option>';
            echo '                                <option value=2> SHA-384 </option>';
            echo '                                <option value=3> SHA-512 </option>';
            echo '                                <option value=4> MD5 </option>';
            echo '                                <option value=5> RIPEMD-160 </option>';
            echo '                              </select>';
            echo '                            </td>';
            echo '                          </tr>';
            echo '                          <tr height="30">';
            echo '                            <td width="30%" align="left"> Spin count </td>';
            echo '                            <td width="*" align="left"> <input type="text" name="spin" value="100000" size="10" disabled/> </td>';
            echo '                            <td width="30%" align="left"> Salt size</td>';
            echo '                            <td width="*" align="left"> <input type="text" name="salt" value="16" size="5" disabled/> </td>';
            echo '                          </tr>';
            echo '                          <tr height="30">';
            echo '                            <td width="30%" align="left"> Password </td>';
            echo '                            <td width="*" align="left"> <input type="password" name="passwordE" value="" size="25" /> </td>';
            echo '                            <td width="30%" align="left"></td>';
            echo '                            <td width="*" align="left"></td>';
            echo '                          </tr>';
        }

        echo '                          <tr height="30" valign="bottom">';
        echo '                            <td colspan="4" align="center"> <input type="submit" name="encrypt" value="Encrypt"/> </td>';
        echo '                          </tr>';

        echo '                        </table>';
        echo '                      </fieldset>';
        echo '                    </td>';
        echo '                  </tr>';
        echo '                  <tr height="60" valign="bottom">';
        echo '                    <td colspan="3" align="left">';
        if ($doc->get_IsEncrypted())
        {
            if (($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeOpenXMLStandardEncryptionHandler') or
                ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeOpenXMLAgileEncryptionHandler') or
                ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeBinaryRC4EncryptionHandler') or
                ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeBinaryRC4CryptoAPIEncryptionHandler'))
            {
                echo '                      <fieldset class="textnormal">';
            }
            else
            {
                echo '                      <fieldset class="textnormal" disabled="disabled">';
            }
        }
        else
        {
            echo '                      <fieldset class="textnormal" disabled="disabled">';
        }
        echo '                      <legend class="lgd">Decryption options </legend>';
        echo '                        <table class="textnormal" width="100%">';
        echo '                          <tr height="30">';
        echo '                            <td width="23%" align="left"> Password </td>';
        echo '                            <td width="*" align="left"> <input type="password" name="passwordD" value="" size="25" /> </td>';
        echo '                          </tr>';
        echo '                          <tr height="30" valign="bottom">';
        echo '                            <td colspan="2" align="center"> <input type="submit" name="decrypt" value="Decrypt"/> </td>';
        echo '                          </tr>';
        echo '                        </table>';
        echo '                      </fieldset>';
        echo '                    </td>';
        echo '                  </tr>';
        echo '                  <tr height="30" valign="bottom">';
        echo '                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>';
        echo '                  </tr>';
        echo '                </table>';
        echo '              </form>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="20">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>';
        echo '            </td>';
        echo '          </tr>';
        echo '        </table>';
        echo '      </td>';
        echo '    </tr>';
        echo '    <tr height="*"></tr>';
        echo '  </table>';
        echo '  </div>';
        echo '</body>';
        echo '</html>';
    }

    if (isset($_POST["decrypt"])) 
    {
        $inputfile = $_POST["inputfile"];
        $filename = $_POST["filename"];
        $password = $_POST["passwordD"];

        if (strlen($password) > 0)
        {
            try
            {
                $doc->Open($inputfile, false);

                if (($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeBinaryRC4EncryptionHandler') or
                    ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeBinaryRC4CryptoAPIEncryptionHandler') or
                    ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeOpenXMLStandardEncryptionHandler'))
                {
                    $doc->get_EncryptionHandler()->CastTo()->set_Password($password);

                    if (!($doc->get_EncryptionHandler()->CastTo()->IsPasswordValid()))
                    {
                        print "Invalid password";
                        return;
                    }
                }

                if ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeOpenXMLAgileEncryptionHandler')
                {
                    $found = false;

                    $handler = $doc->get_EncryptionHandler()->CastTo();
                    for ($i = 0; $i <= $handler->get_KeyEncryptorCount - 1; $i++)
                    {
                        if ($handler->get_KeyEncryptors($i)->ClassName_Inst() == 'TElOfficeOpenXMLPasswordKeyEncryptor')
                        {
                            $handler->get_KeyEncryptors($i)->CastTo()->set_Password($password);

                            if ($handler->get_KeyEncryptors($i)->CastTo()->IsPasswordValid())
                            {
                               $found = true;
                               break;
                            }
                        }
                    }

                    if (!($found))
                    {
                        print "Invalid password";
                        return;
                    }
                }

                $yourfile = basename($filename) . ".tmp";
                $tempname = tempnam(sys_get_temp_dir(), $yourfile);

                $stream = new TMemoryStream;

                $doc->DecryptTo($stream);

                $stream->SaveToFile($tempname);

                if (ob_get_level()) 
                {
                        ob_end_clean();
                }

                header('Content-Description: File Transfer');
                header('Content-Type: application/octet-stream');
                header("Content-Disposition: attachment; filename=$filename");
                header('Content-Transfer-Encoding: binary');
                header('Expires: 0');
                header('Cache-Control: must-revalidate');
                header('Pragma: public');
                header('Content-Length: ' . filesize($tempname));
                readfile($tempname);

                unlink($tempname);
                unlink($inputfile);

                return;
                //print "Decrypt succeeded";
            }
            catch(SBException $e)
            {
                print $e->getMessage();
            }
        }
        else
        {
            print "Password for decrypt is not provided";
        }
    }

    if (isset($_POST["encrypt"])) 
    {
        $inputfile = $_POST["inputfile"];
        $filename = $_POST["filename"];
        $enctype = $_POST["enctype"];
        $password = $_POST["passwordE"];

        if (isset($_POST['keylen'])) {$keylen = $_POST["keylen"];}
        $encprop = (isset($_POST['encprop']) && $_POST['encprop'] == 'yes');

        if (isset($_POST['encalg'])) {$encalg = $_POST["encalg"];}
        if (isset($_POST['hashalg'])) {$hashalg = $_POST["hashalg"];}
        if (isset($_POST['spin'])) {$spin = $_POST["spin"];}
        if (isset($_POST['salt'])) {$salt = $_POST["salt"];}

        if (strlen($password) > 0)
        {
            try
            {
                $doc->Open($inputfile, false);

                $handler;
                if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfBinary)
                {
                    if ($enctype == 0)
                    {
                        $handler = new TElOfficeBinaryRC4EncryptionHandler(NULL);
                    }
                    else
                    {
                        $handler = new TElOfficeBinaryRC4CryptoAPIEncryptionHandler(NULL);
                        $handler->set_KeyLength($keylen);
                        $handler->set_EncryptDocumentProperties($encprop);
                    }
                    $handler->set_Password($password);

                    $doc->set_EncryptionHandler($handler);
                }

                if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXML)
                {
                    if ($enctype == 0)
                    {
                        $handler = new TElOfficeOpenXMLStandardEncryptionHandler(NULL);
                        $handler->Reset();
                        switch ($encalg) {
                            case 0 : $handler->set_EncryptionAlgorithm(SBConstants\SB_ALGORITHM_CNT_AES128); break;
                            case 1 : $handler->set_EncryptionAlgorithm(SBConstants\SB_ALGORITHM_CNT_AES192); break;
                            case 2 : $handler->set_EncryptionAlgorithm(SBConstants\SB_ALGORITHM_CNT_AES256); break;
                            default: $handler->set_EncryptionAlgorithm(SBConstants\SB_ALGORITHM_UNKNOWN);
                        }
                        $handler->set_Password($password);
                    }
                    else
                    {
                        $handler = new TElOfficeOpenXMLAgileEncryptionHandler(NULL);
                        $handler->Reset();
                        switch ($encalg) {
                            case 0 : $handler->set_CipherAlgorithm(SBConstants\SB_ALGORITHM_CNT_AES128); break;
                            case 1 : $handler->set_CipherAlgorithm(SBConstants\SB_ALGORITHM_CNT_AES192); break;
                            case 2 : $handler->set_CipherAlgorithm(SBConstants\SB_ALGORITHM_CNT_AES256); break;
                            default: $handler->set_CipherAlgorithm(SBConstants\SB_ALGORITHM_UNKNOWN);
                        }
                        switch ($hashalg) {
                            case 0 : $handler->set_HashAlgorithm(SBConstants\SB_ALGORITHM_DGST_SHA1); break;
                            case 1 : $handler->set_HashAlgorithm(SBConstants\SB_ALGORITHM_DGST_SHA256); break;
                            case 2 : $handler->set_HashAlgorithm(SBConstants\SB_ALGORITHM_DGST_SHA384); break;
                            case 3 : $handler->set_HashAlgorithm(SBConstants\SB_ALGORITHM_DGST_SHA512); break;
                            case 4 : $handler->set_HashAlgorithm(SBConstants\SB_ALGORITHM_DGST_MD5); break;
                            case 5 : $handler->set_HashAlgorithm(SBConstants\SB_ALGORITHM_DGST_RIPEMD160); break;
                        }
                        $handler->set_SaltSize($salt);

                        $k = $handler->AddPasswordKeyEncryptor($password);
                        $key = $handler->get_KeyEncryptors($k);
                        $key->set_CipherAlgorithm($handler->get_CipherAlgorithm());
                        $key->set_HashAlgorithm($handler->get_HashAlgorithm());
                        $key->set_SpinCount($spin);
                        $key->set_SaltSize($salt);
                    }

                    $doc->set_EncryptionHandler($handler);
                }

                $yourfile = basename($filename) . ".tmp";
                $tempname = tempnam(sys_get_temp_dir(), $yourfile);

                $stream = new TMemoryStream;

                $doc->EncryptTo($stream);

                $stream->SaveToFile($tempname);

                if (ob_get_level()) 
                {
                        ob_end_clean();
                }

                header('Content-Description: File Transfer');
                header('Content-Type: application/octet-stream');
                header("Content-Disposition: attachment; filename=$filename");
                header('Content-Transfer-Encoding: binary');
                header('Expires: 0');
                header('Cache-Control: must-revalidate');
                header('Pragma: public');
                header('Content-Length: ' . filesize($tempname));
                readfile($tempname);

                unlink($tempname);
                unlink($inputfile);

                return;
                //print "Encrypt succeeded";
            }
            catch(SBException $e)
            {
                print $e->getMessage();
            }
        }
        else
        {
            print "Password for encrypt is not provided";
        }
    }

    if (isset($_POST["open"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly";
            die;
        }

        $inputfile = $_FILES["inputfile"]["tmp_name"];
        $filename = $_FILES["inputfile"]["name"];

        if (strlen($inputfile) > 0)
        {
            $tempname = tempnam(sys_get_temp_dir(), $filename);

            if (!copy($inputfile, $tempname)) 
            {
                print "Can not copy $inputfile...\n";
                die;
            }

            try
            {
                $doc->Open($tempname, true);

                ShowForm();

                $doc->Close();
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
            }
        }
        else
        {
            print "Office file is not provided";
        }
    }
?>