<?php 
    date_default_timezone_set("UTC");

    $storage = new TElPKCS11CertStorage(NULL);
    $inputfile = "";
    $nss = false;
    $nssdir = "";

    function ShowForm()
    {
        global $storage;
        global $inputfile;
        global $nss;
        global $nssdir;

        echo '<html>';
        echo '<head>';
        echo '  <title>EldoS Crypto Token demo</title>';
        echo '  <style type="text/css">';
        echo '  .textheader {';
        echo '    font-family: Arial;';
        echo '    font-size: 16;';
        echo '    font-weight: bold;';
        echo '  }';
        echo '  .textnormal {';
        echo '    font-family: Arial;';
        echo '    font-size: 12;';
        echo '  }';
        echo '  </style>';
        echo '</head>';
        echo '<body>';
        echo '  <div align="center">';
        echo '  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">';
        echo '    <tr height="*"></tr>';
        echo '    <tr height="400">';
        echo '      <td width="600" valign="top">';
        echo '        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">';
        echo '          <tr height="50">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textheader">EldoS SecureBlackbox Crypto Token demo</div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="70">';
        echo '            <td width="100%" height="*" align="center" valign="center" class="textnormal">';
        echo '              <div align="center"> This sample illustrates the use of SecureBlackbox PKCS11 components. <br/>';
        echo '              Please choise slot, slot pin and click the "Open" button to open slot of pkcs11 file. </div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="*">';
        echo '            <td width="100%" height="*">';
        echo '              <form action="CryptoToken.php"  method="post" enctype="multipart/form-data">';
        echo '                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                  <tr height="0">';
        echo '                    <td colspan="3"> <input type="hidden" name="inputfile" value="' . $inputfile . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="0">';
        echo '                    <td colspan="3"> <input type="hidden" name="nss" value="' . $nss . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="0">';
        echo '                    <td colspan="3"> <input type="hidden" name="nssdir" value="' . $nssdir . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="30">';
        echo '                    <td width="40%" align="right"> Available slots </td>';
        echo '                    <td width="10"></td>';
        echo '                    <td width="*" align="left">';
        echo '                      <select name="slots" size="1">';
        echo '                        <option value=0 selected>&lt;Please select a slot&gt;</option>';

        for ($i = 0; $i <= $storage->get_Module()->SlotCount - 1; $i++)
        {
            $SlotInfo = $storage->get_Module()->get_Slot($i);
            echo '                        <option value=' . ($i + 1) . '>' . $SlotInfo->get_SlotDescription() . '</option>';
        }

        echo '                      </select>';
        echo '                    </td>';
        echo '                  </tr>';
        echo '                  <tr height="40">';
        echo '                    <td width="40%" align="right"> PIN </td>';
        echo '                    <td width="10"></td>';
        echo '                    <td width="*" align="left"> <input type="password" name="password" value="" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="45" valign="center">';
        echo '                    <td colspan="3" align="center"> <input type="submit" name="openslot" value="Open slot"/> </td>';
        echo '                  </tr>';
        echo '                  <tr height="30" valign="bottom">';
        echo '                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>';
        echo '                  </tr>';
        echo '                </table>';
        echo '              </form>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="20">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>';
        echo '            </td>';
        echo '          </tr>';
        echo '        </table>';
        echo '      </td>';
        echo '    </tr>';
        echo '    <tr height="*"></tr>';
        echo '  </table>';
        echo '  </div>  ';
        echo '</body>';
        echo '</html>';
    }

    if (isset($_POST["openslot"])) 
    {
        $inputfile = $_POST["inputfile"];
        $path_info = pathinfo($inputfile);
        $filename = $path_info['basename'];
        $dirname = $path_info['dirname'];
        $nss = $_POST["nss"];
        $nssdir = $_POST["nssdir"];
        $slot = $_POST["slots"];
        $pin = $_POST["password"];

        if (isset($_POST['password'])) {$password = $_POST['password'];}

        if (strlen($slot) > 0)
        {
            $storage->set_DLLName($inputfile);

            //adding dll directory to the $PATH environment variable
            $oldpath = getenv('PATH');
            putenv('PATH=' . getenv('PATH') . PATH_SEPARATOR . $dirname);

            if ($nss)
            {
                $storage->get_NSSParams()->set_UseNSSMode(true);
                // NSS library expects forward slashes
                $S = str_replace("\\", "/", $nssdir);
                $storage->get_NSSParams()->set_ConfigDir($S);
            }

            try
            {
                $storage->Open();

                if (!$storage->get_Module()->get_Slot($slot - 1)->TokenPresent)
                {
                    print 'Token not found in specified slot';
                    return;
                }

                // Opening new session
                $RO = $storage->get_Module()->get_Slot($slot - 1)->ReadOnly;
                try
                {
                    $session = $storage->OpenSession($slot - 1, $RO);
                }
                catch(SBException $e) 
                {
                    if (!$RO)
                    {
                        $session = $storage->OpenSession($slot - 1, true);
                    }
                    else
                    {
                        print 'Error opening session for slot : ' . $storage->get_Module()->get_Slot($slot - 1)->get_SlotDescription() . ' <br/> ' . $e->getMessage();
                        return;
                    }
                }

                if ($session != NULL)
                {
                    try
                    {
                        $session->Login(TElPKCS11UserType::utUser, $pin);
                    }
                    catch(SBException $e) 
                    {
                        $storage->CloseSession(0);
                        $session = NULL;
                        print 'Error login session <br/>' . $e->getMessage();
                        return;
                    }

                    print 'Certificates in storage : ' . $storage->Count . '<br/> <br/>';

                    for ($i = 0; $i <= $storage->Count - 1; $i++)
                    {
                        print '&nbsp;&nbsp;Certificate #' . ($i+1) . '<br/>';

                        $Cert = $storage->get_Certificates($i);
                        // Subject
                        print '&nbsp;&nbsp;&nbsp;&nbsp;Subject : ' . SBRDN\FormatRDN($Cert->get_SubjectRDN()) . '<br/>';
                        // Issuer
                        print '&nbsp;&nbsp;&nbsp;&nbsp;Issuer : ' . SBRDN\FormatRDN($Cert->get_IssuerRDN()) . '<br/>';
                        // Validity period }
                        print '&nbsp;&nbsp;&nbsp;&nbsp;Valid from : ' . $Cert->get_ValidFrom()->format('d-m-Y H:i:s') . '<br/>';
                        print '&nbsp;&nbsp;&nbsp;&nbsp;Valid to : ' . $Cert->get_ValidTo()->format('d-m-Y H:i:s') . '<br/>';
                        // Algorithm
                        switch ($Cert->get_PublicKeyAlgorithm())
                        {
                            case SBConstants\SB_CERT_ALGORITHM_ID_RSA_ENCRYPTION : $S = "RSA"; break;
                            case SBConstants\SB_CERT_ALGORITHM_ID_DSA : $S = "DSA"; break;
                            case SBConstants\SB_CERT_ALGORITHM_DH_PUBLIC : $S = "DH"; break;
                            default : $S = "Unknown";
                        }
                        $S = $S . ' (' . $Cert->GetPublicKeySize() . ' bits)';
                        if ($Cert->PrivateKeyExists) {$S = $S . ' (priv)';}
                        print '&nbsp;&nbsp;&nbsp;&nbsp;Algorithm : ' . $S . '<br/>';
                    }
                }

            }
            catch(SBException $e) 
            {
                $storage = NULL;
                print 'Error opening storage: ' . $filename . ' <br/> ' . $e->getMessage();
                return;
            }
            
            return;
        }
        else
        {
            print "Choose a slot in storage. <br/><br/>";
        }
    }

    if (isset($_POST["open"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly";
            die;
        }

        $inputfile = $_POST["inputfile"];
        $path_info = pathinfo($inputfile);
        $ext = $path_info['extension'];
        $filename = $path_info['basename'];
        $dirname = $path_info['dirname'];
        $nss = (isset($_POST['nss']) && $_POST['nss'] == 'yes');
        if (isset($_POST['nssdir'])) {$nssdir = $_POST['nssdir'];}

        if (strlen($inputfile) > 0)
        {
            if ($ext != 'dll')
            {
                print 'PKCS11 file must have dll extension';
                return;
            }

            $storage->set_DLLName($inputfile);

            //adding dll directory to the $PATH environment variable
            $oldpath = getenv('PATH');
            putenv('PATH=' . getenv('PATH') . PATH_SEPARATOR . $dirname);

            if ($nss)
            {
                $storage->get_NSSParams()->set_UseNSSMode(true);
                // NSS library expects forward slashes
                $S = str_replace("\\", "/", $nssdir);
                $storage->get_NSSParams()->set_ConfigDir($S);
            }

            try
            {
                $storage->Open();

                ShowForm();
            }
            catch(SBException $e) 
            {
                $storage = NULL;
                print 'Error opening storage: ' . $filename . ' <br/> ' . $e->getMessage();
                return;
            }

            putenv('PATH=' . $oldpath);
            return;
        }
        else
        {
            print "PKCS11 file is not provided";
        }
    }
?>