#include "sbdnssectypes.h"

zend_class_entry *TSBDNSMessageType_ce_ptr = NULL;

zend_class_entry *TSBDNSOperationCode_ce_ptr = NULL;

zend_class_entry *TSBDNSResponseCode_ce_ptr = NULL;

zend_class_entry *TSBDNSResourceType_ce_ptr = NULL;

zend_class_entry *TSBDNSSecurityStatus_ce_ptr = NULL;

zend_class_entry *TSBDNSSecurityStatuses_ce_ptr = NULL;

void SB_CALLBACK TSBDNSKeyNeededEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcOwner, int32_t szOwner, uint16_t KeyTag, uint8_t Algorithm, TElDNSPublicKeyRecordHandle * Key, int8_t * ReleaseKey)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zOwner;
	zval * zKeyTag;
	zval * zAlgorithm;
	zval * zKey;
	zval * zReleaseKey;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOwner);
	ZVAL_STRINGL(zOwner, pcOwner, szOwner, 1);
	MAKE_STD_ZVAL(zKeyTag);
	ZVAL_LONG(zKeyTag, (long)KeyTag);
	MAKE_STD_ZVAL(zAlgorithm);
	ZVAL_LONG(zAlgorithm, (long)Algorithm);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElDNSPublicKeyRecord_ce_ptr, *Key TSRMLS_CC);
	MAKE_STD_ZVAL(zReleaseKey);
	ZVAL_BOOL(zReleaseKey, (zend_bool)*ReleaseKey);

	params[0] = &zSender;
	params[1] = &zOwner;
	params[2] = &zKeyTag;
	params[3] = &zAlgorithm;
	params[4] = &zKey;
	params[5] = &zReleaseKey;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOwner);
	zval_ptr_dtor(&zKeyTag);
	zval_ptr_dtor(&zAlgorithm);
	*Key = SBGetObjectHandleCE(zKey, TElDNSPublicKeyRecord_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zKey TSRMLS_CC);
	zval_ptr_dtor(&zKey);
	*ReleaseKey = (int8_t)Z_BVAL_P(zReleaseKey);
	zval_ptr_dtor(&zReleaseKey);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBDNSKeyValidateEventRaw(void * _ObjectData, TObjectHandle Sender, TElDNSPublicKeyRecordHandle Key, int8_t * Valid)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zKey;
	zval * zValid;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElDNSPublicKeyRecord_ce_ptr, Key TSRMLS_CC);
	MAKE_STD_ZVAL(zValid);
	ZVAL_BOOL(zValid, (zend_bool)*Valid);

	params[0] = &zSender;
	params[1] = &zKey;
	params[2] = &zValid;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKey);
	*Valid = (int8_t)Z_BVAL_P(zValid);
	zval_ptr_dtor(&zValid);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElDNSResourceRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSResourceRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, Prepare)
{
	char *sCanonicalName;
	int sCanonicalName_len;
	long u4OriginalTTL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sCanonicalName, &sCanonicalName_len, &u4OriginalTTL) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecord_Prepare(SBGetObjectHandle(getThis() TSRMLS_CC), sCanonicalName, (int32_t)sCanonicalName_len, (uint32_t)u4OriginalTTL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSResourceRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, Write)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecord_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDNSResourceRecord_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1895897343, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSResourceRecord_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2100193892, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecord_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, get_ResourceClass)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecord_get_ResourceClass(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, set_ResourceClass)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecord_set_ResourceClass(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, get_ResourceCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecord_get_ResourceCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, set_ResourceCode)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecord_set_ResourceCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, get_ResourceType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResourceTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDNSResourceRecord_get_ResourceType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, set_ResourceType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecord_set_ResourceType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, get_TimeToLive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecord_get_TimeToLive(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, set_TimeToLive)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecord_set_TimeToLive(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSResourceRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_Prepare, 0, 0, 2)
	ZEND_ARG_INFO(0, CanonicalName)
	ZEND_ARG_INFO(0, OriginalTTL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_Write, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_get_ResourceClass, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_set_ResourceClass, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_get_ResourceCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_set_ResourceCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_get_ResourceType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_set_ResourceType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_get_TimeToLive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord_set_TimeToLive, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSResourceRecord_methods[] = {
	PHP_ME(TElDNSResourceRecord, Assign, arginfo_TElDNSResourceRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, Prepare, arginfo_TElDNSResourceRecord_Prepare, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, Read, arginfo_TElDNSResourceRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, Write, arginfo_TElDNSResourceRecord_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, get_Data, arginfo_TElDNSResourceRecord_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, get_Name, arginfo_TElDNSResourceRecord_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, set_Name, arginfo_TElDNSResourceRecord_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, get_ResourceClass, arginfo_TElDNSResourceRecord_get_ResourceClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, set_ResourceClass, arginfo_TElDNSResourceRecord_set_ResourceClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, get_ResourceCode, arginfo_TElDNSResourceRecord_get_ResourceCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, set_ResourceCode, arginfo_TElDNSResourceRecord_set_ResourceCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, get_ResourceType, arginfo_TElDNSResourceRecord_get_ResourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, set_ResourceType, arginfo_TElDNSResourceRecord_set_ResourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, get_TimeToLive, arginfo_TElDNSResourceRecord_get_TimeToLive, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, set_TimeToLive, arginfo_TElDNSResourceRecord_set_TimeToLive, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecord, __construct, arginfo_TElDNSResourceRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSResourceRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSResourceRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSResourceRecord", TElDNSResourceRecord_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElDNSResourceRecord_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSIPv4AddressRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSIPv4AddressRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSIPv4AddressRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSIPv4AddressRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSIPv4AddressRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSIPv4AddressRecord, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSIPv4AddressRecord_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-877998105, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSIPv4AddressRecord, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSIPv4AddressRecord_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSIPv4AddressRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSIPv4AddressRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv4AddressRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv4AddressRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv4AddressRecord_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv4AddressRecord_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv4AddressRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSIPv4AddressRecord_methods[] = {
	PHP_ME(TElDNSIPv4AddressRecord, Assign, arginfo_TElDNSIPv4AddressRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSIPv4AddressRecord, Read, arginfo_TElDNSIPv4AddressRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSIPv4AddressRecord, get_Address, arginfo_TElDNSIPv4AddressRecord_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSIPv4AddressRecord, set_Address, arginfo_TElDNSIPv4AddressRecord_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSIPv4AddressRecord, __construct, arginfo_TElDNSIPv4AddressRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSIPv4AddressRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSIPv4AddressRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSIPv4AddressRecord", TElDNSIPv4AddressRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSIPv4AddressRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSNameServerRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSNameServerRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSNameServerRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNameServerRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSNameServerRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNameServerRecord, get_HostName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSNameServerRecord_get_HostName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-621686202, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNameServerRecord, set_HostName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSNameServerRecord_set_HostName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNameServerRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSNameServerRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNameServerRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNameServerRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNameServerRecord_get_HostName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNameServerRecord_set_HostName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNameServerRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSNameServerRecord_methods[] = {
	PHP_ME(TElDNSNameServerRecord, Assign, arginfo_TElDNSNameServerRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNameServerRecord, Read, arginfo_TElDNSNameServerRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNameServerRecord, get_HostName, arginfo_TElDNSNameServerRecord_get_HostName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNameServerRecord, set_HostName, arginfo_TElDNSNameServerRecord_set_HostName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNameServerRecord, __construct, arginfo_TElDNSNameServerRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSNameServerRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSNameServerRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSNameServerRecord", TElDNSNameServerRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSNameServerRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSCanonicalNameRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSCanonicalNameRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSCanonicalNameRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSCanonicalNameRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSCanonicalNameRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSCanonicalNameRecord, get_Domain)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSCanonicalNameRecord_get_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1058713094, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSCanonicalNameRecord, set_Domain)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSCanonicalNameRecord_set_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSCanonicalNameRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSCanonicalNameRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSCanonicalNameRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSCanonicalNameRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSCanonicalNameRecord_get_Domain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSCanonicalNameRecord_set_Domain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSCanonicalNameRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSCanonicalNameRecord_methods[] = {
	PHP_ME(TElDNSCanonicalNameRecord, Assign, arginfo_TElDNSCanonicalNameRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSCanonicalNameRecord, Read, arginfo_TElDNSCanonicalNameRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSCanonicalNameRecord, get_Domain, arginfo_TElDNSCanonicalNameRecord_get_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSCanonicalNameRecord, set_Domain, arginfo_TElDNSCanonicalNameRecord_set_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSCanonicalNameRecord, __construct, arginfo_TElDNSCanonicalNameRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSCanonicalNameRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSCanonicalNameRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSCanonicalNameRecord", TElDNSCanonicalNameRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSCanonicalNameRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSStartOfAuthorityRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSStartOfAuthorityRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSStartOfAuthorityRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, get_Expire)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElDNSStartOfAuthorityRecord_get_Expire(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, set_Expire)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElDNSStartOfAuthorityRecord_set_Expire(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, get_MinimumTTL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElDNSStartOfAuthorityRecord_get_MinimumTTL(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, set_MinimumTTL)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElDNSStartOfAuthorityRecord_set_MinimumTTL(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, get_Person)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSStartOfAuthorityRecord_get_Person(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-720313996, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, set_Person)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSStartOfAuthorityRecord_set_Person(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, get_Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElDNSStartOfAuthorityRecord_get_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, set_Refresh)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElDNSStartOfAuthorityRecord_set_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, get_RefreshRetry)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElDNSStartOfAuthorityRecord_get_RefreshRetry(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, set_RefreshRetry)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElDNSStartOfAuthorityRecord_set_RefreshRetry(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, get_Serial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElDNSStartOfAuthorityRecord_get_Serial(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, set_Serial)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElDNSStartOfAuthorityRecord_set_Serial(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, get_Server)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSStartOfAuthorityRecord_get_Server(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1147017740, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, set_Server)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSStartOfAuthorityRecord_set_Server(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSStartOfAuthorityRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSStartOfAuthorityRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_get_Expire, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_set_Expire, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_get_MinimumTTL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_set_MinimumTTL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_get_Person, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_set_Person, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_get_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_set_Refresh, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_get_RefreshRetry, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_set_RefreshRetry, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_get_Serial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_set_Serial, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_get_Server, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord_set_Server, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSStartOfAuthorityRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSStartOfAuthorityRecord_methods[] = {
	PHP_ME(TElDNSStartOfAuthorityRecord, Assign, arginfo_TElDNSStartOfAuthorityRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, Read, arginfo_TElDNSStartOfAuthorityRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, get_Expire, arginfo_TElDNSStartOfAuthorityRecord_get_Expire, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, set_Expire, arginfo_TElDNSStartOfAuthorityRecord_set_Expire, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, get_MinimumTTL, arginfo_TElDNSStartOfAuthorityRecord_get_MinimumTTL, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, set_MinimumTTL, arginfo_TElDNSStartOfAuthorityRecord_set_MinimumTTL, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, get_Person, arginfo_TElDNSStartOfAuthorityRecord_get_Person, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, set_Person, arginfo_TElDNSStartOfAuthorityRecord_set_Person, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, get_Refresh, arginfo_TElDNSStartOfAuthorityRecord_get_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, set_Refresh, arginfo_TElDNSStartOfAuthorityRecord_set_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, get_RefreshRetry, arginfo_TElDNSStartOfAuthorityRecord_get_RefreshRetry, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, set_RefreshRetry, arginfo_TElDNSStartOfAuthorityRecord_set_RefreshRetry, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, get_Serial, arginfo_TElDNSStartOfAuthorityRecord_get_Serial, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, set_Serial, arginfo_TElDNSStartOfAuthorityRecord_set_Serial, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, get_Server, arginfo_TElDNSStartOfAuthorityRecord_get_Server, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, set_Server, arginfo_TElDNSStartOfAuthorityRecord_set_Server, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSStartOfAuthorityRecord, __construct, arginfo_TElDNSStartOfAuthorityRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSStartOfAuthorityRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSStartOfAuthorityRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSStartOfAuthorityRecord", TElDNSStartOfAuthorityRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSStartOfAuthorityRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSWellKnownServiceRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSWellKnownServiceRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDNSWellKnownServiceRecord_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSWellKnownServiceRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSWellKnownServiceRecord_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(380583622, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSWellKnownServiceRecord_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSWellKnownServiceRecord_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, get_Bits)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSWellKnownServiceRecord_get_Bits(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, set_Bits)
{
	long l4Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSWellKnownServiceRecord_set_Bits(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, get_Protocol)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSWellKnownServiceRecord_get_Protocol(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, set_Protocol)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSWellKnownServiceRecord_set_Protocol(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSWellKnownServiceRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSWellKnownServiceRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_get_Bits, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_set_Bits, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_get_Protocol, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord_set_Protocol, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSWellKnownServiceRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSWellKnownServiceRecord_methods[] = {
	PHP_ME(TElDNSWellKnownServiceRecord, Assign, arginfo_TElDNSWellKnownServiceRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, Clear, arginfo_TElDNSWellKnownServiceRecord_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, Read, arginfo_TElDNSWellKnownServiceRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, get_Address, arginfo_TElDNSWellKnownServiceRecord_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, set_Address, arginfo_TElDNSWellKnownServiceRecord_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, get_Count, arginfo_TElDNSWellKnownServiceRecord_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, get_Bits, arginfo_TElDNSWellKnownServiceRecord_get_Bits, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, set_Bits, arginfo_TElDNSWellKnownServiceRecord_set_Bits, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, get_Protocol, arginfo_TElDNSWellKnownServiceRecord_get_Protocol, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, set_Protocol, arginfo_TElDNSWellKnownServiceRecord_set_Protocol, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSWellKnownServiceRecord, __construct, arginfo_TElDNSWellKnownServiceRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSWellKnownServiceRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSWellKnownServiceRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSWellKnownServiceRecord", TElDNSWellKnownServiceRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSWellKnownServiceRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSDomainNamePointerRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSDomainNamePointerRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSDomainNamePointerRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDomainNamePointerRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSDomainNamePointerRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDomainNamePointerRecord, get_Domain)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSDomainNamePointerRecord_get_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1607802630, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDomainNamePointerRecord, set_Domain)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSDomainNamePointerRecord_set_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDomainNamePointerRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSDomainNamePointerRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDomainNamePointerRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDomainNamePointerRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDomainNamePointerRecord_get_Domain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDomainNamePointerRecord_set_Domain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDomainNamePointerRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSDomainNamePointerRecord_methods[] = {
	PHP_ME(TElDNSDomainNamePointerRecord, Assign, arginfo_TElDNSDomainNamePointerRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDomainNamePointerRecord, Read, arginfo_TElDNSDomainNamePointerRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDomainNamePointerRecord, get_Domain, arginfo_TElDNSDomainNamePointerRecord_get_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDomainNamePointerRecord, set_Domain, arginfo_TElDNSDomainNamePointerRecord_set_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDomainNamePointerRecord, __construct, arginfo_TElDNSDomainNamePointerRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSDomainNamePointerRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSDomainNamePointerRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSDomainNamePointerRecord", TElDNSDomainNamePointerRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSDomainNamePointerRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSHostInfoRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSHostInfoRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSHostInfoRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSHostInfoRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSHostInfoRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSHostInfoRecord, get_CPU)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSHostInfoRecord_get_CPU(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2031564919, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSHostInfoRecord, set_CPU)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSHostInfoRecord_set_CPU(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSHostInfoRecord, get_OS)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSHostInfoRecord_get_OS(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-29569558, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSHostInfoRecord, set_OS)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSHostInfoRecord_set_OS(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSHostInfoRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSHostInfoRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSHostInfoRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSHostInfoRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSHostInfoRecord_get_CPU, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSHostInfoRecord_set_CPU, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSHostInfoRecord_get_OS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSHostInfoRecord_set_OS, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSHostInfoRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSHostInfoRecord_methods[] = {
	PHP_ME(TElDNSHostInfoRecord, Assign, arginfo_TElDNSHostInfoRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSHostInfoRecord, Read, arginfo_TElDNSHostInfoRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSHostInfoRecord, get_CPU, arginfo_TElDNSHostInfoRecord_get_CPU, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSHostInfoRecord, set_CPU, arginfo_TElDNSHostInfoRecord_set_CPU, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSHostInfoRecord, get_OS, arginfo_TElDNSHostInfoRecord_get_OS, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSHostInfoRecord, set_OS, arginfo_TElDNSHostInfoRecord_set_OS, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSHostInfoRecord, __construct, arginfo_TElDNSHostInfoRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSHostInfoRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSHostInfoRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSHostInfoRecord", TElDNSHostInfoRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSHostInfoRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSMailInfoRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSMailInfoRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMailInfoRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailInfoRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSMailInfoRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailInfoRecord, get_MailboxForErrors)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSMailInfoRecord_get_MailboxForErrors(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-365231976, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailInfoRecord, set_MailboxForErrors)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSMailInfoRecord_set_MailboxForErrors(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailInfoRecord, get_ResponsibleMailbox)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSMailInfoRecord_get_ResponsibleMailbox(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(586135272, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailInfoRecord, set_ResponsibleMailbox)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSMailInfoRecord_set_ResponsibleMailbox(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailInfoRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSMailInfoRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailInfoRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailInfoRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailInfoRecord_get_MailboxForErrors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailInfoRecord_set_MailboxForErrors, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailInfoRecord_get_ResponsibleMailbox, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailInfoRecord_set_ResponsibleMailbox, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailInfoRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSMailInfoRecord_methods[] = {
	PHP_ME(TElDNSMailInfoRecord, Assign, arginfo_TElDNSMailInfoRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailInfoRecord, Read, arginfo_TElDNSMailInfoRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailInfoRecord, get_MailboxForErrors, arginfo_TElDNSMailInfoRecord_get_MailboxForErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailInfoRecord, set_MailboxForErrors, arginfo_TElDNSMailInfoRecord_set_MailboxForErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailInfoRecord, get_ResponsibleMailbox, arginfo_TElDNSMailInfoRecord_get_ResponsibleMailbox, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailInfoRecord, set_ResponsibleMailbox, arginfo_TElDNSMailInfoRecord_set_ResponsibleMailbox, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailInfoRecord, __construct, arginfo_TElDNSMailInfoRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSMailInfoRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSMailInfoRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSMailInfoRecord", TElDNSMailInfoRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSMailInfoRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSMailExchangeRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSMailExchangeRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSMailExchangeRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailExchangeRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSMailExchangeRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailExchangeRecord, get_Exchange)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSMailExchangeRecord_get_Exchange(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-230493452, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailExchangeRecord, set_Exchange)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSMailExchangeRecord_set_Exchange(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailExchangeRecord, get_Preference)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSMailExchangeRecord_get_Preference(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailExchangeRecord, set_Preference)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSMailExchangeRecord_set_Preference(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSMailExchangeRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSMailExchangeRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailExchangeRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailExchangeRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailExchangeRecord_get_Exchange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailExchangeRecord_set_Exchange, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailExchangeRecord_get_Preference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailExchangeRecord_set_Preference, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSMailExchangeRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSMailExchangeRecord_methods[] = {
	PHP_ME(TElDNSMailExchangeRecord, Assign, arginfo_TElDNSMailExchangeRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailExchangeRecord, Read, arginfo_TElDNSMailExchangeRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailExchangeRecord, get_Exchange, arginfo_TElDNSMailExchangeRecord_get_Exchange, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailExchangeRecord, set_Exchange, arginfo_TElDNSMailExchangeRecord_set_Exchange, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailExchangeRecord, get_Preference, arginfo_TElDNSMailExchangeRecord_get_Preference, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailExchangeRecord, set_Preference, arginfo_TElDNSMailExchangeRecord_set_Preference, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSMailExchangeRecord, __construct, arginfo_TElDNSMailExchangeRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSMailExchangeRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSMailExchangeRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSMailExchangeRecord", TElDNSMailExchangeRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSMailExchangeRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSTextStringsRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSTextStringsRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSTextStringsRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSTextStringsRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSTextStringsRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSTextStringsRecord, Add)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSTextStringsRecord_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSTextStringsRecord, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDNSTextStringsRecord_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSTextStringsRecord, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDNSTextStringsRecord_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSTextStringsRecord, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSTextStringsRecord_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSTextStringsRecord, get_Lines)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSTextStringsRecord_get_Lines(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(149528278, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSTextStringsRecord, set_Lines)
{
	char *sValue;
	int sValue_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSTextStringsRecord_set_Lines(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSTextStringsRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSTextStringsRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSTextStringsRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSTextStringsRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSTextStringsRecord_Add, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSTextStringsRecord_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSTextStringsRecord_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSTextStringsRecord_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSTextStringsRecord_get_Lines, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSTextStringsRecord_set_Lines, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSTextStringsRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSTextStringsRecord_methods[] = {
	PHP_ME(TElDNSTextStringsRecord, Assign, arginfo_TElDNSTextStringsRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSTextStringsRecord, Read, arginfo_TElDNSTextStringsRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSTextStringsRecord, Add, arginfo_TElDNSTextStringsRecord_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSTextStringsRecord, Clear, arginfo_TElDNSTextStringsRecord_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSTextStringsRecord, Delete, arginfo_TElDNSTextStringsRecord_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSTextStringsRecord, get_Count, arginfo_TElDNSTextStringsRecord_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSTextStringsRecord, get_Lines, arginfo_TElDNSTextStringsRecord_get_Lines, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSTextStringsRecord, set_Lines, arginfo_TElDNSTextStringsRecord_set_Lines, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSTextStringsRecord, __construct, arginfo_TElDNSTextStringsRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSTextStringsRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSTextStringsRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSTextStringsRecord", TElDNSTextStringsRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSTextStringsRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSIPv6AddressRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSIPv6AddressRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSIPv6AddressRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSIPv6AddressRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSIPv6AddressRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSIPv6AddressRecord, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSIPv6AddressRecord_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-555711352, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSIPv6AddressRecord, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSIPv6AddressRecord_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSIPv6AddressRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSIPv6AddressRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv6AddressRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv6AddressRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv6AddressRecord_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv6AddressRecord_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSIPv6AddressRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSIPv6AddressRecord_methods[] = {
	PHP_ME(TElDNSIPv6AddressRecord, Assign, arginfo_TElDNSIPv6AddressRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSIPv6AddressRecord, Read, arginfo_TElDNSIPv6AddressRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSIPv6AddressRecord, get_Address, arginfo_TElDNSIPv6AddressRecord_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSIPv6AddressRecord, set_Address, arginfo_TElDNSIPv6AddressRecord_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSIPv6AddressRecord, __construct, arginfo_TElDNSIPv6AddressRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSIPv6AddressRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSIPv6AddressRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSIPv6AddressRecord", TElDNSIPv6AddressRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSIPv6AddressRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSServiceLocationRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSServiceLocationRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSServiceLocationRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSServiceLocationRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, get_Domain)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSServiceLocationRecord_get_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1781625351, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, set_Domain)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSServiceLocationRecord_set_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSServiceLocationRecord_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, set_Port)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSServiceLocationRecord_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, get_Priority)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSServiceLocationRecord_get_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, set_Priority)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSServiceLocationRecord_set_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, get_Protocol)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSServiceLocationRecord_get_Protocol(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1638400340, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, set_Protocol)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSServiceLocationRecord_set_Protocol(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, get_Service)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSServiceLocationRecord_get_Service(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(988061976, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, set_Service)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSServiceLocationRecord_set_Service(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, get_Target)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSServiceLocationRecord_get_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1946729488, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, set_Target)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSServiceLocationRecord_set_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, get_Weight)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSServiceLocationRecord_get_Weight(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, set_Weight)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSServiceLocationRecord_set_Weight(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSServiceLocationRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSServiceLocationRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_get_Domain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_set_Domain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_get_Priority, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_set_Priority, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_get_Protocol, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_set_Protocol, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_get_Service, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_set_Service, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_get_Target, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_set_Target, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_get_Weight, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord_set_Weight, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSServiceLocationRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSServiceLocationRecord_methods[] = {
	PHP_ME(TElDNSServiceLocationRecord, Assign, arginfo_TElDNSServiceLocationRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, Read, arginfo_TElDNSServiceLocationRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, get_Domain, arginfo_TElDNSServiceLocationRecord_get_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, set_Domain, arginfo_TElDNSServiceLocationRecord_set_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, get_Port, arginfo_TElDNSServiceLocationRecord_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, set_Port, arginfo_TElDNSServiceLocationRecord_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, get_Priority, arginfo_TElDNSServiceLocationRecord_get_Priority, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, set_Priority, arginfo_TElDNSServiceLocationRecord_set_Priority, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, get_Protocol, arginfo_TElDNSServiceLocationRecord_get_Protocol, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, set_Protocol, arginfo_TElDNSServiceLocationRecord_set_Protocol, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, get_Service, arginfo_TElDNSServiceLocationRecord_get_Service, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, set_Service, arginfo_TElDNSServiceLocationRecord_set_Service, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, get_Target, arginfo_TElDNSServiceLocationRecord_get_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, set_Target, arginfo_TElDNSServiceLocationRecord_set_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, get_Weight, arginfo_TElDNSServiceLocationRecord_get_Weight, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, set_Weight, arginfo_TElDNSServiceLocationRecord_set_Weight, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSServiceLocationRecord, __construct, arginfo_TElDNSServiceLocationRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSServiceLocationRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSServiceLocationRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSServiceLocationRecord", TElDNSServiceLocationRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSServiceLocationRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSExtensionsRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSExtensionsRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSExtensionsRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSExtensionsRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, Write)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSExtensionsRecord_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, get_DNSSECOK)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSExtensionsRecord_get_DNSSECOK(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, set_DNSSECOK)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSExtensionsRecord_set_DNSSECOK(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSExtensionsRecord_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, set_Flags)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSExtensionsRecord_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, get_PayloadSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSExtensionsRecord_get_PayloadSize(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, set_PayloadSize)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSExtensionsRecord_set_PayloadSize(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, get_ResponseCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSExtensionsRecord_get_ResponseCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, set_ResponseCode)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSExtensionsRecord_set_ResponseCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSExtensionsRecord_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, set_Version)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSExtensionsRecord_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSExtensionsRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSExtensionsRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_Write, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_get_DNSSECOK, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_set_DNSSECOK, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_get_PayloadSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_set_PayloadSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_get_ResponseCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_set_ResponseCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSExtensionsRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSExtensionsRecord_methods[] = {
	PHP_ME(TElDNSExtensionsRecord, Assign, arginfo_TElDNSExtensionsRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, Read, arginfo_TElDNSExtensionsRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, Write, arginfo_TElDNSExtensionsRecord_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, get_DNSSECOK, arginfo_TElDNSExtensionsRecord_get_DNSSECOK, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, set_DNSSECOK, arginfo_TElDNSExtensionsRecord_set_DNSSECOK, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, get_Flags, arginfo_TElDNSExtensionsRecord_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, set_Flags, arginfo_TElDNSExtensionsRecord_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, get_PayloadSize, arginfo_TElDNSExtensionsRecord_get_PayloadSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, set_PayloadSize, arginfo_TElDNSExtensionsRecord_set_PayloadSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, get_ResponseCode, arginfo_TElDNSExtensionsRecord_get_ResponseCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, set_ResponseCode, arginfo_TElDNSExtensionsRecord_set_ResponseCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, get_Version, arginfo_TElDNSExtensionsRecord_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, set_Version, arginfo_TElDNSExtensionsRecord_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSExtensionsRecord, __construct, arginfo_TElDNSExtensionsRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSExtensionsRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSExtensionsRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSExtensionsRecord", TElDNSExtensionsRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSExtensionsRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSPublicKeyRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSPublicKeyRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSPublicKeyRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSPublicKeyRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSPublicKeyRecord_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, set_Algorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSPublicKeyRecord_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSPublicKeyRecord_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, set_Flags)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSPublicKeyRecord_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, get_KeyTag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSPublicKeyRecord_get_KeyTag(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, get_Protocol)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSPublicKeyRecord_get_Protocol(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, set_Protocol)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSPublicKeyRecord_set_Protocol(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, get_PublicKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDNSPublicKeyRecord_get_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-674564403, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, set_PublicKey)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDNSPublicKeyRecord_set_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, get_SecureEntryPoint)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSPublicKeyRecord_get_SecureEntryPoint(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, set_SecureEntryPoint)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSPublicKeyRecord_set_SecureEntryPoint(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, get_ZoneKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSPublicKeyRecord_get_ZoneKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, set_ZoneKey)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSPublicKeyRecord_set_ZoneKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSPublicKeyRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSPublicKeyRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_get_KeyTag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_get_Protocol, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_set_Protocol, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_get_PublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_set_PublicKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_get_SecureEntryPoint, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_set_SecureEntryPoint, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_get_ZoneKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord_set_ZoneKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSPublicKeyRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSPublicKeyRecord_methods[] = {
	PHP_ME(TElDNSPublicKeyRecord, Assign, arginfo_TElDNSPublicKeyRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, Read, arginfo_TElDNSPublicKeyRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, get_Algorithm, arginfo_TElDNSPublicKeyRecord_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, set_Algorithm, arginfo_TElDNSPublicKeyRecord_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, get_Flags, arginfo_TElDNSPublicKeyRecord_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, set_Flags, arginfo_TElDNSPublicKeyRecord_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, get_KeyTag, arginfo_TElDNSPublicKeyRecord_get_KeyTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, get_Protocol, arginfo_TElDNSPublicKeyRecord_get_Protocol, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, set_Protocol, arginfo_TElDNSPublicKeyRecord_set_Protocol, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, get_PublicKey, arginfo_TElDNSPublicKeyRecord_get_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, set_PublicKey, arginfo_TElDNSPublicKeyRecord_set_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, get_SecureEntryPoint, arginfo_TElDNSPublicKeyRecord_get_SecureEntryPoint, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, set_SecureEntryPoint, arginfo_TElDNSPublicKeyRecord_set_SecureEntryPoint, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, get_ZoneKey, arginfo_TElDNSPublicKeyRecord_get_ZoneKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, set_ZoneKey, arginfo_TElDNSPublicKeyRecord_set_ZoneKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSPublicKeyRecord, __construct, arginfo_TElDNSPublicKeyRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSPublicKeyRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSPublicKeyRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSPublicKeyRecord", TElDNSPublicKeyRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSPublicKeyRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSDelegationSignerRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSDelegationSignerRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSDelegationSignerRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSDelegationSignerRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, Validate)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElDNSPublicKeyRecord_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSDelegationSignerRecord_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSPublicKeyRecord)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSDelegationSignerRecord_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, set_Algorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSDelegationSignerRecord_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, get_Digest)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDNSDelegationSignerRecord_get_Digest(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(332889387, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, set_Digest)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDNSDelegationSignerRecord_set_Digest(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, get_DigestType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSDelegationSignerRecord_get_DigestType(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, set_DigestType)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSDelegationSignerRecord_set_DigestType(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, get_KeyTag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSDelegationSignerRecord_get_KeyTag(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, set_KeyTag)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSDelegationSignerRecord_set_KeyTag(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSDelegationSignerRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSDelegationSignerRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_Validate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElDNSPublicKeyRecord, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_get_Digest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_set_Digest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_get_DigestType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_set_DigestType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_get_KeyTag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord_set_KeyTag, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSDelegationSignerRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSDelegationSignerRecord_methods[] = {
	PHP_ME(TElDNSDelegationSignerRecord, Assign, arginfo_TElDNSDelegationSignerRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, Read, arginfo_TElDNSDelegationSignerRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, Validate, arginfo_TElDNSDelegationSignerRecord_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, get_Algorithm, arginfo_TElDNSDelegationSignerRecord_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, set_Algorithm, arginfo_TElDNSDelegationSignerRecord_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, get_Digest, arginfo_TElDNSDelegationSignerRecord_get_Digest, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, set_Digest, arginfo_TElDNSDelegationSignerRecord_set_Digest, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, get_DigestType, arginfo_TElDNSDelegationSignerRecord_get_DigestType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, set_DigestType, arginfo_TElDNSDelegationSignerRecord_set_DigestType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, get_KeyTag, arginfo_TElDNSDelegationSignerRecord_get_KeyTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, set_KeyTag, arginfo_TElDNSDelegationSignerRecord_set_KeyTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSDelegationSignerRecord, __construct, arginfo_TElDNSDelegationSignerRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSDelegationSignerRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSDelegationSignerRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSDelegationSignerRecord", TElDNSDelegationSignerRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSDelegationSignerRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSSignatureRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSSignatureRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, Prepare)
{
	char *sCanonicalName;
	int sCanonicalName_len;
	long u4AOriginalTTL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sCanonicalName, &sCanonicalName_len, &u4AOriginalTTL) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_Prepare(SBGetObjectHandle(getThis() TSRMLS_CC), sCanonicalName, (int32_t)sCanonicalName_len, (uint32_t)u4AOriginalTTL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSSignatureRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, Validate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSSignatureRecord_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSSignatureRecord_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_Algorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_CoveredCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSSignatureRecord_get_CoveredCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_CoveredCode)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_set_CoveredCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_CoveredType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResourceTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDNSSignatureRecord_get_CoveredType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_CoveredType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_set_CoveredType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_Expiration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElDNSSignatureRecord_get_Expiration(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_Expiration)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_set_Expiration(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_Inception)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElDNSSignatureRecord_get_Inception(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_Inception)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_set_Inception(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_KeyTag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSSignatureRecord_get_KeyTag(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_KeyTag)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_set_KeyTag(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_Labels)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSSignatureRecord_get_Labels(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_Labels)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_set_Labels(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_OriginalTTL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElDNSSignatureRecord_get_OriginalTTL(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_OriginalTTL)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_set_OriginalTTL(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_Signature)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDNSSignatureRecord_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1952464262, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_Signature)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDNSSignatureRecord_set_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, get_Signer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSSignatureRecord_get_Signer(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2006861517, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, set_Signer)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSSignatureRecord_set_Signer(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSSignatureRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSSignatureRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_Prepare, 0, 0, 2)
	ZEND_ARG_INFO(0, CanonicalName)
	ZEND_ARG_INFO(0, AOriginalTTL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_Validate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_CoveredCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_CoveredCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_CoveredType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_CoveredType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_Expiration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_Expiration, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_Inception, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_Inception, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_KeyTag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_KeyTag, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_Labels, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_Labels, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_OriginalTTL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_OriginalTTL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_Signature, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_get_Signer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord_set_Signer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSSignatureRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSSignatureRecord_methods[] = {
	PHP_ME(TElDNSSignatureRecord, Assign, arginfo_TElDNSSignatureRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, Prepare, arginfo_TElDNSSignatureRecord_Prepare, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, Read, arginfo_TElDNSSignatureRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, Validate, arginfo_TElDNSSignatureRecord_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_Algorithm, arginfo_TElDNSSignatureRecord_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_Algorithm, arginfo_TElDNSSignatureRecord_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_CoveredCode, arginfo_TElDNSSignatureRecord_get_CoveredCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_CoveredCode, arginfo_TElDNSSignatureRecord_set_CoveredCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_CoveredType, arginfo_TElDNSSignatureRecord_get_CoveredType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_CoveredType, arginfo_TElDNSSignatureRecord_set_CoveredType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_Expiration, arginfo_TElDNSSignatureRecord_get_Expiration, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_Expiration, arginfo_TElDNSSignatureRecord_set_Expiration, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_Inception, arginfo_TElDNSSignatureRecord_get_Inception, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_Inception, arginfo_TElDNSSignatureRecord_set_Inception, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_KeyTag, arginfo_TElDNSSignatureRecord_get_KeyTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_KeyTag, arginfo_TElDNSSignatureRecord_set_KeyTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_Labels, arginfo_TElDNSSignatureRecord_get_Labels, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_Labels, arginfo_TElDNSSignatureRecord_set_Labels, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_OriginalTTL, arginfo_TElDNSSignatureRecord_get_OriginalTTL, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_OriginalTTL, arginfo_TElDNSSignatureRecord_set_OriginalTTL, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_Signature, arginfo_TElDNSSignatureRecord_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_Signature, arginfo_TElDNSSignatureRecord_set_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, get_Signer, arginfo_TElDNSSignatureRecord_get_Signer, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, set_Signer, arginfo_TElDNSSignatureRecord_set_Signer, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSSignatureRecord, __construct, arginfo_TElDNSSignatureRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSSignatureRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSSignatureRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSSignatureRecord", TElDNSSignatureRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSSignatureRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSNextSecureRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSNextSecureRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecureRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecureRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSNextSecureRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecureRecord, get_NextDomainName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDNSNextSecureRecord_get_NextDomainName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1985733955, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecureRecord, set_NextDomainName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecureRecord_set_NextDomainName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecureRecord, get_ResourceByCode)
{
	long u2Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSNextSecureRecord_get_ResourceByCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecureRecord, set_ResourceByCode)
{
	long u2Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u2Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecureRecord_set_ResourceByCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecureRecord, get_ResourceByType)
{
	long fIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fIndex) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSNextSecureRecord_get_ResourceByType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fIndex, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecureRecord, set_ResourceByType)
{
	long fIndex;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &fIndex, &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecureRecord_set_ResourceByType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fIndex, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecureRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSNextSecureRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecureRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecureRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecureRecord_get_NextDomainName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecureRecord_set_NextDomainName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecureRecord_get_ResourceByCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecureRecord_set_ResourceByCode, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecureRecord_get_ResourceByType, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecureRecord_set_ResourceByType, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecureRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSNextSecureRecord_methods[] = {
	PHP_ME(TElDNSNextSecureRecord, Assign, arginfo_TElDNSNextSecureRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecureRecord, Read, arginfo_TElDNSNextSecureRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecureRecord, get_NextDomainName, arginfo_TElDNSNextSecureRecord_get_NextDomainName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecureRecord, set_NextDomainName, arginfo_TElDNSNextSecureRecord_set_NextDomainName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecureRecord, get_ResourceByCode, arginfo_TElDNSNextSecureRecord_get_ResourceByCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecureRecord, set_ResourceByCode, arginfo_TElDNSNextSecureRecord_set_ResourceByCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecureRecord, get_ResourceByType, arginfo_TElDNSNextSecureRecord_get_ResourceByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecureRecord, set_ResourceByType, arginfo_TElDNSNextSecureRecord_set_ResourceByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecureRecord, __construct, arginfo_TElDNSNextSecureRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSNextSecureRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSNextSecureRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSNextSecureRecord", TElDNSNextSecureRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSNextSecureRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSNextSecure3Record_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSNextSecure3Record, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3Record_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSNextSecure3Record_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3Record_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, set_Algorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3Record_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3Record_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, set_Flags)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3Record_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, get_Iterations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3Record_get_Iterations(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, set_Iterations)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3Record_set_Iterations(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, get_NextOwnerName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDNSNextSecure3Record_get_NextOwnerName(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1260123110, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, set_NextOwnerName)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDNSNextSecure3Record_set_NextOwnerName(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, get_OptOut)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3Record_get_OptOut(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, set_OptOut)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3Record_set_OptOut(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, get_ResourceByCode)
{
	long u2Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3Record_get_ResourceByCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, set_ResourceByCode)
{
	long u2Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u2Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3Record_set_ResourceByCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, get_ResourceByType)
{
	long fIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fIndex) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3Record_get_ResourceByType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fIndex, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, set_ResourceByType)
{
	long fIndex;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &fIndex, &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3Record_set_ResourceByType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fIndex, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, get_Salt)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDNSNextSecure3Record_get_Salt(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1503250812, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, set_Salt)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDNSNextSecure3Record_set_Salt(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3Record, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSNextSecure3Record_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_get_Iterations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_set_Iterations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_get_NextOwnerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_set_NextOwnerName, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_get_OptOut, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_set_OptOut, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_get_ResourceByCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_set_ResourceByCode, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_get_ResourceByType, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_set_ResourceByType, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_get_Salt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record_set_Salt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3Record___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSNextSecure3Record_methods[] = {
	PHP_ME(TElDNSNextSecure3Record, Assign, arginfo_TElDNSNextSecure3Record_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, Read, arginfo_TElDNSNextSecure3Record_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, get_Algorithm, arginfo_TElDNSNextSecure3Record_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, set_Algorithm, arginfo_TElDNSNextSecure3Record_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, get_Flags, arginfo_TElDNSNextSecure3Record_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, set_Flags, arginfo_TElDNSNextSecure3Record_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, get_Iterations, arginfo_TElDNSNextSecure3Record_get_Iterations, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, set_Iterations, arginfo_TElDNSNextSecure3Record_set_Iterations, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, get_NextOwnerName, arginfo_TElDNSNextSecure3Record_get_NextOwnerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, set_NextOwnerName, arginfo_TElDNSNextSecure3Record_set_NextOwnerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, get_OptOut, arginfo_TElDNSNextSecure3Record_get_OptOut, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, set_OptOut, arginfo_TElDNSNextSecure3Record_set_OptOut, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, get_ResourceByCode, arginfo_TElDNSNextSecure3Record_get_ResourceByCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, set_ResourceByCode, arginfo_TElDNSNextSecure3Record_set_ResourceByCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, get_ResourceByType, arginfo_TElDNSNextSecure3Record_get_ResourceByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, set_ResourceByType, arginfo_TElDNSNextSecure3Record_set_ResourceByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, get_Salt, arginfo_TElDNSNextSecure3Record_get_Salt, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, set_Salt, arginfo_TElDNSNextSecure3Record_set_Salt, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3Record, __construct, arginfo_TElDNSNextSecure3Record___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSNextSecure3Record(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSNextSecure3Record_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSNextSecure3Record", TElDNSNextSecure3Record_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSNextSecure3Record_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSNextSecure3ParamRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3ParamRecord_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, Read)
{
	SBArrayZValInfo aiBuffer;
	uint16_t u2OffsetRaw;
	zval *zaBuffer;
	zval *zu2Offset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zu2Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zu2Offset) && (IS_LONG == Z_TYPE_P(zu2Offset)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		u2OffsetRaw = (uint16_t)Z_LVAL_P(zu2Offset);
		SBCheckError(TElDNSNextSecure3ParamRecord_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, &u2OffsetRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zu2Offset, (long)u2OffsetRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3ParamRecord_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, set_Algorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3ParamRecord_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3ParamRecord_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, set_Flags)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3ParamRecord_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, get_Iterations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3ParamRecord_get_Iterations(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, set_Iterations)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3ParamRecord_set_Iterations(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, get_OptOut)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSNextSecure3ParamRecord_get_OptOut(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, set_OptOut)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSNextSecure3ParamRecord_set_OptOut(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, get_Salt)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDNSNextSecure3ParamRecord_get_Salt(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(826528216, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, set_Salt)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDNSNextSecure3ParamRecord_set_Salt(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSNextSecure3ParamRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSNextSecure3ParamRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_Read, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_get_Iterations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_set_Iterations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_get_OptOut, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_set_OptOut, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_get_Salt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord_set_Salt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSNextSecure3ParamRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSNextSecure3ParamRecord_methods[] = {
	PHP_ME(TElDNSNextSecure3ParamRecord, Assign, arginfo_TElDNSNextSecure3ParamRecord_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, Read, arginfo_TElDNSNextSecure3ParamRecord_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, get_Algorithm, arginfo_TElDNSNextSecure3ParamRecord_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, set_Algorithm, arginfo_TElDNSNextSecure3ParamRecord_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, get_Flags, arginfo_TElDNSNextSecure3ParamRecord_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, set_Flags, arginfo_TElDNSNextSecure3ParamRecord_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, get_Iterations, arginfo_TElDNSNextSecure3ParamRecord_get_Iterations, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, set_Iterations, arginfo_TElDNSNextSecure3ParamRecord_set_Iterations, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, get_OptOut, arginfo_TElDNSNextSecure3ParamRecord_get_OptOut, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, set_OptOut, arginfo_TElDNSNextSecure3ParamRecord_set_OptOut, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, get_Salt, arginfo_TElDNSNextSecure3ParamRecord_get_Salt, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, set_Salt, arginfo_TElDNSNextSecure3ParamRecord_set_Salt, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSNextSecure3ParamRecord, __construct, arginfo_TElDNSNextSecure3ParamRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSNextSecure3ParamRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSNextSecure3ParamRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSNextSecure3ParamRecord", TElDNSNextSecure3ParamRecord_methods);
	if (NULL == TElDNSResourceRecord_ce_ptr)
		Register_TElDNSResourceRecord(TSRMLS_C);
	TElDNSNextSecure3ParamRecord_ce_ptr = zend_register_internal_class_ex(&ce, TElDNSResourceRecord_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDNSResourceRecordSet_ce_ptr = NULL;

SB_PHP_METHOD(TElDNSResourceRecordSet, Add)
{
	long fResourceType;
	zval *oResourceRecord;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fResourceType) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSResourceRecordSet_Add(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fResourceType, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSResourceRecord_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResourceRecord, TElDNSResourceRecord_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResourceRecord TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElDNSResourceRecord)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, AddCopy)
{
	zval *oResourceRecord;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResourceRecord, TElDNSResourceRecord_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_AddCopy(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResourceRecord TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSResourceRecord)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecordSet_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecordSet_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecordSet_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, Find)
{
	char *sCriteria;
	int sCriteria_len;
	long fResourceType;
	long l4Start;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sll", &sCriteria, &sCriteria_len, &fResourceType, &l4Start) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_Find(SBGetObjectHandle(getThis() TSRMLS_CC), sCriteria, (int32_t)sCriteria_len, (TSBDNSResourceTypeRaw)fResourceType, (int32_t)l4Start, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, FindAny)
{
	long fResourceType;
	long l4Start;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &fResourceType, &l4Start) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_FindAny(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDNSResourceTypeRaw)fResourceType, (int32_t)l4Start, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, FindKey)
{
	char *sOwner;
	int sOwner_len;
	long l4Start;
	long u1Algorithm;
	long u2KeyTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slll", &sOwner, &sOwner_len, &u2KeyTag, &u1Algorithm, &l4Start) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_FindKey(SBGetObjectHandle(getThis() TSRMLS_CC), sOwner, (int32_t)sOwner_len, (uint16_t)u2KeyTag, (uint8_t)u1Algorithm, (int32_t)l4Start, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, FindSelfSignedSignature)
{
	char *sCriteria;
	int sCriteria_len;
	long fCoveredType;
	long l4Start;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sll", &sCriteria, &sCriteria_len, &fCoveredType, &l4Start) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_FindSelfSignedSignature(SBGetObjectHandle(getThis() TSRMLS_CC), sCriteria, (int32_t)sCriteria_len, (TSBDNSResourceTypeRaw)fCoveredType, (int32_t)l4Start, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, FindSignature)
{
	char *sCriteria;
	int sCriteria_len;
	long fCoveredType;
	long l4Start;
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sll", &sCriteria, &sCriteria_len, &fCoveredType, &l4Start) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_FindSignature(SBGetObjectHandle(getThis() TSRMLS_CC), sCriteria, (int32_t)sCriteria_len, (TSBDNSResourceTypeRaw)fCoveredType, (int32_t)l4Start, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!l", &sCriteria, &sCriteria_len, &fCoveredType, &oKey, TElDNSPublicKeyRecord_ce_ptr, &l4Start) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_FindSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), sCriteria, (int32_t)sCriteria_len, (TSBDNSResourceTypeRaw)fCoveredType, SBGetObjectHandle(oKey TSRMLS_CC), (int32_t)l4Start, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer) or (string, integer, TElDNSPublicKeyRecord, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, FindSignatureByUpperLevel)
{
	char *sCriteria;
	int sCriteria_len;
	long fCoveredType;
	long l4Start;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sll", &sCriteria, &sCriteria_len, &fCoveredType, &l4Start) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_FindSignatureByUpperLevel(SBGetObjectHandle(getThis() TSRMLS_CC), sCriteria, (int32_t)sCriteria_len, (TSBDNSResourceTypeRaw)fCoveredType, (int32_t)l4Start, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, IndexOf)
{
	zval *oResource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResource, TElDNSResourceRecord_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResource TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSResourceRecord)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, Insert)
{
	long fResourceType;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &fResourceType) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSResourceRecordSet_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (TSBDNSResourceTypeRaw)fResourceType, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSResourceRecord_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, Remove)
{
	zval *oResource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResource, TElDNSResourceRecord_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResource TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSResourceRecord)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, Sort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecordSet_Sort(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, Verify)
{
	zval *oKey;
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSignature, TElDNSSignatureRecord_ce_ptr, &oKey, TElDNSPublicKeyRecord_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSSignatureRecord, TElDNSPublicKeyRecord)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSResourceRecordSet_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSResourceRecord_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, get_OwnRecords)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDNSResourceRecordSet_get_OwnRecords(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, set_OwnRecords)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDNSResourceRecordSet_set_OwnRecords(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDNSResourceRecordSet, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDNSResourceRecordSet_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ResourceType_or_ResourceRecord, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_AddCopy, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ResourceRecord, TElDNSResourceRecord, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_Find, 0, 0, 3)
	ZEND_ARG_INFO(0, Criteria)
	ZEND_ARG_INFO(0, ResourceType)
	ZEND_ARG_INFO(0, Start)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_FindAny, 0, 0, 2)
	ZEND_ARG_INFO(0, ResourceType)
	ZEND_ARG_INFO(0, Start)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_FindKey, 0, 0, 4)
	ZEND_ARG_INFO(0, Owner)
	ZEND_ARG_INFO(0, KeyTag)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, Start)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_FindSelfSignedSignature, 0, 0, 3)
	ZEND_ARG_INFO(0, Criteria)
	ZEND_ARG_INFO(0, CoveredType)
	ZEND_ARG_INFO(0, Start)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_FindSignature, 0, 0, 3)
	ZEND_ARG_INFO(0, Criteria)
	ZEND_ARG_INFO(0, CoveredType)
	ZEND_ARG_TYPE_INFO(0, Start_or_Key, 0, 1)
	ZEND_ARG_INFO(0, Start)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_FindSignatureByUpperLevel, 0, 0, 3)
	ZEND_ARG_INFO(0, Criteria)
	ZEND_ARG_INFO(0, CoveredType)
	ZEND_ARG_INFO(0, Start)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_IndexOf, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Resource, TElDNSResourceRecord, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, ResourceType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_Remove, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Resource, TElDNSResourceRecord, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_Sort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_Verify, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Signature, TElDNSSignatureRecord, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElDNSPublicKeyRecord, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_get_OwnRecords, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet_set_OwnRecords, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDNSResourceRecordSet___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDNSResourceRecordSet_methods[] = {
	PHP_ME(TElDNSResourceRecordSet, Add, arginfo_TElDNSResourceRecordSet_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, AddCopy, arginfo_TElDNSResourceRecordSet_AddCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, Assign, arginfo_TElDNSResourceRecordSet_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, Clear, arginfo_TElDNSResourceRecordSet_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, Delete, arginfo_TElDNSResourceRecordSet_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, Find, arginfo_TElDNSResourceRecordSet_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, FindAny, arginfo_TElDNSResourceRecordSet_FindAny, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, FindKey, arginfo_TElDNSResourceRecordSet_FindKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, FindSelfSignedSignature, arginfo_TElDNSResourceRecordSet_FindSelfSignedSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, FindSignature, arginfo_TElDNSResourceRecordSet_FindSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, FindSignatureByUpperLevel, arginfo_TElDNSResourceRecordSet_FindSignatureByUpperLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, IndexOf, arginfo_TElDNSResourceRecordSet_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, Insert, arginfo_TElDNSResourceRecordSet_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, Remove, arginfo_TElDNSResourceRecordSet_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, Sort, arginfo_TElDNSResourceRecordSet_Sort, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, Verify, arginfo_TElDNSResourceRecordSet_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, get_Count, arginfo_TElDNSResourceRecordSet_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, get_Items, arginfo_TElDNSResourceRecordSet_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, get_OwnRecords, arginfo_TElDNSResourceRecordSet_get_OwnRecords, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, set_OwnRecords, arginfo_TElDNSResourceRecordSet_set_OwnRecords, ZEND_ACC_PUBLIC)
	PHP_ME(TElDNSResourceRecordSet, __construct, arginfo_TElDNSResourceRecordSet___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDNSResourceRecordSet(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDNSResourceRecordSet_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDNSResourceRecordSet", TElDNSResourceRecordSet_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElDNSResourceRecordSet_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBDNSSECTypes_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBDNSMessageType", NULL);
	TSBDNSMessageType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDNSMessageType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSMessageType_ce_ptr, "dnsQuery", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSMessageType_ce_ptr, "dnsResponse", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBDNSOperationCode", NULL);
	TSBDNSOperationCode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDNSOperationCode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSOperationCode_ce_ptr, "dnsUnknownOperation", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSOperationCode_ce_ptr, "dnsStandardQuery", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSOperationCode_ce_ptr, "dnsInverseQuery", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSOperationCode_ce_ptr, "dnsStatusRequest", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSOperationCode_ce_ptr, "dnsNotification", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSOperationCode_ce_ptr, "dnsUpdate", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBDNSResponseCode", NULL);
	TSBDNSResponseCode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDNSResponseCode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsUnknownResponse", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsNoError", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsInvalidRequest", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsServerError", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsNameError", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsNotImplemented", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsQueryRefused", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsNameExists", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsRRSetExists", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsRRSetNotExists", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsNotAuthoritative", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsNotInZone", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsInvalidVersion", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsSignatureFailure", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsKeyNotRecognized", 14)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsSignatureTimeout", 15)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsInvalidKeyMode", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsDuplicateKeyName", 17)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsAlgorithmNotSupported", 18)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsBadTruncation", 19)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResponseCode_ce_ptr, "dnsPrivate", 20)
	
	INIT_CLASS_ENTRY(ce, "TSBDNSResourceType", NULL);
	TSBDNSResourceType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDNSResourceType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsUnknownResource", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsIPv4Address", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsNameServer", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsCanonicalName", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsStartOfAuthority", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsWellKnownService", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsDomainNamePointer", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsHostInfo", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsMailInfo", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsMailExchange", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsTextStrings", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsIPv6Address", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsServiceLocation", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsExtensions", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsDelegationSigner", 14)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsSignature", 15)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsNextSecure", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsPublicKey", 17)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsNextSecure3", 18)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsNextSecure3Param", 19)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSResourceType_ce_ptr, "dnsAll", 20)
	
	INIT_CLASS_ENTRY(ce, "TSBDNSSecurityStatus", NULL);
	TSBDNSSecurityStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDNSSecurityStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSSecurityStatus_ce_ptr, "dnsInsecure", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSSecurityStatus_ce_ptr, "dnsIndeterminate", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSSecurityStatus_ce_ptr, "dnsBogus", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSSecurityStatus_ce_ptr, "dnsSecure", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBDNSSecurityStatuses", NULL);
	TSBDNSSecurityStatuses_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBDNSSecurityStatuses_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSSecurityStatuses_ce_ptr, "dnsInsecure", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSSecurityStatuses_ce_ptr, "dnsIndeterminate", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSSecurityStatuses_ce_ptr, "dnsBogus", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBDNSSecurityStatuses_ce_ptr, "dnsSecure", 8)
}

