#include "sbgoogledrivedatastorage.h"

zend_class_entry *TSBGoogleDriveRoot_ce_ptr = NULL;

zend_class_entry *TSBGoogleDriveMetadataLocation_ce_ptr = NULL;

zend_class_entry *TSBGoogleDrivePropertyVisibility_ce_ptr = NULL;

zend_class_entry *TSBGoogleDriveUserRole_ce_ptr = NULL;

zend_class_entry *TSBGoogleDrivePermissionScope_ce_ptr = NULL;

zend_class_entry *TSBGoogleDriveCommentStatus_ce_ptr = NULL;

zend_class_entry *TSBGoogleDriveReplyAction_ce_ptr = NULL;

zend_class_entry *TElGoogleDriveDataStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveDataStorage, StartAuthorization)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorage_StartAuthorization(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1867284013, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, CompleteAuthorization)
{
	char *sAuthorizationCode;
	int sAuthorizationCode_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAuthorizationCode, &sAuthorizationCode_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_CompleteAuthorization(SBGetObjectHandle(getThis() TSRMLS_CC), sAuthorizationCode, (int32_t)sAuthorizationCode_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, AcquireObject)
{
	char *sObjectID;
	int sObjectID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sObjectID, &sObjectID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_AcquireObject(SBGetObjectHandle(getThis() TSRMLS_CC), sObjectID, (int32_t)sObjectID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_AcquireObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, CloseSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_CloseSession(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, CopyObject)
{
	char *sNewDescription;
	char *sNewName;
	int sNewDescription_len;
	int sNewName_len;
	zval *oDestination;
	zval *oNewHandler;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElGoogleDriveDataStorageObject_ce_ptr, &oDestination, TElGoogleDriveFolder_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssO!", &oObj, TElGoogleDriveDataStorageObject_ce_ptr, &sNewName, &sNewName_len, &sNewDescription, &sNewDescription_len, &oDestination, TElGoogleDriveFolder_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sNewName, (int32_t)sNewName_len, sNewDescription, (int32_t)sNewDescription_len, SBGetObjectHandle(oDestination TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_CopyObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject, TElGoogleDriveFolder) or (TElGoogleDriveDataStorageObject, string, string, TElGoogleDriveFolder) or (TElCustomDataStorageObject, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, CreateFolder)
{
	char *sADescription;
	char *sAName;
	int sADescription_len;
	int sAName_len;
	zval *oAParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oAParent, TElGoogleDriveFolder_ce_ptr, &sAName, &sAName_len, &sADescription, &sADescription_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_CreateFolder(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAParent TSRMLS_CC), sAName, (int32_t)sAName_len, sADescription, (int32_t)sADescription_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveFolder_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveFolder, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, CreateObject)
{
	char *sADescription;
	char *sAMimeType;
	char *sAName;
	int sADescription_len;
	int sAMimeType_len;
	int sAName_len;
	zend_bool bAHidden;
	zend_bool bARestricted;
	zend_bool bAStarred;
	zval *oAParent;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sssbbbO!", &oAParent, TElGoogleDriveFolder_ce_ptr, &sAName, &sAName_len, &sADescription, &sADescription_len, &sAMimeType, &sAMimeType_len, &bAHidden, &bARestricted, &bAStarred, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAParent TSRMLS_CC), sAName, (int32_t)sAName_len, sADescription, (int32_t)sADescription_len, sAMimeType, (int32_t)sAMimeType_len, (int8_t)bAHidden, (int8_t)bARestricted, (int8_t)bAStarred, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveFolder, string, string, string, bool, bool, bool, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, GetAccountInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_GetAccountInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveAccountInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, GetObjectThumbnail)
{
	zval *oObj;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElGoogleDriveDataStorageObject_ce_ptr, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_GetObjectThumbnail(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, List)
{
	zval *oFolder;
	zval *oObjects;
	zval *oObjs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oFolder, TElGoogleDriveFolder_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjs, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjs TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveFolder, TElDataStorageObjectList) or (TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, MoveObject)
{
	SBArrayZValInfo aiDestinations;
	zval *oDestination;
	zval *oObj;
	zval *zaDestinations;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElGoogleDriveDataStorageObject_ce_ptr, &oDestination, TElGoogleDriveFolder_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_MoveObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oObj, TElGoogleDriveDataStorageObject_ce_ptr, &zaDestinations, TElGoogleDriveFolder_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaDestinations)) || (IS_NULL == Z_TYPE_P(zaDestinations))))
	{
		if (!SBGetObjectArrayFromZVal(zaDestinations, TElGoogleDriveFolder_ce_ptr, &aiDestinations TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGoogleDriveDataStorage_MoveObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), aiDestinations.data, aiDestinations.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDestinations);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject, TElGoogleDriveFolder) or (TElGoogleDriveDataStorageObject, &array of TElGoogleDriveFolder|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, RenameObject)
{
	char *sNewName;
	int sNewName_len;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElGoogleDriveDataStorageObject_ce_ptr, &sNewName, &sNewName_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_RenameObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sNewName, (int32_t)sNewName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, Search)
{
	char *sQuery;
	int sQuery_len;
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sQuery, &sQuery_len, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_Search(SBGetObjectHandle(getThis() TSRMLS_CC), sQuery, (int32_t)sQuery_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_AccessToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorage_get_AccessToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-320039997, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_ChunkedUploadChunkSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_get_ChunkedUploadChunkSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_ChunkedUploadChunkSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_ChunkedUploadChunkSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_ChunkedUploadThreshold)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_get_ChunkedUploadThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_ChunkedUploadThreshold)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_ChunkedUploadThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_ClientID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorage_get_ClientID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1097659524, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_ClientID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_ClientID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_ClientSecret)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorage_get_ClientSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2005747344, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_ClientSecret)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_ClientSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_PassthroughMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_get_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_PassthroughMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_ReadOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_get_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_ReadOnly)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_RedirectURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorage_get_RedirectURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1767591608, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_RedirectURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_RedirectURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_RefreshToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorage_get_RefreshToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1822766862, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_RefreshToken)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_RefreshToken(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_Root)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleDriveRootRaw fOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_get_Root(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_Root)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_Root(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGoogleDriveRootRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_UpdateViewedDateOnAcquire)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_get_UpdateViewedDateOnAcquire(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_UpdateViewedDateOnAcquire)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_UpdateViewedDateOnAcquire(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_UpdateViewedDateOnWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_get_UpdateViewedDateOnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_UpdateViewedDateOnWrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_UpdateViewedDateOnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_UseETags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_get_UseETags(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_UseETags)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_UseETags(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, get_UsePatchMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorage_get_UsePatchMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, set_UsePatchMethod)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorage_set_UsePatchMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_StartAuthorization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_CompleteAuthorization, 0, 0, 1)
	ZEND_ARG_INFO(0, AuthorizationCode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_AcquireObject, 0, 0, 0)
	ZEND_ARG_INFO(0, ObjectID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_CloseSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_CopyObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Destination_or_NewName_or_NewHandler, 0, 1)
	ZEND_ARG_INFO(0, NewDescription)
	ZEND_ARG_OBJ_INFO(0, Destination, TElGoogleDriveFolder, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_CreateFolder, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, AParent, TElGoogleDriveFolder, 1)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, ADescription)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_CreateObject, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, AParent, TElGoogleDriveFolder, 1)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, ADescription)
	ZEND_ARG_INFO(0, AMimeType)
	ZEND_ARG_INFO(0, AHidden)
	ZEND_ARG_INFO(0, ARestricted)
	ZEND_ARG_INFO(0, AStarred)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_GetAccountInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_GetObjectThumbnail, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Obj, TElGoogleDriveDataStorageObject, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_List, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Folder_or_Objs, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_MoveObject, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Obj, TElGoogleDriveDataStorageObject, 1)
	ZEND_ARG_TYPE_INFO(0, Destination_or_Destinations, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_RenameObject, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Obj, TElGoogleDriveDataStorageObject, 1)
	ZEND_ARG_INFO(0, NewName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_Search, 0, 0, 2)
	ZEND_ARG_INFO(0, Query)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_AccessToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_ChunkedUploadChunkSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_ChunkedUploadChunkSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_ChunkedUploadThreshold, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_ChunkedUploadThreshold, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_ClientID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_ClientID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_ClientSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_ClientSecret, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_PassthroughMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_PassthroughMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_ReadOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_ReadOnly, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_RedirectURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_RedirectURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_RefreshToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_RefreshToken, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_Root, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_Root, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_UpdateViewedDateOnAcquire, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_UpdateViewedDateOnAcquire, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_UpdateViewedDateOnWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_UpdateViewedDateOnWrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_UseETags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_UseETags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_get_UsePatchMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage_set_UsePatchMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveDataStorage_methods[] = {
	PHP_ME(TElGoogleDriveDataStorage, StartAuthorization, arginfo_TElGoogleDriveDataStorage_StartAuthorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, CompleteAuthorization, arginfo_TElGoogleDriveDataStorage_CompleteAuthorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, AcquireObject, arginfo_TElGoogleDriveDataStorage_AcquireObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, CloseSession, arginfo_TElGoogleDriveDataStorage_CloseSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, CopyObject, arginfo_TElGoogleDriveDataStorage_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, CreateFolder, arginfo_TElGoogleDriveDataStorage_CreateFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, CreateObject, arginfo_TElGoogleDriveDataStorage_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, GetAccountInfo, arginfo_TElGoogleDriveDataStorage_GetAccountInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, GetObjectThumbnail, arginfo_TElGoogleDriveDataStorage_GetObjectThumbnail, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, List, arginfo_TElGoogleDriveDataStorage_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, MoveObject, arginfo_TElGoogleDriveDataStorage_MoveObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, RenameObject, arginfo_TElGoogleDriveDataStorage_RenameObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, Search, arginfo_TElGoogleDriveDataStorage_Search, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_AccessToken, arginfo_TElGoogleDriveDataStorage_get_AccessToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_ChunkedUploadChunkSize, arginfo_TElGoogleDriveDataStorage_get_ChunkedUploadChunkSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_ChunkedUploadChunkSize, arginfo_TElGoogleDriveDataStorage_set_ChunkedUploadChunkSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_ChunkedUploadThreshold, arginfo_TElGoogleDriveDataStorage_get_ChunkedUploadThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_ChunkedUploadThreshold, arginfo_TElGoogleDriveDataStorage_set_ChunkedUploadThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_ClientID, arginfo_TElGoogleDriveDataStorage_get_ClientID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_ClientID, arginfo_TElGoogleDriveDataStorage_set_ClientID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_ClientSecret, arginfo_TElGoogleDriveDataStorage_get_ClientSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_ClientSecret, arginfo_TElGoogleDriveDataStorage_set_ClientSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_HTTPClient, arginfo_TElGoogleDriveDataStorage_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_HTTPClient, arginfo_TElGoogleDriveDataStorage_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_PassthroughMode, arginfo_TElGoogleDriveDataStorage_get_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_PassthroughMode, arginfo_TElGoogleDriveDataStorage_set_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_ReadOnly, arginfo_TElGoogleDriveDataStorage_get_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_ReadOnly, arginfo_TElGoogleDriveDataStorage_set_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_RedirectURL, arginfo_TElGoogleDriveDataStorage_get_RedirectURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_RedirectURL, arginfo_TElGoogleDriveDataStorage_set_RedirectURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_RefreshToken, arginfo_TElGoogleDriveDataStorage_get_RefreshToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_RefreshToken, arginfo_TElGoogleDriveDataStorage_set_RefreshToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_Root, arginfo_TElGoogleDriveDataStorage_get_Root, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_Root, arginfo_TElGoogleDriveDataStorage_set_Root, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_UpdateViewedDateOnAcquire, arginfo_TElGoogleDriveDataStorage_get_UpdateViewedDateOnAcquire, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_UpdateViewedDateOnAcquire, arginfo_TElGoogleDriveDataStorage_set_UpdateViewedDateOnAcquire, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_UpdateViewedDateOnWrite, arginfo_TElGoogleDriveDataStorage_get_UpdateViewedDateOnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_UpdateViewedDateOnWrite, arginfo_TElGoogleDriveDataStorage_set_UpdateViewedDateOnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_UseETags, arginfo_TElGoogleDriveDataStorage_get_UseETags, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_UseETags, arginfo_TElGoogleDriveDataStorage_set_UseETags, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, get_UsePatchMethod, arginfo_TElGoogleDriveDataStorage_get_UsePatchMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, set_UsePatchMethod, arginfo_TElGoogleDriveDataStorage_set_UsePatchMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorage, __construct, arginfo_TElGoogleDriveDataStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveDataStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveDataStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveDataStorage", TElGoogleDriveDataStorage_methods);
	if (NULL == TElCustomDataStorage_ce_ptr)
		Register_TElCustomDataStorage(TSRMLS_C);
	TElGoogleDriveDataStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveDataStorageObject_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Copy)
{
	zval *oDestination;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TElGoogleDriveFolder_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorageObject_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveFolder)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, GetThumbnail)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_GetThumbnail(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Move)
{
	SBArrayZValInfo aiDestinations;
	zval *oDestination;
	zval *zaDestinations;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TElGoogleDriveFolder_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_Move(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaDestinations, TElGoogleDriveFolder_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaDestinations)) || (IS_NULL == Z_TYPE_P(zaDestinations))))
	{
		if (!SBGetObjectArrayFromZVal(zaDestinations, TElGoogleDriveFolder_ce_ptr, &aiDestinations TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGoogleDriveDataStorageObject_Move_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiDestinations.data, aiDestinations.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDestinations);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveFolder) or (&array of TElGoogleDriveFolder|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Refresh)
{
	zend_bool bUpdateViewedDate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bUpdateViewedDate) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bUpdateViewedDate) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Rename)
{
	char *sNewName;
	int sNewName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sNewName, &sNewName_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_Rename(SBGetObjectHandle(getThis() TSRMLS_CC), sNewName, (int32_t)sNewName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Touch)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_Touch(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Trash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_Trash(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, Untrash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_Untrash(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_AlternateLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_AlternateLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1067903925, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_AppDataContents)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_AppDataContents(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Comments)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Comments(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveComments_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_CreatedDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_CreatedDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-940642916, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, set_Description)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_set_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Editable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Editable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1967564046, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_ExplicitlyTrashed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_ExplicitlyTrashed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Hidden)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Hidden(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, set_Hidden)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_set_Hidden(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_IconLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_IconLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-813338940, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-200152025, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Kind)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_Kind(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1480857207, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_LastModifyingUser)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorageObject_get_LastModifyingUser(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_LastModifyingUserName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_LastModifyingUserName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1179725569, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_LastViewedByMeDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_LastViewedByMeDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_MimeType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1876255154, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_ModifiedByMeDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_ModifiedByMeDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_ModifiedDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_ModifiedDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, set_ModifiedDate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_set_ModifiedDate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_OwnerNames)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TStringList_Create(&hoOutResult) TSRMLS_CC);
		SBCheckError(TElGoogleDriveDataStorageObject_get_OwnerNames(SBGetObjectHandle(getThis() TSRMLS_CC), hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TStringList_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_OwnerCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_OwnerCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Owners)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Owners(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Parent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_Parent(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2060503713, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Parents)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TStringList_Create(&hoOutResult) TSRMLS_CC);
		SBCheckError(TElGoogleDriveDataStorageObject_get_Parents(SBGetObjectHandle(getThis() TSRMLS_CC), hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TStringList_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Permissions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Permissions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDrivePermissions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Properties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Properties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_QuotaBytesUsed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_QuotaBytesUsed(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Restricted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Restricted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, set_Restricted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_set_Restricted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_SelfLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_SelfLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-137736334, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Shared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Shared(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_SharedWithMeDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_SharedWithMeDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Starred)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Starred(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, set_Starred)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveDataStorageObject_set_Starred(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_ThumbnailLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_ThumbnailLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1497983858, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Trashed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Trashed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_Viewed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_Viewed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_WebContentLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveDataStorageObject_get_WebContentLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-966969945, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, get_WritersCanShare)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveDataStorageObject_get_WritersCanShare(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveDataStorageObject, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElGoogleDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveDataStorageObject_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Copy, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Destination, TElGoogleDriveFolder, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_GetThumbnail, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Move, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Destination_or_Destinations, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Refresh, 0, 0, 1)
	ZEND_ARG_INFO(0, UpdateViewedDate)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Rename, 0, 0, 1)
	ZEND_ARG_INFO(0, NewName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Touch, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Trash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_Untrash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_AlternateLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_AppDataContents, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Comments, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_CreatedDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_set_Description, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Editable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_ExplicitlyTrashed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Hidden, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_set_Hidden, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_IconLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Kind, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_LastModifyingUser, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_LastModifyingUserName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_LastViewedByMeDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_MimeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_ModifiedByMeDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_ModifiedDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_set_ModifiedDate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_OwnerNames, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_OwnerCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Owners, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Parent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Parents, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Permissions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Properties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_QuotaBytesUsed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Restricted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_set_Restricted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_SelfLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Shared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_SharedWithMeDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Starred, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_set_Starred, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_ThumbnailLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Trashed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_Viewed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_WebContentLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject_get_WritersCanShare, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveDataStorageObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElGoogleDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveDataStorageObject_methods[] = {
	PHP_ME(TElGoogleDriveDataStorageObject, Assign, arginfo_TElGoogleDriveDataStorageObject_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, Clear, arginfo_TElGoogleDriveDataStorageObject_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, Copy, arginfo_TElGoogleDriveDataStorageObject_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, Delete, arginfo_TElGoogleDriveDataStorageObject_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, GetThumbnail, arginfo_TElGoogleDriveDataStorageObject_GetThumbnail, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, Move, arginfo_TElGoogleDriveDataStorageObject_Move, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, Refresh, arginfo_TElGoogleDriveDataStorageObject_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, Rename, arginfo_TElGoogleDriveDataStorageObject_Rename, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, Touch, arginfo_TElGoogleDriveDataStorageObject_Touch, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, Trash, arginfo_TElGoogleDriveDataStorageObject_Trash, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, Untrash, arginfo_TElGoogleDriveDataStorageObject_Untrash, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_AlternateLink, arginfo_TElGoogleDriveDataStorageObject_get_AlternateLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_AppDataContents, arginfo_TElGoogleDriveDataStorageObject_get_AppDataContents, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Comments, arginfo_TElGoogleDriveDataStorageObject_get_Comments, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_CreatedDate, arginfo_TElGoogleDriveDataStorageObject_get_CreatedDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Description, arginfo_TElGoogleDriveDataStorageObject_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, set_Description, arginfo_TElGoogleDriveDataStorageObject_set_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Editable, arginfo_TElGoogleDriveDataStorageObject_get_Editable, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_ETag, arginfo_TElGoogleDriveDataStorageObject_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_ExplicitlyTrashed, arginfo_TElGoogleDriveDataStorageObject_get_ExplicitlyTrashed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Hidden, arginfo_TElGoogleDriveDataStorageObject_get_Hidden, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, set_Hidden, arginfo_TElGoogleDriveDataStorageObject_set_Hidden, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_IconLink, arginfo_TElGoogleDriveDataStorageObject_get_IconLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_ID, arginfo_TElGoogleDriveDataStorageObject_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Kind, arginfo_TElGoogleDriveDataStorageObject_get_Kind, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_LastModifyingUser, arginfo_TElGoogleDriveDataStorageObject_get_LastModifyingUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_LastModifyingUserName, arginfo_TElGoogleDriveDataStorageObject_get_LastModifyingUserName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_LastViewedByMeDate, arginfo_TElGoogleDriveDataStorageObject_get_LastViewedByMeDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_MimeType, arginfo_TElGoogleDriveDataStorageObject_get_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_ModifiedByMeDate, arginfo_TElGoogleDriveDataStorageObject_get_ModifiedByMeDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_ModifiedDate, arginfo_TElGoogleDriveDataStorageObject_get_ModifiedDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, set_ModifiedDate, arginfo_TElGoogleDriveDataStorageObject_set_ModifiedDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_OwnerNames, arginfo_TElGoogleDriveDataStorageObject_get_OwnerNames, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_OwnerCount, arginfo_TElGoogleDriveDataStorageObject_get_OwnerCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Owners, arginfo_TElGoogleDriveDataStorageObject_get_Owners, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Parent, arginfo_TElGoogleDriveDataStorageObject_get_Parent, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Parents, arginfo_TElGoogleDriveDataStorageObject_get_Parents, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Permissions, arginfo_TElGoogleDriveDataStorageObject_get_Permissions, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Properties, arginfo_TElGoogleDriveDataStorageObject_get_Properties, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_QuotaBytesUsed, arginfo_TElGoogleDriveDataStorageObject_get_QuotaBytesUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Restricted, arginfo_TElGoogleDriveDataStorageObject_get_Restricted, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, set_Restricted, arginfo_TElGoogleDriveDataStorageObject_set_Restricted, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_SelfLink, arginfo_TElGoogleDriveDataStorageObject_get_SelfLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Shared, arginfo_TElGoogleDriveDataStorageObject_get_Shared, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_SharedWithMeDate, arginfo_TElGoogleDriveDataStorageObject_get_SharedWithMeDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Starred, arginfo_TElGoogleDriveDataStorageObject_get_Starred, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, set_Starred, arginfo_TElGoogleDriveDataStorageObject_set_Starred, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_ThumbnailLink, arginfo_TElGoogleDriveDataStorageObject_get_ThumbnailLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Trashed, arginfo_TElGoogleDriveDataStorageObject_get_Trashed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_Viewed, arginfo_TElGoogleDriveDataStorageObject_get_Viewed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_WebContentLink, arginfo_TElGoogleDriveDataStorageObject_get_WebContentLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, get_WritersCanShare, arginfo_TElGoogleDriveDataStorageObject_get_WritersCanShare, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveDataStorageObject, __construct, arginfo_TElGoogleDriveDataStorageObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveDataStorageObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveDataStorageObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveDataStorageObject", TElGoogleDriveDataStorageObject_methods);
	if (NULL == TElCustomDataStorageObject_ce_ptr)
		Register_TElCustomDataStorageObject(TSRMLS_C);
	TElGoogleDriveDataStorageObject_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveFolder_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveFolder, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveFolder_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFolder, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveFolder_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFolder, CreateFolder)
{
	char *sDescription;
	char *sName;
	int sDescription_len;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sDescription, &sDescription_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveFolder_CreateFolder(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sDescription, (int32_t)sDescription_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveFolder_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFolder, CreateObject)
{
	char *sDescription;
	char *sMimeType;
	char *sName;
	int sDescription_len;
	int sMimeType_len;
	int sName_len;
	zend_bool bHidden;
	zend_bool bRestricted;
	zend_bool bStarred;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssbbbO!", &sName, &sName_len, &sDescription, &sDescription_len, &sMimeType, &sMimeType_len, &bHidden, &bRestricted, &bStarred, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveFolder_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sDescription, (int32_t)sDescription_len, sMimeType, (int32_t)sMimeType_len, (int8_t)bHidden, (int8_t)bRestricted, (int8_t)bStarred, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string, bool, bool, bool, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFolder, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveFolder_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFolder, List)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveFolder_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFolder, ListFolders)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveFolder_ListFolders(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFolder, get_WebViewLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveFolder_get_WebViewLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1851711234, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFolder, __construct)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElGoogleDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveFolder_Create(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFolder_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFolder_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFolder_CreateFolder, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Description)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFolder_CreateObject, 0, 0, 7)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Description)
	ZEND_ARG_INFO(0, MimeType)
	ZEND_ARG_INFO(0, Hidden)
	ZEND_ARG_INFO(0, Restricted)
	ZEND_ARG_INFO(0, Starred)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFolder_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFolder_List, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFolder_ListFolders, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFolder_get_WebViewLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFolder___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElGoogleDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveFolder_methods[] = {
	PHP_ME(TElGoogleDriveFolder, Assign, arginfo_TElGoogleDriveFolder_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFolder, Clear, arginfo_TElGoogleDriveFolder_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFolder, CreateFolder, arginfo_TElGoogleDriveFolder_CreateFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFolder, CreateObject, arginfo_TElGoogleDriveFolder_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFolder, Clone, arginfo_TElGoogleDriveFolder_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFolder, List, arginfo_TElGoogleDriveFolder_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFolder, ListFolders, arginfo_TElGoogleDriveFolder_ListFolders, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFolder, get_WebViewLink, arginfo_TElGoogleDriveFolder_get_WebViewLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFolder, __construct, arginfo_TElGoogleDriveFolder___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveFolder(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveFolder_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveFolder", TElGoogleDriveFolder_methods);
	if (NULL == TElGoogleDriveDataStorageObject_ce_ptr)
		Register_TElGoogleDriveDataStorageObject(TSRMLS_C);
	TElGoogleDriveFolder_ce_ptr = zend_register_internal_class_ex(&ce, TElGoogleDriveDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveProperties, Add)
{
	char *sKey;
	char *sValue;
	int sKey_len;
	int sValue_len;
	long fVisibility;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sls", &sKey, &sKey_len, &fVisibility, &sValue, &sValue_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDriveProperties_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, (TSBGoogleDrivePropertyVisibilityRaw)fVisibility, sValue, (int32_t)sValue_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperties, Exists)
{
	char *sKey;
	int sKey_len;
	long fVisibility;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sKey, &sKey_len, &fVisibility) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveProperties_Exists(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, (TSBGoogleDrivePropertyVisibilityRaw)fVisibility, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperties, IndexOf)
{
	char *sKey;
	int sKey_len;
	long fVisibility;
	zval *oProp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProp, TElGoogleDriveProperty_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDriveProperties_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProp TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sKey, &sKey_len, &fVisibility) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDriveProperties_IndexOf_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, (TSBGoogleDrivePropertyVisibilityRaw)fVisibility, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveProperty) or (string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperties, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveProperties_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperties, ValueByKey)
{
	char *sKey;
	int sKey_len;
	long fVisibility;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sKey, &sKey_len, &fVisibility) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveProperties_ValueByKey(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, (TSBGoogleDrivePropertyVisibilityRaw)fVisibility, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1768416701, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperties, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDriveProperties_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperties, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveProperties_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2074972976, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperties, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveProperties_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveProperty_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperties, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveProperties_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperties, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElGoogleDriveDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveProperties_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties_Add, 0, 0, 3)
	ZEND_ARG_INFO(0, Key)
	ZEND_ARG_INFO(0, Visibility)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties_Exists, 0, 0, 2)
	ZEND_ARG_INFO(0, Key)
	ZEND_ARG_INFO(0, Visibility)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prop_or_Key, 0, 1)
	ZEND_ARG_INFO(0, Visibility)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties_ValueByKey, 0, 0, 2)
	ZEND_ARG_INFO(0, Key)
	ZEND_ARG_INFO(0, Visibility)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperties___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElGoogleDriveDataStorageObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveProperties_methods[] = {
	PHP_ME(TElGoogleDriveProperties, Add, arginfo_TElGoogleDriveProperties_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperties, Exists, arginfo_TElGoogleDriveProperties_Exists, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperties, IndexOf, arginfo_TElGoogleDriveProperties_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperties, Refresh, arginfo_TElGoogleDriveProperties_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperties, ValueByKey, arginfo_TElGoogleDriveProperties_ValueByKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperties, get_Count, arginfo_TElGoogleDriveProperties_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperties, get_ETag, arginfo_TElGoogleDriveProperties_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperties, get_Items, arginfo_TElGoogleDriveProperties_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperties, get_Owner, arginfo_TElGoogleDriveProperties_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperties, __construct, arginfo_TElGoogleDriveProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveProperties", TElGoogleDriveProperties_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDriveProperties_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveComment_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveComment, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElGoogleDriveComment_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveComment_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveComment)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveComment_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveComment_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveComment_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_Author)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveComment_get_Author(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_Content)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveComment_get_Content(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(772715594, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, set_Content)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveComment_set_Content(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_CreatedDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDriveComment_get_CreatedDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_Deleted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveComment_get_Deleted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_HtmlContent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveComment_get_HtmlContent(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1428273400, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveComment_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1542174800, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_ModifiedDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDriveComment_get_ModifiedDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveComment_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_Replies)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveComment_get_Replies(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveReplies_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, get_Status)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleDriveCommentStatusRaw fOutResultRaw = 0;
		SBCheckError(TElGoogleDriveComment_get_Status(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComment, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElGoogleDriveDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveComment_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElGoogleDriveComment, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_Author, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_Content, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_set_Content, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_CreatedDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_Deleted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_HtmlContent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_ModifiedDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_Replies, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment_get_Status, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComment___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElGoogleDriveDataStorageObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveComment_methods[] = {
	PHP_ME(TElGoogleDriveComment, Assign, arginfo_TElGoogleDriveComment_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, Clone, arginfo_TElGoogleDriveComment_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, Delete, arginfo_TElGoogleDriveComment_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, Refresh, arginfo_TElGoogleDriveComment_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_Author, arginfo_TElGoogleDriveComment_get_Author, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_Content, arginfo_TElGoogleDriveComment_get_Content, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, set_Content, arginfo_TElGoogleDriveComment_set_Content, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_CreatedDate, arginfo_TElGoogleDriveComment_get_CreatedDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_Deleted, arginfo_TElGoogleDriveComment_get_Deleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_HtmlContent, arginfo_TElGoogleDriveComment_get_HtmlContent, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_ID, arginfo_TElGoogleDriveComment_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_ModifiedDate, arginfo_TElGoogleDriveComment_get_ModifiedDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_Owner, arginfo_TElGoogleDriveComment_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_Replies, arginfo_TElGoogleDriveComment_get_Replies, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, get_Status, arginfo_TElGoogleDriveComment_get_Status, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComment, __construct, arginfo_TElGoogleDriveComment___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveComment(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveComment_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveComment", TElGoogleDriveComment_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDriveComment_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveReplies_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveReplies, Add)
{
	char *sContent;
	int sContent_len;
	long fAction;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sContent, &sContent_len, &fAction) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDriveReplies_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sContent, (int32_t)sContent_len, (TSBGoogleDriveReplyActionRaw)fAction, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReplies, Refresh)
{
	zend_bool bIncludeDeleted;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bIncludeDeleted) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveReplies_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bIncludeDeleted) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReplies, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDriveReplies_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReplies, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveReplies_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveReply_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReplies, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElGoogleDriveComment_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveReplies_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveComment)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReplies_Add, 0, 0, 2)
	ZEND_ARG_INFO(0, Content)
	ZEND_ARG_INFO(0, Action)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReplies_Refresh, 0, 0, 1)
	ZEND_ARG_INFO(0, IncludeDeleted)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReplies_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReplies_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReplies___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElGoogleDriveComment, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveReplies_methods[] = {
	PHP_ME(TElGoogleDriveReplies, Add, arginfo_TElGoogleDriveReplies_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReplies, Refresh, arginfo_TElGoogleDriveReplies_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReplies, get_Count, arginfo_TElGoogleDriveReplies_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReplies, get_Items, arginfo_TElGoogleDriveReplies_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReplies, __construct, arginfo_TElGoogleDriveReplies___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveReplies(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveReplies_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveReplies", TElGoogleDriveReplies_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDriveReplies_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveUser_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveUser, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveUser_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveUser, get_DisplayName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveUser_get_DisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(118356430, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveUser, get_IsAuthenticated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveUser_get_IsAuthenticated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveUser, get_PermissionID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveUser_get_PermissionID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(189799598, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveUser, get_PictureURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveUser_get_PictureURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2007731218, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveUser, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveUser_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveUser_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveUser_get_DisplayName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveUser_get_IsAuthenticated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveUser_get_PermissionID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveUser_get_PictureURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveUser___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveUser_methods[] = {
	PHP_ME(TElGoogleDriveUser, Clone, arginfo_TElGoogleDriveUser_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveUser, get_DisplayName, arginfo_TElGoogleDriveUser_get_DisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveUser, get_IsAuthenticated, arginfo_TElGoogleDriveUser_get_IsAuthenticated, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveUser, get_PermissionID, arginfo_TElGoogleDriveUser_get_PermissionID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveUser, get_PictureURL, arginfo_TElGoogleDriveUser_get_PictureURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveUser, __construct, arginfo_TElGoogleDriveUser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveUser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveUser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveUser", TElGoogleDriveUser_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDriveUser_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveAccountInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveAccountInfo, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveAccountInfo_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_DomainSharingPolicy)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveAccountInfo_get_DomainSharingPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1824297312, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveAccountInfo_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2029420675, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_LanguageCode)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveAccountInfo_get_LanguageCode(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(291889219, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_LargestChangeID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveAccountInfo_get_LargestChangeID(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveAccountInfo_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-806613287, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_PermissionID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveAccountInfo_get_PermissionID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(26602571, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_QuotaBytesTotal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveAccountInfo_get_QuotaBytesTotal(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_QuotaBytesUsed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveAccountInfo_get_QuotaBytesUsed(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_QuotaBytesUsedAggregate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveAccountInfo_get_QuotaBytesUsedAggregate(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_QuotaBytesUsedInTrash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveAccountInfo_get_QuotaBytesUsedInTrash(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_RemainingChangeIDs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveAccountInfo_get_RemainingChangeIDs(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_RootFolderID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveAccountInfo_get_RootFolderID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(764124397, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, get_User)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveAccountInfo_get_User(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveAccountInfo, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElGoogleDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveAccountInfo_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_DomainSharingPolicy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_LanguageCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_LargestChangeID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_PermissionID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_QuotaBytesTotal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_QuotaBytesUsed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_QuotaBytesUsedAggregate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_QuotaBytesUsedInTrash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_RemainingChangeIDs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_RootFolderID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo_get_User, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveAccountInfo___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElGoogleDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveAccountInfo_methods[] = {
	PHP_ME(TElGoogleDriveAccountInfo, Refresh, arginfo_TElGoogleDriveAccountInfo_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_DomainSharingPolicy, arginfo_TElGoogleDriveAccountInfo_get_DomainSharingPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_ETag, arginfo_TElGoogleDriveAccountInfo_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_LanguageCode, arginfo_TElGoogleDriveAccountInfo_get_LanguageCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_LargestChangeID, arginfo_TElGoogleDriveAccountInfo_get_LargestChangeID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_Name, arginfo_TElGoogleDriveAccountInfo_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_PermissionID, arginfo_TElGoogleDriveAccountInfo_get_PermissionID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_QuotaBytesTotal, arginfo_TElGoogleDriveAccountInfo_get_QuotaBytesTotal, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_QuotaBytesUsed, arginfo_TElGoogleDriveAccountInfo_get_QuotaBytesUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_QuotaBytesUsedAggregate, arginfo_TElGoogleDriveAccountInfo_get_QuotaBytesUsedAggregate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_QuotaBytesUsedInTrash, arginfo_TElGoogleDriveAccountInfo_get_QuotaBytesUsedInTrash, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_RemainingChangeIDs, arginfo_TElGoogleDriveAccountInfo_get_RemainingChangeIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_RootFolderID, arginfo_TElGoogleDriveAccountInfo_get_RootFolderID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, get_User, arginfo_TElGoogleDriveAccountInfo_get_User, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveAccountInfo, __construct, arginfo_TElGoogleDriveAccountInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveAccountInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveAccountInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveAccountInfo", TElGoogleDriveAccountInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDriveAccountInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveComments_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveComments, Add)
{
	char *sContent;
	int sContent_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sContent, &sContent_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDriveComments_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sContent, (int32_t)sContent_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComments, Refresh)
{
	zend_bool bIncludeDeleted;
	zval *dtUpdatedAfter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bIncludeDeleted) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveComments_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bIncludeDeleted) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &dtUpdatedAfter, php_date_get_date_ce(), &bIncludeDeleted) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveComments_Refresh_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtUpdatedAfter TSRMLS_CC), (int8_t)bIncludeDeleted) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (DateTime, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComments, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDriveComments_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComments, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveComments_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComments, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveComments_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveComments, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElGoogleDriveDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveComments_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComments_Add, 0, 0, 1)
	ZEND_ARG_INFO(0, Content)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComments_Refresh, 0, 0, 1)
	ZEND_ARG_INFO(0, IncludeDeleted_or_UpdatedAfter)
	ZEND_ARG_INFO(0, IncludeDeleted)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComments_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComments_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComments_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveComments___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElGoogleDriveDataStorageObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveComments_methods[] = {
	PHP_ME(TElGoogleDriveComments, Add, arginfo_TElGoogleDriveComments_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComments, Refresh, arginfo_TElGoogleDriveComments_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComments, get_Count, arginfo_TElGoogleDriveComments_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComments, get_Items, arginfo_TElGoogleDriveComments_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComments, get_Owner, arginfo_TElGoogleDriveComments_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveComments, __construct, arginfo_TElGoogleDriveComments___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveComments(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveComments_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveComments", TElGoogleDriveComments_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDriveComments_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveReply_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveReply, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElGoogleDriveReply_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveReply_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveReply)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveReply_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveReply_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveReply_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, get_Author)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveReply_get_Author(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, get_Content)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveReply_get_Content(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-415908510, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, set_Content)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveReply_set_Content(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, get_CreatedDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDriveReply_get_CreatedDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, get_Deleted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDriveReply_get_Deleted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, get_HtmlContent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveReply_get_HtmlContent(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-511929974, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveReply_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-948163864, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, get_ModifiedDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDriveReply_get_ModifiedDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveReply_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveReply, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElGoogleDriveComment_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveReply_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveComment)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElGoogleDriveReply, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_get_Author, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_get_Content, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_set_Content, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_get_CreatedDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_get_Deleted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_get_HtmlContent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_get_ModifiedDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveReply___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElGoogleDriveComment, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveReply_methods[] = {
	PHP_ME(TElGoogleDriveReply, Assign, arginfo_TElGoogleDriveReply_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, Clone, arginfo_TElGoogleDriveReply_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, Delete, arginfo_TElGoogleDriveReply_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, get_Author, arginfo_TElGoogleDriveReply_get_Author, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, get_Content, arginfo_TElGoogleDriveReply_get_Content, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, set_Content, arginfo_TElGoogleDriveReply_set_Content, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, get_CreatedDate, arginfo_TElGoogleDriveReply_get_CreatedDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, get_Deleted, arginfo_TElGoogleDriveReply_get_Deleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, get_HtmlContent, arginfo_TElGoogleDriveReply_get_HtmlContent, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, get_ID, arginfo_TElGoogleDriveReply_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, get_ModifiedDate, arginfo_TElGoogleDriveReply_get_ModifiedDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, get_Owner, arginfo_TElGoogleDriveReply_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveReply, __construct, arginfo_TElGoogleDriveReply___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveReply(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveReply_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveReply", TElGoogleDriveReply_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDriveReply_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveProperty_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveProperty, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveProperty_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveProperty_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperty, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveProperty_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperty, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveProperty_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperty, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveProperty_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-280924089, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperty, get_Key)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveProperty_get_Key(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1271914442, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperty, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveProperty_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1159071445, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperty, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveProperty_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperty, get_Visibility)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleDrivePropertyVisibilityRaw fOutResultRaw = 0;
		SBCheckError(TElGoogleDriveProperty_get_Visibility(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveProperty, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElGoogleDriveDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveProperty_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperty_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperty_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperty_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperty_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperty_get_Key, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperty_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperty_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperty_get_Visibility, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveProperty___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElGoogleDriveDataStorageObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveProperty_methods[] = {
	PHP_ME(TElGoogleDriveProperty, Clone, arginfo_TElGoogleDriveProperty_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperty, Delete, arginfo_TElGoogleDriveProperty_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperty, Refresh, arginfo_TElGoogleDriveProperty_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperty, get_ETag, arginfo_TElGoogleDriveProperty_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperty, get_Key, arginfo_TElGoogleDriveProperty_get_Key, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperty, get_Value, arginfo_TElGoogleDriveProperty_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperty, set_Value, arginfo_TElGoogleDriveProperty_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperty, get_Visibility, arginfo_TElGoogleDriveProperty_get_Visibility, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveProperty, __construct, arginfo_TElGoogleDriveProperty___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveProperty(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveProperty_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveProperty", TElGoogleDriveProperty_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDriveProperty_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDrivePermission_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDrivePermission, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDrivePermission_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDrivePermission_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDrivePermission_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDrivePermission_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, TransferOwnership)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDrivePermission_TransferOwnership(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_AuthKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDrivePermission_get_AuthKey(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1403202482, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_Commenter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDrivePermission_get_Commenter(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, set_Commenter)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDrivePermission_set_Commenter(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDrivePermission_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(875257874, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDrivePermission_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-676322268, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDrivePermission_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2093879736, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDrivePermission_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_PhotoLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDrivePermission_get_PhotoLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-473683396, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_Role)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleDriveUserRoleRaw fOutResultRaw = 0;
		SBCheckError(TElGoogleDrivePermission_get_Role(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, set_Role)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDrivePermission_set_Role(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGoogleDriveUserRoleRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_Scope)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleDrivePermissionScopeRaw fOutResultRaw = 0;
		SBCheckError(TElGoogleDrivePermission_get_Scope(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDrivePermission_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1590479294, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, get_WithLink)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDrivePermission_get_WithLink(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermission, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElGoogleDriveDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDrivePermission_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_TransferOwnership, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_AuthKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_Commenter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_set_Commenter, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_PhotoLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_Role, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_set_Role, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_Scope, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission_get_WithLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermission___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElGoogleDriveDataStorageObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDrivePermission_methods[] = {
	PHP_ME(TElGoogleDrivePermission, Clone, arginfo_TElGoogleDrivePermission_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, Delete, arginfo_TElGoogleDrivePermission_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, Refresh, arginfo_TElGoogleDrivePermission_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, TransferOwnership, arginfo_TElGoogleDrivePermission_TransferOwnership, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_AuthKey, arginfo_TElGoogleDrivePermission_get_AuthKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_Commenter, arginfo_TElGoogleDrivePermission_get_Commenter, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, set_Commenter, arginfo_TElGoogleDrivePermission_set_Commenter, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_ETag, arginfo_TElGoogleDrivePermission_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_ID, arginfo_TElGoogleDrivePermission_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_Name, arginfo_TElGoogleDrivePermission_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_Owner, arginfo_TElGoogleDrivePermission_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_PhotoLink, arginfo_TElGoogleDrivePermission_get_PhotoLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_Role, arginfo_TElGoogleDrivePermission_get_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, set_Role, arginfo_TElGoogleDrivePermission_set_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_Scope, arginfo_TElGoogleDrivePermission_get_Scope, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_Value, arginfo_TElGoogleDrivePermission_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, get_WithLink, arginfo_TElGoogleDrivePermission_get_WithLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermission, __construct, arginfo_TElGoogleDrivePermission___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDrivePermission(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDrivePermission_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDrivePermission", TElGoogleDrivePermission_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDrivePermission_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDrivePermissions_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDrivePermissions, Add)
{
	char *sEMailMessage;
	char *sValue;
	int sEMailMessage_len;
	int sValue_len;
	long fAccountType;
	long fRole;
	zend_bool bCanComment;
	zend_bool bSendNotificationEMails;
	zend_bool bWithLink;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llsbbbs", &fRole, &fAccountType, &sValue, &sValue_len, &bCanComment, &bWithLink, &bSendNotificationEMails, &sEMailMessage, &sEMailMessage_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDrivePermissions_Add(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGoogleDriveUserRoleRaw)fRole, (TSBGoogleDrivePermissionScopeRaw)fAccountType, sValue, (int32_t)sValue_len, (int8_t)bCanComment, (int8_t)bWithLink, (int8_t)bSendNotificationEMails, sEMailMessage, (int32_t)sEMailMessage_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, string, bool, bool, bool, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermissions, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDrivePermissions_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermissions, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDrivePermissions_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermissions, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDrivePermissions_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1181240481, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermissions, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDrivePermissions_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDrivePermission_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermissions, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDrivePermissions_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDriveDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDrivePermissions, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElGoogleDriveDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDrivePermissions_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorageObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermissions_Add, 0, 0, 7)
	ZEND_ARG_INFO(0, Role)
	ZEND_ARG_INFO(0, AccountType)
	ZEND_ARG_INFO(0, Value)
	ZEND_ARG_INFO(0, CanComment)
	ZEND_ARG_INFO(0, WithLink)
	ZEND_ARG_INFO(0, SendNotificationEMails)
	ZEND_ARG_INFO(0, EMailMessage)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermissions_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermissions_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermissions_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermissions_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermissions_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDrivePermissions___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElGoogleDriveDataStorageObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDrivePermissions_methods[] = {
	PHP_ME(TElGoogleDrivePermissions, Add, arginfo_TElGoogleDrivePermissions_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermissions, Refresh, arginfo_TElGoogleDrivePermissions_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermissions, get_Count, arginfo_TElGoogleDrivePermissions_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermissions, get_ETag, arginfo_TElGoogleDrivePermissions_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermissions, get_Items, arginfo_TElGoogleDrivePermissions_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermissions, get_Owner, arginfo_TElGoogleDrivePermissions_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDrivePermissions, __construct, arginfo_TElGoogleDrivePermissions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDrivePermissions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDrivePermissions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDrivePermissions", TElGoogleDrivePermissions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDrivePermissions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveCustomFile_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveCustomFile, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElGoogleDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveCustomFile_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveCustomFile___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElGoogleDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveCustomFile_methods[] = {
	PHP_ME(TElGoogleDriveCustomFile, __construct, arginfo_TElGoogleDriveCustomFile___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveCustomFile(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveCustomFile_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveCustomFile", TElGoogleDriveCustomFile_methods);
	if (NULL == TElGoogleDriveDataStorageObject_ce_ptr)
		Register_TElGoogleDriveDataStorageObject(TSRMLS_C);
	TElGoogleDriveCustomFile_ce_ptr = zend_register_internal_class_ex(&ce, TElGoogleDriveDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDriveFile_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDriveFile, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveFile_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDriveFile_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveFile_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, Read)
{
	zval *oData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oData, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveFile_Read(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, Write)
{
	zval *oData;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDriveFile_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, get_DownloadURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveFile_get_DownloadURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1278070179, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, get_FileExtension)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveFile_get_FileExtension(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2069289169, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, get_FileSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDriveFile_get_FileSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, get_MD5Checksum)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveFile_get_MD5Checksum(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-808350931, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, get_OriginalFileName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDriveFile_get_OriginalFileName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(612146522, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDriveFile, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElGoogleDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDriveFile_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_Read, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Data, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_Write, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Data, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_get_DownloadURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_get_FileExtension, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_get_FileSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_get_MD5Checksum, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile_get_OriginalFileName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDriveFile___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElGoogleDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDriveFile_methods[] = {
	PHP_ME(TElGoogleDriveFile, Assign, arginfo_TElGoogleDriveFile_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, Clear, arginfo_TElGoogleDriveFile_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, Clone, arginfo_TElGoogleDriveFile_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, Read, arginfo_TElGoogleDriveFile_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, Write, arginfo_TElGoogleDriveFile_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, get_DownloadURL, arginfo_TElGoogleDriveFile_get_DownloadURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, get_FileExtension, arginfo_TElGoogleDriveFile_get_FileExtension, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, get_FileSize, arginfo_TElGoogleDriveFile_get_FileSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, get_MD5Checksum, arginfo_TElGoogleDriveFile_get_MD5Checksum, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, get_OriginalFileName, arginfo_TElGoogleDriveFile_get_OriginalFileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDriveFile, __construct, arginfo_TElGoogleDriveFile___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDriveFile(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDriveFile_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDriveFile", TElGoogleDriveFile_methods);
	if (NULL == TElGoogleDriveCustomFile_ce_ptr)
		Register_TElGoogleDriveCustomFile(TSRMLS_C);
	TElGoogleDriveFile_ce_ptr = zend_register_internal_class_ex(&ce, TElGoogleDriveCustomFile_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDocument_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDocument, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDocument_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDocument, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDocument_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDocument, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDocument_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDocument, get_EmbedLink)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDocument_get_EmbedLink(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(68790022, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDocument, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElGoogleDriveDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDocument_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDriveDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDocument_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDocument_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDocument_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDocument_get_EmbedLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDocument___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElGoogleDriveDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDocument_methods[] = {
	PHP_ME(TElGoogleDocument, Assign, arginfo_TElGoogleDocument_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDocument, Clear, arginfo_TElGoogleDocument_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDocument, Clone, arginfo_TElGoogleDocument_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDocument, get_EmbedLink, arginfo_TElGoogleDocument_get_EmbedLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDocument, __construct, arginfo_TElGoogleDocument___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDocument(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDocument_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDocument", TElGoogleDocument_methods);
	if (NULL == TElGoogleDriveCustomFile_ce_ptr)
		Register_TElGoogleDriveCustomFile(TSRMLS_C);
	TElGoogleDocument_ce_ptr = zend_register_internal_class_ex(&ce, TElGoogleDriveCustomFile_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBGoogleDriveDataStorage_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBGoogleDriveRoot", NULL);
	TSBGoogleDriveRoot_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleDriveRoot_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveRoot_ce_ptr, "gdrDrive", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveRoot_ce_ptr, "gdrAppFolder", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleDriveMetadataLocation", NULL);
	TSBGoogleDriveMetadataLocation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleDriveMetadataLocation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveMetadataLocation_ce_ptr, "gdmlColocatedObjects", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveMetadataLocation_ce_ptr, "gdmlMetadataSubdir", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveMetadataLocation_ce_ptr, "gdmlMetadataDir", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleDrivePropertyVisibility", NULL);
	TSBGoogleDrivePropertyVisibility_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleDrivePropertyVisibility_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDrivePropertyVisibility_ce_ptr, "gdpvPrivate", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDrivePropertyVisibility_ce_ptr, "gdpvPublic", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleDriveUserRole", NULL);
	TSBGoogleDriveUserRole_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleDriveUserRole_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveUserRole_ce_ptr, "gdurReader", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveUserRole_ce_ptr, "gdurWriter", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveUserRole_ce_ptr, "gdurOwner", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleDrivePermissionScope", NULL);
	TSBGoogleDrivePermissionScope_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleDrivePermissionScope_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDrivePermissionScope_ce_ptr, "gdpsUser", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDrivePermissionScope_ce_ptr, "gdpsGroup", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDrivePermissionScope_ce_ptr, "gdpsDomain", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDrivePermissionScope_ce_ptr, "gdpsAnyone", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleDriveCommentStatus", NULL);
	TSBGoogleDriveCommentStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleDriveCommentStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveCommentStatus_ce_ptr, "gdcsOpen", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveCommentStatus_ce_ptr, "gdcsResolved", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleDriveReplyAction", NULL);
	TSBGoogleDriveReplyAction_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleDriveReplyAction_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveReplyAction_ce_ptr, "gdraNoAction", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveReplyAction_ce_ptr, "gdraResolve", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDriveReplyAction_ce_ptr, "gdraReopen", 2)
}

