#include "sbpgpentities.h"

zend_class_entry *TSBPGPLoadState_ce_ptr = NULL;

zend_class_entry *TSBPGPReasonForRevocation_ce_ptr = NULL;

void SB_CALLBACK TSBPGPReadEventRaw(void * _ObjectData, TObjectHandle Sender, void * UserData, void * Buffer, int32_t MaxSize, int32_t * Written, int8_t * Last)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zUserData;
	zval * zBuffer;
	zval * zMaxSize;
	zval * zWritten;
	zval * zLast;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUserData);
	SBInitPointerObject(zUserData, UserData TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zMaxSize);
	ZVAL_LONG(zMaxSize, (long)MaxSize);
	MAKE_STD_ZVAL(zWritten);
	ZVAL_LONG(zWritten, (long)*Written);
	MAKE_STD_ZVAL(zLast);
	ZVAL_BOOL(zLast, (zend_bool)*Last);

	params[0] = &zSender;
	params[1] = &zUserData;
	params[2] = &zBuffer;
	params[3] = &zMaxSize;
	params[4] = &zWritten;
	params[5] = &zLast;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUserData);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zMaxSize);
	*Written = (int32_t)Z_LVAL_P(zWritten);
	zval_ptr_dtor(&zWritten);
	*Last = (int8_t)Z_BVAL_P(zLast);
	zval_ptr_dtor(&zLast);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPWriteEventRaw(void * _ObjectData, TObjectHandle Sender, void * UserData, void * Buffer, int32_t Size)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zUserData;
	zval * zBuffer;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUserData);
	SBInitPointerObject(zUserData, UserData TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);

	params[0] = &zSender;
	params[1] = &zUserData;
	params[2] = &zBuffer;
	params[3] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUserData);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPPacketEventRaw(void * _ObjectData, TObjectHandle Sender, uint8_t PacketType, TElPGPEntityHandle * Entity, int8_t * Stop)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zPacketType;
	zval * zEntity;
	zval * zStop;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zPacketType);
	ZVAL_LONG(zPacketType, (long)PacketType);
	MAKE_STD_ZVAL(zEntity);
	SBInitObject(zEntity, TElPGPEntity_ce_ptr, *Entity TSRMLS_CC);
	MAKE_STD_ZVAL(zStop);
	ZVAL_BOOL(zStop, (zend_bool)*Stop);

	params[0] = &zSender;
	params[1] = &zPacketType;
	params[2] = &zEntity;
	params[3] = &zStop;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zPacketType);
	*Entity = SBGetObjectHandleCE(zEntity, TElPGPEntity_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zEntity TSRMLS_CC);
	zval_ptr_dtor(&zEntity);
	*Stop = (int8_t)Z_BVAL_P(zStop);
	zval_ptr_dtor(&zStop);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPPacketProcessedEventRaw(void * _ObjectData, TObjectHandle Sender, TElPGPEntityHandle Packet, int8_t * Continue)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zPacket;
	zval * zContinue;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zPacket);
	SBInitObject(zPacket, TElPGPEntity_ce_ptr, Packet TSRMLS_CC);
	MAKE_STD_ZVAL(zContinue);
	ZVAL_BOOL(zContinue, (zend_bool)*Continue);

	params[0] = &zSender;
	params[1] = &zPacket;
	params[2] = &zContinue;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zPacket);
	*Continue = (int8_t)Z_BVAL_P(zContinue);
	zval_ptr_dtor(&zContinue);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPTemporaryStreamEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream, int8_t * FreeOnFinish)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zStream;
	zval * zFreeOnFinish;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);
	MAKE_STD_ZVAL(zFreeOnFinish);
	ZVAL_BOOL(zFreeOnFinish, (zend_bool)*FreeOnFinish);

	params[0] = &zSender;
	params[1] = &zStream;
	params[2] = &zFreeOnFinish;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	*FreeOnFinish = (int8_t)Z_BVAL_P(zFreeOnFinish);
	zval_ptr_dtor(&zFreeOnFinish);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElPGPEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, Load)
{
	SBArrayZValInfo piAReadUserData;
	SBArrayZValInfo piAWriteUserData;
	zval *zpAReadUserData;
	zval *zpAWriteUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpAReadUserData, &zpAWriteUserData) == SUCCESS) && ((Z_TYPE_P(zpAReadUserData) == IS_STRING) || (Z_TYPE_P(zpAReadUserData) == IS_ARRAY) || (Z_TYPE_P(zpAReadUserData) == IS_NULL) || ((Z_TYPE_P(zpAReadUserData) == IS_OBJECT) && (Z_OBJCE_P(zpAReadUserData) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpAWriteUserData) == IS_STRING) || (Z_TYPE_P(zpAWriteUserData) == IS_ARRAY) || (Z_TYPE_P(zpAWriteUserData) == IS_NULL) || ((Z_TYPE_P(zpAWriteUserData) == IS_OBJECT) && (Z_OBJCE_P(zpAWriteUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpAReadUserData, &piAReadUserData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpAWriteUserData, &piAWriteUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPEntity_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piAReadUserData.data, piAWriteUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piAReadUserData);
		SBFreePointerZValInfo(&piAWriteUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, Save)
{
	SBArrayZValInfo piAReadUserData;
	SBArrayZValInfo piAWriteUserData;
	zval *zpAReadUserData;
	zval *zpAWriteUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpAReadUserData, &zpAWriteUserData) == SUCCESS) && ((Z_TYPE_P(zpAReadUserData) == IS_STRING) || (Z_TYPE_P(zpAReadUserData) == IS_ARRAY) || (Z_TYPE_P(zpAReadUserData) == IS_NULL) || ((Z_TYPE_P(zpAReadUserData) == IS_OBJECT) && (Z_OBJCE_P(zpAReadUserData) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpAWriteUserData) == IS_STRING) || (Z_TYPE_P(zpAWriteUserData) == IS_ARRAY) || (Z_TYPE_P(zpAWriteUserData) == IS_NULL) || ((Z_TYPE_P(zpAWriteUserData) == IS_OBJECT) && (Z_OBJCE_P(zpAWriteUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpAReadUserData, &piAReadUserData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpAWriteUserData, &piAWriteUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPEntity_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piAReadUserData.data, piAWriteUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piAReadUserData);
		SBFreePointerZValInfo(&piAWriteUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPEntity_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPEntity_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPEntity_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, get_WriteFlags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPGPEntity_get_WriteFlags(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, set_WriteFlags)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElPGPEntity_set_WriteFlags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, get_AsyncMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPEntity_get_AsyncMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, set_AsyncMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPEntity_set_AsyncMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, get_PacketType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPEntity_get_PacketType(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, get_BytesLeft)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPGPEntity_get_BytesLeft(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, get_OldPacket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPEntity_get_OldPacket(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, set_OldPacket)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPEntity_set_OldPacket(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, get_ForceUndefLenProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPEntity_get_ForceUndefLenProcessing(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, set_ForceUndefLenProcessing)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPEntity_set_ForceUndefLenProcessing(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, get_OnRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPEntity_get_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, set_OnRead)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPEntity_set_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, get_OnWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPEntity_get_OnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, set_OnWrite)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPEntity_set_OnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, get_OnFinish)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPEntity_get_OnFinish(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, set_OnFinish)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPEntity_set_OnFinish(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_Load, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AReadUserData, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AWriteUserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_Save, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AReadUserData, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AWriteUserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_get_WriteFlags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_set_WriteFlags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_get_AsyncMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_set_AsyncMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_get_PacketType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_get_BytesLeft, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_get_OldPacket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_set_OldPacket, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_get_ForceUndefLenProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_set_ForceUndefLenProcessing, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_get_OnRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_set_OnRead, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_get_OnWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_set_OnWrite, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_get_OnFinish, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity_set_OnFinish, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPEntity_methods[] = {
	PHP_ME(TElPGPEntity, Assign, arginfo_TElPGPEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, AssignTo, arginfo_TElPGPEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, Load, arginfo_TElPGPEntity_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, Save, arginfo_TElPGPEntity_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, DataAvailable, arginfo_TElPGPEntity_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, LoadFromStream, arginfo_TElPGPEntity_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, SaveToStream, arginfo_TElPGPEntity_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, get_WriteFlags, arginfo_TElPGPEntity_get_WriteFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, set_WriteFlags, arginfo_TElPGPEntity_set_WriteFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, get_AsyncMode, arginfo_TElPGPEntity_get_AsyncMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, set_AsyncMode, arginfo_TElPGPEntity_set_AsyncMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, get_PacketType, arginfo_TElPGPEntity_get_PacketType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, get_BytesLeft, arginfo_TElPGPEntity_get_BytesLeft, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, get_OldPacket, arginfo_TElPGPEntity_get_OldPacket, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, set_OldPacket, arginfo_TElPGPEntity_set_OldPacket, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, get_ForceUndefLenProcessing, arginfo_TElPGPEntity_get_ForceUndefLenProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, set_ForceUndefLenProcessing, arginfo_TElPGPEntity_set_ForceUndefLenProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, get_OnRead, arginfo_TElPGPEntity_get_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, set_OnRead, arginfo_TElPGPEntity_set_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, get_OnWrite, arginfo_TElPGPEntity_get_OnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, set_OnWrite, arginfo_TElPGPEntity_set_OnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, get_OnFinish, arginfo_TElPGPEntity_get_OnFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, set_OnFinish, arginfo_TElPGPEntity_set_OnFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEntity, __construct, arginfo_TElPGPEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPEntity", TElPGPEntity_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPEntity_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPublicKeyEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPublicKeyEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, AssignFromSecret)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElPGPSecretKeyEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEntity_AssignFromSecret(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSecretKeyEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_Timestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPGPPublicKeyEntity_get_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_Timestamp)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEntity_set_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_Expires)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKeyEntity_get_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_Expires)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEntity_set_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPPublicKeyEntity_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_PublicKeyAlgorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEntity_set_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_KeyMaterial)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2143582661, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_KeyMaterial)
{
	long l4Index;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKeyEntity_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_Version)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEntity_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_CurveOID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_CurveOID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1046886518, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_CurveOID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_CurveOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_KDFHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPPublicKeyEntity_get_KDFHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_KDFHashAlgorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEntity_set_KDFHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_KEKSymmetricAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPPublicKeyEntity_get_KEKSymmetricAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_KEKSymmetricAlgorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEntity_set_KEKSymmetricAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_RSAPublicModulus)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_RSAPublicModulus(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-464929834, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_RSAPublicModulus)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_RSAPublicModulus(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_RSAPublicExponent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_RSAPublicExponent(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1292567869, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_RSAPublicExponent)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_RSAPublicExponent(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_DSAPublicPrime)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_DSAPublicPrime(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1853974370, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_DSAPublicPrime)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_DSAPublicPrime(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_DSAPublicGroupOrder)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_DSAPublicGroupOrder(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-703973587, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_DSAPublicGroupOrder)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_DSAPublicGroupOrder(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_DSAPublicGroupGenerator)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_DSAPublicGroupGenerator(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(66709867, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_DSAPublicGroupGenerator)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_DSAPublicGroupGenerator(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_DSAPublicKeyValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_DSAPublicKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(236482564, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_DSAPublicKeyValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_DSAPublicKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_ElGamalPrime)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_ElGamalPrime(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(264914878, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_ElGamalPrime)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_ElGamalPrime(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_ElGamalGroupGenerator)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_ElGamalGroupGenerator(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1386015752, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_ElGamalGroupGenerator)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_ElGamalGroupGenerator(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_ElGamalPublicKeyValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_ElGamalPublicKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(330883919, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_ElGamalPublicKeyValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_ElGamalPublicKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, get_ECPublicKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPPublicKeyEntity_get_ECPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1178256258, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, set_ECPublicKey)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPPublicKeyEntity_set_ECPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEntity, __construct)
{
	zend_bool bSubkey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKeyEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSubkey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKeyEntity_Create_1((int8_t)bSubkey, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_AssignFromSecret, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElPGPSecretKeyEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_Timestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_Timestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_Expires, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_Expires, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_PublicKeyAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_KeyMaterial, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_KeyMaterial, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_CurveOID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_CurveOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_KDFHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_KDFHashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_KEKSymmetricAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_KEKSymmetricAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_RSAPublicModulus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_RSAPublicModulus, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_RSAPublicExponent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_RSAPublicExponent, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_DSAPublicPrime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_DSAPublicPrime, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_DSAPublicGroupOrder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_DSAPublicGroupOrder, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_DSAPublicGroupGenerator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_DSAPublicGroupGenerator, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_DSAPublicKeyValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_DSAPublicKeyValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_ElGamalPrime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_ElGamalPrime, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_ElGamalGroupGenerator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_ElGamalGroupGenerator, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_ElGamalPublicKeyValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_ElGamalPublicKeyValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_get_ECPublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity_set_ECPublicKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEntity___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, Subkey)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPublicKeyEntity_methods[] = {
	PHP_ME(TElPGPPublicKeyEntity, Assign, arginfo_TElPGPPublicKeyEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, AssignTo, arginfo_TElPGPPublicKeyEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, AssignFromSecret, arginfo_TElPGPPublicKeyEntity_AssignFromSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_Timestamp, arginfo_TElPGPPublicKeyEntity_get_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_Timestamp, arginfo_TElPGPPublicKeyEntity_set_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_Expires, arginfo_TElPGPPublicKeyEntity_get_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_Expires, arginfo_TElPGPPublicKeyEntity_set_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_PublicKeyAlgorithm, arginfo_TElPGPPublicKeyEntity_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_PublicKeyAlgorithm, arginfo_TElPGPPublicKeyEntity_set_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_KeyMaterial, arginfo_TElPGPPublicKeyEntity_get_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_KeyMaterial, arginfo_TElPGPPublicKeyEntity_set_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_Version, arginfo_TElPGPPublicKeyEntity_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_Version, arginfo_TElPGPPublicKeyEntity_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_CurveOID, arginfo_TElPGPPublicKeyEntity_get_CurveOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_CurveOID, arginfo_TElPGPPublicKeyEntity_set_CurveOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_KDFHashAlgorithm, arginfo_TElPGPPublicKeyEntity_get_KDFHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_KDFHashAlgorithm, arginfo_TElPGPPublicKeyEntity_set_KDFHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_KEKSymmetricAlgorithm, arginfo_TElPGPPublicKeyEntity_get_KEKSymmetricAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_KEKSymmetricAlgorithm, arginfo_TElPGPPublicKeyEntity_set_KEKSymmetricAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_RSAPublicModulus, arginfo_TElPGPPublicKeyEntity_get_RSAPublicModulus, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_RSAPublicModulus, arginfo_TElPGPPublicKeyEntity_set_RSAPublicModulus, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_RSAPublicExponent, arginfo_TElPGPPublicKeyEntity_get_RSAPublicExponent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_RSAPublicExponent, arginfo_TElPGPPublicKeyEntity_set_RSAPublicExponent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_DSAPublicPrime, arginfo_TElPGPPublicKeyEntity_get_DSAPublicPrime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_DSAPublicPrime, arginfo_TElPGPPublicKeyEntity_set_DSAPublicPrime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_DSAPublicGroupOrder, arginfo_TElPGPPublicKeyEntity_get_DSAPublicGroupOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_DSAPublicGroupOrder, arginfo_TElPGPPublicKeyEntity_set_DSAPublicGroupOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_DSAPublicGroupGenerator, arginfo_TElPGPPublicKeyEntity_get_DSAPublicGroupGenerator, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_DSAPublicGroupGenerator, arginfo_TElPGPPublicKeyEntity_set_DSAPublicGroupGenerator, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_DSAPublicKeyValue, arginfo_TElPGPPublicKeyEntity_get_DSAPublicKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_DSAPublicKeyValue, arginfo_TElPGPPublicKeyEntity_set_DSAPublicKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_ElGamalPrime, arginfo_TElPGPPublicKeyEntity_get_ElGamalPrime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_ElGamalPrime, arginfo_TElPGPPublicKeyEntity_set_ElGamalPrime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_ElGamalGroupGenerator, arginfo_TElPGPPublicKeyEntity_get_ElGamalGroupGenerator, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_ElGamalGroupGenerator, arginfo_TElPGPPublicKeyEntity_set_ElGamalGroupGenerator, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_ElGamalPublicKeyValue, arginfo_TElPGPPublicKeyEntity_get_ElGamalPublicKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_ElGamalPublicKeyValue, arginfo_TElPGPPublicKeyEntity_set_ElGamalPublicKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, get_ECPublicKey, arginfo_TElPGPPublicKeyEntity_get_ECPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, set_ECPublicKey, arginfo_TElPGPPublicKeyEntity_set_ECPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEntity, __construct, arginfo_TElPGPPublicKeyEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPublicKeyEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPublicKeyEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPublicKeyEntity", TElPGPPublicKeyEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPPublicKeyEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPS2K_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPS2K, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPS2K_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPS2K_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, Load)
{
	long l4Offset;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuffer, &l4Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPS2K_Load(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Offset, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, Save)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPS2K_Save(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1526208339, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, GetSymmetricKey)
{
	char *sPassphrase;
	int sPassphrase_len;
	long l4Needed;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sPassphrase, &sPassphrase_len, &l4Needed) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPS2K_GetSymmetricKey(SBGetObjectHandle(getThis() TSRMLS_CC), sPassphrase, (int32_t)sPassphrase_len, (int32_t)l4Needed, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1473138360, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, get_S2KType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPS2K_get_S2KType(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, set_S2KType)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPS2K_set_S2KType(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, get_Salt)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPS2K_get_Salt(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1798123008, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, set_Salt)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPS2K_set_Salt(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPS2K_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, set_Count)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPS2K_set_Count(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPS2K_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPS2K_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPS2K, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPS2K_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_Load, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_Save, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_GetSymmetricKey, 0, 0, 2)
	ZEND_ARG_INFO(0, Passphrase)
	ZEND_ARG_INFO(0, Needed)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_get_S2KType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_set_S2KType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_get_Salt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_set_Salt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_set_Count, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPS2K___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPS2K_methods[] = {
	PHP_ME(TElPGPS2K, Assign, arginfo_TElPGPS2K_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, AssignTo, arginfo_TElPGPS2K_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, Load, arginfo_TElPGPS2K_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, Save, arginfo_TElPGPS2K_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, GetSymmetricKey, arginfo_TElPGPS2K_GetSymmetricKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, get_S2KType, arginfo_TElPGPS2K_get_S2KType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, set_S2KType, arginfo_TElPGPS2K_set_S2KType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, get_Salt, arginfo_TElPGPS2K_get_Salt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, set_Salt, arginfo_TElPGPS2K_set_Salt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, get_Count, arginfo_TElPGPS2K_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, set_Count, arginfo_TElPGPS2K_set_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, get_HashAlgorithm, arginfo_TElPGPS2K_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, set_HashAlgorithm, arginfo_TElPGPS2K_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPS2K, __construct, arginfo_TElPGPS2K___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPS2K(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPS2K_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPS2K", TElPGPS2K_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPS2K_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPUserIDEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPUserIDEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserIDEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserIDEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserIDEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserIDEntity, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPUserIDEntity_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1132421911, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserIDEntity, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPUserIDEntity_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserIDEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserIDEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserIDEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserIDEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserIDEntity_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserIDEntity_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserIDEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPUserIDEntity_methods[] = {
	PHP_ME(TElPGPUserIDEntity, Assign, arginfo_TElPGPUserIDEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserIDEntity, AssignTo, arginfo_TElPGPUserIDEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserIDEntity, get_Name, arginfo_TElPGPUserIDEntity_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserIDEntity, set_Name, arginfo_TElPGPUserIDEntity_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserIDEntity, __construct, arginfo_TElPGPUserIDEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPUserIDEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPUserIDEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPUserIDEntity", TElPGPUserIDEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPUserIDEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPUserAttrSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPUserAttrSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttrSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttrSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrSubpacket, Compare)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElPGPUserAttrSubpacket_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPUserAttrSubpacket_Compare(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPUserAttrSubpacket)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrSubpacket, get_SubpacketType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPUserAttrSubpacket_get_SubpacketType(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrSubpacket, set_SubpacketType)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttrSubpacket_set_SubpacketType(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserAttrSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrSubpacket_Compare, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElPGPUserAttrSubpacket, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrSubpacket_get_SubpacketType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrSubpacket_set_SubpacketType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPUserAttrSubpacket_methods[] = {
	PHP_ME(TElPGPUserAttrSubpacket, Assign, arginfo_TElPGPUserAttrSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrSubpacket, AssignTo, arginfo_TElPGPUserAttrSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrSubpacket, Compare, arginfo_TElPGPUserAttrSubpacket_Compare, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrSubpacket, get_SubpacketType, arginfo_TElPGPUserAttrSubpacket_get_SubpacketType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrSubpacket, set_SubpacketType, arginfo_TElPGPUserAttrSubpacket_set_SubpacketType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrSubpacket, __construct, arginfo_TElPGPUserAttrSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPUserAttrSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPUserAttrSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPUserAttrSubpacket", TElPGPUserAttrSubpacket_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPUserAttrSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPUserAttrImageSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttrImageSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttrImageSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, Compare)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElPGPUserAttrSubpacket_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPUserAttrImageSubpacket_Compare(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPUserAttrSubpacket)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, get_HeaderVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPUserAttrImageSubpacket_get_HeaderVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, set_HeaderVersion)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttrImageSubpacket_set_HeaderVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, get_ImageFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPUserAttrImageSubpacket_get_ImageFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, set_ImageFormat)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttrImageSubpacket_set_ImageFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, get_ImageData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPUserAttrImageSubpacket_get_ImageData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1417077263, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, set_ImageData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPUserAttrImageSubpacket_set_ImageData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrImageSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserAttrImageSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket_Compare, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElPGPUserAttrSubpacket, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket_get_HeaderVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket_set_HeaderVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket_get_ImageFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket_set_ImageFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket_get_ImageData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket_set_ImageData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrImageSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPUserAttrImageSubpacket_methods[] = {
	PHP_ME(TElPGPUserAttrImageSubpacket, Assign, arginfo_TElPGPUserAttrImageSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrImageSubpacket, AssignTo, arginfo_TElPGPUserAttrImageSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrImageSubpacket, Compare, arginfo_TElPGPUserAttrImageSubpacket_Compare, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrImageSubpacket, get_HeaderVersion, arginfo_TElPGPUserAttrImageSubpacket_get_HeaderVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrImageSubpacket, set_HeaderVersion, arginfo_TElPGPUserAttrImageSubpacket_set_HeaderVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrImageSubpacket, get_ImageFormat, arginfo_TElPGPUserAttrImageSubpacket_get_ImageFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrImageSubpacket, set_ImageFormat, arginfo_TElPGPUserAttrImageSubpacket_set_ImageFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrImageSubpacket, get_ImageData, arginfo_TElPGPUserAttrImageSubpacket_get_ImageData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrImageSubpacket, set_ImageData, arginfo_TElPGPUserAttrImageSubpacket_set_ImageData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrImageSubpacket, __construct, arginfo_TElPGPUserAttrImageSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPUserAttrImageSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPUserAttrImageSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPUserAttrImageSubpacket", TElPGPUserAttrImageSubpacket_methods);
	if (NULL == TElPGPUserAttrSubpacket_ce_ptr)
		Register_TElPGPUserAttrSubpacket(TSRMLS_C);
	TElPGPUserAttrImageSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPUserAttrSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPUserAttrEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPUserAttrEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttrEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttrEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrEntity, get_Subpackets)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserAttrEntity_get_Subpackets(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttrEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserAttrEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrEntity_get_Subpackets, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttrEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPUserAttrEntity_methods[] = {
	PHP_ME(TElPGPUserAttrEntity, Assign, arginfo_TElPGPUserAttrEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrEntity, AssignTo, arginfo_TElPGPUserAttrEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrEntity, get_Subpackets, arginfo_TElPGPUserAttrEntity_get_Subpackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttrEntity, __construct, arginfo_TElPGPUserAttrEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPUserAttrEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPUserAttrEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPUserAttrEntity", TElPGPUserAttrEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPUserAttrEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSignatureEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSignatureEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSignatureEntity_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, set_Version)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, get_SignatureClass)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSignatureEntity_get_SignatureClass(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, set_SignatureClass)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_set_SignatureClass(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, get_CreationTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPGPSignatureEntity_get_CreationTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, set_CreationTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_set_CreationTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, get_KeyID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBKeyID roOutResult;
		SBCheckError(TElPGPSignatureEntity_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBKeyID_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBKeyID) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, set_KeyID)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, TSBKeyID_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_set_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBKeyID *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBKeyID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignatureEntity_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, set_PublicKeyAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_set_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignatureEntity_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, get_Subpackets)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignatureEntity_get_Subpackets(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSignatureSubpackets_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, get_SignatureMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSignatureMaterial roOutResult;
		SBCheckError(TElPGPSignatureEntity_get_SignatureMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPGPSignatureMaterial_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBPGPSignatureMaterial) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, set_SignatureMaterial)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, TSBPGPSignatureMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_set_SignatureMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPSignatureMaterial *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSignatureMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, get_LeftBits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElPGPSignatureEntity_get_LeftBits(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, set_LeftBits)
{
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureEntity_set_LeftBits(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignatureEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_get_SignatureClass, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_set_SignatureClass, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_get_CreationTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_set_CreationTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_set_KeyID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBKeyID, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_set_PublicKeyAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_get_Subpackets, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_get_SignatureMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_set_SignatureMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBPGPSignatureMaterial, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_get_LeftBits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity_set_LeftBits, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSignatureEntity_methods[] = {
	PHP_ME(TElPGPSignatureEntity, Assign, arginfo_TElPGPSignatureEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, AssignTo, arginfo_TElPGPSignatureEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, get_Version, arginfo_TElPGPSignatureEntity_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, set_Version, arginfo_TElPGPSignatureEntity_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, get_SignatureClass, arginfo_TElPGPSignatureEntity_get_SignatureClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, set_SignatureClass, arginfo_TElPGPSignatureEntity_set_SignatureClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, get_CreationTime, arginfo_TElPGPSignatureEntity_get_CreationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, set_CreationTime, arginfo_TElPGPSignatureEntity_set_CreationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, get_KeyID, arginfo_TElPGPSignatureEntity_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, set_KeyID, arginfo_TElPGPSignatureEntity_set_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, get_PublicKeyAlgorithm, arginfo_TElPGPSignatureEntity_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, set_PublicKeyAlgorithm, arginfo_TElPGPSignatureEntity_set_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, get_HashAlgorithm, arginfo_TElPGPSignatureEntity_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, set_HashAlgorithm, arginfo_TElPGPSignatureEntity_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, get_Subpackets, arginfo_TElPGPSignatureEntity_get_Subpackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, get_SignatureMaterial, arginfo_TElPGPSignatureEntity_get_SignatureMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, set_SignatureMaterial, arginfo_TElPGPSignatureEntity_set_SignatureMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, get_LeftBits, arginfo_TElPGPSignatureEntity_get_LeftBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, set_LeftBits, arginfo_TElPGPSignatureEntity_set_LeftBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureEntity, __construct, arginfo_TElPGPSignatureEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSignatureEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSignatureEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSignatureEntity", TElPGPSignatureEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPSignatureEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpacket, get_Hashed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignatureSubpacket_get_Hashed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpacket, set_Hashed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureSubpacket_set_Hashed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpacket, get_Critical)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignatureSubpacket_get_Critical(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpacket, set_Critical)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSignatureSubpacket_set_Critical(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpacket, get_SubpacketType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSignatureSubpacket_get_SubpacketType(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpacket_get_Hashed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpacket_set_Hashed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpacket_get_Critical, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpacket_set_Critical, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpacket_get_SubpacketType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPSignatureSubpacket, Assign, arginfo_TElPGPSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpacket, AssignTo, arginfo_TElPGPSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpacket, get_Hashed, arginfo_TElPGPSignatureSubpacket_get_Hashed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpacket, set_Hashed, arginfo_TElPGPSignatureSubpacket_set_Hashed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpacket, get_Critical, arginfo_TElPGPSignatureSubpacket_get_Critical, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpacket, set_Critical, arginfo_TElPGPSignatureSubpacket_set_Critical, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpacket, get_SubpacketType, arginfo_TElPGPSignatureSubpacket_get_SubpacketType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpacket, __construct, arginfo_TElPGPSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSignatureSubpacket", TElPGPSignatureSubpacket_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPCreationTimeSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPCreationTimeSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCreationTimeSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCreationTimeSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCreationTimeSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCreationTimeSignatureSubpacket, get_CreationTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPGPCreationTimeSignatureSubpacket_get_CreationTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCreationTimeSignatureSubpacket, set_CreationTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPGPCreationTimeSignatureSubpacket_set_CreationTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCreationTimeSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCreationTimeSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCreationTimeSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCreationTimeSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCreationTimeSignatureSubpacket_get_CreationTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCreationTimeSignatureSubpacket_set_CreationTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCreationTimeSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPCreationTimeSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPCreationTimeSignatureSubpacket, Assign, arginfo_TElPGPCreationTimeSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCreationTimeSignatureSubpacket, AssignTo, arginfo_TElPGPCreationTimeSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCreationTimeSignatureSubpacket, get_CreationTime, arginfo_TElPGPCreationTimeSignatureSubpacket_get_CreationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCreationTimeSignatureSubpacket, set_CreationTime, arginfo_TElPGPCreationTimeSignatureSubpacket_set_CreationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCreationTimeSignatureSubpacket, __construct, arginfo_TElPGPCreationTimeSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPCreationTimeSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPCreationTimeSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPCreationTimeSignatureSubpacket", TElPGPCreationTimeSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPCreationTimeSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPExpirationTimeSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPExpirationTimeSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPExpirationTimeSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPExpirationTimeSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPExpirationTimeSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPExpirationTimeSignatureSubpacket, get_ExpirationTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPExpirationTimeSignatureSubpacket_get_ExpirationTime(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPExpirationTimeSignatureSubpacket, set_ExpirationTime)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPExpirationTimeSignatureSubpacket_set_ExpirationTime(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPExpirationTimeSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPExpirationTimeSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExpirationTimeSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExpirationTimeSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExpirationTimeSignatureSubpacket_get_ExpirationTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExpirationTimeSignatureSubpacket_set_ExpirationTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExpirationTimeSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPExpirationTimeSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPExpirationTimeSignatureSubpacket, Assign, arginfo_TElPGPExpirationTimeSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPExpirationTimeSignatureSubpacket, AssignTo, arginfo_TElPGPExpirationTimeSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPExpirationTimeSignatureSubpacket, get_ExpirationTime, arginfo_TElPGPExpirationTimeSignatureSubpacket_get_ExpirationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPExpirationTimeSignatureSubpacket, set_ExpirationTime, arginfo_TElPGPExpirationTimeSignatureSubpacket_set_ExpirationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPExpirationTimeSignatureSubpacket, __construct, arginfo_TElPGPExpirationTimeSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPExpirationTimeSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPExpirationTimeSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPExpirationTimeSignatureSubpacket", TElPGPExpirationTimeSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPExpirationTimeSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPEmbeddedSignatureSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPEmbeddedSignatureSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPEmbeddedSignatureSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEmbeddedSignatureSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPEmbeddedSignatureSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEmbeddedSignatureSignatureSubpacket, get_Signature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPEmbeddedSignatureSignatureSubpacket_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSignatureEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEmbeddedSignatureSignatureSubpacket, set_Signature)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPGPSignatureEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPEmbeddedSignatureSignatureSubpacket_set_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSignatureEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPEmbeddedSignatureSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPEmbeddedSignatureSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEmbeddedSignatureSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEmbeddedSignatureSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEmbeddedSignatureSignatureSubpacket_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEmbeddedSignatureSignatureSubpacket_set_Signature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPSignatureEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPEmbeddedSignatureSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPEmbeddedSignatureSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPEmbeddedSignatureSignatureSubpacket, Assign, arginfo_TElPGPEmbeddedSignatureSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEmbeddedSignatureSignatureSubpacket, AssignTo, arginfo_TElPGPEmbeddedSignatureSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEmbeddedSignatureSignatureSubpacket, get_Signature, arginfo_TElPGPEmbeddedSignatureSignatureSubpacket_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEmbeddedSignatureSignatureSubpacket, set_Signature, arginfo_TElPGPEmbeddedSignatureSignatureSubpacket_set_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPEmbeddedSignatureSignatureSubpacket, __construct, arginfo_TElPGPEmbeddedSignatureSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPEmbeddedSignatureSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPEmbeddedSignatureSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPEmbeddedSignatureSignatureSubpacket", TElPGPEmbeddedSignatureSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPEmbeddedSignatureSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPExportableCertificationSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPExportableCertificationSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPExportableCertificationSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPExportableCertificationSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPExportableCertificationSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPExportableCertificationSignatureSubpacket, get_Exportable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPExportableCertificationSignatureSubpacket_get_Exportable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPExportableCertificationSignatureSubpacket, set_Exportable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPExportableCertificationSignatureSubpacket_set_Exportable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPExportableCertificationSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPExportableCertificationSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExportableCertificationSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExportableCertificationSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExportableCertificationSignatureSubpacket_get_Exportable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExportableCertificationSignatureSubpacket_set_Exportable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPExportableCertificationSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPExportableCertificationSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPExportableCertificationSignatureSubpacket, Assign, arginfo_TElPGPExportableCertificationSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPExportableCertificationSignatureSubpacket, AssignTo, arginfo_TElPGPExportableCertificationSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPExportableCertificationSignatureSubpacket, get_Exportable, arginfo_TElPGPExportableCertificationSignatureSubpacket_get_Exportable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPExportableCertificationSignatureSubpacket, set_Exportable, arginfo_TElPGPExportableCertificationSignatureSubpacket_set_Exportable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPExportableCertificationSignatureSubpacket, __construct, arginfo_TElPGPExportableCertificationSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPExportableCertificationSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPExportableCertificationSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPExportableCertificationSignatureSubpacket", TElPGPExportableCertificationSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPExportableCertificationSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPTrustSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPTrustSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPTrustSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPTrustSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustSignatureSubpacket, get_Level)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPTrustSignatureSubpacket_get_Level(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustSignatureSubpacket, set_Level)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPTrustSignatureSubpacket_set_Level(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustSignatureSubpacket, get_Amount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPTrustSignatureSubpacket_get_Amount(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustSignatureSubpacket, set_Amount)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPTrustSignatureSubpacket_set_Amount(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPTrustSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustSignatureSubpacket_get_Level, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustSignatureSubpacket_set_Level, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustSignatureSubpacket_get_Amount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustSignatureSubpacket_set_Amount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPTrustSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPTrustSignatureSubpacket, Assign, arginfo_TElPGPTrustSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustSignatureSubpacket, AssignTo, arginfo_TElPGPTrustSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustSignatureSubpacket, get_Level, arginfo_TElPGPTrustSignatureSubpacket_get_Level, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustSignatureSubpacket, set_Level, arginfo_TElPGPTrustSignatureSubpacket_set_Level, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustSignatureSubpacket, get_Amount, arginfo_TElPGPTrustSignatureSubpacket_get_Amount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustSignatureSubpacket, set_Amount, arginfo_TElPGPTrustSignatureSubpacket_set_Amount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustSignatureSubpacket, __construct, arginfo_TElPGPTrustSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPTrustSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPTrustSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPTrustSignatureSubpacket", TElPGPTrustSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPTrustSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPRegularExpressionSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPRegularExpressionSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPRegularExpressionSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRegularExpressionSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPRegularExpressionSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRegularExpressionSignatureSubpacket, get_Expression)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPRegularExpressionSignatureSubpacket_get_Expression(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(947152904, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRegularExpressionSignatureSubpacket, set_Expression)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPRegularExpressionSignatureSubpacket_set_Expression(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRegularExpressionSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPRegularExpressionSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRegularExpressionSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRegularExpressionSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRegularExpressionSignatureSubpacket_get_Expression, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRegularExpressionSignatureSubpacket_set_Expression, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRegularExpressionSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPRegularExpressionSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPRegularExpressionSignatureSubpacket, Assign, arginfo_TElPGPRegularExpressionSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRegularExpressionSignatureSubpacket, AssignTo, arginfo_TElPGPRegularExpressionSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRegularExpressionSignatureSubpacket, get_Expression, arginfo_TElPGPRegularExpressionSignatureSubpacket_get_Expression, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRegularExpressionSignatureSubpacket, set_Expression, arginfo_TElPGPRegularExpressionSignatureSubpacket_set_Expression, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRegularExpressionSignatureSubpacket, __construct, arginfo_TElPGPRegularExpressionSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPRegularExpressionSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPRegularExpressionSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPRegularExpressionSignatureSubpacket", TElPGPRegularExpressionSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPRegularExpressionSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPRevocableSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPRevocableSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPRevocableSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocableSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPRevocableSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocableSignatureSubpacket, get_Revocable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPRevocableSignatureSubpacket_get_Revocable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocableSignatureSubpacket, set_Revocable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPRevocableSignatureSubpacket_set_Revocable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocableSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPRevocableSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocableSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocableSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocableSignatureSubpacket_get_Revocable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocableSignatureSubpacket_set_Revocable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocableSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPRevocableSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPRevocableSignatureSubpacket, Assign, arginfo_TElPGPRevocableSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocableSignatureSubpacket, AssignTo, arginfo_TElPGPRevocableSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocableSignatureSubpacket, get_Revocable, arginfo_TElPGPRevocableSignatureSubpacket_get_Revocable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocableSignatureSubpacket, set_Revocable, arginfo_TElPGPRevocableSignatureSubpacket_set_Revocable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocableSignatureSubpacket, __construct, arginfo_TElPGPRevocableSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPRevocableSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPRevocableSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPRevocableSignatureSubpacket", TElPGPRevocableSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPRevocableSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPKeyExpirationTimeSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPKeyExpirationTimeSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPKeyExpirationTimeSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyExpirationTimeSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPKeyExpirationTimeSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyExpirationTimeSignatureSubpacket, get_Expires)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPKeyExpirationTimeSignatureSubpacket_get_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyExpirationTimeSignatureSubpacket, set_Expires)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPKeyExpirationTimeSignatureSubpacket_set_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyExpirationTimeSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPKeyExpirationTimeSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyExpirationTimeSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyExpirationTimeSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyExpirationTimeSignatureSubpacket_get_Expires, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyExpirationTimeSignatureSubpacket_set_Expires, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyExpirationTimeSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPKeyExpirationTimeSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPKeyExpirationTimeSignatureSubpacket, Assign, arginfo_TElPGPKeyExpirationTimeSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyExpirationTimeSignatureSubpacket, AssignTo, arginfo_TElPGPKeyExpirationTimeSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyExpirationTimeSignatureSubpacket, get_Expires, arginfo_TElPGPKeyExpirationTimeSignatureSubpacket_get_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyExpirationTimeSignatureSubpacket, set_Expires, arginfo_TElPGPKeyExpirationTimeSignatureSubpacket_set_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyExpirationTimeSignatureSubpacket, __construct, arginfo_TElPGPKeyExpirationTimeSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPKeyExpirationTimeSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPKeyExpirationTimeSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPKeyExpirationTimeSignatureSubpacket", TElPGPKeyExpirationTimeSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPKeyExpirationTimeSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, get_Preferred)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_get_Preferred(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, set_Preferred)
{
	long l4Index;
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_set_Preferred(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, get_PreferredCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_get_PreferredCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, set_PreferredCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_set_PreferredCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_get_Preferred, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_set_Preferred, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_get_PreferredCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_set_PreferredCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, Assign, arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, AssignTo, arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, get_Preferred, arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_get_Preferred, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, set_Preferred, arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_set_Preferred, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, get_PreferredCount, arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_get_PreferredCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, set_PreferredCount, arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_set_PreferredCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket, __construct, arginfo_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket", TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPRevocationKeySignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPRevocationKeySignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPRevocationKeySignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocationKeySignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPRevocationKeySignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocationKeySignatureSubpacket, get_RevClass)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPRevocationKeySignatureSubpacket_get_RevClass(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocationKeySignatureSubpacket, set_RevClass)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPRevocationKeySignatureSubpacket_set_RevClass(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocationKeySignatureSubpacket, get_AlgID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPRevocationKeySignatureSubpacket_get_AlgID(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocationKeySignatureSubpacket, set_AlgID)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPRevocationKeySignatureSubpacket_set_AlgID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocationKeySignatureSubpacket, get_Fingerprint)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPRevocationKeySignatureSubpacket_get_Fingerprint(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1389470522, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocationKeySignatureSubpacket, set_Fingerprint)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPRevocationKeySignatureSubpacket_set_Fingerprint(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPRevocationKeySignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPRevocationKeySignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocationKeySignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocationKeySignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocationKeySignatureSubpacket_get_RevClass, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocationKeySignatureSubpacket_set_RevClass, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocationKeySignatureSubpacket_get_AlgID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocationKeySignatureSubpacket_set_AlgID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocationKeySignatureSubpacket_get_Fingerprint, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocationKeySignatureSubpacket_set_Fingerprint, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPRevocationKeySignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPRevocationKeySignatureSubpacket_methods[] = {
	PHP_ME(TElPGPRevocationKeySignatureSubpacket, Assign, arginfo_TElPGPRevocationKeySignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocationKeySignatureSubpacket, AssignTo, arginfo_TElPGPRevocationKeySignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocationKeySignatureSubpacket, get_RevClass, arginfo_TElPGPRevocationKeySignatureSubpacket_get_RevClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocationKeySignatureSubpacket, set_RevClass, arginfo_TElPGPRevocationKeySignatureSubpacket_set_RevClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocationKeySignatureSubpacket, get_AlgID, arginfo_TElPGPRevocationKeySignatureSubpacket_get_AlgID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocationKeySignatureSubpacket, set_AlgID, arginfo_TElPGPRevocationKeySignatureSubpacket_set_AlgID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocationKeySignatureSubpacket, get_Fingerprint, arginfo_TElPGPRevocationKeySignatureSubpacket_get_Fingerprint, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocationKeySignatureSubpacket, set_Fingerprint, arginfo_TElPGPRevocationKeySignatureSubpacket_set_Fingerprint, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPRevocationKeySignatureSubpacket, __construct, arginfo_TElPGPRevocationKeySignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPRevocationKeySignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPRevocationKeySignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPRevocationKeySignatureSubpacket", TElPGPRevocationKeySignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPRevocationKeySignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPIssuerKeyIDSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPIssuerKeyIDSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPIssuerKeyIDSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPIssuerKeyIDSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPIssuerKeyIDSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPIssuerKeyIDSignatureSubpacket, get_KeyID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBKeyID roOutResult;
		SBCheckError(TElPGPIssuerKeyIDSignatureSubpacket_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBKeyID_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBKeyID) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPIssuerKeyIDSignatureSubpacket, set_KeyID)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, TSBKeyID_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPIssuerKeyIDSignatureSubpacket_set_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBKeyID *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBKeyID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPIssuerKeyIDSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPIssuerKeyIDSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPIssuerKeyIDSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPIssuerKeyIDSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPIssuerKeyIDSignatureSubpacket_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPIssuerKeyIDSignatureSubpacket_set_KeyID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBKeyID, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPIssuerKeyIDSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPIssuerKeyIDSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPIssuerKeyIDSignatureSubpacket, Assign, arginfo_TElPGPIssuerKeyIDSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPIssuerKeyIDSignatureSubpacket, AssignTo, arginfo_TElPGPIssuerKeyIDSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPIssuerKeyIDSignatureSubpacket, get_KeyID, arginfo_TElPGPIssuerKeyIDSignatureSubpacket_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPIssuerKeyIDSignatureSubpacket, set_KeyID, arginfo_TElPGPIssuerKeyIDSignatureSubpacket_set_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPIssuerKeyIDSignatureSubpacket, __construct, arginfo_TElPGPIssuerKeyIDSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPIssuerKeyIDSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPIssuerKeyIDSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPIssuerKeyIDSignatureSubpacket", TElPGPIssuerKeyIDSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPIssuerKeyIDSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPNotationDataSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPNotationDataSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPNotationDataSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPNotationDataSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPNotationDataSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPNotationDataSignatureSubpacket, get_HumanReadable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPNotationDataSignatureSubpacket_get_HumanReadable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPNotationDataSignatureSubpacket, set_HumanReadable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPNotationDataSignatureSubpacket_set_HumanReadable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPNotationDataSignatureSubpacket, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPNotationDataSignatureSubpacket_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1975189576, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPNotationDataSignatureSubpacket, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPNotationDataSignatureSubpacket_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPNotationDataSignatureSubpacket, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPNotationDataSignatureSubpacket_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1580876624, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPNotationDataSignatureSubpacket, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPNotationDataSignatureSubpacket_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPNotationDataSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPNotationDataSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPNotationDataSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPNotationDataSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPNotationDataSignatureSubpacket_get_HumanReadable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPNotationDataSignatureSubpacket_set_HumanReadable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPNotationDataSignatureSubpacket_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPNotationDataSignatureSubpacket_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPNotationDataSignatureSubpacket_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPNotationDataSignatureSubpacket_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPNotationDataSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPNotationDataSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPNotationDataSignatureSubpacket, Assign, arginfo_TElPGPNotationDataSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPNotationDataSignatureSubpacket, AssignTo, arginfo_TElPGPNotationDataSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPNotationDataSignatureSubpacket, get_HumanReadable, arginfo_TElPGPNotationDataSignatureSubpacket_get_HumanReadable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPNotationDataSignatureSubpacket, set_HumanReadable, arginfo_TElPGPNotationDataSignatureSubpacket_set_HumanReadable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPNotationDataSignatureSubpacket, get_Name, arginfo_TElPGPNotationDataSignatureSubpacket_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPNotationDataSignatureSubpacket, set_Name, arginfo_TElPGPNotationDataSignatureSubpacket_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPNotationDataSignatureSubpacket, get_Value, arginfo_TElPGPNotationDataSignatureSubpacket_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPNotationDataSignatureSubpacket, set_Value, arginfo_TElPGPNotationDataSignatureSubpacket_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPNotationDataSignatureSubpacket, __construct, arginfo_TElPGPNotationDataSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPNotationDataSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPNotationDataSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPNotationDataSignatureSubpacket", TElPGPNotationDataSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPNotationDataSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPreferredHashAlgorithmsSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPreferredHashAlgorithmsSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredHashAlgorithmsSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredHashAlgorithmsSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredHashAlgorithmsSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredHashAlgorithmsSignatureSubpacket, get_Preferred)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPPreferredHashAlgorithmsSignatureSubpacket_get_Preferred(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredHashAlgorithmsSignatureSubpacket, set_Preferred)
{
	long l4Index;
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredHashAlgorithmsSignatureSubpacket_set_Preferred(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredHashAlgorithmsSignatureSubpacket, get_PreferredCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPreferredHashAlgorithmsSignatureSubpacket_get_PreferredCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredHashAlgorithmsSignatureSubpacket, set_PreferredCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredHashAlgorithmsSignatureSubpacket_set_PreferredCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredHashAlgorithmsSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPreferredHashAlgorithmsSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_get_Preferred, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_set_Preferred, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_get_PreferredCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_set_PreferredCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPreferredHashAlgorithmsSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPPreferredHashAlgorithmsSignatureSubpacket, Assign, arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredHashAlgorithmsSignatureSubpacket, AssignTo, arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredHashAlgorithmsSignatureSubpacket, get_Preferred, arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_get_Preferred, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredHashAlgorithmsSignatureSubpacket, set_Preferred, arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_set_Preferred, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredHashAlgorithmsSignatureSubpacket, get_PreferredCount, arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_get_PreferredCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredHashAlgorithmsSignatureSubpacket, set_PreferredCount, arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket_set_PreferredCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredHashAlgorithmsSignatureSubpacket, __construct, arginfo_TElPGPPreferredHashAlgorithmsSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPreferredHashAlgorithmsSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPreferredHashAlgorithmsSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPreferredHashAlgorithmsSignatureSubpacket", TElPGPPreferredHashAlgorithmsSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPPreferredHashAlgorithmsSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, get_Preferred)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_get_Preferred(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, set_Preferred)
{
	long l4Index;
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_set_Preferred(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, get_PreferredCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_get_PreferredCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, set_PreferredCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_set_PreferredCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_get_Preferred, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_set_Preferred, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_get_PreferredCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_set_PreferredCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, Assign, arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, AssignTo, arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, get_Preferred, arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_get_Preferred, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, set_Preferred, arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_set_Preferred, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, get_PreferredCount, arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_get_PreferredCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, set_PreferredCount, arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_set_PreferredCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredCompressionAlgorithmsSignatureSubpacket, __construct, arginfo_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPreferredCompressionAlgorithmsSignatureSubpacket", TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPKeyServerPreferencesSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPKeyServerPreferencesSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPKeyServerPreferencesSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyServerPreferencesSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPKeyServerPreferencesSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyServerPreferencesSignatureSubpacket, get_NoModify)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyServerPreferencesSignatureSubpacket_get_NoModify(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyServerPreferencesSignatureSubpacket, set_NoModify)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPKeyServerPreferencesSignatureSubpacket_set_NoModify(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyServerPreferencesSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPKeyServerPreferencesSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyServerPreferencesSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyServerPreferencesSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyServerPreferencesSignatureSubpacket_get_NoModify, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyServerPreferencesSignatureSubpacket_set_NoModify, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyServerPreferencesSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPKeyServerPreferencesSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPKeyServerPreferencesSignatureSubpacket, Assign, arginfo_TElPGPKeyServerPreferencesSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyServerPreferencesSignatureSubpacket, AssignTo, arginfo_TElPGPKeyServerPreferencesSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyServerPreferencesSignatureSubpacket, get_NoModify, arginfo_TElPGPKeyServerPreferencesSignatureSubpacket_get_NoModify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyServerPreferencesSignatureSubpacket, set_NoModify, arginfo_TElPGPKeyServerPreferencesSignatureSubpacket_set_NoModify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyServerPreferencesSignatureSubpacket, __construct, arginfo_TElPGPKeyServerPreferencesSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPKeyServerPreferencesSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPKeyServerPreferencesSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPKeyServerPreferencesSignatureSubpacket", TElPGPKeyServerPreferencesSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPKeyServerPreferencesSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPreferredKeyServerSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPreferredKeyServerSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredKeyServerSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredKeyServerSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredKeyServerSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredKeyServerSignatureSubpacket, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPPreferredKeyServerSignatureSubpacket_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1670526277, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredKeyServerSignatureSubpacket, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPPreferredKeyServerSignatureSubpacket_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPreferredKeyServerSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPreferredKeyServerSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredKeyServerSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredKeyServerSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredKeyServerSignatureSubpacket_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredKeyServerSignatureSubpacket_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPreferredKeyServerSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPreferredKeyServerSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPPreferredKeyServerSignatureSubpacket, Assign, arginfo_TElPGPPreferredKeyServerSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredKeyServerSignatureSubpacket, AssignTo, arginfo_TElPGPPreferredKeyServerSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredKeyServerSignatureSubpacket, get_URL, arginfo_TElPGPPreferredKeyServerSignatureSubpacket_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredKeyServerSignatureSubpacket, set_URL, arginfo_TElPGPPreferredKeyServerSignatureSubpacket_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPreferredKeyServerSignatureSubpacket, __construct, arginfo_TElPGPPreferredKeyServerSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPreferredKeyServerSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPreferredKeyServerSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPreferredKeyServerSignatureSubpacket", TElPGPPreferredKeyServerSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPPreferredKeyServerSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPrimaryUserIDSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPrimaryUserIDSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPrimaryUserIDSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPrimaryUserIDSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPrimaryUserIDSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPrimaryUserIDSignatureSubpacket, get_Primary)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPPrimaryUserIDSignatureSubpacket_get_Primary(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPrimaryUserIDSignatureSubpacket, set_Primary)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPPrimaryUserIDSignatureSubpacket_set_Primary(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPrimaryUserIDSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPrimaryUserIDSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPrimaryUserIDSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPrimaryUserIDSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPrimaryUserIDSignatureSubpacket_get_Primary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPrimaryUserIDSignatureSubpacket_set_Primary, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPrimaryUserIDSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPrimaryUserIDSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPPrimaryUserIDSignatureSubpacket, Assign, arginfo_TElPGPPrimaryUserIDSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPrimaryUserIDSignatureSubpacket, AssignTo, arginfo_TElPGPPrimaryUserIDSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPrimaryUserIDSignatureSubpacket, get_Primary, arginfo_TElPGPPrimaryUserIDSignatureSubpacket_get_Primary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPrimaryUserIDSignatureSubpacket, set_Primary, arginfo_TElPGPPrimaryUserIDSignatureSubpacket_set_Primary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPrimaryUserIDSignatureSubpacket, __construct, arginfo_TElPGPPrimaryUserIDSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPrimaryUserIDSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPrimaryUserIDSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPrimaryUserIDSignatureSubpacket", TElPGPPrimaryUserIDSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPPrimaryUserIDSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPolicyURLSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPolicyURLSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPolicyURLSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPolicyURLSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPolicyURLSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPolicyURLSignatureSubpacket, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPPolicyURLSignatureSubpacket_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1083080554, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPolicyURLSignatureSubpacket, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPPolicyURLSignatureSubpacket_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPolicyURLSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPolicyURLSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPolicyURLSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPolicyURLSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPolicyURLSignatureSubpacket_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPolicyURLSignatureSubpacket_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPolicyURLSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPolicyURLSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPPolicyURLSignatureSubpacket, Assign, arginfo_TElPGPPolicyURLSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPolicyURLSignatureSubpacket, AssignTo, arginfo_TElPGPPolicyURLSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPolicyURLSignatureSubpacket, get_URL, arginfo_TElPGPPolicyURLSignatureSubpacket_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPolicyURLSignatureSubpacket, set_URL, arginfo_TElPGPPolicyURLSignatureSubpacket_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPolicyURLSignatureSubpacket, __construct, arginfo_TElPGPPolicyURLSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPolicyURLSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPolicyURLSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPolicyURLSignatureSubpacket", TElPGPPolicyURLSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPPolicyURLSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPKeyFlagsSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, get_CertifyOtherKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_get_CertifyOtherKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, set_CertifyOtherKeys)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_set_CertifyOtherKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, get_SignData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_get_SignData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, set_SignData)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_set_SignData(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, get_EncryptData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_get_EncryptData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, set_EncryptData)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_set_EncryptData(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, get_EncryptStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_get_EncryptStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, set_EncryptStorage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_set_EncryptStorage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, get_SplitKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_get_SplitKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, set_SplitKey)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_set_SplitKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, get_GroupKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_get_GroupKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, set_GroupKey)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_set_GroupKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyFlagsSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPKeyFlagsSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_get_CertifyOtherKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_set_CertifyOtherKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_get_SignData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_set_SignData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_get_EncryptData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_set_EncryptData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_get_EncryptStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_set_EncryptStorage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_get_SplitKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_set_SplitKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_get_GroupKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket_set_GroupKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyFlagsSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPKeyFlagsSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, Assign, arginfo_TElPGPKeyFlagsSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, AssignTo, arginfo_TElPGPKeyFlagsSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, get_CertifyOtherKeys, arginfo_TElPGPKeyFlagsSignatureSubpacket_get_CertifyOtherKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, set_CertifyOtherKeys, arginfo_TElPGPKeyFlagsSignatureSubpacket_set_CertifyOtherKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, get_SignData, arginfo_TElPGPKeyFlagsSignatureSubpacket_get_SignData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, set_SignData, arginfo_TElPGPKeyFlagsSignatureSubpacket_set_SignData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, get_EncryptData, arginfo_TElPGPKeyFlagsSignatureSubpacket_get_EncryptData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, set_EncryptData, arginfo_TElPGPKeyFlagsSignatureSubpacket_set_EncryptData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, get_EncryptStorage, arginfo_TElPGPKeyFlagsSignatureSubpacket_get_EncryptStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, set_EncryptStorage, arginfo_TElPGPKeyFlagsSignatureSubpacket_set_EncryptStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, get_SplitKey, arginfo_TElPGPKeyFlagsSignatureSubpacket_get_SplitKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, set_SplitKey, arginfo_TElPGPKeyFlagsSignatureSubpacket_set_SplitKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, get_GroupKey, arginfo_TElPGPKeyFlagsSignatureSubpacket_get_GroupKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, set_GroupKey, arginfo_TElPGPKeyFlagsSignatureSubpacket_set_GroupKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyFlagsSignatureSubpacket, __construct, arginfo_TElPGPKeyFlagsSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPKeyFlagsSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPKeyFlagsSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPKeyFlagsSignatureSubpacket", TElPGPKeyFlagsSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPKeyFlagsSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSignersUserIDSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSignersUserIDSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignersUserIDSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignersUserIDSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignersUserIDSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignersUserIDSignatureSubpacket, get_UserID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSignersUserIDSignatureSubpacket_get_UserID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1135965042, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignersUserIDSignatureSubpacket, set_UserID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSignersUserIDSignatureSubpacket_set_UserID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignersUserIDSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignersUserIDSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignersUserIDSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignersUserIDSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignersUserIDSignatureSubpacket_get_UserID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignersUserIDSignatureSubpacket_set_UserID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignersUserIDSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSignersUserIDSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPSignersUserIDSignatureSubpacket, Assign, arginfo_TElPGPSignersUserIDSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignersUserIDSignatureSubpacket, AssignTo, arginfo_TElPGPSignersUserIDSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignersUserIDSignatureSubpacket, get_UserID, arginfo_TElPGPSignersUserIDSignatureSubpacket_get_UserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignersUserIDSignatureSubpacket, set_UserID, arginfo_TElPGPSignersUserIDSignatureSubpacket_set_UserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignersUserIDSignatureSubpacket, __construct, arginfo_TElPGPSignersUserIDSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSignersUserIDSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSignersUserIDSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSignersUserIDSignatureSubpacket", TElPGPSignersUserIDSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPSignersUserIDSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPReasonForRevocationSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPReasonForRevocationSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPReasonForRevocationSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReasonForRevocationSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPReasonForRevocationSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReasonForRevocationSignatureSubpacket, get_Reason)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPReasonForRevocationRaw fOutResultRaw = 0;
		SBCheckError(TElPGPReasonForRevocationSignatureSubpacket_get_Reason(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReasonForRevocationSignatureSubpacket, set_Reason)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPReasonForRevocationSignatureSubpacket_set_Reason(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPReasonForRevocationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReasonForRevocationSignatureSubpacket, get_Comment)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPReasonForRevocationSignatureSubpacket_get_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1724785671, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReasonForRevocationSignatureSubpacket, set_Comment)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPReasonForRevocationSignatureSubpacket_set_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPReasonForRevocationSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPReasonForRevocationSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReasonForRevocationSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReasonForRevocationSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReasonForRevocationSignatureSubpacket_get_Reason, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReasonForRevocationSignatureSubpacket_set_Reason, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReasonForRevocationSignatureSubpacket_get_Comment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReasonForRevocationSignatureSubpacket_set_Comment, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPReasonForRevocationSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPReasonForRevocationSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPReasonForRevocationSignatureSubpacket, Assign, arginfo_TElPGPReasonForRevocationSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReasonForRevocationSignatureSubpacket, AssignTo, arginfo_TElPGPReasonForRevocationSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReasonForRevocationSignatureSubpacket, get_Reason, arginfo_TElPGPReasonForRevocationSignatureSubpacket_get_Reason, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReasonForRevocationSignatureSubpacket, set_Reason, arginfo_TElPGPReasonForRevocationSignatureSubpacket_set_Reason, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReasonForRevocationSignatureSubpacket, get_Comment, arginfo_TElPGPReasonForRevocationSignatureSubpacket_get_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReasonForRevocationSignatureSubpacket, set_Comment, arginfo_TElPGPReasonForRevocationSignatureSubpacket_set_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPReasonForRevocationSignatureSubpacket, __construct, arginfo_TElPGPReasonForRevocationSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPReasonForRevocationSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPReasonForRevocationSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPReasonForRevocationSignatureSubpacket", TElPGPReasonForRevocationSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPReasonForRevocationSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPFeaturesSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPFeaturesSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPFeaturesSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPFeaturesSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPFeaturesSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPFeaturesSignatureSubpacket, get_ModificationDetection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPFeaturesSignatureSubpacket_get_ModificationDetection(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPFeaturesSignatureSubpacket, set_ModificationDetection)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPFeaturesSignatureSubpacket_set_ModificationDetection(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPFeaturesSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPFeaturesSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPFeaturesSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPFeaturesSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPFeaturesSignatureSubpacket_get_ModificationDetection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPFeaturesSignatureSubpacket_set_ModificationDetection, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPFeaturesSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPFeaturesSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPFeaturesSignatureSubpacket, Assign, arginfo_TElPGPFeaturesSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPFeaturesSignatureSubpacket, AssignTo, arginfo_TElPGPFeaturesSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPFeaturesSignatureSubpacket, get_ModificationDetection, arginfo_TElPGPFeaturesSignatureSubpacket_get_ModificationDetection, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPFeaturesSignatureSubpacket, set_ModificationDetection, arginfo_TElPGPFeaturesSignatureSubpacket_set_ModificationDetection, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPFeaturesSignatureSubpacket, __construct, arginfo_TElPGPFeaturesSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPFeaturesSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPFeaturesSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPFeaturesSignatureSubpacket", TElPGPFeaturesSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPFeaturesSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPTargetSignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPTargetSignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPTargetSignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTargetSignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPTargetSignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTargetSignatureSubpacket, get_Hash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPTargetSignatureSubpacket_get_Hash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-746636638, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTargetSignatureSubpacket, set_Hash)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPTargetSignatureSubpacket_set_Hash(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTargetSignatureSubpacket, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPTargetSignatureSubpacket_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTargetSignatureSubpacket, set_PublicKeyAlgorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPTargetSignatureSubpacket_set_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTargetSignatureSubpacket, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPTargetSignatureSubpacket_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTargetSignatureSubpacket, set_HashAlgorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPTargetSignatureSubpacket_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTargetSignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPTargetSignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTargetSignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTargetSignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTargetSignatureSubpacket_get_Hash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTargetSignatureSubpacket_set_Hash, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTargetSignatureSubpacket_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTargetSignatureSubpacket_set_PublicKeyAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTargetSignatureSubpacket_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTargetSignatureSubpacket_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTargetSignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPTargetSignatureSubpacket_methods[] = {
	PHP_ME(TElPGPTargetSignatureSubpacket, Assign, arginfo_TElPGPTargetSignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTargetSignatureSubpacket, AssignTo, arginfo_TElPGPTargetSignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTargetSignatureSubpacket, get_Hash, arginfo_TElPGPTargetSignatureSubpacket_get_Hash, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTargetSignatureSubpacket, set_Hash, arginfo_TElPGPTargetSignatureSubpacket_set_Hash, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTargetSignatureSubpacket, get_PublicKeyAlgorithm, arginfo_TElPGPTargetSignatureSubpacket_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTargetSignatureSubpacket, set_PublicKeyAlgorithm, arginfo_TElPGPTargetSignatureSubpacket_set_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTargetSignatureSubpacket, get_HashAlgorithm, arginfo_TElPGPTargetSignatureSubpacket_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTargetSignatureSubpacket, set_HashAlgorithm, arginfo_TElPGPTargetSignatureSubpacket_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTargetSignatureSubpacket, __construct, arginfo_TElPGPTargetSignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPTargetSignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPTargetSignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPTargetSignatureSubpacket", TElPGPTargetSignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPTargetSignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPX509SignatureSubpacket_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPX509SignatureSubpacket, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPX509SignatureSubpacket_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPX509SignatureSubpacket, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPX509SignatureSubpacket_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPX509SignatureSubpacket, get_Certificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPX509SignatureSubpacket_get_Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPX509SignatureSubpacket, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPX509SignatureSubpacket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPX509SignatureSubpacket_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPX509SignatureSubpacket_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPX509SignatureSubpacket_get_Certificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPX509SignatureSubpacket___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPX509SignatureSubpacket_methods[] = {
	PHP_ME(TElPGPX509SignatureSubpacket, Assign, arginfo_TElPGPX509SignatureSubpacket_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPX509SignatureSubpacket, AssignTo, arginfo_TElPGPX509SignatureSubpacket_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPX509SignatureSubpacket, get_Certificate, arginfo_TElPGPX509SignatureSubpacket_get_Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPX509SignatureSubpacket, __construct, arginfo_TElPGPX509SignatureSubpacket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPX509SignatureSubpacket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPX509SignatureSubpacket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPX509SignatureSubpacket", TElPGPX509SignatureSubpacket_methods);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	TElPGPX509SignatureSubpacket_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPSignatureSubpacket_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSignatureSubpackets_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSignatureSubpackets, GetSubpacket)
{
	long l4StartFrom;
	long u1SubpacketType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1SubpacketType, &l4StartFrom) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignatureSubpackets_GetSubpacket(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1SubpacketType, (int32_t)l4StartFrom, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSignatureSubpacket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpackets, GetSubpacketCount)
{
	long u1SubpacketType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1SubpacketType) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignatureSubpackets_GetSubpacketCount(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1SubpacketType, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpackets, Add)
{
	SBArrayZValInfo piItem;
	zval *oItem;
	zval *zpItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oItem, TElPGPSignatureSubpacket_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignatureSubpackets_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oItem TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPSignatureSubpackets_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), piItem.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSignatureSubpacket) or (TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpackets, RemoveSubpacket)
{
	long l4StartIndex;
	long u1SubpacketType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1SubpacketType, &l4StartIndex) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignatureSubpackets_RemoveSubpacket(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1SubpacketType, (int32_t)l4StartIndex, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpackets, RemoveSubpacketByIndex)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignatureSubpackets_RemoveSubpacketByIndex(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpackets, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPSignatureSubpackets_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignatureSubpackets, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignatureSubpackets_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpackets_GetSubpacket, 0, 0, 2)
	ZEND_ARG_INFO(0, SubpacketType)
	ZEND_ARG_INFO(0, StartFrom)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpackets_GetSubpacketCount, 0, 0, 1)
	ZEND_ARG_INFO(0, SubpacketType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpackets_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpackets_RemoveSubpacket, 0, 0, 2)
	ZEND_ARG_INFO(0, SubpacketType)
	ZEND_ARG_INFO(0, StartIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpackets_RemoveSubpacketByIndex, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpackets_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignatureSubpackets___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSignatureSubpackets_methods[] = {
	PHP_ME(TElPGPSignatureSubpackets, GetSubpacket, arginfo_TElPGPSignatureSubpackets_GetSubpacket, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpackets, GetSubpacketCount, arginfo_TElPGPSignatureSubpackets_GetSubpacketCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpackets, Add, arginfo_TElPGPSignatureSubpackets_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpackets, RemoveSubpacket, arginfo_TElPGPSignatureSubpackets_RemoveSubpacket, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpackets, RemoveSubpacketByIndex, arginfo_TElPGPSignatureSubpackets_RemoveSubpacketByIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpackets, Clear, arginfo_TElPGPSignatureSubpackets_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignatureSubpackets, __construct, arginfo_TElPGPSignatureSubpackets___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSignatureSubpackets(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSignatureSubpackets_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSignatureSubpackets", TElPGPSignatureSubpackets_methods);
	if (NULL == TList_ce_ptr)
		Register_TList(TSRMLS_C);
	TElPGPSignatureSubpackets_ce_ptr = zend_register_internal_class_ex(&ce, TList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPTrustEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPTrustEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPTrustEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPTrustEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustEntity, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPTrustEntity_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustEntity, set_Flags)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPTrustEntity_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrustEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPTrustEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustEntity_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustEntity_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrustEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPTrustEntity_methods[] = {
	PHP_ME(TElPGPTrustEntity, Assign, arginfo_TElPGPTrustEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustEntity, AssignTo, arginfo_TElPGPTrustEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustEntity, get_Flags, arginfo_TElPGPTrustEntity_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustEntity, set_Flags, arginfo_TElPGPTrustEntity_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrustEntity, __construct, arginfo_TElPGPTrustEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPTrustEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPTrustEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPTrustEntity", TElPGPTrustEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPTrustEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPublicKeyEncryptedSessionKeyEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPublicKeyEncryptedSessionKeyEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEncryptedSessionKeyEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEncryptedSessionKeyEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEncryptedSessionKeyEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEncryptedSessionKeyEntity, get_KeyID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBKeyID roOutResult;
		SBCheckError(TElPGPPublicKeyEncryptedSessionKeyEntity_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBKeyID_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBKeyID) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEncryptedSessionKeyEntity, set_KeyID)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, TSBKeyID_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEncryptedSessionKeyEntity_set_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBKeyID *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBKeyID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEncryptedSessionKeyEntity, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKeyEncryptedSessionKeyEntity_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEncryptedSessionKeyEntity, set_PublicKeyAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEncryptedSessionKeyEntity_set_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEncryptedSessionKeyEntity, get_EncryptedKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPEncryptedSymmetricKey roOutResult;
		SBCheckError(TElPGPPublicKeyEncryptedSessionKeyEntity_get_EncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPGPEncryptedSymmetricKey_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBPGPEncryptedSymmetricKey) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEncryptedSessionKeyEntity, set_EncryptedKey)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, TSBPGPEncryptedSymmetricKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKeyEncryptedSessionKeyEntity_set_EncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPEncryptedSymmetricKey *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPEncryptedSymmetricKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKeyEncryptedSessionKeyEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKeyEncryptedSessionKeyEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_set_KeyID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBKeyID, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_set_PublicKeyAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_get_EncryptedKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_set_EncryptedKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBPGPEncryptedSymmetricKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPublicKeyEncryptedSessionKeyEntity_methods[] = {
	PHP_ME(TElPGPPublicKeyEncryptedSessionKeyEntity, Assign, arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEncryptedSessionKeyEntity, AssignTo, arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEncryptedSessionKeyEntity, get_KeyID, arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEncryptedSessionKeyEntity, set_KeyID, arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_set_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEncryptedSessionKeyEntity, get_PublicKeyAlgorithm, arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEncryptedSessionKeyEntity, set_PublicKeyAlgorithm, arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_set_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEncryptedSessionKeyEntity, get_EncryptedKey, arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_get_EncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEncryptedSessionKeyEntity, set_EncryptedKey, arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity_set_EncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKeyEncryptedSessionKeyEntity, __construct, arginfo_TElPGPPublicKeyEncryptedSessionKeyEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPublicKeyEncryptedSessionKeyEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPublicKeyEncryptedSessionKeyEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPublicKeyEncryptedSessionKeyEntity", TElPGPPublicKeyEncryptedSessionKeyEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPPublicKeyEncryptedSessionKeyEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSymmetricKeyEncryptedSessionKeyEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSymmetricKeyEncryptedSessionKeyEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSymmetricKeyEncryptedSessionKeyEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricKeyEncryptedSessionKeyEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSymmetricKeyEncryptedSessionKeyEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricKeyEncryptedSessionKeyEntity, get_SymmetricAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_SymmetricAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricKeyEncryptedSessionKeyEntity, set_SymmetricAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPSymmetricKeyEncryptedSessionKeyEntity_set_SymmetricAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricKeyEncryptedSessionKeyEntity, get_EncryptedKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_EncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-927187749, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricKeyEncryptedSessionKeyEntity, set_EncryptedKey)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPSymmetricKeyEncryptedSessionKeyEntity_set_EncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricKeyEncryptedSessionKeyEntity, get_S2K)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_S2K(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPS2K_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricKeyEncryptedSessionKeyEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSymmetricKeyEncryptedSessionKeyEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_SymmetricAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_set_SymmetricAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_EncryptedKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_set_EncryptedKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_S2K, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSymmetricKeyEncryptedSessionKeyEntity_methods[] = {
	PHP_ME(TElPGPSymmetricKeyEncryptedSessionKeyEntity, Assign, arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricKeyEncryptedSessionKeyEntity, AssignTo, arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricKeyEncryptedSessionKeyEntity, get_SymmetricAlgorithm, arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_SymmetricAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricKeyEncryptedSessionKeyEntity, set_SymmetricAlgorithm, arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_set_SymmetricAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricKeyEncryptedSessionKeyEntity, get_EncryptedKey, arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_EncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricKeyEncryptedSessionKeyEntity, set_EncryptedKey, arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_set_EncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricKeyEncryptedSessionKeyEntity, get_S2K, arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_S2K, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricKeyEncryptedSessionKeyEntity, __construct, arginfo_TElPGPSymmetricKeyEncryptedSessionKeyEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSymmetricKeyEncryptedSessionKeyEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSymmetricKeyEncryptedSessionKeyEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSymmetricKeyEncryptedSessionKeyEntity", TElPGPSymmetricKeyEncryptedSessionKeyEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPSymmetricKeyEncryptedSessionKeyEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPOnePassSignatureEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPOnePassSignatureEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPOnePassSignatureEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, get_SignatureClass)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPOnePassSignatureEntity_get_SignatureClass(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, set_SignatureClass)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPOnePassSignatureEntity_set_SignatureClass(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPOnePassSignatureEntity_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPOnePassSignatureEntity_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPOnePassSignatureEntity_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, set_PublicKeyAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPOnePassSignatureEntity_set_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, get_KeyID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBKeyID roOutResult;
		SBCheckError(TElPGPOnePassSignatureEntity_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBKeyID_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBKeyID) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, set_KeyID)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, TSBKeyID_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPOnePassSignatureEntity_set_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBKeyID *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBKeyID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPOnePassSignatureEntity_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, set_Version)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPOnePassSignatureEntity_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, get_Nested)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPOnePassSignatureEntity_get_Nested(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, set_Nested)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPOnePassSignatureEntity_set_Nested(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPOnePassSignatureEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPOnePassSignatureEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_get_SignatureClass, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_set_SignatureClass, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_set_PublicKeyAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_set_KeyID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBKeyID, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_get_Nested, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity_set_Nested, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPOnePassSignatureEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPOnePassSignatureEntity_methods[] = {
	PHP_ME(TElPGPOnePassSignatureEntity, Assign, arginfo_TElPGPOnePassSignatureEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, AssignTo, arginfo_TElPGPOnePassSignatureEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, get_SignatureClass, arginfo_TElPGPOnePassSignatureEntity_get_SignatureClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, set_SignatureClass, arginfo_TElPGPOnePassSignatureEntity_set_SignatureClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, get_HashAlgorithm, arginfo_TElPGPOnePassSignatureEntity_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, set_HashAlgorithm, arginfo_TElPGPOnePassSignatureEntity_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, get_PublicKeyAlgorithm, arginfo_TElPGPOnePassSignatureEntity_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, set_PublicKeyAlgorithm, arginfo_TElPGPOnePassSignatureEntity_set_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, get_KeyID, arginfo_TElPGPOnePassSignatureEntity_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, set_KeyID, arginfo_TElPGPOnePassSignatureEntity_set_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, get_Version, arginfo_TElPGPOnePassSignatureEntity_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, set_Version, arginfo_TElPGPOnePassSignatureEntity_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, get_Nested, arginfo_TElPGPOnePassSignatureEntity_get_Nested, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, set_Nested, arginfo_TElPGPOnePassSignatureEntity_set_Nested, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPOnePassSignatureEntity, __construct, arginfo_TElPGPOnePassSignatureEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPOnePassSignatureEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPOnePassSignatureEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPOnePassSignatureEntity", TElPGPOnePassSignatureEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPOnePassSignatureEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSecretKeyEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSecretKeyEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKeyEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKeyEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, get_SymmetricAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSecretKeyEntity_get_SymmetricAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, set_SymmetricAlgorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKeyEntity_set_SymmetricAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, get_S2K)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretKeyEntity_get_S2K(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPS2K_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, set_S2K)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPGPS2K_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKeyEntity_set_S2K(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPS2K)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, get_S2KUsage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSecretKeyEntity_get_S2KUsage(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, set_S2KUsage)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKeyEntity_set_S2KUsage(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, get_IV)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPSecretKeyEntity_get_IV(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1198299137, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, set_IV)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPSecretKeyEntity_set_IV(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, get_EncryptedKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPSecretKeyEntity_get_EncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1936752746, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, set_EncryptedKey)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPSecretKeyEntity_set_EncryptedKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKeyEntity, __construct)
{
	zend_bool bSubkey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretKeyEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSubkey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretKeyEntity_Create_1((int8_t)bSubkey, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_get_SymmetricAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_set_SymmetricAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_get_S2K, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_set_S2K, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPS2K, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_get_S2KUsage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_set_S2KUsage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_get_IV, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_set_IV, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_get_EncryptedKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity_set_EncryptedKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKeyEntity___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, Subkey)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSecretKeyEntity_methods[] = {
	PHP_ME(TElPGPSecretKeyEntity, Assign, arginfo_TElPGPSecretKeyEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, AssignTo, arginfo_TElPGPSecretKeyEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, get_SymmetricAlgorithm, arginfo_TElPGPSecretKeyEntity_get_SymmetricAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, set_SymmetricAlgorithm, arginfo_TElPGPSecretKeyEntity_set_SymmetricAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, get_S2K, arginfo_TElPGPSecretKeyEntity_get_S2K, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, set_S2K, arginfo_TElPGPSecretKeyEntity_set_S2K, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, get_S2KUsage, arginfo_TElPGPSecretKeyEntity_get_S2KUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, set_S2KUsage, arginfo_TElPGPSecretKeyEntity_set_S2KUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, get_IV, arginfo_TElPGPSecretKeyEntity_get_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, set_IV, arginfo_TElPGPSecretKeyEntity_set_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, get_EncryptedKey, arginfo_TElPGPSecretKeyEntity_get_EncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, set_EncryptedKey, arginfo_TElPGPSecretKeyEntity_set_EncryptedKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKeyEntity, __construct, arginfo_TElPGPSecretKeyEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSecretKeyEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSecretKeyEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSecretKeyEntity", TElPGPSecretKeyEntity_methods);
	if (NULL == TElPGPPublicKeyEntity_ce_ptr)
		Register_TElPGPPublicKeyEntity(TSRMLS_C);
	TElPGPSecretKeyEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPPublicKeyEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPStreamingEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPStreamingEntity, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPStreamingEntity_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPStreamingEntity_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPStreamingEntity_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, Save)
{
	SBArrayZValInfo piAReadUserData;
	SBArrayZValInfo piAWriteUserData;
	zval *zpAReadUserData;
	zval *zpAWriteUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpAReadUserData, &zpAWriteUserData) == SUCCESS) && ((Z_TYPE_P(zpAReadUserData) == IS_STRING) || (Z_TYPE_P(zpAReadUserData) == IS_ARRAY) || (Z_TYPE_P(zpAReadUserData) == IS_NULL) || ((Z_TYPE_P(zpAReadUserData) == IS_OBJECT) && (Z_OBJCE_P(zpAReadUserData) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpAWriteUserData) == IS_STRING) || (Z_TYPE_P(zpAWriteUserData) == IS_ARRAY) || (Z_TYPE_P(zpAWriteUserData) == IS_NULL) || ((Z_TYPE_P(zpAWriteUserData) == IS_OBJECT) && (Z_OBJCE_P(zpAWriteUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpAReadUserData, &piAReadUserData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpAWriteUserData, &piAWriteUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPStreamingEntity_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piAReadUserData.data, piAWriteUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piAReadUserData);
		SBFreePointerZValInfo(&piAWriteUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, get_WriteFixedLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPStreamingEntity_get_WriteFixedLength(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, set_WriteFixedLength)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPStreamingEntity_set_WriteFixedLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, get_OnHeaderProcessed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPStreamingEntity_get_OnHeaderProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, set_OnHeaderProcessed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPStreamingEntity_set_OnHeaderProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, get_OnTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPStreamingEntity_get_OnTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, set_OnTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPStreamingEntity_set_OnTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamingEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPStreamingEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_Save, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AReadUserData, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AWriteUserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_get_WriteFixedLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_set_WriteFixedLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_get_OnHeaderProcessed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_set_OnHeaderProcessed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_get_OnTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity_set_OnTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamingEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPStreamingEntity_methods[] = {
	PHP_ME(TElPGPStreamingEntity, DataAvailable, arginfo_TElPGPStreamingEntity_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, LoadFromStream, arginfo_TElPGPStreamingEntity_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, SaveToStream, arginfo_TElPGPStreamingEntity_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, Save, arginfo_TElPGPStreamingEntity_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, get_WriteFixedLength, arginfo_TElPGPStreamingEntity_get_WriteFixedLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, set_WriteFixedLength, arginfo_TElPGPStreamingEntity_set_WriteFixedLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, get_OnHeaderProcessed, arginfo_TElPGPStreamingEntity_get_OnHeaderProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, set_OnHeaderProcessed, arginfo_TElPGPStreamingEntity_set_OnHeaderProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, get_OnTemporaryStream, arginfo_TElPGPStreamingEntity_get_OnTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, set_OnTemporaryStream, arginfo_TElPGPStreamingEntity_set_OnTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamingEntity, __construct, arginfo_TElPGPStreamingEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPStreamingEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPStreamingEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPStreamingEntity", TElPGPStreamingEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPStreamingEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPLiteral_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPLiteral, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPLiteral_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPLiteral, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPLiteral_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPLiteral, get_Filename)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPLiteral_get_Filename(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-669039968, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPLiteral, set_Filename)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPLiteral_set_Filename(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPLiteral, get_Timestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPGPLiteral_get_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPLiteral, set_Timestamp)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPGPLiteral_set_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPLiteral, get_TextMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPLiteral_get_TextMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPLiteral, set_TextMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPLiteral_set_TextMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPLiteral, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPLiteral_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPLiteral_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPLiteral_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPLiteral_get_Filename, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPLiteral_set_Filename, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPLiteral_get_Timestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPLiteral_set_Timestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPLiteral_get_TextMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPLiteral_set_TextMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPLiteral___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPLiteral_methods[] = {
	PHP_ME(TElPGPLiteral, Assign, arginfo_TElPGPLiteral_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPLiteral, AssignTo, arginfo_TElPGPLiteral_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPLiteral, get_Filename, arginfo_TElPGPLiteral_get_Filename, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPLiteral, set_Filename, arginfo_TElPGPLiteral_set_Filename, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPLiteral, get_Timestamp, arginfo_TElPGPLiteral_get_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPLiteral, set_Timestamp, arginfo_TElPGPLiteral_set_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPLiteral, get_TextMode, arginfo_TElPGPLiteral_get_TextMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPLiteral, set_TextMode, arginfo_TElPGPLiteral_set_TextMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPLiteral, __construct, arginfo_TElPGPLiteral___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPLiteral(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPLiteral_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPLiteral", TElPGPLiteral_methods);
	if (NULL == TElPGPStreamingEntity_ce_ptr)
		Register_TElPGPStreamingEntity(TSRMLS_C);
	TElPGPLiteral_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPStreamingEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSymmetricallyEncrypted_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSymmetricallyEncrypted, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSymmetricallyEncrypted_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricallyEncrypted, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSymmetricallyEncrypted_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricallyEncrypted, get_IntegrityProtected)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSymmetricallyEncrypted_get_IntegrityProtected(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricallyEncrypted, set_IntegrityProtected)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSymmetricallyEncrypted_set_IntegrityProtected(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricallyEncrypted, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSymmetricallyEncrypted_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricallyEncrypted, set_Version)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPSymmetricallyEncrypted_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSymmetricallyEncrypted, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSymmetricallyEncrypted_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricallyEncrypted_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricallyEncrypted_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricallyEncrypted_get_IntegrityProtected, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricallyEncrypted_set_IntegrityProtected, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricallyEncrypted_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricallyEncrypted_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSymmetricallyEncrypted___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSymmetricallyEncrypted_methods[] = {
	PHP_ME(TElPGPSymmetricallyEncrypted, Assign, arginfo_TElPGPSymmetricallyEncrypted_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricallyEncrypted, AssignTo, arginfo_TElPGPSymmetricallyEncrypted_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricallyEncrypted, get_IntegrityProtected, arginfo_TElPGPSymmetricallyEncrypted_get_IntegrityProtected, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricallyEncrypted, set_IntegrityProtected, arginfo_TElPGPSymmetricallyEncrypted_set_IntegrityProtected, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricallyEncrypted, get_Version, arginfo_TElPGPSymmetricallyEncrypted_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricallyEncrypted, set_Version, arginfo_TElPGPSymmetricallyEncrypted_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSymmetricallyEncrypted, __construct, arginfo_TElPGPSymmetricallyEncrypted___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSymmetricallyEncrypted(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSymmetricallyEncrypted_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSymmetricallyEncrypted", TElPGPSymmetricallyEncrypted_methods);
	if (NULL == TElPGPStreamingEntity_ce_ptr)
		Register_TElPGPStreamingEntity(TSRMLS_C);
	TElPGPSymmetricallyEncrypted_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPStreamingEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPCompressed_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPCompressed, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCompressed_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCompressed, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCompressed_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCompressed, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPCompressed_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCompressed, set_Algorithm)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPCompressed_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCompressed, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCompressed_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCompressed_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCompressed_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCompressed_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCompressed_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCompressed___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPCompressed_methods[] = {
	PHP_ME(TElPGPCompressed, Assign, arginfo_TElPGPCompressed_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCompressed, AssignTo, arginfo_TElPGPCompressed_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCompressed, get_Algorithm, arginfo_TElPGPCompressed_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCompressed, set_Algorithm, arginfo_TElPGPCompressed_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCompressed, __construct, arginfo_TElPGPCompressed___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPCompressed(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPCompressed_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPCompressed", TElPGPCompressed_methods);
	if (NULL == TElPGPStreamingEntity_ce_ptr)
		Register_TElPGPStreamingEntity(TSRMLS_C);
	TElPGPCompressed_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPStreamingEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPStreamProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPStreamProcessor, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPStreamProcessor_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPStreamProcessor_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, Process)
{
	SBArrayZValInfo piAReadUserData;
	SBArrayZValInfo piAWriteUserData;
	zval *zpAReadUserData;
	zval *zpAWriteUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpAReadUserData, &zpAWriteUserData) == SUCCESS) && ((Z_TYPE_P(zpAReadUserData) == IS_STRING) || (Z_TYPE_P(zpAReadUserData) == IS_ARRAY) || (Z_TYPE_P(zpAReadUserData) == IS_NULL) || ((Z_TYPE_P(zpAReadUserData) == IS_OBJECT) && (Z_OBJCE_P(zpAReadUserData) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpAWriteUserData) == IS_STRING) || (Z_TYPE_P(zpAWriteUserData) == IS_ARRAY) || (Z_TYPE_P(zpAWriteUserData) == IS_NULL) || ((Z_TYPE_P(zpAWriteUserData) == IS_OBJECT) && (Z_OBJCE_P(zpAWriteUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpAReadUserData, &piAReadUserData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpAWriteUserData, &piAWriteUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPStreamProcessor_Process(SBGetObjectHandle(getThis() TSRMLS_CC), piAReadUserData.data, piAWriteUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piAReadUserData);
		SBFreePointerZValInfo(&piAWriteUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, ProcessStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPStreamProcessor_ProcessStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPStreamProcessor_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_CurrentEntity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPStreamProcessor_get_CurrentEntity(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_Empty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPStreamProcessor_get_Empty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, set_Empty)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPStreamProcessor_set_Empty(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_AsyncMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPStreamProcessor_get_AsyncMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, set_AsyncMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPStreamProcessor_set_AsyncMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_ReadUserData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		void * poOutResult = NULL;
		SBCheckError(TElPGPStreamProcessor_get_ReadUserData(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_WriteUserData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		void * poOutResult = NULL;
		SBCheckError(TElPGPStreamProcessor_get_WriteUserData(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_OnRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPStreamProcessor_get_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, set_OnRead)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPStreamProcessor_set_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_OnWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPStreamProcessor_get_OnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, set_OnWrite)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPStreamProcessor_set_OnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_OnPacket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPPacketEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPStreamProcessor_get_OnPacket(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, set_OnPacket)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPStreamProcessor_set_OnPacket(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPPacketEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPPacketEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_OnPacketProcessed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPPacketProcessedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPStreamProcessor_get_OnPacketProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, set_OnPacketProcessed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPStreamProcessor_set_OnPacketProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPPacketProcessedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPPacketProcessedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, get_OnFinish)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPStreamProcessor_get_OnFinish(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, set_OnFinish)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPStreamProcessor_set_OnFinish(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamProcessor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPStreamProcessor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_Process, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AReadUserData, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AWriteUserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_ProcessStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_CurrentEntity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_Empty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_set_Empty, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_AsyncMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_set_AsyncMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_ReadUserData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_WriteUserData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_OnRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_set_OnRead, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_OnWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_set_OnWrite, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_OnPacket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_set_OnPacket, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_OnPacketProcessed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_set_OnPacketProcessed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_get_OnFinish, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor_set_OnFinish, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamProcessor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPStreamProcessor_methods[] = {
	PHP_ME(TElPGPStreamProcessor, Assign, arginfo_TElPGPStreamProcessor_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, AssignTo, arginfo_TElPGPStreamProcessor_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, Process, arginfo_TElPGPStreamProcessor_Process, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, ProcessStream, arginfo_TElPGPStreamProcessor_ProcessStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, DataAvailable, arginfo_TElPGPStreamProcessor_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_CurrentEntity, arginfo_TElPGPStreamProcessor_get_CurrentEntity, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_Empty, arginfo_TElPGPStreamProcessor_get_Empty, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, set_Empty, arginfo_TElPGPStreamProcessor_set_Empty, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_AsyncMode, arginfo_TElPGPStreamProcessor_get_AsyncMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, set_AsyncMode, arginfo_TElPGPStreamProcessor_set_AsyncMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_ReadUserData, arginfo_TElPGPStreamProcessor_get_ReadUserData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_WriteUserData, arginfo_TElPGPStreamProcessor_get_WriteUserData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_OnRead, arginfo_TElPGPStreamProcessor_get_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, set_OnRead, arginfo_TElPGPStreamProcessor_set_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_OnWrite, arginfo_TElPGPStreamProcessor_get_OnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, set_OnWrite, arginfo_TElPGPStreamProcessor_set_OnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_OnPacket, arginfo_TElPGPStreamProcessor_get_OnPacket, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, set_OnPacket, arginfo_TElPGPStreamProcessor_set_OnPacket, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_OnPacketProcessed, arginfo_TElPGPStreamProcessor_get_OnPacketProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, set_OnPacketProcessed, arginfo_TElPGPStreamProcessor_set_OnPacketProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, get_OnFinish, arginfo_TElPGPStreamProcessor_get_OnFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, set_OnFinish, arginfo_TElPGPStreamProcessor_set_OnFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamProcessor, __construct, arginfo_TElPGPStreamProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPStreamProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPStreamProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPStreamProcessor", TElPGPStreamProcessor_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPStreamProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPStubEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPStubEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPStubEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStubEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPStubEntity_methods[] = {
	PHP_ME(TElPGPStubEntity, __construct, arginfo_TElPGPStubEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPStubEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPStubEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPStubEntity", TElPGPStubEntity_methods);
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	TElPGPStubEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPStreamIO_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPStreamIO, Read)
{
	int32_t l4WrittenRaw;
	int8_t bLastRaw;
	long l4MaxSize;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piUserData;
	zval *oSender;
	zval *zbLast;
	zval *zl4Written;
	zval *zpBuffer;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzlzz", &oSender, TObject_ce_ptr, &zpUserData, &zpBuffer, &l4MaxSize, &zl4Written, &zbLast) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Written) && (IS_LONG == Z_TYPE_P(zl4Written)) && PZVAL_IS_REF(zbLast) && (IS_BOOL == Z_TYPE_P(zbLast)))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4WrittenRaw = (int32_t)Z_LVAL_P(zl4Written);
		bLastRaw = (int8_t)Z_BVAL_P(zbLast);
		SBCheckError(TElPGPStreamIO_Read(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSender TSRMLS_CC), piUserData.data, piBuffer.data, (int32_t)l4MaxSize, &l4WrittenRaw, &bLastRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Written, (long)l4WrittenRaw);
		ZVAL_BOOL(zbLast, (zend_bool)bLastRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject, TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL, integer, &integer, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamIO, Write)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piUserData;
	zval *oSender;
	zval *zpBuffer;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzl", &oSender, TObject_ce_ptr, &zpUserData, &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPStreamIO_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSender TSRMLS_CC), piUserData.data, piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TObject, TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamIO, get_Stream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPStreamIO_get_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamIO, set_Stream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPStreamIO_set_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPStreamIO, __construct)
{
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPStreamIO_Create(SBGetObjectHandle(oStrm TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamIO_Read, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Sender, TObject, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, MaxSize)
	ZEND_ARG_INFO(1, Written)
	ZEND_ARG_INFO(1, Last)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamIO_Write, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Sender, TObject, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamIO_get_Stream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamIO_set_Stream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPStreamIO___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPStreamIO_methods[] = {
	PHP_ME(TElPGPStreamIO, Read, arginfo_TElPGPStreamIO_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamIO, Write, arginfo_TElPGPStreamIO_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamIO, get_Stream, arginfo_TElPGPStreamIO_get_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamIO, set_Stream, arginfo_TElPGPStreamIO_set_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPStreamIO, __construct, arginfo_TElPGPStreamIO___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPStreamIO(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPStreamIO_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPStreamIO", TElPGPStreamIO_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPGPStreamIO_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBPGPEntities, CreateEntity)
{
	long u1PktType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1PktType) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPGPEntities_CreateEntity((uint8_t)u1PktType, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPGPEntities, CloneEntity)
{
	zval *oEntity;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oEntity, TElPGPEntity_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPGPEntities_CloneEntity(SBGetObjectHandle(oEntity TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPEntity)" TSRMLS_CC);
	}
}

void Register_SBPGPEntities_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPGPEntities, SB_PGP_BLOCK_SIZE, SB_PGP_BLOCK_SIZE, SB_PGP_BLOCK_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBPGPEntities, SB_PGP_PACKET_BLOCK_BASE_SIZE, SB_PGP_PACKET_BLOCK_BASE_SIZE, SB_PGP_PACKET_BLOCK_BASE_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBPGPEntities, SB_PGP_PACKET_BLOCK_SIZE, SB_PGP_PACKET_BLOCK_SIZE, SB_PGP_PACKET_BLOCK_SIZE);
}

void Register_SBPGPEntities_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPGPLoadState", NULL);
	TSBPGPLoadState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPLoadState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPLoadState_ce_ptr, "lsHeader", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPLoadState_ce_ptr, "lsOldPacketLen", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPLoadState_ce_ptr, "lsNewPacketLen", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPLoadState_ce_ptr, "lsChunk", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPLoadState_ce_ptr, "lsUndefSizeChunk", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPLoadState_ce_ptr, "lsLastChunk", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPLoadState_ce_ptr, "lsFinished", 6)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPReasonForRevocation", NULL);
	TSBPGPReasonForRevocation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPReasonForRevocation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPReasonForRevocation_ce_ptr, "rrNoReason", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPReasonForRevocation_ce_ptr, "rrKeySuperseded", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPReasonForRevocation_ce_ptr, "rrKeyCompromised", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPReasonForRevocation_ce_ptr, "rrKeyRetired", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPReasonForRevocation_ce_ptr, "rrUserIDNotValid", 4)
}

void Register_SBPGPEntities_Aliases(TSRMLS_D)
{
	if (NULL == TElPGPEntity_ce_ptr)
		Register_TElPGPEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPEntity", TElPGPEntity_ce_ptr);
	if (NULL == TElPGPSecretKeyEntity_ce_ptr)
		Register_TElPGPSecretKeyEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPSecretKeyEntity", TElPGPSecretKeyEntity_ce_ptr);
	if (NULL == TElPGPS2K_ce_ptr)
		Register_TElPGPS2K(TSRMLS_C);
	zend_register_class_alias("ElPGPS2K", TElPGPS2K_ce_ptr);
	if (NULL == TElPGPUserIDEntity_ce_ptr)
		Register_TElPGPUserIDEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPUserIDEntity", TElPGPUserIDEntity_ce_ptr);
	if (NULL == TElPGPUserAttrSubpacket_ce_ptr)
		Register_TElPGPUserAttrSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPUserAttrSubpacket", TElPGPUserAttrSubpacket_ce_ptr);
	if (NULL == TElPGPUserAttrImageSubpacket_ce_ptr)
		Register_TElPGPUserAttrImageSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPUserAttrImageSubpacket", TElPGPUserAttrImageSubpacket_ce_ptr);
	if (NULL == TElPGPUserAttrEntity_ce_ptr)
		Register_TElPGPUserAttrEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPUserAttrEntity", TElPGPUserAttrEntity_ce_ptr);
	if (NULL == TElPGPSignatureEntity_ce_ptr)
		Register_TElPGPSignatureEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPSignatureEntity", TElPGPSignatureEntity_ce_ptr);
	if (NULL == TElPGPSignatureSubpacket_ce_ptr)
		Register_TElPGPSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPSignatureSubpacket", TElPGPSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPCreationTimeSignatureSubpacket_ce_ptr)
		Register_TElPGPCreationTimeSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPCreationTimeSignatureSubpacket", TElPGPCreationTimeSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPExpirationTimeSignatureSubpacket_ce_ptr)
		Register_TElPGPExpirationTimeSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPExpirationTimeSignatureSubpacket", TElPGPExpirationTimeSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPEmbeddedSignatureSignatureSubpacket_ce_ptr)
		Register_TElPGPEmbeddedSignatureSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPEmbeddedSignatureSignatureSubpacket", TElPGPEmbeddedSignatureSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPExportableCertificationSignatureSubpacket_ce_ptr)
		Register_TElPGPExportableCertificationSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPExportableCertificationSignatureSubpacket", TElPGPExportableCertificationSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPTrustSignatureSubpacket_ce_ptr)
		Register_TElPGPTrustSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPTrustSignatureSubpacket", TElPGPTrustSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPRegularExpressionSignatureSubpacket_ce_ptr)
		Register_TElPGPRegularExpressionSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPRegularExpressionSignatureSubpacket", TElPGPRegularExpressionSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPRevocableSignatureSubpacket_ce_ptr)
		Register_TElPGPRevocableSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPRevocableSignatureSubpacket", TElPGPRevocableSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPKeyExpirationTimeSignatureSubpacket_ce_ptr)
		Register_TElPGPKeyExpirationTimeSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPKeyExpirationTimeSignatureSubpacket", TElPGPKeyExpirationTimeSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_ce_ptr)
		Register_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPPreferredSymmetricAlgorithmsSignatureSubpacket", TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPRevocationKeySignatureSubpacket_ce_ptr)
		Register_TElPGPRevocationKeySignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPRevocationKeySignatureSubpacket", TElPGPRevocationKeySignatureSubpacket_ce_ptr);
	if (NULL == TElPGPIssuerKeyIDSignatureSubpacket_ce_ptr)
		Register_TElPGPIssuerKeyIDSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPIssuerKeyIDSignatureSubpacket", TElPGPIssuerKeyIDSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPNotationDataSignatureSubpacket_ce_ptr)
		Register_TElPGPNotationDataSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPNotationDataSignatureSubpacket", TElPGPNotationDataSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPPreferredHashAlgorithmsSignatureSubpacket_ce_ptr)
		Register_TElPGPPreferredHashAlgorithmsSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPPreferredHashAlgorithmsSignatureSubpacket", TElPGPPreferredHashAlgorithmsSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_ce_ptr)
		Register_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPPreferredCompressionAlgorithmsSignatureSubpacket", TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPKeyServerPreferencesSignatureSubpacket_ce_ptr)
		Register_TElPGPKeyServerPreferencesSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPKeyServerPreferencesSignatureSubpacket", TElPGPKeyServerPreferencesSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPPreferredKeyServerSignatureSubpacket_ce_ptr)
		Register_TElPGPPreferredKeyServerSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPPreferredKeyServerSignatureSubpacket", TElPGPPreferredKeyServerSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPPrimaryUserIDSignatureSubpacket_ce_ptr)
		Register_TElPGPPrimaryUserIDSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPPrimaryUserIDSignatureSubpacket", TElPGPPrimaryUserIDSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPPolicyURLSignatureSubpacket_ce_ptr)
		Register_TElPGPPolicyURLSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPPolicyURLSignatureSubpacket", TElPGPPolicyURLSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPKeyFlagsSignatureSubpacket_ce_ptr)
		Register_TElPGPKeyFlagsSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPKeyFlagsSignatureSubpacket", TElPGPKeyFlagsSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPSignersUserIDSignatureSubpacket_ce_ptr)
		Register_TElPGPSignersUserIDSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPSignersUserIDSignatureSubpacket", TElPGPSignersUserIDSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPReasonForRevocationSignatureSubpacket_ce_ptr)
		Register_TElPGPReasonForRevocationSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPReasonForRevocationSignatureSubpacket", TElPGPReasonForRevocationSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPFeaturesSignatureSubpacket_ce_ptr)
		Register_TElPGPFeaturesSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPFeaturesSignatureSubpacket", TElPGPFeaturesSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPTargetSignatureSubpacket_ce_ptr)
		Register_TElPGPTargetSignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPTargetSignatureSubpacket", TElPGPTargetSignatureSubpacket_ce_ptr);
	if (NULL == TElPGPX509SignatureSubpacket_ce_ptr)
		Register_TElPGPX509SignatureSubpacket(TSRMLS_C);
	zend_register_class_alias("ElPGPX509SignatureSubpacket", TElPGPX509SignatureSubpacket_ce_ptr);
	if (NULL == TElPGPSignatureSubpackets_ce_ptr)
		Register_TElPGPSignatureSubpackets(TSRMLS_C);
	zend_register_class_alias("ElPGPSignatureSubpackets", TElPGPSignatureSubpackets_ce_ptr);
	if (NULL == TElPGPTrustEntity_ce_ptr)
		Register_TElPGPTrustEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPTrustEntity", TElPGPTrustEntity_ce_ptr);
	if (NULL == TElPGPPublicKeyEncryptedSessionKeyEntity_ce_ptr)
		Register_TElPGPPublicKeyEncryptedSessionKeyEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPPublicKeyEncryptedSessionKeyEntity", TElPGPPublicKeyEncryptedSessionKeyEntity_ce_ptr);
	if (NULL == TElPGPSymmetricKeyEncryptedSessionKeyEntity_ce_ptr)
		Register_TElPGPSymmetricKeyEncryptedSessionKeyEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPSymmetricKeyEncryptedSessionKeyEntity", TElPGPSymmetricKeyEncryptedSessionKeyEntity_ce_ptr);
	if (NULL == TElPGPOnePassSignatureEntity_ce_ptr)
		Register_TElPGPOnePassSignatureEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPOnePassSignatureEntity", TElPGPOnePassSignatureEntity_ce_ptr);
	if (NULL == TElPGPPublicKeyEntity_ce_ptr)
		Register_TElPGPPublicKeyEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPPublicKeyEntity", TElPGPPublicKeyEntity_ce_ptr);
	if (NULL == TElPGPStreamingEntity_ce_ptr)
		Register_TElPGPStreamingEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPStreamingEntity", TElPGPStreamingEntity_ce_ptr);
	if (NULL == TElPGPLiteral_ce_ptr)
		Register_TElPGPLiteral(TSRMLS_C);
	zend_register_class_alias("ElPGPLiteral", TElPGPLiteral_ce_ptr);
	if (NULL == TElPGPSymmetricallyEncrypted_ce_ptr)
		Register_TElPGPSymmetricallyEncrypted(TSRMLS_C);
	zend_register_class_alias("ElPGPSymmetricallyEncrypted", TElPGPSymmetricallyEncrypted_ce_ptr);
	if (NULL == TElPGPCompressed_ce_ptr)
		Register_TElPGPCompressed(TSRMLS_C);
	zend_register_class_alias("ElPGPCompressed", TElPGPCompressed_ce_ptr);
	if (NULL == TElPGPStreamProcessor_ce_ptr)
		Register_TElPGPStreamProcessor(TSRMLS_C);
	zend_register_class_alias("ElPGPStreamProcessor", TElPGPStreamProcessor_ce_ptr);
	if (NULL == TElPGPStubEntity_ce_ptr)
		Register_TElPGPStubEntity(TSRMLS_C);
	zend_register_class_alias("ElPGPStubEntity", TElPGPStubEntity_ce_ptr);
}

