#include "sbsystem.h"

#ifdef SB_WINDOWS
SB_PHP_METHOD(windows_FILETIME, __construct)
#else
SB_PHP_METHOD(in_addr, __construct)
#endif
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
#ifdef SB_WINDOWS
		intern->data = emalloc(sizeof(windows_FILETIME));
		intern->len = sizeof(windows_FILETIME);
#else
		intern->data = emalloc(sizeof(in_addr));
		intern->len = sizeof(in_addr);
#endif
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(windows_FILETIME, getSizeOf)
#else
SB_PHP_METHOD(in_addr, getSizeOf)
#endif
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

#ifdef SB_WINDOWS
	RETURN_LONG(sizeof(windows_FILETIME));
#else
	RETURN_LONG(sizeof(in_addr));
#endif
}

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()
#else
zend_class_entry *in_addr_ce_ptr = NULL;
#endif

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(windows_FILETIME, get_dwLowDateTime)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(windows_FILETIME, set_dwLowDateTime)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(windows_FILETIME, get_dwHighDateTime)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(windows_FILETIME, set_dwHighDateTime)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *windows_FILETIME_ce_ptr = NULL;

static zend_function_entry windows_FILETIME_methods[] = {
	PHP_ME(windows_FILETIME, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(windows_FILETIME, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(windows_FILETIME, get_dwLowDateTime, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(windows_FILETIME, set_dwLowDateTime, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(windows_FILETIME, get_dwHighDateTime, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(windows_FILETIME, set_dwHighDateTime, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
#else
static zend_function_entry in_addr_methods[] = {
	PHP_ME(in_addr, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(in_addr, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
#endif
	PHP_FE_END
};

#ifdef SB_WINDOWS
void Register_windows_FILETIME(TSRMLS_D)
#else
void Register_in_addr(TSRMLS_D)
#endif
{
	zend_class_entry ce;
#ifdef SB_WINDOWS
	if (windows_FILETIME_ce_ptr != NULL)
#else
	if (in_addr_ce_ptr != NULL)
#endif
		return;
#ifdef SB_WINDOWS
	INIT_CLASS_ENTRY(ce, "windows_FILETIME", windows_FILETIME_methods);
	windows_FILETIME_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
#else
	INIT_CLASS_ENTRY(ce, "in_addr", in_addr_methods);
	in_addr_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
#endif
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(windows_LARGE_INTEGER, __construct)
#else
SB_PHP_METHOD(sockaddr_in, __construct)
#endif
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
#ifdef SB_WINDOWS
		intern->data = emalloc(sizeof(windows_LARGE_INTEGER));
		intern->len = sizeof(windows_LARGE_INTEGER);
#else
		intern->data = emalloc(sizeof(sockaddr_in));
		intern->len = sizeof(sockaddr_in);
#endif
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(windows_LARGE_INTEGER, getSizeOf)
#else
SB_PHP_METHOD(sockaddr_in, getSizeOf)
#endif
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

#ifdef SB_WINDOWS
	RETURN_LONG(sizeof(windows_LARGE_INTEGER));
#else
	RETURN_LONG(sizeof(sockaddr_in));
#endif
}

#ifdef SB_WINDOWS
zend_class_entry *windows_LARGE_INTEGER_ce_ptr = NULL;
#else
zend_class_entry *sockaddr_in_ce_ptr = NULL;
#endif

#ifdef SB_WINDOWS
static zend_function_entry windows_LARGE_INTEGER_methods[] = {
	PHP_ME(windows_LARGE_INTEGER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(windows_LARGE_INTEGER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
#else
static zend_function_entry sockaddr_in_methods[] = {
	PHP_ME(sockaddr_in, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(sockaddr_in, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
#endif
	PHP_FE_END
};

#ifdef SB_WINDOWS
void Register_windows_LARGE_INTEGER(TSRMLS_D)
#else
void Register_sockaddr_in(TSRMLS_D)
#endif
{
	zend_class_entry ce;
#ifdef SB_WINDOWS
	if (windows_LARGE_INTEGER_ce_ptr != NULL)
#else
	if (sockaddr_in_ce_ptr != NULL)
#endif
		return;
#ifdef SB_WINDOWS
	INIT_CLASS_ENTRY(ce, "windows_LARGE_INTEGER", windows_LARGE_INTEGER_methods);
	windows_LARGE_INTEGER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
#else
	INIT_CLASS_ENTRY(ce, "sockaddr_in", sockaddr_in_methods);
	sockaddr_in_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
#endif
}

SB_PHP_METHOD(TByteArray, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TByteArray));
		intern->len = sizeof(TByteArray);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TByteArray, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TByteArray));
}

zend_class_entry *TByteArray_ce_ptr = NULL;

static zend_function_entry TByteArray_methods[] = {
	PHP_ME(TByteArray, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TByteArray, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TByteArray(TSRMLS_D)
{
	zend_class_entry ce;
	if (TByteArray_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TByteArray", TByteArray_methods);
	TByteArray_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TClass_ce_ptr = NULL;

zend_class_entry *TDuplicates_ce_ptr = NULL;

SB_PHP_METHOD(TGuid, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TGuid));
		intern->len = sizeof(TGuid);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TGuid, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TGuid));
}

zend_class_entry *TGuid_ce_ptr = NULL;

static zend_function_entry TGuid_methods[] = {
	PHP_ME(TGuid, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TGuid, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TGuid(TSRMLS_D)
{
	zend_class_entry ce;
	if (TGuid_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TGuid", TGuid_methods);
	TGuid_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TListAssignOp_ce_ptr = NULL;

zend_class_entry *TSeekOrigin_ce_ptr = NULL;

zend_class_entry *TTextLineBreakStyle_ce_ptr = NULL;

zend_class_entry *TThreadPriority_ce_ptr = NULL;

void SB_CALLBACK TNotifyEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TThreadMethodRaw(void * _ObjectData)
{
	zval *retval_ptr;
	TSRMLS_FETCH();

	SBCallEvent((zval *)_ObjectData, &retval_ptr, 0, NULL TSRMLS_CC);

	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

SB_PHP_METHOD(TObject, Free)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TObject_Free(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
		SBDetachObjectHandle(getThis() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TObject, GetType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TObject_ClassType(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TObject, ClassName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TObject_ClassName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1710345970, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TObject, ClassName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TObject_ClassName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1710345970, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TObject, ClassNameIs_Inst)
{
	char *sname;
	int sname_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sname, &sname_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TObject_ClassNameIs_1(SBGetObjectHandle(getThis() TSRMLS_CC), sname, (int32_t)sname_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TObject, ClassNameIs)
{
	char *sname;
	int sname_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sname, &sname_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TObject_ClassNameIs(sname, (int32_t)sname_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TObject, InstanceSize_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TObject_InstanceSize_1(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TObject, InstanceSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TObject_InstanceSize(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TObject, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_Free, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_GetType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_ClassName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_ClassName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_ClassNameIs_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_ClassNameIs, 0, 0, 1)
	ZEND_ARG_INFO(0, name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_InstanceSize_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_InstanceSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_detachHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_getOwnHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_setOwnHandle, 0, 0, 1)
	ZEND_ARG_INFO(0, ownHandle)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject_castTo, 0, 0, 0)
	ZEND_ARG_INFO(0, ClassName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject___get, 0, 0, 0)
	ZEND_ARG_INFO(0, name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject___set, 0, 0, 0)
	ZEND_ARG_INFO(0, name)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TObject___isset, 0, 0, 0)
	ZEND_ARG_INFO(0, name)
ZEND_END_ARG_INFO()

static zend_function_entry TObject_methods[] = {
	PHP_ME(TObject, Free, arginfo_TObject_Free, ZEND_ACC_PUBLIC)
	PHP_ME(TObject, GetType, arginfo_TObject_GetType, ZEND_ACC_PUBLIC)
	PHP_ME(TObject, ClassName_Inst, arginfo_TObject_ClassName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TObject, ClassName, arginfo_TObject_ClassName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TObject, ClassNameIs_Inst, arginfo_TObject_ClassNameIs_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TObject, ClassNameIs, arginfo_TObject_ClassNameIs, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TObject, InstanceSize_Inst, arginfo_TObject_InstanceSize_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TObject, InstanceSize, arginfo_TObject_InstanceSize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TObject, __construct, arginfo_TObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TObject, detachHandle, arginfo_TObject_detachHandle, ZEND_ACC_PUBLIC | ZEND_ACC_FINAL)
	PHP_ME(TObject, getOwnHandle, arginfo_TObject_getOwnHandle, ZEND_ACC_PUBLIC | ZEND_ACC_FINAL)
	PHP_ME(TObject, setOwnHandle, arginfo_TObject_setOwnHandle, ZEND_ACC_PUBLIC | ZEND_ACC_FINAL)
	PHP_ME(TObject, castTo, arginfo_TObject_castTo, ZEND_ACC_PUBLIC | ZEND_ACC_FINAL)
	PHP_ME(TObject, __clone, NULL, ZEND_ACC_PRIVATE | ZEND_ACC_FINAL)
	PHP_ME(TObject, __get, arginfo_TObject___get, ZEND_ACC_PRIVATE | ZEND_ACC_FINAL)
	PHP_ME(TObject, __set, arginfo_TObject___set, ZEND_ACC_PRIVATE | ZEND_ACC_FINAL)
	PHP_ME(TObject, __isset, arginfo_TObject___isset, ZEND_ACC_PRIVATE | ZEND_ACC_FINAL)
	PHP_FE_END
};

void Register_TObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TObject", TObject_methods);
	TObject_ce_ptr = zend_register_internal_class(&ce TSRMLS_CC);
	TObject_ce_ptr->create_object = PHP_TObject_New;
	memcpy(&TObject_handlers, zend_get_std_object_handlers(), sizeof(zend_object_handlers));
	TObject_handlers.clone_obj = NULL;
	TObject_handlers.compare_objects = PHP_TObject_compare_objects;
}

zend_class_entry *TBits_ce_ptr = NULL;

SB_PHP_METHOD(TBits, get_Bits)
{
	long l4Bit;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bit) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TBits_get_Bits(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bit, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TBits, set_Bits)
{
	long l4bit;
	zend_bool bvalue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4bit, &bvalue) == SUCCESS)
	{
		SBCheckError(TBits_set_Bits(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4bit, (int8_t)bvalue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TBits, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TBits_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TBits, set_Size)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TBits_set_Size(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TBits, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TBits_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TBits_get_Bits, 0, 0, 1)
	ZEND_ARG_INFO(0, Bit)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TBits_set_Bits, 0, 0, 2)
	ZEND_ARG_INFO(0, bit)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TBits_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TBits_set_Size, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TBits___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TBits_methods[] = {
	PHP_ME(TBits, get_Bits, arginfo_TBits_get_Bits, ZEND_ACC_PUBLIC)
	PHP_ME(TBits, set_Bits, arginfo_TBits_set_Bits, ZEND_ACC_PUBLIC)
	PHP_ME(TBits, get_Size, arginfo_TBits_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TBits, set_Size, arginfo_TBits_set_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TBits, __construct, arginfo_TBits___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TBits(TSRMLS_D)
{
	zend_class_entry ce;
	if (TBits_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TBits", TBits_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TBits_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPersistent_ce_ptr = NULL;

SB_PHP_METHOD(TPersistent, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TPersistent_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPersistent, GetNamePath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPersistent_GetNamePath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1117717680, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPersistent, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPersistent_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPersistent_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPersistent_GetNamePath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPersistent___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPersistent_methods[] = {
	PHP_ME(TPersistent, Assign, arginfo_TPersistent_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TPersistent, GetNamePath, arginfo_TPersistent_GetNamePath, ZEND_ACC_PUBLIC)
	PHP_ME(TPersistent, __construct, arginfo_TPersistent___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPersistent(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPersistent_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPersistent", TPersistent_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TPersistent_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TStream_ce_ptr = NULL;

SB_PHP_METHOD(TStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStream, ReadBuffer)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TStream_ReadBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStream, WriteBuffer)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TStream_WriteBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStream, CopyFrom)
{
	long l8Count;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oSource, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TStream_CopyFrom(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStream, ReadByte)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TStream_ReadByte(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStream, ReadWord)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TStream_ReadWord(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStream, ReadDWord)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TStream_ReadDWord(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStream, ReadAnsiString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TStream_ReadAnsiString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1286935347, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStream, WriteByte)
{
	long u1b;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1b) == SUCCESS)
	{
		SBCheckError(TStream_WriteByte(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1b) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStream, WriteWord)
{
	long u2w;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2w) == SUCCESS)
	{
		SBCheckError(TStream_WriteWord(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2w) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStream, WriteDWord)
{
	long u4d;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4d) == SUCCESS)
	{
		SBCheckError(TStream_WriteDWord(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4d) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStream, WriteAnsiString)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		SBCheckError(TStream_WriteAnsiString(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

SB_PHP_METHOD(TStream, get_Position)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TStream_get_Position(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStream, set_Position)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TStream_set_Position(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStream, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TStream_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStream, set_Size)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TStream_set_Size(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_ReadBuffer, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_WriteBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_CopyFrom, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_ReadByte, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_ReadWord, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_ReadDWord, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_ReadAnsiString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_WriteByte, 0, 0, 1)
	ZEND_ARG_INFO(0, b)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_WriteWord, 0, 0, 1)
	ZEND_ARG_INFO(0, w)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_WriteDWord, 0, 0, 1)
	ZEND_ARG_INFO(0, d)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_WriteAnsiString, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_get_Position, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_set_Position, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream_set_Size, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TStream_methods[] = {
	PHP_ME(TStream, Read, arginfo_TStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TStream, Write, arginfo_TStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TStream, Seek, arginfo_TStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TStream, ReadBuffer, arginfo_TStream_ReadBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TStream, WriteBuffer, arginfo_TStream_WriteBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TStream, CopyFrom, arginfo_TStream_CopyFrom, ZEND_ACC_PUBLIC)
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStream, ReadByte, arginfo_TStream_ReadByte, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStream, ReadWord, arginfo_TStream_ReadWord, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStream, ReadDWord, arginfo_TStream_ReadDWord, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStream, ReadAnsiString, arginfo_TStream_ReadAnsiString, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStream, WriteByte, arginfo_TStream_WriteByte, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStream, WriteWord, arginfo_TStream_WriteWord, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStream, WriteDWord, arginfo_TStream_WriteDWord, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStream, WriteAnsiString, arginfo_TStream_WriteAnsiString, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	PHP_ME(TStream, get_Position, arginfo_TStream_get_Position, ZEND_ACC_PUBLIC)
	PHP_ME(TStream, set_Position, arginfo_TStream_set_Position, ZEND_ACC_PUBLIC)
	PHP_ME(TStream, get_Size, arginfo_TStream_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TStream, set_Size, arginfo_TStream_set_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TStream, __construct, arginfo_TStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TStream", TStream_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TStream_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *THandleStream_ce_ptr = NULL;

SB_PHP_METHOD(THandleStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(THandleStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(THandleStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(THandleStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(THandleStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(THandleStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(THandleStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(THandleStream, get_Handle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(THandleStream_get_Handle(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(THandleStream, __construct)
{
	long l4AHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4AHandle) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(THandleStream_Create((int32_t)l4AHandle, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_THandleStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_THandleStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_THandleStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_THandleStream_get_Handle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_THandleStream___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AHandle)
ZEND_END_ARG_INFO()

static zend_function_entry THandleStream_methods[] = {
	PHP_ME(THandleStream, Read, arginfo_THandleStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(THandleStream, Write, arginfo_THandleStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(THandleStream, Seek, arginfo_THandleStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(THandleStream, get_Handle, arginfo_THandleStream_get_Handle, ZEND_ACC_PUBLIC)
	PHP_ME(THandleStream, __construct, arginfo_THandleStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_THandleStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (THandleStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "THandleStream", THandleStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	THandleStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TFileStream_ce_ptr = NULL;

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TFileStream, get_FileName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TFileStream_get_FileName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(124299016, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

SB_PHP_METHOD(TFileStream, __construct)
{
	char *sAFileName;
	int sAFileName_len;
	long u2Mode;
	long u4Rights;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sAFileName, &sAFileName_len, &u2Mode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TFileStream_Create(sAFileName, (int32_t)sAFileName_len, (uint16_t)u2Mode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sll", &sAFileName, &sAFileName_len, &u2Mode, &u4Rights) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TFileStream_Create_1(sAFileName, (int32_t)sAFileName_len, (uint16_t)u2Mode, (uint32_t)u4Rights, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer) or (string, integer, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TFileStream_get_FileName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TFileStream___construct, 0, 0, 2)
	ZEND_ARG_INFO(0, AFileName)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_INFO(0, Rights)
ZEND_END_ARG_INFO()

static zend_function_entry TFileStream_methods[] = {
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TFileStream, get_FileName, arginfo_TFileStream_get_FileName, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	PHP_ME(TFileStream, __construct, arginfo_TFileStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TFileStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TFileStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TFileStream", TFileStream_methods);
	if (NULL == THandleStream_ce_ptr)
		Register_THandleStream(TSRMLS_C);
	TFileStream_ce_ptr = zend_register_internal_class_ex(&ce, THandleStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TInterfacedObject_ce_ptr = NULL;

SB_PHP_METHOD(TInterfacedObject, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TInterfacedObject_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TInterfacedObject___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TInterfacedObject_methods[] = {
	PHP_ME(TInterfacedObject, __construct, arginfo_TInterfacedObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TInterfacedObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TInterfacedObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TInterfacedObject", TInterfacedObject_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TInterfacedObject_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TInterfacedPersistent_ce_ptr = NULL;

SB_PHP_METHOD(TInterfacedPersistent, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TInterfacedPersistent_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TInterfacedPersistent___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TInterfacedPersistent_methods[] = {
	PHP_ME(TInterfacedPersistent, __construct, arginfo_TInterfacedPersistent___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TInterfacedPersistent(TSRMLS_D)
{
	zend_class_entry ce;
	if (TInterfacedPersistent_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TInterfacedPersistent", TInterfacedPersistent_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TInterfacedPersistent_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TList_ce_ptr = NULL;

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TList, AddList)
{
	zval *oAList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAList, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TList_AddList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

SB_PHP_METHOD(TList, Add)
{
	SBArrayZValInfo piItem;
	zval *zpItem;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), piItem.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Error_Inst)
{
	char *sMsg;
	int sMsg_len;
	long l4Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sMsg, &sMsg_len, &l4Data) == SUCCESS)
	{
		SBCheckError(TList_Error_1(SBGetObjectHandle(getThis() TSRMLS_CC), sMsg, (int32_t)sMsg_len, (int32_t)l4Data) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Error)
{
	char *sMsg;
	int sMsg_len;
	long l4Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sMsg, &sMsg_len, &l4Data) == SUCCESS)
	{
		SBCheckError(TList_Error(sMsg, (int32_t)sMsg_len, (int32_t)l4Data) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Exchange)
{
	long l4Index1;
	long l4Index2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index1, &l4Index2) == SUCCESS)
	{
		SBCheckError(TList_Exchange(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index1, (int32_t)l4Index2) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Expand)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TList_Expand(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Extract)
{
	SBArrayZValInfo piitem;
	zval *zpitem;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpitem) == SUCCESS) && ((Z_TYPE_P(zpitem) == IS_STRING) || (Z_TYPE_P(zpitem) == IS_ARRAY) || (Z_TYPE_P(zpitem) == IS_NULL) || ((Z_TYPE_P(zpitem) == IS_OBJECT) && (Z_OBJCE_P(zpitem) == TSBPointer_ce_ptr))))
	{
		void * poOutResult = NULL;
		if (!SBGetPointerFromZVal(zpitem, &piitem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TList_Extract(SBGetObjectHandle(getThis() TSRMLS_CC), piitem.data, &poOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piitem);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, First)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		void * poOutResult = NULL;
		SBCheckError(TList_First(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, IndexOf)
{
	SBArrayZValInfo piItem;
	zval *zpItem;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TList_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), piItem.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Insert)
{
	long l4Index;
	SBArrayZValInfo piItem;
	zval *zpItem;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, piItem.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Last)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		void * poOutResult = NULL;
		SBCheckError(TList_Last(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Move)
{
	long l4CurIndex;
	long l4NewIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4CurIndex, &l4NewIndex) == SUCCESS)
	{
		SBCheckError(TList_Move(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4CurIndex, (int32_t)l4NewIndex) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Assign)
{
	long fAOperator;
	zval *oListA;
	zval *oListB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oListA, TList_ce_ptr, &fAOperator, &oListB, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TList_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oListA TSRMLS_CC), (TListAssignOpRaw)fAOperator, SBGetObjectHandle(oListB TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList, integer, TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Remove)
{
	SBArrayZValInfo piItem;
	zval *zpItem;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), piItem.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Pack)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TList_Pack(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, Sort)
{
	zval *zCompare;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zCompare) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zCompare))))
	{
		SBCheckError(TList_Sort(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, get_Capacity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TList_get_Capacity(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, set_Capacity)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TList_set_Capacity(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, set_Count)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TList_set_Count(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		void * poOutResult = NULL;
		SBCheckError(TList_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, set_Items)
{
	long l4Index;
	SBArrayZValInfo piItem;
	zval *zpItem;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TList_set_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, piItem.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_AddList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AList, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Error_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, Msg)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Error, 0, 0, 2)
	ZEND_ARG_INFO(0, Msg)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Exchange, 0, 0, 2)
	ZEND_ARG_INFO(0, Index1)
	ZEND_ARG_INFO(0, Index2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Expand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Extract, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_First, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Last, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Move, 0, 0, 2)
	ZEND_ARG_INFO(0, CurIndex)
	ZEND_ARG_INFO(0, NewIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Assign, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, ListA, TList, 1)
	ZEND_ARG_INFO(0, AOperator)
	ZEND_ARG_OBJ_INFO(0, ListB, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Remove, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Pack, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_Sort, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Compare, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_get_Capacity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_set_Capacity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_set_Count, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList_set_Items, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TList_methods[] = {
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TList, AddList, arginfo_TList_AddList, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	PHP_ME(TList, Add, arginfo_TList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Clear, arginfo_TList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Delete, arginfo_TList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Error_Inst, arginfo_TList_Error_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Error, arginfo_TList_Error, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TList, Exchange, arginfo_TList_Exchange, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Expand, arginfo_TList_Expand, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Extract, arginfo_TList_Extract, ZEND_ACC_PUBLIC)
	PHP_ME(TList, First, arginfo_TList_First, ZEND_ACC_PUBLIC)
	PHP_ME(TList, IndexOf, arginfo_TList_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Insert, arginfo_TList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Last, arginfo_TList_Last, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Move, arginfo_TList_Move, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Assign, arginfo_TList_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Remove, arginfo_TList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Pack, arginfo_TList_Pack, ZEND_ACC_PUBLIC)
	PHP_ME(TList, Sort, arginfo_TList_Sort, ZEND_ACC_PUBLIC)
	PHP_ME(TList, get_Capacity, arginfo_TList_get_Capacity, ZEND_ACC_PUBLIC)
	PHP_ME(TList, set_Capacity, arginfo_TList_set_Capacity, ZEND_ACC_PUBLIC)
	PHP_ME(TList, get_Count, arginfo_TList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TList, set_Count, arginfo_TList_set_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TList, get_Items, arginfo_TList_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TList, set_Items, arginfo_TList_set_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TList, __construct, arginfo_TList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TList", TList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TCustomMemoryStream_ce_ptr = NULL;

SB_PHP_METHOD(TCustomMemoryStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TCustomMemoryStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TCustomMemoryStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TCustomMemoryStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TCustomMemoryStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TCustomMemoryStream, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TCustomMemoryStream_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TCustomMemoryStream, SaveToFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TCustomMemoryStream_SaveToFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TCustomMemoryStream, get_Memory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		void * poOutResult = NULL;
		SBCheckError(TCustomMemoryStream_get_Memory(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TCustomMemoryStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TCustomMemoryStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TCustomMemoryStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TCustomMemoryStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TCustomMemoryStream_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TCustomMemoryStream_SaveToFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TCustomMemoryStream_get_Memory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TCustomMemoryStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TCustomMemoryStream_methods[] = {
	PHP_ME(TCustomMemoryStream, Read, arginfo_TCustomMemoryStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TCustomMemoryStream, Seek, arginfo_TCustomMemoryStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TCustomMemoryStream, SaveToStream, arginfo_TCustomMemoryStream_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TCustomMemoryStream, SaveToFile, arginfo_TCustomMemoryStream_SaveToFile, ZEND_ACC_PUBLIC)
	PHP_ME(TCustomMemoryStream, get_Memory, arginfo_TCustomMemoryStream_get_Memory, ZEND_ACC_PUBLIC)
	PHP_ME(TCustomMemoryStream, __construct, arginfo_TCustomMemoryStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TCustomMemoryStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TCustomMemoryStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TCustomMemoryStream", TCustomMemoryStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TCustomMemoryStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TComponent_ce_ptr = NULL;

SB_PHP_METHOD(TComponent, GetNamePath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TComponent_GetNamePath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1591861097, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TComponent, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TComponent_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-423129050, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TComponent, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TComponent_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TComponent, get_Tag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TComponent_get_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TComponent, set_Tag)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TComponent_set_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TComponent, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TComponent_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TComponent_GetNamePath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TComponent_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TComponent_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TComponent_get_Tag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TComponent_set_Tag, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TComponent___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TComponent_methods[] = {
	PHP_ME(TComponent, GetNamePath, arginfo_TComponent_GetNamePath, ZEND_ACC_PUBLIC)
	PHP_ME(TComponent, get_Name, arginfo_TComponent_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TComponent, set_Name, arginfo_TComponent_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TComponent, get_Tag, arginfo_TComponent_get_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TComponent, set_Tag, arginfo_TComponent_set_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TComponent, __construct, arginfo_TComponent___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TComponent(TSRMLS_D)
{
	zend_class_entry ce;
	if (TComponent_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TComponent", TComponent_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TComponent_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TMemoryStream_ce_ptr = NULL;

SB_PHP_METHOD(TMemoryStream, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TMemoryStream_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TMemoryStream, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TMemoryStream_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TMemoryStream, LoadFromFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TMemoryStream_LoadFromFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TMemoryStream, SetSize)
{
	long l4NewSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4NewSize) == SUCCESS)
	{
		SBCheckError(TMemoryStream_SetSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4NewSize) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TMemoryStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TMemoryStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TMemoryStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TMemoryStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TMemoryStream_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TMemoryStream_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TMemoryStream_LoadFromFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TMemoryStream_SetSize, 0, 0, 1)
	ZEND_ARG_INFO(0, NewSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TMemoryStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TMemoryStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TMemoryStream_methods[] = {
	PHP_ME(TMemoryStream, Clear, arginfo_TMemoryStream_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TMemoryStream, LoadFromStream, arginfo_TMemoryStream_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TMemoryStream, LoadFromFile, arginfo_TMemoryStream_LoadFromFile, ZEND_ACC_PUBLIC)
	PHP_ME(TMemoryStream, SetSize, arginfo_TMemoryStream_SetSize, ZEND_ACC_PUBLIC)
	PHP_ME(TMemoryStream, Write, arginfo_TMemoryStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TMemoryStream, __construct, arginfo_TMemoryStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMemoryStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMemoryStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TMemoryStream", TMemoryStream_methods);
	if (NULL == TCustomMemoryStream_ce_ptr)
		Register_TCustomMemoryStream(TSRMLS_C);
	TMemoryStream_ce_ptr = zend_register_internal_class_ex(&ce, TCustomMemoryStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TStrings_ce_ptr = NULL;

SB_PHP_METHOD(TStrings, Add)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStrings_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, AddObject)
{
	char *sS;
	int sS_len;
	zval *oAObject;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sS, &sS_len, &oAObject, TObject_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStrings_AddObject(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, SBGetObjectHandle(oAObject TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, Append)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		SBCheckError(TStrings_Append(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, AddStrings)
{
	zval *oTheStrings;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTheStrings, TStrings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TStrings_AddStrings(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTheStrings TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TStrings_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, BeginUpdate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TStrings_BeginUpdate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TStrings_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TStrings_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, EndUpdate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TStrings_EndUpdate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, Equals)
{
	zval *oTheStrings;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTheStrings, TStrings_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TStrings_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTheStrings TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, Exchange)
{
	long l4Index1;
	long l4Index2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index1, &l4Index2) == SUCCESS)
	{
		SBCheckError(TStrings_Exchange(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index1, (int32_t)l4Index2) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, IndexOf)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStrings_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, IndexOfName)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStrings_IndexOfName(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, IndexOfObject)
{
	zval *oAObject;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAObject, TObject_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStrings_IndexOfObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAObject TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, Insert)
{
	char *sS;
	int sS_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sS, &sS_len) == SUCCESS)
	{
		SBCheckError(TStrings_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sS, (int32_t)sS_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, InsertObject)
{
	char *sS;
	int sS_len;
	long l4Index;
	zval *oAObject;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsO!", &l4Index, &sS, &sS_len, &oAObject, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TStrings_InsertObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sS, (int32_t)sS_len, SBGetObjectHandle(oAObject TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, LoadFromFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TStrings_LoadFromFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TStrings_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, Move)
{
	long l4CurIndex;
	long l4NewIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4CurIndex, &l4NewIndex) == SUCCESS)
	{
		SBCheckError(TStrings_Move(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4CurIndex, (int32_t)l4NewIndex) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, SaveToFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TStrings_SaveToFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TStrings_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStrings, GetNameValue)
{
	char *sAName = NULL;
	char *sAValue = NULL;
	int32_t sAName_len = 0;
	int32_t sAValue_len = 0;
	long l4Index;
	uint32_t _err;
	zval *zsAName;
	zval *zsAValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &l4Index, &zsAName, &zsAValue) == SUCCESS) && PZVAL_IS_REF(zsAName) && (IS_STRING == Z_TYPE_P(zsAName)) && PZVAL_IS_REF(zsAValue) && (IS_STRING == Z_TYPE_P(zsAValue)))
	{
		_err = TStrings_GetNameValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sAName, &sAName_len, sAValue, &sAValue_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sAName = emalloc(sAName_len + 1);
			SBCheckError(SBGetLastReturnStringA(270557200, 2, sAName, &sAName_len) TSRMLS_CC);
			zval_dtor(zsAName);
			sAValue = emalloc(sAValue_len + 1);
			SBCheckError(SBGetLastReturnStringA(270557200, 3, sAValue, &sAValue_len) TSRMLS_CC);
			zval_dtor(zsAValue);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sAName[sAName_len] = 0;
		ZVAL_STRINGL(zsAName, sAName, sAName_len, 0);
		sAValue[sAValue_len] = 0;
		ZVAL_STRINGL(zsAValue, sAValue, sAValue_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &string, &string)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStrings, ExtractName)
{
	char *sS;
	int sS_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TStrings_ExtractName(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1966447779, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStrings, get_TextLineBreakStyle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TTextLineBreakStyleRaw fOutResultRaw = 0;
		SBCheckError(TStrings_get_TextLineBreakStyle(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_TextLineBreakStyle)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TStrings_set_TextLineBreakStyle(SBGetObjectHandle(getThis() TSRMLS_CC), (TTextLineBreakStyleRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

SB_PHP_METHOD(TStrings, get_Delimiter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TStrings_get_Delimiter(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_Delimiter)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TStrings_set_Delimiter(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_DelimitedText)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TStrings_get_DelimitedText(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2129710752, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_DelimitedText)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TStrings_set_DelimitedText(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TStrings, get_StrictDelimiter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TStrings_get_StrictDelimiter(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_StrictDelimiter)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TStrings_set_StrictDelimiter(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

SB_PHP_METHOD(TStrings, get_QuoteChar)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TStrings_get_QuoteChar(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_QuoteChar)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TStrings_set_QuoteChar(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_NameValueSeparator)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TStrings_get_NameValueSeparator(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_NameValueSeparator)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TStrings_set_NameValueSeparator(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_ValueFromIndex)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TStrings_get_ValueFromIndex(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1510370980, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_ValueFromIndex)
{
	char *sValue;
	int sValue_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TStrings_set_ValueFromIndex(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_Capacity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStrings_get_Capacity(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_Capacity)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TStrings_set_Capacity(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_CommaText)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TStrings_get_CommaText(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(525737204, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_CommaText)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TStrings_set_CommaText(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStrings_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_Names)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TStrings_get_Names(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1975535806, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_Objects)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TStrings_get_Objects(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_Objects)
{
	long l4Index;
	zval *oAObject;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAObject, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TStrings_set_Objects(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAObject TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_Values)
{
	char *sName;
	int sName_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TStrings_get_Values(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1478360830, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_Values)
{
	char *sName;
	char *sValue;
	int sName_len;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TStrings_set_Values(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_Strings)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TStrings_get_Strings(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(181721504, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_Strings)
{
	char *sS;
	int sS_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sS, &sS_len) == SUCCESS)
	{
		SBCheckError(TStrings_set_Strings(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sS, (int32_t)sS_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, get_Text)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TStrings_get_Text(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1043818127, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, set_Text)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TStrings_set_Text(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStrings, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TStrings_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_Add, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_AddObject, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_OBJ_INFO(0, AObject, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_Append, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_AddStrings, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, TheStrings, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_BeginUpdate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_EndUpdate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_Equals, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, TheStrings, TStrings, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_Exchange, 0, 0, 2)
	ZEND_ARG_INFO(0, Index1)
	ZEND_ARG_INFO(0, Index2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_IndexOf, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_IndexOfName, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_IndexOfObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AObject, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_InsertObject, 0, 0, 3)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_OBJ_INFO(0, AObject, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_LoadFromFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_Move, 0, 0, 2)
	ZEND_ARG_INFO(0, CurIndex)
	ZEND_ARG_INFO(0, NewIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_SaveToFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_GetNameValue, 0, 0, 3)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, AName)
	ZEND_ARG_INFO(1, AValue)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_ExtractName, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_TextLineBreakStyle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_TextLineBreakStyle, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_Delimiter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_Delimiter, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_DelimitedText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_DelimitedText, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_StrictDelimiter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_StrictDelimiter, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_QuoteChar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_QuoteChar, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_NameValueSeparator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_NameValueSeparator, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_ValueFromIndex, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_ValueFromIndex, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_Capacity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_Capacity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_CommaText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_CommaText, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_Names, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_Objects, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_Objects, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AObject, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_Values, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_Values, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_Strings, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_Strings, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_get_Text, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings_set_Text, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStrings___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TStrings_methods[] = {
	PHP_ME(TStrings, Add, arginfo_TStrings_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, AddObject, arginfo_TStrings_AddObject, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, Append, arginfo_TStrings_Append, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, AddStrings, arginfo_TStrings_AddStrings, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, Assign, arginfo_TStrings_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, BeginUpdate, arginfo_TStrings_BeginUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, Clear, arginfo_TStrings_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, Delete, arginfo_TStrings_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, EndUpdate, arginfo_TStrings_EndUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, Equals, arginfo_TStrings_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, Exchange, arginfo_TStrings_Exchange, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, IndexOf, arginfo_TStrings_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, IndexOfName, arginfo_TStrings_IndexOfName, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, IndexOfObject, arginfo_TStrings_IndexOfObject, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, Insert, arginfo_TStrings_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, InsertObject, arginfo_TStrings_InsertObject, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, LoadFromFile, arginfo_TStrings_LoadFromFile, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, LoadFromStream, arginfo_TStrings_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, Move, arginfo_TStrings_Move, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, SaveToFile, arginfo_TStrings_SaveToFile, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, SaveToStream, arginfo_TStrings_SaveToStream, ZEND_ACC_PUBLIC)
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStrings, GetNameValue, arginfo_TStrings_GetNameValue, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStrings, ExtractName, arginfo_TStrings_ExtractName, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStrings, get_TextLineBreakStyle, arginfo_TStrings_get_TextLineBreakStyle, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_TextLineBreakStyle, arginfo_TStrings_set_TextLineBreakStyle, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	PHP_ME(TStrings, get_Delimiter, arginfo_TStrings_get_Delimiter, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_Delimiter, arginfo_TStrings_set_Delimiter, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_DelimitedText, arginfo_TStrings_get_DelimitedText, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_DelimitedText, arginfo_TStrings_set_DelimitedText, ZEND_ACC_PUBLIC)
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TStrings, get_StrictDelimiter, arginfo_TStrings_get_StrictDelimiter, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_StrictDelimiter, arginfo_TStrings_set_StrictDelimiter, ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	PHP_ME(TStrings, get_QuoteChar, arginfo_TStrings_get_QuoteChar, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_QuoteChar, arginfo_TStrings_set_QuoteChar, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_NameValueSeparator, arginfo_TStrings_get_NameValueSeparator, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_NameValueSeparator, arginfo_TStrings_set_NameValueSeparator, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_ValueFromIndex, arginfo_TStrings_get_ValueFromIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_ValueFromIndex, arginfo_TStrings_set_ValueFromIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_Capacity, arginfo_TStrings_get_Capacity, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_Capacity, arginfo_TStrings_set_Capacity, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_CommaText, arginfo_TStrings_get_CommaText, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_CommaText, arginfo_TStrings_set_CommaText, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_Count, arginfo_TStrings_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_Names, arginfo_TStrings_get_Names, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_Objects, arginfo_TStrings_get_Objects, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_Objects, arginfo_TStrings_set_Objects, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_Values, arginfo_TStrings_get_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_Values, arginfo_TStrings_set_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_Strings, arginfo_TStrings_get_Strings, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_Strings, arginfo_TStrings_set_Strings, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, get_Text, arginfo_TStrings_get_Text, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, set_Text, arginfo_TStrings_set_Text, ZEND_ACC_PUBLIC)
	PHP_ME(TStrings, __construct, arginfo_TStrings___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TStrings(TSRMLS_D)
{
	zend_class_entry ce;
	if (TStrings_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TStrings", TStrings_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TStrings_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TStringList_ce_ptr = NULL;

SB_PHP_METHOD(TStringList, Add)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStringList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TStringList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TStringList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, Exchange)
{
	long l4Index1;
	long l4Index2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index1, &l4Index2) == SUCCESS)
	{
		SBCheckError(TStringList_Exchange(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index1, (int32_t)l4Index2) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, Find)
{
	char *sS;
	int sS_len;
	int32_t l4IndexRaw;
	zval *zl4Index;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sS, &sS_len, &zl4Index) == SUCCESS) && PZVAL_IS_REF(zl4Index) && (IS_LONG == Z_TYPE_P(zl4Index)))
	{
		int8_t bOutResultRaw = 0;
		l4IndexRaw = (int32_t)Z_LVAL_P(zl4Index);
		SBCheckError(TStringList_Find(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &l4IndexRaw, &bOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zl4Index, (long)l4IndexRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, IndexOf)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TStringList_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, Insert)
{
	char *sS;
	int sS_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sS, &sS_len) == SUCCESS)
	{
		SBCheckError(TStringList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sS, (int32_t)sS_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, Sort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TStringList_Sort(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, CustomSort)
{
	zval *zCompareFn;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zCompareFn) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zCompareFn))))
	{
		SBCheckError(TStringList_CustomSort(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, get_Duplicates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TDuplicatesRaw fOutResultRaw = 0;
		SBCheckError(TStringList_get_Duplicates(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, set_Duplicates)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TStringList_set_Duplicates(SBGetObjectHandle(getThis() TSRMLS_CC), (TDuplicatesRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, get_Sorted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TStringList_get_Sorted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, set_Sorted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TStringList_set_Sorted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, get_CaseSensitive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TStringList_get_CaseSensitive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, set_CaseSensitive)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TStringList_set_CaseSensitive(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, get_OnChange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TStringList_get_OnChange(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, set_OnChange)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TStringList_set_OnChange(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, get_OnChanging)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TStringList_get_OnChanging(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, set_OnChanging)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TStringList_set_OnChanging(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TStringList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TStringList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_Add, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_Exchange, 0, 0, 2)
	ZEND_ARG_INFO(0, Index1)
	ZEND_ARG_INFO(0, Index2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_Find, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(1, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_IndexOf, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_Sort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_CustomSort, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CompareFn, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_get_Duplicates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_set_Duplicates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_get_Sorted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_set_Sorted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_get_CaseSensitive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_set_CaseSensitive, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_get_OnChange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_set_OnChange, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_get_OnChanging, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList_set_OnChanging, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TStringList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TStringList_methods[] = {
	PHP_ME(TStringList, Add, arginfo_TStringList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, Clear, arginfo_TStringList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, Delete, arginfo_TStringList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, Exchange, arginfo_TStringList_Exchange, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, Find, arginfo_TStringList_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, IndexOf, arginfo_TStringList_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, Insert, arginfo_TStringList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, Sort, arginfo_TStringList_Sort, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, CustomSort, arginfo_TStringList_CustomSort, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, get_Duplicates, arginfo_TStringList_get_Duplicates, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, set_Duplicates, arginfo_TStringList_set_Duplicates, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, get_Sorted, arginfo_TStringList_get_Sorted, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, set_Sorted, arginfo_TStringList_set_Sorted, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, get_CaseSensitive, arginfo_TStringList_get_CaseSensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, set_CaseSensitive, arginfo_TStringList_set_CaseSensitive, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, get_OnChange, arginfo_TStringList_get_OnChange, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, set_OnChange, arginfo_TStringList_set_OnChange, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, get_OnChanging, arginfo_TStringList_get_OnChanging, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, set_OnChanging, arginfo_TStringList_set_OnChanging, ZEND_ACC_PUBLIC)
	PHP_ME(TStringList, __construct, arginfo_TStringList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TStringList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TStringList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TStringList", TStringList_methods);
	if (NULL == TStrings_ce_ptr)
		Register_TStrings(TSRMLS_C);
	TStringList_ce_ptr = zend_register_internal_class_ex(&ce, TStrings_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TThread_ce_ptr = NULL;

SB_PHP_METHOD(TThread, Synchronize_Inst)
{
	void *pzAMethod;
	zval *oAThread;
	zval *zAMethod;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oAThread, TThread_ce_ptr, &zAMethod) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zAMethod)) || (IS_ARRAY == Z_TYPE_P(zAMethod)) || (IS_CALLABLE == Z_TYPE_P(zAMethod)) || (IS_NULL == Z_TYPE_P(zAMethod))))
	{
		pzAMethod = SBSetEventData(zAMethod TSRMLS_CC);
		SBCheckError(TThread_Synchronize_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAThread TSRMLS_CC), pzAMethod ? &TThreadMethodRaw : NULL, pzAMethod) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TThread, TThreadMethod|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, Synchronize)
{
	void *pzAMethod;
	zval *oAThread;
	zval *zAMethod;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oAThread, TThread_ce_ptr, &zAMethod) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zAMethod)) || (IS_ARRAY == Z_TYPE_P(zAMethod)) || (IS_CALLABLE == Z_TYPE_P(zAMethod)) || (IS_NULL == Z_TYPE_P(zAMethod))))
	{
		pzAMethod = SBSetEventData(zAMethod TSRMLS_CC);
		SBCheckError(TThread_Synchronize(SBGetObjectHandle(oAThread TSRMLS_CC), pzAMethod ? &TThreadMethodRaw : NULL, pzAMethod) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TThread, TThreadMethod|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, AfterConstruction)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TThread_AfterConstruction(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, Resume)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TThread_Resume(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, Suspend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TThread_Suspend(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, Terminate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TThread_Terminate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, WaitFor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TThread_WaitFor(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, get_FreeOnTerminate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TThread_get_FreeOnTerminate(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, set_FreeOnTerminate)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TThread_set_FreeOnTerminate(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, get_Priority)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TThreadPriorityRaw fOutResultRaw = 0;
		SBCheckError(TThread_get_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, set_Priority)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TThread_set_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), (TThreadPriorityRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, get_Suspended)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TThread_get_Suspended(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, set_Suspended)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TThread_set_Suspended(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, get_FatalException)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TThread_get_FatalException(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, get_OnTerminate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TThread_get_OnTerminate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TThread, set_OnTerminate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TThread_set_OnTerminate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
SB_PHP_METHOD(TThread, __construct)
{
	long u4StackSize;
	zend_bool bCreateSuspended;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bl", &bCreateSuspended, &u4StackSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TThread_Create((int8_t)bCreateSuspended, (uint32_t)u4StackSize, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, integer)" TSRMLS_CC);
	}
}
#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_Synchronize_Inst, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, AThread, TThread, 1)
	ZEND_ARG_TYPE_INFO(0, AMethod, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_Synchronize, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, AThread, TThread, 1)
	ZEND_ARG_TYPE_INFO(0, AMethod, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_AfterConstruction, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_Resume, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_Suspend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_Terminate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_WaitFor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_get_FreeOnTerminate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_set_FreeOnTerminate, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_get_Priority, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_set_Priority, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_get_Suspended, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_set_Suspended, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_get_FatalException, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_get_OnTerminate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread_set_OnTerminate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TThread___construct, 0, 0, 2)
	ZEND_ARG_INFO(0, CreateSuspended)
	ZEND_ARG_INFO(0, StackSize)
ZEND_END_ARG_INFO()

static zend_function_entry TThread_methods[] = {
	PHP_ME(TThread, Synchronize_Inst, arginfo_TThread_Synchronize_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, Synchronize, arginfo_TThread_Synchronize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TThread, AfterConstruction, arginfo_TThread_AfterConstruction, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, Resume, arginfo_TThread_Resume, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, Suspend, arginfo_TThread_Suspend, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, Terminate, arginfo_TThread_Terminate, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, WaitFor, arginfo_TThread_WaitFor, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, get_FreeOnTerminate, arginfo_TThread_get_FreeOnTerminate, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, set_FreeOnTerminate, arginfo_TThread_set_FreeOnTerminate, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, get_Priority, arginfo_TThread_get_Priority, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, set_Priority, arginfo_TThread_set_Priority, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, get_Suspended, arginfo_TThread_get_Suspended, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, set_Suspended, arginfo_TThread_set_Suspended, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, get_FatalException, arginfo_TThread_get_FatalException, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, get_OnTerminate, arginfo_TThread_get_OnTerminate, ZEND_ACC_PUBLIC)
	PHP_ME(TThread, set_OnTerminate, arginfo_TThread_set_OnTerminate, ZEND_ACC_PUBLIC)
	#ifdef SB_DEFINE_FPC_SPECIFIC_METHODS
	PHP_ME(TThread, __construct, arginfo_TThread___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	#endif /* SB_DEFINE_FPC_SPECIFIC_METHODS */
	PHP_FE_END
};

void Register_TThread(TSRMLS_D)
{
	zend_class_entry ce;
	if (TThread_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TThread", TThread_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TThread_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_sbsystem_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TDuplicates", NULL);
	TDuplicates_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TDuplicates_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TDuplicates_ce_ptr, "dupIgnore", 0)
	SB_DECLARE_CLASS_LONG_CONST(TDuplicates_ce_ptr, "dupAccept", 1)
	SB_DECLARE_CLASS_LONG_CONST(TDuplicates_ce_ptr, "dupError", 2)
	
	INIT_CLASS_ENTRY(ce, "TListAssignOp", NULL);
	TListAssignOp_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TListAssignOp_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TListAssignOp_ce_ptr, "laCopy", 0)
	SB_DECLARE_CLASS_LONG_CONST(TListAssignOp_ce_ptr, "laAnd", 1)
	SB_DECLARE_CLASS_LONG_CONST(TListAssignOp_ce_ptr, "laOr", 2)
	SB_DECLARE_CLASS_LONG_CONST(TListAssignOp_ce_ptr, "laXor", 3)
	SB_DECLARE_CLASS_LONG_CONST(TListAssignOp_ce_ptr, "laSrcUnique", 4)
	SB_DECLARE_CLASS_LONG_CONST(TListAssignOp_ce_ptr, "laDestUnique", 5)
	
	INIT_CLASS_ENTRY(ce, "TSeekOrigin", NULL);
	TSeekOrigin_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSeekOrigin_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSeekOrigin_ce_ptr, "soBeginning", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSeekOrigin_ce_ptr, "soCurrent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSeekOrigin_ce_ptr, "soEnd", 2)
	
	INIT_CLASS_ENTRY(ce, "TTextLineBreakStyle", NULL);
	TTextLineBreakStyle_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TTextLineBreakStyle_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TTextLineBreakStyle_ce_ptr, "tlbsLF", 0)
	SB_DECLARE_CLASS_LONG_CONST(TTextLineBreakStyle_ce_ptr, "tlbsCRLF", 1)
	SB_DECLARE_CLASS_LONG_CONST(TTextLineBreakStyle_ce_ptr, "tlbsCR", 2)
	
	INIT_CLASS_ENTRY(ce, "TThreadPriority", NULL);
	TThreadPriority_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TThreadPriority_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TThreadPriority_ce_ptr, "tpIdle", 0)
	SB_DECLARE_CLASS_LONG_CONST(TThreadPriority_ce_ptr, "tpLowest", 1)
	SB_DECLARE_CLASS_LONG_CONST(TThreadPriority_ce_ptr, "tpLower", 2)
	SB_DECLARE_CLASS_LONG_CONST(TThreadPriority_ce_ptr, "tpNormal", 3)
	SB_DECLARE_CLASS_LONG_CONST(TThreadPriority_ce_ptr, "tpHigher", 4)
	SB_DECLARE_CLASS_LONG_CONST(TThreadPriority_ce_ptr, "tpHighest", 5)
	SB_DECLARE_CLASS_LONG_CONST(TThreadPriority_ce_ptr, "tpTimeCritical", 6)
}

void Register_sbsystem_Aliases(TSRMLS_D)
{
	TClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TClass", TClass_ce_ptr);
}
