#include "sbwebdavclient.h"

zend_class_entry *TSBWebDavClass_ce_ptr = NULL;

zend_class_entry *TSBWebDavClasses_ce_ptr = NULL;

zend_class_entry *TElWebDAVClient_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVClient, List)
{
	char *sURL;
	int sURL_len;
	long fDepth;
	zval *oObj;
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElWebDavObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oObjects, TElWebDavObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!l", &sURL, &sURL_len, &oObjects, TElWebDavObjectList_ce_ptr, &fDepth) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_List_2(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oObjects TSRMLS_CC), (TSBWebDavDepthRaw)fDepth) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWebDAVStorageObject_ce_ptr, &oObjects, TElWebDavObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_List_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDavObjectList) or (string, TElWebDavObjectList) or (string, TElWebDavObjectList, integer) or (TElWebDAVStorageObject, TElWebDavObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, CreateCollection)
{
	char *sName;
	char *sURL;
	int sName_len;
	int sURL_len;
	zval *oLocks;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_CreateCollection(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParent, TElWebDAVStorageObject_ce_ptr, &sName, &sName_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_CreateCollection_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sName, (int32_t)sName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDAVLockList) or (TElWebDAVStorageObject, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, DeleteObject)
{
	char *sURL;
	int sURL_len;
	zval *oErrors;
	zval *oLocks;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sURL, &sURL_len, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_DeleteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWebDAVStorageObject_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_DeleteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDAVLockList, TElWebDavErrorList) or (TElWebDAVStorageObject, TElWebDavErrorList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, CopyObject)
{
	char *sDestURL;
	char *sSrcURL;
	int sDestURL_len;
	int sSrcURL_len;
	zend_bool bOverwrite;
	zval *oDest;
	zval *oErrors;
	zval *oLocks;
	zval *oSrc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbO!O!", &sSrcURL, &sSrcURL_len, &sDestURL, &sDestURL_len, &bOverwrite, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), sSrcURL, (int32_t)sSrcURL_len, sDestURL, (int32_t)sDestURL_len, (int8_t)bOverwrite, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bO!", &oSrc, TElWebDAVStorageObject_ce_ptr, &oDest, TElWebDAVStorageObject_ce_ptr, &bOverwrite, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSrc TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC), (int8_t)bOverwrite, SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool, TElWebDAVLockList, TElWebDavErrorList) or (TElWebDAVStorageObject, TElWebDAVStorageObject, bool, TElWebDavErrorList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, MoveObject)
{
	char *sDestURL;
	char *sSrcURL;
	int sDestURL_len;
	int sSrcURL_len;
	zend_bool bOverwrite;
	zval *oDest;
	zval *oErrors;
	zval *oLocks;
	zval *oSrc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbO!O!", &sSrcURL, &sSrcURL_len, &sDestURL, &sDestURL_len, &bOverwrite, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_MoveObject(SBGetObjectHandle(getThis() TSRMLS_CC), sSrcURL, (int32_t)sSrcURL_len, sDestURL, (int32_t)sDestURL_len, (int8_t)bOverwrite, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bO!", &oSrc, TElWebDAVStorageObject_ce_ptr, &oDest, TElWebDAVStorageObject_ce_ptr, &bOverwrite, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_MoveObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSrc TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC), (int8_t)bOverwrite, SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool, TElWebDAVLockList, TElWebDavErrorList) or (TElWebDAVStorageObject, TElWebDAVStorageObject, bool, TElWebDavErrorList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, Rename)
{
	char *sNewName;
	char *sURL;
	int sNewName_len;
	int sURL_len;
	zend_bool bMoveToRename;
	zval *oLocks;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbO!", &sURL, &sURL_len, &sNewName, &sNewName_len, &bMoveToRename, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Rename(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sNewName, (int32_t)sNewName_len, (int8_t)bMoveToRename, SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oObj, TElWebDAVStorageObject_ce_ptr, &sNewName, &sNewName_len, &bMoveToRename) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Rename_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sNewName, (int32_t)sNewName_len, (int8_t)bMoveToRename) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool, TElWebDAVLockList) or (TElWebDAVStorageObject, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, ChangeProperties)
{
	char *sURL;
	int sURL_len;
	zval *oLocks;
	zval *oObj;
	zval *oRemoveProperties;
	zval *oSetProperties;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!O!", &sURL, &sURL_len, &oSetProperties, TElWebDavPropertyInfoList_ce_ptr, &oRemoveProperties, TElWebDavPropertyInfoList_ce_ptr, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_ChangeProperties(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oSetProperties TSRMLS_CC), SBGetObjectHandle(oRemoveProperties TSRMLS_CC), SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oObj, TElWebDAVStorageObject_ce_ptr, &oSetProperties, TElWebDavPropertyInfoList_ce_ptr, &oRemoveProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_ChangeProperties_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oSetProperties TSRMLS_CC), SBGetObjectHandle(oRemoveProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPropertyInfoList, TElWebDavPropertyInfoList, TElWebDAVLockList) or (TElWebDAVStorageObject, TElWebDavPropertyInfoList, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, SetProperty)
{
	char *sURL;
	int sURL_len;
	zval *oLocks;
	zval *oObj;
	zval *oPropInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sURL, &sURL_len, &oPropInfo, TElWebDavPropertyInfo_ce_ptr, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_SetProperty(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oPropInfo TSRMLS_CC), SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWebDAVStorageObject_ce_ptr, &oPropInfo, TElWebDavPropertyInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_SetProperty_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oPropInfo TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPropertyInfo, TElWebDAVLockList) or (TElWebDAVStorageObject, TElWebDavPropertyInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, RemoveProperty)
{
	char *sURL;
	int sURL_len;
	zval *oLocks;
	zval *oObj;
	zval *oPropInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sURL, &sURL_len, &oPropInfo, TElWebDavPropertyInfo_ce_ptr, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_RemoveProperty(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oPropInfo TSRMLS_CC), SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWebDAVStorageObject_ce_ptr, &oPropInfo, TElWebDavPropertyInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_RemoveProperty_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oPropInfo TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPropertyInfo, TElWebDAVLockList) or (TElWebDAVStorageObject, TElWebDavPropertyInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, ReadProperties)
{
	char *sURL;
	int sURL_len;
	zval *oObj;
	zval *oProperties;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_ReadProperties(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWebDAVStorageObject_ce_ptr, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_ReadProperties_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPropertyInfoList) or (TElWebDAVStorageObject, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, ReadProperty)
{
	char *sPropName;
	char *sURL;
	int sPropName_len;
	int sURL_len;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sURL, &sURL_len, &sPropName, &sPropName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVClient_ReadProperty(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sPropName, (int32_t)sPropName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavPropertyInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElWebDAVStorageObject_ce_ptr, &sPropName, &sPropName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVClient_ReadProperty_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sPropName, (int32_t)sPropName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavPropertyInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (TElWebDAVStorageObject, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, GetSupportedProperties)
{
	char *sURL;
	int sURL_len;
	zval *oObj;
	zval *oProperties;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_GetSupportedProperties(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWebDAVStorageObject_ce_ptr, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_GetSupportedProperties_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPropertyInfoList) or (TElWebDAVStorageObject, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, ReadSupportedProperties)
{
	char *sURL;
	int sURL_len;
	zval *oObj;
	zval *oProperties;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_ReadSupportedProperties(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWebDAVStorageObject_ce_ptr, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_ReadSupportedProperties_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPropertyInfoList) or (TElWebDAVStorageObject, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, ReadAllProperties)
{
	char *sURL;
	int sURL_len;
	zval *oObj;
	zval *oProperties;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_ReadAllProperties(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWebDAVStorageObject_ce_ptr, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_ReadAllProperties_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPropertyInfoList) or (TElWebDAVStorageObject, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, Upload)
{
	char *sDestURL;
	char *sFilePath;
	int sDestURL_len;
	int sFilePath_len;
	long l4Count;
	long l4StartIndex;
	long l8RestartFrom;
	SBArrayZValInfo aiBuffer;
	zval *oDest;
	zval *oErrors;
	zval *oLocks;
	zval *oStream;
	zval *zaBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sFilePath, &sFilePath_len, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Upload(SBGetObjectHandle(getThis() TSRMLS_CC), sFilePath, (int32_t)sFilePath_len, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sFilePath, &sFilePath_len, &oDest, TElWebDAVStorageObject_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Upload_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilePath, (int32_t)sFilePath_len, SBGetObjectHandle(oDest TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sFilePath, &sFilePath_len, &sDestURL, &sDestURL_len, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Upload_2(SBGetObjectHandle(getThis() TSRMLS_CC), sFilePath, (int32_t)sFilePath_len, sDestURL, (int32_t)sDestURL_len, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllslO!O!", &zaBuffer, &l4StartIndex, &l4Count, &sDestURL, &sDestURL_len, &l8RestartFrom, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_Upload_3(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4StartIndex, (int32_t)l4Count, sDestURL, (int32_t)sDestURL_len, (int64_t)l8RestartFrom, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllO!lO!", &zaBuffer, &l4StartIndex, &l4Count, &oDest, TElWebDAVStorageObject_ce_ptr, &l8RestartFrom, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_Upload_4(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4StartIndex, (int32_t)l4Count, SBGetObjectHandle(oDest TSRMLS_CC), (int64_t)l8RestartFrom, SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slO!O!", &oStream, TStream_ce_ptr, &sDestURL, &sDestURL_len, &l8RestartFrom, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Upload_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sDestURL, (int32_t)sDestURL_len, (int64_t)l8RestartFrom, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lO!", &oStream, TStream_ce_ptr, &oDest, TElWebDAVStorageObject_ce_ptr, &l8RestartFrom, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Upload_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC), (int64_t)l8RestartFrom, SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDAVLockList, TElWebDavErrorList) or (string, TElWebDAVStorageObject, TElWebDavErrorList) or (string, string, TElWebDAVLockList, TElWebDavErrorList) or (array of byte|string|NULL, integer, integer, string, integer, TElWebDAVLockList, TElWebDavErrorList) or (array of byte|string|NULL, integer, integer, TElWebDAVStorageObject, integer, TElWebDavErrorList) or (TStream, string, integer, TElWebDAVLockList, TElWebDavErrorList) or (TStream, TElWebDAVStorageObject, integer, TElWebDavErrorList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, Download)
{
	char *sFilePath;
	char *sURL;
	int sFilePath_len;
	int sURL_len;
	long l4Count;
	long l8RestartFrom;
	zend_bool bOverwrite;
	zval *oLocks;
	zval *oObj;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sURL, &sURL_len, &sFilePath, &sFilePath_len, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Download(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sFilePath, (int32_t)sFilePath_len, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oObj, TElWebDAVStorageObject_ce_ptr, &sFilePath, &sFilePath_len, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Download_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sFilePath, (int32_t)sFilePath_len, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ll", &sURL, &sURL_len, &oStream, TStream_ce_ptr, &l4Count, &l8RestartFrom) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Download_2(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count, (int64_t)l8RestartFrom) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ll", &oObj, TElWebDAVStorageObject_ce_ptr, &oStream, TStream_ce_ptr, &l4Count, &l8RestartFrom) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Download_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count, (int64_t)l8RestartFrom) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llO!", &sURL, &sURL_len, &oStream, TStream_ce_ptr, &l4Count, &l8RestartFrom, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Download_4(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count, (int64_t)l8RestartFrom, SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llO!", &oObj, TElWebDAVStorageObject_ce_ptr, &oStream, TStream_ce_ptr, &l4Count, &l8RestartFrom, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Download_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count, (int64_t)l8RestartFrom, SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool) or (TElWebDAVStorageObject, string, bool) or (string, TStream, integer, integer) or (TElWebDAVStorageObject, TStream, integer, integer) or (string, TStream, integer, integer, TElWebDAVLockList) or (TElWebDAVStorageObject, TStream, integer, integer, TElWebDAVLockList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, DownloadFile)
{
	char *sLocalFileName;
	char *sURL;
	int sLocalFileName_len;
	int sURL_len;
	long fMode;
	long l8RestartFrom;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sURL, &sURL_len, &sLocalFileName, &sLocalFileName_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_DownloadFile(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sLocalFileName, (int32_t)sLocalFileName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sURL, &sURL_len, &sLocalFileName, &sLocalFileName_len, &fMode) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_DownloadFile_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sLocalFileName, (int32_t)sLocalFileName_len, (TSBFileTransferModeRaw)fMode) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssll", &sURL, &sURL_len, &sLocalFileName, &sLocalFileName_len, &fMode, &l8RestartFrom) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_DownloadFile_2(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sLocalFileName, (int32_t)sLocalFileName_len, (TSBFileTransferModeRaw)fMode, (int64_t)l8RestartFrom) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (string, string, integer) or (string, string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, DownloadStream)
{
	char *sURL;
	int sURL_len;
	long fMode;
	long l8RestartFrom;
	zval *oLocalStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!l", &sURL, &sURL_len, &oLocalStream, TStream_ce_ptr, &fMode) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_DownloadStream(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oLocalStream TSRMLS_CC), (TSBFileTransferModeRaw)fMode) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ll", &sURL, &sURL_len, &oLocalStream, TStream_ce_ptr, &fMode, &l8RestartFrom) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_DownloadStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oLocalStream TSRMLS_CC), (TSBFileTransferModeRaw)fMode, (int64_t)l8RestartFrom) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream, integer) or (string, TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, UploadFile)
{
	char *sLocalFileName;
	char *sURL;
	int sLocalFileName_len;
	int sURL_len;
	long fMode;
	long l8RestartFrom;
	zval *oErrors;
	zval *oLocks;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sLocalFileName, &sLocalFileName_len, &sURL, &sURL_len, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_UploadFile(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalFileName, (int32_t)sLocalFileName_len, sURL, (int32_t)sURL_len, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslO!O!", &sLocalFileName, &sLocalFileName_len, &sURL, &sURL_len, &fMode, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_UploadFile_1(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalFileName, (int32_t)sLocalFileName_len, sURL, (int32_t)sURL_len, (TSBFileTransferModeRaw)fMode, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssllO!O!", &sLocalFileName, &sLocalFileName_len, &sURL, &sURL_len, &fMode, &l8RestartFrom, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_UploadFile_2(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalFileName, (int32_t)sLocalFileName_len, sURL, (int32_t)sURL_len, (TSBFileTransferModeRaw)fMode, (int64_t)l8RestartFrom, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, TElWebDAVLockList, TElWebDavErrorList) or (string, string, integer, TElWebDAVLockList, TElWebDavErrorList) or (string, string, integer, integer, TElWebDAVLockList, TElWebDavErrorList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, UploadStream)
{
	char *sURL;
	int sURL_len;
	long fMode;
	long l8RestartFrom;
	zval *oErrors;
	zval *oLocalStream;
	zval *oLocks;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slO!O!", &oLocalStream, TStream_ce_ptr, &sURL, &sURL_len, &fMode, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_UploadStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLocalStream TSRMLS_CC), sURL, (int32_t)sURL_len, (TSBFileTransferModeRaw)fMode, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sllO!O!", &oLocalStream, TStream_ce_ptr, &sURL, &sURL_len, &fMode, &l8RestartFrom, &oLocks, TElWebDAVLockList_ce_ptr, &oErrors, TElWebDavErrorList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_UploadStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLocalStream TSRMLS_CC), sURL, (int32_t)sURL_len, (TSBFileTransferModeRaw)fMode, (int64_t)l8RestartFrom, SBGetObjectHandle(oLocks TSRMLS_CC), SBGetObjectHandle(oErrors TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, integer, TElWebDAVLockList, TElWebDavErrorList) or (TStream, string, integer, integer, TElWebDAVLockList, TElWebDavErrorList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, CancelRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_CancelRequest(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, GetFullURL)
{
	char *sURL;
	int sURL_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVClient_GetFullURL(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(836956781, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, GetFileSize)
{
	char *sURL;
	int sURL_len;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWebDAVClient_GetFileSize(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElWebDAVStorageObject_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWebDAVClient_GetFileSize_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElWebDAVStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, GetResourceType)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		TSBFileTypeRaw fOutResultRaw = 0;
		SBCheckError(TElWebDAVClient_GetResourceType(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, Lock)
{
	char *sOwner;
	char *sURL;
	int sOwner_len;
	int sURL_len;
	long fDepth;
	long fScope;
	long l4Timeout;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslll", &sURL, &sURL_len, &sOwner, &sOwner_len, &fScope, &fDepth, &l4Timeout) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVClient_Lock(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sOwner, (int32_t)sOwner_len, (TSBWebDavLockScopeRaw)fScope, (TSBWebDavDepthRaw)fDepth, (int32_t)l4Timeout, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slll", &oObj, TElWebDAVStorageObject_ce_ptr, &sOwner, &sOwner_len, &fScope, &fDepth, &l4Timeout) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVClient_Lock_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sOwner, (int32_t)sOwner_len, (TSBWebDavLockScopeRaw)fScope, (TSBWebDavDepthRaw)fDepth, (int32_t)l4Timeout, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, integer, integer, integer) or (TElWebDAVStorageObject, string, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, Unlock)
{
	char *sURL;
	int sURL_len;
	zval *oLock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oLock, TElWebDAVLock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_Unlock(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oLock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDAVLock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, RefreshLock)
{
	char *sURL;
	int sURL_len;
	zval *oLock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oLock, TElWebDAVLock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_RefreshLock(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oLock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDAVLock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, PrincipalCollectionSet)
{
	char *sURL;
	int sURL_len;
	zval *oURLs;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oURLs, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oURLs, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWebDAVClient_PrincipalCollectionSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oURLs TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDAVClient, ListPrincipals)
{
	char *sURL;
	int sURL_len;
	long fDepth;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!l", &sURL, &sURL_len, &oList, TElWebDavPrincipalList_ce_ptr, &fDepth) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_ListPrincipals(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), (TSBWebDavDepthRaw)fDepth) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPrincipalList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, AclPrincipalPropSetFirst)
{
	char *sURL;
	int sURL_len;
	SBArrayZValInfo piCtx;
	zval *oProperties;
	zval *zpCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO!", &zpCtx, &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS) && ((PZVAL_IS_REF(zpCtx) && ((IS_STRING == Z_TYPE_P(zpCtx)) || (IS_ARRAY == Z_TYPE_P(zpCtx)))) || ((IS_OBJECT == Z_TYPE_P(zpCtx)) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_AclPrincipalPropSetFirst(SBGetObjectHandle(getThis() TSRMLS_CC), &piCtx.data, sURL, (int32_t)sURL_len, SBGetObjectHandle(oProperties TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piCtx, zpCtx);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, string, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, AclPrincipalPropSetNext)
{
	SBArrayZValInfo piCtx;
	zval *oProperties;
	zval *zpCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zpCtx, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpCtx) == IS_STRING) || (Z_TYPE_P(zpCtx) == IS_ARRAY) || (Z_TYPE_P(zpCtx) == IS_NULL) || ((Z_TYPE_P(zpCtx) == IS_OBJECT) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_AclPrincipalPropSetNext(SBGetObjectHandle(getThis() TSRMLS_CC), piCtx.data, SBGetObjectHandle(oProperties TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piCtx);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, AclPrincipalPropSetClose)
{
	SBArrayZValInfo piCtx;
	zval *zpCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpCtx) == SUCCESS) && ((Z_TYPE_P(zpCtx) == IS_STRING) || (Z_TYPE_P(zpCtx) == IS_ARRAY) || (Z_TYPE_P(zpCtx) == IS_NULL) || ((Z_TYPE_P(zpCtx) == IS_OBJECT) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_AclPrincipalPropSetClose(SBGetObjectHandle(getThis() TSRMLS_CC), piCtx.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piCtx);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, PrincipalPropertySearchFirst)
{
	char *sURL;
	int sURL_len;
	SBArrayZValInfo piCtx;
	zend_bool bApplyToPrincipalCollectionSet;
	zval *oMatches;
	zval *oMatchProperties;
	zval *oProperties;
	zval *zpCtx;
#ifdef SB_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO!O!O!b", &zpCtx, &sURL, &sURL_len, &oMatchProperties, TElWebDavPropertyInfoList_ce_ptr, &oMatches, TStringList_ce_ptr, &oProperties, TElWebDavPropertyInfoList_ce_ptr, &bApplyToPrincipalCollectionSet) == SUCCESS) && ((PZVAL_IS_REF(zpCtx) && ((IS_STRING == Z_TYPE_P(zpCtx)) || (IS_ARRAY == Z_TYPE_P(zpCtx)))) || ((IS_OBJECT == Z_TYPE_P(zpCtx)) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO!O!O!b", &zpCtx, &sURL, &sURL_len, &oMatchProperties, TElWebDavPropertyInfoList_ce_ptr, &oMatches, TElStringList_ce_ptr, &oProperties, TElWebDavPropertyInfoList_ce_ptr, &bApplyToPrincipalCollectionSet) == SUCCESS) && ((PZVAL_IS_REF(zpCtx) && ((IS_STRING == Z_TYPE_P(zpCtx)) || (IS_ARRAY == Z_TYPE_P(zpCtx)))) || ((IS_OBJECT == Z_TYPE_P(zpCtx)) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
#endif
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_PrincipalPropertySearchFirst(SBGetObjectHandle(getThis() TSRMLS_CC), &piCtx.data, sURL, (int32_t)sURL_len, SBGetObjectHandle(oMatchProperties TSRMLS_CC), SBGetObjectHandle(oMatches TSRMLS_CC), SBGetObjectHandle(oProperties TSRMLS_CC), (int8_t)bApplyToPrincipalCollectionSet, &bOutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piCtx, zpCtx);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, string, TElWebDavPropertyInfoList, TStringList, TElWebDavPropertyInfoList, bool)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, string, TElWebDavPropertyInfoList, TElStringList, TElWebDavPropertyInfoList, bool)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDAVClient, PrincipalPropertySearchNext)
{
	SBArrayZValInfo piCtx;
	zval *oProperties;
	zval *zpCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zpCtx, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpCtx) == IS_STRING) || (Z_TYPE_P(zpCtx) == IS_ARRAY) || (Z_TYPE_P(zpCtx) == IS_NULL) || ((Z_TYPE_P(zpCtx) == IS_OBJECT) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_PrincipalPropertySearchNext(SBGetObjectHandle(getThis() TSRMLS_CC), piCtx.data, SBGetObjectHandle(oProperties TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piCtx);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, PrincipalPropertySearchClose)
{
	SBArrayZValInfo piCtx;
	zval *zpCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpCtx) == SUCCESS) && ((Z_TYPE_P(zpCtx) == IS_STRING) || (Z_TYPE_P(zpCtx) == IS_ARRAY) || (Z_TYPE_P(zpCtx) == IS_NULL) || ((Z_TYPE_P(zpCtx) == IS_OBJECT) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_PrincipalPropertySearchClose(SBGetObjectHandle(getThis() TSRMLS_CC), piCtx.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piCtx);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, PrincipalMatch)
{
	char *sURL;
	int sURL_len;
	zval *oObjects;
	zval *oPrincipalProperty;
	zval *oProperties;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!O!", &sURL, &sURL_len, &oPrincipalProperty, TElWebDavPropertyInfo_ce_ptr, &oProperties, TElWebDavPropertyInfoList_ce_ptr, &oObjects, TElWebDavObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_PrincipalMatch(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oPrincipalProperty TSRMLS_CC), SBGetObjectHandle(oProperties TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPropertyInfo, TElWebDavPropertyInfoList, TElWebDavObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, PrincipalSearchPropertySet)
{
	char *sURL;
	int sURL_len;
	zval *oProperties;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_PrincipalSearchPropertySet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oProperties TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, InheritedAclSet)
{
	char *sURL;
	int sURL_len;
	zval *oURLs;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oURLs, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oURLs, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWebDAVClient_InheritedAclSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oURLs TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDAVClient, AclRestrictions)
{
	char *sURL;
	int sURL_len;
	zval *oRestrictions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oRestrictions, TElWebDavACLRestrictions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_AclRestrictions(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oRestrictions TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavACLRestrictions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, SupportedPrivilegeSet)
{
	char *sURL;
	int sURL_len;
	zval *oPrivilegeSet;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oPrivilegeSet, TElWebDavSupportedPrivilegeSet_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_SupportedPrivilegeSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oPrivilegeSet TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavSupportedPrivilegeSet)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, CurrentUserPrivilegeSet)
{
	char *sURL;
	int sURL_len;
	int32_t l4PrivilegesRaw;
	zval *zl4Privileges;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sURL, &sURL_len, &zl4Privileges) == SUCCESS) && PZVAL_IS_REF(zl4Privileges) && (IS_LONG == Z_TYPE_P(zl4Privileges)))
	{
		l4PrivilegesRaw = (int32_t)Z_LVAL_P(zl4Privileges);
		SBCheckError(TElWebDAVClient_CurrentUserPrivilegeSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &l4PrivilegesRaw) TSRMLS_CC);
		ZVAL_LONG(zl4Privileges, (long)l4PrivilegesRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, GetAcl)
{
	char *sURL;
	int sURL_len;
	zval *oCurrentAcl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oCurrentAcl, TElWebDavACL_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_GetAcl(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oCurrentAcl TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavACL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, SetAcl)
{
	char *sURL;
	int sURL_len;
	zval *oNewAcl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oNewAcl, TElWebDavACL_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_SetAcl(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oNewAcl TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElWebDavACL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, CreateAddressBook)
{
	char *sDescription;
	char *sDisplayName;
	char *sLang;
	char *sName;
	char *sURL;
	int sDescription_len;
	int sDisplayName_len;
	int sLang_len;
	int sName_len;
	int sURL_len;
	zval *oLocks;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!", &sURL, &sURL_len, &sDisplayName, &sDisplayName_len, &sDescription, &sDescription_len, &sLang, &sLang_len, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_CreateAddressBook(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sDisplayName, (int32_t)sDisplayName_len, sDescription, (int32_t)sDescription_len, sLang, (int32_t)sLang_len, SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssss", &oParent, TElWebDAVStorageObject_ce_ptr, &sName, &sName_len, &sDisplayName, &sDisplayName_len, &sDescription, &sDescription_len, &sLang, &sLang_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_CreateAddressBook_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sName, (int32_t)sName_len, sDisplayName, (int32_t)sDisplayName_len, sDescription, (int32_t)sDescription_len, sLang, (int32_t)sLang_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sURL, &sURL_len, &sDisplayName, &sDisplayName_len, &sDescription, &sDescription_len, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_CreateAddressBook_2(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sDisplayName, (int32_t)sDisplayName_len, sDescription, (int32_t)sDescription_len, SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sss", &oParent, TElWebDAVStorageObject_ce_ptr, &sName, &sName_len, &sDisplayName, &sDisplayName_len, &sDescription, &sDescription_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_CreateAddressBook_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sName, (int32_t)sName_len, sDisplayName, (int32_t)sDisplayName_len, sDescription, (int32_t)sDescription_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string, string, TElWebDAVLockList) or (TElWebDAVStorageObject, string, string, string, string) or (string, string, string, TElWebDAVLockList) or (TElWebDAVStorageObject, string, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, UploadVCard)
{
	char *sETag;
	char *sURL;
	int sURL_len;
	int32_t sETag_len;
	uint32_t _err;
	zval *oErrors;
	zval *oLocks;
	zval *oStrm;
	zval *oVCard;
	zval *zsETag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!zO!O!", &sURL, &sURL_len, &oStrm, TStream_ce_ptr, &zsETag, &oErrors, TElWebDavErrorList_ce_ptr, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zsETag) && (IS_STRING == Z_TYPE_P(zsETag)))
	{
		sETag = Z_STRVAL_P(zsETag);
		sETag_len = (int32_t)Z_STRLEN_P(zsETag);
		_err = TElWebDAVClient_UploadVCard(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oStrm TSRMLS_CC), sETag, &sETag_len, SBGetObjectHandle(oErrors TSRMLS_CC), SBGetObjectHandle(oLocks TSRMLS_CC));
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sETag = emalloc(sETag_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1437147957, 3, sETag, &sETag_len) TSRMLS_CC);
			zval_dtor(zsETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sETag[sETag_len] = 0;
		ZVAL_STRINGL(zsETag, sETag, sETag_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!zO!O!", &sURL, &sURL_len, &oVCard, TElVCard_ce_ptr, &zsETag, &oErrors, TElWebDavErrorList_ce_ptr, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zsETag) && (IS_STRING == Z_TYPE_P(zsETag)))
	{
		sETag = Z_STRVAL_P(zsETag);
		sETag_len = (int32_t)Z_STRLEN_P(zsETag);
		_err = TElWebDAVClient_UploadVCard_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oVCard TSRMLS_CC), sETag, &sETag_len, SBGetObjectHandle(oErrors TSRMLS_CC), SBGetObjectHandle(oLocks TSRMLS_CC));
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sETag = emalloc(sETag_len + 1);
			SBCheckError(SBGetLastReturnStringA(823719505, 3, sETag, &sETag_len) TSRMLS_CC);
			zval_dtor(zsETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sETag[sETag_len] = 0;
		ZVAL_STRINGL(zsETag, sETag, sETag_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream, &string, TElWebDavErrorList, TElWebDAVLockList) or (string, TElVCard, &string, TElWebDavErrorList, TElWebDAVLockList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, DownloadVCard)
{
	char *sURL;
	int sURL_len;
	TElClassHandle hoVCard;
	zval *oLocks;
	zval *oVCard;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sOO!", &sURL, &sURL_len, &oVCard, TElVCard_ce_ptr, &oLocks, TElWebDAVLockList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oVCard) && (IS_OBJECT == Z_TYPE_P(oVCard)))
	{
		hoVCard = SBGetObjectHandle(oVCard TSRMLS_CC);
		SBCheckError(TElWebDAVClient_DownloadVCard(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &hoVCard, SBGetObjectHandle(oLocks TSRMLS_CC)) TSRMLS_CC);
		SBUpdateObjectHandle(oVCard, hoVCard TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, &TElVCard, TElWebDAVLockList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, GetAddressBookInfo)
{
	char *sURL;
	int sURL_len;
	zval *oInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oInfo, TElCardDavAddressBookInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_GetAddressBookInfo(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oInfo TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElCardDavAddressBookInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, AddressBookQueryFirst)
{
	char *sURL;
	int sURL_len;
	long fDepth;
	long l4Limit;
	SBArrayZValInfo piCtx;
	zend_bool bAll;
	zval *oAddressDataProps;
	zval *oFilter;
	zval *oProperties;
	zval *zpCtx;
#ifdef SB_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO!O!O!lbl", &zpCtx, &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr, &oAddressDataProps, TStringList_ce_ptr, &oFilter, TElCardDavFilter_ce_ptr, &l4Limit, &bAll, &fDepth) == SUCCESS) && ((PZVAL_IS_REF(zpCtx) && ((IS_STRING == Z_TYPE_P(zpCtx)) || (IS_ARRAY == Z_TYPE_P(zpCtx)))) || ((IS_OBJECT == Z_TYPE_P(zpCtx)) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO!O!O!lbl", &zpCtx, &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr, &oAddressDataProps, TElStringList_ce_ptr, &oFilter, TElCardDavFilter_ce_ptr, &l4Limit, &bAll, &fDepth) == SUCCESS) && ((PZVAL_IS_REF(zpCtx) && ((IS_STRING == Z_TYPE_P(zpCtx)) || (IS_ARRAY == Z_TYPE_P(zpCtx)))) || ((IS_OBJECT == Z_TYPE_P(zpCtx)) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
#endif
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_AddressBookQueryFirst(SBGetObjectHandle(getThis() TSRMLS_CC), &piCtx.data, sURL, (int32_t)sURL_len, SBGetObjectHandle(oProperties TSRMLS_CC), SBGetObjectHandle(oAddressDataProps TSRMLS_CC), SBGetObjectHandle(oFilter TSRMLS_CC), (int32_t)l4Limit, (int8_t)bAll, (TSBWebDavDepthRaw)fDepth, &bOutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piCtx, zpCtx);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, string, TElWebDavPropertyInfoList, TStringList, TElCardDavFilter, integer, bool, integer)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, string, TElWebDavPropertyInfoList, TElStringList, TElCardDavFilter, integer, bool, integer)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDAVClient, AddressBookQueryNext)
{
	SBArrayZValInfo piCtx;
	zval *oProperties;
	zval *zpCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zpCtx, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpCtx) == IS_STRING) || (Z_TYPE_P(zpCtx) == IS_ARRAY) || (Z_TYPE_P(zpCtx) == IS_NULL) || ((Z_TYPE_P(zpCtx) == IS_OBJECT) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_AddressBookQueryNext(SBGetObjectHandle(getThis() TSRMLS_CC), piCtx.data, SBGetObjectHandle(oProperties TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piCtx);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, AddressBookQueryClose)
{
	SBArrayZValInfo piCtx;
	zval *zpCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpCtx) == SUCCESS) && ((Z_TYPE_P(zpCtx) == IS_STRING) || (Z_TYPE_P(zpCtx) == IS_ARRAY) || (Z_TYPE_P(zpCtx) == IS_NULL) || ((Z_TYPE_P(zpCtx) == IS_OBJECT) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_AddressBookQueryClose(SBGetObjectHandle(getThis() TSRMLS_CC), piCtx.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piCtx);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, AddressBookMultigetFirst)
{
	char *sURL;
	int sURL_len;
	long fDepth;
	SBArrayZValInfo piCtx;
	zend_bool bAll;
	zval *oAddressDataProps;
	zval *oHrefs;
	zval *oProperties;
	zval *zpCtx;
#ifdef SB_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO!O!O!bl", &zpCtx, &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr, &oAddressDataProps, TStringList_ce_ptr, &oHrefs, TStringList_ce_ptr, &bAll, &fDepth) == SUCCESS) && ((PZVAL_IS_REF(zpCtx) && ((IS_STRING == Z_TYPE_P(zpCtx)) || (IS_ARRAY == Z_TYPE_P(zpCtx)))) || ((IS_OBJECT == Z_TYPE_P(zpCtx)) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO!O!O!bl", &zpCtx, &sURL, &sURL_len, &oProperties, TElWebDavPropertyInfoList_ce_ptr, &oAddressDataProps, TElStringList_ce_ptr, &oHrefs, TElStringList_ce_ptr, &bAll, &fDepth) == SUCCESS) && ((PZVAL_IS_REF(zpCtx) && ((IS_STRING == Z_TYPE_P(zpCtx)) || (IS_ARRAY == Z_TYPE_P(zpCtx)))) || ((IS_OBJECT == Z_TYPE_P(zpCtx)) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
#endif
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_AddressBookMultigetFirst(SBGetObjectHandle(getThis() TSRMLS_CC), &piCtx.data, sURL, (int32_t)sURL_len, SBGetObjectHandle(oProperties TSRMLS_CC), SBGetObjectHandle(oAddressDataProps TSRMLS_CC), SBGetObjectHandle(oHrefs TSRMLS_CC), (int8_t)bAll, (TSBWebDavDepthRaw)fDepth, &bOutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piCtx, zpCtx);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, string, TElWebDavPropertyInfoList, TStringList, TStringList, bool, integer)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, string, TElWebDavPropertyInfoList, TElStringList, TElStringList, bool, integer)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDAVClient, AddressBookMultigetNext)
{
	SBArrayZValInfo piCtx;
	zval *oProperties;
	zval *zpCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zpCtx, &oProperties, TElWebDavPropertyInfoList_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpCtx) == IS_STRING) || (Z_TYPE_P(zpCtx) == IS_ARRAY) || (Z_TYPE_P(zpCtx) == IS_NULL) || ((Z_TYPE_P(zpCtx) == IS_OBJECT) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_AddressBookMultigetNext(SBGetObjectHandle(getThis() TSRMLS_CC), piCtx.data, SBGetObjectHandle(oProperties TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piCtx);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TElWebDavPropertyInfoList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, AddressBookMultigetClose)
{
	SBArrayZValInfo piCtx;
	zval *zpCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpCtx) == SUCCESS) && ((Z_TYPE_P(zpCtx) == IS_STRING) || (Z_TYPE_P(zpCtx) == IS_ARRAY) || (Z_TYPE_P(zpCtx) == IS_NULL) || ((Z_TYPE_P(zpCtx) == IS_OBJECT) && (Z_OBJCE_P(zpCtx) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpCtx, &piCtx TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVClient_AddressBookMultigetClose(SBGetObjectHandle(getThis() TSRMLS_CC), piCtx.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piCtx);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_CurrentUserPrincipal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVClient_get_CurrentUserPrincipal(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, SBWebDAVClient_TElWebDavPrincipal_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_Authenticated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVClient_get_Authenticated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_AddressBookURLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVClient_get_AddressBookURLs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_HTTPSWebDAVClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVClient_get_HTTPSWebDAVClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSWebDAVClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, set_HTTPSWebDAVClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSWebDAVClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_set_HTTPSWebDAVClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSWebDAVClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVClient_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_BaseURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVClient_get_BaseURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(243878430, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, set_BaseURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_set_BaseURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_Owner_AnsiString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVClient_get_Owner_AnsiString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1761416245, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, set_Owner_AnsiString)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_set_Owner_AnsiString(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_LastListedURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVClient_get_LastListedURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-310348052, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_IncludeBackLinks)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVClient_get_IncludeBackLinks(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, set_IncludeBackLinks)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_set_IncludeBackLinks(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_EncodeURL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVClient_get_EncodeURL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, set_EncodeURL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVClient_set_EncodeURL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, get_SupportedClasses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavClassesRaw fOutResultRaw = 0;
		SBCheckError(TElWebDAVClient_get_SupportedClasses(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_List, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Objects_or_URL_or_Obj, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElWebDavObjectList, 1)
	ZEND_ARG_INFO(0, Depth)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_CreateCollection, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, URL_or_Parent, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Locks_or_Name, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_DeleteObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Locks_or_Errors, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Errors, TElWebDavErrorList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_CopyObject, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, SrcURL_or_Src, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DestURL_or_Dest, 0, 1)
	ZEND_ARG_INFO(0, Overwrite)
	ZEND_ARG_TYPE_INFO(0, Locks_or_Errors, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Errors, TElWebDavErrorList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_MoveObject, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, SrcURL_or_Src, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DestURL_or_Dest, 0, 1)
	ZEND_ARG_INFO(0, Overwrite)
	ZEND_ARG_TYPE_INFO(0, Locks_or_Errors, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Errors, TElWebDavErrorList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_Rename, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, NewName)
	ZEND_ARG_INFO(0, MoveToRename)
	ZEND_ARG_OBJ_INFO(0, Locks, TElWebDAVLockList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_ChangeProperties, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_OBJ_INFO(0, SetProperties, TElWebDavPropertyInfoList, 1)
	ZEND_ARG_OBJ_INFO(0, RemoveProperties, TElWebDavPropertyInfoList, 1)
	ZEND_ARG_OBJ_INFO(0, Locks, TElWebDAVLockList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_SetProperty, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_OBJ_INFO(0, PropInfo, TElWebDavPropertyInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Locks, TElWebDAVLockList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_RemoveProperty, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_OBJ_INFO(0, PropInfo, TElWebDavPropertyInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Locks, TElWebDAVLockList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_ReadProperties, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_ReadProperty, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, PropName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_GetSupportedProperties, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_ReadSupportedProperties, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_ReadAllProperties, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_Upload, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, FilePath_or_Buffer_or_Stream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Locks_or_Dest_or_DestURL_or_StartIndex, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Errors_or_Locks_or_Count_or_RestartFrom, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Errors_or_DestURL_or_Dest_or_Locks, 0, 1)
	ZEND_ARG_TYPE_INFO(0, RestartFrom_or_Errors, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Locks_or_Errors, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Errors, TElWebDavErrorList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_Download, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FilePath_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Overwrite_or_Count)
	ZEND_ARG_INFO(0, RestartFrom)
	ZEND_ARG_OBJ_INFO(0, Locks, TElWebDAVLockList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_DownloadFile, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(0, LocalFileName)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_INFO(0, RestartFrom)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_DownloadStream, 0, 0, 3)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, LocalStream, TStream, 1)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_INFO(0, RestartFrom)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_UploadFile, 0, 0, 4)
	ZEND_ARG_INFO(0, LocalFileName)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_TYPE_INFO(0, Locks_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Errors_or_Locks_or_RestartFrom, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Errors_or_Locks, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Errors, TElWebDavErrorList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_UploadStream, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, LocalStream, TStream, 1)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_TYPE_INFO(0, Locks_or_RestartFrom, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Errors_or_Locks, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Errors, TElWebDavErrorList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_CancelRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_GetFullURL, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_GetFileSize, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_GetResourceType, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_Lock, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, URL_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Owner)
	ZEND_ARG_INFO(0, Scope)
	ZEND_ARG_INFO(0, Depth)
	ZEND_ARG_INFO(0, Timeout)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_Unlock, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, Lock, TElWebDAVLock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_RefreshLock, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, Lock, TElWebDAVLock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_PrincipalCollectionSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, URLs, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, URLs, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_ListPrincipals, 0, 0, 3)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, List, TElWebDavPrincipalList, 1)
	ZEND_ARG_INFO(0, Depth)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AclPrincipalPropSetFirst, 0, 0, 3)
	ZEND_ARG_INFO(1, Ctx)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AclPrincipalPropSetNext, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Ctx, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AclPrincipalPropSetClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Ctx, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_PrincipalPropertySearchFirst, 0, 0, 6)
	ZEND_ARG_INFO(1, Ctx)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, MatchProperties, TElWebDavPropertyInfoList, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Matches, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Matches, TElStringList, 1)
#endif
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
	ZEND_ARG_INFO(0, ApplyToPrincipalCollectionSet)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_PrincipalPropertySearchNext, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Ctx, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_PrincipalPropertySearchClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Ctx, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_PrincipalMatch, 0, 0, 4)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, PrincipalProperty, TElWebDavPropertyInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElWebDavObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_PrincipalSearchPropertySet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_InheritedAclSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, URLs, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, URLs, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AclRestrictions, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, Restrictions, TElWebDavACLRestrictions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_SupportedPrivilegeSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, PrivilegeSet, TElWebDavSupportedPrivilegeSet, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_CurrentUserPrivilegeSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(1, Privileges)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_GetAcl, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, CurrentAcl, TElWebDavACL, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_SetAcl, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, NewAcl, TElWebDavACL, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_CreateAddressBook, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, URL_or_Parent, 0, 1)
	ZEND_ARG_INFO(0, DisplayName_or_Name)
	ZEND_ARG_INFO(0, Description_or_DisplayName)
	ZEND_ARG_TYPE_INFO(0, Lang_or_Description_or_Locks, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Locks_or_Lang, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_UploadVCard, 0, 0, 5)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_TYPE_INFO(0, Strm_or_VCard, 0, 1)
	ZEND_ARG_INFO(1, ETag)
	ZEND_ARG_OBJ_INFO(0, Errors, TElWebDavErrorList, 1)
	ZEND_ARG_OBJ_INFO(0, Locks, TElWebDAVLockList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_DownloadVCard, 0, 0, 3)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(1, VCard, TElVCard, 0)
	ZEND_ARG_OBJ_INFO(0, Locks, TElWebDAVLockList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_GetAddressBookInfo, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, Info, TElCardDavAddressBookInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AddressBookQueryFirst, 0, 0, 8)
	ZEND_ARG_INFO(1, Ctx)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, AddressDataProps, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, AddressDataProps, TElStringList, 1)
#endif
	ZEND_ARG_OBJ_INFO(0, Filter, TElCardDavFilter, 1)
	ZEND_ARG_INFO(0, Limit)
	ZEND_ARG_INFO(0, All)
	ZEND_ARG_INFO(0, Depth)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AddressBookQueryNext, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Ctx, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AddressBookQueryClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Ctx, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AddressBookMultigetFirst, 0, 0, 7)
	ZEND_ARG_INFO(1, Ctx)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, AddressDataProps, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Hrefs, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, AddressDataProps, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Hrefs, TElStringList, 1)
#endif
	ZEND_ARG_INFO(0, All)
	ZEND_ARG_INFO(0, Depth)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AddressBookMultigetNext, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Ctx, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Properties, TElWebDavPropertyInfoList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_AddressBookMultigetClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Ctx, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_CurrentUserPrincipal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_Authenticated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_AddressBookURLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_HTTPSWebDAVClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_set_HTTPSWebDAVClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSWebDAVClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_BaseURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_set_BaseURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_Owner_AnsiString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_set_Owner_AnsiString, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_LastListedURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_IncludeBackLinks, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_set_IncludeBackLinks, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_EncodeURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_set_EncodeURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient_get_SupportedClasses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVClient_methods[] = {
	PHP_ME(TElWebDAVClient, List, arginfo_TElWebDAVClient_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, CreateCollection, arginfo_TElWebDAVClient_CreateCollection, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, DeleteObject, arginfo_TElWebDAVClient_DeleteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, CopyObject, arginfo_TElWebDAVClient_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, MoveObject, arginfo_TElWebDAVClient_MoveObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, Rename, arginfo_TElWebDAVClient_Rename, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, ChangeProperties, arginfo_TElWebDAVClient_ChangeProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, SetProperty, arginfo_TElWebDAVClient_SetProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, RemoveProperty, arginfo_TElWebDAVClient_RemoveProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, ReadProperties, arginfo_TElWebDAVClient_ReadProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, ReadProperty, arginfo_TElWebDAVClient_ReadProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, GetSupportedProperties, arginfo_TElWebDAVClient_GetSupportedProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, ReadSupportedProperties, arginfo_TElWebDAVClient_ReadSupportedProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, ReadAllProperties, arginfo_TElWebDAVClient_ReadAllProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, Upload, arginfo_TElWebDAVClient_Upload, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, Download, arginfo_TElWebDAVClient_Download, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, DownloadFile, arginfo_TElWebDAVClient_DownloadFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, DownloadStream, arginfo_TElWebDAVClient_DownloadStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, UploadFile, arginfo_TElWebDAVClient_UploadFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, UploadStream, arginfo_TElWebDAVClient_UploadStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, CancelRequest, arginfo_TElWebDAVClient_CancelRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, GetFullURL, arginfo_TElWebDAVClient_GetFullURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, GetFileSize, arginfo_TElWebDAVClient_GetFileSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, GetResourceType, arginfo_TElWebDAVClient_GetResourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, Lock, arginfo_TElWebDAVClient_Lock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, Unlock, arginfo_TElWebDAVClient_Unlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, RefreshLock, arginfo_TElWebDAVClient_RefreshLock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, PrincipalCollectionSet, arginfo_TElWebDAVClient_PrincipalCollectionSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, ListPrincipals, arginfo_TElWebDAVClient_ListPrincipals, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AclPrincipalPropSetFirst, arginfo_TElWebDAVClient_AclPrincipalPropSetFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AclPrincipalPropSetNext, arginfo_TElWebDAVClient_AclPrincipalPropSetNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AclPrincipalPropSetClose, arginfo_TElWebDAVClient_AclPrincipalPropSetClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, PrincipalPropertySearchFirst, arginfo_TElWebDAVClient_PrincipalPropertySearchFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, PrincipalPropertySearchNext, arginfo_TElWebDAVClient_PrincipalPropertySearchNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, PrincipalPropertySearchClose, arginfo_TElWebDAVClient_PrincipalPropertySearchClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, PrincipalMatch, arginfo_TElWebDAVClient_PrincipalMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, PrincipalSearchPropertySet, arginfo_TElWebDAVClient_PrincipalSearchPropertySet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, InheritedAclSet, arginfo_TElWebDAVClient_InheritedAclSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AclRestrictions, arginfo_TElWebDAVClient_AclRestrictions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, SupportedPrivilegeSet, arginfo_TElWebDAVClient_SupportedPrivilegeSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, CurrentUserPrivilegeSet, arginfo_TElWebDAVClient_CurrentUserPrivilegeSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, GetAcl, arginfo_TElWebDAVClient_GetAcl, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, SetAcl, arginfo_TElWebDAVClient_SetAcl, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, CreateAddressBook, arginfo_TElWebDAVClient_CreateAddressBook, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, UploadVCard, arginfo_TElWebDAVClient_UploadVCard, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, DownloadVCard, arginfo_TElWebDAVClient_DownloadVCard, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, GetAddressBookInfo, arginfo_TElWebDAVClient_GetAddressBookInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AddressBookQueryFirst, arginfo_TElWebDAVClient_AddressBookQueryFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AddressBookQueryNext, arginfo_TElWebDAVClient_AddressBookQueryNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AddressBookQueryClose, arginfo_TElWebDAVClient_AddressBookQueryClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AddressBookMultigetFirst, arginfo_TElWebDAVClient_AddressBookMultigetFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AddressBookMultigetNext, arginfo_TElWebDAVClient_AddressBookMultigetNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, AddressBookMultigetClose, arginfo_TElWebDAVClient_AddressBookMultigetClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_CurrentUserPrincipal, arginfo_TElWebDAVClient_get_CurrentUserPrincipal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_Authenticated, arginfo_TElWebDAVClient_get_Authenticated, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_AddressBookURLs, arginfo_TElWebDAVClient_get_AddressBookURLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_HTTPSWebDAVClient, arginfo_TElWebDAVClient_get_HTTPSWebDAVClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, set_HTTPSWebDAVClient, arginfo_TElWebDAVClient_set_HTTPSWebDAVClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_FileSystemAdapter, arginfo_TElWebDAVClient_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, set_FileSystemAdapter, arginfo_TElWebDAVClient_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_BaseURL, arginfo_TElWebDAVClient_get_BaseURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, set_BaseURL, arginfo_TElWebDAVClient_set_BaseURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_Owner_AnsiString, arginfo_TElWebDAVClient_get_Owner_AnsiString, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, set_Owner_AnsiString, arginfo_TElWebDAVClient_set_Owner_AnsiString, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_LastListedURL, arginfo_TElWebDAVClient_get_LastListedURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_IncludeBackLinks, arginfo_TElWebDAVClient_get_IncludeBackLinks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, set_IncludeBackLinks, arginfo_TElWebDAVClient_set_IncludeBackLinks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_EncodeURL, arginfo_TElWebDAVClient_get_EncodeURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, set_EncodeURL, arginfo_TElWebDAVClient_set_EncodeURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, get_SupportedClasses, arginfo_TElWebDAVClient_get_SupportedClasses, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVClient, __construct, arginfo_TElWebDAVClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVClient", TElWebDAVClient_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElWebDAVClient_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDAVLockList_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVLockList, Merge)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TElWebDAVLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVLockList_Merge(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVLockList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVLockList, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVLockList_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLockList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVLockList, Add)
{
	zval *oLock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oLock, TElWebDAVLock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVLockList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVLock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVLockList, Remove)
{
	zval *oLock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oLock, TElWebDAVLock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVLockList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVLock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVLockList, get_Locks)
{
	long l4Idx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Idx) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVLockList_get_Locks(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Idx, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVLockList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVLockList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVLockList, get_ToIfHeader)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVLockList_get_ToIfHeader(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1992961300, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVLockList, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVLockList_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVLockList_Merge, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TElWebDAVLockList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVLockList_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVLockList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Lock, TElWebDAVLock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVLockList_Remove, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Lock, TElWebDAVLock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVLockList_get_Locks, 0, 0, 1)
	ZEND_ARG_INFO(0, Idx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVLockList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVLockList_get_ToIfHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVLockList___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVLockList_methods[] = {
	PHP_ME(TElWebDAVLockList, Merge, arginfo_TElWebDAVLockList_Merge, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVLockList, Clone, arginfo_TElWebDAVLockList_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVLockList, Add, arginfo_TElWebDAVLockList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVLockList, Remove, arginfo_TElWebDAVLockList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVLockList, get_Locks, arginfo_TElWebDAVLockList_get_Locks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVLockList, get_Count, arginfo_TElWebDAVLockList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVLockList, get_ToIfHeader, arginfo_TElWebDAVLockList_get_ToIfHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVLockList, __construct, arginfo_TElWebDAVLockList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVLockList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVLockList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVLockList", TElWebDAVLockList_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElWebDAVLockList_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDAVMultistatusResponse_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVMultistatusResponse, LoadFromStream)
{
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVMultistatusResponse_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMultistatusResponse, get_Responses)
{
	long l4Idx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Idx) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVMultistatusResponse_get_Responses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Idx, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMultistatusResponse, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVMultistatusResponse_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMultistatusResponse, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVMultistatusResponse_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMultistatusResponse_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMultistatusResponse_get_Responses, 0, 0, 1)
	ZEND_ARG_INFO(0, Idx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMultistatusResponse_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMultistatusResponse___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVMultistatusResponse_methods[] = {
	PHP_ME(TElWebDAVMultistatusResponse, LoadFromStream, arginfo_TElWebDAVMultistatusResponse_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMultistatusResponse, get_Responses, arginfo_TElWebDAVMultistatusResponse_get_Responses, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMultistatusResponse, get_Count, arginfo_TElWebDAVMultistatusResponse_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMultistatusResponse, __construct, arginfo_TElWebDAVMultistatusResponse___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVMultistatusResponse(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVMultistatusResponse_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVMultistatusResponse", TElWebDAVMultistatusResponse_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDAVMultistatusResponse_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavError_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavError, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDavError_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavError, get_NS)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavError_get_NS(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-482115215, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavError, set_NS)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavError_set_NS(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavError, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavError_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1131315731, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavError, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavError_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavError, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavError_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavError_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavError_get_NS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavError_set_NS, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavError_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavError_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavError___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavError_methods[] = {
	PHP_ME(TElWebDavError, LoadFromXML, arginfo_TElWebDavError_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavError, get_NS, arginfo_TElWebDavError_get_NS, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavError, set_NS, arginfo_TElWebDavError_set_NS, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavError, get_Value, arginfo_TElWebDavError_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavError, set_Value, arginfo_TElWebDavError_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavError, __construct, arginfo_TElWebDavError___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavError(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavError_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavError", TElWebDavError_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavError_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavPrivilegeSet_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavPrivilegeSet, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDavPrivilegeSet_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrivilegeSet, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavPrivilegeSet_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrivilegeSet, set_Value)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElWebDavPrivilegeSet_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrivilegeSet, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavPrivilegeSet_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrivilegeSet_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrivilegeSet_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrivilegeSet_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrivilegeSet___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavPrivilegeSet_methods[] = {
	PHP_ME(TElWebDavPrivilegeSet, LoadFromXML, arginfo_TElWebDavPrivilegeSet_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrivilegeSet, get_Value, arginfo_TElWebDavPrivilegeSet_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrivilegeSet, set_Value, arginfo_TElWebDavPrivilegeSet_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrivilegeSet, __construct, arginfo_TElWebDavPrivilegeSet___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavPrivilegeSet(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavPrivilegeSet_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavPrivilegeSet", TElWebDavPrivilegeSet_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavPrivilegeSet_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavSupportedPrivilege_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavSupportedPrivilege, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDavSupportedPrivilege_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, get_NS)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavSupportedPrivilege_get_NS(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(253102328, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, set_NS)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavSupportedPrivilege_set_NS(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavSupportedPrivilege_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(416963922, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavSupportedPrivilege_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavSupportedPrivilege_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1567690921, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, set_Description)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavSupportedPrivilege_set_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, get_DescLang)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavSupportedPrivilege_get_DescLang(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(246912473, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, set_DescLang)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavSupportedPrivilege_set_DescLang(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, get__Abstract)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavSupportedPrivilege_get__Abstract(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, set__Abstract)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDavSupportedPrivilege_set__Abstract(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavSupportedPrivilege_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, set_Value)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElWebDavSupportedPrivilege_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, get_AggregatedPrivileges)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavSupportedPrivilege_get_AggregatedPrivileges(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavSupportedPrivilege_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, get_AggregatedPrivilegeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavSupportedPrivilege_get_AggregatedPrivilegeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilege, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavSupportedPrivilege_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_get_NS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_set_NS, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_set_Description, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_get_DescLang, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_set_DescLang, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_get__Abstract, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_set__Abstract, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_get_AggregatedPrivileges, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege_get_AggregatedPrivilegeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilege___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavSupportedPrivilege_methods[] = {
	PHP_ME(TElWebDavSupportedPrivilege, LoadFromXML, arginfo_TElWebDavSupportedPrivilege_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, get_NS, arginfo_TElWebDavSupportedPrivilege_get_NS, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, set_NS, arginfo_TElWebDavSupportedPrivilege_set_NS, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, get_Name, arginfo_TElWebDavSupportedPrivilege_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, set_Name, arginfo_TElWebDavSupportedPrivilege_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, get_Description, arginfo_TElWebDavSupportedPrivilege_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, set_Description, arginfo_TElWebDavSupportedPrivilege_set_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, get_DescLang, arginfo_TElWebDavSupportedPrivilege_get_DescLang, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, set_DescLang, arginfo_TElWebDavSupportedPrivilege_set_DescLang, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, get__Abstract, arginfo_TElWebDavSupportedPrivilege_get__Abstract, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, set__Abstract, arginfo_TElWebDavSupportedPrivilege_set__Abstract, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, get_Value, arginfo_TElWebDavSupportedPrivilege_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, set_Value, arginfo_TElWebDavSupportedPrivilege_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, get_AggregatedPrivileges, arginfo_TElWebDavSupportedPrivilege_get_AggregatedPrivileges, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, get_AggregatedPrivilegeCount, arginfo_TElWebDavSupportedPrivilege_get_AggregatedPrivilegeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilege, __construct, arginfo_TElWebDavSupportedPrivilege___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavSupportedPrivilege(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavSupportedPrivilege_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavSupportedPrivilege", TElWebDavSupportedPrivilege_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavSupportedPrivilege_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavSupportedPrivilegeSet_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavSupportedPrivilegeSet, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDavSupportedPrivilegeSet_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilegeSet, IsAbstract)
{
	long l4Privilege;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Privilege) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavSupportedPrivilegeSet_IsAbstract(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Privilege, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilegeSet, get_AggregatedPrivileges)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavSupportedPrivilegeSet_get_AggregatedPrivileges(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavSupportedPrivilege_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilegeSet, get_AggregatedPrivilegeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavSupportedPrivilegeSet_get_AggregatedPrivilegeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavSupportedPrivilegeSet, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavSupportedPrivilegeSet_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilegeSet_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilegeSet_IsAbstract, 0, 0, 1)
	ZEND_ARG_INFO(0, Privilege)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilegeSet_get_AggregatedPrivileges, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilegeSet_get_AggregatedPrivilegeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavSupportedPrivilegeSet___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavSupportedPrivilegeSet_methods[] = {
	PHP_ME(TElWebDavSupportedPrivilegeSet, LoadFromXML, arginfo_TElWebDavSupportedPrivilegeSet_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilegeSet, IsAbstract, arginfo_TElWebDavSupportedPrivilegeSet_IsAbstract, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilegeSet, get_AggregatedPrivileges, arginfo_TElWebDavSupportedPrivilegeSet_get_AggregatedPrivileges, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilegeSet, get_AggregatedPrivilegeCount, arginfo_TElWebDavSupportedPrivilegeSet_get_AggregatedPrivilegeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavSupportedPrivilegeSet, __construct, arginfo_TElWebDavSupportedPrivilegeSet___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavSupportedPrivilegeSet(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavSupportedPrivilegeSet_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavSupportedPrivilegeSet", TElWebDavSupportedPrivilegeSet_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavSupportedPrivilegeSet_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDAVPrincipalSearchPropertySetResponse_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVPrincipalSearchPropertySetResponse, LoadFromStream)
{
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVPrincipalSearchPropertySetResponse_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVPrincipalSearchPropertySetResponse, get_Responses)
{
	long l4Idx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Idx) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVPrincipalSearchPropertySetResponse_get_Responses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Idx, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVPrincipalSearchPropertySetResponse, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVPrincipalSearchPropertySetResponse_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVPrincipalSearchPropertySetResponse, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVPrincipalSearchPropertySetResponse_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVPrincipalSearchPropertySetResponse_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVPrincipalSearchPropertySetResponse_get_Responses, 0, 0, 1)
	ZEND_ARG_INFO(0, Idx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVPrincipalSearchPropertySetResponse_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVPrincipalSearchPropertySetResponse___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVPrincipalSearchPropertySetResponse_methods[] = {
	PHP_ME(TElWebDAVPrincipalSearchPropertySetResponse, LoadFromStream, arginfo_TElWebDAVPrincipalSearchPropertySetResponse_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVPrincipalSearchPropertySetResponse, get_Responses, arginfo_TElWebDAVPrincipalSearchPropertySetResponse_get_Responses, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVPrincipalSearchPropertySetResponse, get_Count, arginfo_TElWebDAVPrincipalSearchPropertySetResponse_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVPrincipalSearchPropertySetResponse, __construct, arginfo_TElWebDAVPrincipalSearchPropertySetResponse___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVPrincipalSearchPropertySetResponse(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVPrincipalSearchPropertySetResponse_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVPrincipalSearchPropertySetResponse", TElWebDAVPrincipalSearchPropertySetResponse_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDAVPrincipalSearchPropertySetResponse_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDAVStorageObject_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVStorageObject, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVStorageObject_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, ReadFromXML)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVStorageObject_ReadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, Lock)
{
	long fDepth;
	long fScope;
	long l4Timeout;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lll", &fScope, &fDepth, &l4Timeout) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVStorageObject_Lock(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBWebDavLockScopeRaw)fScope, (TSBWebDavDepthRaw)fDepth, (int32_t)l4Timeout, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, Unlock)
{
	long l4Idx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDAVStorageObject_Unlock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Idx) == SUCCESS)
	{
		SBCheckError(TElWebDAVStorageObject_Unlock_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Idx) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, GetIfHeader)
{
	uint32_t _err;
	zend_bool bWithETag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bWithETag) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVStorageObject_GetIfHeader(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bWithETag, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1461836289, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_Storage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVStorageObject_get_Storage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_ParentURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVStorageObject_get_ParentURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1478733581, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVStorageObject_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-678335939, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_FullURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVStorageObject_get_FullURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1456642290, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_CreationDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElWebDAVStorageObject_get_CreationDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_DisplayName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVStorageObject_get_DisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-629425909, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_ContentLanguage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVStorageObject_get_ContentLanguage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-481993220, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_ContentLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWebDAVStorageObject_get_ContentLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVStorageObject_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1765305739, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVStorageObject_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2664382, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_LastModified)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElWebDAVStorageObject_get_LastModified(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_ResourceType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVStorageObject_get_ResourceType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-93907443, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_Collection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVStorageObject_get_Collection(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_IsAddressBook)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVStorageObject_get_IsAddressBook(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_BackLink)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVStorageObject_get_BackLink(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_SupportsExclusiveLock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVStorageObject_get_SupportsExclusiveLock(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_SupportsSharedLock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVStorageObject_get_SupportsSharedLock(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, get_Locks)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVStorageObject_get_Locks(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLockList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVStorageObject, __construct)
{
	char *sURL;
	int sURL_len;
	zend_bool bHrefOnly;
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStorage, TElWebDAVClient_ce_ptr, &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVStorageObject_Create(SBGetObjectHandle(oStorage TSRMLS_CC), sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oStorage, TElWebDAVClient_ce_ptr, &sURL, &sURL_len, &bHrefOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVStorageObject_Create_1(SBGetObjectHandle(oStorage TSRMLS_CC), sURL, (int32_t)sURL_len, (int8_t)bHrefOnly, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVClient, string) or (TElWebDAVClient, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_ReadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_Lock, 0, 0, 3)
	ZEND_ARG_INFO(0, Scope)
	ZEND_ARG_INFO(0, Depth)
	ZEND_ARG_INFO(0, Timeout)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_Unlock, 0, 0, 0)
	ZEND_ARG_INFO(0, Idx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_GetIfHeader, 0, 0, 1)
	ZEND_ARG_INFO(0, WithETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_Storage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_ParentURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_FullURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_CreationDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_DisplayName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_ContentLanguage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_ContentLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_LastModified, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_ResourceType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_Collection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_IsAddressBook, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_BackLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_SupportsExclusiveLock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_SupportsSharedLock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject_get_Locks, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVStorageObject___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Storage, TElWebDAVClient, 1)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(0, HrefOnly)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVStorageObject_methods[] = {
	PHP_ME(TElWebDAVStorageObject, Clone, arginfo_TElWebDAVStorageObject_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, ReadFromXML, arginfo_TElWebDAVStorageObject_ReadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, Lock, arginfo_TElWebDAVStorageObject_Lock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, Unlock, arginfo_TElWebDAVStorageObject_Unlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, GetIfHeader, arginfo_TElWebDAVStorageObject_GetIfHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_Storage, arginfo_TElWebDAVStorageObject_get_Storage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_ParentURL, arginfo_TElWebDAVStorageObject_get_ParentURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_URL, arginfo_TElWebDAVStorageObject_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_FullURL, arginfo_TElWebDAVStorageObject_get_FullURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_CreationDate, arginfo_TElWebDAVStorageObject_get_CreationDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_DisplayName, arginfo_TElWebDAVStorageObject_get_DisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_ContentLanguage, arginfo_TElWebDAVStorageObject_get_ContentLanguage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_ContentLength, arginfo_TElWebDAVStorageObject_get_ContentLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_ContentType, arginfo_TElWebDAVStorageObject_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_ETag, arginfo_TElWebDAVStorageObject_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_LastModified, arginfo_TElWebDAVStorageObject_get_LastModified, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_ResourceType, arginfo_TElWebDAVStorageObject_get_ResourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_Collection, arginfo_TElWebDAVStorageObject_get_Collection, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_IsAddressBook, arginfo_TElWebDAVStorageObject_get_IsAddressBook, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_BackLink, arginfo_TElWebDAVStorageObject_get_BackLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_SupportsExclusiveLock, arginfo_TElWebDAVStorageObject_get_SupportsExclusiveLock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_SupportsSharedLock, arginfo_TElWebDAVStorageObject_get_SupportsSharedLock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, get_Locks, arginfo_TElWebDAVStorageObject_get_Locks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVStorageObject, __construct, arginfo_TElWebDAVStorageObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVStorageObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVStorageObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVStorageObject", TElWebDAVStorageObject_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDAVStorageObject_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavErrorResponse_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavErrorResponse, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavErrorResponse_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(538312149, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavErrorResponse, get_Status)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavErrorResponse_get_Status(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1169272579, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavErrorResponse, get_Error)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavErrorResponse_get_Error(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1928722256, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavErrorResponse, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavErrorResponse_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-706791856, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavErrorResponse, __construct)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavErrorResponse_Create(SBGetObjectHandle(oNode TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavErrorResponse_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavErrorResponse_get_Status, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavErrorResponse_get_Error, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavErrorResponse_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavErrorResponse___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavErrorResponse_methods[] = {
	PHP_ME(TElWebDavErrorResponse, get_URL, arginfo_TElWebDavErrorResponse_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavErrorResponse, get_Status, arginfo_TElWebDavErrorResponse_get_Status, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavErrorResponse, get_Error, arginfo_TElWebDavErrorResponse_get_Error, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavErrorResponse, get_Description, arginfo_TElWebDavErrorResponse_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavErrorResponse, __construct, arginfo_TElWebDavErrorResponse___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavErrorResponse(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavErrorResponse_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavErrorResponse", TElWebDavErrorResponse_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavErrorResponse_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavObjectList_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavObjectList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDavObjectList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavObjectList, get_Objects)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavObjectList_get_Objects(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavObjectList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavObjectList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavObjectList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavObjectList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavObjectList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavObjectList_get_Objects, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavObjectList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavObjectList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavObjectList_methods[] = {
	PHP_ME(TElWebDavObjectList, Clear, arginfo_TElWebDavObjectList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavObjectList, get_Objects, arginfo_TElWebDavObjectList_get_Objects, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavObjectList, get_Count, arginfo_TElWebDavObjectList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavObjectList, __construct, arginfo_TElWebDavObjectList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavObjectList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavObjectList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavObjectList", TElWebDavObjectList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavObjectList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavErrorList_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavErrorList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDavErrorList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavErrorList, get_Objects)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavErrorList_get_Objects(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavErrorResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavErrorList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavErrorList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavErrorList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavErrorList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavErrorList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavErrorList_get_Objects, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavErrorList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavErrorList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavErrorList_methods[] = {
	PHP_ME(TElWebDavErrorList, Clear, arginfo_TElWebDavErrorList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavErrorList, get_Objects, arginfo_TElWebDavErrorList_get_Objects, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavErrorList, get_Count, arginfo_TElWebDavErrorList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavErrorList, __construct, arginfo_TElWebDavErrorList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavErrorList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavErrorList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavErrorList", TElWebDavErrorList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavErrorList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SBWebDAVClient_TElWebDavPrincipal_ce_ptr = NULL;

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, ReadFromXML)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBWebDAVClient_TElWebDavPrincipal_ReadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, get_DisplayName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVClient_TElWebDavPrincipal_get_DisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1468758278, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVClient_TElWebDavPrincipal_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(750393574, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, get_PrincipalURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVClient_TElWebDavPrincipal_get_PrincipalURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(849938150, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, get_AlternateURISet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBWebDAVClient_TElWebDavPrincipal_get_AlternateURISet(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, get_GroupMemberSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBWebDAVClient_TElWebDavPrincipal_get_GroupMemberSet(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, get_GroupMembership)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBWebDAVClient_TElWebDavPrincipal_get_GroupMembership(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, get_AddressbookHomeSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBWebDAVClient_TElWebDavPrincipal_get_AddressbookHomeSet(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, get_AddressURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVClient_TElWebDavPrincipal_get_AddressURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(524150385, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, get_IsGroup)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBWebDAVClient_TElWebDavPrincipal_get_IsGroup(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVClient_TElWebDavPrincipal, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBWebDAVClient_TElWebDavPrincipal_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_ReadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_get_DisplayName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_get_PrincipalURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_get_AlternateURISet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_get_GroupMemberSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_get_GroupMembership, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_get_AddressbookHomeSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_get_AddressURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal_get_IsGroup, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVClient_TElWebDavPrincipal___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry SBWebDAVClient_TElWebDavPrincipal_methods[] = {
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, ReadFromXML, arginfo_SBWebDAVClient_TElWebDavPrincipal_ReadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, get_DisplayName, arginfo_SBWebDAVClient_TElWebDavPrincipal_get_DisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, get_URL, arginfo_SBWebDAVClient_TElWebDavPrincipal_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, get_PrincipalURL, arginfo_SBWebDAVClient_TElWebDavPrincipal_get_PrincipalURL, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, get_AlternateURISet, arginfo_SBWebDAVClient_TElWebDavPrincipal_get_AlternateURISet, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, get_GroupMemberSet, arginfo_SBWebDAVClient_TElWebDavPrincipal_get_GroupMemberSet, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, get_GroupMembership, arginfo_SBWebDAVClient_TElWebDavPrincipal_get_GroupMembership, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, get_AddressbookHomeSet, arginfo_SBWebDAVClient_TElWebDavPrincipal_get_AddressbookHomeSet, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, get_AddressURL, arginfo_SBWebDAVClient_TElWebDavPrincipal_get_AddressURL, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, get_IsGroup, arginfo_SBWebDAVClient_TElWebDavPrincipal_get_IsGroup, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVClient_TElWebDavPrincipal, __construct, arginfo_SBWebDAVClient_TElWebDavPrincipal___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBWebDAVClient_TElWebDavPrincipal(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBWebDAVClient_TElWebDavPrincipal_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "SBWebDAVClient_TElWebDavPrincipal", SBWebDAVClient_TElWebDavPrincipal_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	SBWebDAVClient_TElWebDavPrincipal_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavPrincipalList_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavPrincipalList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalList, get_Principals)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavPrincipalList_get_Principals(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, SBWebDAVClient_TElWebDavPrincipal_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavPrincipalList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalList_get_Principals, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavPrincipalList_methods[] = {
	PHP_ME(TElWebDavPrincipalList, Clear, arginfo_TElWebDavPrincipalList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalList, get_Principals, arginfo_TElWebDavPrincipalList_get_Principals, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalList, get_Count, arginfo_TElWebDavPrincipalList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalList, __construct, arginfo_TElWebDavPrincipalList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavPrincipalList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavPrincipalList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavPrincipalList", TElWebDavPrincipalList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavPrincipalList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCardDavSupportedAddressData_ce_ptr = NULL;

SB_PHP_METHOD(TElCardDavSupportedAddressData, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCardDavSupportedAddressData_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1908383408, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDavSupportedAddressData, get_Version)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCardDavSupportedAddressData_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-439106319, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDavSupportedAddressData, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCardDavSupportedAddressData_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDavSupportedAddressData_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDavSupportedAddressData_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDavSupportedAddressData___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCardDavSupportedAddressData_methods[] = {
	PHP_ME(TElCardDavSupportedAddressData, get_ContentType, arginfo_TElCardDavSupportedAddressData_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDavSupportedAddressData, get_Version, arginfo_TElCardDavSupportedAddressData_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDavSupportedAddressData, __construct, arginfo_TElCardDavSupportedAddressData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCardDavSupportedAddressData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCardDavSupportedAddressData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCardDavSupportedAddressData", TElCardDavSupportedAddressData_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCardDavSupportedAddressData_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCardDavAddressBookInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElCardDavAddressBookInfo, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCardDavAddressBookInfo_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1712660205, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDavAddressBookInfo, get_SupportedAddressDataCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCardDavAddressBookInfo_get_SupportedAddressDataCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDavAddressBookInfo, get_SupportedAddressData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCardDavAddressBookInfo_get_SupportedAddressData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCardDavSupportedAddressData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDavAddressBookInfo, get_MaxResourceSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCardDavAddressBookInfo_get_MaxResourceSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDavAddressBookInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCardDavAddressBookInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDavAddressBookInfo_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDavAddressBookInfo_get_SupportedAddressDataCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDavAddressBookInfo_get_SupportedAddressData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDavAddressBookInfo_get_MaxResourceSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDavAddressBookInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCardDavAddressBookInfo_methods[] = {
	PHP_ME(TElCardDavAddressBookInfo, get_Description, arginfo_TElCardDavAddressBookInfo_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDavAddressBookInfo, get_SupportedAddressDataCount, arginfo_TElCardDavAddressBookInfo_get_SupportedAddressDataCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDavAddressBookInfo, get_SupportedAddressData, arginfo_TElCardDavAddressBookInfo_get_SupportedAddressData, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDavAddressBookInfo, get_MaxResourceSize, arginfo_TElCardDavAddressBookInfo_get_MaxResourceSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDavAddressBookInfo, __construct, arginfo_TElCardDavAddressBookInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCardDavAddressBookInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCardDavAddressBookInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCardDavAddressBookInfo", TElCardDavAddressBookInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCardDavAddressBookInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCardDavReportContext_ce_ptr = NULL;

SB_PHP_METHOD(TElCardDavReportContext, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCardDavReportContext_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDavReportContext___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCardDavReportContext_methods[] = {
	PHP_ME(TElCardDavReportContext, __construct, arginfo_TElCardDavReportContext___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCardDavReportContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCardDavReportContext_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCardDavReportContext", TElCardDavReportContext_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCardDavReportContext_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBWebDAVClient, AddSlash)
{
	char *ss;
	int ss_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &ss, &ss_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVClient_AddSlash(ss, (int32_t)ss_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1122899655, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBWebDAVClient, HTTPSuccess)
{
	long l4Res;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Res) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBWebDAVClient_HTTPSuccess((int32_t)l4Res, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBWebDAVClient_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBWebDAVClient, SHTTPSWebDavClientNotSet, SB_SHTTPSWebDavClientNotSet, SB_SHTTPSWebDavClientNotSet);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVClient, SHTTPSWebDavClientPrecondFailed, SB_SHTTPSWebDavClientPrecondFailed, SB_SHTTPSWebDavClientPrecondFailed);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVClient, SHTTPSWebDavClientProtectedOrInheritedACE, SB_SHTTPSWebDavClientProtectedOrInheritedACE, SB_SHTTPSWebDavClientProtectedOrInheritedACE);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_CLIENT_ERROR_COLLECTION_EXPECTED, SB_WEBDAV_CLIENT_ERROR_COLLECTION_EXPECTED, SB_WEBDAV_CLIENT_ERROR_COLLECTION_EXPECTED);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_CLIENT_ERROR_DOCUMENT_EXPECTED, SB_WEBDAV_CLIENT_ERROR_DOCUMENT_EXPECTED, SB_WEBDAV_CLIENT_ERROR_DOCUMENT_EXPECTED);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_CLIENT_ERROR_HTTPSWEBDAVCLIENT, SB_WEBDAV_CLIENT_ERROR_HTTPSWEBDAVCLIENT, SB_WEBDAV_CLIENT_ERROR_HTTPSWEBDAVCLIENT);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_CLIENT_ERROR_STATUSCODE, SB_WEBDAV_CLIENT_ERROR_STATUSCODE, SB_WEBDAV_CLIENT_ERROR_STATUSCODE);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_CLIENT_ERROR_FILESIZE, SB_WEBDAV_CLIENT_ERROR_FILESIZE, SB_WEBDAV_CLIENT_ERROR_FILESIZE);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_CLIENT_ERROR_OFFSET_TOO_LARGE, SB_WEBDAV_CLIENT_ERROR_OFFSET_TOO_LARGE, SB_WEBDAV_CLIENT_ERROR_OFFSET_TOO_LARGE);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_CLIENT_ERROR_PRECONDITION_FAILED, SB_WEBDAV_CLIENT_ERROR_PRECONDITION_FAILED, SB_WEBDAV_CLIENT_ERROR_PRECONDITION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_CLIENT_ERROR_PROTECTED_OR_INHERITED_ACE, SB_WEBDAV_CLIENT_ERROR_PROTECTED_OR_INHERITED_ACE, SB_WEBDAV_CLIENT_ERROR_PROTECTED_OR_INHERITED_ACE);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_MULTI_STATUS_RESPONSE, SB_WEBDAV_MULTI_STATUS_RESPONSE, SB_WEBDAV_MULTI_STATUS_RESPONSE);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVClient, SB_WEBDAV_NO_CONTENT_RESPONSE, SB_WEBDAV_NO_CONTENT_RESPONSE, SB_WEBDAV_NO_CONTENT_RESPONSE);
}

void Register_SBWebDAVClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBWebDavClass", NULL);
	TSBWebDavClass_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBWebDavClass_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavClass_ce_ptr, "wdcOne", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavClass_ce_ptr, "wdcTwo", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavClass_ce_ptr, "wdcThree", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBWebDavClasses", NULL);
	TSBWebDavClasses_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBWebDavClasses_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavClasses_ce_ptr, "wdcOne", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavClasses_ce_ptr, "wdcTwo", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavClasses_ce_ptr, "wdcThree", 4)
}

void Register_SBWebDAVClient_Aliases(TSRMLS_D)
{
	if (NULL == TElWebDAVClient_ce_ptr)
		Register_TElWebDAVClient(TSRMLS_C);
	zend_register_class_alias("ElWebDAVClient", TElWebDAVClient_ce_ptr);
	if (NULL == TElWebDAVLockList_ce_ptr)
		Register_TElWebDAVLockList(TSRMLS_C);
	zend_register_class_alias("ElWebDAVLockList", TElWebDAVLockList_ce_ptr);
	if (NULL == TElWebDAVMultistatusResponse_ce_ptr)
		Register_TElWebDAVMultistatusResponse(TSRMLS_C);
	zend_register_class_alias("ElWebDAVMultistatusResponse", TElWebDAVMultistatusResponse_ce_ptr);
	if (NULL == TElWebDAVStorageObject_ce_ptr)
		Register_TElWebDAVStorageObject(TSRMLS_C);
	zend_register_class_alias("ElWebDAVStorageObject", TElWebDAVStorageObject_ce_ptr);
	if (NULL == TElWebDavErrorResponse_ce_ptr)
		Register_TElWebDavErrorResponse(TSRMLS_C);
	zend_register_class_alias("ElWebDAVErrorResponse", TElWebDavErrorResponse_ce_ptr);
	if (NULL == TElWebDavObjectList_ce_ptr)
		Register_TElWebDavObjectList(TSRMLS_C);
	zend_register_class_alias("ElWebDavObjectList", TElWebDavObjectList_ce_ptr);
	if (NULL == TElWebDavErrorList_ce_ptr)
		Register_TElWebDavErrorList(TSRMLS_C);
	zend_register_class_alias("ElWebDavErrorList", TElWebDavErrorList_ce_ptr);
}
