#include "sbwebdavserver.h"

zend_class_entry *TSBWebDavPropfindMode_ce_ptr = NULL;

zend_class_entry *TSBWebDavIfListType_ce_ptr = NULL;

zend_class_entry *TSBWebDavIfStateType_ce_ptr = NULL;

zend_class_entry *TSBWebDavFileOpenMode_ce_ptr = NULL;

void SB_CALLBACK TSBWebDavBeforeRequestEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle Params, int8_t * Accept, int32_t * StatusCode, char * pcReasonPhrase, int32_t * szReasonPhrase)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zParams;
	zval * zAccept;
	zval * zStatusCode;
	zval * zReasonPhrase;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zParams);
	SBInitObject(zParams, TElHTTPServerRequestParams_ce_ptr, Params TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);
	MAKE_STD_ZVAL(zStatusCode);
	ZVAL_LONG(zStatusCode, (long)*StatusCode);
	MAKE_STD_ZVAL(zReasonPhrase);
	ZVAL_STRINGL(zReasonPhrase, pcReasonPhrase, *szReasonPhrase, 1);

	params[0] = &zSender;
	params[1] = &zParams;
	params[2] = &zAccept;
	params[3] = &zStatusCode;
	params[4] = &zReasonPhrase;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zParams);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	*StatusCode = (int32_t)Z_LVAL_P(zStatusCode);
	zval_ptr_dtor(&zStatusCode);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zReasonPhrase), (int32_t)Z_STRLEN_P(zReasonPhrase)) TSRMLS_CC);
	zval_ptr_dtor(&zReasonPhrase);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavRequestEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerRequestParamsHandle Params, TMemoryStreamHandle Data)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zParams;
	zval * zData;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zParams);
	SBInitObject(zParams, TElHTTPServerRequestParams_ce_ptr, Params TSRMLS_CC);
	MAKE_STD_ZVAL(zData);
	SBInitObject(zData, TMemoryStream_ce_ptr, Data TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zParams;
	params[2] = &zData;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zParams);
	zval_ptr_dtor(&zData);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavResponseEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPServerResponseParamsHandle Params, TMemoryStreamHandle Data)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zParams;
	zval * zData;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zParams);
	SBInitObject(zParams, TElHTTPServerResponseParams_ce_ptr, Params TSRMLS_CC);
	MAKE_STD_ZVAL(zData);
	SBInitObject(zData, TMemoryStream_ce_ptr, Data TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zParams;
	params[2] = &zData;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zParams);
	zval_ptr_dtor(&zData);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavStatusCodeEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t StatusCode, TElHTTPServerRequestParamsHandle ReqParams, TElHTTPServerResponseParamsHandle RespParams)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zStatusCode;
	zval * zReqParams;
	zval * zRespParams;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStatusCode);
	ZVAL_LONG(zStatusCode, (long)StatusCode);
	MAKE_STD_ZVAL(zReqParams);
	SBInitObject(zReqParams, TElHTTPServerRequestParams_ce_ptr, ReqParams TSRMLS_CC);
	MAKE_STD_ZVAL(zRespParams);
	SBInitObject(zRespParams, TElHTTPServerResponseParams_ce_ptr, RespParams TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStatusCode;
	params[2] = &zReqParams;
	params[3] = &zRespParams;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStatusCode);
	zval_ptr_dtor(&zReqParams);
	zval_ptr_dtor(&zRespParams);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavBeforeDownloadEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcURL, int32_t * szURL, int8_t * Allow)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zURL;
	zval * zAllow;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, *szURL, 1);
	MAKE_STD_ZVAL(zAllow);
	ZVAL_BOOL(zAllow, (zend_bool)*Allow);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zAllow;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	SBCheckError(SBSetEventReturnStringA(2, Z_STRVAL_P(zURL), (int32_t)Z_STRLEN_P(zURL)) TSRMLS_CC);
	zval_ptr_dtor(&zURL);
	*Allow = (int8_t)Z_BVAL_P(zAllow);
	zval_ptr_dtor(&zAllow);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavBeforeUploadEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcURL, int32_t * szURL, int8_t * Allow)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zURL;
	zval * zAllow;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, *szURL, 1);
	MAKE_STD_ZVAL(zAllow);
	ZVAL_BOOL(zAllow, (zend_bool)*Allow);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zAllow;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	SBCheckError(SBSetEventReturnStringA(2, Z_STRVAL_P(zURL), (int32_t)Z_STRLEN_P(zURL)) TSRMLS_CC);
	zval_ptr_dtor(&zURL);
	*Allow = (int8_t)Z_BVAL_P(zAllow);
	zval_ptr_dtor(&zAllow);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavTransferFinishedEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavPropertyReadValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[7];
	zval * zSender;
	zval * zURL;
	zval * zNS;
	zval * zName;
	zval * zValue;
	zval * zElement;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zNS);
	ZVAL_STRINGL(zNS, pcNS, szNS, 1);
	MAKE_STD_ZVAL(zName);
	ZVAL_STRINGL(zName, pcName, szName, 1);
	MAKE_STD_ZVAL(zValue);
	ZVAL_STRINGL(zValue, pcValue, *szValue, 1);
	MAKE_STD_ZVAL(zElement);
	SBInitObject(zElement, TElXMLDOMElement_ce_ptr, Element TSRMLS_CC);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zNS;
	params[3] = &zName;
	params[4] = &zValue;
	params[5] = &zElement;
	params[6] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 7, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zNS);
	zval_ptr_dtor(&zName);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zValue), (int32_t)Z_STRLEN_P(zValue)) TSRMLS_CC);
	zval_ptr_dtor(&zValue);
	zval_ptr_dtor(&zElement);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavPropertyReadExValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element, TObjectHandle Param, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[8];
	zval * zSender;
	zval * zURL;
	zval * zNS;
	zval * zName;
	zval * zValue;
	zval * zElement;
	zval * zParam;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zNS);
	ZVAL_STRINGL(zNS, pcNS, szNS, 1);
	MAKE_STD_ZVAL(zName);
	ZVAL_STRINGL(zName, pcName, szName, 1);
	MAKE_STD_ZVAL(zValue);
	ZVAL_STRINGL(zValue, pcValue, *szValue, 1);
	MAKE_STD_ZVAL(zElement);
	SBInitObject(zElement, TElXMLDOMElement_ce_ptr, Element TSRMLS_CC);
	MAKE_STD_ZVAL(zParam);
	SBInitObject(zParam, TObject_ce_ptr, Param TSRMLS_CC);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zNS;
	params[3] = &zName;
	params[4] = &zValue;
	params[5] = &zElement;
	params[6] = &zParam;
	params[7] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 8, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zNS);
	zval_ptr_dtor(&zName);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zValue), (int32_t)Z_STRLEN_P(zValue)) TSRMLS_CC);
	zval_ptr_dtor(&zValue);
	zval_ptr_dtor(&zElement);
	zval_ptr_dtor(&zParam);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavPropertyAfterReadValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, TElXMLDOMElementHandle Element)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zURL;
	zval * zNS;
	zval * zName;
	zval * zValue;
	zval * zElement;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zNS);
	ZVAL_STRINGL(zNS, pcNS, szNS, 1);
	MAKE_STD_ZVAL(zName);
	ZVAL_STRINGL(zName, pcName, szName, 1);
	MAKE_STD_ZVAL(zValue);
	ZVAL_STRINGL(zValue, pcValue, *szValue, 1);
	MAKE_STD_ZVAL(zElement);
	SBInitObject(zElement, TElXMLDOMElement_ce_ptr, Element TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zNS;
	params[3] = &zName;
	params[4] = &zValue;
	params[5] = &zElement;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zNS);
	zval_ptr_dtor(&zName);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zValue), (int32_t)Z_STRLEN_P(zValue)) TSRMLS_CC);
	zval_ptr_dtor(&zValue);
	zval_ptr_dtor(&zElement);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavPropertyBeforeWriteValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, char * pcValue, int32_t * szValue, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zURL;
	zval * zNS;
	zval * zName;
	zval * zValue;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zNS);
	ZVAL_STRINGL(zNS, pcNS, szNS, 1);
	MAKE_STD_ZVAL(zName);
	ZVAL_STRINGL(zName, pcName, szName, 1);
	MAKE_STD_ZVAL(zValue);
	ZVAL_STRINGL(zValue, pcValue, *szValue, 1);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zNS;
	params[3] = &zName;
	params[4] = &zValue;
	params[5] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zNS);
	zval_ptr_dtor(&zName);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zValue), (int32_t)Z_STRLEN_P(zValue)) TSRMLS_CC);
	zval_ptr_dtor(&zValue);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavPropertyWriteValueEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, const char * pcValue, int32_t szValue, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zURL;
	zval * zNS;
	zval * zName;
	zval * zValue;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zNS);
	ZVAL_STRINGL(zNS, pcNS, szNS, 1);
	MAKE_STD_ZVAL(zName);
	ZVAL_STRINGL(zName, pcName, szName, 1);
	MAKE_STD_ZVAL(zValue);
	ZVAL_STRINGL(zValue, pcValue, szValue, 1);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zNS;
	params[3] = &zName;
	params[4] = &zValue;
	params[5] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zNS);
	zval_ptr_dtor(&zName);
	zval_ptr_dtor(&zValue);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavPropertyRemoveEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, const char * pcNS, int32_t szNS, const char * pcName, int32_t szName, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zURL;
	zval * zNS;
	zval * zName;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zNS);
	ZVAL_STRINGL(zNS, pcNS, szNS, 1);
	MAKE_STD_ZVAL(zName);
	ZVAL_STRINGL(zName, pcName, szName, 1);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zNS;
	params[3] = &zName;
	params[4] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zNS);
	zval_ptr_dtor(&zName);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavCheckIfAddressBookEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zURL;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavSetAsAddressBookEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, Principal TSRMLS_CC);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	params[3] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zPrincipal);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavCheckIfCalendarEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zURL;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavSetAsCalendarEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, Principal TSRMLS_CC);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	params[3] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zPrincipal);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavReadPrivilegesEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int32_t * Privileges)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	zval * zPrivileges;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, Principal TSRMLS_CC);
	MAKE_STD_ZVAL(zPrivileges);
	ZVAL_LONG(zPrivileges, (long)*Privileges);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	params[3] = &zPrivileges;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zPrincipal);
	*Privileges = (int32_t)Z_LVAL_P(zPrivileges);
	zval_ptr_dtor(&zPrivileges);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavReadOwnerEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle * Principal)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, *Principal TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	*Principal = SBGetObjectHandleCE(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zPrincipal TSRMLS_CC);
	zval_ptr_dtor(&zPrincipal);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavReadSupportedPrivilegesEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, int32_t * Privileges)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	zval * zPrivileges;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, Principal TSRMLS_CC);
	MAKE_STD_ZVAL(zPrivileges);
	ZVAL_LONG(zPrivileges, (long)*Privileges);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	params[3] = &zPrivileges;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zPrincipal);
	*Privileges = (int32_t)Z_LVAL_P(zPrivileges);
	zval_ptr_dtor(&zPrivileges);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavGetPrivilegeDescriptionEventRaw(void * _ObjectData, TObjectHandle Sender, int16_t Privilege, char * pcDescription, int32_t * szDescription, char * pcLanguage, int32_t * szLanguage)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zPrivilege;
	zval * zDescription;
	zval * zLanguage;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zPrivilege);
	ZVAL_LONG(zPrivilege, (long)Privilege);
	MAKE_STD_ZVAL(zDescription);
	ZVAL_STRINGL(zDescription, pcDescription, *szDescription, 1);
	MAKE_STD_ZVAL(zLanguage);
	ZVAL_STRINGL(zLanguage, pcLanguage, *szLanguage, 1);

	params[0] = &zSender;
	params[1] = &zPrivilege;
	params[2] = &zDescription;
	params[3] = &zLanguage;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zPrivilege);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zDescription), (int32_t)Z_STRLEN_P(zDescription)) TSRMLS_CC);
	zval_ptr_dtor(&zDescription);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zLanguage), (int32_t)Z_STRLEN_P(zLanguage)) TSRMLS_CC);
	zval_ptr_dtor(&zLanguage);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavGetACLRestrictionsEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TElWebDavACLRestrictionsHandle Restrictions)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	zval * zRestrictions;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, Principal TSRMLS_CC);
	MAKE_STD_ZVAL(zRestrictions);
	SBInitObject(zRestrictions, TElWebDavACLRestrictions_ce_ptr, Restrictions TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	params[3] = &zRestrictions;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zPrincipal);
	zval_ptr_dtor(&zRestrictions);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavGetACLEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TListHandle List, int8_t * OwnList)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	zval * zList;
	zval * zOwnList;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, Principal TSRMLS_CC);
	MAKE_STD_ZVAL(zList);
	SBInitObject(zList, TList_ce_ptr, List TSRMLS_CC);
	MAKE_STD_ZVAL(zOwnList);
	ZVAL_BOOL(zOwnList, (zend_bool)*OwnList);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	params[3] = &zList;
	params[4] = &zOwnList;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zPrincipal);
	zval_ptr_dtor(&zList);
	*OwnList = (int8_t)Z_BVAL_P(zOwnList);
	zval_ptr_dtor(&zOwnList);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWebDavSetACLEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TListHandle List, TSBWebDavACLErrorRaw * Error, int32_t * StatusCode)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	zval * zList;
	zval * zError;
	zval * zStatusCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, Principal TSRMLS_CC);
	MAKE_STD_ZVAL(zList);
	SBInitObject(zList, TList_ce_ptr, List TSRMLS_CC);
	MAKE_STD_ZVAL(zError);
	ZVAL_LONG(zError, (long)*Error);
	MAKE_STD_ZVAL(zStatusCode);
	ZVAL_LONG(zStatusCode, (long)*StatusCode);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	params[3] = &zList;
	params[4] = &zError;
	params[5] = &zStatusCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zPrincipal);
	zval_ptr_dtor(&zList);
	*Error = (TSBWebDavACLErrorRaw)Z_LVAL_P(zError);
	zval_ptr_dtor(&zError);
	*StatusCode = (int32_t)Z_LVAL_P(zStatusCode);
	zval_ptr_dtor(&zStatusCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

#ifdef SB_WINDOWS
void SB_CALLBACK TSBWebDavGetURLSetEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TStringListHandle List)
#else
void SB_CALLBACK TSBWebDavGetURLSetEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TElStringListHandle List)
#endif
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	zval * zList;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, Principal TSRMLS_CC);
	MAKE_STD_ZVAL(zList);
#ifdef SB_WINDOWS
	SBInitObject(zList, TStringList_ce_ptr, List TSRMLS_CC);
#else
	SBInitObject(zList, TElStringList_ce_ptr, List TSRMLS_CC);
#endif

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	params[3] = &zList;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zPrincipal);
	zval_ptr_dtor(&zList);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCheckUIDUniquenessEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURL, int32_t szURL, SBWebDAVServer_TElWebDavPrincipalHandle Principal, TElDirInfoPropertiesListHandle PropList, int8_t * Unique)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zURL;
	zval * zPrincipal;
	zval * zPropList;
	zval * zUnique;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURL);
	ZVAL_STRINGL(zURL, pcURL, szURL, 1);
	MAKE_STD_ZVAL(zPrincipal);
	SBInitObject(zPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, Principal TSRMLS_CC);
	MAKE_STD_ZVAL(zPropList);
	SBInitObject(zPropList, TElDirInfoPropertiesList_ce_ptr, PropList TSRMLS_CC);
	MAKE_STD_ZVAL(zUnique);
	ZVAL_BOOL(zUnique, (zend_bool)*Unique);

	params[0] = &zSender;
	params[1] = &zURL;
	params[2] = &zPrincipal;
	params[3] = &zPropList;
	params[4] = &zUnique;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURL);
	zval_ptr_dtor(&zPrincipal);
	zval_ptr_dtor(&zPropList);
	*Unique = (int8_t)Z_BVAL_P(zUnique);
	zval_ptr_dtor(&zUnique);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElWebDAVServer_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVServer, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, Close)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, AddProperty)
{
	zval *oProp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProp, TElWebDavProperty_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_AddProperty(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProp TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDavProperty)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, GetProperty)
{
	char *sName;
	char *sNS;
	int sName_len;
	int sNS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sNS, &sNS_len, &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_GetProperty(SBGetObjectHandle(getThis() TSRMLS_CC), sNS, (int32_t)sNS_len, sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavProperty_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, RemoveProperty)
{
	zval *oProp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProp, TElWebDavProperty_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_RemoveProperty(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProp TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDavProperty)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, CreateCollection)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_CreateCollection(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, CreateAddressBook)
{
	char *sDescription;
	char *sURL;
	int sDescription_len;
	int sURL_len;
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sURL, &sURL_len, &sDescription, &sDescription_len, &oOwner, SBWebDAVServer_TElWebDavPrincipal_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_CreateAddressBook(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sDescription, (int32_t)sDescription_len, SBGetObjectHandle(oOwner TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, SBWebDAVServer_TElWebDavPrincipal)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, CreateCalendar)
{
	char *sDescription;
	char *sURL;
	int sDescription_len;
	int sURL_len;
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sURL, &sURL_len, &sDescription, &sDescription_len, &oOwner, SBWebDAVServer_TElWebDavPrincipal_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_CreateCalendar(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sDescription, (int32_t)sDescription_len, SBGetObjectHandle(oOwner TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, SBWebDAVServer_TElWebDavPrincipal)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, PutVCard)
{
	char *sFileName;
	char *sURL;
	int sFileName_len;
	int sURL_len;
	zval *oStrm;
	zval *oVCard;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_PutVCard(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oVCard, TElVCard_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_PutVCard_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oVCard TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sURL, &sURL_len, &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_PutVCard_2(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream) or (string, TElVCard) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, AddCertTypeHandler)
{
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandler, TElSSLCertificateTypeHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_AddCertTypeHandler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSLCertificateTypeHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, RemoveCertTypeHandler)
{
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandler, TElSSLCertificateTypeHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_RemoveCertTypeHandler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSLCertificateTypeHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, GetCertTypeHandler)
{
	long fCertType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fCertType) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_GetCertTypeHandler(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSSLCertificateTypeRaw)fCertType, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSLCertificateTypeHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_MIMETypesMap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_MIMETypesMap(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_Properties)
{
	long l4Idx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Idx) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_Properties(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Idx, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavProperty_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_PropertiesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_PropertiesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_Control)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_Control(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSServer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_ACLOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_ACLOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVACLOptions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_CardDAVOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_CardDAVOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCardDAVOptions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_CalDAVOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_CalDAVOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCalDAVOptions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SSLMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_SSLMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_SSLMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_SSLMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SSLClientAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_SSLClientAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_SSLClientAuthentication)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_SSLClientAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SSLAuthenticationLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAuthenticationLevelRaw fOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_SSLAuthenticationLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_SSLAuthenticationLevel)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_SSLAuthenticationLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAuthenticationLevelRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SSLForceCertificateChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_SSLForceCertificateChain(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_SSLForceCertificateChain)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_SSLForceCertificateChain(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SSLSessionPool)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_SSLSessionPool(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSessionPool_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_SSLSessionPool)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSessionPool_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_SSLSessionPool(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSessionPool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_ClientCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_ClientCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SSLVersions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_SSLVersions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_SSLVersions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_SSLVersions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SSLExtensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_SSLExtensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElServerSSLExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SSLPeerExtensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_SSLPeerExtensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomSSLExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SSLSRPCredentialStore)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_SSLSRPCredentialStore(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSRPCredentialStore_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_SSLSRPCredentialStore)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSRPCredentialStore_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_SSLSRPCredentialStore(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSRPCredentialStore)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_GlobalLockList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_GlobalLockList(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVCustomLockList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_GlobalLockList)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElWebDAVCustomLockList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_GlobalLockList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVCustomLockList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_SendBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_SendBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_DefaultLockTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_DefaultLockTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_DefaultLockTimeout)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_DefaultLockTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_AllowInfinity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_AllowInfinity(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_AllowInfinity)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_AllowInfinity(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_PublishExclusiveLocks)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_PublishExclusiveLocks(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_PublishExclusiveLocks)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_PublishExclusiveLocks(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_PublishSharedLocks)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_PublishSharedLocks(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_PublishSharedLocks)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_PublishSharedLocks(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_ResponseContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVServer_get_ResponseContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-691375627, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_ResponseContentType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_ResponseContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_MicrosoftCompatible)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_MicrosoftCompatible(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_MicrosoftCompatible)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_MicrosoftCompatible(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_ServerName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVServer_get_ServerName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-609983871, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_ServerName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_ServerName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_UseWellKnownURIs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVServer_get_UseWellKnownURIs(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_UseWellKnownURIs)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVServer_set_UseWellKnownURIs(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnGetSrpDb)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBServerSrpDbNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnGetSrpDb(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnGetSrpDb)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnGetSrpDb(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBServerSrpDbNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBServerSrpDbNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnBeforeRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavBeforeRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnBeforeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnBeforeRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnBeforeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavBeforeRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavBeforeRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnResponse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavResponseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnResponse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnResponse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnResponse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavResponseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavResponseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnStatusCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavStatusCodeEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnStatusCode(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnStatusCode)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnStatusCode(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavStatusCodeEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavStatusCodeEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnBeforeUpload)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavBeforeUploadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnBeforeUpload(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnBeforeUpload)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnBeforeUpload(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavBeforeUploadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavBeforeUploadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnBeforeDownload)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavBeforeDownloadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnBeforeDownload(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnBeforeDownload)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnBeforeDownload(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavBeforeDownloadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavBeforeDownloadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnTransferFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavTransferFinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnTransferFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnTransferFinished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnTransferFinished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavTransferFinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavTransferFinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnGetUserPassword)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOnGetUserPasswordEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnGetUserPassword(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnGetUserPassword)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnGetUserPassword(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOnGetUserPasswordEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOnGetUserPasswordEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnReceive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnReceive)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnOpenConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOpenConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnOpenConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnOpenConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnOpenConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOpenConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOpenConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnCertificateValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnCertificateValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnCiphersNegotiated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnCiphersNegotiated)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnSSLError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnSSLError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnSSLError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnSSLError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnExtensionsReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBExtensionsReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnExtensionsReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnExtensionsReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnExtensionsReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBExtensionsReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBExtensionsReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnExtensionsPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBExtensionsPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnExtensionsPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnExtensionsPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnExtensionsPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBExtensionsPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBExtensionsPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBServerKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBServerKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBServerKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnRenegotiationStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRenegotiationStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnRenegotiationStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnRenegotiationStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnRenegotiationStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBRenegotiationStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBRenegotiationStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, get_OnCertificateURLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateURLsEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVServer_get_OnCertificateURLs(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, set_OnCertificateURLs)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVServer_set_OnCertificateURLs(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateURLsEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateURLsEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVServer, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVServer_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_AddProperty, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prop, TElWebDavProperty, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_GetProperty, 0, 0, 2)
	ZEND_ARG_INFO(0, NS)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_RemoveProperty, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prop, TElWebDavProperty, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_CreateCollection, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_CreateAddressBook, 0, 0, 3)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(0, Description)
	ZEND_ARG_OBJ_INFO(0, Owner, SBWebDAVServer_TElWebDavPrincipal, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_CreateCalendar, 0, 0, 3)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(0, Description)
	ZEND_ARG_OBJ_INFO(0, Owner, SBWebDAVServer_TElWebDavPrincipal, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_PutVCard, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_TYPE_INFO(0, Strm_or_VCard_or_FileName, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_AddCertTypeHandler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElSSLCertificateTypeHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_RemoveCertTypeHandler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElSSLCertificateTypeHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_GetCertTypeHandler, 0, 0, 1)
	ZEND_ARG_INFO(0, CertType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_MIMETypesMap, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_Properties, 0, 0, 1)
	ZEND_ARG_INFO(0, Idx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_PropertiesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_Control, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_ACLOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_CardDAVOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_CalDAVOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SSLMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_SSLMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SSLClientAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_SSLClientAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SSLAuthenticationLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_SSLAuthenticationLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SSLForceCertificateChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_SSLForceCertificateChain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SSLSessionPool, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_SSLSessionPool, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSessionPool, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_ClientCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_ClientCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SSLVersions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_SSLVersions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SSLExtensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SSLPeerExtensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SSLSRPCredentialStore, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_SSLSRPCredentialStore, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSRPCredentialStore, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_GlobalLockList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_GlobalLockList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElWebDAVCustomLockList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_SendBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_SendBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_DefaultLockTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_DefaultLockTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_AllowInfinity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_AllowInfinity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_PublishExclusiveLocks, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_PublishExclusiveLocks, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_PublishSharedLocks, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_PublishSharedLocks, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_ResponseContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_ResponseContentType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_MicrosoftCompatible, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_MicrosoftCompatible, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_ServerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_ServerName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_UseWellKnownURIs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_UseWellKnownURIs, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnGetSrpDb, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnGetSrpDb, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnBeforeRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnBeforeRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnResponse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnResponse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnStatusCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnStatusCode, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnBeforeUpload, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnBeforeUpload, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnBeforeDownload, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnBeforeDownload, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnTransferFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnTransferFinished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnGetUserPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnGetUserPassword, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnReceive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnReceive, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnOpenConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnOpenConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnCertificateValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnCertificateValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnCiphersNegotiated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnCiphersNegotiated, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnSSLError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnSSLError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnExtensionsReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnExtensionsReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnExtensionsPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnExtensionsPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnRenegotiationStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnRenegotiationStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_get_OnCertificateURLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer_set_OnCertificateURLs, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVServer_methods[] = {
	PHP_ME(TElWebDAVServer, Open, arginfo_TElWebDAVServer_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, DataAvailable, arginfo_TElWebDAVServer_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, Close, arginfo_TElWebDAVServer_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, AddProperty, arginfo_TElWebDAVServer_AddProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, GetProperty, arginfo_TElWebDAVServer_GetProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, RemoveProperty, arginfo_TElWebDAVServer_RemoveProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, CreateCollection, arginfo_TElWebDAVServer_CreateCollection, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, CreateAddressBook, arginfo_TElWebDAVServer_CreateAddressBook, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, CreateCalendar, arginfo_TElWebDAVServer_CreateCalendar, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, PutVCard, arginfo_TElWebDAVServer_PutVCard, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, AddCertTypeHandler, arginfo_TElWebDAVServer_AddCertTypeHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, RemoveCertTypeHandler, arginfo_TElWebDAVServer_RemoveCertTypeHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, GetCertTypeHandler, arginfo_TElWebDAVServer_GetCertTypeHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_MIMETypesMap, arginfo_TElWebDAVServer_get_MIMETypesMap, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_Properties, arginfo_TElWebDAVServer_get_Properties, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_PropertiesCount, arginfo_TElWebDAVServer_get_PropertiesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_Control, arginfo_TElWebDAVServer_get_Control, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_ACLOptions, arginfo_TElWebDAVServer_get_ACLOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_CardDAVOptions, arginfo_TElWebDAVServer_get_CardDAVOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_CalDAVOptions, arginfo_TElWebDAVServer_get_CalDAVOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_Active, arginfo_TElWebDAVServer_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SSLMode, arginfo_TElWebDAVServer_get_SSLMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_SSLMode, arginfo_TElWebDAVServer_set_SSLMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SSLClientAuthentication, arginfo_TElWebDAVServer_get_SSLClientAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_SSLClientAuthentication, arginfo_TElWebDAVServer_set_SSLClientAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SSLAuthenticationLevel, arginfo_TElWebDAVServer_get_SSLAuthenticationLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_SSLAuthenticationLevel, arginfo_TElWebDAVServer_set_SSLAuthenticationLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SSLForceCertificateChain, arginfo_TElWebDAVServer_get_SSLForceCertificateChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_SSLForceCertificateChain, arginfo_TElWebDAVServer_set_SSLForceCertificateChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_CertStorage, arginfo_TElWebDAVServer_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_CertStorage, arginfo_TElWebDAVServer_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SSLSessionPool, arginfo_TElWebDAVServer_get_SSLSessionPool, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_SSLSessionPool, arginfo_TElWebDAVServer_set_SSLSessionPool, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_ClientCertStorage, arginfo_TElWebDAVServer_get_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_ClientCertStorage, arginfo_TElWebDAVServer_set_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SSLVersions, arginfo_TElWebDAVServer_get_SSLVersions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_SSLVersions, arginfo_TElWebDAVServer_set_SSLVersions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SSLExtensions, arginfo_TElWebDAVServer_get_SSLExtensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SSLPeerExtensions, arginfo_TElWebDAVServer_get_SSLPeerExtensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SSLSRPCredentialStore, arginfo_TElWebDAVServer_get_SSLSRPCredentialStore, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_SSLSRPCredentialStore, arginfo_TElWebDAVServer_set_SSLSRPCredentialStore, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_FileSystemAdapter, arginfo_TElWebDAVServer_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_FileSystemAdapter, arginfo_TElWebDAVServer_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_GlobalLockList, arginfo_TElWebDAVServer_get_GlobalLockList, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_GlobalLockList, arginfo_TElWebDAVServer_set_GlobalLockList, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_SendBufferSize, arginfo_TElWebDAVServer_get_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_SendBufferSize, arginfo_TElWebDAVServer_set_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_DefaultLockTimeout, arginfo_TElWebDAVServer_get_DefaultLockTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_DefaultLockTimeout, arginfo_TElWebDAVServer_set_DefaultLockTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_AllowInfinity, arginfo_TElWebDAVServer_get_AllowInfinity, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_AllowInfinity, arginfo_TElWebDAVServer_set_AllowInfinity, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_PublishExclusiveLocks, arginfo_TElWebDAVServer_get_PublishExclusiveLocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_PublishExclusiveLocks, arginfo_TElWebDAVServer_set_PublishExclusiveLocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_PublishSharedLocks, arginfo_TElWebDAVServer_get_PublishSharedLocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_PublishSharedLocks, arginfo_TElWebDAVServer_set_PublishSharedLocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_ResponseContentType, arginfo_TElWebDAVServer_get_ResponseContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_ResponseContentType, arginfo_TElWebDAVServer_set_ResponseContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_MicrosoftCompatible, arginfo_TElWebDAVServer_get_MicrosoftCompatible, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_MicrosoftCompatible, arginfo_TElWebDAVServer_set_MicrosoftCompatible, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_ServerName, arginfo_TElWebDAVServer_get_ServerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_ServerName, arginfo_TElWebDAVServer_set_ServerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_UseWellKnownURIs, arginfo_TElWebDAVServer_get_UseWellKnownURIs, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_UseWellKnownURIs, arginfo_TElWebDAVServer_set_UseWellKnownURIs, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnGetSrpDb, arginfo_TElWebDAVServer_get_OnGetSrpDb, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnGetSrpDb, arginfo_TElWebDAVServer_set_OnGetSrpDb, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnBeforeRequest, arginfo_TElWebDAVServer_get_OnBeforeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnBeforeRequest, arginfo_TElWebDAVServer_set_OnBeforeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnRequest, arginfo_TElWebDAVServer_get_OnRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnRequest, arginfo_TElWebDAVServer_set_OnRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnResponse, arginfo_TElWebDAVServer_get_OnResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnResponse, arginfo_TElWebDAVServer_set_OnResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnStatusCode, arginfo_TElWebDAVServer_get_OnStatusCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnStatusCode, arginfo_TElWebDAVServer_set_OnStatusCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnBeforeUpload, arginfo_TElWebDAVServer_get_OnBeforeUpload, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnBeforeUpload, arginfo_TElWebDAVServer_set_OnBeforeUpload, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnBeforeDownload, arginfo_TElWebDAVServer_get_OnBeforeDownload, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnBeforeDownload, arginfo_TElWebDAVServer_set_OnBeforeDownload, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnTransferFinished, arginfo_TElWebDAVServer_get_OnTransferFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnTransferFinished, arginfo_TElWebDAVServer_set_OnTransferFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnGetUserPassword, arginfo_TElWebDAVServer_get_OnGetUserPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnGetUserPassword, arginfo_TElWebDAVServer_set_OnGetUserPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnSend, arginfo_TElWebDAVServer_get_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnSend, arginfo_TElWebDAVServer_set_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnReceive, arginfo_TElWebDAVServer_get_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnReceive, arginfo_TElWebDAVServer_set_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnOpenConnection, arginfo_TElWebDAVServer_get_OnOpenConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnOpenConnection, arginfo_TElWebDAVServer_set_OnOpenConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnCertificateValidate, arginfo_TElWebDAVServer_get_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnCertificateValidate, arginfo_TElWebDAVServer_set_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnCiphersNegotiated, arginfo_TElWebDAVServer_get_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnCiphersNegotiated, arginfo_TElWebDAVServer_set_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnSSLError, arginfo_TElWebDAVServer_get_OnSSLError, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnSSLError, arginfo_TElWebDAVServer_set_OnSSLError, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnExtensionsReceived, arginfo_TElWebDAVServer_get_OnExtensionsReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnExtensionsReceived, arginfo_TElWebDAVServer_set_OnExtensionsReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnExtensionsPrepared, arginfo_TElWebDAVServer_get_OnExtensionsPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnExtensionsPrepared, arginfo_TElWebDAVServer_set_OnExtensionsPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnKeyNeeded, arginfo_TElWebDAVServer_get_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnKeyNeeded, arginfo_TElWebDAVServer_set_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnCloseConnection, arginfo_TElWebDAVServer_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnCloseConnection, arginfo_TElWebDAVServer_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnRenegotiationStart, arginfo_TElWebDAVServer_get_OnRenegotiationStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnRenegotiationStart, arginfo_TElWebDAVServer_set_OnRenegotiationStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, get_OnCertificateURLs, arginfo_TElWebDAVServer_get_OnCertificateURLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, set_OnCertificateURLs, arginfo_TElWebDAVServer_set_OnCertificateURLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVServer, __construct, arginfo_TElWebDAVServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVServer", TElWebDAVServer_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElWebDAVServer_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SBWebDAVServer_TElWebDavPrincipal_ce_ptr = NULL;

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, MemberOf)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_MemberOf(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, AddToGroup)
{
	zval *oPrincipal;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_AddToGroup(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPrincipal TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(SBWebDAVServer_TElWebDavPrincipal)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVServer_TElWebDavPrincipal_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1965314985, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, set_Username)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_set_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, get_DisplayName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVServer_TElWebDavPrincipal_get_DisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1763303380, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, set_DisplayName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_set_DisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVServer_TElWebDavPrincipal_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1475568091, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, get_AlternateURISet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_get_AlternateURISet(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, get_Groups)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_get_Groups(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, get_IsGroup)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_get_IsGroup(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, set_IsGroup)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_set_IsGroup(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVServer_TElWebDavPrincipal_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2132166047, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWebDAVServer_TElWebDavPrincipal_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1237418748, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, set_ETag)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_set_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(SBWebDAVServer_TElWebDavPrincipal, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBWebDAVServer_TElWebDavPrincipal_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_MemberOf, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_AddToGroup, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Principal, SBWebDAVServer_TElWebDavPrincipal, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_set_Username, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_get_DisplayName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_set_DisplayName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_get_AlternateURISet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_get_Groups, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_get_IsGroup, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_set_IsGroup, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal_set_ETag, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_SBWebDAVServer_TElWebDavPrincipal___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry SBWebDAVServer_TElWebDavPrincipal_methods[] = {
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, MemberOf, arginfo_SBWebDAVServer_TElWebDavPrincipal_MemberOf, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, AddToGroup, arginfo_SBWebDAVServer_TElWebDavPrincipal_AddToGroup, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, get_Username, arginfo_SBWebDAVServer_TElWebDavPrincipal_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, set_Username, arginfo_SBWebDAVServer_TElWebDavPrincipal_set_Username, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, get_DisplayName, arginfo_SBWebDAVServer_TElWebDavPrincipal_get_DisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, set_DisplayName, arginfo_SBWebDAVServer_TElWebDavPrincipal_set_DisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, get_URL, arginfo_SBWebDAVServer_TElWebDavPrincipal_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, set_URL, arginfo_SBWebDAVServer_TElWebDavPrincipal_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, get_AlternateURISet, arginfo_SBWebDAVServer_TElWebDavPrincipal_get_AlternateURISet, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, get_Groups, arginfo_SBWebDAVServer_TElWebDavPrincipal_get_Groups, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, get_IsGroup, arginfo_SBWebDAVServer_TElWebDavPrincipal_get_IsGroup, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, set_IsGroup, arginfo_SBWebDAVServer_TElWebDavPrincipal_set_IsGroup, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, get_Address, arginfo_SBWebDAVServer_TElWebDavPrincipal_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, set_Address, arginfo_SBWebDAVServer_TElWebDavPrincipal_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, get_ETag, arginfo_SBWebDAVServer_TElWebDavPrincipal_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, set_ETag, arginfo_SBWebDAVServer_TElWebDavPrincipal_set_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(SBWebDAVServer_TElWebDavPrincipal, __construct, arginfo_SBWebDAVServer_TElWebDavPrincipal___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBWebDAVServer_TElWebDavPrincipal(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBWebDAVServer_TElWebDavPrincipal_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "SBWebDAVServer_TElWebDavPrincipal", SBWebDAVServer_TElWebDavPrincipal_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	SBWebDAVServer_TElWebDavPrincipal_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavInMemoryPrincipal_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavInMemoryPrincipal, get_AddressBookHomeSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavInMemoryPrincipal_get_AddressBookHomeSet(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavInMemoryPrincipal, get_CalendarHomeSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavInMemoryPrincipal_get_CalendarHomeSet(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavInMemoryPrincipal, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavInMemoryPrincipal_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavInMemoryPrincipal_get_AddressBookHomeSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavInMemoryPrincipal_get_CalendarHomeSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavInMemoryPrincipal___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavInMemoryPrincipal_methods[] = {
	PHP_ME(TElWebDavInMemoryPrincipal, get_AddressBookHomeSet, arginfo_TElWebDavInMemoryPrincipal_get_AddressBookHomeSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavInMemoryPrincipal, get_CalendarHomeSet, arginfo_TElWebDavInMemoryPrincipal_get_CalendarHomeSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavInMemoryPrincipal, __construct, arginfo_TElWebDavInMemoryPrincipal___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavInMemoryPrincipal(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavInMemoryPrincipal_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavInMemoryPrincipal", TElWebDavInMemoryPrincipal_methods);
	if (NULL == SBWebDAVServer_TElWebDavPrincipal_ce_ptr)
		Register_SBWebDAVServer_TElWebDavPrincipal(TSRMLS_C);
	TElWebDavInMemoryPrincipal_ce_ptr = zend_register_internal_class_ex(&ce, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavPrincipalBackend_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavPrincipalBackend, BeginRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalBackend_BeginRead(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, BeginWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalBackend_BeginWrite(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, Done)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalBackend_Done(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, AddPrincipal)
{
	zval *oPrincipal;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_AddPrincipal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPrincipal TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(SBWebDAVServer_TElWebDavPrincipal)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, RemovePrincipal)
{
	char *sURL;
	int sURL_len;
	zval *oPrincipal;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_RemovePrincipal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPrincipal TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_RemovePrincipal_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(SBWebDAVServer_TElWebDavPrincipal) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, PrincipalExists)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_PrincipalExists(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, FindPrincipalByURL)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavPrincipalBackend_FindPrincipalByURL(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, FindPrincipalByName)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavPrincipalBackend_FindPrincipalByName(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, GetGroupMemberSet)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_GetGroupMemberSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, GetGroupMembership)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_GetGroupMembership(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, GetPrincipalCollectionSet)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_GetPrincipalCollectionSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, GetPrincipalAddressBookHomeSet)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_GetPrincipalAddressBookHomeSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, GetPrincipalCalendarHomeSet)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_GetPrincipalCalendarHomeSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, EnumPrincipals)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_EnumPrincipals(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, CollectionExists)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalBackend_CollectionExists(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalBackend, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavPrincipalBackend_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_BeginRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_BeginWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_Done, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_AddPrincipal, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Principal, SBWebDAVServer_TElWebDavPrincipal, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_RemovePrincipal, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Principal_or_URL, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_PrincipalExists, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_FindPrincipalByURL, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_FindPrincipalByName, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_GetGroupMemberSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_GetGroupMembership, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_GetPrincipalCollectionSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_GetPrincipalAddressBookHomeSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_GetPrincipalCalendarHomeSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_EnumPrincipals, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend_CollectionExists, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalBackend___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavPrincipalBackend_methods[] = {
	PHP_ME(TElWebDavPrincipalBackend, BeginRead, arginfo_TElWebDavPrincipalBackend_BeginRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, BeginWrite, arginfo_TElWebDavPrincipalBackend_BeginWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, Done, arginfo_TElWebDavPrincipalBackend_Done, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, AddPrincipal, arginfo_TElWebDavPrincipalBackend_AddPrincipal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, RemovePrincipal, arginfo_TElWebDavPrincipalBackend_RemovePrincipal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, PrincipalExists, arginfo_TElWebDavPrincipalBackend_PrincipalExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, FindPrincipalByURL, arginfo_TElWebDavPrincipalBackend_FindPrincipalByURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, FindPrincipalByName, arginfo_TElWebDavPrincipalBackend_FindPrincipalByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, GetGroupMemberSet, arginfo_TElWebDavPrincipalBackend_GetGroupMemberSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, GetGroupMembership, arginfo_TElWebDavPrincipalBackend_GetGroupMembership, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, GetPrincipalCollectionSet, arginfo_TElWebDavPrincipalBackend_GetPrincipalCollectionSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, GetPrincipalAddressBookHomeSet, arginfo_TElWebDavPrincipalBackend_GetPrincipalAddressBookHomeSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, GetPrincipalCalendarHomeSet, arginfo_TElWebDavPrincipalBackend_GetPrincipalCalendarHomeSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, EnumPrincipals, arginfo_TElWebDavPrincipalBackend_EnumPrincipals, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, CollectionExists, arginfo_TElWebDavPrincipalBackend_CollectionExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalBackend, __construct, arginfo_TElWebDavPrincipalBackend___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavPrincipalBackend(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavPrincipalBackend_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavPrincipalBackend", TElWebDavPrincipalBackend_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavPrincipalBackend_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavPrincipalMemoryBackend_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, BeginRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalMemoryBackend_BeginRead(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, BeginWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalMemoryBackend_BeginWrite(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, Done)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalMemoryBackend_Done(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, AddPrincipal)
{
	zval *oPrincipal;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_AddPrincipal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPrincipal TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(SBWebDAVServer_TElWebDavPrincipal)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, RemovePrincipal)
{
	char *sURL;
	int sURL_len;
	zval *oPrincipal;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPrincipal, SBWebDAVServer_TElWebDavPrincipal_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_RemovePrincipal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPrincipal TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_RemovePrincipal_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(SBWebDAVServer_TElWebDavPrincipal) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, PrincipalExists)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_PrincipalExists(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, FindPrincipalByURL)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavPrincipalMemoryBackend_FindPrincipalByURL(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, FindPrincipalByName)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavPrincipalMemoryBackend_FindPrincipalByName(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, SBWebDAVServer_TElWebDavPrincipal_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, GetGroupMemberSet)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_GetGroupMemberSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, GetGroupMembership)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_GetGroupMembership(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, GetPrincipalCollectionSet)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_GetPrincipalCollectionSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, GetPrincipalAddressBookHomeSet)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_GetPrincipalAddressBookHomeSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, GetPrincipalCalendarHomeSet)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_GetPrincipalCalendarHomeSet(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, EnumPrincipals)
{
	char *sURL;
	int sURL_len;
	zval *oList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavPrincipalMemoryBackend_EnumPrincipals(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oList TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, get_CardDAVPrefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavPrincipalMemoryBackend_get_CardDAVPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(869611482, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, set_CardDAVPrefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalMemoryBackend_set_CardDAVPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, get_CalDAVPrefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavPrincipalMemoryBackend_get_CalDAVPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-924986638, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, set_CalDAVPrefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalMemoryBackend_set_CalDAVPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, get_PrincipalBaseURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavPrincipalMemoryBackend_get_PrincipalBaseURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(803674432, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, set_PrincipalBaseURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalMemoryBackend_set_PrincipalBaseURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, get_GroupBaseURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavPrincipalMemoryBackend_get_GroupBaseURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1026126359, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, set_GroupBaseURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalMemoryBackend_set_GroupBaseURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, get_ContactFileName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavPrincipalMemoryBackend_get_ContactFileName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1175130762, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, set_ContactFileName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavPrincipalMemoryBackend_set_ContactFileName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavPrincipalMemoryBackend, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavPrincipalMemoryBackend_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_BeginRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_BeginWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_Done, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_AddPrincipal, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Principal, SBWebDAVServer_TElWebDavPrincipal, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_RemovePrincipal, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Principal_or_URL, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_PrincipalExists, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_FindPrincipalByURL, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_FindPrincipalByName, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_GetGroupMemberSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_GetGroupMembership, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_GetPrincipalCollectionSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_GetPrincipalAddressBookHomeSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_GetPrincipalCalendarHomeSet, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_EnumPrincipals, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, List, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, List, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_get_CardDAVPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_set_CardDAVPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_get_CalDAVPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_set_CalDAVPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_get_PrincipalBaseURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_set_PrincipalBaseURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_get_GroupBaseURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_set_GroupBaseURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_get_ContactFileName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend_set_ContactFileName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavPrincipalMemoryBackend___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavPrincipalMemoryBackend_methods[] = {
	PHP_ME(TElWebDavPrincipalMemoryBackend, BeginRead, arginfo_TElWebDavPrincipalMemoryBackend_BeginRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, BeginWrite, arginfo_TElWebDavPrincipalMemoryBackend_BeginWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, Done, arginfo_TElWebDavPrincipalMemoryBackend_Done, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, AddPrincipal, arginfo_TElWebDavPrincipalMemoryBackend_AddPrincipal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, RemovePrincipal, arginfo_TElWebDavPrincipalMemoryBackend_RemovePrincipal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, PrincipalExists, arginfo_TElWebDavPrincipalMemoryBackend_PrincipalExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, FindPrincipalByURL, arginfo_TElWebDavPrincipalMemoryBackend_FindPrincipalByURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, FindPrincipalByName, arginfo_TElWebDavPrincipalMemoryBackend_FindPrincipalByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, GetGroupMemberSet, arginfo_TElWebDavPrincipalMemoryBackend_GetGroupMemberSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, GetGroupMembership, arginfo_TElWebDavPrincipalMemoryBackend_GetGroupMembership, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, GetPrincipalCollectionSet, arginfo_TElWebDavPrincipalMemoryBackend_GetPrincipalCollectionSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, GetPrincipalAddressBookHomeSet, arginfo_TElWebDavPrincipalMemoryBackend_GetPrincipalAddressBookHomeSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, GetPrincipalCalendarHomeSet, arginfo_TElWebDavPrincipalMemoryBackend_GetPrincipalCalendarHomeSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, EnumPrincipals, arginfo_TElWebDavPrincipalMemoryBackend_EnumPrincipals, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, get_CardDAVPrefix, arginfo_TElWebDavPrincipalMemoryBackend_get_CardDAVPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, set_CardDAVPrefix, arginfo_TElWebDavPrincipalMemoryBackend_set_CardDAVPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, get_CalDAVPrefix, arginfo_TElWebDavPrincipalMemoryBackend_get_CalDAVPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, set_CalDAVPrefix, arginfo_TElWebDavPrincipalMemoryBackend_set_CalDAVPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, get_PrincipalBaseURL, arginfo_TElWebDavPrincipalMemoryBackend_get_PrincipalBaseURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, set_PrincipalBaseURL, arginfo_TElWebDavPrincipalMemoryBackend_set_PrincipalBaseURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, get_GroupBaseURL, arginfo_TElWebDavPrincipalMemoryBackend_get_GroupBaseURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, set_GroupBaseURL, arginfo_TElWebDavPrincipalMemoryBackend_set_GroupBaseURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, get_ContactFileName, arginfo_TElWebDavPrincipalMemoryBackend_get_ContactFileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, set_ContactFileName, arginfo_TElWebDavPrincipalMemoryBackend_set_ContactFileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavPrincipalMemoryBackend, __construct, arginfo_TElWebDavPrincipalMemoryBackend___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavPrincipalMemoryBackend(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavPrincipalMemoryBackend_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavPrincipalMemoryBackend", TElWebDavPrincipalMemoryBackend_methods);
	if (NULL == TElWebDavPrincipalBackend_ce_ptr)
		Register_TElWebDavPrincipalBackend(TSRMLS_C);
	TElWebDavPrincipalMemoryBackend_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavPrincipalBackend_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCalDavTextMatchFilter_ce_ptr = NULL;

SB_PHP_METHOD(TElCalDavTextMatchFilter, __construct)
{
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParent, TElWebDavFilter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDavTextMatchFilter_Create(SBGetObjectHandle(oParent TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDavFilter)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavTextMatchFilter___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Parent, TElWebDavFilter, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCalDavTextMatchFilter_methods[] = {
	PHP_ME(TElCalDavTextMatchFilter, __construct, arginfo_TElCalDavTextMatchFilter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCalDavTextMatchFilter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCalDavTextMatchFilter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCalDavTextMatchFilter", TElCalDavTextMatchFilter_methods);
	if (NULL == TElWebDavTextMatchFilter_ce_ptr)
		Register_TElWebDavTextMatchFilter(TSRMLS_C);
	TElCalDavTextMatchFilter_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavTextMatchFilter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCalDavParamFilter_ce_ptr = NULL;

SB_PHP_METHOD(TElCalDavParamFilter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCalDavParamFilter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDavParamFilter, get_IsNotDefined)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCalDavParamFilter_get_IsNotDefined(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDavParamFilter, get_TextMatch)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDavParamFilter_get_TextMatch(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCalDavTextMatchFilter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDavParamFilter, __construct)
{
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParent, TElWebDavFilter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDavParamFilter_Create(SBGetObjectHandle(oParent TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDavFilter)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavParamFilter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavParamFilter_get_IsNotDefined, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavParamFilter_get_TextMatch, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavParamFilter___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Parent, TElWebDavFilter, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCalDavParamFilter_methods[] = {
	PHP_ME(TElCalDavParamFilter, LoadFromXML, arginfo_TElCalDavParamFilter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDavParamFilter, get_IsNotDefined, arginfo_TElCalDavParamFilter_get_IsNotDefined, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDavParamFilter, get_TextMatch, arginfo_TElCalDavParamFilter_get_TextMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDavParamFilter, __construct, arginfo_TElCalDavParamFilter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCalDavParamFilter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCalDavParamFilter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCalDavParamFilter", TElCalDavParamFilter_methods);
	if (NULL == TElWebDavFilter_ce_ptr)
		Register_TElWebDavFilter(TSRMLS_C);
	TElCalDavParamFilter_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavFilter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavTimeRangeBase_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavTimeRangeBase, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavTimeRangeBase_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavTimeRangeBase, get_Start)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElWebDavTimeRangeBase_get_Start(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavTimeRangeBase, get_End_)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElWebDavTimeRangeBase_get_End_(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavTimeRangeBase, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavTimeRangeBase_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavTimeRangeBase_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavTimeRangeBase_get_Start, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavTimeRangeBase_get_End_, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavTimeRangeBase___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavTimeRangeBase_methods[] = {
	PHP_ME(TElWebDavTimeRangeBase, LoadFromXML, arginfo_TElWebDavTimeRangeBase_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavTimeRangeBase, get_Start, arginfo_TElWebDavTimeRangeBase_get_Start, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavTimeRangeBase, get_End_, arginfo_TElWebDavTimeRangeBase_get_End_, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavTimeRangeBase, __construct, arginfo_TElWebDavTimeRangeBase___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavTimeRangeBase(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavTimeRangeBase_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavTimeRangeBase", TElWebDavTimeRangeBase_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavTimeRangeBase_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavTimeRange_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavTimeRange, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavTimeRange_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavTimeRange___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavTimeRange_methods[] = {
	PHP_ME(TElWebDavTimeRange, __construct, arginfo_TElWebDavTimeRange___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavTimeRange(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavTimeRange_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavTimeRange", TElWebDavTimeRange_methods);
	if (NULL == TElWebDavTimeRangeBase_ce_ptr)
		Register_TElWebDavTimeRangeBase(TSRMLS_C);
	TElWebDavTimeRange_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavTimeRangeBase_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCalDavPropFilter_ce_ptr = NULL;

SB_PHP_METHOD(TElCalDavPropFilter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCalDavPropFilter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDavPropFilter, get_SubFilters)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDavPropFilter_get_SubFilters(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDavPropFilter, get_IsNotDefined)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCalDavPropFilter_get_IsNotDefined(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDavPropFilter, get_TimeRange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDavPropFilter_get_TimeRange(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavTimeRange_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDavPropFilter, get_TextMatch)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDavPropFilter_get_TextMatch(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCalDavTextMatchFilter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDavPropFilter, __construct)
{
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParent, TElWebDavFilter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDavPropFilter_Create(SBGetObjectHandle(oParent TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDavFilter)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavPropFilter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavPropFilter_get_SubFilters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavPropFilter_get_IsNotDefined, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavPropFilter_get_TimeRange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavPropFilter_get_TextMatch, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDavPropFilter___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Parent, TElWebDavFilter, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCalDavPropFilter_methods[] = {
	PHP_ME(TElCalDavPropFilter, LoadFromXML, arginfo_TElCalDavPropFilter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDavPropFilter, get_SubFilters, arginfo_TElCalDavPropFilter_get_SubFilters, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDavPropFilter, get_IsNotDefined, arginfo_TElCalDavPropFilter_get_IsNotDefined, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDavPropFilter, get_TimeRange, arginfo_TElCalDavPropFilter_get_TimeRange, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDavPropFilter, get_TextMatch, arginfo_TElCalDavPropFilter_get_TextMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDavPropFilter, __construct, arginfo_TElCalDavPropFilter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCalDavPropFilter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCalDavPropFilter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCalDavPropFilter", TElCalDavPropFilter_methods);
	if (NULL == TElWebDavFilter_ce_ptr)
		Register_TElWebDavFilter(TSRMLS_C);
	TElCalDavPropFilter_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavFilter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCalDAVCompFilter_ce_ptr = NULL;

SB_PHP_METHOD(TElCalDAVCompFilter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCalDAVCompFilter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVCompFilter, get_SubFilters)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDAVCompFilter_get_SubFilters(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVCompFilter, get_IsNotDefined)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCalDAVCompFilter_get_IsNotDefined(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVCompFilter, get_TimeRange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDAVCompFilter_get_TimeRange(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavTimeRange_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVCompFilter, __construct)
{
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParent, TElWebDavFilter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDAVCompFilter_Create(SBGetObjectHandle(oParent TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDavFilter)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVCompFilter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVCompFilter_get_SubFilters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVCompFilter_get_IsNotDefined, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVCompFilter_get_TimeRange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVCompFilter___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Parent, TElWebDavFilter, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCalDAVCompFilter_methods[] = {
	PHP_ME(TElCalDAVCompFilter, LoadFromXML, arginfo_TElCalDAVCompFilter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVCompFilter, get_SubFilters, arginfo_TElCalDAVCompFilter_get_SubFilters, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVCompFilter, get_IsNotDefined, arginfo_TElCalDAVCompFilter_get_IsNotDefined, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVCompFilter, get_TimeRange, arginfo_TElCalDAVCompFilter_get_TimeRange, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVCompFilter, __construct, arginfo_TElCalDAVCompFilter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCalDAVCompFilter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCalDAVCompFilter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCalDAVCompFilter", TElCalDAVCompFilter_methods);
	if (NULL == TElWebDavFilter_ce_ptr)
		Register_TElWebDavFilter(TSRMLS_C);
	TElCalDAVCompFilter_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavFilter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavExtendedRequest_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavExtendedRequest, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavExtendedRequest_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavExtendedRequest, get_ReportName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavExtendedRequest_get_ReportName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-527613685, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavExtendedRequest, set_ReportName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavExtendedRequest_set_ReportName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavExtendedRequest, get_Hrefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavExtendedRequest_get_Hrefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavExtendedRequest, get_AllProp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavExtendedRequest_get_AllProp(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavExtendedRequest, set_AllProp)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDavExtendedRequest_set_AllProp(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavExtendedRequest, get_EvaluationResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavExtendedRequest_get_EvaluationResult(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavExtendedRequest, set_EvaluationResult)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDavExtendedRequest_set_EvaluationResult(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavExtendedRequest, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavExtendedRequest_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExtendedRequest_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExtendedRequest_get_ReportName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExtendedRequest_set_ReportName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExtendedRequest_get_Hrefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExtendedRequest_get_AllProp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExtendedRequest_set_AllProp, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExtendedRequest_get_EvaluationResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExtendedRequest_set_EvaluationResult, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExtendedRequest___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavExtendedRequest_methods[] = {
	PHP_ME(TElWebDavExtendedRequest, LoadFromXML, arginfo_TElWebDavExtendedRequest_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavExtendedRequest, get_ReportName, arginfo_TElWebDavExtendedRequest_get_ReportName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavExtendedRequest, set_ReportName, arginfo_TElWebDavExtendedRequest_set_ReportName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavExtendedRequest, get_Hrefs, arginfo_TElWebDavExtendedRequest_get_Hrefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavExtendedRequest, get_AllProp, arginfo_TElWebDavExtendedRequest_get_AllProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavExtendedRequest, set_AllProp, arginfo_TElWebDavExtendedRequest_set_AllProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavExtendedRequest, get_EvaluationResult, arginfo_TElWebDavExtendedRequest_get_EvaluationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavExtendedRequest, set_EvaluationResult, arginfo_TElWebDavExtendedRequest_set_EvaluationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavExtendedRequest, __construct, arginfo_TElWebDavExtendedRequest___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavExtendedRequest(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavExtendedRequest_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavExtendedRequest", TElWebDavExtendedRequest_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavExtendedRequest_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavAddressBookRequest_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavAddressBookRequest, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavAddressBookRequest_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAddressBookRequest, get_Test)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavFilterTestRaw fOutResultRaw = 0;
		SBCheckError(TElWebDavAddressBookRequest_get_Test(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAddressBookRequest, set_Test)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElWebDavAddressBookRequest_set_Test(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBWebDavFilterTestRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAddressBookRequest, get_Filters)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavAddressBookRequest_get_Filters(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAddressBookRequest, get_Limit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavAddressBookRequest_get_Limit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAddressBookRequest, set_Limit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElWebDavAddressBookRequest_set_Limit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAddressBookRequest, get_Names)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavAddressBookRequest_get_Names(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAddressBookRequest, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavAddressBookRequest_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAddressBookRequest_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAddressBookRequest_get_Test, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAddressBookRequest_set_Test, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAddressBookRequest_get_Filters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAddressBookRequest_get_Limit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAddressBookRequest_set_Limit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAddressBookRequest_get_Names, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAddressBookRequest___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavAddressBookRequest_methods[] = {
	PHP_ME(TElWebDavAddressBookRequest, LoadFromXML, arginfo_TElWebDavAddressBookRequest_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAddressBookRequest, get_Test, arginfo_TElWebDavAddressBookRequest_get_Test, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAddressBookRequest, set_Test, arginfo_TElWebDavAddressBookRequest_set_Test, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAddressBookRequest, get_Filters, arginfo_TElWebDavAddressBookRequest_get_Filters, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAddressBookRequest, get_Limit, arginfo_TElWebDavAddressBookRequest_get_Limit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAddressBookRequest, set_Limit, arginfo_TElWebDavAddressBookRequest_set_Limit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAddressBookRequest, get_Names, arginfo_TElWebDavAddressBookRequest_get_Names, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAddressBookRequest, __construct, arginfo_TElWebDavAddressBookRequest___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavAddressBookRequest(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavAddressBookRequest_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavAddressBookRequest", TElWebDavAddressBookRequest_methods);
	if (NULL == TElWebDavExtendedRequest_ce_ptr)
		Register_TElWebDavExtendedRequest(TSRMLS_C);
	TElWebDavAddressBookRequest_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavExtendedRequest_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavLimitRecurrenceSet_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavLimitRecurrenceSet, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavLimitRecurrenceSet_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavLimitRecurrenceSet___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavLimitRecurrenceSet_methods[] = {
	PHP_ME(TElWebDavLimitRecurrenceSet, __construct, arginfo_TElWebDavLimitRecurrenceSet___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavLimitRecurrenceSet(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavLimitRecurrenceSet_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavLimitRecurrenceSet", TElWebDavLimitRecurrenceSet_methods);
	if (NULL == TElWebDavTimeRangeBase_ce_ptr)
		Register_TElWebDavTimeRangeBase(TSRMLS_C);
	TElWebDavLimitRecurrenceSet_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavTimeRangeBase_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavExpand_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavExpand, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavExpand_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavExpand___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavExpand_methods[] = {
	PHP_ME(TElWebDavExpand, __construct, arginfo_TElWebDavExpand___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavExpand(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavExpand_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavExpand", TElWebDavExpand_methods);
	if (NULL == TElWebDavTimeRangeBase_ce_ptr)
		Register_TElWebDavTimeRangeBase(TSRMLS_C);
	TElWebDavExpand_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavTimeRangeBase_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavLimitFreeBusySet_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavLimitFreeBusySet, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavLimitFreeBusySet_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavLimitFreeBusySet___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavLimitFreeBusySet_methods[] = {
	PHP_ME(TElWebDavLimitFreeBusySet, __construct, arginfo_TElWebDavLimitFreeBusySet___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavLimitFreeBusySet(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavLimitFreeBusySet_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavLimitFreeBusySet", TElWebDavLimitFreeBusySet_methods);
	if (NULL == TElWebDavTimeRangeBase_ce_ptr)
		Register_TElWebDavTimeRangeBase(TSRMLS_C);
	TElWebDavLimitFreeBusySet_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavTimeRangeBase_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavComp_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavComp, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavComp_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, get_Parent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavComp_get_Parent(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavComp_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavComp_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1181735039, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavComp_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, get_AllProp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavComp_get_AllProp(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, set_AllProp)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDavComp_set_AllProp(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, get_AllComp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavComp_get_AllComp(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, set_AllComp)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDavComp_set_AllComp(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, get_Props)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavComp_get_Props(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, get_Comps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavComp_get_Comps(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, get_FullPath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavComp_get_FullPath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1056526818, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavComp, __construct)
{
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParent, TElWebDavComp_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavComp_Create(SBGetObjectHandle(oParent TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDavComp)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_get_Parent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_get_AllProp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_set_AllProp, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_get_AllComp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_set_AllComp, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_get_Props, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_get_Comps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp_get_FullPath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavComp___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Parent, TElWebDavComp, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavComp_methods[] = {
	PHP_ME(TElWebDavComp, LoadFromXML, arginfo_TElWebDavComp_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, get_Parent, arginfo_TElWebDavComp_get_Parent, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, get_Name, arginfo_TElWebDavComp_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, set_Name, arginfo_TElWebDavComp_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, get_AllProp, arginfo_TElWebDavComp_get_AllProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, set_AllProp, arginfo_TElWebDavComp_set_AllProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, get_AllComp, arginfo_TElWebDavComp_get_AllComp, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, set_AllComp, arginfo_TElWebDavComp_set_AllComp, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, get_Props, arginfo_TElWebDavComp_get_Props, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, get_Comps, arginfo_TElWebDavComp_get_Comps, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, get_FullPath, arginfo_TElWebDavComp_get_FullPath, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavComp, __construct, arginfo_TElWebDavComp___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavComp(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavComp_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavComp", TElWebDavComp_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavComp_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavCalendarRequest_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavCalendarRequest, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavCalendarRequest_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCalendarRequest, get_CompFilter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCalendarRequest_get_CompFilter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCalDAVCompFilter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCalendarRequest, get_Timezone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCalendarRequest_get_Timezone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElVCalendar_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCalendarRequest, get_Comp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCalendarRequest_get_Comp(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavComp_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCalendarRequest, get_Expand)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCalendarRequest_get_Expand(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavExpand_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCalendarRequest, get_LimitRecurrenceSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCalendarRequest_get_LimitRecurrenceSet(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavLimitRecurrenceSet_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCalendarRequest, get_LimitFreebusySet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCalendarRequest_get_LimitFreebusySet(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavLimitFreeBusySet_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCalendarRequest, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCalendarRequest_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCalendarRequest_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCalendarRequest_get_CompFilter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCalendarRequest_get_Timezone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCalendarRequest_get_Comp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCalendarRequest_get_Expand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCalendarRequest_get_LimitRecurrenceSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCalendarRequest_get_LimitFreebusySet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCalendarRequest___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavCalendarRequest_methods[] = {
	PHP_ME(TElWebDavCalendarRequest, LoadFromXML, arginfo_TElWebDavCalendarRequest_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCalendarRequest, get_CompFilter, arginfo_TElWebDavCalendarRequest_get_CompFilter, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCalendarRequest, get_Timezone, arginfo_TElWebDavCalendarRequest_get_Timezone, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCalendarRequest, get_Comp, arginfo_TElWebDavCalendarRequest_get_Comp, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCalendarRequest, get_Expand, arginfo_TElWebDavCalendarRequest_get_Expand, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCalendarRequest, get_LimitRecurrenceSet, arginfo_TElWebDavCalendarRequest_get_LimitRecurrenceSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCalendarRequest, get_LimitFreebusySet, arginfo_TElWebDavCalendarRequest_get_LimitFreebusySet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCalendarRequest, __construct, arginfo_TElWebDavCalendarRequest___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavCalendarRequest(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavCalendarRequest_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavCalendarRequest", TElWebDavCalendarRequest_methods);
	if (NULL == TElWebDavExtendedRequest_ce_ptr)
		Register_TElWebDavExtendedRequest(TSRMLS_C);
	TElWebDavCalendarRequest_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavExtendedRequest_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavProperty_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavProperty, Write)
{
	char *sURL;
	char *sValue;
	int sURL_len;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sURL, &sURL_len, &sValue, &sValue_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_Write(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sValue, (int32_t)sValue_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, Read)
{
	char *sURL;
	char *sValue;
	int sURL_len;
	int32_t sValue_len;
	uint32_t _err;
	zval *oElement;
	zval *oParam;
	zval *zsValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sURL, &sURL_len, &zsValue) == SUCCESS) && PZVAL_IS_REF(zsValue) && (IS_STRING == Z_TYPE_P(zsValue)))
	{
		int8_t bOutResultRaw = 0;
		sValue = Z_STRVAL_P(zsValue);
		sValue_len = (int32_t)Z_STRLEN_P(zsValue);
		_err = TElWebDavProperty_Read(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sValue, &sValue_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sValue = emalloc(sValue_len + 1);
			SBCheckError(SBGetLastReturnStringA(1166657834, 2, sValue, &sValue_len) TSRMLS_CC);
			zval_dtor(zsValue);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sValue[sValue_len] = 0;
		ZVAL_STRINGL(zsValue, sValue, sValue_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szO!O!", &sURL, &sURL_len, &zsValue, &oElement, TElXMLDOMElement_ce_ptr, &oParam, TObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zsValue) && (IS_STRING == Z_TYPE_P(zsValue)))
	{
		int8_t bOutResultRaw = 0;
		sValue = Z_STRVAL_P(zsValue);
		sValue_len = (int32_t)Z_STRLEN_P(zsValue);
		_err = TElWebDavProperty_Read_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sValue, &sValue_len, SBGetObjectHandle(oElement TSRMLS_CC), SBGetObjectHandle(oParam TSRMLS_CC), &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sValue = emalloc(sValue_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1674070, 2, sValue, &sValue_len) TSRMLS_CC);
			zval_dtor(zsValue);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sValue[sValue_len] = 0;
		ZVAL_STRINGL(zsValue, sValue, sValue_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string) or (string, &string, TElXMLDOMElement, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, Remove)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_NS)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavProperty_get_NS(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-675426007, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavProperty_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2146835415, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_Live)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_get_Live(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_Protect)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_get_Protect(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_AsXML)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_get_AsXML(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_PrincipalMatch)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_get_PrincipalMatch(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_Principal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_get_Principal(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_AddressBook)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_get_AddressBook(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_Calendar)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_get_Calendar(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_Copy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_get_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_Search)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavProperty_get_Search(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, set_Search)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDavProperty_set_Search(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavProperty_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-56741582, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, set_Description)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavProperty_set_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_DescLang)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavProperty_get_DescLang(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1254145527, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, set_DescLang)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebDavProperty_set_DescLang(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_OnReadValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavPropertyReadValueEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDavProperty_get_OnReadValue(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, set_OnReadValue)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDavProperty_set_OnReadValue(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavPropertyReadValueEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavPropertyReadValueEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_OnReadExValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavPropertyReadExValueEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDavProperty_get_OnReadExValue(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, set_OnReadExValue)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDavProperty_set_OnReadExValue(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavPropertyReadExValueEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavPropertyReadExValueEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_OnWriteValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavPropertyWriteValueEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDavProperty_get_OnWriteValue(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, set_OnWriteValue)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDavProperty_set_OnWriteValue(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavPropertyWriteValueEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavPropertyWriteValueEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_OnAfterReadValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavPropertyAfterReadValueEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDavProperty_get_OnAfterReadValue(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, set_OnAfterReadValue)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDavProperty_set_OnAfterReadValue(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavPropertyAfterReadValueEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavPropertyAfterReadValueEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_OnBeforeWriteValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavPropertyBeforeWriteValueEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDavProperty_get_OnBeforeWriteValue(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, set_OnBeforeWriteValue)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDavProperty_set_OnBeforeWriteValue(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavPropertyBeforeWriteValueEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavPropertyBeforeWriteValueEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, get_OnRemove)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavPropertyRemoveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDavProperty_get_OnRemove(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, set_OnRemove)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDavProperty_set_OnRemove(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavPropertyRemoveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavPropertyRemoveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavProperty, __construct)
{
	char *sName;
	char *sNS;
	int sName_len;
	int sNS_len;
	zend_bool bAddressBook;
	zend_bool bAsXML;
	zend_bool bCalendar;
	zend_bool bCopy;
	zend_bool bLive;
	zend_bool bPrincipal;
	zend_bool bPrincipalMatch;
	zend_bool bProtect;
	zval *oServer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssbbbbbbbb", &oServer, TElWebDAVServer_ce_ptr, &sNS, &sNS_len, &sName, &sName_len, &bLive, &bProtect, &bAsXML, &bPrincipalMatch, &bPrincipal, &bAddressBook, &bCalendar, &bCopy) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavProperty_Create(SBGetObjectHandle(oServer TSRMLS_CC), sNS, (int32_t)sNS_len, sName, (int32_t)sName_len, (int8_t)bLive, (int8_t)bProtect, (int8_t)bAsXML, (int8_t)bPrincipalMatch, (int8_t)bPrincipal, (int8_t)bAddressBook, (int8_t)bCalendar, (int8_t)bCopy, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVServer, string, string, bool, bool, bool, bool, bool, bool, bool, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_Write, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_Read, 0, 0, 2)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(1, Value)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, Param, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_NS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_Live, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_Protect, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_AsXML, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_PrincipalMatch, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_Principal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_AddressBook, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_Calendar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_Copy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_Search, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_set_Search, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_set_Description, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_DescLang, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_set_DescLang, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_OnReadValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_set_OnReadValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_OnReadExValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_set_OnReadExValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_OnWriteValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_set_OnWriteValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_OnAfterReadValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_set_OnAfterReadValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_OnBeforeWriteValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_set_OnBeforeWriteValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_get_OnRemove, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty_set_OnRemove, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavProperty___construct, 0, 0, 11)
	ZEND_ARG_OBJ_INFO(0, Server, TElWebDAVServer, 1)
	ZEND_ARG_INFO(0, NS)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Live)
	ZEND_ARG_INFO(0, Protect)
	ZEND_ARG_INFO(0, AsXML)
	ZEND_ARG_INFO(0, PrincipalMatch)
	ZEND_ARG_INFO(0, Principal)
	ZEND_ARG_INFO(0, AddressBook)
	ZEND_ARG_INFO(0, Calendar)
	ZEND_ARG_INFO(0, Copy)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavProperty_methods[] = {
	PHP_ME(TElWebDavProperty, Write, arginfo_TElWebDavProperty_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, Read, arginfo_TElWebDavProperty_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, Remove, arginfo_TElWebDavProperty_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_NS, arginfo_TElWebDavProperty_get_NS, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_Name, arginfo_TElWebDavProperty_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_Live, arginfo_TElWebDavProperty_get_Live, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_Protect, arginfo_TElWebDavProperty_get_Protect, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_AsXML, arginfo_TElWebDavProperty_get_AsXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_PrincipalMatch, arginfo_TElWebDavProperty_get_PrincipalMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_Principal, arginfo_TElWebDavProperty_get_Principal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_AddressBook, arginfo_TElWebDavProperty_get_AddressBook, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_Calendar, arginfo_TElWebDavProperty_get_Calendar, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_Copy, arginfo_TElWebDavProperty_get_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_Search, arginfo_TElWebDavProperty_get_Search, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, set_Search, arginfo_TElWebDavProperty_set_Search, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_Description, arginfo_TElWebDavProperty_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, set_Description, arginfo_TElWebDavProperty_set_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_DescLang, arginfo_TElWebDavProperty_get_DescLang, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, set_DescLang, arginfo_TElWebDavProperty_set_DescLang, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_OnReadValue, arginfo_TElWebDavProperty_get_OnReadValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, set_OnReadValue, arginfo_TElWebDavProperty_set_OnReadValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_OnReadExValue, arginfo_TElWebDavProperty_get_OnReadExValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, set_OnReadExValue, arginfo_TElWebDavProperty_set_OnReadExValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_OnWriteValue, arginfo_TElWebDavProperty_get_OnWriteValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, set_OnWriteValue, arginfo_TElWebDavProperty_set_OnWriteValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_OnAfterReadValue, arginfo_TElWebDavProperty_get_OnAfterReadValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, set_OnAfterReadValue, arginfo_TElWebDavProperty_set_OnAfterReadValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_OnBeforeWriteValue, arginfo_TElWebDavProperty_get_OnBeforeWriteValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, set_OnBeforeWriteValue, arginfo_TElWebDavProperty_set_OnBeforeWriteValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, get_OnRemove, arginfo_TElWebDavProperty_get_OnRemove, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, set_OnRemove, arginfo_TElWebDavProperty_set_OnRemove, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavProperty, __construct, arginfo_TElWebDavProperty___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavProperty(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavProperty_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavProperty", TElWebDavProperty_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavProperty_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavIfState_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavIfState, get_AType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavIfStateTypeRaw fOutResultRaw = 0;
		SBCheckError(TElWebDavIfState_get_AType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavIfState, get_Condition)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavIfState_get_Condition(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavIfState, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavIfState_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1402584241, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavIfState, __construct)
{
	char *sValue;
	int sValue_len;
	long fAType;
	zend_bool bCondition;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbs", &fAType, &bCondition, &sValue, &sValue_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavIfState_Create((TSBWebDavIfStateTypeRaw)fAType, (int8_t)bCondition, sValue, (int32_t)sValue_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavIfState_get_AType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavIfState_get_Condition, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavIfState_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavIfState___construct, 0, 0, 3)
	ZEND_ARG_INFO(0, AType)
	ZEND_ARG_INFO(0, Condition)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavIfState_methods[] = {
	PHP_ME(TElWebDavIfState, get_AType, arginfo_TElWebDavIfState_get_AType, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavIfState, get_Condition, arginfo_TElWebDavIfState_get_Condition, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavIfState, get_Value, arginfo_TElWebDavIfState_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavIfState, __construct, arginfo_TElWebDavIfState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavIfState(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavIfState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavIfState", TElWebDavIfState_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavIfState_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavIfResource_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavIfResource, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDavIfResource_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2094075176, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavIfResource, get_States)
{
	long l4Idx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Idx) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavIfResource_get_States(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Idx, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavIfState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavIfResource, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavIfResource_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavIfResource, __construct)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavIfResource_Create(sURI, (int32_t)sURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavIfResource_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavIfResource_get_States, 0, 0, 1)
	ZEND_ARG_INFO(0, Idx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavIfResource_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavIfResource___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavIfResource_methods[] = {
	PHP_ME(TElWebDavIfResource, get_URI, arginfo_TElWebDavIfResource_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavIfResource, get_States, arginfo_TElWebDavIfResource_get_States, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavIfResource, get_Count, arginfo_TElWebDavIfResource_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavIfResource, __construct, arginfo_TElWebDavIfResource___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavIfResource(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavIfResource_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavIfResource", TElWebDavIfResource_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavIfResource_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDAVIfHeader_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVIfHeader, Process)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVIfHeader_Process(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVIfHeader, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebDAVIfHeader_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1136815267, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVIfHeader, get_Resources)
{
	long l4Idx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Idx) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVIfHeader_get_Resources(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Idx, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavIfResource_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVIfHeader, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVIfHeader_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVIfHeader, __construct)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVIfHeader_Create(sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVIfHeader_Process, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVIfHeader_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVIfHeader_get_Resources, 0, 0, 1)
	ZEND_ARG_INFO(0, Idx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVIfHeader_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVIfHeader___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVIfHeader_methods[] = {
	PHP_ME(TElWebDAVIfHeader, Process, arginfo_TElWebDAVIfHeader_Process, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVIfHeader, get_URL, arginfo_TElWebDAVIfHeader_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVIfHeader, get_Resources, arginfo_TElWebDAVIfHeader_get_Resources, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVIfHeader, get_Count, arginfo_TElWebDAVIfHeader_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVIfHeader, __construct, arginfo_TElWebDAVIfHeader___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVIfHeader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVIfHeader_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVIfHeader", TElWebDAVIfHeader_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDAVIfHeader_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDAVCustomLockList_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVCustomLockList, Enter)
{
	zend_bool bReadOnly;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElWebDAVCustomLockList_Enter(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bReadOnly) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, Done)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDAVCustomLockList_Done(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, Add)
{
	zval *oLock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oLock, TElWebDAVLock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVCustomLockList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVLock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, Remove)
{
	zval *oLock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oLock, TElWebDAVLock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVCustomLockList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVLock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, Find)
{
	char *sToken;
	int sToken_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sToken, &sToken_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVCustomLockList_Find(SBGetObjectHandle(getThis() TSRMLS_CC), sToken, (int32_t)sToken_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, FindAll)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVCustomLockList_FindAll(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, FindFirst)
{
	char *sURL;
	int sURL_len;
	TElClassHandle hoHandle;
	zval *oHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oHandle, TObject_ce_ptr, &sURL, &sURL_len) == SUCCESS) && PZVAL_IS_REF(oHandle) && (IS_OBJECT == Z_TYPE_P(oHandle)))
	{
		TElClassHandle hoOutResult = NULL;
		hoHandle = SBGetObjectHandle(oHandle TSRMLS_CC);
		SBCheckError(TElWebDAVCustomLockList_FindFirst(SBGetObjectHandle(getThis() TSRMLS_CC), &hoHandle, sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBUpdateObjectHandle(oHandle, hoHandle TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TObject, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, FindNext)
{
	zval *oHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandle, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVCustomLockList_FindNext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandle TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, FindClose)
{
	zval *oHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandle, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVCustomLockList_FindClose(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandle TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, LoadFromStream)
{
	zend_bool bClear;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bClear) == SUCCESS)
	{
		SBCheckError(TElWebDAVCustomLockList_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bClear) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVCustomLockList_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, get_Locks)
{
	long l4Idx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Idx) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVCustomLockList_get_Locks(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Idx, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVCustomLockList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVCustomLockList, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVCustomLockList_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_Enter, 0, 0, 1)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_Done, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Lock, TElWebDAVLock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_Remove, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Lock, TElWebDAVLock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_Find, 0, 0, 1)
	ZEND_ARG_INFO(0, Token)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_FindAll, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_FindFirst, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(1, Handle, TObject, 0)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_FindNext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handle, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_FindClose, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handle, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Clear)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_get_Locks, 0, 0, 1)
	ZEND_ARG_INFO(0, Idx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVCustomLockList___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVCustomLockList_methods[] = {
	PHP_ME(TElWebDAVCustomLockList, Enter, arginfo_TElWebDAVCustomLockList_Enter, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, Done, arginfo_TElWebDAVCustomLockList_Done, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, Add, arginfo_TElWebDAVCustomLockList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, Remove, arginfo_TElWebDAVCustomLockList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, Find, arginfo_TElWebDAVCustomLockList_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, FindAll, arginfo_TElWebDAVCustomLockList_FindAll, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, FindFirst, arginfo_TElWebDAVCustomLockList_FindFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, FindNext, arginfo_TElWebDAVCustomLockList_FindNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, FindClose, arginfo_TElWebDAVCustomLockList_FindClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, LoadFromStream, arginfo_TElWebDAVCustomLockList_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, SaveToStream, arginfo_TElWebDAVCustomLockList_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, get_Locks, arginfo_TElWebDAVCustomLockList_get_Locks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, get_Count, arginfo_TElWebDAVCustomLockList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVCustomLockList, __construct, arginfo_TElWebDAVCustomLockList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVCustomLockList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVCustomLockList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVCustomLockList", TElWebDAVCustomLockList_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElWebDAVCustomLockList_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavFindMemoryLockHandle_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavFindMemoryLockHandle, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavFindMemoryLockHandle_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavFindMemoryLockHandle___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavFindMemoryLockHandle_methods[] = {
	PHP_ME(TElWebDavFindMemoryLockHandle, __construct, arginfo_TElWebDavFindMemoryLockHandle___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavFindMemoryLockHandle(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavFindMemoryLockHandle_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavFindMemoryLockHandle", TElWebDavFindMemoryLockHandle_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavFindMemoryLockHandle_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDAVMemoryLockList_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVMemoryLockList, Enter)
{
	zend_bool bReadOnly;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElWebDAVMemoryLockList_Enter(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bReadOnly) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, Done)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebDAVMemoryLockList_Done(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, Add)
{
	zval *oLock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oLock, TElWebDAVLock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVMemoryLockList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVLock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, Remove)
{
	zval *oLock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oLock, TElWebDAVLock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVMemoryLockList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDAVLock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, Find)
{
	char *sToken;
	int sToken_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sToken, &sToken_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVMemoryLockList_Find(SBGetObjectHandle(getThis() TSRMLS_CC), sToken, (int32_t)sToken_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, FindAll)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVMemoryLockList_FindAll(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, FindFirst)
{
	char *sURL;
	int sURL_len;
	TElClassHandle hoHandle;
	zval *oHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oHandle, TObject_ce_ptr, &sURL, &sURL_len) == SUCCESS) && PZVAL_IS_REF(oHandle) && (IS_OBJECT == Z_TYPE_P(oHandle)))
	{
		TElClassHandle hoOutResult = NULL;
		hoHandle = SBGetObjectHandle(oHandle TSRMLS_CC);
		SBCheckError(TElWebDAVMemoryLockList_FindFirst(SBGetObjectHandle(getThis() TSRMLS_CC), &hoHandle, sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBUpdateObjectHandle(oHandle, hoHandle TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TObject, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, FindNext)
{
	zval *oHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandle, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVMemoryLockList_FindNext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandle TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, FindClose)
{
	zval *oHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandle, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVMemoryLockList_FindClose(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandle TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, LoadFromStream)
{
	zend_bool bClear;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bClear) == SUCCESS)
	{
		SBCheckError(TElWebDAVMemoryLockList_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bClear) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVMemoryLockList_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, Cleanup)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVMemoryLockList_Cleanup(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, get_Locks)
{
	long l4Idx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Idx) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVMemoryLockList_get_Locks(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Idx, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVMemoryLockList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVMemoryLockList, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVMemoryLockList_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_Enter, 0, 0, 1)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_Done, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Lock, TElWebDAVLock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_Remove, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Lock, TElWebDAVLock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_Find, 0, 0, 1)
	ZEND_ARG_INFO(0, Token)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_FindAll, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_FindFirst, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(1, Handle, TObject, 0)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_FindNext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handle, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_FindClose, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handle, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Clear)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_Cleanup, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_get_Locks, 0, 0, 1)
	ZEND_ARG_INFO(0, Idx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVMemoryLockList___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVMemoryLockList_methods[] = {
	PHP_ME(TElWebDAVMemoryLockList, Enter, arginfo_TElWebDAVMemoryLockList_Enter, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, Done, arginfo_TElWebDAVMemoryLockList_Done, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, Add, arginfo_TElWebDAVMemoryLockList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, Remove, arginfo_TElWebDAVMemoryLockList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, Find, arginfo_TElWebDAVMemoryLockList_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, FindAll, arginfo_TElWebDAVMemoryLockList_FindAll, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, FindFirst, arginfo_TElWebDAVMemoryLockList_FindFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, FindNext, arginfo_TElWebDAVMemoryLockList_FindNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, FindClose, arginfo_TElWebDAVMemoryLockList_FindClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, LoadFromStream, arginfo_TElWebDAVMemoryLockList_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, SaveToStream, arginfo_TElWebDAVMemoryLockList_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, Cleanup, arginfo_TElWebDAVMemoryLockList_Cleanup, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, get_Locks, arginfo_TElWebDAVMemoryLockList_get_Locks, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, get_Count, arginfo_TElWebDAVMemoryLockList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVMemoryLockList, __construct, arginfo_TElWebDAVMemoryLockList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVMemoryLockList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVMemoryLockList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVMemoryLockList", TElWebDAVMemoryLockList_methods);
	if (NULL == TElWebDAVCustomLockList_ce_ptr)
		Register_TElWebDAVCustomLockList(TSRMLS_C);
	TElWebDAVMemoryLockList_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDAVCustomLockList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDAVACLOptions_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDAVACLOptions, get_UseACL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDAVACLOptions_get_UseACL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_UseACL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebDAVACLOptions_set_UseACL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_PrincipalBackend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_get_PrincipalBackend(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavPrincipalBackend_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_PrincipalBackend)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElWebDavPrincipalBackend_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebDAVACLOptions_set_PrincipalBackend(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebDavPrincipalBackend)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_AbstractPrivileges)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBArrayZValInfo aiOutResult;
		SBInitArrayZValInfo(&aiOutResult);
		_err = TElWebDAVACLOptions_get_AbstractPrivileges(SBGetObjectHandle(getThis() TSRMLS_CC), aiOutResult.data, &aiOutResult.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			aiOutResult.data = emalloc(aiOutResult.len);
			SBCheckError(SBGetLastReturnBuffer(-490070984, 1, aiOutResult.data, &aiOutResult.len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutResult);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetInt16ArrayToZVal(&aiOutResult, return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_AbstractPrivileges)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetInt16ArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebDAVACLOptions_set_AbstractPrivileges(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of int16|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_MatchingPrincipalsLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDAVACLOptions_get_MatchingPrincipalsLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_MatchingPrincipalsLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElWebDAVACLOptions_set_MatchingPrincipalsLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_OnReadCurrentUserPrivileges)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavReadPrivilegesEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_get_OnReadCurrentUserPrivileges(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_OnReadCurrentUserPrivileges)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVACLOptions_set_OnReadCurrentUserPrivileges(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavReadPrivilegesEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavReadPrivilegesEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_OnReadSupportedPrivileges)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavReadSupportedPrivilegesEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_get_OnReadSupportedPrivileges(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_OnReadSupportedPrivileges)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVACLOptions_set_OnReadSupportedPrivileges(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavReadSupportedPrivilegesEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavReadSupportedPrivilegesEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_OnReadOwner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavReadOwnerEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_get_OnReadOwner(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_OnReadOwner)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVACLOptions_set_OnReadOwner(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavReadOwnerEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavReadOwnerEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_OnGetPrivilegeDescription)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavGetPrivilegeDescriptionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_get_OnGetPrivilegeDescription(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_OnGetPrivilegeDescription)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVACLOptions_set_OnGetPrivilegeDescription(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavGetPrivilegeDescriptionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavGetPrivilegeDescriptionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_OnGetACLRestrictions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavGetACLRestrictionsEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_get_OnGetACLRestrictions(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_OnGetACLRestrictions)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVACLOptions_set_OnGetACLRestrictions(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavGetACLRestrictionsEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavGetACLRestrictionsEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_OnGetACL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavGetACLEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_get_OnGetACL(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_OnGetACL)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVACLOptions_set_OnGetACL(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavGetACLEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavGetACLEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_OnSetACL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavSetACLEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_get_OnSetACL(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_OnSetACL)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVACLOptions_set_OnSetACL(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavSetACLEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavSetACLEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, get_OnGetInheritedACLSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavGetURLSetEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_get_OnGetInheritedACLSet(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, set_OnGetInheritedACLSet)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebDAVACLOptions_set_OnGetInheritedACLSet(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavGetURLSetEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavGetURLSetEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDAVACLOptions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDAVACLOptions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_UseACL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_UseACL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_PrincipalBackend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_PrincipalBackend, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElWebDavPrincipalBackend, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_AbstractPrivileges, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_AbstractPrivileges, 0, 0, 1)
	ZEND_ARG_ARRAY_INFO(0, Value, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_MatchingPrincipalsLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_MatchingPrincipalsLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_OnReadCurrentUserPrivileges, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_OnReadCurrentUserPrivileges, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_OnReadSupportedPrivileges, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_OnReadSupportedPrivileges, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_OnReadOwner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_OnReadOwner, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_OnGetPrivilegeDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_OnGetPrivilegeDescription, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_OnGetACLRestrictions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_OnGetACLRestrictions, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_OnGetACL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_OnGetACL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_OnSetACL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_OnSetACL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_get_OnGetInheritedACLSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions_set_OnGetInheritedACLSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDAVACLOptions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDAVACLOptions_methods[] = {
	PHP_ME(TElWebDAVACLOptions, get_UseACL, arginfo_TElWebDAVACLOptions_get_UseACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_UseACL, arginfo_TElWebDAVACLOptions_set_UseACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_PrincipalBackend, arginfo_TElWebDAVACLOptions_get_PrincipalBackend, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_PrincipalBackend, arginfo_TElWebDAVACLOptions_set_PrincipalBackend, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_AbstractPrivileges, arginfo_TElWebDAVACLOptions_get_AbstractPrivileges, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_AbstractPrivileges, arginfo_TElWebDAVACLOptions_set_AbstractPrivileges, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_MatchingPrincipalsLimit, arginfo_TElWebDAVACLOptions_get_MatchingPrincipalsLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_MatchingPrincipalsLimit, arginfo_TElWebDAVACLOptions_set_MatchingPrincipalsLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_OnReadCurrentUserPrivileges, arginfo_TElWebDAVACLOptions_get_OnReadCurrentUserPrivileges, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_OnReadCurrentUserPrivileges, arginfo_TElWebDAVACLOptions_set_OnReadCurrentUserPrivileges, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_OnReadSupportedPrivileges, arginfo_TElWebDAVACLOptions_get_OnReadSupportedPrivileges, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_OnReadSupportedPrivileges, arginfo_TElWebDAVACLOptions_set_OnReadSupportedPrivileges, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_OnReadOwner, arginfo_TElWebDAVACLOptions_get_OnReadOwner, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_OnReadOwner, arginfo_TElWebDAVACLOptions_set_OnReadOwner, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_OnGetPrivilegeDescription, arginfo_TElWebDAVACLOptions_get_OnGetPrivilegeDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_OnGetPrivilegeDescription, arginfo_TElWebDAVACLOptions_set_OnGetPrivilegeDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_OnGetACLRestrictions, arginfo_TElWebDAVACLOptions_get_OnGetACLRestrictions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_OnGetACLRestrictions, arginfo_TElWebDAVACLOptions_set_OnGetACLRestrictions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_OnGetACL, arginfo_TElWebDAVACLOptions_get_OnGetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_OnGetACL, arginfo_TElWebDAVACLOptions_set_OnGetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_OnSetACL, arginfo_TElWebDAVACLOptions_get_OnSetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_OnSetACL, arginfo_TElWebDAVACLOptions_set_OnSetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, get_OnGetInheritedACLSet, arginfo_TElWebDAVACLOptions_get_OnGetInheritedACLSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, set_OnGetInheritedACLSet, arginfo_TElWebDAVACLOptions_set_OnGetInheritedACLSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDAVACLOptions, __construct, arginfo_TElWebDAVACLOptions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDAVACLOptions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDAVACLOptions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDAVACLOptions", TElWebDAVACLOptions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDAVACLOptions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCardDAVOptions_ce_ptr = NULL;

SB_PHP_METHOD(TElCardDAVOptions, get_UseCardDAV)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCardDAVOptions_get_UseCardDAV(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, set_UseCardDAV)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCardDAVOptions_set_UseCardDAV(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, get_AddressBookURLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCardDAVOptions_get_AddressBookURLs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, get_MaxResourceSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCardDAVOptions_get_MaxResourceSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, set_MaxResourceSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCardDAVOptions_set_MaxResourceSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, get_NumberOfMatchesLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCardDAVOptions_get_NumberOfMatchesLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, set_NumberOfMatchesLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCardDAVOptions_set_NumberOfMatchesLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, get_AllowExtendedMkCol)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCardDAVOptions_get_AllowExtendedMkCol(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, set_AllowExtendedMkCol)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCardDAVOptions_set_AllowExtendedMkCol(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, get_OnCheckIfAddressBook)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavCheckIfAddressBookEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCardDAVOptions_get_OnCheckIfAddressBook(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, set_OnCheckIfAddressBook)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCardDAVOptions_set_OnCheckIfAddressBook(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavCheckIfAddressBookEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavCheckIfAddressBookEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, get_OnSetAsAddressBook)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavSetAsAddressBookEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCardDAVOptions_get_OnSetAsAddressBook(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, set_OnSetAsAddressBook)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCardDAVOptions_set_OnSetAsAddressBook(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavSetAsAddressBookEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavSetAsAddressBookEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, get_OnCheckUIDUniqueness)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCheckUIDUniquenessEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCardDAVOptions_get_OnCheckUIDUniqueness(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, set_OnCheckUIDUniqueness)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCardDAVOptions_set_OnCheckUIDUniqueness(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCheckUIDUniquenessEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCheckUIDUniquenessEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCardDAVOptions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCardDAVOptions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_get_UseCardDAV, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_set_UseCardDAV, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_get_AddressBookURLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_get_MaxResourceSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_set_MaxResourceSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_get_NumberOfMatchesLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_set_NumberOfMatchesLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_get_AllowExtendedMkCol, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_set_AllowExtendedMkCol, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_get_OnCheckIfAddressBook, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_set_OnCheckIfAddressBook, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_get_OnSetAsAddressBook, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_set_OnSetAsAddressBook, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_get_OnCheckUIDUniqueness, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions_set_OnCheckUIDUniqueness, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCardDAVOptions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCardDAVOptions_methods[] = {
	PHP_ME(TElCardDAVOptions, get_UseCardDAV, arginfo_TElCardDAVOptions_get_UseCardDAV, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, set_UseCardDAV, arginfo_TElCardDAVOptions_set_UseCardDAV, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, get_AddressBookURLs, arginfo_TElCardDAVOptions_get_AddressBookURLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, get_MaxResourceSize, arginfo_TElCardDAVOptions_get_MaxResourceSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, set_MaxResourceSize, arginfo_TElCardDAVOptions_set_MaxResourceSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, get_NumberOfMatchesLimit, arginfo_TElCardDAVOptions_get_NumberOfMatchesLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, set_NumberOfMatchesLimit, arginfo_TElCardDAVOptions_set_NumberOfMatchesLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, get_AllowExtendedMkCol, arginfo_TElCardDAVOptions_get_AllowExtendedMkCol, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, set_AllowExtendedMkCol, arginfo_TElCardDAVOptions_set_AllowExtendedMkCol, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, get_OnCheckIfAddressBook, arginfo_TElCardDAVOptions_get_OnCheckIfAddressBook, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, set_OnCheckIfAddressBook, arginfo_TElCardDAVOptions_set_OnCheckIfAddressBook, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, get_OnSetAsAddressBook, arginfo_TElCardDAVOptions_get_OnSetAsAddressBook, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, set_OnSetAsAddressBook, arginfo_TElCardDAVOptions_set_OnSetAsAddressBook, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, get_OnCheckUIDUniqueness, arginfo_TElCardDAVOptions_get_OnCheckUIDUniqueness, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, set_OnCheckUIDUniqueness, arginfo_TElCardDAVOptions_set_OnCheckUIDUniqueness, ZEND_ACC_PUBLIC)
	PHP_ME(TElCardDAVOptions, __construct, arginfo_TElCardDAVOptions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCardDAVOptions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCardDAVOptions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCardDAVOptions", TElCardDAVOptions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCardDAVOptions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCalDAVOptions_ce_ptr = NULL;

SB_PHP_METHOD(TElCalDAVOptions, get_UseCalDAV)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCalDAVOptions_get_UseCalDAV(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, set_UseCalDAV)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCalDAVOptions_set_UseCalDAV(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, get_MaxResourceSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCalDAVOptions_get_MaxResourceSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, set_MaxResourceSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCalDAVOptions_set_MaxResourceSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, get_MinDateTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElCalDAVOptions_get_MinDateTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, set_MinDateTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElCalDAVOptions_set_MinDateTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, get_MaxDateTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElCalDAVOptions_get_MaxDateTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, set_MaxDateTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElCalDAVOptions_set_MaxDateTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, get_MaxRecurrenceInstances)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCalDAVOptions_get_MaxRecurrenceInstances(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, set_MaxRecurrenceInstances)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCalDAVOptions_set_MaxRecurrenceInstances(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, get_MaxAttendeesPerInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCalDAVOptions_get_MaxAttendeesPerInstance(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, set_MaxAttendeesPerInstance)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCalDAVOptions_set_MaxAttendeesPerInstance(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, get_OnCheckIfCalendar)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavCheckIfCalendarEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCalDAVOptions_get_OnCheckIfCalendar(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, set_OnCheckIfCalendar)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCalDAVOptions_set_OnCheckIfCalendar(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavCheckIfCalendarEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavCheckIfCalendarEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, get_OnSetAsCalendar)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWebDavSetAsCalendarEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCalDAVOptions_get_OnSetAsCalendar(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, set_OnSetAsCalendar)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCalDAVOptions_set_OnSetAsCalendar(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWebDavSetAsCalendarEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWebDavSetAsCalendarEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, get_OnCheckUIDUniqueness)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCheckUIDUniquenessEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCalDAVOptions_get_OnCheckUIDUniqueness(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, set_OnCheckUIDUniqueness)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCalDAVOptions_set_OnCheckUIDUniqueness(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCheckUIDUniquenessEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCheckUIDUniquenessEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCalDAVOptions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCalDAVOptions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_get_UseCalDAV, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_set_UseCalDAV, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_get_MaxResourceSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_set_MaxResourceSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_get_MinDateTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_set_MinDateTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_get_MaxDateTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_set_MaxDateTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_get_MaxRecurrenceInstances, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_set_MaxRecurrenceInstances, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_get_MaxAttendeesPerInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_set_MaxAttendeesPerInstance, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_get_OnCheckIfCalendar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_set_OnCheckIfCalendar, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_get_OnSetAsCalendar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_set_OnSetAsCalendar, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_get_OnCheckUIDUniqueness, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions_set_OnCheckUIDUniqueness, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCalDAVOptions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCalDAVOptions_methods[] = {
	PHP_ME(TElCalDAVOptions, get_UseCalDAV, arginfo_TElCalDAVOptions_get_UseCalDAV, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, set_UseCalDAV, arginfo_TElCalDAVOptions_set_UseCalDAV, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, get_MaxResourceSize, arginfo_TElCalDAVOptions_get_MaxResourceSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, set_MaxResourceSize, arginfo_TElCalDAVOptions_set_MaxResourceSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, get_MinDateTime, arginfo_TElCalDAVOptions_get_MinDateTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, set_MinDateTime, arginfo_TElCalDAVOptions_set_MinDateTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, get_MaxDateTime, arginfo_TElCalDAVOptions_get_MaxDateTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, set_MaxDateTime, arginfo_TElCalDAVOptions_set_MaxDateTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, get_MaxRecurrenceInstances, arginfo_TElCalDAVOptions_get_MaxRecurrenceInstances, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, set_MaxRecurrenceInstances, arginfo_TElCalDAVOptions_set_MaxRecurrenceInstances, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, get_MaxAttendeesPerInstance, arginfo_TElCalDAVOptions_get_MaxAttendeesPerInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, set_MaxAttendeesPerInstance, arginfo_TElCalDAVOptions_set_MaxAttendeesPerInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, get_OnCheckIfCalendar, arginfo_TElCalDAVOptions_get_OnCheckIfCalendar, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, set_OnCheckIfCalendar, arginfo_TElCalDAVOptions_set_OnCheckIfCalendar, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, get_OnSetAsCalendar, arginfo_TElCalDAVOptions_get_OnSetAsCalendar, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, set_OnSetAsCalendar, arginfo_TElCalDAVOptions_set_OnSetAsCalendar, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, get_OnCheckUIDUniqueness, arginfo_TElCalDAVOptions_get_OnCheckUIDUniqueness, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, set_OnCheckUIDUniqueness, arginfo_TElCalDAVOptions_set_OnCheckUIDUniqueness, ZEND_ACC_PUBLIC)
	PHP_ME(TElCalDAVOptions, __construct, arginfo_TElCalDAVOptions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCalDAVOptions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCalDAVOptions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCalDAVOptions", TElCalDAVOptions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCalDAVOptions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavCollation_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavCollation, CreateInstance_Inst)
{
	long fCollation;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fCollation) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCollation_CreateInstance_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBWebDavFilterTextMatchCollationRaw)fCollation, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavCollation_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCollation, CreateInstance)
{
	long fCollation;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fCollation) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCollation_CreateInstance((TSBWebDavFilterTextMatchCollationRaw)fCollation, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDavCollation_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCollation, Compare)
{
	char *sS1;
	char *sS2;
	int sS1_len;
	int sS2_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS1, &sS1_len, &sS2, &sS2_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavCollation_Compare(SBGetObjectHandle(getThis() TSRMLS_CC), sS1, (int32_t)sS1_len, sS2, (int32_t)sS2_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCollation, StartsWith)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavCollation_StartsWith(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCollation, EndsWith)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavCollation_EndsWith(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCollation, Equals)
{
	char *sS1;
	char *sS2;
	int sS1_len;
	int sS2_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS1, &sS1_len, &sS2, &sS2_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavCollation_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), sS1, (int32_t)sS1_len, sS2, (int32_t)sS2_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCollation, IndexOf)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavCollation_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavCollation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavCollation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCollation_CreateInstance_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, Collation)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCollation_CreateInstance, 0, 0, 1)
	ZEND_ARG_INFO(0, Collation)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCollation_Compare, 0, 0, 2)
	ZEND_ARG_INFO(0, S1)
	ZEND_ARG_INFO(0, S2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCollation_StartsWith, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCollation_EndsWith, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCollation_Equals, 0, 0, 2)
	ZEND_ARG_INFO(0, S1)
	ZEND_ARG_INFO(0, S2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCollation_IndexOf, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavCollation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavCollation_methods[] = {
	PHP_ME(TElWebDavCollation, CreateInstance_Inst, arginfo_TElWebDavCollation_CreateInstance_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCollation, CreateInstance, arginfo_TElWebDavCollation_CreateInstance, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElWebDavCollation, Compare, arginfo_TElWebDavCollation_Compare, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCollation, StartsWith, arginfo_TElWebDavCollation_StartsWith, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCollation, EndsWith, arginfo_TElWebDavCollation_EndsWith, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCollation, Equals, arginfo_TElWebDavCollation_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCollation, IndexOf, arginfo_TElWebDavCollation_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavCollation, __construct, arginfo_TElWebDavCollation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavCollation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavCollation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavCollation", TElWebDavCollation_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebDavCollation_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavUnicodeCollation_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavUnicodeCollation, Compare)
{
	char *sS1;
	char *sS2;
	int sS1_len;
	int sS2_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS1, &sS1_len, &sS2, &sS2_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavUnicodeCollation_Compare(SBGetObjectHandle(getThis() TSRMLS_CC), sS1, (int32_t)sS1_len, sS2, (int32_t)sS2_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavUnicodeCollation, StartsWith)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavUnicodeCollation_StartsWith(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavUnicodeCollation, EndsWith)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavUnicodeCollation_EndsWith(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavUnicodeCollation, Equals)
{
	char *sS1;
	char *sS2;
	int sS1_len;
	int sS2_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS1, &sS1_len, &sS2, &sS2_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavUnicodeCollation_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), sS1, (int32_t)sS1_len, sS2, (int32_t)sS2_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavUnicodeCollation, IndexOf)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavUnicodeCollation_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavUnicodeCollation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavUnicodeCollation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavUnicodeCollation_Compare, 0, 0, 2)
	ZEND_ARG_INFO(0, S1)
	ZEND_ARG_INFO(0, S2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavUnicodeCollation_StartsWith, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavUnicodeCollation_EndsWith, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavUnicodeCollation_Equals, 0, 0, 2)
	ZEND_ARG_INFO(0, S1)
	ZEND_ARG_INFO(0, S2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavUnicodeCollation_IndexOf, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavUnicodeCollation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavUnicodeCollation_methods[] = {
	PHP_ME(TElWebDavUnicodeCollation, Compare, arginfo_TElWebDavUnicodeCollation_Compare, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavUnicodeCollation, StartsWith, arginfo_TElWebDavUnicodeCollation_StartsWith, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavUnicodeCollation, EndsWith, arginfo_TElWebDavUnicodeCollation_EndsWith, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavUnicodeCollation, Equals, arginfo_TElWebDavUnicodeCollation_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavUnicodeCollation, IndexOf, arginfo_TElWebDavUnicodeCollation_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavUnicodeCollation, __construct, arginfo_TElWebDavUnicodeCollation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavUnicodeCollation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavUnicodeCollation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavUnicodeCollation", TElWebDavUnicodeCollation_methods);
	if (NULL == TElWebDavCollation_ce_ptr)
		Register_TElWebDavCollation(TSRMLS_C);
	TElWebDavUnicodeCollation_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavCollation_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavAsciiCollation_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavAsciiCollation, Compare)
{
	char *sS1;
	char *sS2;
	int sS1_len;
	int sS2_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS1, &sS1_len, &sS2, &sS2_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavAsciiCollation_Compare(SBGetObjectHandle(getThis() TSRMLS_CC), sS1, (int32_t)sS1_len, sS2, (int32_t)sS2_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAsciiCollation, StartsWith)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavAsciiCollation_StartsWith(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAsciiCollation, EndsWith)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavAsciiCollation_EndsWith(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAsciiCollation, Equals)
{
	char *sS1;
	char *sS2;
	int sS1_len;
	int sS2_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS1, &sS1_len, &sS2, &sS2_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavAsciiCollation_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), sS1, (int32_t)sS1_len, sS2, (int32_t)sS2_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAsciiCollation, IndexOf)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavAsciiCollation_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavAsciiCollation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavAsciiCollation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAsciiCollation_Compare, 0, 0, 2)
	ZEND_ARG_INFO(0, S1)
	ZEND_ARG_INFO(0, S2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAsciiCollation_StartsWith, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAsciiCollation_EndsWith, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAsciiCollation_Equals, 0, 0, 2)
	ZEND_ARG_INFO(0, S1)
	ZEND_ARG_INFO(0, S2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAsciiCollation_IndexOf, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavAsciiCollation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavAsciiCollation_methods[] = {
	PHP_ME(TElWebDavAsciiCollation, Compare, arginfo_TElWebDavAsciiCollation_Compare, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAsciiCollation, StartsWith, arginfo_TElWebDavAsciiCollation_StartsWith, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAsciiCollation, EndsWith, arginfo_TElWebDavAsciiCollation_EndsWith, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAsciiCollation, Equals, arginfo_TElWebDavAsciiCollation_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAsciiCollation, IndexOf, arginfo_TElWebDavAsciiCollation_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavAsciiCollation, __construct, arginfo_TElWebDavAsciiCollation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavAsciiCollation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavAsciiCollation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavAsciiCollation", TElWebDavAsciiCollation_methods);
	if (NULL == TElWebDavCollation_ce_ptr)
		Register_TElWebDavCollation(TSRMLS_C);
	TElWebDavAsciiCollation_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavCollation_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebDavOctetCollation_ce_ptr = NULL;

SB_PHP_METHOD(TElWebDavOctetCollation, Compare)
{
	char *sS1;
	char *sS2;
	int sS1_len;
	int sS2_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS1, &sS1_len, &sS2, &sS2_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavOctetCollation_Compare(SBGetObjectHandle(getThis() TSRMLS_CC), sS1, (int32_t)sS1_len, sS2, (int32_t)sS2_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavOctetCollation, StartsWith)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavOctetCollation_StartsWith(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavOctetCollation, EndsWith)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavOctetCollation_EndsWith(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavOctetCollation, Equals)
{
	char *sS1;
	char *sS2;
	int sS1_len;
	int sS2_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS1, &sS1_len, &sS2, &sS2_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebDavOctetCollation_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), sS1, (int32_t)sS1_len, sS2, (int32_t)sS2_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavOctetCollation, IndexOf)
{
	char *sS;
	char *sSubS;
	int sS_len;
	int sSubS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS, &sS_len, &sSubS, &sSubS_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebDavOctetCollation_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, sSubS, (int32_t)sSubS_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebDavOctetCollation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebDavOctetCollation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavOctetCollation_Compare, 0, 0, 2)
	ZEND_ARG_INFO(0, S1)
	ZEND_ARG_INFO(0, S2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavOctetCollation_StartsWith, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavOctetCollation_EndsWith, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavOctetCollation_Equals, 0, 0, 2)
	ZEND_ARG_INFO(0, S1)
	ZEND_ARG_INFO(0, S2)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavOctetCollation_IndexOf, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, SubS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebDavOctetCollation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebDavOctetCollation_methods[] = {
	PHP_ME(TElWebDavOctetCollation, Compare, arginfo_TElWebDavOctetCollation_Compare, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavOctetCollation, StartsWith, arginfo_TElWebDavOctetCollation_StartsWith, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavOctetCollation, EndsWith, arginfo_TElWebDavOctetCollation_EndsWith, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavOctetCollation, Equals, arginfo_TElWebDavOctetCollation_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavOctetCollation, IndexOf, arginfo_TElWebDavOctetCollation_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebDavOctetCollation, __construct, arginfo_TElWebDavOctetCollation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebDavOctetCollation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebDavOctetCollation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebDavOctetCollation", TElWebDavOctetCollation_methods);
	if (NULL == TElWebDavCollation_ce_ptr)
		Register_TElWebDavCollation(TSRMLS_C);
	TElWebDavOctetCollation_ce_ptr = zend_register_internal_class_ex(&ce, TElWebDavCollation_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBWebDAVServer, FindLockInList)
{
	char *sToken;
	int sToken_len;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oList, TList_ce_ptr, &sToken, &sToken_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBWebDAVServer_FindLockInList(SBGetObjectHandle(oList TSRMLS_CC), sToken, (int32_t)sToken_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebDAVLock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList, string)" TSRMLS_CC);
	}
}

void Register_SBWebDAVServer_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SServerName, SB_SServerName, SB_SServerName);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SAllowHeader, SB_SAllowHeader, SB_SAllowHeader);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SMsHeader, SB_SMsHeader, SB_SMsHeader);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SXMLContentType, SB_SXMLContentType, SB_SXMLContentType);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SDAV12Header, SB_SDAV12Header, SB_SDAV12Header);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SDAV1Header, SB_SDAV1Header, SB_SDAV1Header);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SACLHeader, SB_SACLHeader, SB_SACLHeader);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SCardDAVHeader, SB_SCardDAVHeader, SB_SCardDAVHeader);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SCalDAVHeader, SB_SCalDAVHeader, SB_SCalDAVHeader);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SExtendedMkColHeader, SB_SExtendedMkColHeader, SB_SExtendedMkColHeader);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SAllowACLHeader, SB_SAllowACLHeader, SB_SAllowACLHeader);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SAllowCalDAVHeader, SB_SAllowCalDAVHeader, SB_SAllowCalDAVHeader);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SDirContentType, SB_SDirContentType, SB_SDirContentType);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SLockTokenPrefix, SB_SLockTokenPrefix, SB_SLockTokenPrefix);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SSerializeName, SB_SSerializeName, SB_SSerializeName);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SSerializeNS, SB_SSerializeNS, SB_SSerializeNS);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SLangEn, SB_SLangEn, SB_SLangEn);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SWriteProperties, SB_SWriteProperties, SB_SWriteProperties);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SWriteResourceContent, SB_SWriteResourceContent, SB_SWriteResourceContent);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SWriteACL, SB_SWriteACL, SB_SWriteACL);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SBind, SB_SBind, SB_SBind);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SUnbind, SB_SUnbind, SB_SUnbind);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SReadACL, SB_SReadACL, SB_SReadACL);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SReadCurrentUserPrivilegeSetProperty, SB_SReadCurrentUserPrivilegeSetProperty, SB_SReadCurrentUserPrivilegeSetProperty);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SUnlockResource, SB_SUnlockResource, SB_SUnlockResource);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SReadAnyObject, SB_SReadAnyObject, SB_SReadAnyObject);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SWriteAnyObject, SB_SWriteAnyObject, SB_SWriteAnyObject);
	SB_REGISTER_STRING_CONSTANT(SBWebDAVServer, SAnyOperation, SB_SAnyOperation, SB_SAnyOperation);
	SB_REGISTER_LONG_CONSTANT(SBWebDAVServer, wdpCalReadFreeBusy, SB_wdpCalReadFreeBusy, SB_wdpCalReadFreeBusy);
}

void Register_SBWebDAVServer_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBWebDavPropfindMode", NULL);
	TSBWebDavPropfindMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBWebDavPropfindMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavPropfindMode_ce_ptr, "pfmProp", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavPropfindMode_ce_ptr, "pfmPropname", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavPropfindMode_ce_ptr, "pfmAllprop", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBWebDavIfListType", NULL);
	TSBWebDavIfListType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBWebDavIfListType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavIfListType_ce_ptr, "ltNoTagged", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavIfListType_ce_ptr, "ltTagged", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavIfListType_ce_ptr, "ltUnknown", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBWebDavIfStateType", NULL);
	TSBWebDavIfStateType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBWebDavIfStateType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavIfStateType_ce_ptr, "stLockToken", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavIfStateType_ce_ptr, "stEtag", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBWebDavFileOpenMode", NULL);
	TSBWebDavFileOpenMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBWebDavFileOpenMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavFileOpenMode_ce_ptr, "wdfmOpenRead", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBWebDavFileOpenMode_ce_ptr, "wdfmOpenWrite", 1)
}

void Register_SBWebDAVServer_Aliases(TSRMLS_D)
{
	if (NULL == TElWebDAVServer_ce_ptr)
		Register_TElWebDAVServer(TSRMLS_C);
	zend_register_class_alias("ElWebDAVServer", TElWebDAVServer_ce_ptr);
	if (NULL == TElWebDavProperty_ce_ptr)
		Register_TElWebDavProperty(TSRMLS_C);
	zend_register_class_alias("ElWebDavProperty", TElWebDavProperty_ce_ptr);
	if (NULL == TElWebDavIfState_ce_ptr)
		Register_TElWebDavIfState(TSRMLS_C);
	zend_register_class_alias("ElWebDavIfState", TElWebDavIfState_ce_ptr);
	if (NULL == TElWebDavIfResource_ce_ptr)
		Register_TElWebDavIfResource(TSRMLS_C);
	zend_register_class_alias("ElWebDavIfResource", TElWebDavIfResource_ce_ptr);
	if (NULL == TElWebDAVIfHeader_ce_ptr)
		Register_TElWebDAVIfHeader(TSRMLS_C);
	zend_register_class_alias("ElWebDAVIfHeader", TElWebDAVIfHeader_ce_ptr);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	zend_register_class_alias("TElWebDavLockFindHandle", TObject_ce_ptr);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	zend_register_class_alias("ElWebDavLockFindHandle", TObject_ce_ptr);
	if (NULL == TElWebDAVCustomLockList_ce_ptr)
		Register_TElWebDAVCustomLockList(TSRMLS_C);
	zend_register_class_alias("ElWebDAVCustomLockList", TElWebDAVCustomLockList_ce_ptr);
	if (NULL == TElWebDAVMemoryLockList_ce_ptr)
		Register_TElWebDAVMemoryLockList(TSRMLS_C);
	zend_register_class_alias("ElWebDAVMemoryLockList", TElWebDAVMemoryLockList_ce_ptr);
}
