#include "sbxmlsamlcore.h"

void SB_CALLBACK TSBSAMLCertValidatorPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateValidatorHandle * CertValidator, TElX509CertificateHandle Cert)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zCertValidator;
	zval * zCert;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertValidator);
	SBInitObject(zCertValidator, TElX509CertificateValidator_ce_ptr, *CertValidator TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertValidator;
	params[2] = &zCert;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*CertValidator = SBGetObjectHandleCE(zCertValidator, TElX509CertificateValidator_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCertValidator TSRMLS_CC);
	zval_ptr_dtor(&zCertValidator);
	zval_ptr_dtor(&zCert);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLXMLSignerPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElXMLSignerHandle * Signer)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSigner;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSigner);
	SBInitObject(zSigner, TElXMLSigner_ce_ptr, *Signer TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSigner;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Signer = SBGetObjectHandleCE(zSigner, TElXMLSigner_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zSigner TSRMLS_CC);
	zval_ptr_dtor(&zSigner);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLXMLVerifierPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElXMLVerifierHandle * Verifier)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zVerifier;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zVerifier);
	SBInitObject(zVerifier, TElXMLVerifier_ce_ptr, *Verifier TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zVerifier;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Verifier = SBGetObjectHandleCE(zVerifier, TElXMLVerifier_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zVerifier TSRMLS_CC);
	zval_ptr_dtor(&zVerifier);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLXMLEncryptorPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElXMLEncryptorHandle * Encryptor)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zEncryptor;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEncryptor);
	SBInitObject(zEncryptor, TElXMLEncryptor_ce_ptr, *Encryptor TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zEncryptor;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Encryptor = SBGetObjectHandleCE(zEncryptor, TElXMLEncryptor_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zEncryptor TSRMLS_CC);
	zval_ptr_dtor(&zEncryptor);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLXMLDecryptorPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElXMLDecryptorHandle * Decryptor)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zDecryptor;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zDecryptor);
	SBInitObject(zDecryptor, TElXMLDecryptor_ce_ptr, *Decryptor TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zDecryptor;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Decryptor = SBGetObjectHandleCE(zDecryptor, TElXMLDecryptor_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zDecryptor TSRMLS_CC);
	zval_ptr_dtor(&zDecryptor);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBSAMLAuthnContextChoice_ce_ptr = NULL;

zend_class_entry *TSBSAMLDecision_ce_ptr = NULL;

zend_class_entry *TElSAMLElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLElement, Assign)
{
	zval *oOther;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOther, TElSAMLElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLElement_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOther TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLElement, get_Tag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLElement_get_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLElement, set_Tag)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLElement_set_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLElement, get_Handler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLElement_get_Handler(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSecurityHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLElement, set_Handler)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLElement_set_Handler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLElement, get_TextValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLElement_get_TextValue(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(555295703, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLElement_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Other, TElSAMLElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLElement_get_Tag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLElement_set_Tag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLElement_get_Handler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLElement_set_Handler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLElement_get_TextValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLElement_methods[] = {
	PHP_ME(TElSAMLElement, Assign, arginfo_TElSAMLElement_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLElement, LoadFromXML, arginfo_TElSAMLElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLElement, SaveToXML, arginfo_TElSAMLElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLElement, get_Tag, arginfo_TElSAMLElement_get_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLElement, set_Tag, arginfo_TElSAMLElement_set_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLElement, get_Handler, arginfo_TElSAMLElement_get_Handler, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLElement, set_Handler, arginfo_TElSAMLElement_set_Handler, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLElement, get_TextValue, arginfo_TElSAMLElement_get_TextValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLElement, __construct, arginfo_TElSAMLElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLElement", TElSAMLElement_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElSAMLElement_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLConditionsElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLConditionsElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLConditionsElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLConditionsElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLConditionsElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLConditionsElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, AddCondition)
{
	zval *oCond;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCond, TElSAMLConditionAbstractType_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLConditionsElement_AddCondition(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCond TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLConditionAbstractType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, RemoveCondition)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLConditionsElement_RemoveCondition(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, get_OneTimeUse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLConditionsElement_get_OneTimeUse(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLOneTimeUseElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, get_ProxyRestriction)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLConditionsElement_get_ProxyRestriction(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLProxyRestrictionElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, get_NotBefore)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLConditionsElement_get_NotBefore(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, set_NotBefore)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLConditionsElement_set_NotBefore(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, get_NotOnOrAfter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLConditionsElement_get_NotOnOrAfter(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, set_NotOnOrAfter)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLConditionsElement_set_NotOnOrAfter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, get_Conditions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLConditionsElement_get_Conditions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLConditionAbstractType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, get_ConditionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLConditionsElement_get_ConditionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLConditionsElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLConditionsElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_AddCondition, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cond, TElSAMLConditionAbstractType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_RemoveCondition, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_get_OneTimeUse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_get_ProxyRestriction, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_get_NotBefore, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_set_NotBefore, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_get_NotOnOrAfter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_set_NotOnOrAfter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_get_Conditions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement_get_ConditionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionsElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLConditionsElement_methods[] = {
	PHP_ME(TElSAMLConditionsElement, Clear, arginfo_TElSAMLConditionsElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, LoadFromXML, arginfo_TElSAMLConditionsElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, SaveToXML, arginfo_TElSAMLConditionsElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, AddCondition, arginfo_TElSAMLConditionsElement_AddCondition, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, RemoveCondition, arginfo_TElSAMLConditionsElement_RemoveCondition, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, get_OneTimeUse, arginfo_TElSAMLConditionsElement_get_OneTimeUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, get_ProxyRestriction, arginfo_TElSAMLConditionsElement_get_ProxyRestriction, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, get_NotBefore, arginfo_TElSAMLConditionsElement_get_NotBefore, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, set_NotBefore, arginfo_TElSAMLConditionsElement_set_NotBefore, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, get_NotOnOrAfter, arginfo_TElSAMLConditionsElement_get_NotOnOrAfter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, set_NotOnOrAfter, arginfo_TElSAMLConditionsElement_set_NotOnOrAfter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, get_Conditions, arginfo_TElSAMLConditionsElement_get_Conditions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, get_ConditionCount, arginfo_TElSAMLConditionsElement_get_ConditionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLConditionsElement, __construct, arginfo_TElSAMLConditionsElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLConditionsElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLConditionsElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLConditionsElement", TElSAMLConditionsElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLConditionsElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAdviceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAdviceElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAdviceElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdviceElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAdviceElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdviceElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdviceElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdviceElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdviceElement, AddAssertion)
{
	zval *oAssertion;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAssertion, TElSAMLAssertionType_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAdviceElement_AddAssertion(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAssertion TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAssertionType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdviceElement, RemoveAssertion)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLAdviceElement_RemoveAssertion(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdviceElement, get_Others)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdviceElement_get_Others(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdviceElement, get_Assertions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdviceElement_get_Assertions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLAssertionType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdviceElement, get_AssertionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAdviceElement_get_AssertionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdviceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdviceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdviceElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdviceElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdviceElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdviceElement_AddAssertion, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Assertion, TElSAMLAssertionType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdviceElement_RemoveAssertion, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdviceElement_get_Others, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdviceElement_get_Assertions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdviceElement_get_AssertionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdviceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAdviceElement_methods[] = {
	PHP_ME(TElSAMLAdviceElement, Clear, arginfo_TElSAMLAdviceElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdviceElement, LoadFromXML, arginfo_TElSAMLAdviceElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdviceElement, SaveToXML, arginfo_TElSAMLAdviceElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdviceElement, AddAssertion, arginfo_TElSAMLAdviceElement_AddAssertion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdviceElement, RemoveAssertion, arginfo_TElSAMLAdviceElement_RemoveAssertion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdviceElement, get_Others, arginfo_TElSAMLAdviceElement_get_Others, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdviceElement, get_Assertions, arginfo_TElSAMLAdviceElement_get_Assertions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdviceElement, get_AssertionCount, arginfo_TElSAMLAdviceElement_get_AssertionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdviceElement, __construct, arginfo_TElSAMLAdviceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAdviceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAdviceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAdviceElement", TElSAMLAdviceElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLAdviceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSubjectConfirmationDataElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, AddArbitraryElement)
{
	zval *oElem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElem, TElXMLCustomElement_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_AddArbitraryElement(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElem TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCustomElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, AddArbitraryAttribute)
{
	zval *oAttr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAttr, TElXMLDOMAttr_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_AddArbitraryAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAttr TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMAttr)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, RemoveArbitraryElement)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_RemoveArbitraryElement(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, RemoveArbitraryAttribute)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_RemoveArbitraryAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_AType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSubjectConfirmationDataElement_get_AType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1416147377, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, set_AType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_set_AType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_NotBefore)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_get_NotBefore(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, set_NotBefore)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_set_NotBefore(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_NotOnOrAfter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_get_NotOnOrAfter(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, set_NotOnOrAfter)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_set_NotOnOrAfter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_Recipient)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSubjectConfirmationDataElement_get_Recipient(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-250713820, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, set_Recipient)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_set_Recipient(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_InResponseTo)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSubjectConfirmationDataElement_get_InResponseTo(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1580134387, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, set_InResponseTo)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_set_InResponseTo(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSubjectConfirmationDataElement_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(496501356, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationDataElement_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_ArbitraryElements)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_get_ArbitraryElements(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCustomElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_ArbitraryAttributes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_get_ArbitraryAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_ArbitraryElementCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_get_ArbitraryElementCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, get_ArbitraryAttributeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_get_ArbitraryAttributeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationDataElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationDataElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_AddArbitraryElement, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Elem, TElXMLCustomElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_AddArbitraryAttribute, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attr, TElXMLDOMAttr, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_RemoveArbitraryElement, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_RemoveArbitraryAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_AType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_set_AType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_NotBefore, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_set_NotBefore, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_NotOnOrAfter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_set_NotOnOrAfter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_Recipient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_set_Recipient, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_InResponseTo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_set_InResponseTo, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_ArbitraryElements, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_ArbitraryAttributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_ArbitraryElementCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement_get_ArbitraryAttributeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationDataElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSubjectConfirmationDataElement_methods[] = {
	PHP_ME(TElSAMLSubjectConfirmationDataElement, Clear, arginfo_TElSAMLSubjectConfirmationDataElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, LoadFromXML, arginfo_TElSAMLSubjectConfirmationDataElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, SaveToXML, arginfo_TElSAMLSubjectConfirmationDataElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, AddArbitraryElement, arginfo_TElSAMLSubjectConfirmationDataElement_AddArbitraryElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, AddArbitraryAttribute, arginfo_TElSAMLSubjectConfirmationDataElement_AddArbitraryAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, RemoveArbitraryElement, arginfo_TElSAMLSubjectConfirmationDataElement_RemoveArbitraryElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, RemoveArbitraryAttribute, arginfo_TElSAMLSubjectConfirmationDataElement_RemoveArbitraryAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_AType, arginfo_TElSAMLSubjectConfirmationDataElement_get_AType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, set_AType, arginfo_TElSAMLSubjectConfirmationDataElement_set_AType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_NotBefore, arginfo_TElSAMLSubjectConfirmationDataElement_get_NotBefore, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, set_NotBefore, arginfo_TElSAMLSubjectConfirmationDataElement_set_NotBefore, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_NotOnOrAfter, arginfo_TElSAMLSubjectConfirmationDataElement_get_NotOnOrAfter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, set_NotOnOrAfter, arginfo_TElSAMLSubjectConfirmationDataElement_set_NotOnOrAfter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_Recipient, arginfo_TElSAMLSubjectConfirmationDataElement_get_Recipient, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, set_Recipient, arginfo_TElSAMLSubjectConfirmationDataElement_set_Recipient, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_InResponseTo, arginfo_TElSAMLSubjectConfirmationDataElement_get_InResponseTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, set_InResponseTo, arginfo_TElSAMLSubjectConfirmationDataElement_set_InResponseTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_Address, arginfo_TElSAMLSubjectConfirmationDataElement_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, set_Address, arginfo_TElSAMLSubjectConfirmationDataElement_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_ArbitraryElements, arginfo_TElSAMLSubjectConfirmationDataElement_get_ArbitraryElements, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_ArbitraryAttributes, arginfo_TElSAMLSubjectConfirmationDataElement_get_ArbitraryAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_ArbitraryElementCount, arginfo_TElSAMLSubjectConfirmationDataElement_get_ArbitraryElementCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, get_ArbitraryAttributeCount, arginfo_TElSAMLSubjectConfirmationDataElement_get_ArbitraryAttributeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationDataElement, __construct, arginfo_TElSAMLSubjectConfirmationDataElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSubjectConfirmationDataElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSubjectConfirmationDataElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSubjectConfirmationDataElement", TElSAMLSubjectConfirmationDataElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLSubjectConfirmationDataElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLStatementAbstractType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLStatementAbstractType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLStatementAbstractType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLStatementAbstractType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLStatementAbstractType_methods[] = {
	PHP_ME(TElSAMLStatementAbstractType, __construct, arginfo_TElSAMLStatementAbstractType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLStatementAbstractType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLStatementAbstractType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLStatementAbstractType", TElSAMLStatementAbstractType_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLStatementAbstractType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSubjectConfirmationElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, get_ID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationElement_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, set_ID)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLID_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationElement_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, get_SubjectConfirmationData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationElement_get_SubjectConfirmationData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSubjectConfirmationDataElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, set_SubjectConfirmationData)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLSubjectConfirmationDataElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationElement_set_SubjectConfirmationData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLSubjectConfirmationDataElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, get__Method)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSubjectConfirmationElement_get__Method(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1133655517, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, set__Method)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectConfirmationElement_set__Method(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectConfirmationElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectConfirmationElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement_set_ID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement_get_SubjectConfirmationData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement_set_SubjectConfirmationData, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLSubjectConfirmationDataElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement_get__Method, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement_set__Method, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectConfirmationElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSubjectConfirmationElement_methods[] = {
	PHP_ME(TElSAMLSubjectConfirmationElement, Clear, arginfo_TElSAMLSubjectConfirmationElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationElement, LoadFromXML, arginfo_TElSAMLSubjectConfirmationElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationElement, SaveToXML, arginfo_TElSAMLSubjectConfirmationElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationElement, get_ID, arginfo_TElSAMLSubjectConfirmationElement_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationElement, set_ID, arginfo_TElSAMLSubjectConfirmationElement_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationElement, get_SubjectConfirmationData, arginfo_TElSAMLSubjectConfirmationElement_get_SubjectConfirmationData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationElement, set_SubjectConfirmationData, arginfo_TElSAMLSubjectConfirmationElement_set_SubjectConfirmationData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationElement, get__Method, arginfo_TElSAMLSubjectConfirmationElement_get__Method, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationElement, set__Method, arginfo_TElSAMLSubjectConfirmationElement_set__Method, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectConfirmationElement, __construct, arginfo_TElSAMLSubjectConfirmationElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSubjectConfirmationElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSubjectConfirmationElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSubjectConfirmationElement", TElSAMLSubjectConfirmationElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLSubjectConfirmationElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSecurityHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSecurityHandler, Protect)
{
	zval *oDocument;
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oNode, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSecurityHandler_Protect(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSecurityHandler, Unprotect)
{
	TElClassHandle hoOutput = SB_NULL_HANDLE;
	zval *oDocument;
	zval *oInput;
	zval *oOutput;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oDocument, TElXMLDOMDocument_ce_ptr, &oInput, TElXMLDOMElement_ce_ptr, &oOutput, TElXMLDOMElement_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oOutput) && (IS_OBJECT == Z_TYPE_P(oOutput)))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSecurityHandler_Unprotect(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oInput TSRMLS_CC), &hoOutput, &bOutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oOutput, hoOutput TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLDOMElement, &TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSecurityHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSecurityHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSecurityHandler_Protect, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSecurityHandler_Unprotect, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Input, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(1, Output, TElXMLDOMElement, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSecurityHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSecurityHandler_methods[] = {
	PHP_ME(TElSAMLSecurityHandler, Protect, arginfo_TElSAMLSecurityHandler_Protect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSecurityHandler, Unprotect, arginfo_TElSAMLSecurityHandler_Unprotect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSecurityHandler, __construct, arginfo_TElSAMLSecurityHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSecurityHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSecurityHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSecurityHandler", TElSAMLSecurityHandler_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLSecurityHandler_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSignatureHandler, Protect)
{
	zval *oDocument;
	zval *oElem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oElem, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSignatureHandler_Protect(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oElem TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, Unprotect)
{
	TElClassHandle hoOutput = SB_NULL_HANDLE;
	zval *oDocument;
	zval *oInput;
	zval *oOutput;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oDocument, TElXMLDOMDocument_ce_ptr, &oInput, TElXMLDOMElement_ce_ptr, &oOutput, TElXMLDOMElement_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oOutput) && (IS_OBJECT == Z_TYPE_P(oOutput)))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSignatureHandler_Unprotect(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oInput TSRMLS_CC), &hoOutput, &bOutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oOutput, hoOutput TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLDOMElement, &TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSignatureHandler_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSignatureHandler_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_Certificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSignatureHandler_get_Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, set_Certificate)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSignatureHandler_set_Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_VerificationResult)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSignatureHandler_get_VerificationResult(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-662041688, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_ValidateCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSignatureHandler_get_ValidateCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, set_ValidateCertificate)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSignatureHandler_set_ValidateCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_ValidateReferences)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSignatureHandler_get_ValidateReferences(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, set_ValidateReferences)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSignatureHandler_set_ValidateReferences(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_CanonicalizationMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLCanonicalizationMethodRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLSignatureHandler_get_CanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, set_CanonicalizationMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSignatureHandler_set_CanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_SignatureAfterIssuer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSignatureHandler_get_SignatureAfterIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, set_SignatureAfterIssuer)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSignatureHandler_set_SignatureAfterIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_OnValidatorPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLCertValidatorPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLSignatureHandler_get_OnValidatorPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, set_OnValidatorPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLSignatureHandler_set_OnValidatorPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLCertValidatorPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLCertValidatorPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_OnSignerPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLXMLSignerPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLSignatureHandler_get_OnSignerPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, set_OnSignerPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLSignatureHandler_set_OnSignerPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLXMLSignerPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLXMLSignerPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, get_OnVerifierPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLXMLVerifierPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLSignatureHandler_get_OnVerifierPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, set_OnVerifierPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLSignatureHandler_set_OnVerifierPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLXMLVerifierPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLXMLVerifierPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSignatureHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSignatureHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_Protect, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Elem, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_Unprotect, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Input, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(1, Output, TElXMLDOMElement, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_Certificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_set_Certificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_VerificationResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_ValidateCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_set_ValidateCertificate, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_ValidateReferences, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_set_ValidateReferences, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_CanonicalizationMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_set_CanonicalizationMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_SignatureAfterIssuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_set_SignatureAfterIssuer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_OnValidatorPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_set_OnValidatorPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_OnSignerPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_set_OnSignerPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_get_OnVerifierPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler_set_OnVerifierPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSignatureHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSignatureHandler_methods[] = {
	PHP_ME(TElSAMLSignatureHandler, Protect, arginfo_TElSAMLSignatureHandler_Protect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, Unprotect, arginfo_TElSAMLSignatureHandler_Unprotect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_CertStorage, arginfo_TElSAMLSignatureHandler_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, set_CertStorage, arginfo_TElSAMLSignatureHandler_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_Certificate, arginfo_TElSAMLSignatureHandler_get_Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, set_Certificate, arginfo_TElSAMLSignatureHandler_set_Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_VerificationResult, arginfo_TElSAMLSignatureHandler_get_VerificationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_ValidateCertificate, arginfo_TElSAMLSignatureHandler_get_ValidateCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, set_ValidateCertificate, arginfo_TElSAMLSignatureHandler_set_ValidateCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_ValidateReferences, arginfo_TElSAMLSignatureHandler_get_ValidateReferences, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, set_ValidateReferences, arginfo_TElSAMLSignatureHandler_set_ValidateReferences, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_CanonicalizationMethod, arginfo_TElSAMLSignatureHandler_get_CanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, set_CanonicalizationMethod, arginfo_TElSAMLSignatureHandler_set_CanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_SignatureAfterIssuer, arginfo_TElSAMLSignatureHandler_get_SignatureAfterIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, set_SignatureAfterIssuer, arginfo_TElSAMLSignatureHandler_set_SignatureAfterIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_OnValidatorPrepared, arginfo_TElSAMLSignatureHandler_get_OnValidatorPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, set_OnValidatorPrepared, arginfo_TElSAMLSignatureHandler_set_OnValidatorPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_OnSignerPrepared, arginfo_TElSAMLSignatureHandler_get_OnSignerPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, set_OnSignerPrepared, arginfo_TElSAMLSignatureHandler_set_OnSignerPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, get_OnVerifierPrepared, arginfo_TElSAMLSignatureHandler_get_OnVerifierPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, set_OnVerifierPrepared, arginfo_TElSAMLSignatureHandler_set_OnVerifierPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSignatureHandler, __construct, arginfo_TElSAMLSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSignatureHandler", TElSAMLSignatureHandler_methods);
	if (NULL == TElSAMLSecurityHandler_ce_ptr)
		Register_TElSAMLSecurityHandler(TSRMLS_C);
	TElSAMLSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLSecurityHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEncryptionHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEncryptionHandler, Protect)
{
	zval *oDocument;
	zval *oElem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oElem, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptionHandler_Protect(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oElem TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, Unprotect)
{
	TElClassHandle hoOutput = SB_NULL_HANDLE;
	zval *oDocument;
	zval *oInput;
	zval *oOutput;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oDocument, TElXMLDOMDocument_ce_ptr, &oInput, TElXMLDOMElement_ce_ptr, &oOutput, TElXMLDOMElement_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oOutput) && (IS_OBJECT == Z_TYPE_P(oOutput)))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLEncryptionHandler_Unprotect(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oInput TSRMLS_CC), &hoOutput, &bOutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oOutput, hoOutput TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLDOMElement, &TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, get_Certificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptionHandler_get_Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, set_Certificate)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptionHandler_set_Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, get_DecryptionResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLEncryptionHandler_get_DecryptionResult(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, set_DecryptionResult)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptionHandler_set_DecryptionResult(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, get_OnXMLEncryptorPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLXMLEncryptorPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLEncryptionHandler_get_OnXMLEncryptorPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, set_OnXMLEncryptorPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLEncryptionHandler_set_OnXMLEncryptorPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLXMLEncryptorPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLXMLEncryptorPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, get_OnXMLDecryptorPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLXMLDecryptorPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLEncryptionHandler_get_OnXMLDecryptorPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, set_OnXMLDecryptorPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLEncryptionHandler_set_OnXMLDecryptorPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLXMLDecryptorPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLXMLDecryptorPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptionHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_Protect, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Elem, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_Unprotect, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Input, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(1, Output, TElXMLDOMElement, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_get_Certificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_set_Certificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_get_DecryptionResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_set_DecryptionResult, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_get_OnXMLEncryptorPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_set_OnXMLEncryptorPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_get_OnXMLDecryptorPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler_set_OnXMLDecryptorPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEncryptionHandler_methods[] = {
	PHP_ME(TElSAMLEncryptionHandler, Protect, arginfo_TElSAMLEncryptionHandler_Protect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, Unprotect, arginfo_TElSAMLEncryptionHandler_Unprotect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, get_Certificate, arginfo_TElSAMLEncryptionHandler_get_Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, set_Certificate, arginfo_TElSAMLEncryptionHandler_set_Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, get_DecryptionResult, arginfo_TElSAMLEncryptionHandler_get_DecryptionResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, set_DecryptionResult, arginfo_TElSAMLEncryptionHandler_set_DecryptionResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, get_OnXMLEncryptorPrepared, arginfo_TElSAMLEncryptionHandler_get_OnXMLEncryptorPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, set_OnXMLEncryptorPrepared, arginfo_TElSAMLEncryptionHandler_set_OnXMLEncryptorPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, get_OnXMLDecryptorPrepared, arginfo_TElSAMLEncryptionHandler_get_OnXMLDecryptorPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, set_OnXMLDecryptorPrepared, arginfo_TElSAMLEncryptionHandler_set_OnXMLDecryptorPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionHandler, __construct, arginfo_TElSAMLEncryptionHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEncryptionHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEncryptionHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEncryptionHandler", TElSAMLEncryptionHandler_methods);
	if (NULL == TElSAMLSecurityHandler_ce_ptr)
		Register_TElSAMLSecurityHandler(TSRMLS_C);
	TElSAMLEncryptionHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLSecurityHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSubjectElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSubjectElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, AddSubjectConfirmation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLSubjectElement_AddSubjectConfirmation(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, RemoveSubjectConfirmation)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectElement_RemoveSubjectConfirmation(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, get_Sequence)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSubjectElement_get_Sequence(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, get_ID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectElement_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, set_ID)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLID_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectElement_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, get_SubjectConfirmations)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectElement_get_SubjectConfirmations(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSubjectConfirmationElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, get_SubjectConfirmationCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLSubjectElement_get_SubjectConfirmationCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_AddSubjectConfirmation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_RemoveSubjectConfirmation, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_get_Sequence, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_set_ID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_get_SubjectConfirmations, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement_get_SubjectConfirmationCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSubjectElement_methods[] = {
	PHP_ME(TElSAMLSubjectElement, Clear, arginfo_TElSAMLSubjectElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, LoadFromXML, arginfo_TElSAMLSubjectElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, SaveToXML, arginfo_TElSAMLSubjectElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, AddSubjectConfirmation, arginfo_TElSAMLSubjectElement_AddSubjectConfirmation, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, RemoveSubjectConfirmation, arginfo_TElSAMLSubjectElement_RemoveSubjectConfirmation, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, get_Sequence, arginfo_TElSAMLSubjectElement_get_Sequence, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, get_ID, arginfo_TElSAMLSubjectElement_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, set_ID, arginfo_TElSAMLSubjectElement_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, get_SubjectConfirmations, arginfo_TElSAMLSubjectElement_get_SubjectConfirmations, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, get_SubjectConfirmationCount, arginfo_TElSAMLSubjectElement_get_SubjectConfirmationCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectElement, __construct, arginfo_TElSAMLSubjectElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSubjectElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSubjectElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSubjectElement", TElSAMLSubjectElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLSubjectElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLID_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLID, CompareTo)
{
	zval *oOther;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOther, TElSAMLID_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLID_CompareTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOther TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLID, CreateByName_Inst)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLID_CreateByName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLID, CreateByName)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLID_CreateByName(sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLID, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLID_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLID_CompareTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Other, TElSAMLID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLID_CreateByName_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLID_CreateByName, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLID___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLID_methods[] = {
	PHP_ME(TElSAMLID, CompareTo, arginfo_TElSAMLID_CompareTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLID, CreateByName_Inst, arginfo_TElSAMLID_CreateByName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLID, CreateByName, arginfo_TElSAMLID_CreateByName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSAMLID, __construct, arginfo_TElSAMLID___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLID(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLID_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLID", TElSAMLID_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLID_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLBaseIDElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLBaseIDElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLBaseIDElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBaseIDElement, CompareTo)
{
	zval *oOther;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOther, TElSAMLID_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLBaseIDElement_CompareTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOther TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBaseIDElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLBaseIDElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBaseIDElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLBaseIDElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLBaseIDElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBaseIDElement, get_NameQualifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLBaseIDElement_get_NameQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-416329181, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBaseIDElement, set_NameQualifier)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLBaseIDElement_set_NameQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBaseIDElement, get_SPNameQualifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLBaseIDElement_get_SPNameQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-958183618, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBaseIDElement, set_SPNameQualifier)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLBaseIDElement_set_SPNameQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLBaseIDElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLBaseIDElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBaseIDElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBaseIDElement_CompareTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Other, TElSAMLID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBaseIDElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBaseIDElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBaseIDElement_get_NameQualifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBaseIDElement_set_NameQualifier, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBaseIDElement_get_SPNameQualifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBaseIDElement_set_SPNameQualifier, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLBaseIDElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLBaseIDElement_methods[] = {
	PHP_ME(TElSAMLBaseIDElement, Clear, arginfo_TElSAMLBaseIDElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBaseIDElement, CompareTo, arginfo_TElSAMLBaseIDElement_CompareTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBaseIDElement, LoadFromXML, arginfo_TElSAMLBaseIDElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBaseIDElement, SaveToXML, arginfo_TElSAMLBaseIDElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBaseIDElement, get_NameQualifier, arginfo_TElSAMLBaseIDElement_get_NameQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBaseIDElement, set_NameQualifier, arginfo_TElSAMLBaseIDElement_set_NameQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBaseIDElement, get_SPNameQualifier, arginfo_TElSAMLBaseIDElement_get_SPNameQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBaseIDElement, set_SPNameQualifier, arginfo_TElSAMLBaseIDElement_set_SPNameQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLBaseIDElement, __construct, arginfo_TElSAMLBaseIDElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLBaseIDElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLBaseIDElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLBaseIDElement", TElSAMLBaseIDElement_methods);
	if (NULL == TElSAMLID_ce_ptr)
		Register_TElSAMLID(TSRMLS_C);
	TElSAMLBaseIDElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLID_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLNameIDElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLNameIDElement, Assign)
{
	zval *oOther;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOther, TElSAMLElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLNameIDElement_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOther TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLNameIDElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, CompareTo)
{
	zval *oOther;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOther, TElSAMLID_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLNameIDElement_CompareTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOther TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLNameIDElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLNameIDElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLNameIDElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLNameIDElement_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1573865641, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLNameIDElement_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, get_NameQualifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLNameIDElement_get_NameQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(318386129, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, set_NameQualifier)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLNameIDElement_set_NameQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, get_SPNameQualifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLNameIDElement_get_SPNameQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-824361899, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, set_SPNameQualifier)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLNameIDElement_set_SPNameQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, get_Format)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLNameIDElement_get_Format(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-658707873, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, set_Format)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLNameIDElement_set_Format(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, get_SPProvidedID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLNameIDElement_get_SPProvidedID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1911942527, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, set_SPProvidedID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLNameIDElement_set_SPProvidedID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLNameIDElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLNameIDElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Other, TElSAMLElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_CompareTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Other, TElSAMLID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_get_NameQualifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_set_NameQualifier, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_get_SPNameQualifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_set_SPNameQualifier, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_get_Format, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_set_Format, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_get_SPProvidedID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement_set_SPProvidedID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLNameIDElement_methods[] = {
	PHP_ME(TElSAMLNameIDElement, Assign, arginfo_TElSAMLNameIDElement_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, Clear, arginfo_TElSAMLNameIDElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, CompareTo, arginfo_TElSAMLNameIDElement_CompareTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, LoadFromXML, arginfo_TElSAMLNameIDElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, SaveToXML, arginfo_TElSAMLNameIDElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, get_Value, arginfo_TElSAMLNameIDElement_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, set_Value, arginfo_TElSAMLNameIDElement_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, get_NameQualifier, arginfo_TElSAMLNameIDElement_get_NameQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, set_NameQualifier, arginfo_TElSAMLNameIDElement_set_NameQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, get_SPNameQualifier, arginfo_TElSAMLNameIDElement_get_SPNameQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, set_SPNameQualifier, arginfo_TElSAMLNameIDElement_set_SPNameQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, get_Format, arginfo_TElSAMLNameIDElement_get_Format, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, set_Format, arginfo_TElSAMLNameIDElement_set_Format, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, get_SPProvidedID, arginfo_TElSAMLNameIDElement_get_SPProvidedID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, set_SPProvidedID, arginfo_TElSAMLNameIDElement_set_SPProvidedID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLNameIDElement, __construct, arginfo_TElSAMLNameIDElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLNameIDElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLNameIDElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLNameIDElement", TElSAMLNameIDElement_methods);
	if (NULL == TElSAMLID_ce_ptr)
		Register_TElSAMLID(TSRMLS_C);
	TElSAMLNameIDElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLID_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEncryptedElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEncryptedElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedElement, Encrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedElement_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedElement, Decrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedElement_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedElement, get_ElementName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEncryptedElement_get_ElementName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(351879124, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedElement, set_ElementName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedElement_set_ElementName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedElement, get_Decrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLEncryptedElement_get_Decrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedElement, set_Decrypted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedElement_set_Decrypted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement_Encrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement_Decrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement_get_ElementName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement_set_ElementName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement_get_Decrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement_set_Decrypted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEncryptedElement_methods[] = {
	PHP_ME(TElSAMLEncryptedElement, Clear, arginfo_TElSAMLEncryptedElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedElement, LoadFromXML, arginfo_TElSAMLEncryptedElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedElement, SaveToXML, arginfo_TElSAMLEncryptedElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedElement, Encrypt, arginfo_TElSAMLEncryptedElement_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedElement, Decrypt, arginfo_TElSAMLEncryptedElement_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedElement, get_ElementName, arginfo_TElSAMLEncryptedElement_get_ElementName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedElement, set_ElementName, arginfo_TElSAMLEncryptedElement_set_ElementName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedElement, get_Decrypted, arginfo_TElSAMLEncryptedElement_get_Decrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedElement, set_Decrypted, arginfo_TElSAMLEncryptedElement_set_Decrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedElement, __construct, arginfo_TElSAMLEncryptedElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEncryptedElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEncryptedElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEncryptedElement", TElSAMLEncryptedElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLEncryptedElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEncryptedIDElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEncryptedIDElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedIDElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, CompareTo)
{
	zval *oOther;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOther, TElSAMLID_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLEncryptedIDElement_CompareTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOther TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedIDElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedIDElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedIDElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, Encrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedIDElement_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, Decrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedIDElement_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, get_EncryptedElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedIDElement_get_EncryptedElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLEncryptedElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, set_EncryptedElement)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLEncryptedElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedIDElement_set_EncryptedElement(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLEncryptedElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, get_ID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedIDElement_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, set_ID)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLID_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedIDElement_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedIDElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedIDElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_CompareTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Other, TElSAMLID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_Encrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_Decrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_get_EncryptedElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_set_EncryptedElement, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLEncryptedElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement_set_ID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedIDElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEncryptedIDElement_methods[] = {
	PHP_ME(TElSAMLEncryptedIDElement, Clear, arginfo_TElSAMLEncryptedIDElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, CompareTo, arginfo_TElSAMLEncryptedIDElement_CompareTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, LoadFromXML, arginfo_TElSAMLEncryptedIDElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, SaveToXML, arginfo_TElSAMLEncryptedIDElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, Encrypt, arginfo_TElSAMLEncryptedIDElement_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, Decrypt, arginfo_TElSAMLEncryptedIDElement_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, get_EncryptedElement, arginfo_TElSAMLEncryptedIDElement_get_EncryptedElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, set_EncryptedElement, arginfo_TElSAMLEncryptedIDElement_set_EncryptedElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, get_ID, arginfo_TElSAMLEncryptedIDElement_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, set_ID, arginfo_TElSAMLEncryptedIDElement_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedIDElement, __construct, arginfo_TElSAMLEncryptedIDElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEncryptedIDElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEncryptedIDElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEncryptedIDElement", TElSAMLEncryptedIDElement_methods);
	if (NULL == TElSAMLID_ce_ptr)
		Register_TElSAMLID(TSRMLS_C);
	TElSAMLEncryptedIDElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLID_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLIssuerElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLIssuerElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLIssuerElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIssuerElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIssuerElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIssuerElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIssuerElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLIssuerElement_methods[] = {
	PHP_ME(TElSAMLIssuerElement, LoadFromXML, arginfo_TElSAMLIssuerElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIssuerElement, __construct, arginfo_TElSAMLIssuerElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLIssuerElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLIssuerElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLIssuerElement", TElSAMLIssuerElement_methods);
	if (NULL == TElSAMLNameIDElement_ce_ptr)
		Register_TElSAMLNameIDElement(TSRMLS_C);
	TElSAMLIssuerElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLNameIDElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAssertionType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAssertionType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAssertionType_methods[] = {
	PHP_ME(TElSAMLAssertionType, __construct, arginfo_TElSAMLAssertionType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAssertionType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAssertionType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAssertionType", TElSAMLAssertionType_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLAssertionType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAssertionIDRefElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAssertionIDRefElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionIDRefElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionIDRefElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionIDRefElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionIDRefElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionIDRefElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionIDRefElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionIDRefElement, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAssertionIDRefElement_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2101556489, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionIDRefElement, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionIDRefElement_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionIDRefElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionIDRefElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionIDRefElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionIDRefElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionIDRefElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionIDRefElement_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionIDRefElement_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionIDRefElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAssertionIDRefElement_methods[] = {
	PHP_ME(TElSAMLAssertionIDRefElement, Clear, arginfo_TElSAMLAssertionIDRefElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionIDRefElement, LoadFromXML, arginfo_TElSAMLAssertionIDRefElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionIDRefElement, SaveToXML, arginfo_TElSAMLAssertionIDRefElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionIDRefElement, get_Value, arginfo_TElSAMLAssertionIDRefElement_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionIDRefElement, set_Value, arginfo_TElSAMLAssertionIDRefElement_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionIDRefElement, __construct, arginfo_TElSAMLAssertionIDRefElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAssertionIDRefElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAssertionIDRefElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAssertionIDRefElement", TElSAMLAssertionIDRefElement_methods);
	if (NULL == TElSAMLAssertionType_ce_ptr)
		Register_TElSAMLAssertionType(TSRMLS_C);
	TElSAMLAssertionIDRefElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLAssertionType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAssertionURIRefElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAssertionURIRefElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionURIRefElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionURIRefElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionURIRefElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionURIRefElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionURIRefElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionURIRefElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionURIRefElement, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAssertionURIRefElement_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-538814587, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionURIRefElement, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionURIRefElement_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionURIRefElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionURIRefElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionURIRefElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionURIRefElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionURIRefElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionURIRefElement_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionURIRefElement_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionURIRefElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAssertionURIRefElement_methods[] = {
	PHP_ME(TElSAMLAssertionURIRefElement, Clear, arginfo_TElSAMLAssertionURIRefElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionURIRefElement, LoadFromXML, arginfo_TElSAMLAssertionURIRefElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionURIRefElement, SaveToXML, arginfo_TElSAMLAssertionURIRefElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionURIRefElement, get_Value, arginfo_TElSAMLAssertionURIRefElement_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionURIRefElement, set_Value, arginfo_TElSAMLAssertionURIRefElement_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionURIRefElement, __construct, arginfo_TElSAMLAssertionURIRefElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAssertionURIRefElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAssertionURIRefElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAssertionURIRefElement", TElSAMLAssertionURIRefElement_methods);
	if (NULL == TElSAMLAssertionType_ce_ptr)
		Register_TElSAMLAssertionType(TSRMLS_C);
	TElSAMLAssertionURIRefElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLAssertionType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAssertionElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAssertionElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, LoadFromXML)
{
	zend_bool bClearBefore;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oElement, TElXMLDOMElement_ce_ptr, &bClearBefore) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_LoadFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), (int8_t)bClearBefore) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement) or (TElXMLDOMElement, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, AddStatement)
{
	zval *oSt;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSt, TElSAMLStatementAbstractType_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAssertionElement_AddStatement(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSt TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLStatementAbstractType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, RemoveStatement)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_RemoveStatement(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_Signed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLAssertionElement_get_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, set_Signed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_set_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_Version)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAssertionElement_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2133065494, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, set_Version)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAssertionElement_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1006347946, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_IssueInstant)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLAssertionElement_get_IssueInstant(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, set_IssueInstant)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_set_IssueInstant(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_Issuer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionElement_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLIssuerElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, set_Issuer)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLIssuerElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_set_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLIssuerElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_Signature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionElement_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_Subject)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionElement_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSubjectElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, set_Subject)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLSubjectElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_set_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLSubjectElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_Conditions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionElement_get_Conditions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLConditionsElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, set_Conditions)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLConditionsElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_set_Conditions(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLConditionsElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_Advice)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionElement_get_Advice(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLAdviceElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, set_Advice)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLAdviceElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAssertionElement_set_Advice(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAdviceElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_Statements)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionElement_get_Statements(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLStatementAbstractType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, get_StatementCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAssertionElement_get_StatementCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAssertionElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
	ZEND_ARG_INFO(0, ClearBefore)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_AddStatement, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, St, TElSAMLStatementAbstractType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_RemoveStatement, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_Signed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_set_Signed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_IssueInstant, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_set_IssueInstant, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_set_Issuer, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLIssuerElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_set_Subject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLSubjectElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_Conditions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_set_Conditions, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLConditionsElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_Advice, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_set_Advice, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLAdviceElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_Statements, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement_get_StatementCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAssertionElement_methods[] = {
	PHP_ME(TElSAMLAssertionElement, Clear, arginfo_TElSAMLAssertionElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, LoadFromXML, arginfo_TElSAMLAssertionElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, SaveToXML, arginfo_TElSAMLAssertionElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, AddStatement, arginfo_TElSAMLAssertionElement_AddStatement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, RemoveStatement, arginfo_TElSAMLAssertionElement_RemoveStatement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_Signed, arginfo_TElSAMLAssertionElement_get_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, set_Signed, arginfo_TElSAMLAssertionElement_set_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_Version, arginfo_TElSAMLAssertionElement_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, set_Version, arginfo_TElSAMLAssertionElement_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_ID, arginfo_TElSAMLAssertionElement_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, set_ID, arginfo_TElSAMLAssertionElement_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_IssueInstant, arginfo_TElSAMLAssertionElement_get_IssueInstant, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, set_IssueInstant, arginfo_TElSAMLAssertionElement_set_IssueInstant, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_Issuer, arginfo_TElSAMLAssertionElement_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, set_Issuer, arginfo_TElSAMLAssertionElement_set_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_Signature, arginfo_TElSAMLAssertionElement_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_Subject, arginfo_TElSAMLAssertionElement_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, set_Subject, arginfo_TElSAMLAssertionElement_set_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_Conditions, arginfo_TElSAMLAssertionElement_get_Conditions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, set_Conditions, arginfo_TElSAMLAssertionElement_set_Conditions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_Advice, arginfo_TElSAMLAssertionElement_get_Advice, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, set_Advice, arginfo_TElSAMLAssertionElement_set_Advice, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_Statements, arginfo_TElSAMLAssertionElement_get_Statements, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, get_StatementCount, arginfo_TElSAMLAssertionElement_get_StatementCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAssertionElement, __construct, arginfo_TElSAMLAssertionElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAssertionElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAssertionElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAssertionElement", TElSAMLAssertionElement_methods);
	if (NULL == TElSAMLAssertionType_ce_ptr)
		Register_TElSAMLAssertionType(TSRMLS_C);
	TElSAMLAssertionElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLAssertionType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEncryptedAssertionElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEncryptedAssertionElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedAssertionElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAssertionElement, LoadFromXML)
{
	zend_bool bClearBefore;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedAssertionElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oElement, TElXMLDOMElement_ce_ptr, &bClearBefore) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedAssertionElement_LoadFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), (int8_t)bClearBefore) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement) or (TElXMLDOMElement, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAssertionElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedAssertionElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedAssertionElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAssertionElement, Decrypt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedAssertionElement_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAssertionElement, get_Decrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLEncryptedAssertionElement_get_Decrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAssertionElement, get_EncryptedElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedAssertionElement_get_EncryptedElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLEncryptedElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAssertionElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedAssertionElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAssertionElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAssertionElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
	ZEND_ARG_INFO(0, ClearBefore)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAssertionElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAssertionElement_Decrypt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAssertionElement_get_Decrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAssertionElement_get_EncryptedElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAssertionElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEncryptedAssertionElement_methods[] = {
	PHP_ME(TElSAMLEncryptedAssertionElement, Clear, arginfo_TElSAMLEncryptedAssertionElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAssertionElement, LoadFromXML, arginfo_TElSAMLEncryptedAssertionElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAssertionElement, SaveToXML, arginfo_TElSAMLEncryptedAssertionElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAssertionElement, Decrypt, arginfo_TElSAMLEncryptedAssertionElement_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAssertionElement, get_Decrypted, arginfo_TElSAMLEncryptedAssertionElement_get_Decrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAssertionElement, get_EncryptedElement, arginfo_TElSAMLEncryptedAssertionElement_get_EncryptedElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAssertionElement, __construct, arginfo_TElSAMLEncryptedAssertionElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEncryptedAssertionElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEncryptedAssertionElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEncryptedAssertionElement", TElSAMLEncryptedAssertionElement_methods);
	if (NULL == TElSAMLAssertionElement_ce_ptr)
		Register_TElSAMLAssertionElement(TSRMLS_C);
	TElSAMLEncryptedAssertionElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLAssertionElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLConditionAbstractType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLConditionAbstractType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLConditionAbstractType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLConditionAbstractType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLConditionAbstractType_methods[] = {
	PHP_ME(TElSAMLConditionAbstractType, __construct, arginfo_TElSAMLConditionAbstractType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLConditionAbstractType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLConditionAbstractType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLConditionAbstractType", TElSAMLConditionAbstractType_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLConditionAbstractType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAudienceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAudienceElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAudienceElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAudienceElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAudienceElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAudienceElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceElement, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAudienceElement_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1019261914, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceElement, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAudienceElement_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAudienceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceElement_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceElement_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAudienceElement_methods[] = {
	PHP_ME(TElSAMLAudienceElement, Clear, arginfo_TElSAMLAudienceElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceElement, LoadFromXML, arginfo_TElSAMLAudienceElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceElement, SaveToXML, arginfo_TElSAMLAudienceElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceElement, get_Value, arginfo_TElSAMLAudienceElement_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceElement, set_Value, arginfo_TElSAMLAudienceElement_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceElement, __construct, arginfo_TElSAMLAudienceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAudienceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAudienceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAudienceElement", TElSAMLAudienceElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLAudienceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAudienceRestrictionElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAudienceRestrictionElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAudienceRestrictionElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceRestrictionElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAudienceRestrictionElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceRestrictionElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAudienceRestrictionElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAudienceRestrictionElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceRestrictionElement, AddAudience)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAudienceRestrictionElement_AddAudience(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceRestrictionElement, RemoveAudience)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLAudienceRestrictionElement_RemoveAudience(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceRestrictionElement, get_AudienceList)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAudienceRestrictionElement_get_AudienceList(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLAudienceElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceRestrictionElement, get_AudienceCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAudienceRestrictionElement_get_AudienceCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAudienceRestrictionElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAudienceRestrictionElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceRestrictionElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceRestrictionElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceRestrictionElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceRestrictionElement_AddAudience, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceRestrictionElement_RemoveAudience, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceRestrictionElement_get_AudienceList, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceRestrictionElement_get_AudienceCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAudienceRestrictionElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAudienceRestrictionElement_methods[] = {
	PHP_ME(TElSAMLAudienceRestrictionElement, Clear, arginfo_TElSAMLAudienceRestrictionElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceRestrictionElement, LoadFromXML, arginfo_TElSAMLAudienceRestrictionElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceRestrictionElement, SaveToXML, arginfo_TElSAMLAudienceRestrictionElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceRestrictionElement, AddAudience, arginfo_TElSAMLAudienceRestrictionElement_AddAudience, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceRestrictionElement, RemoveAudience, arginfo_TElSAMLAudienceRestrictionElement_RemoveAudience, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceRestrictionElement, get_AudienceList, arginfo_TElSAMLAudienceRestrictionElement_get_AudienceList, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceRestrictionElement, get_AudienceCount, arginfo_TElSAMLAudienceRestrictionElement_get_AudienceCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAudienceRestrictionElement, __construct, arginfo_TElSAMLAudienceRestrictionElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAudienceRestrictionElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAudienceRestrictionElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAudienceRestrictionElement", TElSAMLAudienceRestrictionElement_methods);
	if (NULL == TElSAMLConditionAbstractType_ce_ptr)
		Register_TElSAMLConditionAbstractType(TSRMLS_C);
	TElSAMLAudienceRestrictionElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLConditionAbstractType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLOneTimeUseElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLOneTimeUseElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLOneTimeUseElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOneTimeUseElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOneTimeUseElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOneTimeUseElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOneTimeUseElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOneTimeUseElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOneTimeUseElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOneTimeUseElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOneTimeUseElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLOneTimeUseElement_methods[] = {
	PHP_ME(TElSAMLOneTimeUseElement, LoadFromXML, arginfo_TElSAMLOneTimeUseElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOneTimeUseElement, SaveToXML, arginfo_TElSAMLOneTimeUseElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOneTimeUseElement, __construct, arginfo_TElSAMLOneTimeUseElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLOneTimeUseElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLOneTimeUseElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLOneTimeUseElement", TElSAMLOneTimeUseElement_methods);
	if (NULL == TElSAMLConditionAbstractType_ce_ptr)
		Register_TElSAMLConditionAbstractType(TSRMLS_C);
	TElSAMLOneTimeUseElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLConditionAbstractType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLProxyRestrictionElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLProxyRestrictionElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLProxyRestrictionElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLProxyRestrictionElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLProxyRestrictionElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLProxyRestrictionElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLProxyRestrictionElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLProxyRestrictionElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLProxyRestrictionElement, AddAudience)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLProxyRestrictionElement_AddAudience(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLProxyRestrictionElement, RemoveAudience)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLProxyRestrictionElement_RemoveAudience(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLProxyRestrictionElement, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLProxyRestrictionElement_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLProxyRestrictionElement, get_AudienceList)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLProxyRestrictionElement_get_AudienceList(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLAudienceElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLProxyRestrictionElement, get_AudienceCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLProxyRestrictionElement_get_AudienceCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLProxyRestrictionElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLProxyRestrictionElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLProxyRestrictionElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLProxyRestrictionElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLProxyRestrictionElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLProxyRestrictionElement_AddAudience, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLProxyRestrictionElement_RemoveAudience, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLProxyRestrictionElement_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLProxyRestrictionElement_get_AudienceList, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLProxyRestrictionElement_get_AudienceCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLProxyRestrictionElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLProxyRestrictionElement_methods[] = {
	PHP_ME(TElSAMLProxyRestrictionElement, Clear, arginfo_TElSAMLProxyRestrictionElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLProxyRestrictionElement, LoadFromXML, arginfo_TElSAMLProxyRestrictionElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLProxyRestrictionElement, SaveToXML, arginfo_TElSAMLProxyRestrictionElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLProxyRestrictionElement, AddAudience, arginfo_TElSAMLProxyRestrictionElement_AddAudience, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLProxyRestrictionElement, RemoveAudience, arginfo_TElSAMLProxyRestrictionElement_RemoveAudience, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLProxyRestrictionElement, get_Count, arginfo_TElSAMLProxyRestrictionElement_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLProxyRestrictionElement, get_AudienceList, arginfo_TElSAMLProxyRestrictionElement_get_AudienceList, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLProxyRestrictionElement, get_AudienceCount, arginfo_TElSAMLProxyRestrictionElement_get_AudienceCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLProxyRestrictionElement, __construct, arginfo_TElSAMLProxyRestrictionElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLProxyRestrictionElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLProxyRestrictionElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLProxyRestrictionElement", TElSAMLProxyRestrictionElement_methods);
	if (NULL == TElSAMLConditionAbstractType_ce_ptr)
		Register_TElSAMLConditionAbstractType(TSRMLS_C);
	TElSAMLProxyRestrictionElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLConditionAbstractType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSubjectLocalityElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSubjectLocalityElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectLocalityElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectLocalityElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectLocalityElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectLocalityElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectLocalityElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectLocalityElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectLocalityElement, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSubjectLocalityElement_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(709745831, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectLocalityElement, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectLocalityElement_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectLocalityElement, get_DNSName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSubjectLocalityElement_get_DNSName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1344459917, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectLocalityElement, set_DNSName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSubjectLocalityElement_set_DNSName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSubjectLocalityElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSubjectLocalityElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectLocalityElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectLocalityElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectLocalityElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectLocalityElement_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectLocalityElement_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectLocalityElement_get_DNSName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectLocalityElement_set_DNSName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSubjectLocalityElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSubjectLocalityElement_methods[] = {
	PHP_ME(TElSAMLSubjectLocalityElement, Clear, arginfo_TElSAMLSubjectLocalityElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectLocalityElement, LoadFromXML, arginfo_TElSAMLSubjectLocalityElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectLocalityElement, SaveToXML, arginfo_TElSAMLSubjectLocalityElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectLocalityElement, get_Address, arginfo_TElSAMLSubjectLocalityElement_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectLocalityElement, set_Address, arginfo_TElSAMLSubjectLocalityElement_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectLocalityElement, get_DNSName, arginfo_TElSAMLSubjectLocalityElement_get_DNSName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectLocalityElement, set_DNSName, arginfo_TElSAMLSubjectLocalityElement_set_DNSName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSubjectLocalityElement, __construct, arginfo_TElSAMLSubjectLocalityElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSubjectLocalityElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSubjectLocalityElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSubjectLocalityElement", TElSAMLSubjectLocalityElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLSubjectLocalityElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAuthnContextElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAuthnContextElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnContextElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnContextElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnContextElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnContextElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, get_Choice)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLAuthnContextChoiceRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLAuthnContextElement_get_Choice(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, set_Choice)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnContextElement_set_Choice(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLAuthnContextChoiceRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, get_AuthnContextClassRef)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAuthnContextElement_get_AuthnContextClassRef(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1888874211, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, set_AuthnContextClassRef)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnContextElement_set_AuthnContextClassRef(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, get_AuthnContextDecl)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnContextElement_get_AuthnContextDecl(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, set_AuthnContextDecl)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnContextElement_set_AuthnContextDecl(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, get_AuthnContextDeclRef)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAuthnContextElement_get_AuthnContextDeclRef(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1357102068, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, set_AuthnContextDeclRef)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnContextElement_set_AuthnContextDeclRef(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, get_AuthenticatingAuthorities)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnContextElement_get_AuthenticatingAuthorities(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnContextElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnContextElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_get_Choice, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_set_Choice, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_get_AuthnContextClassRef, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_set_AuthnContextClassRef, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_get_AuthnContextDecl, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_set_AuthnContextDecl, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_get_AuthnContextDeclRef, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_set_AuthnContextDeclRef, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement_get_AuthenticatingAuthorities, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnContextElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAuthnContextElement_methods[] = {
	PHP_ME(TElSAMLAuthnContextElement, Clear, arginfo_TElSAMLAuthnContextElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, LoadFromXML, arginfo_TElSAMLAuthnContextElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, SaveToXML, arginfo_TElSAMLAuthnContextElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, get_Choice, arginfo_TElSAMLAuthnContextElement_get_Choice, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, set_Choice, arginfo_TElSAMLAuthnContextElement_set_Choice, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, get_AuthnContextClassRef, arginfo_TElSAMLAuthnContextElement_get_AuthnContextClassRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, set_AuthnContextClassRef, arginfo_TElSAMLAuthnContextElement_set_AuthnContextClassRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, get_AuthnContextDecl, arginfo_TElSAMLAuthnContextElement_get_AuthnContextDecl, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, set_AuthnContextDecl, arginfo_TElSAMLAuthnContextElement_set_AuthnContextDecl, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, get_AuthnContextDeclRef, arginfo_TElSAMLAuthnContextElement_get_AuthnContextDeclRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, set_AuthnContextDeclRef, arginfo_TElSAMLAuthnContextElement_set_AuthnContextDeclRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, get_AuthenticatingAuthorities, arginfo_TElSAMLAuthnContextElement_get_AuthenticatingAuthorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnContextElement, __construct, arginfo_TElSAMLAuthnContextElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAuthnContextElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAuthnContextElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAuthnContextElement", TElSAMLAuthnContextElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLAuthnContextElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAuthnStatementElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAuthnStatementElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnStatementElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnStatementElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnStatementElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnStatementElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, get_AuthnInstant)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLAuthnStatementElement_get_AuthnInstant(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, set_AuthnInstant)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnStatementElement_set_AuthnInstant(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, get_SessionIndex)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAuthnStatementElement_get_SessionIndex(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-979391094, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, set_SessionIndex)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnStatementElement_set_SessionIndex(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, get_SessionNotOnOrAfter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLAuthnStatementElement_get_SessionNotOnOrAfter(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, set_SessionNotOnOrAfter)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnStatementElement_set_SessionNotOnOrAfter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, get_SubjectLocality)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnStatementElement_get_SubjectLocality(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSubjectLocalityElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, set_SubjectLocality)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLSubjectLocalityElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnStatementElement_set_SubjectLocality(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLSubjectLocalityElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, get_AuthnContext)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnStatementElement_get_AuthnContext(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLAuthnContextElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, set_AuthnContext)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLAuthnContextElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnStatementElement_set_AuthnContext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAuthnContextElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnStatementElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnStatementElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_get_AuthnInstant, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_set_AuthnInstant, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_get_SessionIndex, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_set_SessionIndex, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_get_SessionNotOnOrAfter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_set_SessionNotOnOrAfter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_get_SubjectLocality, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_set_SubjectLocality, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLSubjectLocalityElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_get_AuthnContext, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement_set_AuthnContext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLAuthnContextElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnStatementElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAuthnStatementElement_methods[] = {
	PHP_ME(TElSAMLAuthnStatementElement, Clear, arginfo_TElSAMLAuthnStatementElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, LoadFromXML, arginfo_TElSAMLAuthnStatementElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, SaveToXML, arginfo_TElSAMLAuthnStatementElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, get_AuthnInstant, arginfo_TElSAMLAuthnStatementElement_get_AuthnInstant, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, set_AuthnInstant, arginfo_TElSAMLAuthnStatementElement_set_AuthnInstant, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, get_SessionIndex, arginfo_TElSAMLAuthnStatementElement_get_SessionIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, set_SessionIndex, arginfo_TElSAMLAuthnStatementElement_set_SessionIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, get_SessionNotOnOrAfter, arginfo_TElSAMLAuthnStatementElement_get_SessionNotOnOrAfter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, set_SessionNotOnOrAfter, arginfo_TElSAMLAuthnStatementElement_set_SessionNotOnOrAfter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, get_SubjectLocality, arginfo_TElSAMLAuthnStatementElement_get_SubjectLocality, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, set_SubjectLocality, arginfo_TElSAMLAuthnStatementElement_set_SubjectLocality, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, get_AuthnContext, arginfo_TElSAMLAuthnStatementElement_get_AuthnContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, set_AuthnContext, arginfo_TElSAMLAuthnStatementElement_set_AuthnContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnStatementElement, __construct, arginfo_TElSAMLAuthnStatementElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAuthnStatementElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAuthnStatementElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAuthnStatementElement", TElSAMLAuthnStatementElement_methods);
	if (NULL == TElSAMLStatementAbstractType_ce_ptr)
		Register_TElSAMLStatementAbstractType(TSRMLS_C);
	TElSAMLAuthnStatementElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLStatementAbstractType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAttributeType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAttributeType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAttributeType_methods[] = {
	PHP_ME(TElSAMLAttributeType, __construct, arginfo_TElSAMLAttributeType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAttributeType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAttributeType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAttributeType", TElSAMLAttributeType_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLAttributeType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAttributeValue_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAttributeValue, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeValue_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeValue, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeValue_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeValue, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeValue_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeValue_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeValue, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAttributeValue_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(477033646, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeValue, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeValue_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeValue, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAttributeValue_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1079452459, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeValue, set_ContentType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeValue_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeValue, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeValue_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeValue_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeValue_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeValue_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeValue_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeValue_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeValue_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeValue_set_ContentType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeValue___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAttributeValue_methods[] = {
	PHP_ME(TElSAMLAttributeValue, Clear, arginfo_TElSAMLAttributeValue_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeValue, LoadFromXML, arginfo_TElSAMLAttributeValue_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeValue, SaveToXML, arginfo_TElSAMLAttributeValue_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeValue, get_Value, arginfo_TElSAMLAttributeValue_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeValue, set_Value, arginfo_TElSAMLAttributeValue_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeValue, get_ContentType, arginfo_TElSAMLAttributeValue_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeValue, set_ContentType, arginfo_TElSAMLAttributeValue_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeValue, __construct, arginfo_TElSAMLAttributeValue___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAttributeValue(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAttributeValue_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAttributeValue", TElSAMLAttributeValue_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLAttributeValue_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAttributeElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAttributeElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, AddArbitraryAttribute)
{
	zval *oAttr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAttr, TElXMLDOMAttr_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAttributeElement_AddArbitraryAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAttr TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMAttr)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, RemoveArbitraryAttribute)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeElement_RemoveArbitraryAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, AddValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAttributeElement_AddValue(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, RemoveValue)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeElement_RemoveValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAttributeElement_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1250963866, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeElement_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, get_NameFormat)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAttributeElement_get_NameFormat(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2010801173, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, set_NameFormat)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeElement_set_NameFormat(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, get_FriendlyName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAttributeElement_get_FriendlyName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1773911550, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, set_FriendlyName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeElement_set_FriendlyName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, get_Values)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeElement_get_Values(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLAttributeValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, get_ValueCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAttributeElement_get_ValueCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, get_ArbitraryAttributes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeElement_get_ArbitraryAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, get_ArbitraryAttributeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAttributeElement_get_ArbitraryAttributeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_AddArbitraryAttribute, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attr, TElXMLDOMAttr, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_RemoveArbitraryAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_AddValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_RemoveValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_get_NameFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_set_NameFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_get_FriendlyName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_set_FriendlyName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_get_Values, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_get_ValueCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_get_ArbitraryAttributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement_get_ArbitraryAttributeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAttributeElement_methods[] = {
	PHP_ME(TElSAMLAttributeElement, Clear, arginfo_TElSAMLAttributeElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, LoadFromXML, arginfo_TElSAMLAttributeElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, SaveToXML, arginfo_TElSAMLAttributeElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, AddArbitraryAttribute, arginfo_TElSAMLAttributeElement_AddArbitraryAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, RemoveArbitraryAttribute, arginfo_TElSAMLAttributeElement_RemoveArbitraryAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, AddValue, arginfo_TElSAMLAttributeElement_AddValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, RemoveValue, arginfo_TElSAMLAttributeElement_RemoveValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, get_Name, arginfo_TElSAMLAttributeElement_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, set_Name, arginfo_TElSAMLAttributeElement_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, get_NameFormat, arginfo_TElSAMLAttributeElement_get_NameFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, set_NameFormat, arginfo_TElSAMLAttributeElement_set_NameFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, get_FriendlyName, arginfo_TElSAMLAttributeElement_get_FriendlyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, set_FriendlyName, arginfo_TElSAMLAttributeElement_set_FriendlyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, get_Values, arginfo_TElSAMLAttributeElement_get_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, get_ValueCount, arginfo_TElSAMLAttributeElement_get_ValueCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, get_ArbitraryAttributes, arginfo_TElSAMLAttributeElement_get_ArbitraryAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, get_ArbitraryAttributeCount, arginfo_TElSAMLAttributeElement_get_ArbitraryAttributeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeElement, __construct, arginfo_TElSAMLAttributeElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAttributeElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAttributeElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAttributeElement", TElSAMLAttributeElement_methods);
	if (NULL == TElSAMLAttributeType_ce_ptr)
		Register_TElSAMLAttributeType(TSRMLS_C);
	TElSAMLAttributeElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLAttributeType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEncryptedAttributeElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEncryptedAttributeElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedAttributeElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAttributeElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedAttributeElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAttributeElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedAttributeElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedAttributeElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAttributeElement, get_EncryptedElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedAttributeElement_get_EncryptedElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLEncryptedElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAttributeElement, set_EncryptedElement)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLEncryptedElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptedAttributeElement_set_EncryptedElement(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLEncryptedElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptedAttributeElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptedAttributeElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAttributeElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAttributeElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAttributeElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAttributeElement_get_EncryptedElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAttributeElement_set_EncryptedElement, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLEncryptedElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptedAttributeElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEncryptedAttributeElement_methods[] = {
	PHP_ME(TElSAMLEncryptedAttributeElement, Clear, arginfo_TElSAMLEncryptedAttributeElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAttributeElement, LoadFromXML, arginfo_TElSAMLEncryptedAttributeElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAttributeElement, SaveToXML, arginfo_TElSAMLEncryptedAttributeElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAttributeElement, get_EncryptedElement, arginfo_TElSAMLEncryptedAttributeElement_get_EncryptedElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAttributeElement, set_EncryptedElement, arginfo_TElSAMLEncryptedAttributeElement_set_EncryptedElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptedAttributeElement, __construct, arginfo_TElSAMLEncryptedAttributeElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEncryptedAttributeElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEncryptedAttributeElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEncryptedAttributeElement", TElSAMLEncryptedAttributeElement_methods);
	if (NULL == TElSAMLAttributeType_ce_ptr)
		Register_TElSAMLAttributeType(TSRMLS_C);
	TElSAMLEncryptedAttributeElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLAttributeType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAttributeStatementElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAttributeStatementElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeStatementElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeStatementElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeStatementElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeStatementElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeStatementElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeStatementElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeStatementElement, AddAttribute)
{
	zval *oAttr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAttr, TElSAMLAttributeType_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAttributeStatementElement_AddAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAttr TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAttributeType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeStatementElement, RemoveAttribute)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeStatementElement_RemoveAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeStatementElement, get_Attributes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeStatementElement_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLAttributeType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeStatementElement, get_AttributeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAttributeStatementElement_get_AttributeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeStatementElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeStatementElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeStatementElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeStatementElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeStatementElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeStatementElement_AddAttribute, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attr, TElSAMLAttributeType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeStatementElement_RemoveAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeStatementElement_get_Attributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeStatementElement_get_AttributeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeStatementElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAttributeStatementElement_methods[] = {
	PHP_ME(TElSAMLAttributeStatementElement, Clear, arginfo_TElSAMLAttributeStatementElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeStatementElement, LoadFromXML, arginfo_TElSAMLAttributeStatementElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeStatementElement, SaveToXML, arginfo_TElSAMLAttributeStatementElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeStatementElement, AddAttribute, arginfo_TElSAMLAttributeStatementElement_AddAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeStatementElement, RemoveAttribute, arginfo_TElSAMLAttributeStatementElement_RemoveAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeStatementElement, get_Attributes, arginfo_TElSAMLAttributeStatementElement_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeStatementElement, get_AttributeCount, arginfo_TElSAMLAttributeStatementElement_get_AttributeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeStatementElement, __construct, arginfo_TElSAMLAttributeStatementElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAttributeStatementElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAttributeStatementElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAttributeStatementElement", TElSAMLAttributeStatementElement_methods);
	if (NULL == TElSAMLStatementAbstractType_ce_ptr)
		Register_TElSAMLStatementAbstractType(TSRMLS_C);
	TElSAMLAttributeStatementElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLStatementAbstractType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLActionElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLActionElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLActionElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLActionElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLActionElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLActionElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLActionElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLActionElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLActionElement, get__Namespace)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLActionElement_get__Namespace(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1984242241, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLActionElement, set__Namespace)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLActionElement_set__Namespace(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLActionElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLActionElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLActionElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLActionElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLActionElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLActionElement_get__Namespace, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLActionElement_set__Namespace, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLActionElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLActionElement_methods[] = {
	PHP_ME(TElSAMLActionElement, Clear, arginfo_TElSAMLActionElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLActionElement, LoadFromXML, arginfo_TElSAMLActionElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLActionElement, SaveToXML, arginfo_TElSAMLActionElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLActionElement, get__Namespace, arginfo_TElSAMLActionElement_get__Namespace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLActionElement, set__Namespace, arginfo_TElSAMLActionElement_set__Namespace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLActionElement, __construct, arginfo_TElSAMLActionElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLActionElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLActionElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLActionElement", TElSAMLActionElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLActionElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEvidenceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEvidenceElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEvidenceElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEvidenceElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEvidenceElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEvidenceElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEvidenceElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEvidenceElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEvidenceElement, AddAssertion)
{
	zval *oAssertion;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAssertion, TElSAMLAssertionType_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLEvidenceElement_AddAssertion(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAssertion TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAssertionType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEvidenceElement, RemoveAssertion)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLEvidenceElement_RemoveAssertion(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEvidenceElement, get_Assertions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEvidenceElement_get_Assertions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLAssertionType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEvidenceElement, get_AssertionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLEvidenceElement_get_AssertionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEvidenceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEvidenceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEvidenceElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEvidenceElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEvidenceElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEvidenceElement_AddAssertion, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Assertion, TElSAMLAssertionType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEvidenceElement_RemoveAssertion, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEvidenceElement_get_Assertions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEvidenceElement_get_AssertionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEvidenceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEvidenceElement_methods[] = {
	PHP_ME(TElSAMLEvidenceElement, Clear, arginfo_TElSAMLEvidenceElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEvidenceElement, LoadFromXML, arginfo_TElSAMLEvidenceElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEvidenceElement, SaveToXML, arginfo_TElSAMLEvidenceElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEvidenceElement, AddAssertion, arginfo_TElSAMLEvidenceElement_AddAssertion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEvidenceElement, RemoveAssertion, arginfo_TElSAMLEvidenceElement_RemoveAssertion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEvidenceElement, get_Assertions, arginfo_TElSAMLEvidenceElement_get_Assertions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEvidenceElement, get_AssertionCount, arginfo_TElSAMLEvidenceElement_get_AssertionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEvidenceElement, __construct, arginfo_TElSAMLEvidenceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEvidenceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEvidenceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEvidenceElement", TElSAMLEvidenceElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLEvidenceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAuthzDecisionStatementElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAuthzDecisionStatementElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthzDecisionStatementElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthzDecisionStatementElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthzDecisionStatementElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, AddAction)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAuthzDecisionStatementElement_AddAction(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, RemoveAction)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthzDecisionStatementElement_RemoveAction(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, get_Resource)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAuthzDecisionStatementElement_get_Resource(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(69930981, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, set_Resource)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthzDecisionStatementElement_set_Resource(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, get_Decision)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLDecisionRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLAuthzDecisionStatementElement_get_Decision(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, set_Decision)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthzDecisionStatementElement_set_Decision(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLDecisionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, get_Evidence)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthzDecisionStatementElement_get_Evidence(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLEvidenceElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, set_Evidence)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLEvidenceElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthzDecisionStatementElement_set_Evidence(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLEvidenceElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, get_Actions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthzDecisionStatementElement_get_Actions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLActionElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, get_ActionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAuthzDecisionStatementElement_get_ActionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthzDecisionStatementElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthzDecisionStatementElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_AddAction, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_RemoveAction, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_get_Resource, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_set_Resource, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_get_Decision, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_set_Decision, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_get_Evidence, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_set_Evidence, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLEvidenceElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_get_Actions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement_get_ActionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzDecisionStatementElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAuthzDecisionStatementElement_methods[] = {
	PHP_ME(TElSAMLAuthzDecisionStatementElement, Clear, arginfo_TElSAMLAuthzDecisionStatementElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, LoadFromXML, arginfo_TElSAMLAuthzDecisionStatementElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, SaveToXML, arginfo_TElSAMLAuthzDecisionStatementElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, AddAction, arginfo_TElSAMLAuthzDecisionStatementElement_AddAction, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, RemoveAction, arginfo_TElSAMLAuthzDecisionStatementElement_RemoveAction, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, get_Resource, arginfo_TElSAMLAuthzDecisionStatementElement_get_Resource, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, set_Resource, arginfo_TElSAMLAuthzDecisionStatementElement_set_Resource, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, get_Decision, arginfo_TElSAMLAuthzDecisionStatementElement_get_Decision, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, set_Decision, arginfo_TElSAMLAuthzDecisionStatementElement_set_Decision, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, get_Evidence, arginfo_TElSAMLAuthzDecisionStatementElement_get_Evidence, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, set_Evidence, arginfo_TElSAMLAuthzDecisionStatementElement_set_Evidence, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, get_Actions, arginfo_TElSAMLAuthzDecisionStatementElement_get_Actions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, get_ActionCount, arginfo_TElSAMLAuthzDecisionStatementElement_get_ActionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthzDecisionStatementElement, __construct, arginfo_TElSAMLAuthzDecisionStatementElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAuthzDecisionStatementElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAuthzDecisionStatementElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAuthzDecisionStatementElement", TElSAMLAuthzDecisionStatementElement_methods);
	if (NULL == TElSAMLStatementAbstractType_ce_ptr)
		Register_TElSAMLStatementAbstractType(TSRMLS_C);
	TElSAMLAuthzDecisionStatementElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLStatementAbstractType_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLSAMLCore, GetSAMLNSMap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLSAMLCore_GetSAMLNSMap(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLNamespaceMap_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, SetSAMLNSMap)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLNamespaceMap_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBXMLSAMLCore_SetSAMLNSMap(SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLNamespaceMap)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, CreateElementNS)
{
	char *sName;
	char *sURI;
	int sName_len;
	int sURI_len;
	zval *oDocument;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oDocument, TElXMLDOMDocument_ce_ptr, &sURI, &sURI_len, &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLSAMLCore_CreateElementNS(SBGetObjectHandle(oDocument TSRMLS_CC), sURI, (int32_t)sURI_len, sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, StreamToStr)
{
	uint32_t _err;
	zval *oInput;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oInput, TStream_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCore_StreamToStr(SBGetObjectHandle(oInput TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2086217162, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, StreamToStrUTF8)
{
	uint32_t _err;
	zval *oInput;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oInput, TStream_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCore_StreamToStrUTF8(SBGetObjectHandle(oInput TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2108430952, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, StreamToArray)
{
	uint32_t _err;
	zval *oInput;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oInput, TStream_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBXMLSAMLCore_StreamToArray(SBGetObjectHandle(oInput TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(649955445, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, FindChildElement)
{
	char *sName;
	char *sNamespaceURI;
	int sName_len;
	int sNamespaceURI_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oElement, TElXMLDOMElement_ce_ptr, &sName, &sName_len, &sNamespaceURI, &sNamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLSAMLCore_FindChildElement(SBGetObjectHandle(oElement TSRMLS_CC), sName, (int32_t)sName_len, sNamespaceURI, (int32_t)sNamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, FreeList)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBXMLSAMLCore_FreeList(SBGetObjectHandle(oList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, XMLStrToBool)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBXMLSAMLCore_XMLStrToBool(sS, (int32_t)sS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, BoolToXMLStr)
{
	uint32_t _err;
	zend_bool bB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bB) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCore_BoolToXMLStr((int8_t)bB, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(210526793, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, GenerateID)
{
	long l4Len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCore_GenerateID((int32_t)l4Len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2144510525, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCore_GenerateID_1(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1398244008, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or ()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, RandomString)
{
	long l4Len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCore_RandomString((int32_t)l4Len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(648203179, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCore_RandomString_1(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(582899431, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or ()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, DateTimeToString)
{
	uint32_t _err;
	zval *dtDT;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtDT, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLCore_DateTimeToString(SBGetDateTime(dtDT TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1180590213, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLCore, CurrentDateTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBXMLSAMLCore_CurrentDateTime(&dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBXMLSAMLCore_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBXMLSAMLCore, BUF_SZ, SB_BUF_SZ, SB_BUF_SZ);
	SB_REGISTER_LONG_CONSTANT(SBXMLSAMLCore, SB_SAML_TIMEZONE_UTC, SB_SAML_TIMEZONE_UTC, SB_SAML_TIMEZONE_UTC);
	SB_REGISTER_LONG_CONSTANT(SBXMLSAMLCore, SB_SAML_TIMEZONE_LOCAL, SB_SAML_TIMEZONE_LOCAL, SB_SAML_TIMEZONE_LOCAL);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SAMLVersion, SB_SAMLVersion, SB_SAMLVersion);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLAssertionNamespace, SB_xmlSAMLAssertionNamespace, SB_xmlSAMLAssertionNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLProtocolNamespace, SB_xmlSAMLProtocolNamespace, SB_xmlSAMLProtocolNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLMetadataNamespace, SB_xmlSAMLMetadataNamespace, SB_xmlSAMLMetadataNamespace);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLMDPrefix, SB_xmlSAMLMDPrefix, SB_xmlSAMLMDPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLNameIDFormatUnspecified, SB_xmlSAMLNameIDFormatUnspecified, SB_xmlSAMLNameIDFormatUnspecified);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLNameIDFormatEmailAddress11, SB_xmlSAMLNameIDFormatEmailAddress11, SB_xmlSAMLNameIDFormatEmailAddress11);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLNameIDFormatEmailAddress, SB_xmlSAMLNameIDFormatEmailAddress, SB_xmlSAMLNameIDFormatEmailAddress);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLNameIDFormatX509SubjectName, SB_xmlSAMLNameIDFormatX509SubjectName, SB_xmlSAMLNameIDFormatX509SubjectName);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLNameIDFormatWindowsDomainQualifiedName, SB_xmlSAMLNameIDFormatWindowsDomainQualifiedName, SB_xmlSAMLNameIDFormatWindowsDomainQualifiedName);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLNameIDFormatKerberos, SB_xmlSAMLNameIDFormatKerberos, SB_xmlSAMLNameIDFormatKerberos);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLNameIDFormatEntity, SB_xmlSAMLNameIDFormatEntity, SB_xmlSAMLNameIDFormatEntity);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLNameIDFormatPersistent, SB_xmlSAMLNameIDFormatPersistent, SB_xmlSAMLNameIDFormatPersistent);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLNameIDFormatTransient, SB_xmlSAMLNameIDFormatTransient, SB_xmlSAMLNameIDFormatTransient);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLKeyInfoConfirmationDataType, SB_xmlSAMLKeyInfoConfirmationDataType, SB_xmlSAMLKeyInfoConfirmationDataType);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLPrefix, SB_xmlSAMLPrefix, SB_xmlSAMLPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, xmlSAMLProtocolPrefix, SB_xmlSAMLProtocolPrefix, SB_xmlSAMLProtocolPrefix);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SNotImplemented, SB_SNotImplemented, SB_SNotImplemented);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SMissingAttribute, SB_SMissingAttribute, SB_SMissingAttribute);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SMissingElement, SB_SMissingElement, SB_SMissingElement);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SInvalidAttributeValue, SB_SInvalidAttributeValue, SB_SInvalidAttributeValue);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SEncryptionError, SB_SEncryptionError, SB_SEncryptionError);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SInvalidTypeCast, SB_SInvalidTypeCast, SB_SInvalidTypeCast);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SPermit, SB_SPermit, SB_SPermit);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SDeny, SB_SDeny, SB_SDeny);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SIndeterminate, SB_SIndeterminate, SB_SIndeterminate);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, STrue1, SB_STrue1, SB_STrue1);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, STrue2, SB_STrue2, SB_STrue2);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SFalse1, SB_SFalse1, SB_SFalse1);
	SB_REGISTER_STRING_CONSTANT(SBXMLSAMLCore, SFalse2, SB_SFalse2, SB_SFalse2);
}

void Register_SBXMLSAMLCore_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBSAMLAuthnContextChoice", NULL);
	TSBSAMLAuthnContextChoice_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLAuthnContextChoice_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLAuthnContextChoice_ce_ptr, "sacV1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLAuthnContextChoice_ce_ptr, "sacV2", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBSAMLDecision", NULL);
	TSBSAMLDecision_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLDecision_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLDecision_ce_ptr, "sadnPermit", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLDecision_ce_ptr, "sadnDeny", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLDecision_ce_ptr, "sadnIndeterminate", 2)
}

void Register_SBXMLSAMLCore_Aliases(TSRMLS_D)
{
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	zend_register_class_alias("TElSAMLAuthnContextDecl", TElSAMLElement_ce_ptr);
}
