#include "sbxmlsec.h"

zend_class_entry *TElXMLSignatureType_ce_ptr = NULL;

zend_class_entry *TElXMLSignatureTypes_ce_ptr = NULL;

zend_class_entry *TElXMLSignatureCompliance_ce_ptr = NULL;

zend_class_entry *TElXMLSigMethodType_ce_ptr = NULL;

zend_class_entry *TElXMLDigestMethod_ce_ptr = NULL;

zend_class_entry *TElXMLMACMethod_ce_ptr = NULL;

zend_class_entry *TElXMLSignatureMethod_ce_ptr = NULL;

zend_class_entry *TElXMLKeyInfoX509DataParam_ce_ptr = NULL;

zend_class_entry *TElXMLKeyInfoX509DataParams_ce_ptr = NULL;

zend_class_entry *TElXMLKeyInfoPGPDataParam_ce_ptr = NULL;

zend_class_entry *TElXMLEncryptedDataType_ce_ptr = NULL;

zend_class_entry *TElXMLEncryptionMethod_ce_ptr = NULL;

zend_class_entry *TElXMLKeyEncryptionType_ce_ptr = NULL;

zend_class_entry *TElXMLKeyTransportMethod_ce_ptr = NULL;

zend_class_entry *TElXMLKeyWrapMethod_ce_ptr = NULL;

zend_class_entry *TSBXMLECKeyValueFormat_ce_ptr = NULL;

zend_class_entry *TSBXMLECPrimeNumberType_ce_ptr = NULL;

void SB_CALLBACK TSBXMLFormatElementEventRaw(void * _ObjectData, TObjectHandle Sender, TElXMLDOMElementHandle Element, int32_t Level, const char * pcPath, int32_t szPath, char * pcStartTagWhitespace, int32_t * szStartTagWhitespace, char * pcEndTagWhitespace, int32_t * szEndTagWhitespace)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zElement;
	zval * zLevel;
	zval * zPath;
	zval * zStartTagWhitespace;
	zval * zEndTagWhitespace;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zElement);
	SBInitObject(zElement, TElXMLDOMElement_ce_ptr, Element TSRMLS_CC);
	MAKE_STD_ZVAL(zLevel);
	ZVAL_LONG(zLevel, (long)Level);
	MAKE_STD_ZVAL(zPath);
	ZVAL_STRINGL(zPath, pcPath, szPath, 1);
	MAKE_STD_ZVAL(zStartTagWhitespace);
	ZVAL_STRINGL(zStartTagWhitespace, pcStartTagWhitespace, *szStartTagWhitespace, 1);
	MAKE_STD_ZVAL(zEndTagWhitespace);
	ZVAL_STRINGL(zEndTagWhitespace, pcEndTagWhitespace, *szEndTagWhitespace, 1);

	params[0] = &zSender;
	params[1] = &zElement;
	params[2] = &zLevel;
	params[3] = &zPath;
	params[4] = &zStartTagWhitespace;
	params[5] = &zEndTagWhitespace;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zElement);
	zval_ptr_dtor(&zLevel);
	zval_ptr_dtor(&zPath);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zStartTagWhitespace), (int32_t)Z_STRLEN_P(zStartTagWhitespace)) TSRMLS_CC);
	zval_ptr_dtor(&zStartTagWhitespace);
	SBCheckError(SBSetEventReturnStringA(6, Z_STRVAL_P(zEndTagWhitespace), (int32_t)Z_STRLEN_P(zEndTagWhitespace)) TSRMLS_CC);
	zval_ptr_dtor(&zEndTagWhitespace);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXMLFormatTextEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcText, int32_t * szText, TElXMLTextTypeRaw TextType, int32_t Level, const char * pcPath, int32_t szPath)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zText;
	zval * zTextType;
	zval * zLevel;
	zval * zPath;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zText);
	ZVAL_STRINGL(zText, pcText, *szText, 1);
	MAKE_STD_ZVAL(zTextType);
	ZVAL_LONG(zTextType, (long)TextType);
	MAKE_STD_ZVAL(zLevel);
	ZVAL_LONG(zLevel, (long)Level);
	MAKE_STD_ZVAL(zPath);
	ZVAL_STRINGL(zPath, pcPath, szPath, 1);

	params[0] = &zSender;
	params[1] = &zText;
	params[2] = &zTextType;
	params[3] = &zLevel;
	params[4] = &zPath;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	SBCheckError(SBSetEventReturnStringA(2, Z_STRVAL_P(zText), (int32_t)Z_STRLEN_P(zText)) TSRMLS_CC);
	zval_ptr_dtor(&zText);
	zval_ptr_dtor(&zTextType);
	zval_ptr_dtor(&zLevel);
	zval_ptr_dtor(&zPath);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElXMLRDNCompatibilityMode_ce_ptr = NULL;

zend_class_entry *TElXMLKeyInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfo, Add)
{
	zval *oItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oItem, TElXMLKeyInfoItem_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLKeyInfo_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oItem TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfoItem)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, Insert)
{
	long l4Index;
	zval *oItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oItem, TElXMLKeyInfoItem_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfo_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oItem TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLKeyInfoItem)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfo_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfo_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfo_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfo_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfo_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfo_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, ExtractAllCertificates)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfo_ExtractAllCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, SetKeyData)
{
	zval *oKeyData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeyData, TElXMLKeyInfoData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfo_SetKeyData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfoData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLKeyInfo_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfo_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfoItem_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfo_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfo_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, get_KeyName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfo_get_KeyName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-825535084, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, set_KeyName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfo_set_KeyName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfo_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1757004984, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfo_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfo, __construct)
{
	char *sAKeyName;
	int sAKeyName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAKeyName, &sAKeyName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfo_Create_1(sAKeyName, (int32_t)sAKeyName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Item, TElXMLKeyInfoItem, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, Item, TElXMLKeyInfoItem, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_ExtractAllCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_SetKeyData, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, KeyData, TElXMLKeyInfoData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_get_KeyName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_set_KeyName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfo___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, AKeyName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfo_methods[] = {
	PHP_ME(TElXMLKeyInfo, Add, arginfo_TElXMLKeyInfo_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, Insert, arginfo_TElXMLKeyInfo_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, Delete, arginfo_TElXMLKeyInfo_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, Clear, arginfo_TElXMLKeyInfo_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, IsEmpty, arginfo_TElXMLKeyInfo_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, LoadFromXML, arginfo_TElXMLKeyInfo_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, SaveToXML, arginfo_TElXMLKeyInfo_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, ExtractAllCertificates, arginfo_TElXMLKeyInfo_ExtractAllCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, SetKeyData, arginfo_TElXMLKeyInfo_SetKeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, get_Count, arginfo_TElXMLKeyInfo_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, get_Items, arginfo_TElXMLKeyInfo_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, get_CryptoProviderManager, arginfo_TElXMLKeyInfo_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, set_CryptoProviderManager, arginfo_TElXMLKeyInfo_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, get_KeyName, arginfo_TElXMLKeyInfo_get_KeyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, set_KeyName, arginfo_TElXMLKeyInfo_set_KeyName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, get_ID, arginfo_TElXMLKeyInfo_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, set_ID, arginfo_TElXMLKeyInfo_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfo, __construct, arginfo_TElXMLKeyInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfo", TElXMLKeyInfo_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLKeyInfo_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLAlgorithmParameters_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLAlgorithmParameters, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAlgorithmParameters_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAlgorithmParameters_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAlgorithmParameters, GetCryptoProviderParameters)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAlgorithmParameters_GetCryptoProviderParameters(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAlgorithmParameters, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAlgorithmParameters_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAlgorithmParameters_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAlgorithmParameters_GetCryptoProviderParameters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAlgorithmParameters___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLAlgorithmParameters_methods[] = {
	PHP_ME(TElXMLAlgorithmParameters, Clone, arginfo_TElXMLAlgorithmParameters_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAlgorithmParameters, GetCryptoProviderParameters, arginfo_TElXMLAlgorithmParameters_GetCryptoProviderParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAlgorithmParameters, __construct, arginfo_TElXMLAlgorithmParameters___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLAlgorithmParameters(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLAlgorithmParameters_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLAlgorithmParameters", TElXMLAlgorithmParameters_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLAlgorithmParameters_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLReference_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLReference, UpdateDigestValue)
{
	long l4Mode;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Mode) == SUCCESS)
	{
		SBCheckError(TElXMLReference_UpdateDigestValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Mode) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Mode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLReference_UpdateDigestValue_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Mode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLReference_UpdateDigestValue_2(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLReference_UpdateDigestValue_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or () or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReference_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLReference_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLReference_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLReference_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReference_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReference_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, IsURIResolved)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLReference_IsURIResolved(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, ProcessData)
{
	long fCanonicalizationMethod;
	zval *oHashFunc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHashFunc, TElHashFunction_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLReference_ProcessData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHashFunc TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oHashFunc, TElHashFunction_ce_ptr, &fCanonicalizationMethod) == SUCCESS)
	{
		SBCheckError(TElXMLReference_ProcessData_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHashFunc TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)fCanonicalizationMethod) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHashFunction) or (TElHashFunction, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_TransformChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReference_get_TransformChain(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTransformChain_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_DigestMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLDigestMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLReference_get_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_DigestMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLDigestMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_DigestValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLReference_get_DigestValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-122015954, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_DigestValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLReference_set_DigestValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_DigestMethodParameters)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReference_get_DigestMethodParameters(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAlgorithmParameters_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLReference_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-360275294, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLReference_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1050038929, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_RefType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLReference_get_RefType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(509598317, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_RefType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_RefType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_HasURI)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLReference_get_HasURI(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_HasURI)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_HasURI(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_URIData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLReference_get_URIData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1606693015, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_URIData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLReference_set_URIData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_URINode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReference_get_URINode(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_URINode)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_URINode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_URINodes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReference_get_URINodes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLNodeSet_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_URINodes)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLNodeSet_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_URINodes(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLNodeSet)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_URIStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReference_get_URIStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_URIStream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_URIStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_URIStreamOffset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElXMLReference_get_URIStreamOffset(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_URIStreamOffset)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_URIStreamOffset(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, get_URIStreamCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElXMLReference_get_URIStreamCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, set_URIStreamCount)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElXMLReference_set_URIStreamCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReference, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReference_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_UpdateDigestValue, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Mode_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Manager_or_Prov, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_IsURIResolved, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_ProcessData, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, HashFunc, TElHashFunction, 1)
	ZEND_ARG_INFO(0, CanonicalizationMethod)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_TransformChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_DigestMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_DigestMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_DigestValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_DigestValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_DigestMethodParameters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_RefType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_RefType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_HasURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_HasURI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_URIData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_URIData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_URINode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_URINode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_URINodes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_URINodes, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLNodeSet, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_URIStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_URIStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_URIStreamOffset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_URIStreamOffset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_get_URIStreamCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference_set_URIStreamCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReference___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLReference_methods[] = {
	PHP_ME(TElXMLReference, UpdateDigestValue, arginfo_TElXMLReference_UpdateDigestValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, Clone, arginfo_TElXMLReference_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, Clear, arginfo_TElXMLReference_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, LoadFromXML, arginfo_TElXMLReference_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, SaveToXML, arginfo_TElXMLReference_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, IsURIResolved, arginfo_TElXMLReference_IsURIResolved, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, ProcessData, arginfo_TElXMLReference_ProcessData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_TransformChain, arginfo_TElXMLReference_get_TransformChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_DigestMethod, arginfo_TElXMLReference_get_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_DigestMethod, arginfo_TElXMLReference_set_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_DigestValue, arginfo_TElXMLReference_get_DigestValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_DigestValue, arginfo_TElXMLReference_set_DigestValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_DigestMethodParameters, arginfo_TElXMLReference_get_DigestMethodParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_ID, arginfo_TElXMLReference_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_ID, arginfo_TElXMLReference_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_URI, arginfo_TElXMLReference_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_URI, arginfo_TElXMLReference_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_RefType, arginfo_TElXMLReference_get_RefType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_RefType, arginfo_TElXMLReference_set_RefType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_HasURI, arginfo_TElXMLReference_get_HasURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_HasURI, arginfo_TElXMLReference_set_HasURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_URIData, arginfo_TElXMLReference_get_URIData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_URIData, arginfo_TElXMLReference_set_URIData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_URINode, arginfo_TElXMLReference_get_URINode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_URINode, arginfo_TElXMLReference_set_URINode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_URINodes, arginfo_TElXMLReference_get_URINodes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_URINodes, arginfo_TElXMLReference_set_URINodes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_URIStream, arginfo_TElXMLReference_get_URIStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_URIStream, arginfo_TElXMLReference_set_URIStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_URIStreamOffset, arginfo_TElXMLReference_get_URIStreamOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_URIStreamOffset, arginfo_TElXMLReference_set_URIStreamOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, get_URIStreamCount, arginfo_TElXMLReference_get_URIStreamCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, set_URIStreamCount, arginfo_TElXMLReference_set_URIStreamCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReference, __construct, arginfo_TElXMLReference___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLReference(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLReference_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLReference", TElXMLReference_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLReference_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLReferenceList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLReferenceList, Add)
{
	zval *oAReference;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLReferenceList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAReference, TElXMLReference_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLReferenceList_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAReference TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElXMLReference)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReferenceList, Insert)
{
	long l4Index;
	zval *oAReference;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAReference, TElXMLReference_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLReferenceList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAReference TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLReference)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReferenceList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLReferenceList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReferenceList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLReferenceList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReferenceList, IndexOf)
{
	zval *oAReference;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAReference, TElXMLReference_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLReferenceList_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAReference TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLReference)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReferenceList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLReferenceList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReferenceList, get_Reference)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReferenceList_get_Reference(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLReference_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLReferenceList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLReferenceList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReferenceList_Add, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, AReference, TElXMLReference, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReferenceList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AReference, TElXMLReference, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReferenceList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReferenceList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReferenceList_IndexOf, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AReference, TElXMLReference, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReferenceList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReferenceList_get_Reference, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLReferenceList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLReferenceList_methods[] = {
	PHP_ME(TElXMLReferenceList, Add, arginfo_TElXMLReferenceList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReferenceList, Insert, arginfo_TElXMLReferenceList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReferenceList, Delete, arginfo_TElXMLReferenceList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReferenceList, Clear, arginfo_TElXMLReferenceList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReferenceList, IndexOf, arginfo_TElXMLReferenceList_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReferenceList, get_Count, arginfo_TElXMLReferenceList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReferenceList, get_Reference, arginfo_TElXMLReferenceList_get_Reference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLReferenceList, __construct, arginfo_TElXMLReferenceList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLReferenceList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLReferenceList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLReferenceList", TElXMLReferenceList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLReferenceList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLGOSTR3411Parameters_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLGOSTR3411Parameters, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLGOSTR3411Parameters_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGOSTR3411Parameters, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGOSTR3411Parameters_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAlgorithmParameters_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGOSTR3411Parameters, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLGOSTR3411Parameters_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGOSTR3411Parameters, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGOSTR3411Parameters_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGOSTR3411Parameters_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGOSTR3411Parameters, GetCryptoProviderParameters)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGOSTR3411Parameters_GetCryptoProviderParameters(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGOSTR3411Parameters, get_DigestParameter)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLGOSTR3411Parameters_get_DigestParameter(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-325513964, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGOSTR3411Parameters, set_DigestParameter)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLGOSTR3411Parameters_set_DigestParameter(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGOSTR3411Parameters, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGOSTR3411Parameters_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGOSTR3411Parameters_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGOSTR3411Parameters_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGOSTR3411Parameters_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGOSTR3411Parameters_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGOSTR3411Parameters_GetCryptoProviderParameters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGOSTR3411Parameters_get_DigestParameter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGOSTR3411Parameters_set_DigestParameter, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGOSTR3411Parameters___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLGOSTR3411Parameters_methods[] = {
	PHP_ME(TElXMLGOSTR3411Parameters, Clear, arginfo_TElXMLGOSTR3411Parameters_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGOSTR3411Parameters, Clone, arginfo_TElXMLGOSTR3411Parameters_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGOSTR3411Parameters, LoadFromXML, arginfo_TElXMLGOSTR3411Parameters_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGOSTR3411Parameters, SaveToXML, arginfo_TElXMLGOSTR3411Parameters_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGOSTR3411Parameters, GetCryptoProviderParameters, arginfo_TElXMLGOSTR3411Parameters_GetCryptoProviderParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGOSTR3411Parameters, get_DigestParameter, arginfo_TElXMLGOSTR3411Parameters_get_DigestParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGOSTR3411Parameters, set_DigestParameter, arginfo_TElXMLGOSTR3411Parameters_set_DigestParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGOSTR3411Parameters, __construct, arginfo_TElXMLGOSTR3411Parameters___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLGOSTR3411Parameters(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLGOSTR3411Parameters_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLGOSTR3411Parameters", TElXMLGOSTR3411Parameters_methods);
	if (NULL == TElXMLAlgorithmParameters_ce_ptr)
		Register_TElXMLAlgorithmParameters(TSRMLS_C);
	TElXMLGOSTR3411Parameters_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAlgorithmParameters_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLRSAPSSParameters_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLRSAPSSParameters, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLRSAPSSParameters_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRSAPSSParameters_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAlgorithmParameters_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLRSAPSSParameters_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRSAPSSParameters_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRSAPSSParameters_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, GetCryptoProviderParameters)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRSAPSSParameters_GetCryptoProviderParameters(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, get_DigestMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLDigestMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLRSAPSSParameters_get_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, set_DigestMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLRSAPSSParameters_set_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLDigestMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, get_MaskGenerationFunction)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLRSAPSSParameters_get_MaskGenerationFunction(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, set_MaskGenerationFunction)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElXMLRSAPSSParameters_set_MaskGenerationFunction(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, get_SaltLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLRSAPSSParameters_get_SaltLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, set_SaltLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElXMLRSAPSSParameters_set_SaltLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, get_TrailerField)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLRSAPSSParameters_get_TrailerField(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, set_TrailerField)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElXMLRSAPSSParameters_set_TrailerField(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRSAPSSParameters, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRSAPSSParameters_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_GetCryptoProviderParameters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_get_DigestMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_set_DigestMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_get_MaskGenerationFunction, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_set_MaskGenerationFunction, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_get_SaltLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_set_SaltLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_get_TrailerField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters_set_TrailerField, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRSAPSSParameters___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLRSAPSSParameters_methods[] = {
	PHP_ME(TElXMLRSAPSSParameters, Clear, arginfo_TElXMLRSAPSSParameters_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, Clone, arginfo_TElXMLRSAPSSParameters_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, LoadFromXML, arginfo_TElXMLRSAPSSParameters_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, SaveToXML, arginfo_TElXMLRSAPSSParameters_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, GetCryptoProviderParameters, arginfo_TElXMLRSAPSSParameters_GetCryptoProviderParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, get_DigestMethod, arginfo_TElXMLRSAPSSParameters_get_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, set_DigestMethod, arginfo_TElXMLRSAPSSParameters_set_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, get_MaskGenerationFunction, arginfo_TElXMLRSAPSSParameters_get_MaskGenerationFunction, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, set_MaskGenerationFunction, arginfo_TElXMLRSAPSSParameters_set_MaskGenerationFunction, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, get_SaltLength, arginfo_TElXMLRSAPSSParameters_get_SaltLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, set_SaltLength, arginfo_TElXMLRSAPSSParameters_set_SaltLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, get_TrailerField, arginfo_TElXMLRSAPSSParameters_get_TrailerField, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, set_TrailerField, arginfo_TElXMLRSAPSSParameters_set_TrailerField, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRSAPSSParameters, __construct, arginfo_TElXMLRSAPSSParameters___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLRSAPSSParameters(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLRSAPSSParameters_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLRSAPSSParameters", TElXMLRSAPSSParameters_methods);
	if (NULL == TElXMLAlgorithmParameters_ce_ptr)
		Register_TElXMLAlgorithmParameters(TSRMLS_C);
	TElXMLRSAPSSParameters_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAlgorithmParameters_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoItem_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoItem, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoItem_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoItem___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoItem_methods[] = {
	PHP_ME(TElXMLKeyInfoItem, __construct, arginfo_TElXMLKeyInfoItem___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoItem(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoItem_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoItem", TElXMLKeyInfoItem_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLKeyInfoItem_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoData, get_OwnResources)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoData_get_OwnResources(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoData, set_OwnResources)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoData_set_OwnResources(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoData, __construct)
{
	zend_bool bAOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoData_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoData_Create_1((int8_t)bAOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoData_Create_2((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoData_get_OwnResources, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoData_set_OwnResources, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoData___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoData_methods[] = {
	PHP_ME(TElXMLKeyInfoData, get_OwnResources, arginfo_TElXMLKeyInfoData_get_OwnResources, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoData, set_OwnResources, arginfo_TElXMLKeyInfoData_set_OwnResources, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoData, __construct, arginfo_TElXMLKeyInfoData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoData", TElXMLKeyInfoData_methods);
	if (NULL == TElXMLKeyInfoItem_ce_ptr)
		Register_TElXMLKeyInfoItem(TSRMLS_C);
	TElXMLKeyInfoData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoItem_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoHMACData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoHMACData, get_Key)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoHMACData_get_Key(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHMACKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoHMACData, set_Key)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHMACKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoHMACData_set_Key(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHMACKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoHMACData, __construct)
{
	zend_bool bAOwnResources;
	zend_bool bOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoHMACData_Create((int8_t)bOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoHMACData_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoHMACData_get_Key, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoHMACData_set_Key, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHMACKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoHMACData___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnResources_or_AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoHMACData_methods[] = {
	PHP_ME(TElXMLKeyInfoHMACData, get_Key, arginfo_TElXMLKeyInfoHMACData_get_Key, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoHMACData, set_Key, arginfo_TElXMLKeyInfoHMACData_set_Key, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoHMACData, __construct, arginfo_TElXMLKeyInfoHMACData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoHMACData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoHMACData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoHMACData", TElXMLKeyInfoHMACData_methods);
	if (NULL == TElXMLKeyInfoData_ce_ptr)
		Register_TElXMLKeyInfoData(TSRMLS_C);
	TElXMLKeyInfoHMACData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoSymmetricData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoSymmetricData, get_Key)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoSymmetricData_get_Key(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSymmetricKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoSymmetricData, set_Key)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSymmetricKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoSymmetricData_set_Key(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSymmetricKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoSymmetricData, __construct)
{
	zend_bool bAOwnResources;
	zend_bool bOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoSymmetricData_Create((int8_t)bOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoSymmetricData_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoSymmetricData_get_Key, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoSymmetricData_set_Key, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSymmetricKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoSymmetricData___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnResources_or_AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoSymmetricData_methods[] = {
	PHP_ME(TElXMLKeyInfoSymmetricData, get_Key, arginfo_TElXMLKeyInfoSymmetricData_get_Key, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoSymmetricData, set_Key, arginfo_TElXMLKeyInfoSymmetricData_set_Key, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoSymmetricData, __construct, arginfo_TElXMLKeyInfoSymmetricData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoSymmetricData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoSymmetricData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoSymmetricData", TElXMLKeyInfoSymmetricData_methods);
	if (NULL == TElXMLKeyInfoData_ce_ptr)
		Register_TElXMLKeyInfoData(TSRMLS_C);
	TElXMLKeyInfoSymmetricData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoAsymmetricData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoAsymmetricData, __construct)
{
	zend_bool bAOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoAsymmetricData_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoAsymmetricData_Create_1((int8_t)bAOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoAsymmetricData_Create_2((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAsymmetricData___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoAsymmetricData_methods[] = {
	PHP_ME(TElXMLKeyInfoAsymmetricData, __construct, arginfo_TElXMLKeyInfoAsymmetricData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoAsymmetricData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoAsymmetricData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoAsymmetricData", TElXMLKeyInfoAsymmetricData_methods);
	if (NULL == TElXMLKeyInfoData_ce_ptr)
		Register_TElXMLKeyInfoData(TSRMLS_C);
	TElXMLKeyInfoAsymmetricData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoRSAData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoRSAData, Update)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoRSAData_Update(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoRSAData, get_RSAKeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoRSAData_get_RSAKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRSAKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoRSAData, get_Exponent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoRSAData_get_Exponent(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1104675180, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoRSAData, get_Modulus)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoRSAData_get_Modulus(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2125016035, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoRSAData, __construct)
{
	zend_bool bAOwnResources;
	zend_bool bOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoRSAData_Create((int8_t)bOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoRSAData_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRSAData_Update, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRSAData_get_RSAKeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRSAData_get_Exponent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRSAData_get_Modulus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRSAData___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnResources_or_AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoRSAData_methods[] = {
	PHP_ME(TElXMLKeyInfoRSAData, Update, arginfo_TElXMLKeyInfoRSAData_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoRSAData, get_RSAKeyMaterial, arginfo_TElXMLKeyInfoRSAData_get_RSAKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoRSAData, get_Exponent, arginfo_TElXMLKeyInfoRSAData_get_Exponent, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoRSAData, get_Modulus, arginfo_TElXMLKeyInfoRSAData_get_Modulus, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoRSAData, __construct, arginfo_TElXMLKeyInfoRSAData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoRSAData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoRSAData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoRSAData", TElXMLKeyInfoRSAData_methods);
	if (NULL == TElXMLKeyInfoAsymmetricData_ce_ptr)
		Register_TElXMLKeyInfoAsymmetricData(TSRMLS_C);
	TElXMLKeyInfoRSAData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoAsymmetricData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoDSAData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoDSAData, Update)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoDSAData_Update(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDSAData, get_DSAKeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoDSAData_get_DSAKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDSAKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDSAData, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDSAData_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-876226309, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDSAData, get_Q)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDSAData_get_Q(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1128077203, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDSAData, get_G)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDSAData_get_G(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1209425212, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDSAData, get_Y)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDSAData_get_Y(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1306959777, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDSAData, get_J)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDSAData_get_J(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(916922753, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDSAData, get_Seed)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDSAData_get_Seed(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(360872276, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDSAData, get_PgenCounter)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDSAData_get_PgenCounter(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-932049508, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDSAData, __construct)
{
	zend_bool bAOwnResources;
	zend_bool bOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoDSAData_Create((int8_t)bOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoDSAData_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData_Update, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData_get_DSAKeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData_get_Q, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData_get_G, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData_get_Y, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData_get_J, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData_get_Seed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData_get_PgenCounter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDSAData___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnResources_or_AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoDSAData_methods[] = {
	PHP_ME(TElXMLKeyInfoDSAData, Update, arginfo_TElXMLKeyInfoDSAData_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDSAData, get_DSAKeyMaterial, arginfo_TElXMLKeyInfoDSAData_get_DSAKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDSAData, get_P, arginfo_TElXMLKeyInfoDSAData_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDSAData, get_Q, arginfo_TElXMLKeyInfoDSAData_get_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDSAData, get_G, arginfo_TElXMLKeyInfoDSAData_get_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDSAData, get_Y, arginfo_TElXMLKeyInfoDSAData_get_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDSAData, get_J, arginfo_TElXMLKeyInfoDSAData_get_J, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDSAData, get_Seed, arginfo_TElXMLKeyInfoDSAData_get_Seed, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDSAData, get_PgenCounter, arginfo_TElXMLKeyInfoDSAData_get_PgenCounter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDSAData, __construct, arginfo_TElXMLKeyInfoDSAData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoDSAData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoDSAData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoDSAData", TElXMLKeyInfoDSAData_methods);
	if (NULL == TElXMLKeyInfoAsymmetricData_ce_ptr)
		Register_TElXMLKeyInfoAsymmetricData(TSRMLS_C);
	TElXMLKeyInfoDSAData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoAsymmetricData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoDHData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoDHData, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDHData_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-58599596, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDHData, get_Q)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDHData_get_Q(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1954093118, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDHData, get_Generator)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDHData_get_Generator(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(992220893, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDHData, get_PublicKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDHData_get_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1868378555, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDHData, get_Seed)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDHData_get_Seed(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(831519352, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDHData, get_PgenCounter)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoDHData_get_PgenCounter(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1886665510, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoDHData, __construct)
{
	zend_bool bAOwnResources;
	zend_bool bOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoDHData_Create((int8_t)bOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoDHData_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDHData_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDHData_get_Q, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDHData_get_Generator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDHData_get_PublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDHData_get_Seed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDHData_get_PgenCounter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoDHData___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnResources_or_AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoDHData_methods[] = {
	PHP_ME(TElXMLKeyInfoDHData, get_P, arginfo_TElXMLKeyInfoDHData_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDHData, get_Q, arginfo_TElXMLKeyInfoDHData_get_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDHData, get_Generator, arginfo_TElXMLKeyInfoDHData_get_Generator, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDHData, get_PublicKey, arginfo_TElXMLKeyInfoDHData_get_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDHData, get_Seed, arginfo_TElXMLKeyInfoDHData_get_Seed, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDHData, get_PgenCounter, arginfo_TElXMLKeyInfoDHData_get_PgenCounter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoDHData, __construct, arginfo_TElXMLKeyInfoDHData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoDHData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoDHData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoDHData", TElXMLKeyInfoDHData_methods);
	if (NULL == TElXMLKeyInfoAsymmetricData_ce_ptr)
		Register_TElXMLKeyInfoAsymmetricData(TSRMLS_C);
	TElXMLKeyInfoDHData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoAsymmetricData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoGOST2001Data_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoGOST2001Data, Update)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoGOST2001Data_Update(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoGOST2001Data, get_GOST2001KeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoGOST2001Data_get_GOST2001KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGOST2001KeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoGOST2001Data, get_PublicKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoGOST2001Data_get_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1969419628, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoGOST2001Data, get_PublicKeyParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoGOST2001Data_get_PublicKeyParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1224232396, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoGOST2001Data, get_DigestParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoGOST2001Data_get_DigestParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1298008030, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoGOST2001Data, get_EncryptionParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoGOST2001Data_get_EncryptionParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-366757360, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoGOST2001Data, __construct)
{
	zend_bool bAOwnResources;
	zend_bool bOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoGOST2001Data_Create((int8_t)bOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoGOST2001Data_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoGOST2001Data_Update, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoGOST2001Data_get_GOST2001KeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoGOST2001Data_get_PublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoGOST2001Data_get_PublicKeyParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoGOST2001Data_get_DigestParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoGOST2001Data_get_EncryptionParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoGOST2001Data___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnResources_or_AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoGOST2001Data_methods[] = {
	PHP_ME(TElXMLKeyInfoGOST2001Data, Update, arginfo_TElXMLKeyInfoGOST2001Data_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoGOST2001Data, get_GOST2001KeyMaterial, arginfo_TElXMLKeyInfoGOST2001Data_get_GOST2001KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoGOST2001Data, get_PublicKey, arginfo_TElXMLKeyInfoGOST2001Data_get_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoGOST2001Data, get_PublicKeyParamSet, arginfo_TElXMLKeyInfoGOST2001Data_get_PublicKeyParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoGOST2001Data, get_DigestParamSet, arginfo_TElXMLKeyInfoGOST2001Data_get_DigestParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoGOST2001Data, get_EncryptionParamSet, arginfo_TElXMLKeyInfoGOST2001Data_get_EncryptionParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoGOST2001Data, __construct, arginfo_TElXMLKeyInfoGOST2001Data___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoGOST2001Data(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoGOST2001Data_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoGOST2001Data", TElXMLKeyInfoGOST2001Data_methods);
	if (NULL == TElXMLKeyInfoAsymmetricData_ce_ptr)
		Register_TElXMLKeyInfoAsymmetricData(TSRMLS_C);
	TElXMLKeyInfoGOST2001Data_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoAsymmetricData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoPGPData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoPGPData, Update)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoPGPData_Update(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, get_IncludeDataParam)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLKeyInfoPGPDataParamRaw fOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoPGPData_get_IncludeDataParam(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, set_IncludeDataParam)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoPGPData_set_IncludeDataParam(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLKeyInfoPGPDataParamRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, get_IncludeKeyValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoPGPData_get_IncludeKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, set_IncludeKeyValue)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoPGPData_set_IncludeKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, get_PublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoPGPData_get_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPCustomPublicKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, set_PublicKey)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPGPCustomPublicKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoPGPData_set_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomPublicKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, get_SecretKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoPGPData_get_SecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPCustomSecretKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, set_SecretKey)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPGPCustomSecretKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoPGPData_set_SecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomSecretKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, get_Passphrase)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoPGPData_get_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1435123891, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, set_Passphrase)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoPGPData_set_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, get_KeyID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoPGPData_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-739064151, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, get_KeyPacketCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoPGPData_get_KeyPacketCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, get_KeyPackets)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoPGPData_get_KeyPackets(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1561652292, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoPGPData, __construct)
{
	zend_bool bAOwnResources;
	zend_bool bOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoPGPData_Create((int8_t)bOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoPGPData_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_Update, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_get_IncludeDataParam, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_set_IncludeDataParam, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_get_IncludeKeyValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_set_IncludeKeyValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_get_PublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_set_PublicKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPCustomPublicKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_get_SecretKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_set_SecretKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPCustomSecretKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_get_Passphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_set_Passphrase, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_get_KeyPacketCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData_get_KeyPackets, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoPGPData___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnResources_or_AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoPGPData_methods[] = {
	PHP_ME(TElXMLKeyInfoPGPData, Update, arginfo_TElXMLKeyInfoPGPData_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, get_IncludeDataParam, arginfo_TElXMLKeyInfoPGPData_get_IncludeDataParam, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, set_IncludeDataParam, arginfo_TElXMLKeyInfoPGPData_set_IncludeDataParam, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, get_IncludeKeyValue, arginfo_TElXMLKeyInfoPGPData_get_IncludeKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, set_IncludeKeyValue, arginfo_TElXMLKeyInfoPGPData_set_IncludeKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, get_PublicKey, arginfo_TElXMLKeyInfoPGPData_get_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, set_PublicKey, arginfo_TElXMLKeyInfoPGPData_set_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, get_SecretKey, arginfo_TElXMLKeyInfoPGPData_get_SecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, set_SecretKey, arginfo_TElXMLKeyInfoPGPData_set_SecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, get_Passphrase, arginfo_TElXMLKeyInfoPGPData_get_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, set_Passphrase, arginfo_TElXMLKeyInfoPGPData_set_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, get_KeyID, arginfo_TElXMLKeyInfoPGPData_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, get_KeyPacketCount, arginfo_TElXMLKeyInfoPGPData_get_KeyPacketCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, get_KeyPackets, arginfo_TElXMLKeyInfoPGPData_get_KeyPackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoPGPData, __construct, arginfo_TElXMLKeyInfoPGPData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoPGPData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoPGPData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoPGPData", TElXMLKeyInfoPGPData_methods);
	if (NULL == TElXMLKeyInfoAsymmetricData_ce_ptr)
		Register_TElXMLKeyInfoAsymmetricData(TSRMLS_C);
	TElXMLKeyInfoPGPData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoAsymmetricData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoECData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoECData, get_ECKeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoECData_get_ECKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElECKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, get_KeyValueFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLECKeyValueFormatRaw fOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoECData_get_KeyValueFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, set_KeyValueFormat)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoECData_set_KeyValueFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXMLECKeyValueFormatRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, get_PrimeNumberType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLECPrimeNumberTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoECData_get_PrimeNumberType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, set_PrimeNumberType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoECData_set_PrimeNumberType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXMLECPrimeNumberTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, get_IncludeDomainParameters)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoECData_get_IncludeDomainParameters(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, set_IncludeDomainParameters)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoECData_set_IncludeDomainParameters(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, get_UseExplicitParameters)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoECData_get_UseExplicitParameters(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, set_UseExplicitParameters)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoECData_set_UseExplicitParameters(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, get_ECDSAPrefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoECData_get_ECDSAPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2142626132, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, set_ECDSAPrefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoECData_set_ECDSAPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, get_DSIG11Prefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoECData_get_DSIG11Prefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-474300905, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, set_DSIG11Prefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoECData_set_DSIG11Prefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoECData, __construct)
{
	zend_bool bAOwnResources;
	zval *oAManager;
	zval *oAProvider;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoECData_Create((int8_t)bAOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oAManager, TElCustomCryptoProviderManager_ce_ptr, &oAProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoECData_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oAManager TSRMLS_CC), SBGetObjectHandle(oAProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_get_ECKeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_get_KeyValueFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_set_KeyValueFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_get_PrimeNumberType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_set_PrimeNumberType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_get_IncludeDomainParameters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_set_IncludeDomainParameters, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_get_UseExplicitParameters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_set_UseExplicitParameters, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_get_ECDSAPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_set_ECDSAPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_get_DSIG11Prefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData_set_DSIG11Prefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoECData___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AOwnResources)
	ZEND_ARG_OBJ_INFO(0, AManager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, AProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoECData_methods[] = {
	PHP_ME(TElXMLKeyInfoECData, get_ECKeyMaterial, arginfo_TElXMLKeyInfoECData_get_ECKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, get_KeyValueFormat, arginfo_TElXMLKeyInfoECData_get_KeyValueFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, set_KeyValueFormat, arginfo_TElXMLKeyInfoECData_set_KeyValueFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, get_PrimeNumberType, arginfo_TElXMLKeyInfoECData_get_PrimeNumberType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, set_PrimeNumberType, arginfo_TElXMLKeyInfoECData_set_PrimeNumberType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, get_IncludeDomainParameters, arginfo_TElXMLKeyInfoECData_get_IncludeDomainParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, set_IncludeDomainParameters, arginfo_TElXMLKeyInfoECData_set_IncludeDomainParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, get_UseExplicitParameters, arginfo_TElXMLKeyInfoECData_get_UseExplicitParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, set_UseExplicitParameters, arginfo_TElXMLKeyInfoECData_set_UseExplicitParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, get_ECDSAPrefix, arginfo_TElXMLKeyInfoECData_get_ECDSAPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, set_ECDSAPrefix, arginfo_TElXMLKeyInfoECData_set_ECDSAPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, get_DSIG11Prefix, arginfo_TElXMLKeyInfoECData_get_DSIG11Prefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, set_DSIG11Prefix, arginfo_TElXMLKeyInfoECData_set_DSIG11Prefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoECData, __construct, arginfo_TElXMLKeyInfoECData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoECData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoECData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoECData", TElXMLKeyInfoECData_methods);
	if (NULL == TElXMLKeyInfoAsymmetricData_ce_ptr)
		Register_TElXMLKeyInfoAsymmetricData(TSRMLS_C);
	TElXMLKeyInfoECData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoAsymmetricData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLIssuerSerial_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLIssuerSerial, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLIssuerSerial_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIssuerSerial, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLIssuerSerial_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIssuerSerial, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLIssuerSerial_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIssuerSerial, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLIssuerSerial_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLIssuerSerial_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIssuerSerial, get_IssuerRDN)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLIssuerSerial_get_IssuerRDN(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIssuerSerial, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLIssuerSerial_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(993919007, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIssuerSerial, set_SerialNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLIssuerSerial_set_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIssuerSerial, get_HexSerialNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLIssuerSerial_get_HexSerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIssuerSerial, set_HexSerialNumber)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLIssuerSerial_set_HexSerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIssuerSerial, __construct)
{
	char *sAName;
	char *sANamespaceURI;
	char *sAPrefix;
	int sAName_len;
	int sANamespaceURI_len;
	int sAPrefix_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLIssuerSerial_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sAName, &sAName_len, &sANamespaceURI, &sANamespaceURI_len, &sAPrefix, &sAPrefix_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLIssuerSerial_Create_1(sAName, (int32_t)sAName_len, sANamespaceURI, (int32_t)sANamespaceURI_len, sAPrefix, (int32_t)sAPrefix_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial_get_IssuerRDN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial_set_SerialNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial_get_HexSerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial_set_HexSerialNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIssuerSerial___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, ANamespaceURI)
	ZEND_ARG_INFO(0, APrefix)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLIssuerSerial_methods[] = {
	PHP_ME(TElXMLIssuerSerial, Clear, arginfo_TElXMLIssuerSerial_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIssuerSerial, IsEmpty, arginfo_TElXMLIssuerSerial_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIssuerSerial, LoadFromXML, arginfo_TElXMLIssuerSerial_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIssuerSerial, SaveToXML, arginfo_TElXMLIssuerSerial_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIssuerSerial, get_IssuerRDN, arginfo_TElXMLIssuerSerial_get_IssuerRDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIssuerSerial, get_SerialNumber, arginfo_TElXMLIssuerSerial_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIssuerSerial, set_SerialNumber, arginfo_TElXMLIssuerSerial_set_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIssuerSerial, get_HexSerialNumber, arginfo_TElXMLIssuerSerial_get_HexSerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIssuerSerial, set_HexSerialNumber, arginfo_TElXMLIssuerSerial_set_HexSerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIssuerSerial, __construct, arginfo_TElXMLIssuerSerial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLIssuerSerial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLIssuerSerial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLIssuerSerial", TElXMLIssuerSerial_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLIssuerSerial_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoX509Data_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoX509Data, Update)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoX509Data_Update(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_IncludeDataParams)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLKeyInfoX509DataParamsRaw fOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoX509Data_get_IncludeDataParams(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, set_IncludeDataParams)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoX509Data_set_IncludeDataParams(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLKeyInfoX509DataParamsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_IncludeKeyValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoX509Data_get_IncludeKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, set_IncludeKeyValue)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoX509Data_set_IncludeKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_Certificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoX509Data_get_Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, set_Certificate)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoX509Data_set_Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoX509Data_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoX509Data_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_HexSerialNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoX509Data_get_HexSerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, set_HexSerialNumber)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoX509Data_set_HexSerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_IssuerSerialCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoX509Data_get_IssuerSerialCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_SubjectRDNCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoX509Data_get_SubjectRDNCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_SKICount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoX509Data_get_SKICount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_IssuerRDNs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoX509Data_get_IssuerRDNs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_SerialNumbers)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoX509Data_get_SerialNumbers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(928540558, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_SubjectRDNs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoX509Data_get_SubjectRDNs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_SKIs)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoX509Data_get_SKIs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-268885928, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_CRLData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoX509Data_get_CRLData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1908471967, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, get_GeneratedKeyValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoX509Data_get_GeneratedKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfoData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoX509Data, __construct)
{
	zend_bool bAOwnResources;
	zend_bool bOwnResources;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnResources) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoX509Data_Create((int8_t)bOwnResources, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!O!", &bAOwnResources, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoX509Data_Create_1((int8_t)bAOwnResources, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_Update, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_IncludeDataParams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_set_IncludeDataParams, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_IncludeKeyValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_set_IncludeKeyValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_Certificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_set_Certificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_HexSerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_set_HexSerialNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_IssuerSerialCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_SubjectRDNCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_SKICount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_IssuerRDNs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_SerialNumbers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_SubjectRDNs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_SKIs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_CRLData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data_get_GeneratedKeyValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoX509Data___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnResources_or_AOwnResources)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoX509Data_methods[] = {
	PHP_ME(TElXMLKeyInfoX509Data, Update, arginfo_TElXMLKeyInfoX509Data_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_IncludeDataParams, arginfo_TElXMLKeyInfoX509Data_get_IncludeDataParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, set_IncludeDataParams, arginfo_TElXMLKeyInfoX509Data_set_IncludeDataParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_IncludeKeyValue, arginfo_TElXMLKeyInfoX509Data_get_IncludeKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, set_IncludeKeyValue, arginfo_TElXMLKeyInfoX509Data_set_IncludeKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_Certificate, arginfo_TElXMLKeyInfoX509Data_get_Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, set_Certificate, arginfo_TElXMLKeyInfoX509Data_set_Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_CertStorage, arginfo_TElXMLKeyInfoX509Data_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, set_CertStorage, arginfo_TElXMLKeyInfoX509Data_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_HexSerialNumber, arginfo_TElXMLKeyInfoX509Data_get_HexSerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, set_HexSerialNumber, arginfo_TElXMLKeyInfoX509Data_set_HexSerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_IssuerSerialCount, arginfo_TElXMLKeyInfoX509Data_get_IssuerSerialCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_SubjectRDNCount, arginfo_TElXMLKeyInfoX509Data_get_SubjectRDNCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_SKICount, arginfo_TElXMLKeyInfoX509Data_get_SKICount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_IssuerRDNs, arginfo_TElXMLKeyInfoX509Data_get_IssuerRDNs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_SerialNumbers, arginfo_TElXMLKeyInfoX509Data_get_SerialNumbers, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_SubjectRDNs, arginfo_TElXMLKeyInfoX509Data_get_SubjectRDNs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_SKIs, arginfo_TElXMLKeyInfoX509Data_get_SKIs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_CRLData, arginfo_TElXMLKeyInfoX509Data_get_CRLData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, get_GeneratedKeyValue, arginfo_TElXMLKeyInfoX509Data_get_GeneratedKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoX509Data, __construct, arginfo_TElXMLKeyInfoX509Data___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoX509Data(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoX509Data_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoX509Data", TElXMLKeyInfoX509Data_methods);
	if (NULL == TElXMLKeyInfoAsymmetricData_ce_ptr)
		Register_TElXMLKeyInfoAsymmetricData(TSRMLS_C);
	TElXMLKeyInfoX509Data_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoAsymmetricData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoNode_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoNode, get_OwnNode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLKeyInfoNode_get_OwnNode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoNode, set_OwnNode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoNode_set_OwnNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoNode, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoNode_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoNode, set_Value)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoNode_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoNode, __construct)
{
	zend_bool bAOwnNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoNode_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAOwnNode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoNode_Create_1((int8_t)bAOwnNode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoNode_get_OwnNode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoNode_set_OwnNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoNode_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoNode_set_Value, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoNode___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, AOwnNode)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoNode_methods[] = {
	PHP_ME(TElXMLKeyInfoNode, get_OwnNode, arginfo_TElXMLKeyInfoNode_get_OwnNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoNode, set_OwnNode, arginfo_TElXMLKeyInfoNode_set_OwnNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoNode, get_Value, arginfo_TElXMLKeyInfoNode_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoNode, set_Value, arginfo_TElXMLKeyInfoNode_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoNode, __construct, arginfo_TElXMLKeyInfoNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoNode", TElXMLKeyInfoNode_methods);
	if (NULL == TElXMLKeyInfoItem_ce_ptr)
		Register_TElXMLKeyInfoItem(TSRMLS_C);
	TElXMLKeyInfoNode_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoItem_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoRetrievalMethod_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoRetrievalMethod, get_DataType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoRetrievalMethod_get_DataType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1368849327, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoRetrievalMethod, set_DataType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoRetrievalMethod_set_DataType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoRetrievalMethod, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoRetrievalMethod_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1866219304, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoRetrievalMethod, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoRetrievalMethod_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoRetrievalMethod, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoRetrievalMethod_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRetrievalMethod_get_DataType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRetrievalMethod_set_DataType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRetrievalMethod_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRetrievalMethod_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoRetrievalMethod___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoRetrievalMethod_methods[] = {
	PHP_ME(TElXMLKeyInfoRetrievalMethod, get_DataType, arginfo_TElXMLKeyInfoRetrievalMethod_get_DataType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoRetrievalMethod, set_DataType, arginfo_TElXMLKeyInfoRetrievalMethod_set_DataType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoRetrievalMethod, get_URI, arginfo_TElXMLKeyInfoRetrievalMethod_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoRetrievalMethod, set_URI, arginfo_TElXMLKeyInfoRetrievalMethod_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoRetrievalMethod, __construct, arginfo_TElXMLKeyInfoRetrievalMethod___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoRetrievalMethod(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoRetrievalMethod_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoRetrievalMethod", TElXMLKeyInfoRetrievalMethod_methods);
	if (NULL == TElXMLKeyInfoItem_ce_ptr)
		Register_TElXMLKeyInfoItem(TSRMLS_C);
	TElXMLKeyInfoRetrievalMethod_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoItem_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLKeyInfoAgreementMethod_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, get_Algorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoAgreementMethod_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(278118663, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, set_Algorithm)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoAgreementMethod_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, get_DigestMethod)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLKeyInfoAgreementMethod_get_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(274422856, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, set_DigestMethod)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoAgreementMethod_set_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, get_KANonce)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLKeyInfoAgreementMethod_get_KANonce(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2065028047, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, set_KANonce)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLKeyInfoAgreementMethod_set_KANonce(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoAgreementMethod_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoAgreementMethod_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, get_OriginatorKeyInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoAgreementMethod_get_OriginatorKeyInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, set_OriginatorKeyInfo)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLKeyInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoAgreementMethod_set_OriginatorKeyInfo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, get_RecipientKeyInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoAgreementMethod_get_RecipientKeyInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, set_RecipientKeyInfo)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLKeyInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLKeyInfoAgreementMethod_set_RecipientKeyInfo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLKeyInfoAgreementMethod, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLKeyInfoAgreementMethod_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_get_DigestMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_set_DigestMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_get_KANonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_set_KANonce, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_get_OriginatorKeyInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_set_OriginatorKeyInfo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLKeyInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_get_RecipientKeyInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod_set_RecipientKeyInfo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLKeyInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLKeyInfoAgreementMethod___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLKeyInfoAgreementMethod_methods[] = {
	PHP_ME(TElXMLKeyInfoAgreementMethod, get_Algorithm, arginfo_TElXMLKeyInfoAgreementMethod_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, set_Algorithm, arginfo_TElXMLKeyInfoAgreementMethod_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, get_DigestMethod, arginfo_TElXMLKeyInfoAgreementMethod_get_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, set_DigestMethod, arginfo_TElXMLKeyInfoAgreementMethod_set_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, get_KANonce, arginfo_TElXMLKeyInfoAgreementMethod_get_KANonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, set_KANonce, arginfo_TElXMLKeyInfoAgreementMethod_set_KANonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, get_CryptoProviderManager, arginfo_TElXMLKeyInfoAgreementMethod_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, set_CryptoProviderManager, arginfo_TElXMLKeyInfoAgreementMethod_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, get_OriginatorKeyInfo, arginfo_TElXMLKeyInfoAgreementMethod_get_OriginatorKeyInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, set_OriginatorKeyInfo, arginfo_TElXMLKeyInfoAgreementMethod_set_OriginatorKeyInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, get_RecipientKeyInfo, arginfo_TElXMLKeyInfoAgreementMethod_get_RecipientKeyInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, set_RecipientKeyInfo, arginfo_TElXMLKeyInfoAgreementMethod_set_RecipientKeyInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLKeyInfoAgreementMethod, __construct, arginfo_TElXMLKeyInfoAgreementMethod___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLKeyInfoAgreementMethod(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLKeyInfoAgreementMethod_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoAgreementMethod", TElXMLKeyInfoAgreementMethod_methods);
	if (NULL == TElXMLKeyInfoItem_ce_ptr)
		Register_TElXMLKeyInfoItem(TSRMLS_C);
	TElXMLKeyInfoAgreementMethod_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLKeyInfoItem_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLProperty_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLProperty, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLProperty_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-686294022, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperty, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLProperty_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperty, get_Target)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLProperty_get_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(945522519, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperty, set_Target)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLProperty_set_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperty, get_PropertyNode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLProperty_get_PropertyNode(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperty, set_PropertyNode)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLProperty_set_PropertyNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperty, get_OwnPropertyNode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLProperty_get_OwnPropertyNode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperty, set_OwnPropertyNode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLProperty_set_OwnPropertyNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperty, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLProperty_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperty_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperty_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperty_get_Target, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperty_set_Target, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperty_get_PropertyNode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperty_set_PropertyNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperty_get_OwnPropertyNode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperty_set_OwnPropertyNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperty___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLProperty_methods[] = {
	PHP_ME(TElXMLProperty, get_ID, arginfo_TElXMLProperty_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperty, set_ID, arginfo_TElXMLProperty_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperty, get_Target, arginfo_TElXMLProperty_get_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperty, set_Target, arginfo_TElXMLProperty_set_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperty, get_PropertyNode, arginfo_TElXMLProperty_get_PropertyNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperty, set_PropertyNode, arginfo_TElXMLProperty_set_PropertyNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperty, get_OwnPropertyNode, arginfo_TElXMLProperty_get_OwnPropertyNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperty, set_OwnPropertyNode, arginfo_TElXMLProperty_set_OwnPropertyNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperty, __construct, arginfo_TElXMLProperty___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLProperty(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLProperty_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLProperty", TElXMLProperty_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLProperty_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLProperties, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLProperties_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLProperties_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLProperties_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLProperties_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, Add)
{
	zval *oAProperty;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAProperty, TElXMLProperty_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLProperties_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAProperty TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLProperty)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, Insert)
{
	long l4Index;
	zval *oAProperty;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAProperty, TElXMLProperty_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLProperties_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAProperty TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLProperty)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLProperties_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLProperties_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLProperties_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLProperties_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(759380718, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLProperties_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, get_Properties)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLProperties_get_Properties(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLProperty_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProperties, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLProperties_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AProperty, TElXMLProperty, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AProperty, TElXMLProperty, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties_get_Properties, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProperties___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLProperties_methods[] = {
	PHP_ME(TElXMLProperties, IsEmpty, arginfo_TElXMLProperties_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, LoadFromXML, arginfo_TElXMLProperties_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, SaveToXML, arginfo_TElXMLProperties_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, Add, arginfo_TElXMLProperties_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, Insert, arginfo_TElXMLProperties_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, Delete, arginfo_TElXMLProperties_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, Clear, arginfo_TElXMLProperties_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, get_Count, arginfo_TElXMLProperties_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, get_ID, arginfo_TElXMLProperties_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, set_ID, arginfo_TElXMLProperties_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, get_Properties, arginfo_TElXMLProperties_get_Properties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProperties, __construct, arginfo_TElXMLProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLProperties", TElXMLProperties_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLProperties_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLProcessor, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLProcessor_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProcessor, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLProcessor_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLProcessor, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLProcessor_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProcessor_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProcessor_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLProcessor___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLProcessor_methods[] = {
	PHP_ME(TElXMLProcessor, get_CryptoProviderManager, arginfo_TElXMLProcessor_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProcessor, set_CryptoProviderManager, arginfo_TElXMLProcessor_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLProcessor, __construct, arginfo_TElXMLProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLProcessor", TElXMLProcessor_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElXMLProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLFormatter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLFormatter, AppendElement)
{
	zval *oChild;
	zval *oDocument;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParent, TElXMLDOMElement_ce_ptr, &oChild, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLFormatter_AppendElement(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oChild TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oParent, TElXMLDOMElement_ce_ptr, &oChild, TElXMLCustomElement_ce_ptr, &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLFormatter_AppendElement_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oChild TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLDOMElement) or (TElXMLDOMElement, TElXMLCustomElement, TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, AppendElementWithText)
{
	char *sChildText;
	int sChildText_len;
	long fChildTextType;
	zval *oChild;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sl", &oParent, TElXMLDOMElement_ce_ptr, &oChild, TElXMLDOMElement_ce_ptr, &sChildText, &sChildText_len, &fChildTextType) == SUCCESS)
	{
		SBCheckError(TElXMLFormatter_AppendElementWithText(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oChild TSRMLS_CC), sChildText, (int32_t)sChildText_len, (TElXMLTextTypeRaw)fChildTextType) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLDOMElement, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, AppendText)
{
	char *sText;
	int sText_len;
	long fTextType;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oParent, TElXMLDOMElement_ce_ptr, &sText, &sText_len, &fTextType) == SUCCESS)
	{
		SBCheckError(TElXMLFormatter_AppendText(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sText, (int32_t)sText_len, (TElXMLTextTypeRaw)fTextType) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, InsertBefore)
{
	zval *oChild;
	zval *oChildRef;
	zval *oDocument;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!", &oParent, TElXMLDOMElement_ce_ptr, &oChildRef, TElXMLDOMNode_ce_ptr, &oChild, TElXMLCustomElement_ce_ptr, &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLFormatter_InsertBefore(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oChildRef TSRMLS_CC), SBGetObjectHandle(oChild TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLDOMNode, TElXMLCustomElement, TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLFormatter_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, Push)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLFormatter_Push(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, Pop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLFormatter_Pop(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, get_Level)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLFormatter_get_Level(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, set_Level)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElXMLFormatter_set_Level(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, get_Path)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLFormatter_get_Path(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-313071919, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, set_Path)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLFormatter_set_Path(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, get_OnFormatElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLFormatElementEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLFormatter_get_OnFormatElement(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, set_OnFormatElement)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLFormatter_set_OnFormatElement(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLFormatElementEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLFormatElementEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, get_OnFormatText)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLFormatTextEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLFormatter_get_OnFormatText(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, set_OnFormatText)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLFormatter_set_OnFormatText(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLFormatTextEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLFormatTextEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLFormatter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLFormatter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_AppendElement, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Parent, TElXMLDOMElement, 1)
	ZEND_ARG_TYPE_INFO(0, Child, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_AppendElementWithText, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Parent, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, Child, TElXMLDOMElement, 1)
	ZEND_ARG_INFO(0, ChildText)
	ZEND_ARG_INFO(0, ChildTextType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_AppendText, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Parent, TElXMLDOMElement, 1)
	ZEND_ARG_INFO(0, Text)
	ZEND_ARG_INFO(0, TextType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_InsertBefore, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Parent, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, ChildRef, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, Child, TElXMLCustomElement, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_Push, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_Pop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_get_Level, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_set_Level, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_get_Path, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_set_Path, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_get_OnFormatElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_set_OnFormatElement, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_get_OnFormatText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter_set_OnFormatText, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLFormatter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLFormatter_methods[] = {
	PHP_ME(TElXMLFormatter, AppendElement, arginfo_TElXMLFormatter_AppendElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, AppendElementWithText, arginfo_TElXMLFormatter_AppendElementWithText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, AppendText, arginfo_TElXMLFormatter_AppendText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, InsertBefore, arginfo_TElXMLFormatter_InsertBefore, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, Clear, arginfo_TElXMLFormatter_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, Push, arginfo_TElXMLFormatter_Push, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, Pop, arginfo_TElXMLFormatter_Pop, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, get_Level, arginfo_TElXMLFormatter_get_Level, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, set_Level, arginfo_TElXMLFormatter_set_Level, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, get_Path, arginfo_TElXMLFormatter_get_Path, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, set_Path, arginfo_TElXMLFormatter_set_Path, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, get_OnFormatElement, arginfo_TElXMLFormatter_get_OnFormatElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, set_OnFormatElement, arginfo_TElXMLFormatter_set_OnFormatElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, get_OnFormatText, arginfo_TElXMLFormatter_get_OnFormatText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, set_OnFormatText, arginfo_TElXMLFormatter_set_OnFormatText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLFormatter, __construct, arginfo_TElXMLFormatter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLFormatter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLFormatter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLFormatter", TElXMLFormatter_methods);
	if (NULL == TElXMLCustomFormatter_ce_ptr)
		Register_TElXMLCustomFormatter(TSRMLS_C);
	TElXMLFormatter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomFormatter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDescriptorMap_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDescriptorMap, Add)
{
	char *sDescriptor;
	int sDescriptor_len;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zs", &zaOID, &sDescriptor, &sDescriptor_len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLDescriptorMap_Add(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, sDescriptor, (int32_t)sDescriptor_len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, ClearOID)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLDescriptorMap_ClearOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, RemoveAt)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLDescriptorMap_RemoveAt(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, FindDescriptor)
{
	SBArrayZValInfo aiOID;
	uint32_t _err;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		_err = TElXMLDescriptorMap_FindDescriptor(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-384415760, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiOID);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, FindOID)
{
	char *sDescriptor;
	int sDescriptor_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDescriptor, &sDescriptor_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLDescriptorMap_FindOID(SBGetObjectHandle(getThis() TSRMLS_CC), sDescriptor, (int32_t)sDescriptor_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-484118159, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, ClearOIDs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLDescriptorMap_ClearOIDs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, ClearOrders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLDescriptorMap_ClearOrders(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, GetOrder)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLDescriptorMap_GetOrder(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, SetOrder)
{
	long l4Index;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLDescriptorMap_SetOrder(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiOID.data, aiOID.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, get_CompatibilityMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLRDNCompatibilityModeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLDescriptorMap_get_CompatibilityMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, set_CompatibilityMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLDescriptorMap_set_CompatibilityMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLRDNCompatibilityModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, get_ReverseOrder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDescriptorMap_get_ReverseOrder(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, set_ReverseOrder)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLDescriptorMap_set_ReverseOrder(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, get_Separator)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDescriptorMap_get_Separator(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-736376533, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, set_Separator)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDescriptorMap_set_Separator(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDescriptorMap_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, get_OID)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLDescriptorMap_get_OID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(607548868, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, get_Descriptor)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDescriptorMap_get_Descriptor(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2102724535, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDescriptorMap, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDescriptorMap_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_Add, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
	ZEND_ARG_INFO(0, Descriptor)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_ClearOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_RemoveAt, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_FindDescriptor, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_FindOID, 0, 0, 1)
	ZEND_ARG_INFO(0, Descriptor)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_ClearOIDs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_ClearOrders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_GetOrder, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_SetOrder, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_get_CompatibilityMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_set_CompatibilityMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_get_ReverseOrder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_set_ReverseOrder, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_get_Separator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_set_Separator, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_get_OID, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap_get_Descriptor, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDescriptorMap___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDescriptorMap_methods[] = {
	PHP_ME(TElXMLDescriptorMap, Add, arginfo_TElXMLDescriptorMap_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, ClearOID, arginfo_TElXMLDescriptorMap_ClearOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, RemoveAt, arginfo_TElXMLDescriptorMap_RemoveAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, FindDescriptor, arginfo_TElXMLDescriptorMap_FindDescriptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, FindOID, arginfo_TElXMLDescriptorMap_FindOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, ClearOIDs, arginfo_TElXMLDescriptorMap_ClearOIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, ClearOrders, arginfo_TElXMLDescriptorMap_ClearOrders, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, GetOrder, arginfo_TElXMLDescriptorMap_GetOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, SetOrder, arginfo_TElXMLDescriptorMap_SetOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, get_CompatibilityMode, arginfo_TElXMLDescriptorMap_get_CompatibilityMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, set_CompatibilityMode, arginfo_TElXMLDescriptorMap_set_CompatibilityMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, get_ReverseOrder, arginfo_TElXMLDescriptorMap_get_ReverseOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, set_ReverseOrder, arginfo_TElXMLDescriptorMap_set_ReverseOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, get_Separator, arginfo_TElXMLDescriptorMap_get_Separator, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, set_Separator, arginfo_TElXMLDescriptorMap_set_Separator, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, get_Count, arginfo_TElXMLDescriptorMap_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, get_OID, arginfo_TElXMLDescriptorMap_get_OID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, get_Descriptor, arginfo_TElXMLDescriptorMap_get_Descriptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDescriptorMap, __construct, arginfo_TElXMLDescriptorMap___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDescriptorMap(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDescriptorMap_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDescriptorMap", TElXMLDescriptorMap_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLDescriptorMap_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLSec, ToCryptoBinary)
{
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zend_bool bKeepTrailingZero;
	zval *zaBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuf) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBXMLSec_ToCryptoBinary(aiBuf.data, aiBuf.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1623342769, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaBuf, &bKeepTrailingZero) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBXMLSec_ToCryptoBinary_1(aiBuf.data, aiBuf.len, (int8_t)bKeepTrailingZero, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1254246457, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, FindChildElementEnc)
{
	char *sName;
	int sName_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oElement, TElXMLDOMElement_ce_ptr, &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLSec_FindChildElementEnc(SBGetObjectHandle(oElement TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, FindChildElementSig)
{
	char *sName;
	int sName_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oElement, TElXMLDOMElement_ce_ptr, &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLSec_FindChildElementSig(SBGetObjectHandle(oElement TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, FindChildElementXAdES)
{
	char *sName;
	char *sNamespaceURI;
	int sName_len;
	int sNamespaceURI_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oElement, TElXMLDOMElement_ce_ptr, &sName, &sName_len, &sNamespaceURI, &sNamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLSec_FindChildElementXAdES(SBGetObjectHandle(oElement TSRMLS_CC), sName, (int32_t)sName_len, sNamespaceURI, (int32_t)sNamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, CalculateDigest)
{
	long faMethod;
	long l4Size;
	SBArrayZValInfo piBuf;
	uint32_t _err;
	zval *oManager;
	zval *oParameters;
	zval *oProv;
	zval *zpBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zpBuf, &l4Size, &faMethod) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBXMLSec_CalculateDigest(piBuf.data, (int32_t)l4Size, (TElXMLDigestMethodRaw)faMethod, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-979580673, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piBuf);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllO!O!", &zpBuf, &l4Size, &faMethod, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBXMLSec_CalculateDigest_1(piBuf.data, (int32_t)l4Size, (TElXMLDigestMethodRaw)faMethod, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(771892710, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piBuf);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllO!O!O!", &zpBuf, &l4Size, &faMethod, &oParameters, TElXMLAlgorithmParameters_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBXMLSec_CalculateDigest_2(piBuf.data, (int32_t)l4Size, (TElXMLDigestMethodRaw)faMethod, SBGetObjectHandle(oParameters TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(569048271, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piBuf);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, integer) or (TSBPointer|array of byte|string|NULL, integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TSBPointer|array of byte|string|NULL, integer, integer, TElXMLAlgorithmParameters, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, CalculateDigestStream)
{
	long faMethod;
	long l8Count;
	uint32_t _err;
	zval *oManager;
	zval *oProv;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llO!O!", &oStream, TStream_ce_ptr, &l8Count, &faMethod, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBXMLSec_CalculateDigestStream(SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Count, (TElXMLDigestMethodRaw)faMethod, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1056304977, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, DigestMethodToHashAlgorithm)
{
	long fDigestMethod;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDigestMethod) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBXMLSec_DigestMethodToHashAlgorithm((TElXMLDigestMethodRaw)fDigestMethod, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, DigestMethodToURI)
{
	long fDigestMethod;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDigestMethod) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSec_DigestMethodToURI((TElXMLDigestMethodRaw)fDigestMethod, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1416321502, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, URIToDigestMethod)
{
	char *sDigestMethod;
	int sDigestMethod_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDigestMethod, &sDigestMethod_len) == SUCCESS)
	{
		TElXMLDigestMethodRaw fOutResultRaw = 0;
		SBCheckError(SBXMLSec_URIToDigestMethod(sDigestMethod, (int32_t)sDigestMethod_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, GetDigestMethodFromSignatureMethod)
{
	long fSignatureMethod;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fSignatureMethod) == SUCCESS)
	{
		TElXMLDigestMethodRaw fOutResultRaw = 0;
		SBCheckError(SBXMLSec_GetDigestMethodFromSignatureMethod((TElXMLSignatureMethodRaw)fSignatureMethod, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, HashAlgorithmToDigestMethod)
{
	long l4HashAlgorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4HashAlgorithm) == SUCCESS)
	{
		TElXMLDigestMethodRaw fOutResultRaw = 0;
		SBCheckError(SBXMLSec_HashAlgorithmToDigestMethod((int32_t)l4HashAlgorithm, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, FormatRDN)
{
	uint32_t _err;
	zval *oRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRDN, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSec_FormatRDN(SBGetObjectHandle(oRDN TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-474742362, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, ExtractRDN)
{
	char *sData;
	int sData_len;
	zval *oRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sData, &sData_len, &oRDN, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBXMLSec_ExtractRDN(sData, (int32_t)sData_len, SBGetObjectHandle(oRDN TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSec, RDNDescriptorMap)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLSec_RDNDescriptorMap(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDescriptorMap_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBXMLSec_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBXMLSec, SXMLReferenceNoContext, SB_SXMLReferenceNoContext, SB_SXMLReferenceNoContext);
	SB_REGISTER_STRING_CONSTANT(SBXMLSec, SXMLUnsupportedECFieldType, SB_SXMLUnsupportedECFieldType, SB_SXMLUnsupportedECFieldType);
}

void Register_SBXMLSec_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElXMLSignatureType", NULL);
	TElXMLSignatureType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLSignatureType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureType_ce_ptr, "xstDetached", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureType_ce_ptr, "xstEnveloping", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureType_ce_ptr, "xstEnveloped", 2)
	
	INIT_CLASS_ENTRY(ce, "TElXMLSignatureTypes", NULL);
	TElXMLSignatureTypes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TElXMLSignatureTypes_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureTypes_ce_ptr, "xstDetached", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureTypes_ce_ptr, "xstEnveloping", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureTypes_ce_ptr, "xstEnveloped", 4)
	
	INIT_CLASS_ENTRY(ce, "TElXMLSignatureCompliance", NULL);
	TElXMLSignatureCompliance_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLSignatureCompliance_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureCompliance_ce_ptr, "xscDSIG", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureCompliance_ce_ptr, "xscEBICS", 1)
	
	INIT_CLASS_ENTRY(ce, "TElXMLSigMethodType", NULL);
	TElXMLSigMethodType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLSigMethodType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSigMethodType_ce_ptr, "xmtSig", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSigMethodType_ce_ptr, "xmtMAC", 1)
	
	INIT_CLASS_ENTRY(ce, "TElXMLDigestMethod", NULL);
	TElXMLDigestMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLDigestMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDigestMethod_ce_ptr, "xdmMD5", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDigestMethod_ce_ptr, "xdmSHA1", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDigestMethod_ce_ptr, "xdmSHA224", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDigestMethod_ce_ptr, "xdmSHA256", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDigestMethod_ce_ptr, "xdmSHA384", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDigestMethod_ce_ptr, "xdmSHA512", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDigestMethod_ce_ptr, "xdmRIPEMD160", 6)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDigestMethod_ce_ptr, "xdmGOST", 7)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDigestMethod_ce_ptr, "xdmWhirlpool", 8)
	
	INIT_CLASS_ENTRY(ce, "TElXMLMACMethod", NULL);
	TElXMLMACMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLMACMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLMACMethod_ce_ptr, "xmmHMAC_MD5", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLMACMethod_ce_ptr, "xmmHMAC_SHA1", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLMACMethod_ce_ptr, "xmmHMAC_SHA224", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLMACMethod_ce_ptr, "xmmHMAC_SHA256", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLMACMethod_ce_ptr, "xmmHMAC_SHA384", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLMACMethod_ce_ptr, "xmmHMAC_SHA512", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLMACMethod_ce_ptr, "xmmHMAC_RIPEMD160", 6)
	
	INIT_CLASS_ENTRY(ce, "TElXMLSignatureMethod", NULL);
	TElXMLSignatureMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLSignatureMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmDSS", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_MD5", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_SHA1", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_SHA256", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_SHA384", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_SHA512", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_RIPEMD160", 6)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmECDSA_SHA1", 7)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmGOST1994", 8)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmGOST2001", 9)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_SHA224", 10)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_Whirlpool", 11)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmDSA_SHA256", 12)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmECDSA_SHA224", 13)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmECDSA_SHA256", 14)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmECDSA_SHA384", 15)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmECDSA_SHA512", 16)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmECDSA_RIPEMD160", 17)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmECDSA_Whirlpool", 18)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_PSS", 19)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_PSS_MD5_MGF1", 20)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_PSS_SHA1_MGF1", 21)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_PSS_SHA224_MGF1", 22)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_PSS_SHA256_MGF1", 23)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_PSS_SHA384_MGF1", 24)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_PSS_SHA512_MGF1", 25)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_PSS_RIPEMD160_MGF1", 26)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLSignatureMethod_ce_ptr, "xsmRSA_PSS_Whirlpool_MGF1", 27)
	
	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoX509DataParam", NULL);
	TElXMLKeyInfoX509DataParam_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLKeyInfoX509DataParam_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParam_ce_ptr, "xkidX509IssuerSerial", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParam_ce_ptr, "xkidX509SKI", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParam_ce_ptr, "xkidX509SubjectName", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParam_ce_ptr, "xkidX509Certificate", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParam_ce_ptr, "xkidX509CRL", 4)
	
	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoX509DataParams", NULL);
	TElXMLKeyInfoX509DataParams_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TElXMLKeyInfoX509DataParams_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParams_ce_ptr, "xkidX509IssuerSerial", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParams_ce_ptr, "xkidX509SKI", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParams_ce_ptr, "xkidX509SubjectName", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParams_ce_ptr, "xkidX509Certificate", 8)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoX509DataParams_ce_ptr, "xkidX509CRL", 16)
	
	INIT_CLASS_ENTRY(ce, "TElXMLKeyInfoPGPDataParam", NULL);
	TElXMLKeyInfoPGPDataParam_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLKeyInfoPGPDataParam_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoPGPDataParam_ce_ptr, "xkidPGPKeyID", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyInfoPGPDataParam_ce_ptr, "xkidPGPKeyPacket", 1)
	
	INIT_CLASS_ENTRY(ce, "TElXMLEncryptedDataType", NULL);
	TElXMLEncryptedDataType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLEncryptedDataType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptedDataType_ce_ptr, "xedtElement", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptedDataType_ce_ptr, "xedtContent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptedDataType_ce_ptr, "xedtExternal", 2)
	
	INIT_CLASS_ENTRY(ce, "TElXMLEncryptionMethod", NULL);
	TElXMLEncryptionMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLEncryptionMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptionMethod_ce_ptr, "xem3DES", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptionMethod_ce_ptr, "xemAES", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptionMethod_ce_ptr, "xemCamellia", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptionMethod_ce_ptr, "xemDES", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptionMethod_ce_ptr, "xemRC4", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptionMethod_ce_ptr, "xemSEED", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLEncryptionMethod_ce_ptr, "xemAES_GCM", 6)
	
	INIT_CLASS_ENTRY(ce, "TElXMLKeyEncryptionType", NULL);
	TElXMLKeyEncryptionType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLKeyEncryptionType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyEncryptionType_ce_ptr, "xetKeyTransport", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyEncryptionType_ce_ptr, "xetKeyWrap", 1)
	
	INIT_CLASS_ENTRY(ce, "TElXMLKeyTransportMethod", NULL);
	TElXMLKeyTransportMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLKeyTransportMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyTransportMethod_ce_ptr, "xktRSA15", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyTransportMethod_ce_ptr, "xktRSAOAEP", 1)
	
	INIT_CLASS_ENTRY(ce, "TElXMLKeyWrapMethod", NULL);
	TElXMLKeyWrapMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLKeyWrapMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyWrapMethod_ce_ptr, "xwm3DES", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyWrapMethod_ce_ptr, "xwmAES128", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyWrapMethod_ce_ptr, "xwmAES192", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyWrapMethod_ce_ptr, "xwmAES256", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyWrapMethod_ce_ptr, "xwmCamellia128", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyWrapMethod_ce_ptr, "xwmCamellia192", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyWrapMethod_ce_ptr, "xwmCamellia256", 6)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLKeyWrapMethod_ce_ptr, "xwmSEED", 7)
	
	INIT_CLASS_ENTRY(ce, "TSBXMLECKeyValueFormat", NULL);
	TSBXMLECKeyValueFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXMLECKeyValueFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLECKeyValueFormat_ce_ptr, "xekfRFC4050", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLECKeyValueFormat_ce_ptr, "xekfDSIG11", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBXMLECPrimeNumberType", NULL);
	TSBXMLECPrimeNumberType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXMLECPrimeNumberType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLECPrimeNumberType_ce_ptr, "xeptInteger", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLECPrimeNumberType_ce_ptr, "xeptHex", 1)
	
	INIT_CLASS_ENTRY(ce, "TElXMLRDNCompatibilityMode", NULL);
	TElXMLRDNCompatibilityMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLRDNCompatibilityMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLRDNCompatibilityMode_ce_ptr, "cmRFC", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLRDNCompatibilityMode_ce_ptr, "cmDotNET", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLRDNCompatibilityMode_ce_ptr, "cmCustom", 2)
}

void Register_SBXMLSec_Aliases(TSRMLS_D)
{
	if (NULL == TElXMLKeyInfo_ce_ptr)
		Register_TElXMLKeyInfo(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfo", TElXMLKeyInfo_ce_ptr);
	if (NULL == TElXMLAlgorithmParameters_ce_ptr)
		Register_TElXMLAlgorithmParameters(TSRMLS_C);
	zend_register_class_alias("ElXMLAlgorithmParameters", TElXMLAlgorithmParameters_ce_ptr);
	if (NULL == TElXMLReference_ce_ptr)
		Register_TElXMLReference(TSRMLS_C);
	zend_register_class_alias("ElXMLReference", TElXMLReference_ce_ptr);
	if (NULL == TElXMLReferenceList_ce_ptr)
		Register_TElXMLReferenceList(TSRMLS_C);
	zend_register_class_alias("ElXMLReferenceList", TElXMLReferenceList_ce_ptr);
	if (NULL == TElXMLKeyInfoItem_ce_ptr)
		Register_TElXMLKeyInfoItem(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoItem", TElXMLKeyInfoItem_ce_ptr);
	if (NULL == TElXMLKeyInfoData_ce_ptr)
		Register_TElXMLKeyInfoData(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoData", TElXMLKeyInfoData_ce_ptr);
	if (NULL == TElXMLKeyInfoHMACData_ce_ptr)
		Register_TElXMLKeyInfoHMACData(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoHMACData", TElXMLKeyInfoHMACData_ce_ptr);
	if (NULL == TElXMLKeyInfoSymmetricData_ce_ptr)
		Register_TElXMLKeyInfoSymmetricData(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoSymmetricData", TElXMLKeyInfoSymmetricData_ce_ptr);
	if (NULL == TElXMLKeyInfoAsymmetricData_ce_ptr)
		Register_TElXMLKeyInfoAsymmetricData(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoAsymmetricData", TElXMLKeyInfoAsymmetricData_ce_ptr);
	if (NULL == TElXMLKeyInfoRSAData_ce_ptr)
		Register_TElXMLKeyInfoRSAData(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoRSAData", TElXMLKeyInfoRSAData_ce_ptr);
	if (NULL == TElXMLKeyInfoDSAData_ce_ptr)
		Register_TElXMLKeyInfoDSAData(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoDSAData", TElXMLKeyInfoDSAData_ce_ptr);
	if (NULL == TElXMLKeyInfoDHData_ce_ptr)
		Register_TElXMLKeyInfoDHData(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoDHData", TElXMLKeyInfoDHData_ce_ptr);
	if (NULL == TElXMLKeyInfoPGPData_ce_ptr)
		Register_TElXMLKeyInfoPGPData(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoPGPData", TElXMLKeyInfoPGPData_ce_ptr);
	if (NULL == TElXMLIssuerSerial_ce_ptr)
		Register_TElXMLIssuerSerial(TSRMLS_C);
	zend_register_class_alias("ElXMLIssuerSerial", TElXMLIssuerSerial_ce_ptr);
	if (NULL == TElXMLKeyInfoX509Data_ce_ptr)
		Register_TElXMLKeyInfoX509Data(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoX509Data", TElXMLKeyInfoX509Data_ce_ptr);
	if (NULL == TElXMLKeyInfoNode_ce_ptr)
		Register_TElXMLKeyInfoNode(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoNode", TElXMLKeyInfoNode_ce_ptr);
	if (NULL == TElXMLKeyInfoRetrievalMethod_ce_ptr)
		Register_TElXMLKeyInfoRetrievalMethod(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoRetrievalMethod", TElXMLKeyInfoRetrievalMethod_ce_ptr);
	if (NULL == TElXMLKeyInfoAgreementMethod_ce_ptr)
		Register_TElXMLKeyInfoAgreementMethod(TSRMLS_C);
	zend_register_class_alias("ElXMLKeyInfoAgreementMethod", TElXMLKeyInfoAgreementMethod_ce_ptr);
	if (NULL == TElXMLProperty_ce_ptr)
		Register_TElXMLProperty(TSRMLS_C);
	zend_register_class_alias("ElXMLProperty", TElXMLProperty_ce_ptr);
	if (NULL == TElXMLProperties_ce_ptr)
		Register_TElXMLProperties(TSRMLS_C);
	zend_register_class_alias("ElXMLProperties", TElXMLProperties_ce_ptr);
	if (NULL == TElXMLProcessor_ce_ptr)
		Register_TElXMLProcessor(TSRMLS_C);
	zend_register_class_alias("ElXMLProcessor", TElXMLProcessor_ce_ptr);
	if (NULL == TElXMLFormatter_ce_ptr)
		Register_TElXMLFormatter(TSRMLS_C);
	zend_register_class_alias("ElXMLFormatter", TElXMLFormatter_ce_ptr);
}

