#include "sbzipentities.h"

void SB_CALLBACK TSBZipReadEventRaw(void * _ObjectData, TObjectHandle Sender, void * UserData, uint8_t pBuffer[], int32_t * szBuffer, int32_t Index, int32_t NeededSize, int32_t * Written, int8_t * Last)
{
	zval *retval_ptr;
	zval **params[7];
	zval * zSender;
	zval * zUserData;
	zval * zBuffer;
	SBArrayZValInfo aiBuffer;
	zval * zIndex;
	zval * zNeededSize;
	zval * zWritten;
	zval * zLast;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUserData);
	SBInitPointerObject(zUserData, UserData TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	ZVAL_STRINGL(zBuffer, pBuffer, *szBuffer, 1);
	MAKE_STD_ZVAL(zIndex);
	ZVAL_LONG(zIndex, (long)Index);
	MAKE_STD_ZVAL(zNeededSize);
	ZVAL_LONG(zNeededSize, (long)NeededSize);
	MAKE_STD_ZVAL(zWritten);
	ZVAL_LONG(zWritten, (long)*Written);
	MAKE_STD_ZVAL(zLast);
	ZVAL_BOOL(zLast, (zend_bool)*Last);

	params[0] = &zSender;
	params[1] = &zUserData;
	params[2] = &zBuffer;
	params[3] = &zIndex;
	params[4] = &zNeededSize;
	params[5] = &zWritten;
	params[6] = &zLast;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 7, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUserData);
	if (SBGetByteArrayFromZVal(zBuffer, &aiBuffer TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(3, aiBuffer.data, aiBuffer.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiBuffer);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zIndex);
	zval_ptr_dtor(&zNeededSize);
	*Written = (int32_t)Z_LVAL_P(zWritten);
	zval_ptr_dtor(&zWritten);
	*Last = (int8_t)Z_BVAL_P(zLast);
	zval_ptr_dtor(&zLast);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBZipWriteEventRaw(void * _ObjectData, TObjectHandle Sender, void * UserData, const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int32_t Size)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zUserData;
	zval * zBuffer;
	zval * zIndex;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUserData);
	SBInitPointerObject(zUserData, UserData TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	ZVAL_STRINGL(zBuffer, pBuffer, szBuffer, 1);
	MAKE_STD_ZVAL(zIndex);
	ZVAL_LONG(zIndex, (long)Index);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);

	params[0] = &zSender;
	params[1] = &zUserData;
	params[2] = &zBuffer;
	params[3] = &zIndex;
	params[4] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUserData);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zIndex);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBZipLocalFileHeaderLoadedEventRaw(void * _ObjectData, TObjectHandle Sender, TElZipLocalFileHeaderHandle Header)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHeader;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHeader);
	SBInitObject(zHeader, TElZipLocalFileHeader_ce_ptr, Header TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHeader;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHeader);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBZipDataDescriptorLoadedEventRaw(void * _ObjectData, TObjectHandle Sender, TElZipLocalFileHeaderHandle Header)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHeader;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHeader);
	SBInitObject(zHeader, TElZipLocalFileHeader_ce_ptr, Header TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHeader;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHeader);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBZipCentralFileHeaderLoadedEventRaw(void * _ObjectData, TObjectHandle Sender, TElZipCentralFileHeaderHandle Header)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHeader;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHeader);
	SBInitObject(zHeader, TElZipCentralFileHeader_ce_ptr, Header TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHeader;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHeader);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBZipFileDataEventRaw(void * _ObjectData, TObjectHandle Sender, TElZipLocalFileHeaderHandle Header)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHeader;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHeader);
	SBInitObject(zHeader, TElZipLocalFileHeader_ce_ptr, Header TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHeader;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHeader);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBZipCentralDirectoryProcessEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int32_t Size, uint8_t pProcessedData[], int32_t * szProcessedData, int32_t ProcessedIndex, int32_t * ProcessedSize)
{
	zval *retval_ptr;
	zval **params[7];
	zval * zSender;
	zval * zBuffer;
	zval * zIndex;
	zval * zSize;
	zval * zProcessedData;
	SBArrayZValInfo aiProcessedData;
	zval * zProcessedIndex;
	zval * zProcessedSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	ZVAL_STRINGL(zBuffer, pBuffer, szBuffer, 1);
	MAKE_STD_ZVAL(zIndex);
	ZVAL_LONG(zIndex, (long)Index);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);
	MAKE_STD_ZVAL(zProcessedData);
	ZVAL_STRINGL(zProcessedData, pProcessedData, *szProcessedData, 1);
	MAKE_STD_ZVAL(zProcessedIndex);
	ZVAL_LONG(zProcessedIndex, (long)ProcessedIndex);
	MAKE_STD_ZVAL(zProcessedSize);
	ZVAL_LONG(zProcessedSize, (long)*ProcessedSize);

	params[0] = &zSender;
	params[1] = &zBuffer;
	params[2] = &zIndex;
	params[3] = &zSize;
	params[4] = &zProcessedData;
	params[5] = &zProcessedIndex;
	params[6] = &zProcessedSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 7, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zIndex);
	zval_ptr_dtor(&zSize);
	if (SBGetByteArrayFromZVal(zProcessedData, &aiProcessedData TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(5, aiProcessedData.data, aiProcessedData.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiProcessedData);
	zval_ptr_dtor(&zProcessedData);
	zval_ptr_dtor(&zProcessedIndex);
	*ProcessedSize = (int32_t)Z_LVAL_P(zProcessedSize);
	zval_ptr_dtor(&zProcessedSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBZipArchiveErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ErrorCode, const char * pcErrorMessage, int32_t szErrorMessage, int8_t * TryContinue)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zErrorCode;
	zval * zErrorMessage;
	zval * zTryContinue;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)ErrorCode);
	MAKE_STD_ZVAL(zErrorMessage);
	ZVAL_STRINGL(zErrorMessage, pcErrorMessage, szErrorMessage, 1);
	MAKE_STD_ZVAL(zTryContinue);
	ZVAL_BOOL(zTryContinue, (zend_bool)*TryContinue);

	params[0] = &zSender;
	params[1] = &zErrorCode;
	params[2] = &zErrorMessage;
	params[3] = &zTryContinue;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zErrorCode);
	zval_ptr_dtor(&zErrorMessage);
	*TryContinue = (int8_t)Z_BVAL_P(zTryContinue);
	zval_ptr_dtor(&zTryContinue);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElZipEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntity, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntity_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntity_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, Load)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntity_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, Save)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntity_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, SaveToStream)
{
	SBArrayZValInfo piUserData;
	zval *oStream;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntity_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, SaveToBuffer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEntity_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2024305251, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZipEntity_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, get_BodySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntity_get_BodySize(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, get_Body)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEntity_get_Body(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-965944862, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, get_Loaded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntity_get_Loaded(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, get_Signature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntity_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, set_Signature)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntity_set_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, get_SkipSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntity_get_SkipSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, set_SkipSignature)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipEntity_set_SkipSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, get_Zip64Used)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntity_get_Zip64Used(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, set_Zip64Used)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipEntity_set_Zip64Used(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, get_Position)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipEntity_get_Position(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, set_Position)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZipEntity_set_Position(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, get_OnRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBZipReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipEntity_get_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, set_OnRead)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipEntity_set_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBZipReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBZipReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, get_OnWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBZipWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipEntity_get_OnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, set_OnWrite)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipEntity_set_OnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBZipWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBZipWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_SaveToStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_SaveToBuffer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_get_BodySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_get_Body, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_get_Loaded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_set_Signature, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_get_SkipSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_set_SkipSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_get_Zip64Used, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_set_Zip64Used, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_get_Position, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_set_Position, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_get_OnRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_set_OnRead, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_get_OnWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity_set_OnWrite, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntity_methods[] = {
	PHP_ME(TElZipEntity, Assign, arginfo_TElZipEntity_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, AssignTo, arginfo_TElZipEntity_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, Load, arginfo_TElZipEntity_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, Save, arginfo_TElZipEntity_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, SaveToStream, arginfo_TElZipEntity_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, SaveToBuffer, arginfo_TElZipEntity_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, DataAvailable, arginfo_TElZipEntity_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, get_BodySize, arginfo_TElZipEntity_get_BodySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, get_Body, arginfo_TElZipEntity_get_Body, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, get_Loaded, arginfo_TElZipEntity_get_Loaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, get_Signature, arginfo_TElZipEntity_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, set_Signature, arginfo_TElZipEntity_set_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, get_SkipSignature, arginfo_TElZipEntity_get_SkipSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, set_SkipSignature, arginfo_TElZipEntity_set_SkipSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, get_Zip64Used, arginfo_TElZipEntity_get_Zip64Used, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, set_Zip64Used, arginfo_TElZipEntity_set_Zip64Used, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, get_Position, arginfo_TElZipEntity_get_Position, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, set_Position, arginfo_TElZipEntity_set_Position, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, get_OnRead, arginfo_TElZipEntity_get_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, set_OnRead, arginfo_TElZipEntity_set_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, get_OnWrite, arginfo_TElZipEntity_get_OnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, set_OnWrite, arginfo_TElZipEntity_set_OnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntity, __construct, arginfo_TElZipEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntity", TElZipEntity_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElZipEntity_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipLocalFileHeader_ce_ptr = NULL;

SB_PHP_METHOD(TElZipLocalFileHeader, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, Load)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipLocalFileHeader_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, Save)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipLocalFileHeader_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_VersionToExtract)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_VersionToExtract(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_VersionToExtract)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_VersionToExtract(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_GeneralBitFlag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_GeneralBitFlag(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_GeneralBitFlag)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_GeneralBitFlag(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_DataDescriptor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipLocalFileHeader_get_DataDescriptor(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipDataDescriptor_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_DataDescriptor)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElZipDataDescriptor_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_DataDescriptor(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipDataDescriptor)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_CompressionMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_CompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_CompressionMethod)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_CompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_LastModFileTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_LastModFileTime(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_LastModFileTime)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_LastModFileTime(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_LastModFileDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_LastModFileDate(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_LastModFileDate)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_LastModFileDate(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_CRC32)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_CRC32)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_CompressedSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_CompressedSize)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_OriginalSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_OriginalSize)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_FileName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipLocalFileHeader_get_FileName(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(914518135, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_FileName)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipLocalFileHeader_set_FileName(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_ExtraField)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipLocalFileHeader_get_ExtraField(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-465658070, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_ExtraField)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipLocalFileHeader_set_ExtraField(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_DataOffset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_DataOffset(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_DataOffset)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_DataOffset(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipLocalFileHeader_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, get_DataDescriptorUsed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipLocalFileHeader_get_DataDescriptorUsed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, set_DataDescriptorUsed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipLocalFileHeader_set_DataDescriptorUsed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipLocalFileHeader, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipLocalFileHeader_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_VersionToExtract, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_VersionToExtract, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_GeneralBitFlag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_GeneralBitFlag, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_DataDescriptor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_DataDescriptor, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElZipDataDescriptor, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_CompressionMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_CompressionMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_LastModFileTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_LastModFileTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_LastModFileDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_LastModFileDate, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_CRC32, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_CRC32, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_CompressedSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_CompressedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_OriginalSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_OriginalSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_FileName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_FileName, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_ExtraField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_ExtraField, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_DataOffset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_DataOffset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_get_DataDescriptorUsed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader_set_DataDescriptorUsed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipLocalFileHeader___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipLocalFileHeader_methods[] = {
	PHP_ME(TElZipLocalFileHeader, Assign, arginfo_TElZipLocalFileHeader_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, AssignTo, arginfo_TElZipLocalFileHeader_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, Load, arginfo_TElZipLocalFileHeader_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, Save, arginfo_TElZipLocalFileHeader_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, DataAvailable, arginfo_TElZipLocalFileHeader_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_VersionToExtract, arginfo_TElZipLocalFileHeader_get_VersionToExtract, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_VersionToExtract, arginfo_TElZipLocalFileHeader_set_VersionToExtract, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_GeneralBitFlag, arginfo_TElZipLocalFileHeader_get_GeneralBitFlag, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_GeneralBitFlag, arginfo_TElZipLocalFileHeader_set_GeneralBitFlag, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_DataDescriptor, arginfo_TElZipLocalFileHeader_get_DataDescriptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_DataDescriptor, arginfo_TElZipLocalFileHeader_set_DataDescriptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_CompressionMethod, arginfo_TElZipLocalFileHeader_get_CompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_CompressionMethod, arginfo_TElZipLocalFileHeader_set_CompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_LastModFileTime, arginfo_TElZipLocalFileHeader_get_LastModFileTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_LastModFileTime, arginfo_TElZipLocalFileHeader_set_LastModFileTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_LastModFileDate, arginfo_TElZipLocalFileHeader_get_LastModFileDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_LastModFileDate, arginfo_TElZipLocalFileHeader_set_LastModFileDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_CRC32, arginfo_TElZipLocalFileHeader_get_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_CRC32, arginfo_TElZipLocalFileHeader_set_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_CompressedSize, arginfo_TElZipLocalFileHeader_get_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_CompressedSize, arginfo_TElZipLocalFileHeader_set_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_OriginalSize, arginfo_TElZipLocalFileHeader_get_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_OriginalSize, arginfo_TElZipLocalFileHeader_set_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_FileName, arginfo_TElZipLocalFileHeader_get_FileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_FileName, arginfo_TElZipLocalFileHeader_set_FileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_ExtraField, arginfo_TElZipLocalFileHeader_get_ExtraField, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_ExtraField, arginfo_TElZipLocalFileHeader_set_ExtraField, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_DataOffset, arginfo_TElZipLocalFileHeader_get_DataOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_DataOffset, arginfo_TElZipLocalFileHeader_set_DataOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_Extensions, arginfo_TElZipLocalFileHeader_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, get_DataDescriptorUsed, arginfo_TElZipLocalFileHeader_get_DataDescriptorUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, set_DataDescriptorUsed, arginfo_TElZipLocalFileHeader_set_DataDescriptorUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipLocalFileHeader, __construct, arginfo_TElZipLocalFileHeader___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipLocalFileHeader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipLocalFileHeader_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipLocalFileHeader", TElZipLocalFileHeader_methods);
	if (NULL == TElZipEntity_ce_ptr)
		Register_TElZipEntity(TSRMLS_C);
	TElZipLocalFileHeader_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipCentralFileHeader_ce_ptr = NULL;

SB_PHP_METHOD(TElZipCentralFileHeader, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, Load)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralFileHeader_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, Save)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralFileHeader_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_VersionMadeBy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_VersionMadeBy(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_VersionMadeBy)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_VersionMadeBy(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_VersionToExtract)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_VersionToExtract(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_VersionToExtract)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_VersionToExtract(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_GeneralBitFlag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_GeneralBitFlag(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_GeneralBitFlag)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_GeneralBitFlag(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_CompressionMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_CompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_CompressionMethod)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_CompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_LastModFileTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_LastModFileTime(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_LastModFileTime)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_LastModFileTime(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_LastModFileDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_LastModFileDate(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_LastModFileDate)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_LastModFileDate(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_CRC32)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_CRC32)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_CompressedSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_CompressedSize)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_OriginalSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_OriginalSize)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_DiskNumberStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_DiskNumberStart(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_DiskNumberStart)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_DiskNumberStart(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_InternalFileAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_InternalFileAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_InternalFileAttributes)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_InternalFileAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_ExternalFileAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_ExternalFileAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_ExternalFileAttributes)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_ExternalFileAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_LocalHeaderOffset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralFileHeader_get_LocalHeaderOffset(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_LocalHeaderOffset)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralFileHeader_set_LocalHeaderOffset(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_FileName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipCentralFileHeader_get_FileName(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-494809799, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_FileName)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralFileHeader_set_FileName(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_ExtraField)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipCentralFileHeader_get_ExtraField(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1058334355, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_ExtraField)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralFileHeader_set_ExtraField(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_Comment)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipCentralFileHeader_get_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1830159033, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, set_Comment)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralFileHeader_set_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipCentralFileHeader_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralFileHeader, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipCentralFileHeader_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_VersionMadeBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_VersionMadeBy, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_VersionToExtract, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_VersionToExtract, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_GeneralBitFlag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_GeneralBitFlag, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_CompressionMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_CompressionMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_LastModFileTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_LastModFileTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_LastModFileDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_LastModFileDate, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_CRC32, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_CRC32, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_CompressedSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_CompressedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_OriginalSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_OriginalSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_DiskNumberStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_DiskNumberStart, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_InternalFileAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_InternalFileAttributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_ExternalFileAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_ExternalFileAttributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_LocalHeaderOffset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_LocalHeaderOffset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_FileName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_FileName, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_ExtraField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_ExtraField, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_Comment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_set_Comment, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralFileHeader___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipCentralFileHeader_methods[] = {
	PHP_ME(TElZipCentralFileHeader, Assign, arginfo_TElZipCentralFileHeader_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, AssignTo, arginfo_TElZipCentralFileHeader_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, Load, arginfo_TElZipCentralFileHeader_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, Save, arginfo_TElZipCentralFileHeader_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, DataAvailable, arginfo_TElZipCentralFileHeader_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_VersionMadeBy, arginfo_TElZipCentralFileHeader_get_VersionMadeBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_VersionMadeBy, arginfo_TElZipCentralFileHeader_set_VersionMadeBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_VersionToExtract, arginfo_TElZipCentralFileHeader_get_VersionToExtract, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_VersionToExtract, arginfo_TElZipCentralFileHeader_set_VersionToExtract, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_GeneralBitFlag, arginfo_TElZipCentralFileHeader_get_GeneralBitFlag, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_GeneralBitFlag, arginfo_TElZipCentralFileHeader_set_GeneralBitFlag, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_CompressionMethod, arginfo_TElZipCentralFileHeader_get_CompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_CompressionMethod, arginfo_TElZipCentralFileHeader_set_CompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_LastModFileTime, arginfo_TElZipCentralFileHeader_get_LastModFileTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_LastModFileTime, arginfo_TElZipCentralFileHeader_set_LastModFileTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_LastModFileDate, arginfo_TElZipCentralFileHeader_get_LastModFileDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_LastModFileDate, arginfo_TElZipCentralFileHeader_set_LastModFileDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_CRC32, arginfo_TElZipCentralFileHeader_get_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_CRC32, arginfo_TElZipCentralFileHeader_set_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_CompressedSize, arginfo_TElZipCentralFileHeader_get_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_CompressedSize, arginfo_TElZipCentralFileHeader_set_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_OriginalSize, arginfo_TElZipCentralFileHeader_get_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_OriginalSize, arginfo_TElZipCentralFileHeader_set_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_DiskNumberStart, arginfo_TElZipCentralFileHeader_get_DiskNumberStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_DiskNumberStart, arginfo_TElZipCentralFileHeader_set_DiskNumberStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_InternalFileAttributes, arginfo_TElZipCentralFileHeader_get_InternalFileAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_InternalFileAttributes, arginfo_TElZipCentralFileHeader_set_InternalFileAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_ExternalFileAttributes, arginfo_TElZipCentralFileHeader_get_ExternalFileAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_ExternalFileAttributes, arginfo_TElZipCentralFileHeader_set_ExternalFileAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_LocalHeaderOffset, arginfo_TElZipCentralFileHeader_get_LocalHeaderOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_LocalHeaderOffset, arginfo_TElZipCentralFileHeader_set_LocalHeaderOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_FileName, arginfo_TElZipCentralFileHeader_get_FileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_FileName, arginfo_TElZipCentralFileHeader_set_FileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_ExtraField, arginfo_TElZipCentralFileHeader_get_ExtraField, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_ExtraField, arginfo_TElZipCentralFileHeader_set_ExtraField, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_Comment, arginfo_TElZipCentralFileHeader_get_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, set_Comment, arginfo_TElZipCentralFileHeader_set_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, get_Extensions, arginfo_TElZipCentralFileHeader_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralFileHeader, __construct, arginfo_TElZipCentralFileHeader___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipCentralFileHeader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipCentralFileHeader_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipCentralFileHeader", TElZipCentralFileHeader_methods);
	if (NULL == TElZipEntity_ce_ptr)
		Register_TElZipEntity(TSRMLS_C);
	TElZipCentralFileHeader_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipDataDescriptor_ce_ptr = NULL;

SB_PHP_METHOD(TElZipDataDescriptor, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipDataDescriptor_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipDataDescriptor_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, Load)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipDataDescriptor_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, Save)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipDataDescriptor_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZipDataDescriptor_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, get_CRC32)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipDataDescriptor_get_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, set_CRC32)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipDataDescriptor_set_CRC32(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, get_CompressedSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipDataDescriptor_get_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, set_CompressedSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZipDataDescriptor_set_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, get_OriginalSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipDataDescriptor_get_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, set_OriginalSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZipDataDescriptor_set_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, get_WriteSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipDataDescriptor_get_WriteSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, set_WriteSignature)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipDataDescriptor_set_WriteSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipDataDescriptor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipDataDescriptor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_get_CRC32, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_set_CRC32, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_get_CompressedSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_set_CompressedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_get_OriginalSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_set_OriginalSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_get_WriteSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor_set_WriteSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipDataDescriptor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipDataDescriptor_methods[] = {
	PHP_ME(TElZipDataDescriptor, Assign, arginfo_TElZipDataDescriptor_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, AssignTo, arginfo_TElZipDataDescriptor_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, Load, arginfo_TElZipDataDescriptor_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, Save, arginfo_TElZipDataDescriptor_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, DataAvailable, arginfo_TElZipDataDescriptor_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, get_CRC32, arginfo_TElZipDataDescriptor_get_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, set_CRC32, arginfo_TElZipDataDescriptor_set_CRC32, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, get_CompressedSize, arginfo_TElZipDataDescriptor_get_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, set_CompressedSize, arginfo_TElZipDataDescriptor_set_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, get_OriginalSize, arginfo_TElZipDataDescriptor_get_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, set_OriginalSize, arginfo_TElZipDataDescriptor_set_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, get_WriteSignature, arginfo_TElZipDataDescriptor_get_WriteSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, set_WriteSignature, arginfo_TElZipDataDescriptor_set_WriteSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipDataDescriptor, __construct, arginfo_TElZipDataDescriptor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipDataDescriptor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipDataDescriptor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipDataDescriptor", TElZipDataDescriptor_methods);
	if (NULL == TElZipEntity_ce_ptr)
		Register_TElZipEntity(TSRMLS_C);
	TElZipDataDescriptor_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityExtensions_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityExtensions, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtensions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtensions_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtensions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntityExtensions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtensions_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtensions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityExtensions_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityExtensions_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1478363975, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, Save)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEntityExtensions_Save(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1603024002, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, AddExtension)
{
	long u4ExtensionType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4ExtensionType) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElZipEntityExtensions_AddExtension(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4ExtensionType, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, ExtensionByType)
{
	long l4Index;
	long u4ExtensionType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4ExtensionType, &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_ExtensionByType(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4ExtensionType, (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, RemoveExtension)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtensions_RemoveExtension(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, RemoveExtensionByType)
{
	long l4Index;
	long u4ExtensionType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4ExtensionType, &l4Index) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtensions_RemoveExtensionByType(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4ExtensionType, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, ClearExtensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZipEntityExtensions_ClearExtensions(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_Size32Bit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityExtensions_get_Size32Bit(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, set_Size32Bit)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtensions_set_Size32Bit(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, set_Owner)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtensions_set_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_ExtensionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElZipEntityExtensions_get_ExtensionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_Extensions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_BodySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElZipEntityExtensions_get_BodySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_Zip64Info)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_Zip64Info(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityZip64InfoExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_StrongEncryptionHeader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_StrongEncryptionHeader(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityStrongEncryptionExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_WinZipAesInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_WinZipAesInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityWinZipAESExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_CertificateStore)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_CertificateStore(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityCertificateStoreExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_CentralDirectorySignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_CentralDirectorySignature(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityCentralDirSignatureExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_ExtendedTimestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_ExtendedTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityExtendedTimestampExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_UIDAndGID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_UIDAndGID(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityUIDAndGIDExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_Unix1)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_Unix1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityUnix1Extension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_Unix2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_Unix2(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityUnix2Extension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_SignatureCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElZipEntityExtensions_get_SignatureCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, get_Signatures)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_get_Signatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntitySignatureExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtensions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtensions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtensions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntityExtensions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_Save, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_AddExtension, 0, 0, 1)
	ZEND_ARG_INFO(0, ExtensionType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_ExtensionByType, 0, 0, 2)
	ZEND_ARG_INFO(0, ExtensionType)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_RemoveExtension, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_RemoveExtensionByType, 0, 0, 2)
	ZEND_ARG_INFO(0, ExtensionType)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_ClearExtensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_Size32Bit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_set_Size32Bit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_set_Owner, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_ExtensionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_Extensions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_BodySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_Zip64Info, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_StrongEncryptionHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_WinZipAesInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_CertificateStore, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_CentralDirectorySignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_ExtendedTimestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_UIDAndGID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_Unix1, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_Unix2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_SignatureCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions_get_Signatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtensions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityExtensions_methods[] = {
	PHP_ME(TElZipEntityExtensions, Assign, arginfo_TElZipEntityExtensions_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, AssignTo, arginfo_TElZipEntityExtensions_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, LoadFromBuffer, arginfo_TElZipEntityExtensions_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, SaveToBuffer, arginfo_TElZipEntityExtensions_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, Save, arginfo_TElZipEntityExtensions_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, AddExtension, arginfo_TElZipEntityExtensions_AddExtension, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, ExtensionByType, arginfo_TElZipEntityExtensions_ExtensionByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, RemoveExtension, arginfo_TElZipEntityExtensions_RemoveExtension, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, RemoveExtensionByType, arginfo_TElZipEntityExtensions_RemoveExtensionByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, ClearExtensions, arginfo_TElZipEntityExtensions_ClearExtensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_Size32Bit, arginfo_TElZipEntityExtensions_get_Size32Bit, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, set_Size32Bit, arginfo_TElZipEntityExtensions_set_Size32Bit, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_Owner, arginfo_TElZipEntityExtensions_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, set_Owner, arginfo_TElZipEntityExtensions_set_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_ExtensionCount, arginfo_TElZipEntityExtensions_get_ExtensionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_Extensions, arginfo_TElZipEntityExtensions_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_BodySize, arginfo_TElZipEntityExtensions_get_BodySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_Zip64Info, arginfo_TElZipEntityExtensions_get_Zip64Info, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_StrongEncryptionHeader, arginfo_TElZipEntityExtensions_get_StrongEncryptionHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_WinZipAesInfo, arginfo_TElZipEntityExtensions_get_WinZipAesInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_CertificateStore, arginfo_TElZipEntityExtensions_get_CertificateStore, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_CentralDirectorySignature, arginfo_TElZipEntityExtensions_get_CentralDirectorySignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_ExtendedTimestamp, arginfo_TElZipEntityExtensions_get_ExtendedTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_UIDAndGID, arginfo_TElZipEntityExtensions_get_UIDAndGID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_Unix1, arginfo_TElZipEntityExtensions_get_Unix1, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_Unix2, arginfo_TElZipEntityExtensions_get_Unix2, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_SignatureCount, arginfo_TElZipEntityExtensions_get_SignatureCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, get_Signatures, arginfo_TElZipEntityExtensions_get_Signatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtensions, __construct, arginfo_TElZipEntityExtensions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityExtensions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityExtensions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityExtensions", TElZipEntityExtensions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElZipEntityExtensions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipCentralDirectorySignature_ce_ptr = NULL;

SB_PHP_METHOD(TElZipCentralDirectorySignature, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipCentralDirectorySignature_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipCentralDirectorySignature_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, Load)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralDirectorySignature_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, Save)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralDirectorySignature_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZipCentralDirectorySignature_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralDirectorySignature_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipCentralDirectorySignature_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, set_HashAlgorithm)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipCentralDirectorySignature_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, get_IssuerName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipCentralDirectorySignature_get_IssuerName(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1962124583, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, set_IssuerName)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralDirectorySignature_set_IssuerName(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipCentralDirectorySignature_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1528552866, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, set_SerialNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralDirectorySignature_set_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, get_CentralSignature)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipCentralDirectorySignature_get_CentralSignature(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1776620704, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, set_CentralSignature)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipCentralDirectorySignature_set_CentralSignature(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipCentralDirectorySignature, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipCentralDirectorySignature_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_get_IssuerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_set_IssuerName, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_set_SerialNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_get_CentralSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature_set_CentralSignature, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipCentralDirectorySignature___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipCentralDirectorySignature_methods[] = {
	PHP_ME(TElZipCentralDirectorySignature, Assign, arginfo_TElZipCentralDirectorySignature_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, AssignTo, arginfo_TElZipCentralDirectorySignature_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, Load, arginfo_TElZipCentralDirectorySignature_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, Save, arginfo_TElZipCentralDirectorySignature_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, DataAvailable, arginfo_TElZipCentralDirectorySignature_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, get_Version, arginfo_TElZipCentralDirectorySignature_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, get_HashAlgorithm, arginfo_TElZipCentralDirectorySignature_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, set_HashAlgorithm, arginfo_TElZipCentralDirectorySignature_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, get_IssuerName, arginfo_TElZipCentralDirectorySignature_get_IssuerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, set_IssuerName, arginfo_TElZipCentralDirectorySignature_set_IssuerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, get_SerialNumber, arginfo_TElZipCentralDirectorySignature_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, set_SerialNumber, arginfo_TElZipCentralDirectorySignature_set_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, get_CentralSignature, arginfo_TElZipCentralDirectorySignature_get_CentralSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, set_CentralSignature, arginfo_TElZipCentralDirectorySignature_set_CentralSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipCentralDirectorySignature, __construct, arginfo_TElZipCentralDirectorySignature___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipCentralDirectorySignature(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipCentralDirectorySignature_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipCentralDirectorySignature", TElZipCentralDirectorySignature_methods);
	if (NULL == TElZipEntity_ce_ptr)
		Register_TElZipEntity(TSRMLS_C);
	TElZipCentralDirectorySignature_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZip64EndOfCentralDirectory_ce_ptr = NULL;

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, Load)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZip64EndOfCentralDirectory_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, Save)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZip64EndOfCentralDirectory_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_StructureVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_StructureVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_StructureVersion)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_StructureVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_VersionMadeBy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_VersionMadeBy(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_VersionMadeBy)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_VersionMadeBy(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_VersionToExtract)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_VersionToExtract(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_VersionToExtract)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_VersionToExtract(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_DiskNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_DiskNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_DiskNumber)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_DiskNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_CentralDirStartDisk)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_CentralDirStartDisk(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_CentralDirStartDisk)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_CentralDirStartDisk(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_EntriesOnDiskCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_EntriesOnDiskCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_EntriesOnDiskCount)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_EntriesOnDiskCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_EntriesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_EntriesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_EntriesCount)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_EntriesCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_CentralDirSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_CentralDirSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_CentralDirSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_CentralDirSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_CentralDirOffset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_CentralDirOffset(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_CentralDirOffset)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_CentralDirOffset(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_ExtensibleData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZip64EndOfCentralDirectory_get_ExtensibleData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(238049893, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_ExtensibleData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZip64EndOfCentralDirectory_set_ExtensibleData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_CompressionMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_CompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_CompressionMethod)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_CompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_CompressedSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_CompressedSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_OriginalSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_OriginalSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_EncryptionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_EncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_EncryptionAlgorithm)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_EncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_KeyLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_KeyLength(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_KeyLength)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_KeyLength(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_EncryptionFlags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_EncryptionFlags(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_EncryptionFlags)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_EncryptionFlags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_HashAlgortihm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectory_get_HashAlgortihm(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_HashAlgortihm)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectory_set_HashAlgortihm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, get_Hash)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZip64EndOfCentralDirectory_get_Hash(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1709263965, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, set_Hash)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZip64EndOfCentralDirectory_set_Hash(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZip64EndOfCentralDirectory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_StructureVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_StructureVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_VersionMadeBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_VersionMadeBy, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_VersionToExtract, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_VersionToExtract, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_DiskNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_DiskNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_CentralDirStartDisk, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_CentralDirStartDisk, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_EntriesOnDiskCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_EntriesOnDiskCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_EntriesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_EntriesCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_CentralDirSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_CentralDirSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_CentralDirOffset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_CentralDirOffset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_ExtensibleData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_ExtensibleData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_CompressionMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_CompressionMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_CompressedSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_CompressedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_OriginalSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_OriginalSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_EncryptionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_EncryptionAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_KeyLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_KeyLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_EncryptionFlags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_EncryptionFlags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_HashAlgortihm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_HashAlgortihm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_get_Hash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory_set_Hash, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZip64EndOfCentralDirectory_methods[] = {
	PHP_ME(TElZip64EndOfCentralDirectory, Assign, arginfo_TElZip64EndOfCentralDirectory_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, AssignTo, arginfo_TElZip64EndOfCentralDirectory_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, Load, arginfo_TElZip64EndOfCentralDirectory_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, Save, arginfo_TElZip64EndOfCentralDirectory_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, DataAvailable, arginfo_TElZip64EndOfCentralDirectory_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_StructureVersion, arginfo_TElZip64EndOfCentralDirectory_get_StructureVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_StructureVersion, arginfo_TElZip64EndOfCentralDirectory_set_StructureVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_VersionMadeBy, arginfo_TElZip64EndOfCentralDirectory_get_VersionMadeBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_VersionMadeBy, arginfo_TElZip64EndOfCentralDirectory_set_VersionMadeBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_VersionToExtract, arginfo_TElZip64EndOfCentralDirectory_get_VersionToExtract, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_VersionToExtract, arginfo_TElZip64EndOfCentralDirectory_set_VersionToExtract, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_DiskNumber, arginfo_TElZip64EndOfCentralDirectory_get_DiskNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_DiskNumber, arginfo_TElZip64EndOfCentralDirectory_set_DiskNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_CentralDirStartDisk, arginfo_TElZip64EndOfCentralDirectory_get_CentralDirStartDisk, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_CentralDirStartDisk, arginfo_TElZip64EndOfCentralDirectory_set_CentralDirStartDisk, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_EntriesOnDiskCount, arginfo_TElZip64EndOfCentralDirectory_get_EntriesOnDiskCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_EntriesOnDiskCount, arginfo_TElZip64EndOfCentralDirectory_set_EntriesOnDiskCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_EntriesCount, arginfo_TElZip64EndOfCentralDirectory_get_EntriesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_EntriesCount, arginfo_TElZip64EndOfCentralDirectory_set_EntriesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_CentralDirSize, arginfo_TElZip64EndOfCentralDirectory_get_CentralDirSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_CentralDirSize, arginfo_TElZip64EndOfCentralDirectory_set_CentralDirSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_CentralDirOffset, arginfo_TElZip64EndOfCentralDirectory_get_CentralDirOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_CentralDirOffset, arginfo_TElZip64EndOfCentralDirectory_set_CentralDirOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_ExtensibleData, arginfo_TElZip64EndOfCentralDirectory_get_ExtensibleData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_ExtensibleData, arginfo_TElZip64EndOfCentralDirectory_set_ExtensibleData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_CompressionMethod, arginfo_TElZip64EndOfCentralDirectory_get_CompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_CompressionMethod, arginfo_TElZip64EndOfCentralDirectory_set_CompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_CompressedSize, arginfo_TElZip64EndOfCentralDirectory_get_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_CompressedSize, arginfo_TElZip64EndOfCentralDirectory_set_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_OriginalSize, arginfo_TElZip64EndOfCentralDirectory_get_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_OriginalSize, arginfo_TElZip64EndOfCentralDirectory_set_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_EncryptionAlgorithm, arginfo_TElZip64EndOfCentralDirectory_get_EncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_EncryptionAlgorithm, arginfo_TElZip64EndOfCentralDirectory_set_EncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_KeyLength, arginfo_TElZip64EndOfCentralDirectory_get_KeyLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_KeyLength, arginfo_TElZip64EndOfCentralDirectory_set_KeyLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_EncryptionFlags, arginfo_TElZip64EndOfCentralDirectory_get_EncryptionFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_EncryptionFlags, arginfo_TElZip64EndOfCentralDirectory_set_EncryptionFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_HashAlgortihm, arginfo_TElZip64EndOfCentralDirectory_get_HashAlgortihm, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_HashAlgortihm, arginfo_TElZip64EndOfCentralDirectory_set_HashAlgortihm, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, get_Hash, arginfo_TElZip64EndOfCentralDirectory_get_Hash, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, set_Hash, arginfo_TElZip64EndOfCentralDirectory_set_Hash, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectory, __construct, arginfo_TElZip64EndOfCentralDirectory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZip64EndOfCentralDirectory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZip64EndOfCentralDirectory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZip64EndOfCentralDirectory", TElZip64EndOfCentralDirectory_methods);
	if (NULL == TElZipEntity_ce_ptr)
		Register_TElZipEntity(TSRMLS_C);
	TElZip64EndOfCentralDirectory_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZip64EndOfCentralDirectoryLocator_ce_ptr = NULL;

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, Load)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, Save)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, get_DiskNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_get_DiskNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, set_DiskNumber)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_set_DiskNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, get_Offset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_get_Offset(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, set_Offset)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_set_Offset(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, get_TotalDiskCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_get_TotalDiskCount(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, set_TotalDiskCount)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_set_TotalDiskCount(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZip64EndOfCentralDirectoryLocator, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZip64EndOfCentralDirectoryLocator_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_get_DiskNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_set_DiskNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_get_Offset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_set_Offset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_get_TotalDiskCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator_set_TotalDiskCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZip64EndOfCentralDirectoryLocator___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZip64EndOfCentralDirectoryLocator_methods[] = {
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, Assign, arginfo_TElZip64EndOfCentralDirectoryLocator_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, AssignTo, arginfo_TElZip64EndOfCentralDirectoryLocator_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, Load, arginfo_TElZip64EndOfCentralDirectoryLocator_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, Save, arginfo_TElZip64EndOfCentralDirectoryLocator_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, DataAvailable, arginfo_TElZip64EndOfCentralDirectoryLocator_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, get_DiskNumber, arginfo_TElZip64EndOfCentralDirectoryLocator_get_DiskNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, set_DiskNumber, arginfo_TElZip64EndOfCentralDirectoryLocator_set_DiskNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, get_Offset, arginfo_TElZip64EndOfCentralDirectoryLocator_get_Offset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, set_Offset, arginfo_TElZip64EndOfCentralDirectoryLocator_set_Offset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, get_TotalDiskCount, arginfo_TElZip64EndOfCentralDirectoryLocator_get_TotalDiskCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, set_TotalDiskCount, arginfo_TElZip64EndOfCentralDirectoryLocator_set_TotalDiskCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZip64EndOfCentralDirectoryLocator, __construct, arginfo_TElZip64EndOfCentralDirectoryLocator___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZip64EndOfCentralDirectoryLocator(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZip64EndOfCentralDirectoryLocator_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZip64EndOfCentralDirectoryLocator", TElZip64EndOfCentralDirectoryLocator_methods);
	if (NULL == TElZipEntity_ce_ptr)
		Register_TElZipEntity(TSRMLS_C);
	TElZip64EndOfCentralDirectoryLocator_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEndOfCentralDirectory_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEndOfCentralDirectory, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEndOfCentralDirectory_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEndOfCentralDirectory_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, Load)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEndOfCentralDirectory_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, Save)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEndOfCentralDirectory_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZipEndOfCentralDirectory_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, get_DiskNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEndOfCentralDirectory_get_DiskNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, set_DiskNumber)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEndOfCentralDirectory_set_DiskNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, get_CentralDirStartDisk)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEndOfCentralDirectory_get_CentralDirStartDisk(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, set_CentralDirStartDisk)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEndOfCentralDirectory_set_CentralDirStartDisk(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, get_EntriesOnDiskCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEndOfCentralDirectory_get_EntriesOnDiskCount(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, set_EntriesOnDiskCount)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEndOfCentralDirectory_set_EntriesOnDiskCount(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, get_EntriesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEndOfCentralDirectory_get_EntriesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, set_EntriesCount)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEndOfCentralDirectory_set_EntriesCount(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, get_CentralDirSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEndOfCentralDirectory_get_CentralDirSize(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, set_CentralDirSize)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEndOfCentralDirectory_set_CentralDirSize(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, get_CentralDirOffset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEndOfCentralDirectory_get_CentralDirOffset(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, set_CentralDirOffset)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEndOfCentralDirectory_set_CentralDirOffset(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, get_Comment)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEndOfCentralDirectory_get_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(80875795, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, set_Comment)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEndOfCentralDirectory_set_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEndOfCentralDirectory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEndOfCentralDirectory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_get_DiskNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_set_DiskNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_get_CentralDirStartDisk, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_set_CentralDirStartDisk, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_get_EntriesOnDiskCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_set_EntriesOnDiskCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_get_EntriesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_set_EntriesCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_get_CentralDirSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_set_CentralDirSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_get_CentralDirOffset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_set_CentralDirOffset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_get_Comment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory_set_Comment, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEndOfCentralDirectory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEndOfCentralDirectory_methods[] = {
	PHP_ME(TElZipEndOfCentralDirectory, Assign, arginfo_TElZipEndOfCentralDirectory_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, AssignTo, arginfo_TElZipEndOfCentralDirectory_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, Load, arginfo_TElZipEndOfCentralDirectory_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, Save, arginfo_TElZipEndOfCentralDirectory_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, DataAvailable, arginfo_TElZipEndOfCentralDirectory_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, get_DiskNumber, arginfo_TElZipEndOfCentralDirectory_get_DiskNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, set_DiskNumber, arginfo_TElZipEndOfCentralDirectory_set_DiskNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, get_CentralDirStartDisk, arginfo_TElZipEndOfCentralDirectory_get_CentralDirStartDisk, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, set_CentralDirStartDisk, arginfo_TElZipEndOfCentralDirectory_set_CentralDirStartDisk, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, get_EntriesOnDiskCount, arginfo_TElZipEndOfCentralDirectory_get_EntriesOnDiskCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, set_EntriesOnDiskCount, arginfo_TElZipEndOfCentralDirectory_set_EntriesOnDiskCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, get_EntriesCount, arginfo_TElZipEndOfCentralDirectory_get_EntriesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, set_EntriesCount, arginfo_TElZipEndOfCentralDirectory_set_EntriesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, get_CentralDirSize, arginfo_TElZipEndOfCentralDirectory_get_CentralDirSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, set_CentralDirSize, arginfo_TElZipEndOfCentralDirectory_set_CentralDirSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, get_CentralDirOffset, arginfo_TElZipEndOfCentralDirectory_get_CentralDirOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, set_CentralDirOffset, arginfo_TElZipEndOfCentralDirectory_set_CentralDirOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, get_Comment, arginfo_TElZipEndOfCentralDirectory_get_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, set_Comment, arginfo_TElZipEndOfCentralDirectory_set_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEndOfCentralDirectory, __construct, arginfo_TElZipEndOfCentralDirectory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEndOfCentralDirectory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEndOfCentralDirectory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEndOfCentralDirectory", TElZipEndOfCentralDirectory_methods);
	if (NULL == TElZipEntity_ce_ptr)
		Register_TElZipEntity(TSRMLS_C);
	TElZipEndOfCentralDirectory_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipArchiveExtraData_ce_ptr = NULL;

SB_PHP_METHOD(TElZipArchiveExtraData, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipArchiveExtraData_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipArchiveExtraData, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipArchiveExtraData_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipArchiveExtraData, Load)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipArchiveExtraData_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipArchiveExtraData, Save)
{
	SBArrayZValInfo piUserData;
	zval *zpUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpUserData) == SUCCESS) && ((Z_TYPE_P(zpUserData) == IS_STRING) || (Z_TYPE_P(zpUserData) == IS_ARRAY) || (Z_TYPE_P(zpUserData) == IS_NULL) || ((Z_TYPE_P(zpUserData) == IS_OBJECT) && (Z_OBJCE_P(zpUserData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpUserData, &piUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipArchiveExtraData_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piUserData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piUserData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipArchiveExtraData, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZipArchiveExtraData_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipArchiveExtraData, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipArchiveExtraData_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipArchiveExtraData, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipArchiveExtraData_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipArchiveExtraData_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipArchiveExtraData_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipArchiveExtraData_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipArchiveExtraData_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipArchiveExtraData_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipArchiveExtraData_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipArchiveExtraData___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipArchiveExtraData_methods[] = {
	PHP_ME(TElZipArchiveExtraData, Assign, arginfo_TElZipArchiveExtraData_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipArchiveExtraData, AssignTo, arginfo_TElZipArchiveExtraData_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipArchiveExtraData, Load, arginfo_TElZipArchiveExtraData_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipArchiveExtraData, Save, arginfo_TElZipArchiveExtraData_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipArchiveExtraData, DataAvailable, arginfo_TElZipArchiveExtraData_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipArchiveExtraData, get_Extensions, arginfo_TElZipArchiveExtraData_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipArchiveExtraData, __construct, arginfo_TElZipArchiveExtraData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipArchiveExtraData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipArchiveExtraData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipArchiveExtraData", TElZipArchiveExtraData_methods);
	if (NULL == TElZipEntity_ce_ptr)
		Register_TElZipEntity(TSRMLS_C);
	TElZipArchiveExtraData_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntity_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElZipProcessor, Process)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipProcessor_Process(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, ProcessLocalHeader)
{
	TElClassHandle hoHeader;
	zval *oHeader;
	zval *oStream;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O", &oStream, TStream_ce_ptr, &oHeader, TElZipLocalFileHeader_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oHeader) && (IS_OBJECT == Z_TYPE_P(oHeader)))
	{
		int8_t bOutResultRaw = 0;
		hoHeader = SBGetObjectHandle(oHeader TSRMLS_CC);
		SBCheckError(TElZipProcessor_ProcessLocalHeader(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &hoHeader, &bOutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oHeader, hoHeader TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &TElZipLocalFileHeader)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElZipProcessor_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_Processed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_Processed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_EndOfData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_EndOfData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_CentralDirectoryCompressed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_CentralDirectoryCompressed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_CentralDirectoryEncrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_CentralDirectoryEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_UseCentralDirectory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_UseCentralDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_UseCentralDirectory)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipProcessor_set_UseCentralDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnePass)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_OnePass(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnePass)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipProcessor_set_OnePass(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_Zip64Format)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_Zip64Format(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_EndOfCentralDir)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipProcessor_get_EndOfCentralDir(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEndOfCentralDirectory_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_Zip64EndOfCentralDir)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipProcessor_get_Zip64EndOfCentralDir(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZip64EndOfCentralDirectory_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_CentralDirectorySignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipProcessor_get_CentralDirectorySignature(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipCentralDirectorySignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_CentralDirectoryEntriesCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_CentralDirectoryEntriesCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_CentralDirectorySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_CentralDirectorySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_CentralDirectoryPosition)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipProcessor_get_CentralDirectoryPosition(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_ArchiveExtraData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipProcessor_get_ArchiveExtraData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipArchiveExtraData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnLocalFileHeaderLoaded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBZipLocalFileHeaderLoadedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipProcessor_get_OnLocalFileHeaderLoaded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnLocalFileHeaderLoaded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipProcessor_set_OnLocalFileHeaderLoaded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBZipLocalFileHeaderLoadedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBZipLocalFileHeaderLoadedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnDataDescriptorLoaded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBZipDataDescriptorLoadedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipProcessor_get_OnDataDescriptorLoaded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnDataDescriptorLoaded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipProcessor_set_OnDataDescriptorLoaded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBZipDataDescriptorLoadedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBZipDataDescriptorLoadedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnCentralFileHeaderLoaded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBZipCentralFileHeaderLoadedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipProcessor_get_OnCentralFileHeaderLoaded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnCentralFileHeaderLoaded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipProcessor_set_OnCentralFileHeaderLoaded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBZipCentralFileHeaderLoadedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBZipCentralFileHeaderLoadedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnFileData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBZipFileDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipProcessor_get_OnFileData(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnFileData)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipProcessor_set_OnFileData(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBZipFileDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBZipFileDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnFileHeadersLoaded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipProcessor_get_OnFileHeadersLoaded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnFileHeadersLoaded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipProcessor_set_OnFileHeadersLoaded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnCentralDirectoryFound)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipProcessor_get_OnCentralDirectoryFound(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnCentralDirectoryFound)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipProcessor_set_OnCentralDirectoryFound(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnProcessCentralDirectory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBZipCentralDirectoryProcessEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipProcessor_get_OnProcessCentralDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnProcessCentralDirectory)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipProcessor_set_OnProcessCentralDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBZipCentralDirectoryProcessEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBZipCentralDirectoryProcessEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnCentralDirectoryProcessed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipProcessor_get_OnCentralDirectoryProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnCentralDirectoryProcessed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipProcessor_set_OnCentralDirectoryProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, get_OnArchiveError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBZipArchiveErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZipProcessor_get_OnArchiveError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, set_OnArchiveError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZipProcessor_set_OnArchiveError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBZipArchiveErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBZipArchiveErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipProcessor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipProcessor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_Process, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_ProcessLocalHeader, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_OBJ_INFO(1, Header, TElZipLocalFileHeader, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_Processed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_EndOfData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_CentralDirectoryCompressed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_CentralDirectoryEncrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_UseCentralDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_UseCentralDirectory, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnePass, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnePass, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_Zip64Format, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_EndOfCentralDir, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_Zip64EndOfCentralDir, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_CentralDirectorySignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_CentralDirectoryEntriesCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_CentralDirectorySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_CentralDirectoryPosition, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_ArchiveExtraData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnLocalFileHeaderLoaded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnLocalFileHeaderLoaded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnDataDescriptorLoaded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnDataDescriptorLoaded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnCentralFileHeaderLoaded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnCentralFileHeaderLoaded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnFileData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnFileData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnFileHeadersLoaded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnFileHeadersLoaded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnCentralDirectoryFound, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnCentralDirectoryFound, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnProcessCentralDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnProcessCentralDirectory, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnCentralDirectoryProcessed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnCentralDirectoryProcessed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_get_OnArchiveError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor_set_OnArchiveError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipProcessor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipProcessor_methods[] = {
	PHP_ME(TElZipProcessor, Process, arginfo_TElZipProcessor_Process, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, ProcessLocalHeader, arginfo_TElZipProcessor_ProcessLocalHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, DataAvailable, arginfo_TElZipProcessor_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_Processed, arginfo_TElZipProcessor_get_Processed, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_EndOfData, arginfo_TElZipProcessor_get_EndOfData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_CentralDirectoryCompressed, arginfo_TElZipProcessor_get_CentralDirectoryCompressed, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_CentralDirectoryEncrypted, arginfo_TElZipProcessor_get_CentralDirectoryEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_UseCentralDirectory, arginfo_TElZipProcessor_get_UseCentralDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_UseCentralDirectory, arginfo_TElZipProcessor_set_UseCentralDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnePass, arginfo_TElZipProcessor_get_OnePass, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnePass, arginfo_TElZipProcessor_set_OnePass, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_Zip64Format, arginfo_TElZipProcessor_get_Zip64Format, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_EndOfCentralDir, arginfo_TElZipProcessor_get_EndOfCentralDir, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_Zip64EndOfCentralDir, arginfo_TElZipProcessor_get_Zip64EndOfCentralDir, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_CentralDirectorySignature, arginfo_TElZipProcessor_get_CentralDirectorySignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_CentralDirectoryEntriesCount, arginfo_TElZipProcessor_get_CentralDirectoryEntriesCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_CentralDirectorySize, arginfo_TElZipProcessor_get_CentralDirectorySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_CentralDirectoryPosition, arginfo_TElZipProcessor_get_CentralDirectoryPosition, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_ArchiveExtraData, arginfo_TElZipProcessor_get_ArchiveExtraData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnLocalFileHeaderLoaded, arginfo_TElZipProcessor_get_OnLocalFileHeaderLoaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnLocalFileHeaderLoaded, arginfo_TElZipProcessor_set_OnLocalFileHeaderLoaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnDataDescriptorLoaded, arginfo_TElZipProcessor_get_OnDataDescriptorLoaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnDataDescriptorLoaded, arginfo_TElZipProcessor_set_OnDataDescriptorLoaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnCentralFileHeaderLoaded, arginfo_TElZipProcessor_get_OnCentralFileHeaderLoaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnCentralFileHeaderLoaded, arginfo_TElZipProcessor_set_OnCentralFileHeaderLoaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnFileData, arginfo_TElZipProcessor_get_OnFileData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnFileData, arginfo_TElZipProcessor_set_OnFileData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnFileHeadersLoaded, arginfo_TElZipProcessor_get_OnFileHeadersLoaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnFileHeadersLoaded, arginfo_TElZipProcessor_set_OnFileHeadersLoaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnCentralDirectoryFound, arginfo_TElZipProcessor_get_OnCentralDirectoryFound, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnCentralDirectoryFound, arginfo_TElZipProcessor_set_OnCentralDirectoryFound, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnProcessCentralDirectory, arginfo_TElZipProcessor_get_OnProcessCentralDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnProcessCentralDirectory, arginfo_TElZipProcessor_set_OnProcessCentralDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnCentralDirectoryProcessed, arginfo_TElZipProcessor_get_OnCentralDirectoryProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnCentralDirectoryProcessed, arginfo_TElZipProcessor_set_OnCentralDirectoryProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, get_OnArchiveError, arginfo_TElZipProcessor_get_OnArchiveError, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, set_OnArchiveError, arginfo_TElZipProcessor_set_OnArchiveError, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipProcessor, __construct, arginfo_TElZipProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipProcessor", TElZipProcessor_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElZipProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityExtension, CreateByType_Inst)
{
	long u4ExtensionType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4ExtensionType) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtension_CreateByType_1(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4ExtensionType, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, CreateByType)
{
	long u4ExtensionType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4ExtensionType) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtension_CreateByType((uint32_t)u4ExtensionType, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtension_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityExtension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityExtension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1192335644, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, get_BodySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElZipEntityExtension_get_BodySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, get_ExtensionType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityExtension_get_ExtensionType(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, set_ExtensionType)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtension_set_ExtensionType(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtension_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElZipEntityExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, set_Owner)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElZipEntityExtensions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtension_set_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtensions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_CreateByType_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, ExtensionType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_CreateByType, 0, 0, 1)
	ZEND_ARG_INFO(0, ExtensionType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_get_BodySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_get_ExtensionType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_set_ExtensionType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension_set_Owner, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElZipEntityExtensions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityExtension_methods[] = {
	PHP_ME(TElZipEntityExtension, CreateByType_Inst, arginfo_TElZipEntityExtension_CreateByType_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, CreateByType, arginfo_TElZipEntityExtension_CreateByType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElZipEntityExtension, Assign, arginfo_TElZipEntityExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, AssignTo, arginfo_TElZipEntityExtension_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, LoadFromBuffer, arginfo_TElZipEntityExtension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, SaveToBuffer, arginfo_TElZipEntityExtension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, get_BodySize, arginfo_TElZipEntityExtension_get_BodySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, get_ExtensionType, arginfo_TElZipEntityExtension_get_ExtensionType, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, set_ExtensionType, arginfo_TElZipEntityExtension_set_ExtensionType, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, get_Owner, arginfo_TElZipEntityExtension_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, set_Owner, arginfo_TElZipEntityExtension_set_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtension, __construct, arginfo_TElZipEntityExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityExtension", TElZipEntityExtension_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElZipEntityExtension_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityCustomExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityCustomExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityCustomExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCustomExtension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityCustomExtension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCustomExtension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityCustomExtension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1197495497, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCustomExtension, get_ExtensionData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEntityCustomExtension_get_ExtensionData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2051315642, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCustomExtension, set_ExtensionData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityCustomExtension_set_ExtensionData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCustomExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityCustomExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCustomExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCustomExtension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCustomExtension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCustomExtension_get_ExtensionData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCustomExtension_set_ExtensionData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCustomExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityCustomExtension_methods[] = {
	PHP_ME(TElZipEntityCustomExtension, Assign, arginfo_TElZipEntityCustomExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCustomExtension, LoadFromBuffer, arginfo_TElZipEntityCustomExtension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCustomExtension, SaveToBuffer, arginfo_TElZipEntityCustomExtension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCustomExtension, get_ExtensionData, arginfo_TElZipEntityCustomExtension_get_ExtensionData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCustomExtension, set_ExtensionData, arginfo_TElZipEntityCustomExtension_set_ExtensionData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCustomExtension, __construct, arginfo_TElZipEntityCustomExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityCustomExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityCustomExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityCustomExtension", TElZipEntityCustomExtension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntityCustomExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityZip64InfoExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityZip64InfoExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityZip64InfoExtension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityZip64InfoExtension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-40110327, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, get_OriginalSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipEntityZip64InfoExtension_get_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, set_OriginalSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityZip64InfoExtension_set_OriginalSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, get_OriginalSizeAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityZip64InfoExtension_get_OriginalSizeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, get_CompressedSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipEntityZip64InfoExtension_get_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, set_CompressedSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityZip64InfoExtension_set_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, get_CompressedSizeAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityZip64InfoExtension_get_CompressedSizeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, get_RelativeHeaderOffset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElZipEntityZip64InfoExtension_get_RelativeHeaderOffset(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, set_RelativeHeaderOffset)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityZip64InfoExtension_set_RelativeHeaderOffset(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, get_RelativeHeaderOffsetAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityZip64InfoExtension_get_RelativeHeaderOffsetAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, get_DiskStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityZip64InfoExtension_get_DiskStart(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, set_DiskStart)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityZip64InfoExtension_set_DiskStart(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, get_DiskStartAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityZip64InfoExtension_get_DiskStartAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityZip64InfoExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityZip64InfoExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_get_OriginalSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_set_OriginalSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_get_OriginalSizeAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_get_CompressedSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_set_CompressedSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_get_CompressedSizeAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_get_RelativeHeaderOffset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_set_RelativeHeaderOffset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_get_RelativeHeaderOffsetAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_get_DiskStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_set_DiskStart, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension_get_DiskStartAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityZip64InfoExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityZip64InfoExtension_methods[] = {
	PHP_ME(TElZipEntityZip64InfoExtension, Assign, arginfo_TElZipEntityZip64InfoExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, LoadFromBuffer, arginfo_TElZipEntityZip64InfoExtension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, SaveToBuffer, arginfo_TElZipEntityZip64InfoExtension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, get_OriginalSize, arginfo_TElZipEntityZip64InfoExtension_get_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, set_OriginalSize, arginfo_TElZipEntityZip64InfoExtension_set_OriginalSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, get_OriginalSizeAvailable, arginfo_TElZipEntityZip64InfoExtension_get_OriginalSizeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, get_CompressedSize, arginfo_TElZipEntityZip64InfoExtension_get_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, set_CompressedSize, arginfo_TElZipEntityZip64InfoExtension_set_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, get_CompressedSizeAvailable, arginfo_TElZipEntityZip64InfoExtension_get_CompressedSizeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, get_RelativeHeaderOffset, arginfo_TElZipEntityZip64InfoExtension_get_RelativeHeaderOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, set_RelativeHeaderOffset, arginfo_TElZipEntityZip64InfoExtension_set_RelativeHeaderOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, get_RelativeHeaderOffsetAvailable, arginfo_TElZipEntityZip64InfoExtension_get_RelativeHeaderOffsetAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, get_DiskStart, arginfo_TElZipEntityZip64InfoExtension_get_DiskStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, set_DiskStart, arginfo_TElZipEntityZip64InfoExtension_set_DiskStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, get_DiskStartAvailable, arginfo_TElZipEntityZip64InfoExtension_get_DiskStartAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityZip64InfoExtension, __construct, arginfo_TElZipEntityZip64InfoExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityZip64InfoExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityZip64InfoExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityZip64InfoExtension", TElZipEntityZip64InfoExtension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntityZip64InfoExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityStrongEncryptionExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityStrongEncryptionExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityStrongEncryptionExtension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityStrongEncryptionExtension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(877026828, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, get_Format)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityStrongEncryptionExtension_get_Format(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, set_Format)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityStrongEncryptionExtension_set_Format(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, get_AlgorithmID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityStrongEncryptionExtension_get_AlgorithmID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, set_AlgorithmID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityStrongEncryptionExtension_set_AlgorithmID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, get_KeyLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityStrongEncryptionExtension_get_KeyLength(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, set_KeyLength)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityStrongEncryptionExtension_set_KeyLength(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityStrongEncryptionExtension_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, set_Flags)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityStrongEncryptionExtension_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, get_RecipientCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElZipEntityStrongEncryptionExtension_get_RecipientCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, set_RecipientCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityStrongEncryptionExtension_set_RecipientCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, get_HashAlgorithmID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityStrongEncryptionExtension_get_HashAlgorithmID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, set_HashAlgorithmID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityStrongEncryptionExtension_set_HashAlgorithmID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, get_HashSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityStrongEncryptionExtension_get_HashSize(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, get_RecipientHashes)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEntityStrongEncryptionExtension_get_RecipientHashes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1946597905, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, set_RecipientHashes)
{
	long l4Index;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityStrongEncryptionExtension_set_RecipientHashes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityStrongEncryptionExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityStrongEncryptionExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_get_Format, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_set_Format, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_get_AlgorithmID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_set_AlgorithmID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_get_KeyLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_set_KeyLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_get_RecipientCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_set_RecipientCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_get_HashAlgorithmID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_set_HashAlgorithmID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_get_HashSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_get_RecipientHashes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension_set_RecipientHashes, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityStrongEncryptionExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityStrongEncryptionExtension_methods[] = {
	PHP_ME(TElZipEntityStrongEncryptionExtension, Assign, arginfo_TElZipEntityStrongEncryptionExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, LoadFromBuffer, arginfo_TElZipEntityStrongEncryptionExtension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, SaveToBuffer, arginfo_TElZipEntityStrongEncryptionExtension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, get_Format, arginfo_TElZipEntityStrongEncryptionExtension_get_Format, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, set_Format, arginfo_TElZipEntityStrongEncryptionExtension_set_Format, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, get_AlgorithmID, arginfo_TElZipEntityStrongEncryptionExtension_get_AlgorithmID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, set_AlgorithmID, arginfo_TElZipEntityStrongEncryptionExtension_set_AlgorithmID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, get_KeyLength, arginfo_TElZipEntityStrongEncryptionExtension_get_KeyLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, set_KeyLength, arginfo_TElZipEntityStrongEncryptionExtension_set_KeyLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, get_Flags, arginfo_TElZipEntityStrongEncryptionExtension_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, set_Flags, arginfo_TElZipEntityStrongEncryptionExtension_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, get_RecipientCount, arginfo_TElZipEntityStrongEncryptionExtension_get_RecipientCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, set_RecipientCount, arginfo_TElZipEntityStrongEncryptionExtension_set_RecipientCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, get_HashAlgorithmID, arginfo_TElZipEntityStrongEncryptionExtension_get_HashAlgorithmID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, set_HashAlgorithmID, arginfo_TElZipEntityStrongEncryptionExtension_set_HashAlgorithmID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, get_HashSize, arginfo_TElZipEntityStrongEncryptionExtension_get_HashSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, get_RecipientHashes, arginfo_TElZipEntityStrongEncryptionExtension_get_RecipientHashes, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, set_RecipientHashes, arginfo_TElZipEntityStrongEncryptionExtension_set_RecipientHashes, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityStrongEncryptionExtension, __construct, arginfo_TElZipEntityStrongEncryptionExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityStrongEncryptionExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityStrongEncryptionExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityStrongEncryptionExtension", TElZipEntityStrongEncryptionExtension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntityStrongEncryptionExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityWinZipAESExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityWinZipAESExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityWinZipAESExtension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityWinZipAESExtension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1430637885, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityWinZipAESExtension_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, set_Version)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityWinZipAESExtension_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, get_Vendor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityWinZipAESExtension_get_Vendor(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, set_Vendor)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityWinZipAESExtension_set_Vendor(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, get_KeyStrength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElZipEntityWinZipAESExtension_get_KeyStrength(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, set_KeyStrength)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityWinZipAESExtension_set_KeyStrength(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, get_ActualCompressionMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityWinZipAESExtension_get_ActualCompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, set_ActualCompressionMethod)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityWinZipAESExtension_set_ActualCompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityWinZipAESExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityWinZipAESExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_get_Vendor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_set_Vendor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_get_KeyStrength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_set_KeyStrength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_get_ActualCompressionMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension_set_ActualCompressionMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityWinZipAESExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityWinZipAESExtension_methods[] = {
	PHP_ME(TElZipEntityWinZipAESExtension, Assign, arginfo_TElZipEntityWinZipAESExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, LoadFromBuffer, arginfo_TElZipEntityWinZipAESExtension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, SaveToBuffer, arginfo_TElZipEntityWinZipAESExtension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, get_Version, arginfo_TElZipEntityWinZipAESExtension_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, set_Version, arginfo_TElZipEntityWinZipAESExtension_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, get_Vendor, arginfo_TElZipEntityWinZipAESExtension_get_Vendor, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, set_Vendor, arginfo_TElZipEntityWinZipAESExtension_set_Vendor, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, get_KeyStrength, arginfo_TElZipEntityWinZipAESExtension_get_KeyStrength, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, set_KeyStrength, arginfo_TElZipEntityWinZipAESExtension_set_KeyStrength, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, get_ActualCompressionMethod, arginfo_TElZipEntityWinZipAESExtension_get_ActualCompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, set_ActualCompressionMethod, arginfo_TElZipEntityWinZipAESExtension_set_ActualCompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityWinZipAESExtension, __construct, arginfo_TElZipEntityWinZipAESExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityWinZipAESExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityWinZipAESExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityWinZipAESExtension", TElZipEntityWinZipAESExtension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntityWinZipAESExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityCertificateStoreExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityCertificateStoreExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityCertificateStoreExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCertificateStoreExtension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityCertificateStoreExtension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCertificateStoreExtension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityCertificateStoreExtension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-480400654, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCertificateStoreExtension, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityCertificateStoreExtension_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCertificateStoreExtension, get_StoreData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEntityCertificateStoreExtension_get_StoreData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(628867747, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCertificateStoreExtension, set_StoreData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityCertificateStoreExtension_set_StoreData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCertificateStoreExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityCertificateStoreExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCertificateStoreExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCertificateStoreExtension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCertificateStoreExtension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCertificateStoreExtension_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCertificateStoreExtension_get_StoreData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCertificateStoreExtension_set_StoreData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCertificateStoreExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityCertificateStoreExtension_methods[] = {
	PHP_ME(TElZipEntityCertificateStoreExtension, Assign, arginfo_TElZipEntityCertificateStoreExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCertificateStoreExtension, LoadFromBuffer, arginfo_TElZipEntityCertificateStoreExtension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCertificateStoreExtension, SaveToBuffer, arginfo_TElZipEntityCertificateStoreExtension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCertificateStoreExtension, get_Version, arginfo_TElZipEntityCertificateStoreExtension_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCertificateStoreExtension, get_StoreData, arginfo_TElZipEntityCertificateStoreExtension_get_StoreData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCertificateStoreExtension, set_StoreData, arginfo_TElZipEntityCertificateStoreExtension_set_StoreData, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCertificateStoreExtension, __construct, arginfo_TElZipEntityCertificateStoreExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityCertificateStoreExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityCertificateStoreExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityCertificateStoreExtension", TElZipEntityCertificateStoreExtension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntityCertificateStoreExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntitySignatureExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntitySignatureExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntitySignatureExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntitySignatureExtension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntitySignatureExtension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(2011885204, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntitySignatureExtension_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntitySignatureExtension_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, set_HashAlgorithm)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntitySignatureExtension_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, get_IssuerName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEntitySignatureExtension_get_IssuerName(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1705639200, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, set_IssuerName)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntitySignatureExtension_set_IssuerName(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEntitySignatureExtension_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(808425604, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, set_SerialNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntitySignatureExtension_set_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, get_Signature)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElZipEntitySignatureExtension_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1346749344, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, set_Signature)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntitySignatureExtension_set_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntitySignatureExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntitySignatureExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_get_IssuerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_set_IssuerName, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_set_SerialNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension_set_Signature, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntitySignatureExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntitySignatureExtension_methods[] = {
	PHP_ME(TElZipEntitySignatureExtension, Assign, arginfo_TElZipEntitySignatureExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, LoadFromBuffer, arginfo_TElZipEntitySignatureExtension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, SaveToBuffer, arginfo_TElZipEntitySignatureExtension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, get_Version, arginfo_TElZipEntitySignatureExtension_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, get_HashAlgorithm, arginfo_TElZipEntitySignatureExtension_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, set_HashAlgorithm, arginfo_TElZipEntitySignatureExtension_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, get_IssuerName, arginfo_TElZipEntitySignatureExtension_get_IssuerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, set_IssuerName, arginfo_TElZipEntitySignatureExtension_set_IssuerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, get_SerialNumber, arginfo_TElZipEntitySignatureExtension_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, set_SerialNumber, arginfo_TElZipEntitySignatureExtension_set_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, get_Signature, arginfo_TElZipEntitySignatureExtension_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, set_Signature, arginfo_TElZipEntitySignatureExtension_set_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntitySignatureExtension, __construct, arginfo_TElZipEntitySignatureExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntitySignatureExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntitySignatureExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntitySignatureExtension", TElZipEntitySignatureExtension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntitySignatureExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityCentralDirSignatureExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityCentralDirSignatureExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityCentralDirSignatureExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityCentralDirSignatureExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityCentralDirSignatureExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCentralDirSignatureExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityCentralDirSignatureExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityCentralDirSignatureExtension_methods[] = {
	PHP_ME(TElZipEntityCentralDirSignatureExtension, Assign, arginfo_TElZipEntityCentralDirSignatureExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityCentralDirSignatureExtension, __construct, arginfo_TElZipEntityCentralDirSignatureExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityCentralDirSignatureExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityCentralDirSignatureExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityCentralDirSignatureExtension", TElZipEntityCentralDirSignatureExtension_methods);
	if (NULL == TElZipEntitySignatureExtension_ce_ptr)
		Register_TElZipEntitySignatureExtension(TSRMLS_C);
	TElZipEntityCentralDirSignatureExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntitySignatureExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityUnix1Extension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityUnix1Extension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix1Extension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityUnix1Extension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityUnix1Extension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(412875712, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, get_ModifyTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityUnix1Extension_get_ModifyTime(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, set_ModifyTime)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix1Extension_set_ModifyTime(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, get_AccessTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityUnix1Extension_get_AccessTime(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, set_AccessTime)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix1Extension_set_AccessTime(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, get_UIDAndGIDAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityUnix1Extension_get_UIDAndGIDAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, set_UIDAndGIDAvailable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix1Extension_set_UIDAndGIDAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, get_UID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityUnix1Extension_get_UID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, set_UID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix1Extension_set_UID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, get_GID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityUnix1Extension_get_GID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, set_GID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix1Extension_set_GID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix1Extension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityUnix1Extension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_get_ModifyTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_set_ModifyTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_get_AccessTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_set_AccessTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_get_UIDAndGIDAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_set_UIDAndGIDAvailable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_get_UID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_set_UID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_get_GID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension_set_GID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix1Extension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityUnix1Extension_methods[] = {
	PHP_ME(TElZipEntityUnix1Extension, Assign, arginfo_TElZipEntityUnix1Extension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, LoadFromBuffer, arginfo_TElZipEntityUnix1Extension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, SaveToBuffer, arginfo_TElZipEntityUnix1Extension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, get_ModifyTime, arginfo_TElZipEntityUnix1Extension_get_ModifyTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, set_ModifyTime, arginfo_TElZipEntityUnix1Extension_set_ModifyTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, get_AccessTime, arginfo_TElZipEntityUnix1Extension_get_AccessTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, set_AccessTime, arginfo_TElZipEntityUnix1Extension_set_AccessTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, get_UIDAndGIDAvailable, arginfo_TElZipEntityUnix1Extension_get_UIDAndGIDAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, set_UIDAndGIDAvailable, arginfo_TElZipEntityUnix1Extension_set_UIDAndGIDAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, get_UID, arginfo_TElZipEntityUnix1Extension_get_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, set_UID, arginfo_TElZipEntityUnix1Extension_set_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, get_GID, arginfo_TElZipEntityUnix1Extension_get_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, set_GID, arginfo_TElZipEntityUnix1Extension_set_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix1Extension, __construct, arginfo_TElZipEntityUnix1Extension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityUnix1Extension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityUnix1Extension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityUnix1Extension", TElZipEntityUnix1Extension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntityUnix1Extension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityUnix2Extension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityUnix2Extension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix2Extension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix2Extension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityUnix2Extension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix2Extension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityUnix2Extension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1998106057, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix2Extension, get_UIDAndGIDAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityUnix2Extension_get_UIDAndGIDAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix2Extension, set_UIDAndGIDAvailable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix2Extension_set_UIDAndGIDAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix2Extension, get_UID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityUnix2Extension_get_UID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix2Extension, set_UID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix2Extension_set_UID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix2Extension, get_GID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityUnix2Extension_get_GID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix2Extension, set_GID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityUnix2Extension_set_GID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUnix2Extension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityUnix2Extension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension_get_UIDAndGIDAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension_set_UIDAndGIDAvailable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension_get_UID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension_set_UID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension_get_GID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension_set_GID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUnix2Extension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityUnix2Extension_methods[] = {
	PHP_ME(TElZipEntityUnix2Extension, Assign, arginfo_TElZipEntityUnix2Extension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix2Extension, LoadFromBuffer, arginfo_TElZipEntityUnix2Extension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix2Extension, SaveToBuffer, arginfo_TElZipEntityUnix2Extension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix2Extension, get_UIDAndGIDAvailable, arginfo_TElZipEntityUnix2Extension_get_UIDAndGIDAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix2Extension, set_UIDAndGIDAvailable, arginfo_TElZipEntityUnix2Extension_set_UIDAndGIDAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix2Extension, get_UID, arginfo_TElZipEntityUnix2Extension_get_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix2Extension, set_UID, arginfo_TElZipEntityUnix2Extension_set_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix2Extension, get_GID, arginfo_TElZipEntityUnix2Extension_get_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix2Extension, set_GID, arginfo_TElZipEntityUnix2Extension_set_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUnix2Extension, __construct, arginfo_TElZipEntityUnix2Extension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityUnix2Extension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityUnix2Extension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityUnix2Extension", TElZipEntityUnix2Extension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntityUnix2Extension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityExtendedTimestampExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtendedTimestampExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityExtendedTimestampExtension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityExtendedTimestampExtension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1170652717, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, get_ModifyTimeAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityExtendedTimestampExtension_get_ModifyTimeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, set_ModifyTimeAvailable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtendedTimestampExtension_set_ModifyTimeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, get_AccessTimeAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityExtendedTimestampExtension_get_AccessTimeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, set_AccessTimeAvailable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtendedTimestampExtension_set_AccessTimeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, get_CreateTimeAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityExtendedTimestampExtension_get_CreateTimeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, set_CreateTimeAvailable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtendedTimestampExtension_set_CreateTimeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, get_ModifyTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityExtendedTimestampExtension_get_ModifyTime(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, set_ModifyTime)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtendedTimestampExtension_set_ModifyTime(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, get_AccessTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityExtendedTimestampExtension_get_AccessTime(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, set_AccessTime)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtendedTimestampExtension_set_AccessTime(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, get_CreateTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityExtendedTimestampExtension_get_CreateTime(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, set_CreateTime)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityExtendedTimestampExtension_set_CreateTime(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, get_CentralHeader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZipEntityExtendedTimestampExtension_get_CentralHeader(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityExtendedTimestampExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityExtendedTimestampExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_get_ModifyTimeAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_set_ModifyTimeAvailable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_get_AccessTimeAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_set_AccessTimeAvailable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_get_CreateTimeAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_set_CreateTimeAvailable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_get_ModifyTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_set_ModifyTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_get_AccessTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_set_AccessTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_get_CreateTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_set_CreateTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension_get_CentralHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityExtendedTimestampExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityExtendedTimestampExtension_methods[] = {
	PHP_ME(TElZipEntityExtendedTimestampExtension, Assign, arginfo_TElZipEntityExtendedTimestampExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, LoadFromBuffer, arginfo_TElZipEntityExtendedTimestampExtension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, SaveToBuffer, arginfo_TElZipEntityExtendedTimestampExtension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, get_ModifyTimeAvailable, arginfo_TElZipEntityExtendedTimestampExtension_get_ModifyTimeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, set_ModifyTimeAvailable, arginfo_TElZipEntityExtendedTimestampExtension_set_ModifyTimeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, get_AccessTimeAvailable, arginfo_TElZipEntityExtendedTimestampExtension_get_AccessTimeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, set_AccessTimeAvailable, arginfo_TElZipEntityExtendedTimestampExtension_set_AccessTimeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, get_CreateTimeAvailable, arginfo_TElZipEntityExtendedTimestampExtension_get_CreateTimeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, set_CreateTimeAvailable, arginfo_TElZipEntityExtendedTimestampExtension_set_CreateTimeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, get_ModifyTime, arginfo_TElZipEntityExtendedTimestampExtension_get_ModifyTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, set_ModifyTime, arginfo_TElZipEntityExtendedTimestampExtension_set_ModifyTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, get_AccessTime, arginfo_TElZipEntityExtendedTimestampExtension_get_AccessTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, set_AccessTime, arginfo_TElZipEntityExtendedTimestampExtension_set_AccessTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, get_CreateTime, arginfo_TElZipEntityExtendedTimestampExtension_get_CreateTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, set_CreateTime, arginfo_TElZipEntityExtendedTimestampExtension_set_CreateTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, get_CentralHeader, arginfo_TElZipEntityExtendedTimestampExtension_get_CentralHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityExtendedTimestampExtension, __construct, arginfo_TElZipEntityExtendedTimestampExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityExtendedTimestampExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityExtendedTimestampExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityExtendedTimestampExtension", TElZipEntityExtendedTimestampExtension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntityExtendedTimestampExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZipEntityUIDAndGIDExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElZipEntityUIDAndGIDExtension, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElZipEntityExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElZipEntityUIDAndGIDExtension_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElZipEntityExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUIDAndGIDExtension, LoadFromBuffer)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElZipEntityUIDAndGIDExtension_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUIDAndGIDExtension, SaveToBuffer)
{
	int32_t l4SizeRaw;
	long l4Index;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zaBuffer, &l4Index, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElZipEntityUIDAndGIDExtension_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, (int32_t)l4Index, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1966902770, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUIDAndGIDExtension, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElZipEntityUIDAndGIDExtension_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUIDAndGIDExtension, get_UID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityUIDAndGIDExtension_get_UID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUIDAndGIDExtension, set_UID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityUIDAndGIDExtension_set_UID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUIDAndGIDExtension, get_GID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElZipEntityUIDAndGIDExtension_get_GID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUIDAndGIDExtension, set_GID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElZipEntityUIDAndGIDExtension_set_GID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZipEntityUIDAndGIDExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZipEntityUIDAndGIDExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUIDAndGIDExtension_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElZipEntityExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUIDAndGIDExtension_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUIDAndGIDExtension_SaveToBuffer, 0, 0, 3)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUIDAndGIDExtension_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUIDAndGIDExtension_get_UID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUIDAndGIDExtension_set_UID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUIDAndGIDExtension_get_GID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUIDAndGIDExtension_set_GID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZipEntityUIDAndGIDExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElZipEntityUIDAndGIDExtension_methods[] = {
	PHP_ME(TElZipEntityUIDAndGIDExtension, Assign, arginfo_TElZipEntityUIDAndGIDExtension_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUIDAndGIDExtension, LoadFromBuffer, arginfo_TElZipEntityUIDAndGIDExtension_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUIDAndGIDExtension, SaveToBuffer, arginfo_TElZipEntityUIDAndGIDExtension_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUIDAndGIDExtension, get_Version, arginfo_TElZipEntityUIDAndGIDExtension_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUIDAndGIDExtension, get_UID, arginfo_TElZipEntityUIDAndGIDExtension_get_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUIDAndGIDExtension, set_UID, arginfo_TElZipEntityUIDAndGIDExtension_set_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUIDAndGIDExtension, get_GID, arginfo_TElZipEntityUIDAndGIDExtension_get_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUIDAndGIDExtension, set_GID, arginfo_TElZipEntityUIDAndGIDExtension_set_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElZipEntityUIDAndGIDExtension, __construct, arginfo_TElZipEntityUIDAndGIDExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZipEntityUIDAndGIDExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZipEntityUIDAndGIDExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZipEntityUIDAndGIDExtension", TElZipEntityUIDAndGIDExtension_methods);
	if (NULL == TElZipEntityExtension_ce_ptr)
		Register_TElZipEntityExtension(TSRMLS_C);
	TElZipEntityUIDAndGIDExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElZipEntityExtension_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBZipEntities_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBZipEntities, ZIP_READ_BLOCK_SIZE, SB_ZIP_READ_BLOCK_SIZE, SB_ZIP_READ_BLOCK_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBZipEntities, ZIP64_MARK_32, SB_ZIP64_MARK_32, SB_ZIP64_MARK_32);
	SB_REGISTER_LONG_CONSTANT(SBZipEntities, ZIP64_MARK_16, SB_ZIP64_MARK_16, SB_ZIP64_MARK_16);
}

